/*  
	Copyright (C) 2005 Mark Riley

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

	Any queries, I can be contacted at mark_riley99@hotmail.com

	Big thanks out (in no particular order) to Firebird, bdb, SimonC, BobD, EMJB, Wembley, R2-D2,
	KidHazy, Deadbeef, garyo, Tony May, tichtich, Pavel, ginner, aramil, Wolfgang, Henk, Joe, and Rudolf 
	for all their help offered,	code plundered, information gleened, 
	inspiration drawn, translations given and testing performed.
*/

#ifdef WIN32
#pragma comment(lib, "c:\\TopfieldDisk\\DataFiles\\SDK\\TAP_SDK_DLL")
#include "TAP_Emulations.h"
#endif

#include <Math.h>
#include "tap.h"
//#include "tapapifix.h"
//#include "exTap.h"
//#include "FirmwareCalls.h"
//#include "TAPExtensions.h"
#include "gfxlib.h"
#include "translations.h" 
#include "menu.h"
#include "skin.h"
#include "graphics.h"
//#include "DirectOSD.h"
#include "GIF_LIB.h"
//#include "Flash.h"
#include "dlmalloc.h"
#include "id3.h"
#include "rasterfontbrowser.h"
#ifndef WIN32
#include "libFireBird.h"
#endif

#define ID_RBACK 0x8000acdc 

TAP_ID( ID_RBACK );
TAP_PROGRAM_NAME("Media Manager 1.5");
TAP_AUTHOR_NAME("Mark");
TAP_DESCRIPTION("Manages Photos, Music & Videos");
TAP_ETCINFO(__DATE__);

#include "TSRCommander.h"

void logText(const char* text, bool close_log);
void openLogfile();
void closeLogfile();
bool InProgramFilesFolder(char* path);
bool InMp3FilesFolder(char* path);
bool InDataFilesFolder(char* path);
bool IsDataFilesFolder(char* path);
bool InFolder(char* trial, char* folder);
word ChangeDir(char *path);
bool ChangeDirPath(char *path);
void ChangeToRoot(char *new_path);
bool ChangeDirProgramFiles();
bool ChangeDirRootFromUnknown();
bool ChangeDirDataFiles();
bool ChangeDirMp3();
bool ChangeDirMediaManager();
bool ChangeDirPlaylists();
bool ChangeDirSkins();
bool ChangeDirFonts();
bool ChangeDirCurrentRecording(char *name, dword start_cluster, TYPE_File *rec_file);
dword getEEPROMOffset();
//void DeterminePIN(char *pin, dword eeprom_offset);
void gmtToLocalTime(dword utc_time, word *local_mjd, word *local_hour, word *local_min, int offset, dword offset_override);
bool isJpg(char *name);
bool isBmp(char *name);
bool isGif(char *name);
bool isPhoto(char *name);
bool isMp3(char *name);
bool isRec(char *name);
bool isSkin(char *name);
bool isFont(char *name);
bool isCache(char *name);
bool isRecycled(char *name);
bool isRecycledPhoto(char *name);
bool isRecycledRec(char *name);
bool isRecycledMp3(char *name);
bool isThumbnail(char *name);
bool isArtAssociation(char *name);
bool isScene(char *name);
bool isRecycledThumbnail(char *name);
bool isGifThumbnail(char *name);
bool isLog(char *name);
bool isTAP(char *name);
int isCopy(char *name);
bool isTF5800();
bool isTF5100t();
bool isTF5100c();
bool isTF5200c();
bool isTF5000();
int getDirectoryLevel(char *directory);
bool isPhotoPlaylist(char *name);
bool isMp3Playlist(char *name);
bool isPlaylist(char *name);
int containsSubstring(char *string_to_check, char *search_string);
bool OsdActive (int startCol, int startRow, int endCol, int endRow);
dword getRandom();
int getWidth(char *text, byte font_size);
int getWidthRounded(char *text, byte font_size, bool rounded);
void getDrawDimensionsAndOffset(int bitmap_width, int bitmap_height, int *calc_width, int *calc_height, int *calc_offset_x, int *calc_offset_y, 
								int widescreen_factor, bool cache, bool thumbnail, bool rotated_sideways, bool full_size, bool album_art, bool compact_art);
void ExtractLastField(char *path, char *significant_part);
void ExtractDirectory(char *path, char *significant_part);
void ExtractExtension(char *name, char *extension);
int getExtensionLength(char *name);
void ExtractBaseMp3Directory(char *directory, char *base_dir);
void truncateStringForDisplay(char *text, dword max_length, byte font_size);
void transformPathDelimiters(char *path, char *extract);
bool isParentDirectory(char *file_name);
bool isMp3Directory(char *file_name);
void FormatSortName(char* target, char* source);
bool hasDateStamp(char* name);
bool initHook();
int startTap(char *pFilename);
void getWordInLine(char *info_line, char *word_in_line, word *line_pointer);
word countWordsInLine(char *info_line);
bool getInfoLine(char *info_line, word *info_pointer, char *extInfo, int max_length, byte font_size);
word* decode_jpg_wembley_style(void * data, int *bitmap_width, int *bitmap_height, int start);
byte *load_jpg_wembley_style( char *filename, byte *raw_data, int raw_size, int *width, int *height );
void free_jpg_wembley_style( void );
void CaptureVideo(int width, int height);
word *loadAndDecodeBitmap(char *name, int *width, int *height);
byte *LoadGifDirect(char *name, int *bitmap_width, int *bitmap_height);
int compareDimensions(const void *s1, const void *s2);
int compareRecordings(const void *s1, const void *s2);
int compareMatchedRecordings(const void *s1, const void *s2);
int compareJPEGs(const void *s1, const void *s2);
int compareStrings (const void *s1, const void *s2);
int compareArtists (const void *s1, const void *s2);
int compareSkins (const void *s1, const void *s2);
void populateJPEGs(bool recursive, bool show_message);
void populateMP3s(bool recursive, bool show_message);
void populateFiles();
void handleStopKey(bool mp3);
void handleStopMenu();
void handleLoadPlaylistKey();
void handleLoadSkinKey();
void handleKeyboardKey();
void handleSkinEditorKey();
void handleSkinElementKey();
void handleHelpKey();
void handleVideoBatchJob(bool confirm);
void handleMarkFile(char *file_name, char *dir, dword start_cluster, word mjd, word hour, word min, dword size, bool locked);
void updateOptionCount(void);
bool createCacheDirectoryIfNotThere();
void drawBlankFileList(word no_of_lines);
void exitScreensaver(void);
void exitAlbumArt(void);
void exitCompactMode(void);
void exitBlankScreen(void);
void startMP3Mode(dword mode, bool switching);
void startExternalMode(dword mode, bool switching, bool radio);
void handleChangeTrack(bool next_track);
void moveMP3Highlight();
void moveAlbumArtToStructure();
void processJPEG(bool album_art);
void clearHistory(bool photo);
void freeMediaFiles();
void freeSavedRecordings();
void freeDimensions();
void handleMenuKey();
void handleExitKey(bool permanent_exit, bool delete_osd);
void doRename(char *old_name, char *new_name, bool rename_new_folder, bool folder);
void drawFileListFooter(int info_idx);
bool isFolder(int idx);
bool isDuffRec(TYPE_File rec_file);
void ProcessFile(const char * FileName);
void LoadHeaderInfo(char *name, dword start_cluster, char *directory, int idx, bool notify);
bool appendToName(dword rename_rule, char *name, char *extension, char *from_dir, char *to_dir, word mjd, word hour, word min);
void doDelete(char *file_to_delete, dword start_cluster, char *directory, bool folder, bool change_dir);
void doRecycle(char *file_to_delete, dword start_cluster, char *directory, word mjd, word hour, word min, dword size, bool folder, bool change_dir);
void doMove(word mjd, word hour, word min);
void handleReorderKey();
void handlePlayKey(void);
char *getFirstFolderInHistory();
void saveNavHistory(int idx, int highlight, bool overwrite);
void copyMemoryToWindow();
void updatePlaylistCount(void);
void drawPlaylistFooter(int idx);
void drawPlaylistLine(int line_idx, int data_idx);
void drawPlaylistLines(word start);
void drawFile(int line_idx, int data_idx);
void updateFileCount(void);
void drawFiles(word start);
void drawOption(int line_idx, int data_idx);
void drawOptions(word start);
void drawOptionsFooter();
void updateSkinEditorCount(void);
void drawSkinEditorFooter(int idx);
void drawSkinEditorLine(int line_idx, int data_idx);
void drawSkinEditorLines(word start);
void drawMoveFolder(int line_idx, int data_idx);
void drawMoveFolders(word start);
void drawLoadPlaylists(word start);
void drawLoadPlaylist();
void drawLoadPlaylistLine(int line_idx, int data_idx);
void drawLoadSkinLine(int line_idx, int data_idx);
void drawLoadSkins(word start);
void drawSkinElement(int line_idx, int data_idx);
void drawSkinElements(word start);
void updateAutoDeleteListCount(void);
void drawAutoDeleteListFooter(int idx);
void drawAutoDeleteListLine(int line_idx, int data_idx);
void drawAutoDeleteListLines(word start);
void copyMemoryToMenu();
void copyMemoryToMoveFolders();
void formatDateString(word mjd, char *text, bool long_format);
void formatDuration(char *text, word duration_hour, word duration_min);
void loadAutoDeleteList();
void loadRecycleBinList();
unsigned long genrand_int32(void);
int getFolderHistoryLength();
void seedRandom();
void CacheLogos(void);
void checkForDefaultSkin();
void handleEvent();
void computePreviousMenuSection(int *idx);
void computeNextMenuSection(int *idx);
bool inSightOfNextMenuSection(int idx, bool forwards);
void logMemory(char *message, bool log_verbose);
TYPE_File* getPhotoCache(char *name, bool thumbnail);
void *getThumbnailRawData(TYPE_File *thumbnail_file, int *thumbnail_width, int *thumbnail_height, bool recording, bool gif);
bool appendToMarkedRecordings(char *name, char *directory, dword start_cluster, word mjd, word hour, word min, dword size);
void extractRecordingData(TYPE_File file, char *directory, int rules_idx);
void createRecordingThumbnail(char *recording_name, dword start_cluster, bool thumbnail, bool scenes, bool force_thumbnail, bool force_scenes, bool already_playing);
void initialiseLine(int x, int y, int w, int height, byte *gradient, word colour, word tt_colour);
bool move(char *from_dir, char *to_dir, char *move_file_name);
void createAllRecordingThumbnails(bool from_batch);
word getRecHeaderDetail(char *name);
void drawInfoBox(char *title, char *info_line_1, char *info_line_2, bool show_ok, bool save);
bool readID3Tag(char *file_name, bool playing, bool read_art);
void deleteRecHeader(char *name, dword start_cluster);
void handleChangeFolder(bool forward, bool force);
void appendToRecycleBinList(char *file_name, dword start_cluster, char *directory, word mjd, word hour, word min, dword size, bool folder);
void startMp3Slideshow(bool first_mp3);
void playMp3(char *file_name);
void clearFolderHistory();
void drawMp3InfoBox();
void exitSlideshow(void);
bool appendMp3Header(char *name, char *dir, word mjd, byte hour, byte min, bool change);
struct media_files* getMp3Header(char *name, char *dir, word mjd, byte hour, byte min, bool create, bool change, bool notify);
void checkTrackNumberOrdering(bool dir_info, int no_of_items);
void cacheToDisk16Bit(char *name, word *data, int width, int height, bool thumbnail);
void exitRadioSlideshow();
void freeMemory();
bool drawGIF(byte *pixmap, int width, int height, int actual_offset_x, int actual_offset_y, int xl, int yl);
bool drawJPEG(word *pixmap, int width, int height, int actual_offset_x, int actual_offset_y, int xl, int yl);
void loadAndDecodeJpeg();
bool active();
void loadMp3Headers(bool show_message, bool initialisation, bool force);
void drawRoundedRectangle(word region, word x, word y, word w, word h, word border, word no_of_lines, word header, word footer, word border_colour, word flood_colour, word fill_colour, bool prefill);
void exitTap();

#define VIEW_TICK	500
#define NUMBER_OF_OPTIONS  (sizeof(options) / sizeof(_options))

word mjd, start_mjd, end_mjd, year, time;
byte hour, min, sec, month, day, week_day;

static TYPE_File playing_file;
static byte multi_play_batch_mode, rec_playing_type = PLAYMODE_None;
static byte *processing_save, *info_save, *rec_info_save, *help_save, *move_folder_save, *keyboard_save;
static byte *yes_no_save, *options_save, *auto_delete_save, *pin_save, *load_playlist_save, *load_skin_save, *skin_element_save;
static bool batch_job_started = FALSE, slideshow_started = FALSE, screensaver_started = FALSE;
static bool multi_play_started = FALSE, choose_multi_play_mode, overnight_play, play_next_recording = FALSE, skip_to_letter = FALSE, manual_batch_job = FALSE;
static bool external_slideshow = FALSE, radio_slideshow = FALSE, paused_slideshow = FALSE;
static bool window_displayed = FALSE, menu_displayed = FALSE, options_displayed = FALSE;
static bool stop_menu_displayed = FALSE, keyboard_displayed = FALSE, log_displayed = FALSE;
static bool playlist_displayed = FALSE, auto_deletes_displayed = FALSE, auto_delete_update_displayed = FALSE;
static bool recycle_bin_displayed = FALSE, scenes_displayed = FALSE, move_folders_displayed = FALSE, info_displayed = FALSE;
static bool rec_info_displayed = FALSE, help_displayed = FALSE, pin_box_displayed = FALSE, load_playlist_displayed = FALSE;
static bool load_skin_displayed = FALSE, skin_editor_displayed = FALSE, skin_elements_displayed = FALSE, compact_help_displayed = TRUE;
static bool mp3_playing = FALSE, mp3_stopping = FALSE, free_mp3s, rec_playing = FALSE, firmware_hacks_enabled = TRUE;
static bool rec_recording_1 = FALSE, rec_recording_2 = FALSE;
static bool move_successful = FALSE, api_move_available = FALSE, debug_move_available = FALSE;
static bool apply_fade_image = FALSE, do_order_by_track_number = FALSE;
static char last_played_name[100], recording_1_name[100], recording_2_name[100];
static char mp3_playlist_name[100] = "", photo_playlist_name[100] = "", mp3_folder[100] = "";
static bool mp3s_in_current_folder = FALSE, thumbnail_mode = FALSE, photo_playlist_mode, single_mp3_mode = FALSE;
static bool was_tv = FALSE, was_radio = FALSE, was_mp3 = FALSE;
static bool loading_jpeg = FALSE, mp3_slideshow = FALSE, show_all_files = FALSE, compact_art_mode = FALSE, compact_tv_mode = FALSE;
static bool album_art_started = FALSE, compact_mode_started = FALSE, blank_screen_started = FALSE, blink_on = FALSE;
static bool copy_recording = FALSE, copy_batch_job = FALSE, copy_successful, thumbnail_batch_job = FALSE, trim_recording = FALSE;
static bool reverse_screensaver = FALSE, stop_playing = FALSE, recreate_plane2 = FALSE, confirmation_box_displayed = FALSE;
static bool yes_selected = FALSE, delete_all = FALSE, smart_delete = FALSE, delete_active_rec = FALSE;
static bool stop_active_rec = FALSE, confirm_video_job = FALSE, info_box_displayed = FALSE, mp3_art_deleted = FALSE;
static bool photo_cache_deleted = FALSE, folder_cache_deleted = FALSE, append_to_progress_data = FALSE, sort_options = FALSE;
static bool idle_before_window_display = FALSE, idle_before_initial_display = FALSE, idle_before_photo_display = FALSE, idle_before_stop_menu_display = FALSE, idle_before_mp3_slideshow = FALSE;
static bool draw_playlist = FALSE, play_mp3 = FALSE, stop_mp3 = FALSE, start_slideshow = FALSE;
static dword tick_draw_window = 0, tick_draw_photo = 0, tick_draw_stop_menu = 0, photo_mode, saved_fsd, last_played_cluster;
static word region, region_now, region_1, region_2, region_mem;
static word displayed_mp3_progress, displayed_radio_progress;
int no_of_playlist_photos, no_of_playlist_mp3s, no_of_auto_deletes, no_of_skin_elements, no_of_insert_elements;
int no_of_delete_options = 6;
word no_of_recycles = 0;
dword random_seed;
bool mp3_playlist_playing, desc_ext_installed = FALSE;

typedef enum {
	SHOW_PLANE1,
	FADE_TO_PLANE2,
	SHOW_PLANE2,
	FADE_TO_PLANE1
} _fade_state;
_fade_state fade_state = SHOW_PLANE1;

static byte no_of_options, no_of_stop_options;
static byte *jpeg_data = NULL, *byte_data = NULL;
static word *jpeg_bitmap = NULL, *cached_data = NULL, *thumbnail_data = NULL, *screen_data = NULL;
char file_name[100], curr_dir[256], tracked_dir[256] = "", known_dir[256], temp[256], temp2[256], displayed_radio_event[128];
char from_dir[256], to_dir[256], from_dir_saved[256], to_dir_saved[256], old_name[100], new_name[100], extension[10] = "";;
static char saved_jpg_current_dir[256], saved_mp3_current_dir[256], saved_rec_current_dir[256], saved_pf_current_dir[256], move_file_name[100];
static char toppy_pin[5], entered_pin[5], lookup_letter[2];
static int  bitmap_width, bitmap_height, cached_width, cached_height;
static int  no_of_jpegs = 0, no_of_mp3s = 0, no_of_mp3_headers = 0;
static int  no_of_move_folders = 0, no_of_playlists = 0, no_of_photo_playlists = 0, no_of_mp3_playlists = 0;
static int  local_no_of_jpegs = 0, local_no_of_mp3s = 0, local_no_of_recs = 0, default_folder_count = 0;
static int  current_def_slideshow_folder = 0, current_def_startup_folder = 0, current_skin = 0, skin_count = 0;
static int  current_jpg_activation_key, current_mp3_activation_key, current_rec_activation_key, current_pf_activation_key, current_last_played_activation_key, current_create_thumbnail_key;
static int  channel_number, current_channel_number, tv_radio;
static int  current_jpeg = 0, previous_jpeg = 0, current_mp3 = 0;
static int  tick = 0, fade_tick = 0, timeout_tick = 0, copy_tick = 0, copy_error_tick = 0, tick_one_sec = 0, log_memory_tick = 0;
static int  tick_two_sec = 0, update_progress_tick = 0, refresh_rec_tick = 0, refresh_disk_space_tick = 0;
static int  cursor_tick = 0, last_thumb_run = 0, trim_tick = 0, play_next_tick = 0, burnout_tick = 0, letter_tick = 0;
static int  arrow_press_length, screensaver_delay = 1, memory_delay = 2;
static int  no_of_files = 0, no_of_rec_headers = 0, no_of_dimensions = 0;
static int toppy_transparency, toppy_tv_ratio, toppy_tv_format, toppy_mheg_status, letter_idx;
static int gmt_offset = 0, compact_offset_x = 190, compact_offset_y = 190;
static int curr_idx, options_idx, move_folder_idx, load_playlist_idx, load_skin_idx, stop_menu_idx, auto_delete_idx, auto_delete_update_idx, skin_editor_idx, skin_element_idx, saved_menu_idx = 1, saved_idx;
static int curr_highlight, options_highlight, move_folder_highlight, load_playlist_highlight, load_skin_highlight, stop_menu_highlight, auto_delete_highlight, auto_delete_update_highlight, skin_editor_highlight, skin_element_highlight, saved_menu_highlight = 1;
static int skin_colour_idx, saved_playlist_idx, saved_playlist_highlight;
static int saved_scene_idx, saved_recycle_idx, saved_recycle_highlight;
static int saved_auto_delete_idx, saved_auto_delete_highlight;
TYPE_TapChInfo channel_info;

#define HISTORY_LENGTH 512
int photo_history[HISTORY_LENGTH], mp3_history[HISTORY_LENGTH];
static char *folder_history[HISTORY_LENGTH];
word photo_history_pointer = 0, mp3_history_pointer = 0, folder_history_pointer = 0;

struct _nav_history
{
	int idx;
	int highlight;
} nav_history[20], jpg_nav_history[20], mp3_nav_history[20], rec_nav_history[20], pf_nav_history[20];
static bool jpg_navigation = FALSE, mp3_navigation = FALSE, rec_navigation = FALSE, pf_navigation = FALSE;
static byte line_height, line_count, line_gap, trim_step;
static word copy_step, copy_delay;
static byte pin_counter = 0, pin_play_type;
static bool scenes_are_locked = FALSE;
#define PLAY_FROM_START 0
#define PLAY_FROM_LAST_WATCHED 1
#define PLAY_FROM_SCENE 2
#define LOCKED_FILE 0x02
static byte lut[256][4];
static dword /*eeprom_offset,*/ saved_letter;

dword heap_size, free_size, available_size;

#define MEMORY_LIMIT 4096

static int last_played_key = 0, no_of_progress = 0;
struct progress_data
{
	char  file_name[100];
	dword start_cluster;
	dword current_block;
	dword total_block;
} *progress[512];
struct _skin_elements
{
	char *element_name;
	char *element_comment;
	word red;
	word green;
	word blue;
} **skin_elements;
struct _dimensions_old
{
	char file_name[100];
	word width;
	word height;
} dimensions_old;
struct _dimensions
{
	char file_name[100];
	word width;
	word height;
	byte rotation;
} *dimensions[512], *dimension_1, *dimension_2;
struct _dir_info
{
	char *file_name;
	char *event_name;
	char *sort_name;
	char *description;
	char *service_name;
	word no_of_jpegs;
	word no_of_mp3s;
	word no_of_recs;
	word hour;
	word min;
	word duration;
	word mjd;
	dword start_cluster;
	dword size;
	bool folder;
	word attr;
	bool locked;
	bool radio;
	byte service_type;
	word service_num;
	word event_start_hour;
	word event_start_min;
	word event_end_hour;
	word event_end_min;
	byte encryption;
	byte track_number;
} *dir_info[2048], *info_1, *info_2;
typedef struct header_info
{
	char *file_name;
	char *directory;
	dword start_cluster;
	char *event_name;
	char *description;
	char *service_name;
	word duration;
	word mjd;
	bool radio;
	byte service_type;
	word service_num;
	word event_start_hour;
	word event_start_min;
	word event_end_hour;
	word event_end_min;
	word attr;
	word *thumbnail;
	int thumbnail_width;
	int thumbnail_height;
} TYPE_Header;
TYPE_Header *all_rec_headers[1024];
TYPE_Header *getRecHeader(char *name, dword start_cluster);
static bool reload_header = FALSE;
struct media_files
{
	char *directory;
	char *file_name;
	char *sort_name;

	char *track_name;
	char *artist_name;
	char *album_name;
	char *genre_string;
	char *year_string;
	byte track_number;
	bool header_loaded;
	word duration;

	word mjd;
	word hour;
	word min;
}  **jpeg_files, **mp3_files, **all_mp3_headers, *jpeg_file_1, *jpeg_file_2;
ID3 *id3_info = NULL, *playing_id3_info = NULL;
static bool mp3s_loaded = FALSE;
struct playlist
{
	char directory[256];
	char file_name[100];
} *photo_playlist[512], *mp3_playlist[512];
struct _auto_delete_list
{
	char file_name[100];
	word delete_after_days;
	word delete_after_min;
	word delete_after_max;
	word delete_when_disk;
	word spare_1;
	word spare_2;
	word spare_3;
	word spare_4;
} *auto_delete_list[512], auto_delete_copy, *auto_delete_switch;
struct _recycle_bin_list
{
	char file_name[100];
	char directory[256];
	bool folder;
	word mjd;
	word hour;
	word min;
	dword size;
	word deletion_mjd;
	word deletion_hour;
	word deletion_min;
	dword start_cluster;
} *recycle_bin_list[512], *recycle_1, *recycle_2;
struct _recordings_extract
{
	char *file_name;
	char *matched_name;
	char *directory;
	dword start_cluster;
	word mjd;
	word hour;
	word min;
	dword size;
} **recordings_extract, *extract_1, *extract_2;
static word no_of_recordings;
struct _recordings_episode_count
{
	char *matched_name;
	word no_of_episodes;
} **recordings_episode_count, *episodes_1, *episodes_2;
static word no_of_matched_recordings;
char *move_folders[128];
struct _skins
{
	char *skin_name;
	bool in_skins_folder;
} skins[128], skin_1, skin_2;

char *default_directories[128], *mp3_playlists[128], *photo_playlists[128], *insert_elements[128];
struct _marked_recordings
{
	char *file_name;
	char *directory;
	word mjd;
	word hour;
	word min;
	dword size;
	dword start_cluster;
} marked_recordings[32];
word no_of_marked_recordings = 0;
struct _saved_recordings
{
	char file_name[100];
	char directory[256];
	dword start_cluster;
} *saved_recordings[32];
int no_of_saved_recordings = 0;
byte saved_recording_mode;
extern struct exif
{
	char heading[20];
	char detail[100];
} photo_exif[32];
extern int no_of_details;
static word info_x_offset, info_y_offset, info_width, info_height, mp3_progress_offset;
char **all_folders;
int  all_folders_count, all_folders_idx;

bool show_jpeg = TRUE, enlarge_jpeg = TRUE, puzzle_jpeg = TRUE, memory_delay_elapsed = TRUE, jpeg_failed = FALSE; 
bool slideshow_paused = FALSE, force_display = FALSE, drawing_jpeg = FALSE, draw_from_cache = FALSE, smaller_font = FALSE;
word rotated_degrees = 0, shrink_factor = 11, puzzle_counter = 0;
int puzzle_history[16];

TYPE_OsdBaseInfo osd_base_info_plane1;
extern word *_vAddr[576];

#define ATTR_DELETED 	0xff
#define ATTR_PARENT 	240
#define ATTR_THIS	 	241

#define VIEW_W	600
#define VIEW_H	450

#define RKEY_Red 		0x1003f
#define RKEY_Green		0x10024
#define RKEY_Yellow		0x10025
#define RKEY_Blue		0x10026
#define RKEY_White 		0x1003e
#define RKEY_Filelist	0x10042
#define RKEY_Options	0x10010
#define RKEY_Text		RKEY_Next
#define RKEY_Pip		0x10041
#define RKEY_PipSwap    0x10040
#define RKEY_None		0x0
#define RAWKEY_Up				0x100 
#define RAWKEY_Down				0x101 
#define RAWKEY_Right			0x102 
#define RAWKEY_Left				0x103 
#define RAWKEY_List_TVRad		0x104 
#define RAWKEY_ChUp_Subt		0x107
#define RAWKEY_VolUp_Fav		0x109
#define RAWKEY_VolDown_Exit		0x11c
#define RAWKEY_TVRadio_Uhf		0x143 
#define RAWKEY_ChDown_Teletext	0x147 

static dword activation_options[] = {RKEY_None, RKEY_Filelist, RKEY_Recall, RKEY_TvSat, RKEY_Slow, RKEY_Mute, RKEY_TvRadio, RKEY_Text, RKEY_Pip, RKEY_PipSwap, RKEY_Options, RKEY_0, RKEY_1, RKEY_2, RKEY_3, RKEY_4, RKEY_5, RKEY_6, RKEY_7, RKEY_8, RKEY_9, RKEY_Uhf, RKEY_Fav, RKEY_Subt, RKEY_AudioTrk, RKEY_White, RKEY_Red, RKEY_Green, RKEY_Yellow, RKEY_Blue};
#define NUMBER_OF_ACTIVATIONS  30

//#define X  75
//#define Y  45
#define W  613
#define H  444

TYPE_File *log_file;
char log_line[128];
int  log_line_pointer;
bool log_eof;
dword log_size, log_read_so_far;
byte *log_data;
int page_pointers[128];
word page_number;

#define OPTIONS_FILENAME "MediaManager.ini"
#define DATA_BUFFER_SIZE_ini 1024

char log_buffer[512], association_buffer[512];
char buffer[100], buffer2[100], buffer3[100], buffer4[256], buffer5[256];

static char  *dataBuffer_ini;
static int   dataBufferPtr_ini;

#define BUFFER_SIZE 1500

// Variable used to cater for offset differences between TF5000 (0 offset), TF5000  (-4 offset) and the TF5800 (4 bytes offset)
int headerOffset = 4;

#define REC_VERSION_OFFSET 8
#define REC_VERSION_LENGTH 2
unsigned short recVersion;

#define REC_DURATION_OFFSET 8
#define REC_DURATION_LENGTH 2
unsigned short recDuration;

#define SVC_NUM_OFFSET 10
unsigned short svcNum;

#define SVC_TYPE_OFFSET 13
unsigned short svcType;

#define SERVICE_NAME_OFFSET 28 //TF5100 29
#define SERVICE_NAME_LENGTH 24
char serviceName[MAX_SvcName];

#define EVENT_DESC_MAX_LENGTH 256
char eventDescName[EVENT_DESC_MAX_LENGTH];

#define EVENT_DURATION_OFFSET 70
#define EVENT_DURATION_LENGTH 2
unsigned short eventDuration;

#define EVENT_STARTMJD_OFFSET 76
#define EVENT_STARTMJD_LENGTH 2
unsigned short eventStartMJD;

#define EVENT_STARTHOUR_OFFSET 78
unsigned short eventStartHour;

#define EVENT_STARTMIN_OFFSET 79
unsigned short eventStartMin;

#define EVENT_ENDMJD_OFFSET 80
#define EVENT_ENDMJD_LENGTH 2
unsigned short eventEndMJD;

#define EVENT_ENDHOUR_OFFSET 82
unsigned short eventEndHour;

#define EVENT_ENDMIN_OFFSET 83
unsigned short eventEndMin;

#define EVENT_NAME_LENGTH_OFFSET 85 //89  TF5100 (subtract 1 from the length)
#define EVENT_NAME_LENGTH_LENGTH 1
unsigned short eventNameLength;

#define PARENTAL_RATING_OFFSET 86  // 90
#define PARENTAL_RATING_LENGTH 1
unsigned short parentalRating;

#define EVENT_NAME_OFFSET 87  //91  TF5100 88
#define EVENT_NAME_MAX_LENGTH 256
char eventName[EVENT_NAME_MAX_LENGTH];

#define EXT_INFO_LENGTH_OFFSET 362
#define EXT_INFO_LENGTH_LENGTH 2
unsigned short extInfoLength;

#define EXT_INFO_OFFSET 368
#define EXT_INFO_MAX_LENGTH 1024
char extInfo[EXT_INFO_MAX_LENGTH];

#define RESUME_BOOKMARK_OFFSET 1528
#define RESUME_BOOKMARK_LENGTH 4
unsigned long resumeBookmark;

int info_start_pixel;
word info_pointer, info_lines;
#define SCROLL_DOWN 0
#define SCROLL_UP	1
#define PAGE_DOWN	2
#define PAGE_UP		3

char keyboard_name[100];
word cursor_pointer;
word keyboard_data[36];
bool new_folder = FALSE, search_mp3s = FALSE, new_auto_delete = FALSE;
int keyboard_idx = 0, keyboard_offset = 0;
byte keyboard_case;
#define KEYBOARD_AUTO 0
#define KEYBOARD_UPPER 1
#define KEYBOARD_LOWER 2
#define KEYBOARD_NUMERIC 3

#define OSD_RED             "\x90[25]" 
#define OSD_GREEN           "\x90[26]"
#define OSD_YELLOW          "\x90[27]"
#define OSD_BLUE            "\x90[28]"
#define OSD_WHITE           "\x90[29]"
#define OSD_REWIND          "\x90[31]"
#define OSD_PLAY            "\x90[32]"
#define OSD_PAUSE           "\x90[33]"
#define OSD_FORWARD         "\x90[34]"
#define OSD_SLOW            "\x90[35]"
#define OSD_STOP            "\x90[36]"
#define OSD_RECORD          "\x90[37]" 
#define OSD_OPT             "\x90[43]" 
#define OSD_OK              "\x90[3]" 

//bool (*TAP_Hdd_Move)(char *from_dir, char *to_dir, char *filename);
/*enum
{
    oTAP_Hdd_unknown0          = 0x00,  //hdd related, called by debug functions 'rs', 'rc'     -- read sector?
    oTAP_Hdd_unknown1          = 0x01,  //hdd related, called by debug functions 'ws', 'wc'     -- write sector?
    oTAP_unknown2              = 0x02,  //writes to eeprom? @ 0xa3ffffe0, 0xa3ffffe1
    oTAP_Hdd_unknown3          = 0x03,  //ata/dma related, ???
    oTAP_Hdd_SetBookmark       = 0x04,
    oTAP_Hdd_GotoBookmark      = 0x05,
    oTAP_Hdd_ChangePlaybackPos = 0x06,
    oTAP_ControlEit            = 0x07,
    oTAP_SetBk                 = 0x08,
    oTAP_EPG_UpdateEvent       = 0x09,
    oTAP_EPG_DeleteEvent       = 0x0a,
    oTAP_EPG_GetExtInfo        = 0x0b,
    oTAP_Channel_IsStarted     = 0x0c,
    oTAP_Vfd_GetStatus         = 0x0d,
    oTAP_Vfd_Control           = 0x0e,
    oTAP_Vfd_SendData          = 0x0f,
    oTAP_Win_SetAvtice         = 0x10,
    oTAP_Win_SetDrawItemFunc   = 0x11,
    oTAP_SysOsdControl         = 0x12,
    oTAP_Hdd_Move              = 0x13,
    oTAP_Osd_unknown20         = 0x14,  //osd related, ???
};
#ifdef WIN32
void * (*TAP_GetSystemProc)(int);
#endif
#ifndef WIN32
extern void * (*TAP_GetSystemProc)(int);
#endif*/

#define FILE_LIST_NAVIGATION 0
#define PLAYLIST_NAVIGATION 1
#define MENU_NAVIGATION 2
#define SKIN_EDITOR_NAVIGATION 3
#define SKIN_LOAD_NAVIGATION 4
#define SKIN_ELEMENT_NAVIGATION 5
#define PLAYLIST_LOAD_NAVIGATION 6
#define MOVE_FOLDER_NAVIGATION 7
#define AUTO_DELETE_NAVIGATION 8

// use for WSSKiller support
#define  WSS_43    0x20001
#define  WSS_Auto  0x20002

static int dimensions_key = -1;
enum {
	NO_ROTATION,
	ROTATION_90,
	ROTATION_180,
	ROTATION_270
};

#define BLOCK_UPDATE_PERIOD 160

static bool is_ozzie = FALSE, was_paused = FALSE, was_playing = FALSE;
static dword paused_tick = 0;

typedef struct
{
  word  evtId;
  dword startTime;
  dword   endTime;
  word  duration;
  byte  runningStatus;
  char  eventNameDesc[253];  // Replaces eventName and description
  byte  genre;       // New element
  byte  genreSub;    // New element
  byte  descOffset;  // New element - usually zero without patch
  byte  parentalRating;
  byte  satIdx;
  word  svcId;
  word  orgNetId;
  word  tsId;
} TYPE_TapEventDE;
#define TAP_GetEventDE(t,n,e) ((TYPE_TapEventDE*)TAP_GetEvent(t,n,e))
#define TAP_GetCurrentEventDE(t,n) ((TYPE_TapEventDE*)TAP_GetCurrentEvent(t,n))

static int saved_channel_number, saved_tv_radio;
static int no_of_tv_channels = 0, no_of_radio_channels = 0;
static struct channel {
	char *channel_name;
	word channel_number;
} **channels;

char* getChannel(dword channel_number)
{
	word i;
	for (i = 0; i < no_of_tv_channels; i++) {
		if (channels[i]->channel_number == channel_number)
			return channels[i]->channel_name;
	}
	return "";
}

void populateChannels()
{	
	word i;

	TAP_Channel_GetTotalNum(&no_of_tv_channels, &no_of_radio_channels);
	channels = dlmalloc(sizeof(*channels) * no_of_tv_channels);

	for (i = 0; i < no_of_tv_channels; i++) {
		TAP_Channel_GetInfo(SVC_TYPE_Tv, i, &channel_info);	

		channels[i] = dlmalloc(sizeof(*channels[i]));
		memset(channels[i], 0, sizeof(*channels[i]));

		// populate the file name and folder flag
		channels[i]->channel_name = dlmalloc(strlen(channel_info.chName) + 1);
		strcpy(channels[i]->channel_name, channel_info.chName);
		channels[i]->channel_number = i;
	}

	if (mp3_channel > no_of_tv_channels)
		mp3_channel = 0;
}

void freeChannels()
{
	word i;
	if (channels) {
		for (i = 0; i < no_of_tv_channels; i++) {
			if (channels[i]) {
				if (channels[i]->channel_name)
					dlfree(channels[i]->channel_name);

				dlfree(channels[i]);
				channels[i] = NULL;
			}
		}

		dlfree(channels);
		dlmalloc_trim(0);
	}
}

static int looked = 0;
static dword *bmCount = NULL;
static dword *bmRec = NULL;
static int bmMax = 0;

// Locates firmware variables
static void findBM()
{
  word *bm;
  extern int _appl_version;

#ifndef WIN32
  looked = 1;
  bm = (word*)FindInstructionSequence(
    "3c1681ee 3c1381ee 26d6b10c 2673b100 8f8487ec 26650008 0c055da3 26c60180",
    "fff00000 fff00000 ff000000 ff000000 ffff0000 ff0fffff fc000000 ff8ff000",
    0x80100000, 0x80180000, 0, FALSE);
  if(bm == NULL)
    TAP_Print("No bookmark variables - unsupported firmware (fw: %d:%x)\n", *((volatile word*)0xa3fffffa), _appl_version);
  else
  {
    bmRec = (dword*)((bm[1]<<16)+(short)bm[5]);
    bmCount = (dword*)((bm[3]<<16)+(short)bm[7]);
    bmMax = bm[15] >> 3;
  }
#endif
}

// Returns bookmark count for the slot (0,1=RecSlot, 2=Play)
dword getBookmarkCount(dword slot)
{
  if(looked == 0)
    findBM();
  if(bmCount && slot<=2)
    return bmCount[slot];
  else
    return 0;
}

// Returns bookmark n for the slot (0,1=RecSlot, 2=Play)
dword getBookmark(dword slot, dword n)
{
  if(looked == 0)
    findBM();
  if(bmRec && n<bmCount[slot])
    return bmRec[slot*bmMax+n];
  else
    return 0;
}

void gotoAccurateBookmark(dword slot)
{
	TYPE_PlayInfo play_info; TYPE_RecInfo rec_info;
	word mins_in, percentage; dword bookmark_block;

	TAP_Hdd_ChangePlaybackPos(0);

	if (!skip_to_bookmark || getBookmarkCount(slot) == 0)
		return;

	TAP_Hdd_GetPlayInfo(&play_info);
	if (slot < 2) 
		TAP_Hdd_GetRecInfo(slot, &rec_info);
	bookmark_block = getBookmark(slot, 0);

	if (slot < 2) {
		dword total_block = (rec_info.duration*60) * play_info.totalBlock / rec_info.recordedSec;
		mins_in = bookmark_block * rec_info.duration / total_block;
		percentage = bookmark_block * 100 / total_block;
	}
	else {
		mins_in = bookmark_block * play_info.duration / play_info.totalBlock;
		percentage = bookmark_block * 100 / play_info.totalBlock;
	}

	if (mins_in <= 10 && percentage <= 60)
		TAP_Hdd_GotoBookmark();
}

TYPE_TapEventDE* getDEEvent(int service_type, int service_number, int *event_number)
{
	TYPE_TapEventDE* events;
	int no_of_events, i; 

	//events = TAP_GetEventDE(service_type, service_number, &no_of_events);	
	return TAP_GetCurrentEventDE(service_type, service_number);

	// find current event
	/*if (events) { 
        for (i = 0; i < no_of_events; i++) { 
            if (events[i].runningStatus == 4)
                break; 
        } 
    } 

    if (events && events[i].runningStatus == 4) { 
		*event_number = i;
		return events;
	}

	if (events)
		TAP_MemFree(events);

	return NULL;*/
}

TYPE_TapEvent* getEvent(int service_type, int service_number, int *event_number)
{
	TYPE_TapEvent* events;
	int no_of_events, i; 

	//event = TAP_GetEvent(service_type, service_number, &no_of_events);	
	return TAP_GetCurrentEvent(service_type, service_number);	

	// find current event
	/*if (events) { 
        for (i = 0; i < no_of_events; i++) { 
            if (events[i].runningStatus == 4)
                break; 
        } 
    } 

    if (events && events[i].runningStatus == 4) { 
		*event_number = i;
		return events;
	}

	if (events)
		TAP_MemFree(events);

	return NULL;*/
}

void drawText(word region_mem, dword x, dword y, dword max, char *text, dword fc, dword bc, byte font_size)
{
	if (strcmp(font_name, "Default") != 0) {
		switch (font_size) {
			case FNT_Size_1419:	
				if (fonts[current_font].small_font)
					TAP_Osd_PutS_Font(region_mem, x, y+2, (max == -1) ? 0 : max, text, fc, COLOR_None, fonts[current_font].small_font, ALIGN_LEFT); 
				else
					TAP_Osd_PutS(region_mem, x, y, max, text, fc, COLOR_None, FALSE, font_size, FALSE, ALIGN_LEFT);
				break;
			case FNT_Size_1622:	
				if (fonts[current_font].medium_font)
					TAP_Osd_PutS_Font(region_mem, x, y+2, (max == -1) ? 0 : max, text, fc, COLOR_None, fonts[current_font].medium_font, ALIGN_LEFT); 
				else
					TAP_Osd_PutS(region_mem, x, y, max, text, fc, COLOR_None, FALSE, font_size, FALSE, ALIGN_LEFT);
				break;
			case FNT_Size_1926:	
				if (fonts[current_font].large_font)
					TAP_Osd_PutS_Font(region_mem, x, y+2, (max == -1) ? 0 : max, text, fc, COLOR_None, fonts[current_font].large_font, ALIGN_LEFT); 
				else
					TAP_Osd_PutS(region_mem, x, y, max, text, fc, COLOR_None, FALSE, font_size, FALSE, ALIGN_LEFT);
				break;
		}
	}
	else
		TAP_Osd_PutS(region_mem, x, y, max, text, fc, COLOR_None, FALSE, font_size, FALSE, ALIGN_LEFT);
}

void drawHelpButton(word region, dword x, dword y, dword color1, dword color2, char *button)
{
	if (masterpiece_mode) {
		TAP_Osd_FillBox(region, x, y+3, 15, 10, color1);
		if (color2 != COLOR_None)
			TAP_Osd_FillBox(region, x+3, y+3+3, 9, 4, color2);
	}
	else
		TAP_Osd_PutString1419(region, x-5, y, -1, button, COLOR_None, COLOR_None); 
}

void refreshCompactChannel()
{
	word string_length, indent, compact_width = 460, compact_height = 276;

	// get channel info
	TAP_Channel_GetCurrentSubTV(&channel_number);
	TAP_Channel_GetInfo(SVC_TYPE_Tv, channel_number, &channel_info);

	// get the length of string for centralizing
	string_length = getWidth(channel_info.chName, FNT_Size_1419);
	if (string_length > 200) string_length = 200;
	indent = compact_offset_x+compact_width-200-15+((200-string_length) / 2);
	TAP_Osd_FillBox(region, compact_offset_x+compact_width-200-15, compact_offset_y+30, 200, 25, COLOR_Black);
	drawText(region, indent, compact_offset_y+33, -1, channel_info.chName, bare_bones_text_colour, COLOR_None, FNT_Size_1419);
}

bool isRecPlaying(TYPE_PlayInfo play_info)
{
	return (play_info.playMode == PLAYMODE_Playing || play_info.playMode == PLAYMODE_RecPlaying);
}

bool isPlaying(TYPE_PlayInfo play_info)
{
	return (isRecPlaying(play_info) || play_info.playMode == PLAYMODE_TempPlaying);
}

void handleStopMp3(bool clear_folders, bool save_history) 
{
	mp3_playing = FALSE;
	TAP_Hdd_StopMp3();
	if (save_history && mp3_playlist_playing) {
		if (getHistoryLength(FALSE) == no_of_mp3s)
			clearHistory(FALSE);
		savePlaylistHistory();
	}
	clearHistory(FALSE);
	if (clear_folders)
		clearFolderHistory();
}

void handleKickoffMp3Mode()
{
	if (mp3_channel) {
		TAP_Channel_GetCurrent(&saved_channel_number, &saved_tv_radio);
		TAP_Channel_Start(1, SVC_TYPE_Tv, mp3_channel - 1);
	}

	single_mp3_mode = FALSE;
	startMP3Mode(mp3_mode, FALSE);

	if (idle_before_photo_display) 
		play_mp3 = TRUE;
	else {
		ChangeDirPath(mp3_files[current_mp3]->directory);
		playMp3(mp3_files[current_mp3]->file_name);
		if (mp3_mode == OFF && (playlist_displayed || !thumbnail_mode)) 
			drawMp3InfoBox();
	}
}

bool isOzzie()
{
#ifndef WIN32
	dword i;
	char *pChar = (char*)0x80200000;

	for (i = 0; i < 0x100000; i++) {
		if((pChar[i + 0] == 'N') &&
				(pChar[i + 1] == 'P') &&
				(pChar[i + 2] == 'T') &&
				(pChar[i + 3] == 'A')) {
			return TRUE;
		}
	}
#endif
	return FALSE;
}

bool isPaused(TYPE_PlayInfo play_info)
{
	int currentTick = TAP_GetTick(); 
	static int lastBlock = 0, lastChangeTick = 0;

	if (play_info.playMode == PLAYMODE_Playing ||
			play_info.playMode == PLAYMODE_RecPlaying ||
			play_info.playMode == PLAYMODE_TempPlaying ||
			(play_info.playMode == PLAYMODE_None &&
				play_info.trickMode == TRICKMODE_Pause)) {

		if (!isTF5800()) {
			if (lastBlock != play_info.currentBlock)	{
				lastBlock = play_info.currentBlock;
				lastChangeTick = currentTick;
			}

			if ((currentTick - lastChangeTick) > BLOCK_UPDATE_PERIOD) {
				if (!was_paused)
					paused_tick = TAP_GetTick(); 
				return TRUE;
			}

			return FALSE;
		}
		ef (play_info.trickMode == TRICKMODE_Pause) {
			if (!was_paused) {
				paused_tick = TAP_GetTick(); 
			}
			return TRUE;
		}
	}

	return FALSE;
} 

struct _status
{
	bool isMuted;
	byte volumeLevel;
} status;

void mute()
{
#ifndef WIN32
    if (status.isMuted)
    {
        //TAP_SetSoundLevel(status.volumeLevel);
		TAP_SetSystemVar(SYSVAR_Vol, status.volumeLevel);
        TAP_WriteSystemVar();
        status.isMuted = FALSE;
    }
    else
    {
        status.volumeLevel = TAP_GetSystemVar(SYSVAR_Vol);
        TAP_SetSystemVar(SYSVAR_Vol, 0);
        TAP_WriteSystemVar();
	    status.isMuted = TRUE;
    } 
#endif
}

void volUp()
{
#ifndef WIN32
    if (status.isMuted)
    {
        //TAP_SetSoundLevel(status.volumeLevel);
		TAP_SetSystemVar(SYSVAR_Vol, status.volumeLevel);
        TAP_WriteSystemVar();
        status.isMuted = FALSE;
    }
    else
    {
        status.volumeLevel = TAP_GetSystemVar(SYSVAR_Vol);
        if (status.volumeLevel < 31) TAP_SetSystemVar(SYSVAR_Vol, ++status.volumeLevel);
        TAP_WriteSystemVar();
    } 
#endif
}

void volDown()
{
#ifndef WIN32
	if (status.isMuted)
    {
        //TAP_SetSoundLevel(status.volumeLevel);
		TAP_SetSystemVar(SYSVAR_Vol, status.volumeLevel);
        TAP_WriteSystemVar();
        status.isMuted = FALSE;
    }
    else
    {
        status.volumeLevel = TAP_GetSystemVar(SYSVAR_Vol);
        if (status.volumeLevel > 0) TAP_SetSystemVar(SYSVAR_Vol, --status.volumeLevel);
        TAP_WriteSystemVar();
    } 
#endif
} 

char *playback_ext_info;

void saveExtendedInfo()
{
	if (preload_video_headers)
		return;

	if (playback_ext_info) {
		dlfree(playback_ext_info);
		playback_ext_info = NULL;
	}

	playback_ext_info = dlmalloc(strlen(dir_info[curr_idx]->description) + 1);
	strcpy(playback_ext_info, dir_info[curr_idx]->description);
}

void recreateWindow()
{
	TAP_Osd_Delete(region);
	TAP_Osd_Delete(region_mem);
	region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
	region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
}

void overnightShutdown()
{
#ifndef WIN32
	if (overnight_shutdown && !manual_batch_job) {
		TYPE_RecInfo rec_info_1, rec_info_2;
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(0, &rec_info_2);
		if (!((rec_info_1.recType == RECTYPE_Normal) || (rec_info_1.recType == RECTYPE_Copy))
				&& !((rec_info_2.recType == RECTYPE_Normal) || (rec_info_2.recType == RECTYPE_Copy))) {
			//if (firmware_hacks_enabled) {
				logText("Shutdown Toppy", FALSE);
				//exTAP_Shutdown();
				closeLogfile();
				//TAP_Shutdown();
				Shutdown(TaskPower);
			//}
		}
	}
#endif

	manual_batch_job = FALSE;
}

void drawMasterpieceBackground(word region, word x, word y, word w, word h, word border, word no_of_lines, word header, word footer, word border_colour, word fill_colour)
{
	TAP_Osd_DrawRectangle(region, x-5-2, y-5-2, w+10+1+4, h+10+1+4, 3, border_colour);
	if (fill_colour != COLOR_None) TAP_Osd_FillBox(region, x-5, y-5, w+10+1, h+10+1, fill_colour);
	if (header > 0) TAP_Osd_FillBox(region, x-5, y-5, w+10+1, header+5, header_bg_colour);
	if (header > 0) TAP_Osd_FillBox(region, x-5, y+header, w+10+1, 3, border_colour);
	if (footer > 0) TAP_Osd_FillBox(region, x-5, y+h-footer, w+10+1, footer+5+1, footer_bg_colour);
	else TAP_Osd_FillBox(region, x-5, y+h, w+10+1, 5+1, (fill_colour != COLOR_None ? fill_colour : body_bg_colour));
}

void drawProcessingMessage(word region, char *message, bool left_justify, bool top_left, bool fill)
{
	word string_length, indent, x = top_left ? 50 : offset_x+120, y = top_left ? 50 : offset_y+200, w = 360, h = 25;

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 0, 0, frame_colour, COLOR_None, header_bg_colour, TRUE);

	//TAP_Osd_DrawRectangle(region, x, y, w, h, 2, frame_colour);
	//TAP_Osd_FillBox(region, x+2, y+2, w-4, h-4, header_bg_colour);
	string_length = getWidth(message, FNT_Size_1926);
	indent = left_justify ? x+2+10 : x+2 + (((w-4) - string_length) / 2);
	drawText(region, indent, y+1, -1, message, header_text_colour, COLOR_None, FNT_Size_1926);
}

void extractHeaderThumbnail(TYPE_Header *header, char *name)
{
	TYPE_File *thumbnail_file;
	int thumbnail_width, thumbnail_height;

	if (header) {
		thumbnail_file = getPhotoCache(name, TRUE);
		if (thumbnail_file) {
			if (header->thumbnail) {
				dlfree(header->thumbnail);
				dlmalloc_trim(0);
			}
			header->thumbnail = (word *) getThumbnailRawData(thumbnail_file, &thumbnail_width, &thumbnail_height, TRUE, FALSE);
			header->thumbnail_width = thumbnail_width;
			header->thumbnail_height = thumbnail_height;
		}
	}
}

void checkMp3Match(struct media_files *mp3_header)
{
	if (mp3_header == NULL)
		return;

	if (containsSubstring(mp3_header->file_name, keyboard_name) >= 0
			|| (mp3_header->artist_name && containsSubstring(mp3_header->artist_name, keyboard_name) >= 0)
			|| (mp3_header->album_name && containsSubstring(mp3_header->album_name, keyboard_name) >= 0)
			|| (mp3_header->track_name && containsSubstring(mp3_header->track_name, keyboard_name) >= 0)
			|| (mp3_header->genre_string && containsSubstring(mp3_header->genre_string, keyboard_name) >= 0)
			|| (mp3_header->year_string && containsSubstring(mp3_header->year_string, keyboard_name) >= 0))
		appendToPlaylist(FALSE, mp3_header->directory, mp3_header->file_name, FALSE);
}

#define LOAD_HEADERS 0
#define LOAD_DECODINGS 1
#define LOAD_AUTO_DELETE_RULES 2
#define CREATE_THUMBNAILS 3
#define LOAD_SEARCH_MP3S 4

void parseAllFiles(int mode, int rules_idx, bool notify)
{
	TYPE_File file;
	int subfolder_count = 0, i;
	char **subfolders = dlmalloc(sizeof(*subfolders) * 2048);

	i = TAP_Hdd_FindFirst(&file);
	while (i-- && subfolder_count < 2048) {
	
		if (isRec(file.name)) {
			if (mode == LOAD_HEADERS)
				LoadHeaderInfo(file.name, file.startCluster, tracked_dir, -1, notify);
			ef (mode == LOAD_DECODINGS) {
				if (file.crypt > 0 
						&& ((overnight_copy == AUTO_COPY_ALL)
							|| (overnight_copy == AUTO_COPY && file.crypt != 0x02))
						&& isCopy(file.name) < 0) {
					if (write_log) TAP_SPrint(log_buffer, "Found %s, %s", file.name, tracked_dir);
					if (write_log) logText(log_buffer, FALSE);
					appendToMarkedRecordings(file.name, tracked_dir, file.startCluster, file.mjd, file.hour, file.min, file.size);
				}
			}
			ef (mode == LOAD_AUTO_DELETE_RULES) {
				if ((file.skip != LOCKED_FILE) && !isDuffRec(file))
					extractRecordingData(file, tracked_dir, rules_idx);
			}
			ef (mode == CREATE_THUMBNAILS) {
				if (!isDuffRec(file))
					createRecordingThumbnail(file.name, file.startCluster, TRUE, TRUE, FALSE, FALSE, FALSE);
			}
		}
		ef (isMp3(file.name))
		{
			if (mode == LOAD_SEARCH_MP3S) {
				if (preload_mp3_headers)
					getMp3Header(file.name, tracked_dir, file.mjd, file.hour, file.min, TRUE, FALSE, notify);
				ef (search_mp3s && containsSubstring(file.name, keyboard_name) >= 0)
					appendToPlaylist(FALSE, tracked_dir, file.name, FALSE);
			}
		}

		if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0 && strcmp(file.name, "CutFiles") != 0)	
		{
			subfolders[subfolder_count] = dlmalloc(100 * sizeof(char));
			strcpy(subfolders[subfolder_count], file.name);
			subfolder_count++;
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	for (i = 0; i < subfolder_count; i++)
	{
		ChangeDir(subfolders[i]);
		parseAllFiles(mode, rules_idx, notify);
		ChangeDir("..");
	}

	for (i = 0; i < subfolder_count; i++)
	{
		dlfree(subfolders[i]);
		subfolders[i] = NULL;
	}
	dlfree(subfolders);
	subfolders = NULL;

	dlmalloc_trim(0);
}

void copyMarkedRecordingsToSavedRecordings()
{
	word i;

	freeSavedRecordings();

	for (i = 0; i < no_of_marked_recordings; i++) {
		saved_recordings[i] = dlmalloc(sizeof(*saved_recordings[i]));

		strcpy(saved_recordings[i]->directory, marked_recordings[i].directory);
		strcpy(saved_recordings[i]->file_name, marked_recordings[i].file_name);
		saved_recordings[i]->start_cluster = marked_recordings[i].start_cluster;
	}

	no_of_saved_recordings = no_of_marked_recordings;
	saved_recording_mode = multi_play_batch_mode;
}

void copySavedRecordingsToMarkedRecordings()
{
	word i;

	for (i = 0; i < no_of_saved_recordings; i++) {
		marked_recordings[i].directory = dlmalloc(256 + 1);
		marked_recordings[i].file_name = dlmalloc(100 + 1);

		strcpy(marked_recordings[i].directory, saved_recordings[i]->directory);
		strcpy(marked_recordings[i].file_name, saved_recordings[i]->file_name);

		marked_recordings[i].start_cluster = saved_recordings[i]->start_cluster;
	}

	no_of_marked_recordings = no_of_saved_recordings;
	multi_play_batch_mode = saved_recording_mode;	
}

void saveSavedRecordings()
{
	TYPE_File *file;
	word i;

	// save user marked vids to disk
	copyMarkedRecordingsToSavedRecordings();

	ChangeDirMediaManager();
	if (TAP_Hdd_Exist("vid_saved.dat")) TAP_Hdd_Delete("vid_saved.dat");
	TAP_Hdd_Create("vid_saved.dat", ATTR_NORMAL);

	file = TAP_Hdd_Fopen("vid_saved.dat");
	TAP_Hdd_Fwrite(&no_of_saved_recordings, sizeof(int), 1, file);
	TAP_Hdd_Fwrite(&saved_recording_mode, sizeof(byte), 1, file);
	for (i = 0; i < no_of_saved_recordings; i++) {
		TAP_Hdd_Fwrite(saved_recordings[i], sizeof(*saved_recordings[i]), 1, file);
	}
	TAP_Hdd_Fclose(file);
	ChangeDirPath(curr_dir);
}

void loadSavedRecordings(bool copy_to_marked)
{
	TYPE_File *file;
	word i;

	freeSavedRecordings();

	// load in the recordings from disk
	ChangeDirMediaManager();
	strcpy(file_name, "vid_saved.dat");
	if (TAP_Hdd_Exist(file_name)) {
		if (write_log) logText("Reading saved vids from file", FALSE);
		file = TAP_Hdd_Fopen(file_name);
		if (file != NULL) {
			TAP_Hdd_Fread(&no_of_saved_recordings, sizeof(int), 1, file);
			TAP_Hdd_Fread(&saved_recording_mode, sizeof(byte), 1, file);
			for (i = 0; i < no_of_saved_recordings; i++) {
				saved_recordings[i] = dlmalloc(sizeof(*saved_recordings[i]));
				TAP_Hdd_Fread(saved_recordings[i], sizeof(*saved_recordings[i]), 1, file);
				TAP_SPrint(log_buffer, "Read %s, %s", saved_recordings[i]->file_name, saved_recordings[i]->directory);
				if (write_log) logText(log_buffer, FALSE);
			}
			TAP_Hdd_Fclose(file);
		}
		TAP_SPrint(log_buffer, "Read %d saved vids from file", no_of_saved_recordings);
		if (write_log) logText(log_buffer, FALSE);
	}

	// copy to the array for processing
	if (copy_to_marked)
		copySavedRecordingsToMarkedRecordings();

	ChangeDirPath(curr_dir);
}

void deleteSavedRecordings()
{
	// free memory
	freeSavedRecordings();

	// delete the file
	ChangeDirMediaManager();
	if (TAP_Hdd_Exist("vid_saved.dat")) TAP_Hdd_Delete("vid_saved.dat");
	ChangeDirPath(curr_dir);
}

void saveDimensions()
{
	TYPE_File *dimensions_file;
	word i;
	char *save_dump;

	qsort(dimensions, no_of_dimensions, sizeof(dimensions[0]), compareDimensions);
#ifndef WIN32
	if (TAP_Hdd_Exist("Cache")) {
#endif
		ChangeDir("Cache");
		if (TAP_Hdd_Exist("dimensions.dat")) TAP_Hdd_Delete("dimensions.dat");
		TAP_Hdd_Create("dimensions.dat", ATTR_NORMAL);
		dimensions_file = TAP_Hdd_Fopen("dimensions.dat");
		TAP_Hdd_Fwrite(&dimensions_key, sizeof(int), 1, dimensions_file);
		TAP_Hdd_Fwrite(&no_of_dimensions, sizeof(int), 1, dimensions_file);

		if (no_of_dimensions > 0) {
			save_dump = dlmalloc(sizeof(*dimensions[0]) * no_of_dimensions);

			for (i = 0; i < no_of_dimensions; i++) {
				memcpy(save_dump, dimensions[i], sizeof(*dimensions[i]));
				save_dump += sizeof(*dimensions[i]);
			}
			save_dump -= sizeof(*dimensions[0]) * no_of_dimensions;
			TAP_Hdd_Fwrite(save_dump, sizeof(*dimensions[0]), no_of_dimensions, dimensions_file);
			
			dlfree(save_dump);
			dlmalloc_trim(0);
		}

		//for (i = 0; i < no_of_dimensions; i++)
		//	TAP_Hdd_Fwrite(dimensions[i], sizeof(*dimensions[i]), 1, dimensions_file);

		TAP_Hdd_Fclose(dimensions_file);
		ChangeDir("..");
#ifndef WIN32
	}
#endif
}

void convertDimensions(TYPE_File *dimensions_file)
{
	word i;

	no_of_dimensions = dimensions_key;
	dimensions_key = -1;

	for (i = 0; i < no_of_dimensions; i++) {
		dimensions[i] = dlmalloc(sizeof(*dimensions[i]));
		memset(dimensions[i], 0, sizeof(*dimensions[i]));
		TAP_Hdd_Fread(dimensions[i], sizeof(dimensions_old), 1, dimensions_file);
		dimensions[i]->rotation = NO_ROTATION;
	}
	
	TAP_Hdd_Fclose(dimensions_file);

	ChangeDir("..");
	saveDimensions();
	ChangeDir("Cache");
}

/*void deleteDimensions()
{
#ifndef WIN32
	if (no_of_jpegs > 0) {
		if (TAP_Hdd_Exist("Cache")) {
			ChangeDir("Cache");
			if (TAP_Hdd_Exist("dimensions.dat"))
				TAP_Hdd_Delete("dimensions.dat");
			ChangeDir("..");
		}
	}
#endif
}*/

void loadDimensions()
{
	TYPE_File *dimensions_file;
	word i;
	char *load_dump;

	// create the cache dir if necessary
	createCacheDirectoryIfNotThere();

	// free any existing dim memory
	freeDimensions();

	// get the dimensions if cache exists
	ChangeDir("Cache");
	strcpy(file_name, "dimensions.dat");
	if (TAP_Hdd_Exist(file_name)) {
		if (write_log) if (verbose) logText("Reading dimensions from file", FALSE);
		dimensions_file = TAP_Hdd_Fopen(file_name);
		if (dimensions_file != NULL) {

			TAP_Hdd_Fread(&dimensions_key, sizeof(int), 1, dimensions_file);
			if (dimensions_key == -1) {
				TAP_Hdd_Fread(&no_of_dimensions, sizeof(int), 1, dimensions_file);

				if (no_of_dimensions > 0) {
					load_dump = dlmalloc(sizeof(*dimensions[0]) * no_of_dimensions);
					TAP_Hdd_Fread(load_dump, sizeof(*dimensions[0]), no_of_dimensions, dimensions_file);
					for (i = 0; i < no_of_dimensions; i++) {
						dimensions[i] = dlmalloc(sizeof(*dimensions[i]));
						memcpy(dimensions[i], load_dump, sizeof(*dimensions[i]));
						load_dump += sizeof(*dimensions[i]);
					}

					load_dump -= sizeof(*dimensions[0]) * no_of_dimensions;
					dlfree(load_dump);
					dlmalloc_trim(0);
				}

				//for (i = 0; i < no_of_dimensions; i++) {
				//	dimensions[i] = dlmalloc(sizeof(*dimensions[i]));
				//	TAP_Hdd_Fread(dimensions[i], sizeof(*dimensions[i]), 1, dimensions_file);
				//}

				TAP_Hdd_Fclose(dimensions_file);
			}
			else {
				// convert file to add the rotation flag
				convertDimensions(dimensions_file);
			}
		}
	}
	ChangeDir("..");
}

void deleteMp3Header(char *name, char *dir)
{
	int i, found_idx = -1; 

	if (!preload_mp3_headers)
		return;

	for (i = 0; i < no_of_mp3_headers; i++) {
		if (strcmp(all_mp3_headers[i]->file_name, name) == 0 && strcmp(all_mp3_headers[i]->directory, dir) == 0) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete mp3 header for %s, at %d of %d", name, i, no_of_mp3_headers);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			found_idx = i;
			break;
		}
	}

	if (found_idx >= 0) {
		dlfree(all_mp3_headers[found_idx]->file_name);
		dlfree(all_mp3_headers[found_idx]->directory);
		if (all_mp3_headers[found_idx]->track_name) dlfree(all_mp3_headers[found_idx]->track_name);
		if (all_mp3_headers[found_idx]->artist_name) dlfree(all_mp3_headers[found_idx]->artist_name);
		if (all_mp3_headers[found_idx]->album_name) dlfree(all_mp3_headers[found_idx]->album_name);
		if (all_mp3_headers[found_idx]->genre_string) dlfree(all_mp3_headers[found_idx]->genre_string);
		if (all_mp3_headers[found_idx]->year_string) dlfree(all_mp3_headers[found_idx]->year_string);

		for (i = found_idx; i < no_of_mp3_headers-1; i++) {
			memmove(all_mp3_headers[i], all_mp3_headers[i+1], sizeof(*all_mp3_headers[i]));
		}

		dlfree(all_mp3_headers[no_of_mp3_headers-1]);
		no_of_mp3_headers--;
	}

	dlmalloc_trim(0);
}

void appendMp3HeaderDetails(struct media_files *mp3_header, char *dir, bool change)
{
	if (change) ChangeDirPath(dir);
	readID3Tag(mp3_header->file_name, FALSE, FALSE);
	if (change) ChangeDirPath(curr_dir);

	if (id3_info->artist && strlen(id3_info->artist) > 0) {
		mp3_header->artist_name = dlmalloc(strlen(id3_info->artist) + 1);
		strcpy(mp3_header->artist_name, id3_info->artist);
	}
	if (id3_info->album && strlen(id3_info->album) > 0) {
		mp3_header->album_name = dlmalloc(strlen(id3_info->album) + 1);
		strcpy(mp3_header->album_name, id3_info->album);
	}
	if (id3_info->title && strlen(id3_info->title) > 0) {
		mp3_header->track_name = dlmalloc(strlen(id3_info->title) + 1);
		strcpy(mp3_header->track_name, id3_info->title);
	}
	if (id3_info->genre_code && strlen(id3_info->genre_code) > 0) {
		mp3_header->genre_string = dlmalloc(strlen(id3_info->genre) + 1);
		strcpy(mp3_header->genre_string, id3_info->genre);
	}
	if (id3_info->year && strlen(id3_info->year) > 0) {
		mp3_header->year_string = dlmalloc(strlen(id3_info->year) + 1);
		strcpy(mp3_header->year_string, id3_info->year);
	}
	mp3_header->duration = id3_info->duration;
	mp3_header->track_number = id3_info->track_number;
	mp3_header->header_loaded = TRUE;

	destroy_ID3(id3_info);
	id3_info = NULL;
}

bool appendMp3Header(char *name, char *dir, word mjd, byte hour, byte min, bool change)
{
	if (no_of_mp3_headers == MEMORY_LIMIT)
		return FALSE;

	if (no_of_mp3_headers == 0)
		all_mp3_headers = dlmalloc(sizeof(*all_mp3_headers) * MEMORY_LIMIT);

	all_mp3_headers[no_of_mp3_headers] = dlmalloc(sizeof(*all_mp3_headers[no_of_mp3_headers]));
	memset(all_mp3_headers[no_of_mp3_headers], 0, sizeof(*all_mp3_headers[no_of_mp3_headers]));

	// populate the file name and folder flag
	all_mp3_headers[no_of_mp3_headers]->directory = dlmalloc(strlen(dir) + 1);
	all_mp3_headers[no_of_mp3_headers]->file_name = dlmalloc(strlen(name) + 1);
	all_mp3_headers[no_of_mp3_headers]->sort_name = dlmalloc(strlen(name) + 2);
	strcpy(all_mp3_headers[no_of_mp3_headers]->directory, dir);
	strcpy(all_mp3_headers[no_of_mp3_headers]->file_name, name);
	FormatSortName(all_mp3_headers[no_of_mp3_headers]->sort_name, name);
	all_mp3_headers[no_of_mp3_headers]->mjd = mjd;
	all_mp3_headers[no_of_mp3_headers]->hour = hour;
	all_mp3_headers[no_of_mp3_headers]->min = min;
	no_of_mp3_headers++;

	if (preload_mp3_headers == HEADERS || preload_mp3_headers == HEADERS_LAZY)
		return TRUE;

	appendMp3HeaderDetails(all_mp3_headers[no_of_mp3_headers-1], dir, change);

	return TRUE;
}

struct media_files* getMp3Header(char *name, char *dir, word mjd, byte hour, byte min, bool create, bool change, bool notify)
{
	word i;

	if (!preload_mp3_headers)
		return NULL;

	for (i = 0; i < no_of_mp3_headers; i++) {
		if (strcmp(all_mp3_headers[i]->file_name, name) == 0 && strcmp(all_mp3_headers[i]->directory, dir) == 0) {
			if (!all_mp3_headers[i]->header_loaded && (preload_mp3_headers == HEADERS_AND_THUMBNAILS || preload_mp3_headers == HEADERS_AND_THUMBNAILS_LAZY))
				appendMp3HeaderDetails(all_mp3_headers[i], dir, change);

			return all_mp3_headers[i];
		}
	}

	if (create) {
		if (appendMp3Header(name, dir, mjd, hour, min, change)) {
			if (notify) {
				TAP_SPrint(buffer, "%d", no_of_mp3_headers);
				TAP_Osd_FillBox(region, active() ? offset_x+120+2+(360-4)-55 : 50+2+(360-4)-55, active() ? offset_y+200 : 50, 55, 25, header_bg_colour);
				drawText(region, active() ? offset_x+120+2+(360-4)-50 : 50+2+(360-4)-50, active() ? offset_y+200 : 50, -1, buffer, header_text_colour, COLOR_None, FNT_Size_1926);
			}
			return all_mp3_headers[no_of_mp3_headers-1];
		}
	}

	return NULL;
}

struct _dimensions *getDimensions(char *name)
{
	word i;

	for (i = 0; i < no_of_dimensions; i++) {
		if (strcmp(dimensions[i]->file_name, name) == 0)
			return dimensions[i];
	}

	return NULL;
}

bool displayProgress(word watched_mins, int current_block, int total_block, dword progress_format)
{
	switch (progress_format) {
		case NO_PROGRESS:
		case BAR:
			return FALSE;

		case MINS_GONE_MINS_LEFT:
		case MINS_GONE:
		case MINS_LEFT:
		case HOURS_MINS_GONE:
		case HOURS_MINS_LEFT:
			if (watched_mins > 0) 
				return TRUE;
			break;

		case PERCENTAGE_GONE:
		case PERCENTAGE_LEFT:
			if (total_block > 0 && (current_block*100/total_block) > 0)
				return TRUE;
			break;
	}

	return FALSE;
}

void adjustIndexForDelete(int *curr_idx, int *curr_highlight, int no_of_files, word lines) 
{
	// if at end of list, then move idx up
	if (*curr_idx == (no_of_files - 1)) {
		*curr_idx = *curr_idx - 1;
		if (no_of_files <= lines)
			*curr_highlight = *curr_highlight - 1;
	}
	ef (no_of_files > lines && *curr_idx >= (no_of_files - lines) && ((*curr_idx - *curr_highlight) >= (no_of_files - lines)))
		*curr_highlight = *curr_highlight + 1;
}

/*void drawScrollBar(word curr_idx, word curr_highlight, word lines)
{
	word screen_height = 287;
	word scroll_height = ((curr_idx - curr_highlight + (no_of_files < lines ? no_of_files : lines)) * screen_height / no_of_files);

	//TAP_Osd_FillBox(region_mem, X+W+10+1-9, Y+30+3, 4, screen_height, COLOR_Black);
	//TAP_Osd_FillBox(region_mem, X+W+10+1-9, Y+30+3, 4, scroll_height, COLOR_Yellow);
}*/

void shuffleUpFileList(word navigation_type, int *curr_idx, int *curr_highlight, int no_of_files, word lines)
{
	word scroll_height;

	if (no_of_files == 0)
		return;

	*curr_idx = (*curr_idx - 1) < 0 ? no_of_files - 1 : *curr_idx - 1;
	
	if (*curr_highlight == 0) {
		if (*curr_idx == (no_of_files - 1)) {
			if (no_of_files > lines)
				*curr_highlight = lines-1;
			else
				*curr_highlight = no_of_files - 1;
			if (navigation_type == MENU_NAVIGATION)
				drawOptions(*curr_idx - *curr_highlight);
			ef (navigation_type == PLAYLIST_NAVIGATION)
				drawPlaylistLines(*curr_idx - *curr_highlight);
			ef (navigation_type == SKIN_EDITOR_NAVIGATION)
				drawSkinEditorLines(*curr_idx - *curr_highlight);
			ef (navigation_type == SKIN_LOAD_NAVIGATION) {
				drawLoadSkins(*curr_idx - *curr_highlight);
				copyMemoryToMoveFolders();
			}
			ef (navigation_type == SKIN_ELEMENT_NAVIGATION) {
				drawSkinElements(*curr_idx - *curr_highlight);
				copyMemoryToMoveFolders();
			}
			ef (navigation_type == PLAYLIST_LOAD_NAVIGATION) {
				drawLoadPlaylists(*curr_idx - *curr_highlight);
				copyMemoryToMoveFolders();
			}
			ef (navigation_type == MOVE_FOLDER_NAVIGATION) {
				drawMoveFolders(*curr_idx - *curr_highlight);
				copyMemoryToMoveFolders();
			}
			ef (navigation_type == AUTO_DELETE_NAVIGATION)
				drawAutoDeleteListLines(*curr_idx - *curr_highlight);
			ef (navigation_type == FILE_LIST_NAVIGATION)
				drawFiles(*curr_idx - *curr_highlight);
		}
		else {
			if (no_of_files > lines && (*curr_idx < lines))
				*curr_highlight = *curr_idx;
			else
				*curr_highlight = lines-1;
			if (navigation_type == MENU_NAVIGATION)
				drawOptions(*curr_idx - *curr_highlight);
			ef (navigation_type == PLAYLIST_NAVIGATION)
				drawPlaylistLines(*curr_idx - *curr_highlight);
			ef (navigation_type == SKIN_EDITOR_NAVIGATION)
				drawSkinEditorLines(*curr_idx - *curr_highlight);
			ef (navigation_type == SKIN_LOAD_NAVIGATION) {
				drawLoadSkins(*curr_idx - *curr_highlight);
				copyMemoryToMoveFolders();
			}
			ef (navigation_type == SKIN_ELEMENT_NAVIGATION) {
				drawSkinElements(*curr_idx - *curr_highlight);
				copyMemoryToMoveFolders();}
			ef (navigation_type == PLAYLIST_LOAD_NAVIGATION) {
				drawLoadPlaylists(*curr_idx - *curr_highlight);
				copyMemoryToMoveFolders();
			}
			ef (navigation_type == MOVE_FOLDER_NAVIGATION) {
				drawMoveFolders(*curr_idx - *curr_highlight);
				copyMemoryToMoveFolders();
			}
			ef (navigation_type == AUTO_DELETE_NAVIGATION)
				drawAutoDeleteListLines(*curr_idx - *curr_highlight);
			ef (navigation_type == FILE_LIST_NAVIGATION)
				drawFiles(*curr_idx - *curr_highlight);
		}
	}
	else {
		*curr_highlight = *curr_highlight - 1;
		if (navigation_type == MENU_NAVIGATION) {
			drawOption(*curr_highlight, *curr_idx);
			drawOption(*curr_highlight + 1, *curr_idx + 1);
		}
		ef (navigation_type == PLAYLIST_NAVIGATION) {
			drawPlaylistLine(*curr_highlight, *curr_idx);
			drawPlaylistLine(*curr_highlight + 1, *curr_idx + 1);
		}
		ef (navigation_type == SKIN_EDITOR_NAVIGATION) {
			drawSkinEditorLine(*curr_highlight, *curr_idx);
			drawSkinEditorLine(*curr_highlight + 1, *curr_idx + 1);
		}
		ef (navigation_type == SKIN_LOAD_NAVIGATION) {
			drawLoadSkinLine(*curr_highlight, *curr_idx);
			drawLoadSkinLine(*curr_highlight + 1, *curr_idx + 1);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == SKIN_ELEMENT_NAVIGATION) {
			drawSkinElement(*curr_highlight, *curr_idx);
			drawSkinElement(*curr_highlight + 1, *curr_idx + 1);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == PLAYLIST_LOAD_NAVIGATION) {
			drawLoadPlaylistLine(*curr_highlight, *curr_idx);
			drawLoadPlaylistLine(*curr_highlight + 1, *curr_idx + 1);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == MOVE_FOLDER_NAVIGATION) {
			drawMoveFolder(*curr_highlight, *curr_idx);
			drawMoveFolder(*curr_highlight + 1, *curr_idx + 1);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == AUTO_DELETE_NAVIGATION) {
			drawAutoDeleteListLine(*curr_highlight, *curr_idx);
			drawAutoDeleteListLine(*curr_highlight + 1, *curr_idx + 1);
		}
		ef (navigation_type == FILE_LIST_NAVIGATION) {
			drawFile(*curr_highlight, *curr_idx);
			drawFile(*curr_highlight + 1, *curr_idx + 1);
		}
	}

	//drawScrollBar(*curr_idx, *curr_highlight, lines);

	// populate the footer box
	if (navigation_type == MENU_NAVIGATION) {
		drawOptionsFooter(*curr_idx);
		updateOptionCount();
		copyMemoryToMenu();
	}
	ef (navigation_type == PLAYLIST_NAVIGATION) {
		drawPlaylistFooter(*curr_idx);
		updatePlaylistCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == SKIN_EDITOR_NAVIGATION) {
		drawSkinEditorFooter(*curr_idx);
		updateSkinEditorCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == AUTO_DELETE_NAVIGATION) {
		drawAutoDeleteListFooter(*curr_idx);
		updateAutoDeleteListCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == FILE_LIST_NAVIGATION) {
		drawFileListFooter(*curr_idx);
		updateFileCount();
		copyMemoryToWindow();
	}
}

void shuffleDownFileList(word navigation_type, int *curr_idx, int *curr_highlight, int no_of_files, word lines)
{
	word scroll_height;

	if (no_of_files == 0)
		return;

	*curr_idx = (*curr_idx + 1 == no_of_files) ? 0 : *curr_idx + 1;

	if (*curr_highlight == lines-1 || *curr_idx == 0) {
		if (no_of_files > lines && (*curr_idx >= (no_of_files - lines)))
			*curr_highlight = lines - (no_of_files - *curr_idx);
		else
			*curr_highlight = 0;
		if (navigation_type == MENU_NAVIGATION)
			drawOptions(*curr_idx - *curr_highlight);
		ef (navigation_type == PLAYLIST_NAVIGATION)
			drawPlaylistLines(*curr_idx - *curr_highlight);
		ef (navigation_type == SKIN_EDITOR_NAVIGATION)
			drawSkinEditorLines(*curr_idx - *curr_highlight);
		ef (navigation_type == SKIN_LOAD_NAVIGATION) {
			drawLoadSkins(*curr_idx - *curr_highlight);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == SKIN_ELEMENT_NAVIGATION) {
			drawSkinElements(*curr_idx - *curr_highlight);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == PLAYLIST_LOAD_NAVIGATION) {
			drawLoadPlaylists(*curr_idx - *curr_highlight);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == MOVE_FOLDER_NAVIGATION) {
			drawMoveFolders(*curr_idx - *curr_highlight);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == AUTO_DELETE_NAVIGATION)
			drawAutoDeleteListLines(*curr_idx - *curr_highlight);
		ef (navigation_type == FILE_LIST_NAVIGATION)
			drawFiles(*curr_idx - *curr_highlight);
	}
	else {
		*curr_highlight = *curr_highlight + 1;
		if (navigation_type == MENU_NAVIGATION) {
			drawOption(*curr_highlight - 1, *curr_idx - 1);
			drawOption(*curr_highlight, *curr_idx);
		}
		ef (navigation_type == PLAYLIST_NAVIGATION){
			drawPlaylistLine(*curr_highlight - 1, *curr_idx - 1);
			drawPlaylistLine(*curr_highlight, *curr_idx);
		}
		ef (navigation_type == SKIN_EDITOR_NAVIGATION) {
			drawSkinEditorLine(*curr_highlight - 1, *curr_idx - 1);
			drawSkinEditorLine(*curr_highlight, *curr_idx);
		}
		ef (navigation_type == SKIN_LOAD_NAVIGATION) {
			drawLoadSkinLine(*curr_highlight - 1, *curr_idx - 1);
			drawLoadSkinLine(*curr_highlight, *curr_idx);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == SKIN_ELEMENT_NAVIGATION) {
			drawSkinElement(*curr_highlight - 1, *curr_idx - 1);
			drawSkinElement(*curr_highlight, *curr_idx);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == PLAYLIST_LOAD_NAVIGATION) {
			drawLoadPlaylistLine(*curr_highlight - 1, *curr_idx - 1);
			drawLoadPlaylistLine(*curr_highlight, *curr_idx);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == MOVE_FOLDER_NAVIGATION) {
			drawMoveFolder(*curr_highlight - 1, *curr_idx - 1);
			drawMoveFolder(*curr_highlight, *curr_idx);
			copyMemoryToMoveFolders();
		}
		ef (navigation_type == AUTO_DELETE_NAVIGATION) {
			drawAutoDeleteListLine(*curr_highlight - 1, *curr_idx - 1);
			drawAutoDeleteListLine(*curr_highlight, *curr_idx);
		}
		ef (navigation_type == FILE_LIST_NAVIGATION) {
			drawFile(*curr_highlight - 1, *curr_idx - 1);
			drawFile(*curr_highlight, *curr_idx);
		}
	}

	//drawScrollBar(*curr_idx, *curr_highlight, lines);

	// populate the footer box
	if (navigation_type == MENU_NAVIGATION) {
		drawOptionsFooter(*curr_idx);
		updateOptionCount();
		copyMemoryToMenu();
	}
	ef (navigation_type == PLAYLIST_NAVIGATION) {
		drawPlaylistFooter(*curr_idx);
		updatePlaylistCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == SKIN_EDITOR_NAVIGATION) {
		drawSkinEditorFooter(*curr_idx);
		updateSkinEditorCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == AUTO_DELETE_NAVIGATION) {
		drawAutoDeleteListFooter(*curr_idx);
		updateAutoDeleteListCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == FILE_LIST_NAVIGATION) {
		drawFileListFooter(*curr_idx);
		updateFileCount();
		copyMemoryToWindow();
	}
}
		
void pageBackFileList(word navigation_type, int *curr_idx, int *curr_highlight, int no_of_files, word lines)
{
	word scroll_height;

	if (no_of_files == 0)
		return;

	if (navigation_type == MENU_NAVIGATION && inSightOfNextMenuSection(*curr_idx, FALSE)) {
		computePreviousMenuSection(curr_idx);
		if (*curr_idx <= (no_of_files - 10))
			*curr_highlight = 1;
		else
			*curr_highlight = 10 - (no_of_files - *curr_idx);
	}
	else {
		*curr_idx = (*curr_idx == 0) ? (no_of_files - 1) : (*curr_idx - lines) < 0 ? 0 : (*curr_idx - lines);

		if (no_of_files > lines && *curr_idx == (no_of_files - 1))
			*curr_highlight = lines-1;
		ef (*curr_idx < lines)
			*curr_highlight = *curr_idx;
	}

	if (navigation_type == MENU_NAVIGATION)
		drawOptions(*curr_idx - *curr_highlight);
	ef (navigation_type == PLAYLIST_NAVIGATION)
		drawPlaylistLines(*curr_idx < (lines-1) ? 0 : *curr_idx - *curr_highlight);
	ef (navigation_type == SKIN_EDITOR_NAVIGATION)
		drawSkinEditorLines(*curr_idx < (lines-1) ? 0 : *curr_idx - *curr_highlight);
	ef (navigation_type == SKIN_LOAD_NAVIGATION) {
		drawLoadSkins(*curr_idx < (lines-1) ? 0 : *curr_idx - *curr_highlight);
		copyMemoryToMoveFolders();
	}
	ef (navigation_type == SKIN_ELEMENT_NAVIGATION) {
		drawSkinElements(*curr_idx < (lines-1) ? 0 : *curr_idx - *curr_highlight);
		copyMemoryToMoveFolders();
	}
	ef (navigation_type == PLAYLIST_LOAD_NAVIGATION) {
		drawLoadPlaylists(*curr_idx < (lines-1) ? 0 : *curr_idx - *curr_highlight);
		copyMemoryToMoveFolders();
	}
	ef (navigation_type == MOVE_FOLDER_NAVIGATION) {
		drawMoveFolders(*curr_idx < (lines-1) ? 0 : *curr_idx - *curr_highlight);
		copyMemoryToMoveFolders();
	}
	ef (navigation_type == AUTO_DELETE_NAVIGATION)
		drawAutoDeleteListLines(*curr_idx < (lines-1) ? 0 : *curr_idx - *curr_highlight);
	else
		drawFiles(*curr_idx < (lines-1) ? 0 : *curr_idx - *curr_highlight);

	//drawScrollBar(*curr_idx, *curr_highlight, lines);

	// populate the footer box
	if (navigation_type == MENU_NAVIGATION) {
		drawOptionsFooter(*curr_idx);
		updateOptionCount();
		copyMemoryToMenu();
	}
	ef (navigation_type == PLAYLIST_NAVIGATION) {
		drawPlaylistFooter(*curr_idx);
		updatePlaylistCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == SKIN_EDITOR_NAVIGATION) {
		drawSkinEditorFooter(*curr_idx);
		updateSkinEditorCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == AUTO_DELETE_NAVIGATION) {
		drawAutoDeleteListFooter(*curr_idx);
		updateAutoDeleteListCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == FILE_LIST_NAVIGATION) {
		drawFileListFooter(*curr_idx);
		updateFileCount();
		copyMemoryToWindow();
	}
}

void pageForwardFileList(word navigation_type, int *curr_idx, int *curr_highlight, int no_of_files, word lines)
{
	word scroll_height;

	if (no_of_files == 0)
		return;

	if (navigation_type == MENU_NAVIGATION && inSightOfNextMenuSection(*curr_idx, TRUE)) {
		computeNextMenuSection(curr_idx);
		if (*curr_idx <= (no_of_files - 10))
			*curr_highlight = 1;
		else
			*curr_highlight = 10 - (no_of_files - *curr_idx);
	}
	else {
		*curr_idx = (*curr_idx == (no_of_files - 1)) ? 0 : ((*curr_idx + lines) > (no_of_files - 1) ? (no_of_files - 1) : *curr_idx + lines);

		if (no_of_files > lines && ((*curr_idx - *curr_highlight) >= (no_of_files - lines)))
			*curr_highlight = lines - (no_of_files - *curr_idx);
		ef (*curr_idx == 0) {
			*curr_highlight = 0;
		}
		ef (*curr_idx == (no_of_files - 1))
			*curr_highlight = *curr_idx;
	}

	if (navigation_type == MENU_NAVIGATION)
		drawOptions(*curr_idx - *curr_highlight);
	ef (navigation_type == PLAYLIST_NAVIGATION)
		drawPlaylistLines(*curr_idx - *curr_highlight);
	ef (navigation_type == SKIN_EDITOR_NAVIGATION)
		drawSkinEditorLines(*curr_idx - *curr_highlight);
	ef (navigation_type == SKIN_LOAD_NAVIGATION) {
		drawLoadSkins(*curr_idx - *curr_highlight);
		copyMemoryToMoveFolders();
	}
	ef (navigation_type == SKIN_ELEMENT_NAVIGATION) {
		drawSkinElements(*curr_idx - *curr_highlight);
		copyMemoryToMoveFolders();
	}
	ef (navigation_type == PLAYLIST_LOAD_NAVIGATION) {
		drawLoadPlaylists(*curr_idx - *curr_highlight);
		copyMemoryToMoveFolders();
	}
	ef (navigation_type == MOVE_FOLDER_NAVIGATION) {
		drawMoveFolders(*curr_idx - *curr_highlight);
		copyMemoryToMoveFolders();
	}
	ef (navigation_type == AUTO_DELETE_NAVIGATION)
		drawAutoDeleteListLines(*curr_idx - *curr_highlight);
	else
		drawFiles(*curr_idx - *curr_highlight);

	//drawScrollBar(*curr_idx, *curr_highlight, lines);

	// populate the footer box
	if (navigation_type == MENU_NAVIGATION) {
		drawOptionsFooter(*curr_idx);
		updateOptionCount();
		copyMemoryToMenu();
	}
	ef (navigation_type == PLAYLIST_NAVIGATION) {
		drawPlaylistFooter(*curr_idx);
		updatePlaylistCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == SKIN_EDITOR_NAVIGATION) {
		drawSkinEditorFooter(*curr_idx);
		updateSkinEditorCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == AUTO_DELETE_NAVIGATION) {
		drawAutoDeleteListFooter(*curr_idx);
		updateAutoDeleteListCount();
		copyMemoryToWindow();
	}
	ef (navigation_type == FILE_LIST_NAVIGATION) {
		drawFileListFooter(*curr_idx);
		updateFileCount();
		copyMemoryToWindow();
	}
}

bool appendToMarkedRecordings(char *name, char *directory, dword start_cluster, word mjd, word hour, word min, dword size)
{
	if (no_of_marked_recordings == 32)
		return FALSE;

	marked_recordings[no_of_marked_recordings].file_name = dlmalloc(100);
	marked_recordings[no_of_marked_recordings].directory = dlmalloc(256);
	strcpy(marked_recordings[no_of_marked_recordings].file_name, name);
	strcpy(marked_recordings[no_of_marked_recordings].directory, directory);
    marked_recordings[no_of_marked_recordings].mjd = mjd;
	marked_recordings[no_of_marked_recordings].hour = hour;
	marked_recordings[no_of_marked_recordings].min = min;
	marked_recordings[no_of_marked_recordings].size = size;
	marked_recordings[no_of_marked_recordings].start_cluster = start_cluster;
	no_of_marked_recordings++;
	
	if (write_log) TAP_SPrint(log_buffer, "Appended marked recording, %s, %d", name, no_of_marked_recordings);
	if (write_log) logText(log_buffer, FALSE);

	return TRUE;
}

void removeFromMarkedRecordings(char *name, char *directory, dword start_cluster)
{
	int i, found_idx = -1; 
	for (i = 0; i < no_of_marked_recordings; i++) {
		if (strcmp(marked_recordings[i].file_name, name) == 0 
				&& strcmp(marked_recordings[i].directory, directory) == 0 
				&& marked_recordings[i].start_cluster == start_cluster) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete marked recording %s", marked_recordings[i].file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			found_idx = i;
			break;
		}
	}

	if (found_idx >= 0) {
		for (i = found_idx; i < no_of_marked_recordings-1; i++) {
			strcpy(marked_recordings[i].file_name, marked_recordings[i+1].file_name);
			strcpy(marked_recordings[i].directory, marked_recordings[i+1].directory);
			marked_recordings[i].mjd = marked_recordings[i+1].mjd;
			marked_recordings[i].hour = marked_recordings[i+1].hour;
			marked_recordings[i].min = marked_recordings[i+1].min;
			marked_recordings[i].size = marked_recordings[i+1].size;
			marked_recordings[i].start_cluster = marked_recordings[i+1].start_cluster;
		}

		dlfree(marked_recordings[no_of_marked_recordings-1].file_name);
		dlfree(marked_recordings[no_of_marked_recordings-1].directory);
		no_of_marked_recordings--;
	}

	dlmalloc_trim(0);
}

void clearMarkedRecordings()
{
	word i;

	for (i = 0; i < no_of_marked_recordings; i++) {
		dlfree(marked_recordings[i].file_name);
		dlfree(marked_recordings[i].directory);
	}

	dlmalloc_trim(0);
	no_of_marked_recordings = 0;
}

void popNextRecording()
{
	word i;

	if (write_log) TAP_SPrint(log_buffer, "Pop next recording, number left %d", no_of_marked_recordings);
	if (write_log) logText(log_buffer, TRUE);

	for (i = 0; i < no_of_marked_recordings-1; i++) {
		strcpy(marked_recordings[i].file_name, marked_recordings[i+1].file_name);
		strcpy(marked_recordings[i].directory, marked_recordings[i+1].directory);
		marked_recordings[i].start_cluster = marked_recordings[i+1].start_cluster;
	}
	no_of_marked_recordings--;
}

void handleThumbnailsBatchJob()
{
	TYPE_PlayInfo play_info;

	TAP_Hdd_GetPlayInfo(&play_info);

	// create the thumbnails
	if (overnight_thumbs && play_info.playMode != PLAYMODE_Playing) {
		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Started thumbnail job at %02d:%02d", hour, min);
		if (write_log) logText(log_buffer, TRUE);

		createAllRecordingThumbnails(TRUE); 

		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Finished thumbnail job at %02d:%02d", hour, min);
		if (write_log) logText(log_buffer, FALSE);
	}

	thumbnail_batch_job = FALSE;
}

#define MULTI_DECODE 0
#define MULTI_PLAY 1

void handlePlaybackWhenExistingPlayback(TYPE_PlayInfo play_info)
{
	if (play_info.playMode == PLAYMODE_Playing && play_info.file) {
		if (rec_playing) {
			memcpy(&playing_file, play_info.file, sizeof(playing_file));
			update_progress_tick = TAP_GetTick();
			append_to_progress_data = TRUE;
		}
	}
}

void stopRunawayCopy()
{
	TYPE_RecInfo rec_info_1, rec_info_2;
	bool copying_on_1, copying_on_2;

	// stop any runaway copies
	copying_on_1 = TAP_Hdd_GetRecInfo(0, &rec_info_1) && rec_info_1.recType == RECTYPE_Copy;
	copying_on_2 = TAP_Hdd_GetRecInfo(1, &rec_info_2) && rec_info_2.recType == RECTYPE_Copy;
	if (copying_on_1) {
		if (write_log) logText("Stop runaway copy", FALSE);
		TAP_Hdd_StopRecord(0);
	}
	if (copying_on_2) {
		if (write_log) logText("Stop runaway copy", FALSE);
		TAP_Hdd_StopRecord(1);
	}
}

bool findCopyName()
{
	TYPE_File file;
	word i, length;
	bool copy_1_exists = FALSE, copy_2_exists = FALSE, copy_3_exists = FALSE, copy_4_exists = FALSE;

	// save the video name (minus extension)
	memset(file_name, '\0', 100);
	strncat(file_name, marked_recordings[0].file_name, strlen(marked_recordings[0].file_name)-4);

	// find the copy name (latest {orig-name}(COPY)-x.rec file) (assumes max of 4 copies)
	strcpy(buffer, "");
	TAP_SPrint(buffer2, "%s(COPY)-1", file_name);
	TAP_SPrint(buffer3, "%s(COPY)-2", file_name);
	TAP_SPrint(buffer4, "%s(COPY)-3", file_name);
	TAP_SPrint(buffer5, "%s(COPY)-4", file_name);
	length = strlen(buffer2);

	// loop through the \DataFiles files to find the latest copy
	ChangeDirDataFiles();
	i = TAP_Hdd_FindFirst(&file);
	while (i--) {
		if (isRec(file.name) && strlen(file.name) >= length) {
			if (!(copy_2_exists || copy_3_exists || copy_4_exists) && strncmp(buffer2, file.name, length) == 0) {
				if (write_log) logText("Found copy 1", FALSE);
				strcpy(buffer, file.name);
				copy_1_exists = TRUE;
			}
			ef (!(copy_3_exists || copy_4_exists) && strncmp(buffer3, file.name, length) == 0) {
				if (write_log) logText("Found copy 2", FALSE);
				strcpy(buffer, file.name);
				copy_2_exists = TRUE;
			}
			ef (!copy_4_exists && strncmp(buffer4, file.name, length) == 0) {
				if (write_log) logText("Found copy 3", FALSE);
				strcpy(buffer, file.name);
				copy_3_exists = TRUE;
			}
			ef (strncmp(buffer5, file.name, length) == 0) {
				if (write_log) logText("Found copy 4", FALSE);
				strcpy(buffer, file.name);
				copy_4_exists = TRUE;
			}
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	return (copy_1_exists || copy_2_exists || copy_3_exists || copy_4_exists);
}

void postPlayProcessing()
{
	// move current vid to bin and rename copy if we are decoding
	if (overnight_play && copy_successful && multi_play_batch_mode == MULTI_DECODE) {
		bool copy_exists = FALSE;

		// stop any runaway copies
		stopRunawayCopy();

		// do the slightly complex process to find the copy name (may have had a date appended)
		copy_exists = findCopyName();

		if (copy_exists) {
			// first recycle the original file
			if (write_log) TAP_SPrint(log_buffer, "Recycle %s, %s", marked_recordings[0].file_name, marked_recordings[0].directory);
			if (write_log) logText(log_buffer, TRUE);
			ChangeDirPath(marked_recordings[0].directory);
			doRecycle(marked_recordings[0].file_name, marked_recordings[0].start_cluster, marked_recordings[0].directory, 
					  playing_file.mjd, playing_file.hour, playing_file.min, playing_file.size, FALSE, FALSE);

			// now we have the correct copy name, rename to the original video name
			//if (write_log) TAP_SPrint(log_buffer, "Rename %s to %s\r\n", buffer, marked_recordings[0].file_name);
			//if (write_log) logText(log_buffer, FALSE);
			//doRename(buffer, marked_recordings[0].file_name, FALSE, FALSE);
					
			// move the copy to the original directory
			if (strcmp(marked_recordings[0].directory, "/DataFiles") != 0) {
				if (write_log) TAP_SPrint(log_buffer, "move(%s, %s, %s)", "/DataFiles", marked_recordings[0].directory, buffer);
				if (write_log) logText(log_buffer, TRUE);
				move("/DataFiles", marked_recordings[0].directory, buffer);
				if (write_log) logText("Move successful", FALSE);
			}
		}
	}
}

void finishMultiPlay(bool abort)
{
	if (write_log) logText("Play multi finished", FALSE);
	clearMarkedRecordings();
	if (overnight_play) {
		freeSavedRecordings();
		if (!abort) {
			copy_tick = TAP_GetTick();	
			thumbnail_batch_job = TRUE;
		}
		else
			manual_batch_job = FALSE;
		overnight_play = FALSE;
	}
	multi_play_started = FALSE;
	ChangeDirPath(curr_dir);
}

void playNextRecording()
{
	TYPE_RecInfo rec_info_1, rec_info_2;
	TYPE_PlayInfo play_info;
	bool recording_on_1 = TAP_Hdd_GetRecInfo(0, &rec_info_1), recording_on_2 = TAP_Hdd_GetRecInfo(1, &rec_info_2);

	if (write_log) logText("Play next recording", FALSE);
	
	if (recording_on_1) {
		if (write_log) TAP_SPrint(log_buffer, "Recording %s, %d on 1", rec_info_1.fileName, rec_info_1.recType);
		if (write_log) logText(log_buffer, FALSE);
	}
	if (recording_on_2) {
		if (write_log) TAP_SPrint(log_buffer, "Recording %s, %d on 2", rec_info_2.fileName, rec_info_2.recType);
		if (write_log) logText(log_buffer, FALSE);
	}

	// if we were decoding, but another recording has started, or the channel has changed, then abort process
	if (multi_play_batch_mode == MULTI_DECODE) {
		if ((TAP_Hdd_GetRecInfo(0, &rec_info_1) && rec_info_1.recType == RECTYPE_Normal)
				|| (TAP_Hdd_GetRecInfo(1, &rec_info_2) && rec_info_2.recType == RECTYPE_Normal)) {
			if (write_log) logText("Abandon decode job due to recording", FALSE);
			stopRunawayCopy();
			finishMultiPlay(TRUE);
			return;
		}

		TAP_Channel_GetCurrent(&tv_radio, &channel_number);
		if (channel_number != current_channel_number) {
			if (write_log) logText("Abandon decode job due to channel change", FALSE);
			stopRunawayCopy();
			finishMultiPlay(TRUE);
			return;
		}
	}

	postPlayProcessing();
	popNextRecording();

	if (no_of_marked_recordings == 0) {
		finishMultiPlay(FALSE);
		return;
	}

	ChangeDirPath(marked_recordings[0].directory);	
	while (no_of_marked_recordings > 0 && !TAP_Hdd_Exist(marked_recordings[0].file_name)) {
		popNextRecording();
		if (no_of_marked_recordings > 0)
			ChangeDirPath(marked_recordings[0].directory);	
	}

	if (no_of_marked_recordings > 0) {
		if (write_log) TAP_SPrint(log_buffer, "Play multi %s, %s at %d", marked_recordings[0].directory, marked_recordings[0].file_name, TAP_GetTick());
		if (write_log) logText(log_buffer, FALSE);

		if (multi_play_batch_mode == MULTI_DECODE) {
			if (decode_channel)
				TAP_Channel_Start(1, SVC_TYPE_Tv, decode_channel == 30000 ? getRecHeaderDetail(marked_recordings[0].file_name) : decode_channel - 1);
			TAP_Channel_GetCurrent(&tv_radio, &current_channel_number);
		}

		TAP_Hdd_PlayTs(marked_recordings[0].file_name);
		TAP_Delay(50);
		TAP_Hdd_ChangePlaybackPos(0);

		// if there was already a playback in progress, then update the details with the new playback
		TAP_Hdd_GetPlayInfo(&play_info);
		if (play_info.playMode == PLAYMODE_Playing && play_info.file) {
			handlePlaybackWhenExistingPlayback(play_info);

			// kick off the fast copy if a decode batch job
			if (multi_play_batch_mode == MULTI_DECODE) {
				if (write_log) TAP_SPrint(log_buffer, "Decode %s", marked_recordings[0].file_name);
				if (write_log) logText(log_buffer, FALSE);

				copy_recording = TRUE;
				copy_successful = FALSE;
				copy_step = 0;
				copy_delay = 400;
				copy_tick = TAP_GetTick();
			}
		}

		ChangeDirPath(curr_dir);
	}
	else {
		finishMultiPlay(FALSE);
	}
}

bool isMarkedRecording(char *name, dword start_cluster)
{
	word i;

	for (i = 0; i < no_of_marked_recordings; i++)
	{
		if (strcmp(marked_recordings[i].file_name, name) == 0 && marked_recordings[i].start_cluster == start_cluster)
			return TRUE;
	}

	return FALSE;
}

bool isSavedRecording(char *name, dword start_cluster)
{
	word i;

	for (i = 0; i < no_of_saved_recordings; i++) {
		if (strcmp(saved_recordings[i]->file_name, name) == 0 && saved_recordings[i]->start_cluster == start_cluster)
			return TRUE;
	}

	return FALSE;
}

bool selectionContainsEncodedVideos()
{
	word i;

	for (i = 0; i < no_of_files; i++) {
		if (isMarkedRecording(dir_info[i]->file_name, dir_info[i]->start_cluster))
			if (dir_info[i]->encryption != 0 && dir_info[i]->encryption != 0x02)
				return TRUE;
	}

	return FALSE;
}

void showJobDuration()
{
	word i, mins = 0;

	for (i = 0; i < no_of_files; i++) {
		if (isMarkedRecording(dir_info[i]->file_name, dir_info[i]->start_cluster))
			mins += dir_info[i]->duration;
	}

	if (multi_play_batch_mode == MULTI_DECODE) {
		switch (decode_speed) {
			case DECODE_REAL_TIME:	break;
			case DECODE_TWO_TIMES:	mins /= 2; break;
			case DECODE_FOUR_TIMES:	mins /= 4; break;
			case DECODE_SIX_TIMES:	mins /= 6; break;
		}
	}

	TAP_SPrint(buffer, "%s %d%s %d%s", job_will_take_approx_t, mins / 60, h_t, mins % 60, m_t);
	drawInfoBox(video_job_t, buffer, NULL, FALSE, TRUE);
	TAP_Delay(200);
	//TAP_Osd_RestoreBox(region_mem, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
	//TAP_Osd_RestoreBox(region, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
	TAP_MemFree(info_save);
	info_save = NULL;
}

void setReturnIndex(char *name)
{
	word i;

	for (i = 0; i < no_of_files; i++) {
		if (strcmp(name, dir_info[i]->file_name) == 0) {
			saveNavHistory(i, -1, TRUE);
			break;
		}
	}
}

bool skinInList(char *name, bool in_skins_folder)
{
	word i;

    for (i = 0; i < skin_count; i++) {
		if (strcmp(skins[i].skin_name, name) == 0 && skins[i].in_skins_folder == in_skins_folder) 
			return TRUE;
    }

	return FALSE;
}

void loadSkins()
{
	TYPE_File file;
	word i;

	for (i = 0; i < skin_count; i++) {
		dlfree(skins[i].skin_name);
		skins[i].skin_name = NULL;
	}

	skin_count = 0;

	ChangeDirSkins();
	i = TAP_Hdd_FindFirst(&file);
    while(i-- && skin_count < 128) {
        if (isSkin(file.name)) {
			memset (&skins[skin_count], 0, sizeof(skins[skin_count]));
			skins[skin_count].skin_name = dlmalloc(100 * sizeof(char));
			strcpy(skins[skin_count].skin_name, file.name);
			skins[skin_count].in_skins_folder = TRUE;
			skin_count++;
        }

        if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
            break;
    }

	ChangeDirProgramFiles();
	i = TAP_Hdd_FindFirst(&file);
    while(i-- && skin_count < 128) {
        if (isSkin(file.name) /*&& !skinInList(file.name, FALSE)*/) {
			memset (&skins[skin_count], 0, sizeof(skins[skin_count]));
			skins[skin_count].skin_name = dlmalloc(100 * sizeof(char));
			strcpy(skins[skin_count].skin_name, file.name);
			skins[skin_count].in_skins_folder = FALSE;
			skin_count++;
        }

        if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
            break;
    }

	qsort(skins, skin_count, sizeof(skins[0]), compareSkins);

	// find the idx of the current skin (try Skins folder first)
	current_skin = -1;
	for (i = 0; i < skin_count; i++) {
		if (strcmp(skins[i].skin_name, skin_file_name) == 0 && skins[i].in_skins_folder) {
            current_skin = i;
			ChangeDirSkins();
		}
	}

	// if not there, then try PF folder
	if (current_skin == -1) {
		for (i = 0; i < skin_count; i++) {
			if (strcmp(skins[i].skin_name, skin_file_name) == 0 && !skins[i].in_skins_folder) {
	            current_skin = i;
				ChangeDirProgramFiles();
			}
		}
	}
}

void setLut(char *name)
{
	word i;

	GifColorType *ColorMap;
	GifFileType *gif_file = DGifOpen(name);
	ColorMap = (gif_file -> IColorMap ? gif_file -> IColorMap : gif_file -> SColorMap);
	for (i = 0; i < 256; i++) {
		lut[i][0] = ColorMap[i].Red;
		lut[i][1] = ColorMap[i].Green;
		lut[i][2] = ColorMap[i].Blue;
		lut[i][3] = 0;
	}
	DGifCloseFile(gif_file);
	TAP_Osd_SetLut(0, lut);
}

dword getNextFolderIndex(char **subfolders, int subfolder_count)
{
	int this_folder = -1, i;

	// first, strip off any preceding 'The' from the current folder
	strcpy(buffer, folder_history[0]); strlwr(buffer);
	strcpy(buffer3, "/MP3/");
	strcat(buffer3, (strlen(buffer) > 9 && strncmp(buffer+5, "the ", 4) == 0) ? folder_history[0]+9 : folder_history[0]+5);

	for (i = 0; i < subfolder_count; i++) {

		// strip off any preceding 'The' from the artist folder
		strcpy(buffer, subfolders[i]); strlwr(buffer);
		strcpy(buffer2, "/MP3/"); 
		strcat(buffer2, (strlen(buffer) > 4 && strncmp(buffer, "the ", 4) == 0) ? subfolders[i]+4 : subfolders[i]);

		// stop when we overshoot the current folder
		if (strcmp(buffer2, buffer3) > 0) {
			this_folder = i - 1;
			break;
		}
	}

	return (this_folder == -1) ? 0 : (this_folder + 1) % subfolder_count;
}

/* change to a new mp3 artist folder */
bool ChangeDirFolder() 
{
	TYPE_File file;
	int i, subfolder_count = 0, original_level, current_level;
	char artist_dir[100];
	dword next_folder;
	char **subfolders = dlmalloc(sizeof(*subfolders) * 2048);

	// get the current mp3 folder level (may be 0 if a playlist is playing)
	if (folder_history[0] == NULL) {
		original_level = 0;
		current_level = 0;
	}
	else {
		original_level = getDirectoryLevel(getFirstFolderInHistory());
		current_level = getDirectoryLevel(folder_history[0]);
	}
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Current level is %d, original is %d", current_level, original_level);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	// extract the artist from the currently playing folder (put random rubbish in if playlist is playing)
	if (current_level == 0)
		strcpy(artist_dir, "xYzYx");
	//ef (current_level == 1)
	//	strcpy(artist_dir, mp3_folder);
	else
		ExtractBaseMp3Directory(folder_history[0], artist_dir);
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Artist folder is %s", artist_dir);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	ChangeDirMp3();

	i = TAP_Hdd_FindFirst(&file);
	while (i-- && subfolder_count < 2048) {
		
		if (file.attr == ATTR_FOLDER && strcmp(file.name, artist_dir) != 0 && strcmp(file.name, "Cache") != 0)
		{
			subfolders[subfolder_count] = dlmalloc(100 * sizeof(char));
			strcpy(subfolders[subfolder_count], file.name);
			subfolder_count++;
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	qsort(subfolders, subfolder_count, sizeof(subfolders[0]), compareArtists);

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Found %d other artists", subfolder_count);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	if (subfolder_count == 0) {
		// no other artist folders, so nothing we can do
		dlfree(subfolders);
		subfolders = NULL;
		return FALSE;
	}
	//ef (original_level == 1 || (original_level == 2 && mp3s_in_current_folder)) {
	ef (original_level == 2) {
		// since we were previously at the artist level, change to another artist level
		next_folder = randomise_mp3s ? (getRandom() % subfolder_count) : getNextFolderIndex(subfolders, subfolder_count);
		ChangeDir(subfolders[next_folder]);
		strcpy(mp3_folder, subfolders[next_folder]);
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Changed to new artist folder %s", subfolders[next_folder]);
		if (write_log) if (verbose) logText(log_buffer, FALSE);
	}
	else {
		// we were previously at least at the album level, so find a random album of the random artist
		next_folder = randomise_mp3s ? (getRandom() % subfolder_count) : getNextFolderIndex(subfolders, subfolder_count);
		ChangeDir(subfolders[next_folder]);
		strcpy(mp3_folder, subfolders[next_folder]);
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Changed to new artist folder %s", subfolders[next_folder]);
		if (write_log) if (verbose) logText(log_buffer, FALSE);

		// free existing subfolder memory
		for (i = 0; i < subfolder_count; i++)
		{
			dlfree(subfolders[i]);
			subfolders[i] = NULL;
		}
		dlmalloc_trim(0);

		// check all the albums for this artist
		subfolder_count = 0;
		i = TAP_Hdd_FindFirst(&file);
		while (i-- && subfolder_count < 512) {
			
			if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0)
			{
				subfolders[subfolder_count] = dlmalloc(100 * sizeof(char));
				strcpy(subfolders[subfolder_count], file.name);
				subfolder_count++;
			}

			if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
				break;
		}

		qsort(subfolders, subfolder_count, sizeof(subfolders[0]), compareStrings);

		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Found %d albums", subfolder_count);
		if (write_log) if (verbose) logText(log_buffer, FALSE);

		// if no albums, then may be a compilation, so stop, otherwise choose a random album
		if (subfolder_count > 0) {
			next_folder = getRandom() % subfolder_count;
			ChangeDir(subfolders[next_folder]);
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Changed to new album folder %s", subfolders[next_folder]);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
		}
	}

	for (i = 0; i < subfolder_count; i++)
	{
		dlfree(subfolders[i]);
		subfolders[i] = NULL;
	}
	dlfree(subfolders);
	subfolders = NULL;

	dlmalloc_trim(0);

	if (write_log) if (verbose) logText("Change folder successful", FALSE);

	return TRUE;
}

void loadPlaylistFiles(bool photo)
{
	TYPE_File file;
	int i;

	// load the playlist files into memory
	for (i = 0; i < 128; i++)
	{
		if (photo) {
			if (photo_playlists[i] != NULL)
				dlfree(photo_playlists[i]);
		}
		else {
			if (mp3_playlists[i] != NULL)
				dlfree(mp3_playlists[i]);
		}
	}
	dlmalloc_trim(0);

	if (photo) no_of_photo_playlists = 0;
	else no_of_mp3_playlists = 0;

	ChangeDirPlaylists();
	i = TAP_Hdd_FindFirst(&file);
    while(i--) {
		if (photo) {
			if (isPhotoPlaylist(file.name) && no_of_photo_playlists < 128) {
				memset (&photo_playlists[no_of_photo_playlists], 0, sizeof(photo_playlists[no_of_photo_playlists]));
				photo_playlists[no_of_photo_playlists] = dlmalloc(100 * sizeof(char));
				strcpy(photo_playlists[no_of_photo_playlists], file.name);
				no_of_photo_playlists++;
			}
		}
		else {
			if (isMp3Playlist(file.name) && no_of_mp3_playlists < 128) {
				memset(&mp3_playlists[no_of_mp3_playlists], 0, sizeof(mp3_playlists[no_of_mp3_playlists]));
				mp3_playlists[no_of_mp3_playlists] = dlmalloc(100 * sizeof(char));
				strcpy(mp3_playlists[no_of_mp3_playlists], file.name);
				no_of_mp3_playlists++;
			}
		}

        if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
            break;
    }

	qsort(photo_playlists, no_of_photo_playlists, sizeof(photo_playlists[0]), compareStrings);
	qsort(mp3_playlists, no_of_mp3_playlists, sizeof(mp3_playlists[0]), compareStrings);

	ChangeDirPath(curr_dir);
}

// Filters video memory
void videoMemoryInterlaceFlickerFilter(word i, word j, word w, word h) 
{
#ifndef WIN32
    dword x=0, y=0;
	dword p1, p2;
	int r, g, b;

	/*if (filter_flickering) {
		for (x = i; x < (i+w); x++) {
			for (y = j; y < (j+h-1); y++) {
				p1 = *(_vAddr[y] + x);
				p2 = *(_vAddr[y+1] + x);
				r = (((p1 >> 10) & 31) + ((p2 >> 10) & 31)) >> 1;
				g = (((p1 >> 5) & 31) + ((p2 >> 5) & 31)) >> 1;
				b = ((p1 & 31) + (p2 & 31)) >> 1;
				*(_vAddr[y] + x) = RGB8888(r<<3,g<<3,b<<3);
			}
		}
	}*/
#endif
}

void copyMemoryToKeyboard()
{
	word x, y, w, h;

	x = X; y = Y; w = W; h = H;

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30-122+5, x-5, y+30, FALSE);
	TAP_Osd_Copy(region_mem, region, x, y+h-122+5, w+1, 122+1, x, y+h-122+5, FALSE);

	videoMemoryInterlaceFlickerFilter(x, y, w, h);
}

void copyMemoryToStopMenu()
{
	word x, y, w, h;

	x = X+200; y = Y+100; w = W-400; h = 30+(29*no_of_stop_options)+3+40;
	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30-40, x-5, y+30, FALSE);
	TAP_Osd_Copy(region_mem, region, x, y+h-40, w+1, 40+4, x, y+h-40, FALSE);

	videoMemoryInterlaceFlickerFilter(x, y, w, h);
}

void copyMemoryToOptions()
{
	word x, y, w, h;

	x = X+150; y = Y+40+((10-no_of_options)/2)*29; w = W-300; h = 30+(29*no_of_options)+3+40;
	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30-40, x-5, y+30, FALSE);
	TAP_Osd_Copy(region_mem, region, x, y+h-40, w+1, 40+4, x, y+h-40, FALSE);

	videoMemoryInterlaceFlickerFilter(x, y, w, h);
}

void copyMemoryToMoveFolders()
{
	word x, y, w, h;

	x = X+150; y = Y+50; w = W-300; h = 30+(29*8)+3+70;
	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30-70, x-5, y+30, FALSE);
	TAP_Osd_Copy(region_mem, region, x, y+h-70, w+1, 70+4, x, y+h-70, FALSE);

	videoMemoryInterlaceFlickerFilter(x, y, w, h);
}

void copyMemoryToRecInfoViewer()
{
	word x, y, w, h;

	x = X+40; y = Y; w = W-80; h = 442;
	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);

	videoMemoryInterlaceFlickerFilter(x, y, w, h);
}

void copyMemoryToMenu()
{
	word x, y, w, h;

	x = X; y = Y; w = W; h = H;
	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30-122+1, x-5, y+30, FALSE);
	TAP_Osd_Copy(region_mem, region, x, y+h-122+1, w+1, 122+5, x, y+h-122+1, FALSE);

	videoMemoryInterlaceFlickerFilter(x, y, w, h);
}

void copyMemoryToWindow()
{
	word x, y, w, h;

	if ((thumbnail_mode && !playlist_displayed && !auto_deletes_displayed && !recycle_bin_displayed) || scenes_displayed) {
		x = thumbnail_offset_x; y = thumbnail_offset_y; w = 640; h = 526;
	}
	else {
		x = X; y = Y; w = W; h = H;
	}

	if ((thumbnail_mode && !playlist_displayed && !auto_deletes_displayed && !recycle_bin_displayed) || scenes_displayed)
		TAP_Osd_Copy(region_mem, region, x, y, w, h, x, y, FALSE);
	else {
		TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
		TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30-122+1, x-5, y+30, FALSE);
		TAP_Osd_Copy(region_mem, region, x, y+h-122+1, w+1, 122+5, x, y+h-122+1, FALSE);
	}

	if (!thumbnail_mode) videoMemoryInterlaceFlickerFilter(x, y, w, h);
}

void drawRoundedRectangle(word region, word x, word y, word w, word h, word border, word no_of_lines, word header, word footer, word border_colour, word flood_colour, word fill_colour, bool fill)
{
	word colour;

	if (masterpiece_mode == 1) {
		drawMasterpieceBackground(region, x, y, w, h, border, no_of_lines, header, footer, border_colour, fill ? fill_colour : COLOR_None);
		return;
	}

#ifndef WIN32

	gxCircleQuadrant(region, x+5, y+5, 10+border, border_colour, 1, TRUE);
	gxCircleQuadrant(region, x+w-5, y+5, 10+border, border_colour, 2, TRUE);
	gxCircleQuadrant(region, x+5, y+h-5, 10+border, border_colour, 3, TRUE);
	gxCircleQuadrant(region, x+w-5, y+h-5, 10+border, border_colour, 4, TRUE);
	drawArea(region, x+5, y-5-border, w-10, border, border_colour);
	drawArea(region, x-5-border, y+5, border, h-10, border_colour);
	drawArea(region, x+w+5+1, y+5, border, h-10, border_colour);
	drawArea(region, x+5, y+h+5+1, w-10, border, border_colour);

	// fill the corners
	colour = header > 0 ? header_bg_colour : fill_colour;
	gxCircleQuadrant(region, x+5, y+5, 10, colour, 1, TRUE);
	gxCircleQuadrant(region, x+w-5, y+5, 10, colour, 2, TRUE);
	if (header > 0) {
		drawArea(region, x+5, y-5, w-10, 5, header_bg_colour);
		drawArea(region, x-5, y+5, 5, header-5, header_bg_colour);
		drawArea(region, x+w, y+5, 5+1, header-5, header_bg_colour);
	}
	else {
		drawArea(region, x+5, y-5, w-10, 5, fill_colour);
	}

	colour = footer > 0 ? footer_bg_colour : fill_colour;
	gxCircleQuadrant(region, x+5, y+h-5, 10, colour, 3, TRUE);
	gxCircleQuadrant(region, x+w-5, y+h-5, 10, colour, 4, TRUE);
	if (footer > 0) {
		drawArea(region, x+5, y+h, w-10, 5+1, footer_bg_colour);
		drawArea(region, x-5, y+h-footer, 5, footer-5, footer_bg_colour);
		drawArea(region, x+w, y+h-footer, 5+1, footer-5, footer_bg_colour);
	}
	else {
		drawArea(region, x+5, y+h, w-10, 5+1, fill_colour);
	}

	if (fill) {
		drawArea(region, x+5, y-5, w-10, 10, fill_colour);
		drawArea(region, x+5, y+h-5, w-10, 10, fill_colour);
		drawArea(region, x-5, y+5, w+10+1, h-10, fill_colour);
	}
#endif
}

bool fixRecording() 
{
	if (write_log) TAP_SPrint(log_buffer, "Fix recording %s", dir_info[curr_idx]->file_name);
	if (write_log) logText(log_buffer, FALSE);

	// only works in DataFiles folder and a source recording must be marked
	if (!IsDataFilesFolder(curr_dir) || no_of_marked_recordings != 1)
		return FALSE;

	ChangeDirProgramFiles();
	if (!TAP_Hdd_Exist("recFixer.tap"))
		ChangeDir("Auto Start");
	if (!TAP_Hdd_Exist("recFixer.tap"))
		return FALSE;

	// save the original names
	strcpy(buffer, marked_recordings[0].file_name);
	strcpy(buffer2, dir_info[curr_idx]->file_name);
	
	// renames to source and fix
	ChangeDirDataFiles();
	TAP_Hdd_Rename(buffer, "source.rec");
	TAP_Hdd_Rename(buffer2, "fix.rec");

	// run the tap
	ChangeDirProgramFiles();
	if (!TAP_Hdd_Exist("recFixer.tap"))
		ChangeDir("Auto Start");

#ifndef WIN32
	if (write_log) TAP_SPrint(log_buffer, "Fix %s using %s", buffer2, buffer);
	if (write_log) logText(log_buffer, FALSE);
	//if (firmware_hacks_enabled)
		//exTAP_TAP_Load("recFixer.tap"); 
		//TAP_Start("recFixer.tap");
		HDD_TAP_Start("recFixer.tap", FALSE, NULL, NULL);
#endif

	// rename to original names
	ChangeDirDataFiles();
	TAP_Hdd_Rename("source.rec", buffer);
	TAP_Hdd_Rename("fix.rec", buffer2);

	// reload the header
	if (preload_video_headers) {
		deleteRecHeader(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster);
		LoadHeaderInfo(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, curr_dir, -1, FALSE);
	}

	clearMarkedRecordings();
	return TRUE;
}

bool isValidRec(int idx)
{
	return isRec(dir_info[idx]->file_name) && dir_info[idx]->attr == ATTR_TS;
}

void trimID3TagSpaces(char *tag)
{
	int start, end, length = strlen(tag);
	strcpy(temp, tag);

	for (start = 0; start < length; start++) {
		if (temp[start] != '\0' && tag[start] != ' ')
			break;
	}
	
	if (start == length) {
		strcpy(tag, "");
		return;
	}

	for (end = length; end >= 0; end--) {
		if (tag[end] != '\0' && tag[end] != ' ')
			break;
	}

	memcpy(tag, temp+start, length-start-(length-end)+1);
	tag[length-start-(length-end)+1] = '\0';
}

// check to see if any playlist entries are playing, setting the appropriate idx if so
int setPlaylistIndex()
{
	word i;

	for (i = 0; i < no_of_playlist_mp3s; i++) {
		if (strcmp(mp3_playlist[i]->file_name, mp3_files[current_mp3]->file_name) == 0
				&& strcmp(mp3_playlist[i]->directory, mp3_files[current_mp3]->directory) == 0) {
			saved_playlist_idx = current_mp3;
			saved_playlist_highlight = -1;
			return saved_playlist_idx;
		}
	}

	return -1;
}

void copyID3ToID3(bool playing_to_id3, bool copy_art)
{
	ID3 *id3_info_to, *id3_info_from; size_t length = 0; 

	if (playing_to_id3) {
		if (id3_info)
			destroy_ID3(id3_info);
		id3_info = create_ID3(NULL);
		id3_info_to = id3_info; id3_info_from = playing_id3_info;
	}
	else {
		if (playing_id3_info)
			destroy_ID3(playing_id3_info);
		playing_id3_info = create_ID3(NULL);
		id3_info_to = playing_id3_info; id3_info_from = id3_info;
	}

	id3_info_to->buffer = dlmalloc(512); id3_info_to->ptr = id3_info_to->buffer;
	if (id3_info_from->title && strlen(id3_info_from->title) > 0) {	
		length = strlen(id3_info_from->title) + 1;
		memcpy(id3_info_to->ptr, id3_info_from->title, length);
		id3_info_to->title = id3_info_to->ptr;
		id3_info_to->ptr += length;
	}
	if (id3_info_from->artist && strlen(id3_info_from->artist) > 0) {
		length = strlen(id3_info_from->artist) + 1;
		memcpy(id3_info_to->ptr, id3_info_from->artist, length);
		id3_info_to->artist = id3_info_to->ptr;
		id3_info_to->ptr += length;
	}
	if (id3_info_from->album && strlen(id3_info_from->album) > 0) {	
		length = strlen(id3_info_from->album) + 1;
		memcpy(id3_info_to->ptr, id3_info_from->album, length);
		id3_info_to->album = id3_info_to->ptr;
		id3_info_to->ptr += length;
	}
	if (id3_info_from->year && strlen(id3_info_from->year) > 0) {
		length = strlen(id3_info_from->year) + 1;
		memcpy(id3_info_to->ptr, id3_info_from->year, length);
		id3_info_to->year = id3_info_to->ptr;
		id3_info_to->ptr += length;
	}
	if (id3_info_from->genre_code && strlen(id3_info_from->genre_code) > 0) {	
		length = strlen(id3_info_from->genre_code) + 1;
		memcpy(id3_info_to->ptr, id3_info_from->genre_code, length);
		strcpy(id3_info_to->genre, id3_info_from->genre);
		id3_info_to->genre_code = id3_info_to->ptr;
	}
	if (copy_art && id3_info_from->picture && id3_info_from->picture_size > 0){
		id3_info_to->picture = dlmalloc(id3_info->picture_size);
		memcpy(id3_info_to->picture, id3_info_from->picture, id3_info_from->picture_size);
	}

	id3_info_to->bitrate = id3_info_from->bitrate;
	id3_info_to->samplerate = id3_info_from->samplerate;
}

void copyMp3HeaderToID3(struct media_files *mp3_header)
{
	size_t length = 0; 

	if (id3_info)
		destroy_ID3(id3_info);
	id3_info = create_ID3(NULL);

	id3_info->buffer = dlmalloc(512); id3_info->ptr = id3_info->buffer;
	if (mp3_header->track_name && strlen(mp3_header->track_name) > 0) {	
		length = strlen(mp3_header->track_name) + 1;
		memcpy(id3_info->ptr, mp3_header->track_name, length);
		id3_info->title = id3_info->ptr;
		id3_info->ptr += length;
	}
	if (mp3_header->artist_name && strlen(mp3_header->artist_name) > 0) {
		length = strlen(mp3_header->artist_name) + 1;
		memcpy(id3_info->ptr, mp3_header->artist_name, length);
		id3_info->artist = id3_info->ptr;
		id3_info->ptr += length;
	}
	if (mp3_header->album_name && strlen(mp3_header->album_name) > 0) {	
		length = strlen(mp3_header->album_name) + 1;
		memcpy(id3_info->ptr, mp3_header->album_name, length);
		id3_info->album = id3_info->ptr;
		id3_info->ptr += length;
	}
	if (mp3_header->year_string && strlen(mp3_header->year_string) > 0) {
		length = strlen(mp3_header->year_string) + 1;
		memcpy(id3_info->ptr, mp3_header->year_string, length);
		id3_info->year = id3_info->ptr;
		id3_info->ptr += length;
	}
	if (mp3_header->genre_string && strlen(mp3_header->genre_string) > 0) {	
		length = strlen(mp3_header->genre_string) + 1;
		memcpy(id3_info->ptr, mp3_header->genre_string, length);
		memcpy(id3_info->genre, mp3_header->genre_string, length);
		id3_info->genre_code = id3_info->ptr;
	}
}

bool readID3Tag(char *file_name, bool playing, bool read_art)
{
	bool success = FALSE;

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Read ID3 tag for %s", file_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	id3_info = create_ID3(id3_info);
	success = parse_file_ID3(id3_info, file_name, read_art);

	if (id3_info->title)		trimID3TagSpaces(id3_info->title);
	if (id3_info->artist)		trimID3TagSpaces(id3_info->artist);
	if (id3_info->album)		trimID3TagSpaces(id3_info->album);
	if (id3_info->year)			trimID3TagSpaces(id3_info->year);
	if (id3_info->genre_code)	trimID3TagSpaces(id3_info->genre);

	if (playing)
		copyID3ToID3(FALSE, read_art);

	return success;
}

void refreshCompactModeHelp(bool mp3) 
{
	word string_length, indent;
	word x = 190, y = 430, w = 340, h = 80;

	if (!mp3) return;

	if (compact_offset_x != 190 || compact_offset_y != 190 || compact_art_mode || compact_tv_mode) return;

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 0, 0, bare_bones_border_colour, COLOR_None, COLOR_Black, TRUE);

	if (mp3) {
		TAP_SPrint(buffer, "< %s   |> %s   > %s", prev_tune_t, restart_tune_t, next_tune_t);
		string_length = getWidth(buffer, FNT_Size_1419);
		indent = x + ((w - string_length) / 2);
		
		drawText(region, indent, y+10, -1, "< ", bare_bones_title_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth("< ", FNT_Size_1419);
		TAP_SPrint(buffer, "%s   ", prev_tune_t);
		drawText(region, indent, y+10, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth(buffer, FNT_Size_1419);
		drawText(region, indent, y+10, -1, "|> ", bare_bones_title_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth("|> ", FNT_Size_1419);
		TAP_SPrint(buffer, "%s  ", restart_tune_t);
		drawText(region, indent, y+10, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth(buffer, FNT_Size_1419);
		drawText(region, indent, y+10, -1, "> ", bare_bones_title_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth("> ", FNT_Size_1419);
		TAP_SPrint(buffer, "%s   ", next_tune_t);
		drawText(region, indent, y+10, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth(buffer, FNT_Size_1419);

		TAP_SPrint(buffer, "%s %s   << %s   >> %s", stop_t, stop_tune_t, prev_folder_t, next_folder_t);
		string_length = getWidth(buffer, FNT_Size_1419);
		indent = x + ((w - string_length) / 2);

		TAP_SPrint(buffer, "%s ", stop_t);
		drawText(region, indent, y+30, -1, buffer, bare_bones_title_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth(buffer, FNT_Size_1419);
		TAP_SPrint(buffer, "%s   ", stop_tune_t);
		drawText(region, indent, y+30, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth(buffer, FNT_Size_1419);
		drawText(region, indent, y+30, -1, "<< ", bare_bones_title_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth("<< ", FNT_Size_1419);
		TAP_SPrint(buffer, "%s   ", prev_folder_t);
		drawText(region, indent, y+30, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth(buffer, FNT_Size_1419);
		drawText(region, indent, y+30, -1, ">> ", bare_bones_title_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth(">> ", FNT_Size_1419);
		TAP_SPrint(buffer, "%s   ", next_folder_t);
		drawText(region, indent, y+30, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);
		indent += getWidth(buffer, FNT_Size_1419);

		TAP_SPrint(buffer, press_text_to_toggle_t);
		string_length = getWidth(buffer, FNT_Size_1419);
		indent = x + ((w - string_length) / 2);
		drawText(region, indent, y+58, -1, buffer, bare_bones_title_colour, COLOR_None, FNT_Size_1419);
	}
}

void refreshCompactMode(bool mp3) 
{
	TYPE_PlayInfo play_info;
	word mp3_length, mp3_progress, string_length, indent;
	bool compact_large_mode = (compact_art_mode || compact_tv_mode);
	word compact_width = compact_large_mode ? 460 : 340, compact_height = compact_large_mode ? 276 : 196;
	int width, height, xl = 200, yl = 200, art_offset_y;
	
	if (mp3) {
		
		if (compact_art_mode) {
			current_jpeg = 0;
			moveAlbumArtToStructure();
			loadAndDecodeJpeg();
			if (jpeg_bitmap && !jpeg_failed) {
				if (draw_from_cache || isJpg(jpeg_files[current_jpeg]->file_name)) {
					width = cached_width, height = cached_height;
				}
				else {
					width = bitmap_width, height = bitmap_height;
				}
				getDrawDimensionsAndOffset(width, height, &xl, &yl, NULL, NULL, widescreen_adjustment_factor, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE);

				art_offset_y = compact_offset_y + ((276-yl)/2);
				if (isGif(jpeg_files[current_jpeg]->file_name))
					drawGIF(jpeg_data, width, height, compact_offset_x+compact_width-xl-15, art_offset_y, xl, yl);
				else
					drawJPEG(jpeg_bitmap, width, height, compact_offset_x+compact_width-xl-15, art_offset_y, xl, yl);
#ifdef WIN32
				TAP_Osd_Copy(region_mem, region, 0, 0, 720, 576, 0, 0, FALSE);
#endif
				TAP_Osd_DrawRectangle(region, compact_offset_x+compact_width-xl-15-1, art_offset_y-1, xl+2, yl+2, 2, bare_bones_border_colour);
			}
			else {
				TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
			}

			freeMemory();
		}
		ef (compact_tv_mode) {
			TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
			TAP_Osd_FillBox(region, compact_offset_x+compact_width-xl-15, compact_offset_y+58, 200, 160, COLOR_None);
			TAP_Osd_DrawRectangle(region, compact_offset_x+compact_width-xl-15-1, compact_offset_y+58-1, 200+2, 160+2, 2, bare_bones_border_colour);
			TAP_Channel_Start(CHANNEL_Sub, SVC_TYPE_Tv, -1);
			TAP_Channel_GetCurrentSubTV(&channel_number);
			TAP_Channel_Start(CHANNEL_Sub, SVC_TYPE_Tv, channel_number);
			TAP_Channel_Scale(CHANNEL_Sub, compact_offset_x+compact_width-xl-15, compact_offset_y+58, 200, 160, TRUE);

			refreshCompactChannel();
		}
		else {
			TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
		}
		drawRoundedRectangle(region, compact_offset_x, compact_offset_y, compact_width, compact_height, 3, 0, 0, 0, bare_bones_border_colour, COLOR_None, COLOR_Black, FALSE);

		// display the artist
		if (playing_id3_info->artist && strlen(playing_id3_info->artist) > 0) {
			TAP_SPrint(buffer, "/%s", playing_id3_info->artist);
		}
		else {
			ExtractDirectory(mp3_files[current_mp3]->directory, from_dir);
			ExtractLastField(from_dir, buffer);
		}
		if (strcmp(buffer, "/Root") == 0 || strcmp(buffer, "/MP3") == 0) TAP_SPrint(buffer, "/%s", unknown_artist_t);
		string_length = getWidth(buffer+1, FNT_Size_1419);
		indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
		if (indent < compact_offset_x+5) indent = compact_offset_x+5;
		drawText(region, indent, compact_large_mode ? compact_offset_y+62 : compact_offset_y+22, compact_large_mode ? compact_offset_x+compact_width-xl-20 : compact_offset_x+compact_width-2, buffer+1, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

		// display the track name
		if (playing_id3_info->title && strlen(playing_id3_info->title) > 0) {
			TAP_SPrint(buffer, "%s", playing_id3_info->title);
		}
		else {
			memset(buffer, '\0', 100);
			strncat(buffer, mp3_files[current_mp3]->file_name, strlen(mp3_files[current_mp3]->file_name)-4);
		}
		string_length = getWidth(buffer, FNT_Size_1419);
		indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
		if (indent < compact_offset_x+5) indent = compact_offset_x+5;
		drawText(region, indent, compact_large_mode ? compact_offset_y+82 : compact_offset_y+42, compact_large_mode ? compact_offset_x+compact_width-xl-20 : compact_offset_x+compact_width-2, buffer, bare_bones_title_colour, COLOR_None, FNT_Size_1419);

		// display the album name
		if (playing_id3_info->album && strlen(playing_id3_info->album) > 0) {
			TAP_SPrint(buffer, "/%s", playing_id3_info->album);
		}
		else {
			ExtractLastField(mp3_files[current_mp3]->directory, buffer);
		}
		if (strcmp(buffer, "/Root") == 0 || strcmp(buffer, "/MP3") == 0) TAP_SPrint(buffer, "/%s", unknown_album_t);
		string_length = getWidth(buffer+1, FNT_Size_1419);
		indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
		if (indent < compact_offset_x+5) indent = compact_offset_x+5;
		drawText(region, indent, compact_large_mode ? compact_offset_y+102 : compact_offset_y+62, compact_large_mode ? compact_offset_x+compact_width-xl-20 : compact_offset_x+compact_width-2, buffer+1, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

		// display the year
		if (playing_id3_info->year && strlen(playing_id3_info->year) > 0) {
			TAP_SPrint(buffer, "%s", playing_id3_info->year);
			string_length = getWidth(buffer, FNT_Size_1419);
			indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
			if (indent < compact_offset_x+5) indent = compact_offset_x+5;
			drawText(region, indent, compact_large_mode ? compact_offset_y+122 : compact_offset_y+82, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);
		}

		// string together the number of this mp3 and the total mp3s
		TAP_SPrint(buffer, "%d %s %d %s", current_mp3+1, of_t, no_of_mp3s, tunes_t);
		string_length = getWidth(buffer, FNT_Size_1419);
		indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
		if (indent < compact_offset_x+5) indent = compact_offset_x+5;
		drawText(region, indent, compact_large_mode ? compact_offset_y+162 : compact_offset_y+122, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

		// get the mp3 progress
#ifndef WIN32
		TAP_Hdd_GetPlayInfo(&play_info);
#else
		play_info.currentBlock = 35;
		play_info.duration = 212;
#endif
		mp3_length = play_info.duration;
		mp3_progress = play_info.currentBlock;
		if (mp3_progress > mp3_length) mp3_progress = mp3_length;
		TAP_SPrint(buffer, "%02d:%02d %s %02d:%02d", mp3_progress / 60, mp3_progress % 60, of_t, mp3_length / 60, mp3_length % 60);
		string_length = getWidth(buffer, FNT_Size_1419);
		indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
		if (indent < compact_offset_x+5) indent = compact_offset_x+5;
		mp3_progress_offset = indent;
		drawText(region, indent, compact_large_mode ? compact_offset_y+192 : compact_offset_y+152, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

		if (mp3_end_mode == REPEAT_ALBUM) TAP_Osd_PutGd(region, compact_offset_x+10, compact_offset_y+10, &_repeat4Gd, TRUE);
		if (randomise_mp3s) TAP_Osd_PutGd(region, (mp3_end_mode == REPEAT_ALBUM) ? compact_offset_x+40 : compact_offset_x+10, compact_offset_y+10, &_shuffle4Gd, TRUE);
	}
	else {
		TYPE_TapEvent *channel_event;

		if (compact_tv_mode) {
			TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
			TAP_Osd_FillBox(region, compact_offset_x+compact_width-xl-15, compact_offset_y+58, 200, 160, COLOR_None);
			TAP_Osd_DrawRectangle(region, compact_offset_x+compact_width-xl-15-1, compact_offset_y+58-1, 200+2, 160+2, 2, bare_bones_border_colour);
			TAP_Channel_Start(CHANNEL_Sub, SVC_TYPE_Tv, -1);
			TAP_Channel_GetCurrentSubTV(&channel_number);
			TAP_Channel_Start(CHANNEL_Sub, SVC_TYPE_Tv, channel_number);
			TAP_Channel_Scale(CHANNEL_Sub, compact_offset_x+compact_width-xl-15, compact_offset_y+58, 200, 160, TRUE);

			refreshCompactChannel();
		}
		else {
			TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
		}
		drawRoundedRectangle(region, compact_offset_x, compact_offset_y, compact_width, compact_height, 3, 0, 0, 0, bare_bones_border_colour, COLOR_None, COLOR_Black, FALSE);

		// get the name of the station
		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Channel_GetCurrent(&tv_radio, &channel_number);
		if (isPlaying(play_info)) {
			TAP_Channel_GetInfo(play_info.svcType, play_info.svcNum, &channel_info);
			channel_event = &play_info.evtInfo;
		}
		else {
			TAP_Channel_GetInfo(tv_radio, channel_number, &channel_info);
			channel_event = TAP_GetCurrentEvent(tv_radio, channel_number);
		}

		// display the channel name
		string_length = getWidth(channel_info.chName, FNT_Size_1419);
		indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
		if (indent < compact_offset_x+5) indent = compact_offset_x+5;
		drawText(region, indent, compact_large_mode ? compact_offset_y+65 : compact_offset_y+30, compact_large_mode ? compact_offset_x+compact_width-xl-20 : compact_offset_x+compact_width-2, channel_info.chName, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

		// display the event name
		if (channel_event) {
			byte start_hour, start_min, end_hour, end_min, duration_hour, duration_min, progress_hour, progress_min;
			word duration;

			strcpy(displayed_radio_event, channel_event->eventName);
			string_length = getWidth(channel_event->eventName, FNT_Size_1419);
			indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
			if (indent < compact_offset_x+5) indent = compact_offset_x+5;
			drawText(region, indent, compact_large_mode ? compact_offset_y+85 : compact_offset_y+50, compact_large_mode ? compact_offset_x+compact_width-xl-20 : compact_offset_x+compact_width-2, channel_event->eventName, bare_bones_title_colour, COLOR_None, FNT_Size_1419);
		
			// get the event times
			if (isPlaying(play_info)) {
				duration_hour = play_info.duration / 60;
				duration_min  = play_info.duration % 60; 
			}
			else {
				duration_hour = (channel_event->duration >> 8) & 0xff;  
				duration_min  = (channel_event->duration) & 0xff;  
			}
			start_hour = (channel_event->startTime >> 8) & 0xff;  
			start_min  = (channel_event->startTime) & 0xff;  
			end_hour = (channel_event->endTime >> 8) & 0xff;  
			end_min  = (channel_event->endTime) & 0xff;  
	
			// display the event times
			TAP_SPrint(buffer, "%02d:%02d - %02d:%02d", start_hour, start_min, end_hour, end_min);
			string_length = getWidth(buffer, FNT_Size_1419);
			indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
			drawText(region, indent, compact_large_mode ? compact_offset_y+105 : compact_offset_y+70, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

			// display the duration
			duration = duration_hour*60 + duration_min;
			formatDuration(buffer, duration_hour, duration_min); 
			string_length = getWidth(buffer, FNT_Size_1419);
			indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
			drawText(region, indent, compact_large_mode ? compact_offset_y+125 : compact_offset_y+90, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

			// get the event progress
			if (isPlaying(play_info)) {
				displayed_radio_progress = (play_info.currentBlock * play_info.duration) / play_info.totalBlock;
				progress_hour = displayed_radio_progress / 60;
				progress_min  = displayed_radio_progress % 60;
			}
			else {
				TAP_GetTime(&mjd, &hour, &min, &sec);
				progress_hour = ((hour*60 + min) - (start_hour*60 + start_min)) / 60;
				progress_min  = ((hour*60 + min) - (start_hour*60 + start_min)) % 60;
				displayed_radio_progress = progress_hour*60 + progress_min;
			}

			if (displayed_radio_progress <= duration) {
				// display the event progress
				formatDuration(buffer, progress_hour, progress_min);
				string_length = getWidth(buffer, FNT_Size_1419);
				indent = compact_large_mode ? compact_offset_x+2 + ((compact_width-xl-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
				drawText(region, indent, compact_large_mode ? compact_offset_y+175 : compact_offset_y+140, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

				// draw the progress bar
				if (duration > 0 && ((displayed_radio_progress*100/duration) > 0)) {
					TAP_Osd_DrawRectangle(region, compact_large_mode ? compact_offset_x+75-2 : compact_offset_x+128-2, compact_large_mode ? compact_offset_y+205-2 : compact_offset_y+170-2, 100+4, 5+4, 2, bare_bones_title_colour);
					TAP_Osd_FillBox(region, compact_large_mode ? compact_offset_x+75 : compact_offset_x+128, compact_large_mode ? compact_offset_y+205 : compact_offset_y+170, (displayed_radio_progress*100 / duration), 5, bare_bones_text_colour);
				}
			}
		}
	}

	TAP_Osd_PutGd(region, compact_offset_x+3, compact_offset_y+compact_height-70, &_treble2Gd, TRUE);
}

void refreshRadioProgress()
{
	TYPE_TapEvent *channel_event;
	TYPE_PlayInfo play_info;
	int string_length, indent;
	word compact_width = compact_tv_mode ? 460 : 340, compact_height = compact_tv_mode ? 276 : 196;
	
	if (!compact_mode_started)
		return;

	if (burnout_delay && TAP_GetTick() > (burnout_tick + burnout_delay*100)) {
		compact_offset_x = ((getRandom() % (compact_tv_mode ? 4 : 6)) + 1) * 45;
		compact_offset_y = ((getRandom() % (compact_tv_mode ? 6 : 8)) + 1) * 36;
		refreshCompactMode(FALSE);
		burnout_tick = TAP_GetTick();
		return;
	}

	TAP_Hdd_GetPlayInfo(&play_info);
	TAP_Channel_GetCurrent(&tv_radio, &channel_number);
	if (isPlaying(play_info)) {
		TAP_Channel_GetInfo(play_info.svcType, play_info.svcNum, &channel_info);
		channel_event = &play_info.evtInfo;
	}
	else {
		TAP_Channel_GetInfo(tv_radio, channel_number, &channel_info);
		channel_event = TAP_GetCurrentEvent(tv_radio, channel_number);
	}

	// check the event name progress
	if (channel_event) {
		byte start_hour, start_min, progress_hour, progress_min, duration_hour, duration_min;
		word duration;

		// if event has changed, refresh the whole display
		if (strcmp(channel_event->eventName, displayed_radio_event) != 0) {
			refreshCompactMode(FALSE);
			return;
		}

		// get the event progress
		if (isPlaying(play_info)) {
			word progress = (play_info.currentBlock * play_info.duration) / play_info.totalBlock;
			progress_hour = progress / 60;
			progress_min  = progress % 60;
			duration_hour = play_info.duration / 60;
			duration_min  = play_info.duration % 60; 
		}
		else {
			TAP_GetTime(&mjd, &hour, &min, &sec);
			start_hour = (channel_event->startTime >> 8) & 0xff;  
			start_min  = (channel_event->startTime) & 0xff; 
			progress_hour = ((hour*60 + min) - (start_hour*60 + start_min)) / 60;
			progress_min  = ((hour*60 + min) - (start_hour*60 + start_min)) % 60;
			duration_hour = (channel_event->duration >> 8) & 0xff;  
			duration_min  = (channel_event->duration) & 0xff;  
		}

		if ((progress_hour*60 + progress_min) != displayed_radio_progress) {
			displayed_radio_progress = progress_hour*60 + progress_min;
	
			duration = duration_hour*60 + duration_min;

			if (displayed_radio_progress <= duration) {
				// display the event progress
				formatDuration(buffer, progress_hour, progress_min);
				string_length = getWidth(buffer, FNT_Size_1419);
				indent = compact_tv_mode ? compact_offset_x+2 + ((compact_width-200-15 - string_length) / 2) : compact_offset_x+2 + ((compact_width+10 - string_length) / 2);
				TAP_Osd_FillBox(region, indent-50, compact_tv_mode ? compact_offset_y+175 : compact_offset_y+140, string_length+100, 20, COLOR_Black);
				drawText(region, indent, compact_tv_mode ? compact_offset_y+175 : compact_offset_y+140, -1, buffer, bare_bones_text_colour, COLOR_None, FNT_Size_1419);

				// draw the progress bar
				if (duration > 0 && ((displayed_radio_progress*100/duration) > 0)) {
					TAP_Osd_DrawRectangle(region, compact_tv_mode ? compact_offset_x+75-2 : compact_offset_x+128-2, compact_tv_mode ? compact_offset_y+205-2 : compact_offset_y+170-2, 100+4, 5+4, 2, bare_bones_title_colour);
					TAP_Osd_FillBox(region, compact_tv_mode ? compact_offset_x+75 : compact_offset_x+128, compact_tv_mode ? compact_offset_y+205 : compact_offset_y+170, (displayed_radio_progress*100 / duration), 5, bare_bones_text_colour);
				}
			}
		}
	}
}

void refreshAlbumArt() 
{
	moveAlbumArtToStructure();
	current_jpeg = 0;

	full_size_display = FALSE;
	show_jpeg = TRUE;
	memory_delay_elapsed = TRUE;
	clearHistory(TRUE);
	processJPEG(TRUE);
}

void toggleAlbumArt()
{
	full_size_display = full_size_display ? FALSE : TRUE;
	processJPEG(TRUE);
}

void playMp3(char *file_name)
{
	readID3Tag(file_name, TRUE, TRUE);

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play MP3 %s, %s", file_name, mp3_files[current_mp3]->directory);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
#ifndef WIN32
	TAP_Hdd_PlayMp3(file_name);
#endif
	mp3_playing = TRUE;

	mp3_progress_offset = 0;
	if (slideshow_started) {
		startMp3Slideshow(FALSE);
		if (recreate_plane2) {
			// playing the first mp3 seems to redraw plane 2, so recreate it if we have started a slideshow
			TAP_Osd_Delete(region_2);
			region_2 = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_Plane2);
			recreate_plane2 = FALSE;
		}
	}
	ef (album_art_started)
		refreshAlbumArt();
	ef (compact_mode_started) {
		refreshCompactMode(external_slideshow ? FALSE : TRUE);
		if (compact_help_displayed)
			refreshCompactModeHelp(external_slideshow ? FALSE : TRUE);
	}
}

/* get the latest nav history */
int getNavHistoryIndex()
{
	if (nav_history[0].idx > (no_of_files - 1)) {
		nav_history[0].idx = no_of_files - 1;
		nav_history[0].highlight = -1;
	}

	return (nav_history[0].idx < 0) ? 0 : nav_history[0].idx;
}

/* get the latest nav history */
int getNavHistoryHighlight()
{
	int highlight = nav_history[0].highlight;
	return (highlight > (no_of_files - 1)) ? no_of_files - 1 : highlight;
}

/* pop the last highlight into the history array, bumping up all the rest */
void saveNavHistory(int idx, int highlight, bool overwrite)
{
	int i;

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Save nav history %d, %d", idx, highlight);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	if (!overwrite) {
		for (i = 20-1; i > 0; i--) {
			nav_history[i].idx = nav_history[i-1].idx;
			nav_history[i].highlight = nav_history[i-1].highlight;
		}
	}

	nav_history[0].idx = idx;
	nav_history[0].highlight = highlight;
}

/* remove the last entry and bump down all the rest */
void rollbackNavHistory()
{
	int i;

	for (i = 0; i < 20-1; i++) {
		nav_history[i].idx = nav_history[i+1].idx;
		nav_history[i].highlight = nav_history[i+1].highlight;
	}
}

/* reset all nav history (current and components) */
void clearAllNavHistory()
{
	int i;

	for (i = 0; i < 20; i++) {
		nav_history[i].idx = -1;
		nav_history[i].highlight = -1;
		jpg_nav_history[i].idx = -1;
		jpg_nav_history[i].highlight = -1;
		mp3_nav_history[i].idx = -1;
		mp3_nav_history[i].highlight = -1;
		rec_nav_history[i].idx = -1;
		rec_nav_history[i].highlight = -1;
		pf_nav_history[i].idx = -1;
		pf_nav_history[i].highlight = -1;
	}
}

/* reset nav history (both current and jpg) */
void clearJpgNavHistory()
{
	int i;

	for (i = 0; i < 20; i++) {
		nav_history[i].idx = -1;
		nav_history[i].highlight = -1;
		jpg_nav_history[i].idx = -1;
		jpg_nav_history[i].highlight = -1;
	}
}

/* there is some history if first entry not -1 */
bool navHistoryExists()
{
	return (nav_history[0].idx >= 0);
}

/* save a copy of the nav history for later restore */
void copyNavHistory()
{
	int i;

	if (jpg_navigation) {
		for (i = 0; i < 20; i++) {
			jpg_nav_history[i].idx = nav_history[i].idx;
			jpg_nav_history[i].highlight = nav_history[i].highlight;
		}
		strcpy(saved_jpg_current_dir, curr_dir);
	}
	ef (mp3_navigation) {
		for (i = 0; i < 20; i++) {
			mp3_nav_history[i].idx = nav_history[i].idx;
			mp3_nav_history[i].highlight = nav_history[i].highlight;
		}
		strcpy(saved_mp3_current_dir, curr_dir);
	}
	ef (rec_navigation) {
		for (i = 0; i < 20; i++) {
			rec_nav_history[i].idx = nav_history[i].idx;
			rec_nav_history[i].highlight = nav_history[i].highlight;
		}
		strcpy(saved_rec_current_dir, curr_dir);
	}
	ef (pf_navigation) {
		for (i = 0; i < 20; i++) {
			pf_nav_history[i].idx = nav_history[i].idx;
			pf_nav_history[i].highlight = nav_history[i].highlight;
		}
		strcpy(saved_pf_current_dir, curr_dir);
	}
}

/* restore nav history from a backup */
void restoreNavHistory()
{
	int i;

	if (jpg_navigation) {
		for (i = 0; i < 20; i++) {
			nav_history[i].idx = jpg_nav_history[i].idx;
			nav_history[i].highlight = jpg_nav_history[i].highlight;
		}
	}
	ef (mp3_navigation) {
		for (i = 0; i < 20; i++) {
			nav_history[i].idx = mp3_nav_history[i].idx;
			nav_history[i].highlight = mp3_nav_history[i].highlight;
		}
	}
	ef (pf_navigation) {
		for (i = 0; i < 20; i++) {
			nav_history[i].idx = pf_nav_history[i].idx;
			nav_history[i].highlight = pf_nav_history[i].highlight;
		}
	}
	else {
		for (i = 0; i < 20; i++) {
			nav_history[i].idx = rec_nav_history[i].idx;
			nav_history[i].highlight = rec_nav_history[i].highlight;
		}
	}
}

void saveNavHistoryOnExit()
{
	if (discard_navigation_history) {
		clearAllNavHistory();
		if (jpg_navigation) {
			strcpy(saved_jpg_current_dir, default_startup_directory);
			strcpy(curr_dir, saved_jpg_current_dir);
		}
		ef (rec_navigation) {
			strcpy(saved_rec_current_dir, "/DataFiles");
			strcpy(curr_dir, saved_rec_current_dir);
		}
		ef (pf_navigation) {
			strcpy(saved_pf_current_dir, "/ProgramFiles");
			strcpy(curr_dir, saved_pf_current_dir);
		}
		else {
			strcpy(saved_mp3_current_dir, "/MP3");
			strcpy(curr_dir, saved_mp3_current_dir);
		}
		ChangeDirPath(curr_dir);
	}
	else {
		if (window_displayed) {
			saveNavHistory(curr_idx, curr_highlight, FALSE);
			copyNavHistory();
		}
	}
}

/* pop the last mp3 or photo into the history array, bumping up all the rest */
void saveHistory(bool photo, int idx)
{
	int i;

	if (photo) {
		for (i = HISTORY_LENGTH-1; i > 0; i--) {
			photo_history[i] = photo_history[i-1];
		}
		photo_history[0] = idx;
	}
	else {
		for (i = HISTORY_LENGTH-1; i > 0; i--) {
			mp3_history[i] = mp3_history[i-1];
		}
		mp3_history[0] = idx;
	}
}

/* reset mp3 or photo history */
void clearHistory(bool photo)
{
	int i;

	for (i = 0; i < HISTORY_LENGTH; i++) {
		if (photo)
			photo_history[i] = -1;
		else
			mp3_history[i] = -1;
	}

	if (photo)
		photo_history_pointer = 0;
	else
		mp3_history_pointer = 0;
}

/* return number of files in the history */
int getHistoryLength(bool photo)
{
	int length = 0, i;

	//if (!photo && !randomise_mp3s)
	//	return current_mp3 + 1;

	for (i = 0; i < HISTORY_LENGTH; i++) {
		if (photo && photo_history[i] == -1) 
			break;
		if (!photo && mp3_history[i] == -1)
			break;

		length++;
	}

	return length;
}

/* check whether requested idx exists in history */
bool existsInHistory(bool photo, int idx)
{
	int i;

	if (photo) {
		for (i = 0; i < HISTORY_LENGTH; i++) {
			if (photo_history[i] == -1) {
				return FALSE;
			}
			if (idx == photo_history[i])
				return TRUE;
		}
	}
	else {
		for (i = 0; i < HISTORY_LENGTH; i++) {
			if (mp3_history[i] == -1) {
				return FALSE;
			}
			if (idx == mp3_history[i])
				return TRUE;
		}
	}

	return FALSE;
}

/* check history and return the next appropriate jpeg */
int getNextJpeg(bool forward)
{
	int next_jpeg, history_length;

	// get the number of files in the history
	history_length = getHistoryLength(TRUE);

	// if all files played, then reset the history
	if (forward &&  (history_length == no_of_jpegs)) {
		clearHistory(TRUE);
		history_length = 0;
	}

	if (randomise_photos) {
		if (forward) {
			// if skipping forward then get next jpeg not in history
			if (photo_history_pointer > 0)
				next_jpeg = photo_history[--photo_history_pointer];
			else {
				next_jpeg = getRandom() % no_of_jpegs;
				while (existsInHistory(TRUE, next_jpeg))
					next_jpeg = getRandom() % no_of_jpegs;
				saveHistory(TRUE, next_jpeg);
			}
		}
		else {
			// if skipping backward, get the item 2 places back (as we are always one ahead of ourselves)
			if (photo_history_pointer == (no_of_jpegs - 2) 
					|| photo_history_pointer == (HISTORY_LENGTH - 2) 
					|| photo_history[photo_history_pointer + 2] == -1)
				// at end of history, so just use the current jpeg
				next_jpeg = photo_history[++photo_history_pointer];
			else {
				// otherwise get the item 2 places back
				next_jpeg = photo_history[photo_history_pointer + 2];
				photo_history_pointer += 2;
			}
		}
	}
	else {
		if (forward) {
			next_jpeg = (current_jpeg + 1) % no_of_jpegs;
		}
		else {
			next_jpeg = (current_jpeg == 0) ? no_of_jpegs - 1 : current_jpeg - 1;
			next_jpeg = (next_jpeg == 0) ? no_of_jpegs - 1 : next_jpeg - 1;
		}
	}

	return next_jpeg;
}

/* check history and return the next appropriate mp3 */
int getNextMp3(bool forward)
{
	int next_mp3, history_length;
	
	// get the number of files in the history
	history_length = getHistoryLength(FALSE);

	// if all files played, then reset the history
	if (forward && (history_length == no_of_mp3s)) {
		clearHistory(FALSE);
		history_length = 0;
	}

	if (randomise_mp3s) {
		if (forward) {
			// if skipping forward then get next track not in history
			if (mp3_history_pointer > 0)
				next_mp3 = mp3_history[--mp3_history_pointer];
			else {
				next_mp3 = getRandom() % no_of_mp3s;
				while (existsInHistory(FALSE, next_mp3))
					next_mp3 = getRandom() % no_of_mp3s;
				saveHistory(FALSE, next_mp3);
			}
		}
		else {
			// if skipping backward, get the previous item
			if (mp3_history_pointer == (no_of_mp3s - 1) 
					|| mp3_history_pointer == (HISTORY_LENGTH - 1) 
					|| mp3_history[mp3_history_pointer + 1] == -1)
				next_mp3 = mp3_history[mp3_history_pointer];
			else
				next_mp3 = mp3_history[++mp3_history_pointer];
		}
	}
	else {
		if (forward) {
			if (mp3_history_pointer > 0)
				next_mp3 = mp3_history[--mp3_history_pointer];
			else {
				next_mp3 = (current_mp3 + 1) % no_of_mp3s;
				saveHistory(FALSE, next_mp3);
			}
		}
		else {
			if (mp3_history_pointer == (no_of_mp3s - 1) 
					|| mp3_history_pointer == (HISTORY_LENGTH - 1) 
					|| mp3_history[mp3_history_pointer + 1] == -1)
				next_mp3 = mp3_history[mp3_history_pointer];
			else
				next_mp3 = mp3_history[++mp3_history_pointer];
		}
	}

	return next_mp3;
}

/* pop the last folder into the history array, bumping up all the rest */
void saveFolderHistory(char *folder)
{
	int i, history_length = getFolderHistoryLength();

	// allocate memory for the new entry (which will actually be the last entry)
	folder_history[history_length] = dlmalloc(sizeof(char) * 100);

	// shuffle up all the other folders and copy the new one to the start of array
	for (i = history_length; i > 0; i--) {
		strcpy(folder_history[i], folder_history[i-1]);
	}
	strcpy(folder_history[0], folder);
}

/* reset folder history */
void clearFolderHistory()
{
	int i;

	for (i = 0; i < HISTORY_LENGTH; i++) {
		if (folder_history[i]) {
			dlfree(folder_history[i]);
			folder_history[i] = NULL;
		}
	}

	dlmalloc_trim(0);
	folder_history_pointer = 0;
}

/* return number of folders in the history */
int getFolderHistoryLength()
{
	int length = 0, i;

	for (i = 0; i < HISTORY_LENGTH; i++) {
		if (folder_history[i] == NULL)
			break;

		length++;
	}

	return length;
}

/* find original history entry */
char *getFirstFolderInHistory()
{
	int i;

	// if history full, then get last entry
	if (getFolderHistoryLength() == HISTORY_LENGTH)
		return folder_history[HISTORY_LENGTH-1];

	// otherwise return last non null entry
	for (i = 0; i < HISTORY_LENGTH-1; i++) {
		if (folder_history[i+1] == NULL)
			return folder_history[i];
	}

	// should be impossible
	return NULL;
}

/* check history and return the next appropriate jpeg */
char *getNextFolder(bool forward)
{
	char *next_folder;
	word history_length;

	// get the number of files in the history
	history_length = getFolderHistoryLength();

	// if histroy full then reset 
	if (forward && (history_length == HISTORY_LENGTH)) {
		clearFolderHistory();
		history_length = 0;
	}

	if (forward) {
		// if skipping forward then get next folder
		next_folder = folder_history[--folder_history_pointer];
	}
	else {
		// if skipping backward, get the item 1 places back 
		if (folder_history_pointer == (HISTORY_LENGTH - 1) 
				|| folder_history[folder_history_pointer + 1] == NULL)
			// at end of history, so just use the current folder
			next_folder = folder_history[folder_history_pointer];
		else {
			// otherwise get the item 1 place back
			next_folder = folder_history[++folder_history_pointer];
		}
	}

	return next_folder;
}

void freeMediaFiles()
{
	int i;

	if (jpeg_files) {
		for (i = 0; i < no_of_jpegs; i++)
		{
			if (jpeg_files[i]) 
			{
				if (jpeg_files[i]->directory)
				{
					dlfree(jpeg_files[i]->directory);
					jpeg_files[i]->directory = NULL;
				}
				if (jpeg_files[i]->file_name)
				{
					dlfree(jpeg_files[i]->file_name);
					jpeg_files[i]->file_name = NULL;
				}
				if (jpeg_files[i]->sort_name)
				{
					dlfree(jpeg_files[i]->sort_name);
					jpeg_files[i]->sort_name = NULL;
				}

				dlfree(jpeg_files[i]);
				jpeg_files[i] = NULL;
			}
		}

		dlfree(jpeg_files);
		jpeg_files = NULL;

		dlmalloc_trim(0);
	}

	no_of_jpegs = 0;
}

void freeMP3Structure()
{
	int i;

	if (mp3_files) {
		if (free_mp3s) {
			for (i = 0; i < no_of_mp3s; i++) {
				if (mp3_files[i]) {
					if (mp3_files[i]->directory) {
						dlfree(mp3_files[i]->directory);
						mp3_files[i]->directory = NULL;
					}
					if (mp3_files[i]->file_name) {
						dlfree(mp3_files[i]->file_name);
						mp3_files[i]->file_name = NULL;
					}
					if (mp3_files[i]->sort_name) {
						dlfree(mp3_files[i]->sort_name);
						mp3_files[i]->sort_name = NULL;
					}

					if (free_mp3s) dlfree(mp3_files[i]);
					mp3_files[i] = NULL;
				}
			}
			dlfree(mp3_files);
		}
 
		mp3_files = NULL;

		dlmalloc_trim(0);
	}

	no_of_mp3s = 0;
}

void deleteAllMp3Headers()
{
	int i;

	if (all_mp3_headers) {
		for (i = 0; i < no_of_mp3_headers; i++)
		{
			if (all_mp3_headers[i]) {
				dlfree(all_mp3_headers[i]->directory);
				dlfree(all_mp3_headers[i]->file_name);
				if (all_mp3_headers[i]->album_name)	dlfree(all_mp3_headers[i]->album_name);
				if (all_mp3_headers[i]->artist_name) dlfree(all_mp3_headers[i]->artist_name);
				if (all_mp3_headers[i]->genre_string) dlfree(all_mp3_headers[i]->genre_string);
				if (all_mp3_headers[i]->track_name) dlfree(all_mp3_headers[i]->track_name);
				if (all_mp3_headers[i]->year_string) dlfree(all_mp3_headers[i]->year_string);

				dlfree(all_mp3_headers[i]);
				all_mp3_headers[i] = NULL;
			}
		}

		dlfree(all_mp3_headers);
		all_mp3_headers = NULL;

		dlmalloc_trim(0);
	}

	no_of_mp3_headers = 0;
}

void freeMoveFolders()
{
	word i;

	for (i = 0; i < 128; i++) {
		if (move_folders[move_folder_idx] != NULL) {
			dlfree(move_folders[move_folder_idx]);
			move_folders[move_folder_idx] = NULL;
		}
	}

	dlmalloc_trim(0);
}

void freeAllFolders()
{
	word i;

	if (all_folders) {
		for (i = 0; i < all_folders_count; i++)	{
			if (all_folders[i])	{
				dlfree(all_folders[i]);
				all_folders[i] = NULL;
			}
		}

		dlfree(all_folders);
		all_folders = NULL;

		dlmalloc_trim(0);
	}
}

byte *dummy_data = (byte *) 1;
word *dummy_bitmap = (word *) 1;

void freeMemory()
{
	if (jpeg_data) {
		if (jpeg_data != dummy_data)
			dlfree(jpeg_data);
		jpeg_data = NULL;
	}
	if (jpeg_bitmap) {
		if (jpeg_bitmap != dummy_bitmap)
			dlfree(jpeg_bitmap);
		jpeg_bitmap = NULL;
	}
	if (screen_data) {
		dlfree(screen_data);
		screen_data = NULL;
	}
	if (cached_data) {
		dlfree(cached_data);
		cached_data = NULL;
	}
	if (thumbnail_data)	{
		dlfree(thumbnail_data);
		thumbnail_data = NULL;
	}
	if (byte_data) {
		dlfree(byte_data);
		byte_data = NULL;
	}

	free_jpg_wembley_style();

	dlmalloc_trim(0);

	memory_delay_elapsed = FALSE;
	if (write_log) if (verbose) logText("Wait two seconds", FALSE);
	tick_one_sec = TAP_GetTick();
}

void freeDirInfo()
{
	word i;

	for (i = 0; i < no_of_files; i++) {
		if (dir_info[i]->file_name) dlfree(dir_info[i]->file_name);
		if (dir_info[i]->event_name) dlfree(dir_info[i]->event_name);
		if (dir_info[i]->sort_name) dlfree(dir_info[i]->sort_name);
		if (dir_info[i]->description) dlfree(dir_info[i]->description);
		if (dir_info[i]->service_name)	dlfree(dir_info[i]->service_name);

		dlfree(dir_info[i]);
		dir_info[i] = NULL;
	}

	no_of_files = 0;

	dlmalloc_trim(0);
}

void freeAutoDeleteMemory()
{
	word i;

	if (recordings_episode_count) {
		for (i = 0; i < no_of_matched_recordings; i++) {
			if (recordings_episode_count[i]) {
				if (recordings_episode_count[i]->matched_name) {
					dlfree(recordings_episode_count[i]->matched_name);
					recordings_episode_count[i]->matched_name = NULL;
				}
				dlfree(recordings_episode_count[i]);
				recordings_episode_count[i] = NULL;
			}
		}

		if (recordings_episode_count) {
			dlfree(recordings_episode_count);
			recordings_episode_count = NULL;
		}

		dlmalloc_trim(0);
	}

	if (recordings_extract) {
		for (i = 0; i < no_of_recordings; i++) {
			if (recordings_extract[i]) {
				if (recordings_extract[i]->file_name) {
					dlfree(recordings_extract[i]->file_name);
					recordings_extract[i]->file_name = NULL;
				}
				if (recordings_extract[i]->matched_name) {
					dlfree(recordings_extract[i]->matched_name);
					recordings_extract[i]->matched_name = NULL;
				}
				if (recordings_extract[i]->directory) {
					dlfree(recordings_extract[i]->directory);
					recordings_extract[i]->directory = NULL;
				}
				dlfree(recordings_extract[i]);
				recordings_extract[i] = NULL;
			}
		}

		if (recordings_extract) {
			dlfree(recordings_extract);
			recordings_extract = NULL;
		}

		dlmalloc_trim(0);
	}
}

void freeDimensions()
{
	word i;

	// clear any existing dim memory
	for (i = 0; i < no_of_dimensions; i++) {
		if (dimensions[i]) {
			dlfree(dimensions[i]);
			dimensions[i] = NULL;
		}
	}

	no_of_dimensions = 0;

	dlmalloc_trim(0);
}

void freeSavedRecordings()
{
	word i;

	// clear any existing saved vid memory
	for (i = 0; i < no_of_saved_recordings; i++) {
		if (saved_recordings[i]) {
			dlfree(saved_recordings[i]);
			saved_recordings[i] = NULL;
		}
	}

	no_of_saved_recordings = 0;

	dlmalloc_trim(0);
}

bool inSightOfNextMenuSection(int idx, bool forwards)
{
	int start = idx, i;

	if (forwards) {
		if (start >= (NUMBER_OF_OPTIONS - 10))
			return TRUE;

		for (i = 1; i <= 10; i++) {
			if (options[start+i].divider)
				return TRUE;
		}
	}
	else {
		if (start <= 10)
			return TRUE;

		for (i = 2; i <= 10; i++) {
			if (options[start-i].divider)
				return TRUE;
		}
	}

	return FALSE;
}

void computePreviousMenuSection(int *idx)
{
	int start = *idx, i;

	if (*idx == 1)
		start = NUMBER_OF_OPTIONS-1;
	ef (options[*idx-1].divider)
		start -= 2;
	else
		start--;

	for (i = start; i >= 0; i--) {
		if (options[i].divider) {
			*idx = i;
			break;
		}
	}

	*idx += 1;
}

bool isLastDivider(int idx)
{
	word i;

	for (i = idx; i < NUMBER_OF_OPTIONS; i++) {
		if (options[i].divider)
			return FALSE;
	}

	return TRUE;
}

void computeNextMenuSection(int *idx)
{
	word start = *idx, i;

	if (*idx == NUMBER_OF_OPTIONS-1 || isLastDivider(*idx))
		start = 0;

	for (i = start; i < NUMBER_OF_OPTIONS; i++) {
		if (options[i].divider) {
			*idx = i;
			break;
		}
	}

	*idx += 1;
}

word computeOptionNumber(data_idx)
{
	word i, option_number = 0;

	for (i = 0; i <= data_idx; i++) {
		if (!options[i].divider)
			option_number++;
	}

	return option_number;
}

word computeNumberOfOptions()
{
	word i, option_number = 0;

	for (i = 0; i < NUMBER_OF_OPTIONS; i++) {
		if (!options[i].divider)
			option_number++;
	}

	return option_number;
}

void setActivationKeyText(char *buffer, dword key)
{
	switch (key)
	{
		case RKEY_None:		TAP_SPrint(buffer, " %s", none_t); break;
		case RKEY_Filelist:	TAP_SPrint(buffer, " %s", archive_t); break;
		case RKEY_Recall:	TAP_SPrint(buffer, " %s", recall_t); break;
		case RKEY_TvSat:	TAP_SPrint(buffer, " %s", tv_sat_t); break;
		case RKEY_Slow:		TAP_SPrint(buffer, " %s", slow_motion_t); break;
		case RKEY_Mute:		TAP_SPrint(buffer, " %s", mute_t); break;
		case RKEY_TvRadio:	TAP_SPrint(buffer, " %s", tv_radio_t); break;
		case RKEY_Text:		TAP_SPrint(buffer, " %s", teletext_t); break;
		case RKEY_Pip:		TAP_SPrint(buffer, " %s", PiP_t); break;
		case RKEY_PipSwap:	TAP_SPrint(buffer, " %s", PiP_swap_t); break;
		case RKEY_Options:	TAP_SPrint(buffer, " %s", options_t); break;
		case RKEY_0:		TAP_SPrint(buffer, " %s", "0"); break;
		case RKEY_1:		TAP_SPrint(buffer, " %s", "1"); break;
		case RKEY_2:		TAP_SPrint(buffer, " %s", "2"); break;
		case RKEY_3:		TAP_SPrint(buffer, " %s", "3"); break;
		case RKEY_4:		TAP_SPrint(buffer, " %s", "4"); break;
		case RKEY_5:		TAP_SPrint(buffer, " %s", "5"); break;
		case RKEY_6:		TAP_SPrint(buffer, " %s", "6"); break;
		case RKEY_7:		TAP_SPrint(buffer, " %s", "7"); break;
		case RKEY_8:		TAP_SPrint(buffer, " %s", "8"); break;
		case RKEY_9:		TAP_SPrint(buffer, " %s", "9"); break;
		case RKEY_Uhf:		TAP_SPrint(buffer, " %s", "UHF"); break;
		case RKEY_Fav:		TAP_SPrint(buffer, " %s", "Fav"); break;
		case RKEY_Subt:		TAP_SPrint(buffer, " %s", "Subtitles"); break;
		case RKEY_AudioTrk:	TAP_SPrint(buffer, " %s", "Audio track"); break;
		case RKEY_White:	TAP_SPrint(buffer, " %s", "White"); break;
		case RKEY_Red:	    TAP_SPrint(buffer, " %s", "Red"); break;
		case RKEY_Green:	TAP_SPrint(buffer, " %s", "Green"); break;
		case RKEY_Yellow:	TAP_SPrint(buffer, " %s", "Yellow"); break;
		case RKEY_Blue:		TAP_SPrint(buffer, " %s", "Blue"); break;
	}
}

void drawOption(int line_idx, int data_idx)
{
	int y;
	dword fc;

	y = 30 + (line_idx * 29) + 3;

	if (line_idx == curr_highlight) {
		initialiseLine(X-5, Y+y, W+10+1, 26, highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
	}
	else {
		initialiseLine(X-5, Y+y, W+10+1, 26, background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
	}
	
	if (options[data_idx].divider) {
		word string_length = getWidth(options[data_idx].option_name, FNT_Size_1622);
		word indent = X-5 + ((W+10 - string_length) / 2);
		TAP_Osd_FillBox(region_mem, X-5, Y+y, W+10+1, 26, folder_bg_colour);
		drawText(region_mem, indent, Y+y+3, -1, options[data_idx].option_name, header_text_colour, folder_bg_colour, FNT_Size_1622);
		return;
	}

	TAP_Osd_FillBox(region_mem, X+30, Y+y, 2, 26, frame_colour);
	TAP_Osd_FillBox(region_mem, X+W-250, Y+y, 2, 26, frame_colour);
	
	TAP_SPrint(buffer, " %d", computeOptionNumber(data_idx));
	drawText(region_mem, X-3, Y+y+3, X+30, buffer, fc, body_bg_colour, FNT_Size_1622);

	TAP_SPrint(buffer, "%s", options[data_idx].option_name);
	drawText(region_mem, X+30+10, Y+y+3, X+W-250-5-2, buffer, fc, body_bg_colour, FNT_Size_1622);

	// stop here if this is just a divider
	if (options[data_idx].divider) return;

	switch (data_idx)
	{
		case JPG_ACTIVATION_KEY:
			setActivationKeyText(buffer, jpg_activation_key);
			break;
		case MP3_ACTIVATION_KEY:
			setActivationKeyText(buffer, mp3_activation_key);
			break;
		case REC_ACTIVATION_KEY:
			setActivationKeyText(buffer, rec_activation_key);
			break;
		case PF_ACTIVATION_KEY:
			setActivationKeyText(buffer, pf_activation_key);
			break;
		case DEFAULT_SLIDESHOW_DIRECTORY:
			transformPathDelimiters(default_slideshow_directory, buffer2);
			TAP_SPrint(buffer, " %s", buffer2);
			break;
		case DEFAULT_STARTUP_DIRECTORY:
			transformPathDelimiters(default_startup_directory, buffer2);
			TAP_SPrint(buffer, " %s", buffer2);
			break;
		case RADIO_MODE: 
			switch (radio_mode)
			{
				case OFF:			TAP_SPrint(buffer, " %s", off_t); break;
				case SLIDESHOW:		TAP_SPrint(buffer, " %s", slideshow_t); break;
				case SCREENSAVER1:	TAP_SPrint(buffer, " %s", screensaver_1_t); break;
				case SCREENSAVER2:	TAP_SPrint(buffer, " %s", screensaver_2_t); break;
				case SCREENSAVER3:	TAP_SPrint(buffer, " %s", screensaver_3_t); break;
				case SCREENSAVER4:	TAP_SPrint(buffer, " %s", screensaver_4_t); break;
				case SCREENSAVER5:	TAP_SPrint(buffer, " %s", screensaver_5_t); break;
				case COMPACT:		TAP_SPrint(buffer, " %s", bare_bones_t); break;
				case COMPACT_TV:	TAP_SPrint(buffer, " %s + %s", bare_bones_t, "TV"); break;
				case BLANK_SCREEN:	TAP_SPrint(buffer, " %s", blank_screen_t); break;
			}
			break;
		case MP3_MODE: 
			switch (mp3_mode)
			{
				case OFF:			TAP_SPrint(buffer, " %s", off_t); break;
				case SLIDESHOW:		TAP_SPrint(buffer, " %s", slideshow_t); break;
				case ALBUM_ART:		TAP_SPrint(buffer, " %s", album_art_t); break;
				case SCREENSAVER1:	TAP_SPrint(buffer, " %s", screensaver_1_t); break;
				case SCREENSAVER2:	TAP_SPrint(buffer, " %s", screensaver_2_t); break;
				case SCREENSAVER3:	TAP_SPrint(buffer, " %s", screensaver_3_t); break;
				case SCREENSAVER4:	TAP_SPrint(buffer, " %s", screensaver_4_t); break;
				case SCREENSAVER5:	TAP_SPrint(buffer, " %s", screensaver_5_t); break;
				case COMPACT:		TAP_SPrint(buffer, " %s", bare_bones_t); break;
				case COMPACT_ART:	TAP_SPrint(buffer, " %s + %s", bare_bones_t, album_art_t); break;
				case COMPACT_TV:	TAP_SPrint(buffer, " %s + %s", bare_bones_t, "TV"); break;
				case BLANK_SCREEN:	TAP_SPrint(buffer, " %s", blank_screen_t); break;
			}
			break;
		case RANDOMISE_PHOTOS:
			TAP_SPrint(buffer, " %s", randomise_photos ? random_t : sequential_t);
			break;
		case RANDOMISE_MP3S: 
			TAP_SPrint(buffer, " %s", randomise_mp3s ? random_t : sequential_t);
			break;
		case SLIDESHOW_DELAY:
			TAP_SPrint(buffer, " %d %s", slideshow_delay, seconds_t);
			break;
		case WIDESCREEN_ADJUSTMENT_FACTOR:
			TAP_SPrint(buffer, " %d%s", widescreen_adjustment_factor, "%");
			break;
		case FILTER_FLICKERING:
			TAP_SPrint(buffer, " %s", filter_flickering ? on_t : off_t);
			break;
		case FADE_IMAGE:
			TAP_SPrint(buffer, " %s", fade_image ? on_t : off_t);
			break;
		case PHOTO_ASPECT_RATIO: 
			switch (photo_aspect_ratio)
			{
				case NO_ASPECT_RATIO_SWITCH:	TAP_SPrint(buffer, " %s", do_not_switch_t); break;
				case SWITCH_TO_4_3_CENTER:		TAP_SPrint(buffer, " %s", switch_center_t); break;
				case SWITCH_TO_4_3_LETTER:		TAP_SPrint(buffer, " %s", switch_letterbox_t); break;
				case SWITCH_TO_16_9:			TAP_SPrint(buffer, " %s", switch_widescreen_t); break;
			}
			break;
		case OVERNIGHT_BATCH:
			switch (overnight_batch)
			{
				case CACHE_NOT_RUN:		TAP_SPrint(buffer, " %s", off_t); break;
				case CACHE_OVERNIGHT:	TAP_SPrint(buffer, " %s", overnight_t); break;
				case CACHE_NOW:			TAP_SPrint(buffer, " %s", on_close_t); break;
			}
			break;
		case OVERNIGHT_BATCH_TIME:
			hour = overnight_batch_time / 60;
			min  = overnight_batch_time % 60;
			TAP_SPrint(buffer, " %02d:%02d", hour, min);
			break;
		case DISPLAY_REC_EVENT_NAME: 
			switch (display_rec_event_name)
			{
				case DISPLAY_FILE_NAME:		TAP_SPrint(buffer, " %s", file_name_t); break;
				case DISPLAY_EVENT_NAME:	TAP_SPrint(buffer, " %s", event_name_t); break;
				case DISPLAY_SORT_NAME:		TAP_SPrint(buffer, " %s", trimmed_file_name_t); break;
			}
			break;
		case HIGHLIGHT_OLDEST_RECORDING:
			TAP_SPrint(buffer, " %s", highlight_oldest_recording ? on_t : off_t);
			break;
		case LAST_PLAYED_ACTIVATION_KEY:
			setActivationKeyText(buffer, last_played_activation_key);
			break;
		case CREATE_THUMBNAIL_KEY:
			setActivationKeyText(buffer, create_thumbnail_key);
			break;
		case PLAY_RESUMES_VIDEO: 
			switch (play_resumes_video)
			{
				case 0:		TAP_SPrint(buffer, " %s", resume_from_start_t); break;
				case 1:		TAP_SPrint(buffer, " %s", from_start_resume_t); break;
				case 2:		TAP_SPrint(buffer, " %s", from_start_from_start_t); break;
			}
			break;
		case LIST_PROGRESS_FORMAT: 
			switch (list_progress_format) {
				case MINS_GONE_MINS_LEFT:		TAP_SPrint(buffer, " %s", mins_gone_left_t); break;
				case MINS_GONE:					TAP_SPrint(buffer, " %s", mins_gone_t); break;
				case MINS_LEFT:					TAP_SPrint(buffer, " %s", mins_left_t); break;
				case HOURS_MINS_GONE:			TAP_SPrint(buffer, " %s", hours_mins_gone_t); break;
				case HOURS_MINS_LEFT:			TAP_SPrint(buffer, " %s", hours_mins_left_t); break;
				case PERCENTAGE_GONE:			TAP_SPrint(buffer, " %s: x%s", percentage_gone_t, "%"); break;
				case PERCENTAGE_LEFT:			TAP_SPrint(buffer, " %s: -x%s", percentage_left_t, "%"); break;
				case NO_PROGRESS:				TAP_SPrint(buffer, " %s", not_displayed_t); break;
				case BAR:						TAP_SPrint(buffer, " %s", progress_bar_t); break;
			}
			break;
		case FOOTER_PROGRESS_FORMAT: 
			switch (footer_progress_format) {
				case MINS_GONE_MINS_LEFT:		TAP_SPrint(buffer, " %s", mins_gone_left_t); break;
				case MINS_GONE:					TAP_SPrint(buffer, " %s", mins_gone_t); break;
				case MINS_LEFT:					TAP_SPrint(buffer, " %s", mins_left_t); break;
				case HOURS_MINS_GONE:			TAP_SPrint(buffer, " %s", hours_mins_gone_t); break;
				case HOURS_MINS_LEFT:			TAP_SPrint(buffer, " %s", hours_mins_left_t); break;
				case PERCENTAGE_GONE:			TAP_SPrint(buffer, " %s: x%s", percentage_gone_t, "%"); break;
				case PERCENTAGE_LEFT:			TAP_SPrint(buffer, " %s: -x%s", percentage_left_t, "%"); break;
				case NO_PROGRESS:				TAP_SPrint(buffer, " %s", not_displayed_t); break;
			}
			break;
		case FOOTER_REC_HEADER_FORMAT: 
			switch (footer_rec_header_format) {
				case EVENT_NAME:				TAP_SPrint(buffer, " %s", event_name_t); break;
				case CHANNEL_ONLY:				TAP_SPrint(buffer, " %s", channel_name_t); break;
				case CHANNEL_PLUS_TIME:			TAP_SPrint(buffer, " %s - %s", channel_name_t, start_end_t); break;
				case CHANNEL_PLUS_DATE:			TAP_SPrint(buffer, " %s - %s", channel_name_t, date_t); break;
				case CHANNEL_PLUS_SIZE:			TAP_SPrint(buffer, " %s - %s", channel_name_t, size_mb_t); break;
				case CHANNEL_PLUS_DURATION:		TAP_SPrint(buffer, " %s - %s", channel_name_t, duration_t); break;
				case CHANNEL_PLUS_EVENT_NAME:	TAP_SPrint(buffer, " %s - %s", channel_name_t, event_name_t); break;
				case CHANNEL_PLUS_BIT_RATE:		TAP_SPrint(buffer, " %s - GB/%s", channel_name_t, h_t); break;
			}
			break;
		case VIDEO_INFO_FORMAT: 
			switch (video_info_format) {
				case ALL:						TAP_SPrint(buffer, " %s", all_details_t); break;
				case DESCRIPTION_ONLY:			TAP_SPrint(buffer, " %s", description_only_t); break;
			}
			break;
		case DISPLAY_LOGOS:
			TAP_SPrint(buffer, " %s", display_logos ? on_t : off_t);
			break;
		case PRELOAD_VIDEO_HEADERS:
			switch (preload_video_headers) {
				case OFF:							TAP_SPrint(buffer, " %s", off_t); break;
				case HEADERS:						TAP_SPrint(buffer, " %s", headers_onlt_t); break;
				case HEADERS_AND_THUMBNAILS:		TAP_SPrint(buffer, " %s", headers_and_thumbs_t); break;
				case HEADERS_LAZY:					TAP_SPrint(buffer, " %s (%s)", headers_onlt_t, lazy_t); break;
				case HEADERS_AND_THUMBNAILS_LAZY:	TAP_SPrint(buffer, " %s (%s)", headers_and_thumbs_t, lazy_t); break;
			}
			break;
		case CREATE_SCENES: 
			TAP_SPrint(buffer, " %s", create_scenes ? on_t : off_t);
			break;
		case THUMBNAIL_SKIP: 
			TAP_SPrint(buffer, " %d %s", thumbnail_skip, minutes_t);
			break;
		case SCENE_SKIP: 
			TAP_SPrint(buffer, " %d %s", scene_skip, minutes_t);
			break;
		case OVERNIGHT_THUMBS: 
			switch (overnight_thumbs)
			{
				case THUMBS_NOT_RUN:	TAP_SPrint(buffer, " %s", off_t); break;
				case THUMBS_OVERNIGHT:	TAP_SPrint(buffer, " %s", create_t); break;
			}
			break;
		case OVERNIGHT_AUTO_DELETE: 
			switch (overnight_auto_delete)
			{
				case THUMBS_NOT_RUN:	TAP_SPrint(buffer, " %s", off_t); break;
				case THUMBS_OVERNIGHT:	TAP_SPrint(buffer, " %s", run_t); break;
			}
			break;
		case OVERNIGHT_COPY: 
			switch (overnight_copy)
			{
				case THUMBS_NOT_RUN:	TAP_SPrint(buffer, " %s", off_t); break;
				case THUMBS_OVERNIGHT:	TAP_SPrint(buffer, " %s", selection_t); break;
				case AUTO_COPY:			TAP_SPrint(buffer, " %s", auto_decode_t); break;		
				case AUTO_COPY_ALL:		TAP_SPrint(buffer, " %s", auto_decode_t); break;		
					
			}
			break;
		case DECODE_SPEED: 
			switch (decode_speed)
			{
				case DECODE_REAL_TIME:	TAP_SPrint(buffer, " %s", real_time_t); break;
				case DECODE_TWO_TIMES:	TAP_SPrint(buffer, " %s %s", "2x", speed_t); break;
				case DECODE_FOUR_TIMES:	TAP_SPrint(buffer, " %s %s", "4x", speed_t); break;
				case DECODE_SIX_TIMES:	TAP_SPrint(buffer, " %s %s", "6x", speed_t); break;
			}
			break;
		case DECODE_CHANNEL: 
			switch (decode_channel)
			{
				case OFF:				TAP_SPrint(buffer, " %s", none_t); break;
				case 30000:				TAP_SPrint(buffer, " %s", same_as_source_t); break;
				default:				TAP_SPrint(buffer, " %d", decode_channel); break;
			}
			break;
		case MP3_CHANNEL: 
			switch (mp3_channel)
			{
				case OFF:				TAP_SPrint(buffer, " %s", none_t); break;
				default:				TAP_SPrint(buffer, " %s", getChannel(mp3_channel-1)); break;
			}
			break;
		case OVERNIGHT_SHUTDOWN: 
			TAP_SPrint(buffer, " %s", overnight_shutdown ? on_t : off_t);
			break;
		case GMT_OFFSET_OVERRIDE: 
			if (gmt_offset_override == 0)
				TAP_SPrint(buffer, " %s", off_t);
			else
				TAP_SPrint(buffer, " +%d %s", gmt_offset_override , gmt_offset_override == 1 ? hour_t : hours_t);
			break;
		case MASTERPIECE_MODE: 
			switch (masterpiece_mode)
			{
				case OFF:	TAP_SPrint(buffer, " %s", off_t); break;
				case 1:		TAP_SPrint(buffer, " %s", on_t); break;
				case 2:		TAP_SPrint(buffer, " %s", "Mode 2"); break;
			}
			break;
		case SKIP_TO_BOOKMARK: 
			TAP_SPrint(buffer, " %s", skip_to_bookmark ? on_t : off_t); break;
			break;
		case DISPLAY_TOPPY_ARCHIVE: 
			TAP_SPrint(buffer, " %s", display_toppy_archive ? on_t : off_t); break;
			break;
		case OVERNIGHT_THUMBS_TIME:
			hour = overnight_thumbs_time / 60;
			min  = overnight_thumbs_time % 60;
			TAP_SPrint(buffer, " %02d:%02d", hour, min);
			break;
		case ENABLE_STOP_MENU: 
			switch (enable_stop_menu)
			{
				case OFF:	TAP_SPrint(buffer, " %s", off_t); break;
				case 1:		TAP_SPrint(buffer, " %s (%s)", on_t, delete_t); break;
				case 2:		TAP_SPrint(buffer, " %s (%s)", on_t, stop_t); break;
				case 3:		TAP_SPrint(buffer, " %s", smart_t); break;
			}
			break;
		case STOP_MENU_PERCENTAGE:
			TAP_SPrint(buffer, " %d%s %s", stop_menu_percentage, "%", of_video_watched_t);
			break;
		case ENABLE_RECYCLE_BIN: 
			TAP_SPrint(buffer, " %s", enable_recycle_bin ? on_t : off_t);
			break;
		case EMPTY_BIN_PERCENTAGE: 
			TAP_SPrint(buffer, " %d%s %s", empty_bin_percentage, "%", full_t);
			break;
		case WATCHED_ICON_PERCENTAGE: 
			TAP_SPrint(buffer, " %d%s %s", watched_icon_percentage, "%", watched_t);
			break;
		case EMPTY_BIN_DAYS: 
			TAP_SPrint(buffer, " %d %s", empty_bin_days, days_t);
			break;
		case RECYCLE_BY_DELETION_DATE: 
			TAP_SPrint(buffer, " %s", recycle_by_deletion_date ? use_deletion_date_t : use_creation_date_t);
			break;
		case RECURSE_SUBFOLDERS:
			TAP_SPrint(buffer, " %s", recurse_subfolders ? on_t : off_t);
			break;
		case FOLDER_PREVIEW:
			TAP_SPrint(buffer, " %s", folder_preview ? on_t : off_t);
			break;
		case AUTO_RENAME_RULE:
			switch (auto_rename_rule)
			{
				case OFF:								TAP_SPrint(buffer, " %s", off_t); break;
				case RENAME_BY_NUMBER:					TAP_SPrint(buffer, " %s", by_number_t); break;
				case RENAME_BY_DATE:					TAP_SPrint(buffer, " %s", by_date_if_clash_t); break;
				case RENAME_BY_DATE_AND_TIME:			TAP_SPrint(buffer, " %s", by_date_and_time_if_clash_t); break;
				case RENAME_BY_DATE_ALWAYS:				TAP_SPrint(buffer, " %s", by_date_always_t); break;
				case RENAME_BY_DATE_AND_TIME_ALWAYS:	TAP_SPrint(buffer, " %s", by_date_and_time_always_t); break;
			}
			break;
		case DISABLE_FOLDER_COUNT: 
			TAP_SPrint(buffer, " %s", disable_folder_count ? on_t : off_t);
			break;
		case HIDE_EMPTY_FOLDERS: 
			TAP_SPrint(buffer, " %s", hide_empty_folders ? on_t : off_t);
			break;
		case SHOW_HEADER_ICONS: 
			TAP_SPrint(buffer, " %s", show_header_icons ? on_t : off_t);
			break;
		case FILE_ICONS_LEFT_ALIGNED: 
			TAP_SPrint(buffer, " %s", file_icons_left_aligned ? left_t : right_t);
			break;
		case DISABLE_THUMBNAILS: 
			TAP_SPrint(buffer, " %s", disable_thumbnails ? on_t : off_t);
			break;
		case DISABLE_FILE_DETAILS: 
			TAP_SPrint(buffer, " %s", disable_file_details ? on_t : off_t);
			break;
		case DISK_SPACE_FORMAT: 
			switch (disk_space_format)
			{
				case PERCENTAGE_USED:		TAP_SPrint(buffer, " %s", percentage_used_t); break;
				case GB_USED:				TAP_SPrint(buffer, " %s", gigabytes_used_t); break;
				case PERCENTAGE_FREE:		TAP_SPrint(buffer, " %s", percentage_free_t); break;
				case GB_FREE:				TAP_SPrint(buffer, " %s", gigabytes_free_t); break;
				case PERCENTAGE_USED_LARGE:	TAP_SPrint(buffer, " %s %s", percentage_used_t, "(Big font)"); break;
				case GB_USED_LARGE:			TAP_SPrint(buffer, " %s %s", gigabytes_used_t, "(Big font)"); break;
				case PERCENTAGE_FREE_LARGE:	TAP_SPrint(buffer, " %s %s", percentage_free_t, "(Big font)"); break;
				case GB_FREE_LARGE:			TAP_SPrint(buffer, " %s %s", gigabytes_free_t, "(Big font)"); break;
			}
			break;
		case GRADIENT_INCREMENT: 
			TAP_SPrint(buffer, " %d", gradient_increment);
			break;
		case TWO_TONE_INCREMENT: 
			TAP_SPrint(buffer, " %d", two_tone_increment);
			break;
		case PAGE_WITH_ARROWS: 
			TAP_SPrint(buffer, " %s", page_with_arrows ? "< & >" : "<< & >>");
			break;
		case PHOTO_ORDERING_MODE:
			switch (photo_ordering_mode)
			{
				case ORDER_BY_DATE:			TAP_SPrint(buffer, " %s", by_date_option_t); break;
				case ORDER_BY_NAME:			TAP_SPrint(buffer, " %s", by_name_option_t); break;
				case ORDER_BY_DATE_DESC:	TAP_SPrint(buffer, " %s", by_rev_date_option_t); break;
				case ORDER_BY_NAME_DESC:	TAP_SPrint(buffer, " %s", by_rev_name_option_t); break;
			}
			break;
		case MUSIC_ORDERING_MODE:
			switch (music_ordering_mode)
			{
				case ORDER_BY_DATE:			TAP_SPrint(buffer, " %s", by_date_option_t); break;
				case ORDER_BY_NAME:			TAP_SPrint(buffer, " %s", by_name_option_t); break;
				case ORDER_BY_DATE_DESC:	TAP_SPrint(buffer, " %s", by_rev_date_option_t); break;
				case ORDER_BY_NAME_DESC:	TAP_SPrint(buffer, " %s", by_rev_name_option_t); break;
			}
			break;
		case VIDEO_ORDERING_MODE:
			switch (video_ordering_mode)
			{
				case ORDER_BY_DATE:			TAP_SPrint(buffer, " %s", by_date_option_t); break;
				case ORDER_BY_NAME:			TAP_SPrint(buffer, " %s", by_name_option_t); break;
				case ORDER_BY_SIZE:			TAP_SPrint(buffer, " %s", by_size_option_t); break;
				case ORDER_BY_DATE_DESC:	TAP_SPrint(buffer, " %s", by_rev_date_option_t); break;
				case ORDER_BY_NAME_DESC:	TAP_SPrint(buffer, " %s", by_rev_name_option_t); break;
				case ORDER_BY_SIZE_DESC:	TAP_SPrint(buffer, " %s", by_rev_size_option_t); break;
			}
			break;
		case RECYCLE_ORDERING_MODE:
			switch (recycle_ordering_mode)
			{
				case ORDER_BY_DATE:					TAP_SPrint(buffer, " %s", by_date_option_t); break;
				case ORDER_BY_NAME:					TAP_SPrint(buffer, " %s", by_name_option_t); break;
				case ORDER_BY_DATE_DESC:			TAP_SPrint(buffer, " %s", by_rev_date_option_t); break;
				case ORDER_BY_NAME_DESC:			TAP_SPrint(buffer, " %s", by_rev_name_option_t); break;
			}
			break;
		case FILE_LIST_X: 
			TAP_SPrint(buffer, " %d", X);
			break;
		case FILE_LIST_Y: 
			TAP_SPrint(buffer, " %d", Y);
			break;		
		case OFFSET_X:
			TAP_SPrint(buffer, " %d", offset_x);
			break;
		case OFFSET_Y:
			TAP_SPrint(buffer, " %d", offset_y);
			break;
		case THUMBNAIL_OFFSET_X:
			TAP_SPrint(buffer, " %d", thumbnail_offset_x);
			break;
		case THUMBNAIL_OFFSET_Y:
			TAP_SPrint(buffer, " %d", thumbnail_offset_y);
			break;
		case SHOW_ALL_FILES_ACTIVATION_KEY:
			switch (show_all_files_activation_key)
			{
				case RKEY_None:		TAP_SPrint(buffer, " %s", none_t); break;
				case RKEY_Pip:		TAP_SPrint(buffer, " %s", PiP_t); break;
				case RKEY_PipSwap:	TAP_SPrint(buffer, " %s", PiP_swap_t); break;
			}
			break;
		case WRITE_LOG:
			TAP_SPrint(buffer, " %s", write_log ? on_t : off_t);
			break;
		case VERBOSE:
			TAP_SPrint(buffer, " %s", verbose ? verbose_t : scant_t);
			break;
		case SKIN_FILE_NAME:
			memset(buffer2, '\0', 100);
			strncat(buffer2, skin_file_name, strlen(skin_file_name)-4);
			TAP_SPrint(buffer, " %s", buffer2);
			break;
		case FONT_NAME:
			memset(buffer2, '\0', 100);
			strncat(buffer2, font_name, strlen(font_name));
			if (strcmp(font_name, "Default") != 0) {
				TAP_SPrint(buffer3, " (%dS, %dM, %dL)", fonts[current_font].small_font ? fonts[current_font].small_font->m_fontHeight : 0, fonts[current_font].medium_font ? fonts[current_font].medium_font->m_fontHeight : 0, fonts[current_font].large_font ? fonts[current_font].large_font->m_fontHeight : 0);
				strcat(buffer2, buffer3);
			}
			TAP_SPrint(buffer, " %s", buffer2);
			break;
		case SHOW_REMAINING_HOURS:
			TAP_SPrint(buffer, " %s", show_remaining_hours ? on_t : off_t);
			break;
		case SHOW_LAST_PLAYED_ICON:
			TAP_SPrint(buffer, " %s", show_last_played_icon ? on_t : off_t);
			break;
		case FULL_SIZE_DISPLAY:
			TAP_SPrint(buffer, " %s", full_size_display ? on_t : off_t);
			break;
		case FOLDERS_AT_END:
			TAP_SPrint(buffer, " %s", folders_at_end ? on_t : off_t);
			break;
		case HIDE_TOP_LEVEL_PARENT:
			switch (hide_top_level_parent) {
				case OFF:		TAP_SPrint(buffer, " %s", off_t); break;
				case DATAFILES: TAP_SPrint(buffer, " %s %s", when_in_t, "\\DataFiles"); break;
				case ALWAYS:	TAP_SPrint(buffer, " %s", always_t); break;
			}
			break;
		case MEGABYTES_PER_HOUR:
			TAP_SPrint(buffer, " %d", megabytes_per_hour);
			break;
		case DISCARD_NAVIGATION_HISTORY:
			TAP_SPrint(buffer, " %s", discard_navigation_history ? on_t : off_t);
			break;
		case ENABLE_COMPONENT_SWITCHING:
			switch (enable_component_switching) {
				case OFF:		TAP_SPrint(buffer, " %s", off_t); break;
				case DATAFILES: TAP_SPrint(buffer, " %s %s", with_t, " < & >"); break;
				case ALWAYS:	TAP_SPrint(buffer, " %s %s", with_t, " >"); break;
			}
			break;
		case TEXT_JUSTIFICATION:
			switch (text_justification)
			{
				case FULLY_JUSTIFY:					TAP_SPrint(buffer, " %s", fully_justify_t); break;
				case LEFT_JUSTIFY:					TAP_SPrint(buffer, " %s", left_justify_t); break;
			}
			break;
		case MP3_END_MODE:
			switch (mp3_end_mode)
			{
				case STOP_ALBUM:					TAP_SPrint(buffer, " %s", stop_t); break;
				case NEXT_ALBUM:					TAP_SPrint(buffer, " %s", next_album_t); break;
				case REPEAT_ALBUM:					TAP_SPrint(buffer, " %s", repeat_t); break;
			}
			break;
		case ORDER_BY_TRACK_NUMBER: 
			TAP_SPrint(buffer, " %s", order_by_track_number ? on_t : off_t);
			break;
		case PRELOAD_MP3_HEADERS: 
			switch (preload_mp3_headers) {
				case OFF:							TAP_SPrint(buffer, " %s", off_t); break;
				case HEADERS:						TAP_SPrint(buffer, " %s", file_name_t); break;
				case HEADERS_AND_THUMBNAILS:		TAP_SPrint(buffer, " %s + %s", file_name_t, id3_info_t); break;
				case HEADERS_LAZY:					TAP_SPrint(buffer, " %s (%s)", file_name_t, lazy_t); break;
				case HEADERS_AND_THUMBNAILS_LAZY:	TAP_SPrint(buffer, " %s + %s (%s)", file_name_t, id3_info_t, lazy_t); break;
			}
			break;
		case PAUSED_MODE: 
			switch (paused_mode)
			{
				case OFF:			TAP_SPrint(buffer, " %s", off_t); break;
				case SLIDESHOW:		TAP_SPrint(buffer, " %s", slideshow_t); break;
				case SCREENSAVER1:	TAP_SPrint(buffer, " %s", screensaver_1_t); break;
				case SCREENSAVER2:	TAP_SPrint(buffer, " %s", screensaver_2_t); break;
				case SCREENSAVER3:	TAP_SPrint(buffer, " %s", screensaver_3_t); break;
				case SCREENSAVER4:	TAP_SPrint(buffer, " %s", screensaver_4_t); break;
				case SCREENSAVER5:	TAP_SPrint(buffer, " %s", screensaver_5_t); break;
			}
			break;
		case PAUSED_DELAY: 
			TAP_SPrint(buffer, " %d", paused_delay);
			break;
		case BURNOUT_DELAY:
			if (burnout_delay)
				TAP_SPrint(buffer, " %d %s", burnout_delay, seconds_t);
			else 
				TAP_SPrint(buffer, " %s", off_t);
			break;
		case USE_NUMBERS_TO_SEARCH:
			TAP_SPrint(buffer, " %s", use_numbers_to_search ? on_t : off_t);
			break;
		case TIDY_HARD_DISK:
			TAP_SPrint(buffer, " %s", press_recall_t);
			break;
		case RELOAD_SKINS:
			TAP_SPrint(buffer, " %s", press_ok_t);
			break;
		case RUN_VIDEO_JOB:
			TAP_SPrint(buffer, " %s", press_ok_t);
			break;
		case RELOAD_MP3_HEADERS:
			TAP_SPrint(buffer, " %s", press_ok_t);
			break;
		case EXIT_TAP:
			TAP_SPrint(buffer, " %s", press_ok_t);
			break;
	}

	drawText(region_mem, X+W-247, Y+y+3, X+W+5-3, buffer, fc, body_bg_colour, FNT_Size_1622);

	if (data_idx == OVERNIGHT_COPY) { 
		switch (overnight_copy)
		{
			case AUTO_COPY:	
				drawText(region_mem, X+W-50+15, Y+y+3, X+W+5-3, "$", COLOR_Yellow, body_bg_colour, FNT_Size_1622);
				drawText(region_mem, X+W-50+30, Y+y+3, X+W+5-3, "$", RGB8888(255,75,15), body_bg_colour, FNT_Size_1622);
				break;
			case AUTO_COPY_ALL:	
				drawText(region_mem, X+W-50, Y+y+3, X+W+5-3, "$", COLOR_Yellow, body_bg_colour, FNT_Size_1622);
				drawText(region_mem, X+W-50+15, Y+y+3, X+W+5-3, "$", RGB8888(255,75,15), body_bg_colour, FNT_Size_1622);
				drawText(region_mem, X+W-50+30, Y+y+3, X+W+5-3, "$", COLOR_Green, body_bg_colour, FNT_Size_1622);
				break;
		}
	}
}

void drawOptions(word start)
{
	int i;
	int finish;
	finish = (NUMBER_OF_OPTIONS > 10) ? 10 : NUMBER_OF_OPTIONS;
	for(i = 0; i < finish; i++)
	{
		drawOption(i, start + i);
	}
}

void drawOptionsFooter()
{
	char info_line[80], word_in_line[40];
	word line_pointer, i=0, line_characters, pixels_left, word_count, pixel_skip, pixel_remainder;
	int info_offset_x = X+5;
	int info_offset_y = Y+340, max_info_length;
	info_pointer = 0;

	TAP_Osd_FillBox(region_mem, X, Y+320+3, W+5, 120+7+1, footer_bg_colour);

	max_info_length = strlen(options_help[curr_idx]);
	while (max_info_length > info_pointer && i < 4) {
		// get the next line for display
		getInfoLine(info_line, &info_pointer, options_help[curr_idx], W-20, FNT_Size_1622);
		
		info_offset_x = X+5;
		if (info_pointer >= max_info_length || text_justification == LEFT_JUSTIFY)
			// last line so dump it as it is
			drawText(region_mem, info_offset_x, info_offset_y, X+W-5, info_line, body_text_colour, COLOR_None, FNT_Size_1622);
		else {
			// calculate number of characters/words in line
			line_characters = strlen(info_line);
			pixels_left = W-15 - getWidth(info_line, FNT_Size_1622);
			line_pointer = 0; 
			word_count = countWordsInLine(info_line);

			// calculate the number of pixels to add between words to stretch the line to the end of display
			pixel_skip = pixels_left / (word_count-1); 
			pixel_remainder = pixels_left % (word_count-1);

			// draw one word at a time
			while (strlen(info_line) >= line_pointer) {
				getWordInLine(info_line, word_in_line, &line_pointer);
				drawText(region_mem, info_offset_x, info_offset_y, X+W-5, word_in_line, body_text_colour, COLOR_None, FNT_Size_1622);

				// calculate the next word position, add on any leftover pixels one at a time until all gone
				info_offset_x += getWidthRounded(word_in_line, FNT_Size_1622, FALSE);
				info_offset_x += pixel_skip;
				if (pixel_remainder > 0) {
					info_offset_x++; 
					pixel_remainder--;
				}
			}
		}
		info_offset_y += 22;
		i++;
	}
}

void drawOptionsMenu(int idx, int highlight, bool draw_background)
{
	dword string_length;
	word indent, x = X, y = Y, w = W, h = H;

	drawBlankFileList(10);

	// header section
	TAP_Osd_FillBox( region_mem, x, y, w, 30, header_bg_colour);

	// vertical dividers
	TAP_Osd_FillBox(region_mem, x+30, Y+30, 2, 321-30, frame_colour );
	TAP_Osd_FillBox(region_mem, x+w-250, Y+30, 2, 321-30, frame_colour );

	// header text
	TAP_Osd_PutGd(region_mem, X+10, Y, &_spannerGd, TRUE);
	TAP_SPrint(buffer, "%s%d %s", options_menu_all_t, computeNumberOfOptions(), of_them_t);
	string_length = getWidth(buffer, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, -1, buffer, header_text_colour, header_bg_colour, FNT_Size_1926);

	curr_idx = idx;
	curr_highlight = highlight;
	drawOptions(curr_idx-curr_highlight);

	// populate the footer box
	drawOptionsFooter();

	updateOptionCount();

	if (draw_background)
		drawRoundedRectangle(region, x, y, w, h, 3, 10, 30, 122, frame_colour, COLOR_None, body_bg_colour, FALSE);
}

void drawInfoLine(int line_number)
{
	drawText(region_mem, info_x_offset+8, info_y_offset+29+8+((line_number)*20), info_x_offset+1+info_width-2, photo_exif[line_number].heading, info_header_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, info_x_offset+8+150, info_y_offset+29+8+((line_number)*20), info_x_offset+1+info_width-2, photo_exif[line_number].detail, info_detail_colour, COLOR_None, FNT_Size_1622);
}

void drawInfoLines()
{
	int i = 0, finish = no_of_details > 20 ? 20 : no_of_details;

	for (i = 0; i < finish; i++)
	{
		drawInfoLine(i);
	}
}

void drawInfoViewerHeader(void)
{
	dword string_length;
	word indent;

	TAP_Osd_FillBox(region_mem, info_x_offset, info_y_offset, info_width, 30, header_bg_colour);

	TAP_SPrint(buffer, "%s", dir_info[curr_idx]->file_name);

	string_length = getWidth(buffer, FNT_Size_1926);
	if (string_length > info_width-2) string_length = info_width-2;
	indent = info_x_offset + ((info_width - string_length) / 2);
	drawText(region_mem, indent, info_y_offset+2, info_x_offset+info_width-2, buffer, header_text_colour, COLOR_None, FNT_Size_1926);
}

void drawBlankInfoViewer()
{
	// fill whole area
	TAP_Osd_FillBox(region_mem, info_x_offset-5, info_y_offset+30+3, info_width+10+1, info_height-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, info_x_offset-5, info_y_offset+30, info_width+10+1, 3, frame_colour);
}

int calculateInfoXWidth()
{
	int max_detail_width = 0, i;
	for (i = 0; i < no_of_details; i++)
	{
		if (getWidth(photo_exif[i].detail, FNT_Size_1622) > max_detail_width)
			max_detail_width = getWidth(photo_exif[i].detail, FNT_Size_1622);
	}

	return max_detail_width+150+18;
}

void drawInfoViewer()
{
	word x, y, w, h;

	info_save = TAP_Osd_SaveBox(region, X, Y, W, H);

	info_width = calculateInfoXWidth();
	info_height = (no_of_details > 20 ? 20 : no_of_details * 20) + 48;
	info_x_offset = (720 - (12+info_width)) / 2;
	info_y_offset = (576 - (29+8+info_height)) / 2;
	
	x = info_x_offset, y = info_y_offset, w = info_width, h = info_height;

	TAP_ExitNormal();

	// draw window
	drawBlankInfoViewer();
	
	// header section
	drawInfoViewerHeader();

	// draw lines
	drawInfoLines();

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void drawAutoDeleteUpdateBoxLine(int data_idx)
{
	int y;
	dword fc;

	y = 30 + (data_idx * 29) + 3;

	if (data_idx == auto_delete_update_highlight) {
		initialiseLine(X+40-5, Y+y, W-80+10+1, 26, auto_del_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
	}
	else {
		initialiseLine(X+40-5, Y+y, W-80+10+1, 26, auto_del_background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
	}

	TAP_Osd_FillBox(region_mem, X+40+200, Y+y, 2, 26, frame_colour);

	switch (data_idx) {
		case 0:
			TAP_SPrint(buffer, "%s", name_to_delete_t);
			drawText(region_mem, X+40, Y+y+3, X+40+200-1, buffer, fc, COLOR_None, FNT_Size_1622);
			if (strcmp(auto_delete_list[auto_delete_idx]->file_name, "*") == 0)
				TAP_SPrint(buffer, "All videos in \\DataFiles", auto_delete_list[auto_delete_idx]->file_name);
			else
				TAP_SPrint(buffer, "%s", auto_delete_list[auto_delete_idx]->file_name);
			drawText(region_mem, X+40+200+2+5, Y+y+3, X+40+W-80-1, buffer, fc, COLOR_None, FNT_Size_1622);
			break;
		case 1:
			TAP_SPrint(buffer, "%s", delete_after_t);
			drawText(region_mem, X+40, Y+y+3, X+40+200-1, buffer, fc, COLOR_None, FNT_Size_1622);
			TAP_SPrint(buffer, "%d %s", auto_delete_list[auto_delete_idx]->delete_after_days, days_t);
			drawText(region_mem, X+40+200+2+5, Y+y+3, X+40+W-80-1, buffer, fc, COLOR_None, FNT_Size_1622);
			break;
		case 2:
			TAP_SPrint(buffer, "%s", keep_at_least_t);
			drawText(region_mem, X+40, Y+y+3, X+40+200-1, buffer, fc, COLOR_None, FNT_Size_1622);
			TAP_SPrint(buffer, "%d %s", auto_delete_list[auto_delete_idx]->delete_after_min, episodes_t);
			drawText(region_mem, X+40+200+2+5, Y+y+3, X+40+W-80-1, buffer, fc, COLOR_None, FNT_Size_1622);
			break;
		case 3:
			TAP_SPrint(buffer, "%s", keep_at_most_t);
			drawText(region_mem, X+40, Y+y+3, X+40+200-1, buffer, fc, COLOR_None, FNT_Size_1622);
			TAP_SPrint(buffer, "%d %s", auto_delete_list[auto_delete_idx]->delete_after_max, episodes_t);
			drawText(region_mem, X+40+200+2+5, Y+y+3, X+40+W-80-1, buffer, fc, COLOR_None, FNT_Size_1622);
			break;
		case 4:
			TAP_SPrint(buffer, "%s", delete_when_disk_t);
			drawText(region_mem, X+40, Y+y+3, X+40+200-1, buffer, fc, COLOR_None, FNT_Size_1622);
			TAP_SPrint(buffer, "%d%s %s", auto_delete_list[auto_delete_idx]->delete_when_disk, "%", full_t);
			drawText(region_mem, X+40+200+2+5, Y+y+3, X+40+W-80-1, buffer, fc, COLOR_None, FNT_Size_1622);
			break;
		case 5:
			drawText(region_mem, X+40, Y+y+3, X+40+200-1, save_and_exit_t, fc, COLOR_None, FNT_Size_1622);
			drawText(region_mem, X+40+200+2+5, Y+y+3, X+40+W-80-1, press_ok_t, fc, COLOR_None, FNT_Size_1622);
			break;
	}
}

void drawAutoDeleteUpdateBoxLines()
{
	int i;

	// draw each line
	for(i = 0; i < no_of_delete_options; i++)
	{
		drawAutoDeleteUpdateBoxLine(i);
	}
}

void drawAutoDeleteUpdateBox()
{
	word i, j, string_length, indent;
	word x = X+40, y = Y, w = W-80, h = 442;
	
	TAP_ExitNormal();
	
	// fill whole area
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	TAP_SPrint(buffer, "%s", "Auto delete rules");
	string_length = getWidth(buffer, FNT_Size_1926);
	if (string_length > w-2) string_length = w-2;
	indent = x + ((w - string_length) / 2);
	drawText(region_mem, indent, y, x+w-2, buffer, header_text_colour, COLOR_None, FNT_Size_1926);

	j = 30;
	for (i = 0; i < no_of_delete_options; i++)
	{
		TAP_Osd_FillBox(region_mem, x-5, y+j, w+10+1, 3, frame_colour);
		j += 3;

		initialiseLine(x-5, y+j, w+10+1, 26, auto_del_background_gradient, body_bg_colour, tt_body_bg_colour);
		j += 26;
	}
	TAP_Osd_FillBox(region_mem, x-5, y+j, w+10+1, 3, frame_colour);

	// vertical divider
	TAP_Osd_FillBox(region_mem, x+200, y+30, 2, 3+(29*no_of_delete_options), frame_colour);

	// draw lines
	drawAutoDeleteUpdateBoxLines();

	drawRoundedRectangle(region, x, y, w, h, 3, no_of_delete_options, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	copyMemoryToRecInfoViewer();
}

void drawRecDetailLines(int scroll_type)
{
	char info_line[80], word_in_line[40];
	word line_pointer, i=0, j, line_characters, pixels_left, word_count, pixel_skip, pixel_remainder, blank_lines;
	int info_offset_x = X+40+5;
	int info_offset_y = info_start_pixel, max_info_length, actual_lines;
	bool break_line;

	// if scrolling, then copy the text we want to keep - TODO
	/*switch (scroll_type) {
		case SCROLL_DOWN:
			TAP_Osd_Copy(region, region, X, info_offset_y+22, W, 22*9, X, info_offset_y, FALSE);
			break;
		case SCROLL_UP:
			TAP_Osd_Copy(region, region, X, info_offset_y, W, 22*9, X, info_offset_y+22, FALSE);
			break;
	}*/

	TAP_Osd_FillBox(region_mem, X+40-5, info_offset_y, W-80+10+1, (22*info_lines)+12, body_bg_colour);

	actual_lines = video_info_format == ALL ? (smaller_font ? info_lines + 3 : info_lines) : (smaller_font ? info_lines + 4 : info_lines);
	max_info_length = strlen(extInfo);

	while (max_info_length > info_pointer && i < actual_lines) {
		// get the next line for display
		break_line = getInfoLine(info_line, &info_pointer, extInfo, W-80-20, smaller_font ? FNT_Size_1419 : FNT_Size_1622);

		// save the pointer for the second line in case we need to scroll down
		//if (i == 0) info_second_line_pointer = info_pointer;

		info_offset_x = X+40+5;
		blank_lines = strlen(info_line) == 0 ? blank_lines + 1 : 0;

		if (blank_lines > 1) continue;

		if (info_pointer >= max_info_length || break_line || text_justification == LEFT_JUSTIFY)
			// last line so dump it as it it
			drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-5, info_line, info_detail_colour, body_bg_colour, (smaller_font ? FNT_Size_1419 : FNT_Size_1622));
		else {
			// calculate number of characters/words in line
			line_characters = strlen(info_line);
			pixels_left = W-80-15 - getWidth(info_line, smaller_font ? FNT_Size_1419 : FNT_Size_1622);
			line_pointer = 0; j = 0;
			word_count = countWordsInLine(info_line);

			// calculate the number of pixels to add between words to stretch the line to the end of display
			pixel_skip = pixels_left / (word_count-1); 
			pixel_remainder = pixels_left % (word_count-1);

			// draw one word at a time
			while (strlen(info_line) >= line_pointer) {
				getWordInLine(info_line, word_in_line, &line_pointer);
				drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-5, word_in_line, info_detail_colour, body_bg_colour, (smaller_font ? FNT_Size_1419 : FNT_Size_1622));

				// calculate the next word position, add on any leftover pixels one at a time until all gone
				info_offset_x += getWidthRounded(word_in_line, smaller_font ? FNT_Size_1419 : FNT_Size_1622, FALSE);
				info_offset_x += pixel_skip;
				if (pixel_remainder > 0) {
					info_offset_x++; 
					pixel_remainder--;
				}
				j++;
			}
		}
		info_offset_y += smaller_font ? 18 : 22;
		i++;

		/*if (break_line) {
			info_offset_y += 22;
			i++;
		}*/
	}

	// if not first page then signify this with <
	if (page_number > 0)
		drawText(region_mem, X+40-5, info_start_pixel+2, -1, "<", body_text_colour, body_bg_colour, FNT_Size_1419);

	// if still more to show then signify this with >
	if (info_pointer < max_info_length)
		drawText(region_mem, X+40+W-80+5-12, info_offset_y-22+2, -1, ">", body_text_colour, body_bg_colour, FNT_Size_1419);
}

void formatDuration(char *text, word duration_hour, word duration_min)
{
	if (duration_hour > 1) {
		if (duration_min > 0)
			TAP_SPrint(text, "%d %s %d %s", duration_hour, hours_t, duration_min, mins_t);
		else
			TAP_SPrint(text, "%d %s", duration_hour, hours_t);
	}
	ef (duration_hour > 0) {
		if (duration_min > 0)
			TAP_SPrint(text, "%d %s %d %s", duration_hour, hour_t, duration_min, mins_t);
		else
			TAP_SPrint(text, "%d %s", duration_hour, hour_t);
	}
	else
		TAP_SPrint(text, "%d %s", duration_min, mins_t);
}

void formatFileSize(dword *mb, int duration)
{
	int expected_mb = duration * (megabytes_per_hour ? megabytes_per_hour : (isTF5800() ? 30 : 50));

	if (*mb == 0)
		return;

	if (*mb < expected_mb) {
		if ((expected_mb - *mb)	>= (1024 * 23))
			*mb += (1024 * 24);
		ef ((expected_mb - *mb)	>= (1024 * 19))
			*mb += (1024 * 20);
		ef ((expected_mb - *mb)	>= (1024 * 15))
			*mb += (1024 * 16);
		ef ((expected_mb - *mb)	>= (1024 * 11))
			*mb += (1024 * 12);
		ef ((expected_mb - *mb)	>= (1024 * 7))
			*mb += (1024 * 8);
		ef ((expected_mb - *mb)	>= (1024 * 3))
			*mb += (1024 * 4);
	}
}

bool isRadioRecording(int idx)
{
	if (dir_info[idx]->radio 
			|| (isTF5800() 
				&& TAP_Channel_GetInfo(dir_info[idx]->service_type, dir_info[idx]->service_num, &channel_info) == 1
				&& channel_info.logicalChNum >= 700 && channel_info.logicalChNum < 800))
		return TRUE;

	return FALSE;
}

void drawRecInfoLines()
{
	TYPE_PlayInfo play_info;
	TYPE_RecInfo rec_info_1, rec_info_2;
	int i = 0, duration, recorded_sec;
	dword current_block, total_block, file_size = 0;
	word info_offset_y, info_offset_x;

	strcpy(eventDescName, "");
	strcpy(extInfo, "");
	strcpy(serviceName, "");
	duration = 0; mjd = 0; eventStartHour = 0; eventEndHour = 0; eventStartMin = 0; eventEndMin = 0;

	TAP_Hdd_GetPlayInfo(&play_info);
	TAP_Hdd_GetRecInfo(0, &rec_info_1);
	TAP_Hdd_GetRecInfo(1, &rec_info_2);

	// populate required fields either from header, or from play/rec info
	strcpy(extInfo,		dir_info[curr_idx]->description);
	strcpy(serviceName, dir_info[curr_idx]->service_name);
	mjd				= dir_info[curr_idx]->mjd;
	file_size		= dir_info[curr_idx]->size;
	eventStartHour	= dir_info[curr_idx]->event_start_hour;
	eventStartMin	= dir_info[curr_idx]->event_start_min;
	eventEndHour	= dir_info[curr_idx]->event_end_hour;
	eventEndMin		= dir_info[curr_idx]->event_end_min;

	if (play_info.file && play_info.playMode == PLAYMODE_Playing 
			&& strcmp(play_info.file->name, dir_info[curr_idx]->file_name) == 0
			&& play_info.file->startCluster == dir_info[curr_idx]->start_cluster) {
		duration = play_info.duration;
		current_block = play_info.currentBlock;
		total_block = play_info.totalBlock;
	}	
	ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0) {
		duration = rec_info_1.duration;
		recorded_sec = rec_info_1.recordedSec;
	}			
	ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0) {
		duration = rec_info_2.duration;
		recorded_sec = rec_info_2.recordedSec;
	}
	else {
		if (dir_info[curr_idx]->duration == 0 && dir_info[curr_idx]->attr != 0)
			LoadHeaderInfo(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, curr_dir, curr_idx, FALSE);
		current_block = getCurrentBlock(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster);
		total_block = getTotalBlock(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster);
		duration = dir_info[curr_idx]->duration;
	}

	// initialise offsets
	info_offset_y = Y+30+10;
	info_offset_x = X+40+5;

	if (video_info_format == ALL) {
		// channel name
		drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-2, channel_t, info_header_colour, body_bg_colour, FNT_Size_1622);
		drawText(region_mem, info_offset_x+100, info_offset_y, X+40+W-80-2, serviceName, info_detail_colour, body_bg_colour, FNT_Size_1622);
		info_offset_y += 25;

		// date/time stamp
		drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-2, date_time_t, info_header_colour, body_bg_colour, FNT_Size_1622);
		if (mjd == 0) 
			TAP_SPrint(buffer, invalid_date_and_time_t);
		else {
			formatDateString(mjd, buffer, TRUE);
			TAP_SPrint(buffer, "%s, %02d:%02d", buffer, dir_info[curr_idx]->hour, dir_info[curr_idx]->min);
		}
		drawText(region_mem, info_offset_x+100, info_offset_y, X+40+W-80-2, buffer, info_detail_colour, body_bg_colour, FNT_Size_1622);
		info_offset_y += 25;

		// programme time
		drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-2, event_time_t, info_header_colour, body_bg_colour, FNT_Size_1622);
		TAP_SPrint(buffer, "%02d:%02d ~ %02d:%02d", eventStartHour, eventStartMin, eventEndHour, eventEndMin);
		drawText(region_mem, info_offset_x+100, info_offset_y, X+40+W-80-2, buffer, info_detail_colour, body_bg_colour, FNT_Size_1622);
		info_offset_y += 25;

		// duration
		drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-2, length_t, info_header_colour, body_bg_colour, FNT_Size_1622);
		if (duration > 119)
			TAP_SPrint(buffer, "%d %s %d %s", duration / 60, hours_t, duration % 60, mins_t);
		ef (duration > 59)
			TAP_SPrint(buffer, "%d %s %d %s", duration / 60, hour_t, duration % 60, mins_t);
		else
			TAP_SPrint(buffer, "%d %s", duration, mins_t);
		drawText(region_mem, info_offset_x+100, info_offset_y, X+40+W-80-2, buffer, info_detail_colour, body_bg_colour, FNT_Size_1622);

		// file size
		if (file_size > 0) {
			dword mb = 0;
			mb = file_size / 1048576;
			if (!isRadioRecording(curr_idx) && (duration > 0))
				formatFileSize(&mb, duration);
			TAP_SPrint(buffer2, "(%d MB)", mb);
			drawText(region_mem, info_offset_x+100+getWidth(buffer, FNT_Size_1622)+10, info_offset_y, X+40+W-80-2, buffer2, info_detail_colour, body_bg_colour, FNT_Size_1622);
		}

		info_offset_y += 25;
		info_lines = 11;

		// viewed/recorded percentage
		if (IsDataFilesFolder(curr_dir) 
				&& (strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0 
					|| strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0)) {
			drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-2, recorded_capital_t, info_header_colour, body_bg_colour, FNT_Size_1622);
			TAP_SPrint(buffer, "%d%s", recorded_sec/60*100 / duration, "%");
			drawText(region_mem, info_offset_x+100, info_offset_y, X+40+W-80-2, buffer, info_detail_colour, body_bg_colour, FNT_Size_1622);
			info_offset_y += 25;
			info_lines--;
		}
		ef (total_block > 0) {
			drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-2, watched_capital_t, info_header_colour, body_bg_colour, FNT_Size_1622);
			TAP_SPrint(buffer, "%d%s", current_block*100 / total_block, "%");
			drawText(region_mem, info_offset_x+100, info_offset_y, X+40+W-80-2, buffer, info_detail_colour, body_bg_colour, FNT_Size_1622);
			info_offset_y += 25;
			info_lines--;
		}
		info_offset_y += 20;
	}
	else {
		info_lines = 17;
	}

	// description header
	drawText(region_mem, info_offset_x, info_offset_y, X+40+W-80-2, description_t, info_header_colour, body_bg_colour, FNT_Size_1622);
	
	// now draw the fully justified program description, use the extended info if there, otherwise the short desc 
	info_start_pixel = info_offset_y+25; info_pointer = 0;
	page_number = 0;
	drawRecDetailLines(-1);
}

void drawRecInfoViewerHeader(void)
{
	int string_length;
	word indent;

	TAP_Osd_FillBox(region_mem, X+40, Y, W-80, 30, header_bg_colour);

	string_length = getWidth(dir_info[curr_idx]->sort_name, FNT_Size_1926);
	if (string_length > W-80-2) string_length = W-80-2;
	indent = X+40 + ((W-80 - string_length) / 2);

	switch (display_rec_event_name) {
		case DISPLAY_FILE_NAME:
			memset(buffer, '\0', 100);
			strncat(buffer, dir_info[curr_idx]->file_name, strlen(dir_info[curr_idx]->file_name)-4);
			drawText(region_mem, indent, Y, X+40+W-80-2, buffer, header_text_colour, header_bg_colour, FNT_Size_1926);
			break;

		case DISPLAY_EVENT_NAME:
			drawText(region_mem, indent, Y, X+40+W-80-2, dir_info[curr_idx]->event_name, header_text_colour, header_bg_colour, FNT_Size_1926);
			break;

		case DISPLAY_SORT_NAME:
			drawText(region_mem, indent, Y, X+40+W-80-2, dir_info[curr_idx]->sort_name, header_text_colour, header_bg_colour, FNT_Size_1926);
			break;
	}
}

void drawBlankRecInfoViewer()
{
	// fill whole area
	TAP_Osd_FillBox(region_mem, X+40-5, Y+30+3, W-80+10+1, 442-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, X+40-5, Y+30, W-80+10+1, 3, frame_colour);
}

void drawRecInfoViewer()
{
	word x = X+40, y = Y, w = W-80, h = 442;

	rec_info_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	TAP_ExitNormal();
	
	// draw window
	drawBlankRecInfoViewer();
	
	// header section
	drawRecInfoViewerHeader();

	// draw lines
	drawRecInfoLines();

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	copyMemoryToRecInfoViewer();
}

void drawRecHelpViewer()
{
	int help_x_offset, help_y_offset, indent, string_length;
	word x = X+125, y = Y-10, w = W-250, h = 500;

	help_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	TAP_ExitNormal();

	// fill whole area
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(video_manager_help_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, x+w-2, video_manager_help_t, header_text_colour, COLOR_None, FNT_Size_1926);

	// display standard button help
	help_x_offset = x;
	help_y_offset = y+30+10;
	help_x_offset = x+65 - getWidth(play_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(ok_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, ok_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(stop_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, stop_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	if (page_with_arrows) {
		help_x_offset = x+65 - getWidth("< >", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "< >", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	else {
		help_x_offset = x+65 - getWidth("<< >>", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "<< >>", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	help_x_offset = x+65 - getWidth(info_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, info_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(guide_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, guide_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(tv_sat_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, tv_sat_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(slow_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, slow_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(recall_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, recall_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(tv_radio_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, tv_radio_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(one_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, one_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(two_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, two_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(three_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, three_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(four_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, four_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+65 - getWidth(five_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, five_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawHelpButton(region_mem, x+65-15-13, help_y_offset+3, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 23;
	drawHelpButton(region_mem, x+65-15-13, help_y_offset+3, RGB8888(204,20,20), COLOR_None, OSD_RED); help_y_offset += 23;
	drawHelpButton(region_mem, x+65-15-13, help_y_offset+3, RGB8888(0,224,0), COLOR_None, OSD_GREEN); help_y_offset += 23;
	drawHelpButton(region_mem, x+65-15-13, help_y_offset+3, RGB8888(224,224,0), COLOR_None, OSD_YELLOW); help_y_offset += 23;
	drawHelpButton(region_mem, x+65-15-13, help_y_offset+3, RGB8888(20,20,224), COLOR_None, OSD_BLUE); 
			
	help_x_offset = x+75;
	help_y_offset = y+30+10;
	if (play_resumes_video == 1) {
		drawText(region_mem, help_x_offset, help_y_offset, -1, resume_video_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	else {
		drawText(region_mem, help_x_offset, help_y_offset, -1, play_video_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	if (play_resumes_video) {
		drawText(region_mem, help_x_offset, help_y_offset, -1, change_dir_play_video_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	else {
		drawText(region_mem, help_x_offset, help_y_offset, -1, change_dir_resume_video_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	drawText(region_mem, help_x_offset, help_y_offset, -1, stop_video_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, page_up_down_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, details_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, browse_scenes_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, auto_delete_list_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, update_auto_delete_rules_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, toggle_view_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, "Mark video", info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, create_video_thumbnail_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, create_video_scenes_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_video_thumb_scenes_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_folder_thumbs_scenes_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, create_new_thumbs_scenes_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, rename_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, new_folder_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, move_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, extra_options_t, info_detail_colour, COLOR_None, FNT_Size_1622); 
	
	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}


void drawJpgHelpViewer()
{
	int help_x_offset, help_y_offset, indent, string_length;
	word x = X+125, y = Y-10, w = W-250, h = 500;

	help_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	TAP_ExitNormal();

	// fill whole area
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(photo_manager_help_t, FNT_Size_1926);
	indent = x-5 + ((W-250+10 - string_length) / 2);
	drawText(region_mem, indent, Y-10, x+W-250-2, photo_manager_help_t, header_text_colour, COLOR_None, FNT_Size_1926);

	// display standard button help
	help_y_offset = Y-10+30+10;
	help_x_offset = x+70 - getWidth(play_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(ok_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, ok_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(stop_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, stop_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	if (page_with_arrows) {
		help_x_offset = x+70 - getWidth("< >", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "< >", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	else {
		help_x_offset = x+70 - getWidth("<< >>", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "<< >>", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	help_x_offset = x+70 - getWidth(info_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, info_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(guide_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, guide_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(recall_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, recall_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(record_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, record_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(options_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, options_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(exit_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, exit_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(one_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, one_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(two_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, two_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(three_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, three_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+70 - getWidth(four_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, four_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawHelpButton(region_mem, x+70-15-13, help_y_offset+3, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 23;
	drawHelpButton(region_mem, x+70-15-13, help_y_offset+3, RGB8888(204,20,20), COLOR_None, OSD_RED); help_y_offset += 23;
	drawHelpButton(region_mem, x+70-15-13, help_y_offset+3, RGB8888(0,224,0), COLOR_None, OSD_GREEN); help_y_offset += 23;
	drawHelpButton(region_mem, x+70-15-13, help_y_offset+3, RGB8888(224,224,0), COLOR_None, OSD_YELLOW); help_y_offset += 23;
	drawHelpButton(region_mem, x+70-15-13, help_y_offset+3, RGB8888(20,20,224), COLOR_None, OSD_BLUE); 
			
	help_x_offset = x+80;
	help_y_offset = Y-10+30+10;
	drawText(region_mem, help_x_offset, help_y_offset, -1, start_slideshow_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, change_dir_show_photo_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, stop_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, page_up_down_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, display_exif_info_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, browse_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, toggle_view_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, add_photo_folder_to_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, extra_options_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, return_to_tv_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, associate_photo_with_album_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, associate_photo_with_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_photo_cache_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_folder_cache_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, previous_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, new_folder_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, move_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, next_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); 

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void drawMp3HelpViewer()
{
	int help_x_offset, help_y_offset, indent, string_length;
	word x = X+125, y = Y+20, w = W-250, h = 410;

	help_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	TAP_ExitNormal();

	// fill whole area
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);
	
	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(music_manager_help_t, FNT_Size_1926);
	indent = X+125-5 + ((W-250+10 - string_length) / 2);
	drawText(region_mem, indent, Y+20, X+125+W-250-2, music_manager_help_t, header_text_colour, COLOR_None, FNT_Size_1926);
	
	// display standard button help
	help_x_offset = X+125+20;
	help_y_offset = Y+20+30+10;
	help_x_offset = X+125+75 - getWidth(play_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = X+125+75 - getWidth(ok_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, ok_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = X+125+75 - getWidth(stop_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, stop_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	if (page_with_arrows) {
		help_x_offset = X+125+75 - getWidth("< >", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "< >", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	else {
		help_x_offset = X+125+75 - getWidth("<< >>", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "<< >>", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	help_x_offset = X+125+75 - getWidth(guide_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, guide_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = X+125+75 - getWidth(recall_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, recall_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = X+125+75 - getWidth(record_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, record_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = X+125+75 - getWidth(options_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, options_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = X+125+75 - getWidth(exit_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, exit_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = X+125+75 - getWidth(one_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, one_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = X+125+75 - getWidth(two_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, two_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawHelpButton(region_mem, X+125+75-15-13, help_y_offset+3, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 23;
	drawHelpButton(region_mem, X+125+75-15-13, help_y_offset+3, RGB8888(204,20,20), COLOR_None, OSD_RED); help_y_offset += 23;
	drawHelpButton(region_mem, X+125+75-15-13, help_y_offset+3, RGB8888(0,224,0), COLOR_None, OSD_GREEN); help_y_offset += 23;
	drawHelpButton(region_mem, X+125+75-15-13, help_y_offset+3, RGB8888(224,224,0), COLOR_None, OSD_YELLOW); help_y_offset += 23;
	drawHelpButton(region_mem, X+125+75-15-13, help_y_offset+3, RGB8888(20,20,224), COLOR_None, OSD_BLUE); 
			
	help_x_offset = X+125+85;
	help_y_offset = Y+20+30+10;
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_album_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, change_dir_play_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, stop_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, page_up_down_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, browse_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, toggle_view_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, add_tune_folder_to_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, extra_options_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, return_to_tv_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_art_association_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, rename_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, previous_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, new_folder_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, move_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, next_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622);

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void drawPlaylistHelpViewer()
{
	int help_x_offset, help_y_offset, indent, string_length;
	word x = X+125, y = Y+40, w = W-250, h = 370;

	help_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	TAP_ExitNormal();

	// fill whole area
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(playlist_help_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, x+w-2, playlist_help_t, header_text_colour, COLOR_None, FNT_Size_1926);

	// display standard button help
	help_x_offset = x+20;
	help_y_offset = y+30+10;
	help_x_offset = x+75 - getWidth(play_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(ok_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, ok_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(stop_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, stop_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth("<< >>", FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, "<< >>", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth("< >", FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, "< >", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(exit_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, exit_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(record_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, record_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(tv_radio_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, tv_radio_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(one_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, one_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(three_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, three_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(204,20,20), COLOR_None, OSD_RED); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(0,224,0), COLOR_None, OSD_GREEN); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(20,20,224), COLOR_None, OSD_BLUE); 
			
	help_x_offset = x+85;
	help_y_offset = y+30+10;
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_entire_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, show_photo_play_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, stop_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, page_up_down_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, toggle_photo_music_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, return_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, save_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, load_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, shuffle_up_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, shuffle_down_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_item_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, previous_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, clear_playlist_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, next_tune_t, info_detail_colour, COLOR_None, FNT_Size_1622); 

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void drawRecycleBinHelpViewer()
{
	int help_x_offset, help_y_offset, indent, string_length;
	word x = X+125, y = Y+110, w = W-250, h = 230;

	help_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	TAP_ExitNormal();

	// fill whole area
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(recycle_bin_help_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, x+w-2, recycle_bin_help_t, header_text_colour, COLOR_None, FNT_Size_1926);

	// display standard button help
	help_x_offset = x+20;
	help_y_offset = y+30+10;
	if (page_with_arrows) {
		help_x_offset = x+75 - getWidth("< >", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "< >", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	else {
		help_x_offset = x+75 - getWidth("<< >>", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "<< >>", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	help_x_offset = x+75 - getWidth(exit_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, exit_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(recall_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, recall_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(pause_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, pause_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(224,224,0), COLOR_None, OSD_YELLOW); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(0,224,0), COLOR_None, OSD_GREEN);
			
	help_x_offset = x+85;
	help_y_offset = y+30+10;
	drawText(region_mem, help_x_offset, help_y_offset, -1, page_up_down_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, return_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, smart_delete_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, sort_by_name_date_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, restore_file_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, empty_bin_t, info_detail_colour, COLOR_None, FNT_Size_1622); 

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void drawSkinEditorHelpViewer()
{
	int help_x_offset, help_y_offset, indent, string_length;
	word x = X+125, y = Y+30, w = W-250, h = 350;

	help_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	TAP_ExitNormal();

	// fill whole area
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(skin_editor_help_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, x+w-2, skin_editor_help_t, header_text_colour, COLOR_None, FNT_Size_1926);

	// display standard button help
	help_x_offset = x+20;
	help_y_offset = y+30+10;
	help_x_offset = x+75 - getWidth("<< >>", FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, "<< >>", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(exit_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, exit_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(tv_radio_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, tv_radio_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(record_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, record_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(ok_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, ok_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth("1/4", FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, "1/4", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, "2/5", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, "3/6", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(204,20,20), COLOR_None, OSD_RED); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(20,20,224), COLOR_None, OSD_BLUE); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(0,224,0), COLOR_None, OSD_GREEN); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(224,224,0), COLOR_None, OSD_YELLOW);
				
	help_x_offset = x+85;
	help_y_offset = y+30+10;
	drawText(region_mem, help_x_offset, help_y_offset, -1, page_up_down_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, return_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, show_list_of_skins_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, save_to_disk_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, test_changes_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, amend_red_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, amend_green_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, amend_blue_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_element_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, add_element_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, set_skin_as_default_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, decrease_colour_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, increase_colour_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void drawAutoDeleteHelpViewer()
{
	int help_x_offset, help_y_offset, indent, string_length;
	word x = X+125, y = Y+110, w = W-250, h = 230;

	help_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	TAP_ExitNormal();

	// fill whole area
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	
	// header divider
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);
	
	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(auto_delete_help_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, x+w-2, auto_delete_help_t, header_text_colour, COLOR_None, FNT_Size_1926);

	// display standard button help
	help_x_offset = x+20;
	help_y_offset = y+30+10;
	if (page_with_arrows) {
		help_x_offset = x+75 - getWidth("< >", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "< >", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	}
	else {
		help_x_offset = x+75 - getWidth("<< >>", FNT_Size_1622);
		drawText(region_mem, help_x_offset, help_y_offset, -1, "<< >>", info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	} 
	help_x_offset = x+75 - getWidth(recall_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, recall_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	help_x_offset = x+75 - getWidth(play_t, FNT_Size_1622);
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_t, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(0,224,0), COLOR_None, OSD_GREEN); help_y_offset += 23;
	drawHelpButton(region_mem, x+75-15-13, help_y_offset+3, RGB8888(204,20,20), COLOR_None, OSD_RED);
			
	help_x_offset = x+85;
	help_y_offset = y+30+10;
	drawText(region_mem, help_x_offset, help_y_offset, -1, page_up_down_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, run_rules_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, run_all_rules_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_rules_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, delete_all_rules_t, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 23;
	drawText(region_mem, help_x_offset, help_y_offset, -1, add_rules_t, info_detail_colour, COLOR_None, FNT_Size_1622);

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

bool isPhotoLog(char *name)
{
	if (strlen(name) != 16)
		return FALSE;

    if (strcmp(name, "MediaManager.log") == 0)
        return TRUE;

    return FALSE;
}

void drawLogLine(int *line_number)
{
	log_line_pointer = 0;
	
	while (log_read_so_far < log_size)				
	{
		if (log_data[log_read_so_far] == '\n') {
			log_read_so_far++;
			break;			
		}

		if (log_data[log_read_so_far] == '\r' )
		{	
			// carriage return is followed by new line -> discard them both.
			log_read_so_far++;
			log_read_so_far++;
			if (log_read_so_far == log_size)											
				log_eof = TRUE;
			break;
		}

		if (log_line_pointer < 127)
		{
			// treat tabs as a space
			if (log_data[log_read_so_far] == '\t')
				strcpy(&log_line[log_line_pointer], " ");
			else
				log_line[log_line_pointer] = log_data[log_read_so_far];

			log_line_pointer++;
		}

		log_read_so_far++;
		if (log_read_so_far == log_size)											
			log_eof = TRUE;
	}

	log_line[log_line_pointer] = '\0';										// add a terminator to the string

	if (log_line[0] != ' ') {
		if (smaller_font)
			drawText(region_mem, X+4, Y+30+10+((*line_number)*16), X+W-5, log_line, body_text_colour, COLOR_None, FNT_Size_1419);
		else
			drawText(region_mem, X+4, Y+30+10+((*line_number)*20), X+W-5, log_line, body_text_colour, COLOR_None, FNT_Size_1622);
	}
	else
		(*line_number) = (*line_number) - 1;
}

void drawLogLines()
{
	int i = 0;
	int finish = 20;

	TAP_Osd_FillBox(region_mem, X, Y+30+3, W, H-30-3, body_bg_colour);

	log_eof = FALSE;
	page_pointers[page_number] = log_read_so_far;
	while (!log_eof && i < (smaller_font ? 25 : 20))
	{
		drawLogLine(&i);
		i++;
	}
}

void drawLogViewerHeader(void)
{
	dword string_length;
	word indent;

	TAP_Osd_FillBox(region_mem, X, Y, W, 30, header_bg_colour);

	drawText(region_mem, X+7, Y+4, -1, "<<", folder_text_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, X+7+33, Y+4, -1, up_t, header_text_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, X+W-85, Y+4, -1, down_t, header_text_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, X+W-30, Y+4, -1, ">>", folder_text_colour, COLOR_None, FNT_Size_1622);

	TAP_SPrint(buffer, "%s", dir_info[curr_idx]->file_name);

	string_length = getWidth(buffer, FNT_Size_1926);
	if (string_length > W-200) string_length = W-200;
	indent = X+100 + ((W-200 - string_length) / 2);
	drawText(region_mem, indent, Y, X+100+W-200, buffer, header_text_colour, header_bg_colour, FNT_Size_1926);
}

void drawBlankLogViewer()
{
	// fill whole area
	TAP_Osd_FillBox(region_mem, X-5, Y+30+3, W+10+1, H-30-3, body_bg_colour);

	// header divider
	TAP_Osd_FillBox(region_mem, X-5, Y+30, W+10+1, 3, frame_colour);
}

void drawLogViewer(bool draw_background)
{
	TAP_ExitNormal();

	// draw window
	drawBlankLogViewer();
	
	// header section
	drawLogViewerHeader();

	memset(log_line, '\0', 128);
	log_line_pointer = 0;
	//log_length = TAP_Hdd_Flen(log_file);
	log_read_so_far = 0;

	// draw lines
	smaller_font = FALSE;
	drawLogLines();

	if (draw_background)
		drawRoundedRectangle(region, X, Y, W, H, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, X, Y, W, 30, X, Y, FALSE);
	TAP_Osd_Copy(region_mem, region, X-5, Y+30, W+10+1, H-30, X-5, Y+30, FALSE);
}

void WriteIniFile()
{
	TYPE_File	*writeFile;

	if ( TAP_Hdd_Exist( OPTIONS_FILENAME ) ) TAP_Hdd_Delete( OPTIONS_FILENAME );	// Just delete any old copies

	TAP_Hdd_Create( OPTIONS_FILENAME, ATTR_PROGRAM );						// Create the file

	writeFile = TAP_Hdd_Fopen( OPTIONS_FILENAME );
	if ( writeFile == NULL ) return; 										// Check we can open it

	TAP_Hdd_Fwrite( dataBuffer_ini, DATA_BUFFER_SIZE_ini, 1, writeFile );	// dump the whole buffer in one hit

	TAP_Hdd_Fclose( writeFile );
}

void WriteStrToIniBuf( char *str )											// add str to current end of buffer
{																			// and move end out
	int count, i;

    count = strlen(str);
	
	for ( i=0; i<count; i++)
	{
		dataBuffer_ini[dataBufferPtr_ini+i] = str[i];							// copy accross 1 char at a time
	}
	dataBufferPtr_ini += i;
}

void SaveConfigurationToFile( void )
{
	dataBuffer_ini = dlmalloc( DATA_BUFFER_SIZE_ini );				// Buffer the write data to memory before writing all in one hit
	memset( dataBuffer_ini, '\0', DATA_BUFFER_SIZE_ini );				// set the whole buffer to the string termination character (null)
	dataBufferPtr_ini = 0;

	TAP_SPrint(buffer4, "%d\r\n", radio_mode);
	WriteStrToIniBuf(buffer4);

	TAP_SPrint(buffer4, "%s\r\n", default_slideshow_directory);
	WriteStrToIniBuf( buffer4 );
	
	TAP_SPrint(buffer4, "%d\r\n", slideshow_delay);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", jpg_activation_key);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", offset_x);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", offset_y);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", overnight_batch);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", overnight_batch_time + (24 * 60 * overnight_batch_day));
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", widescreen_adjustment_factor);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", write_log);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", verbose);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", filter_flickering);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", randomise_mp3s);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", randomise_photos);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", mp3_mode);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%s\r\n", default_startup_directory);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", recurse_subfolders);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", thumbnail_offset_x);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", thumbnail_offset_y);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", fade_image);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", rec_activation_key);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", create_scenes);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", thumbnail_skip);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", scene_skip);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", overnight_thumbs);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", overnight_thumbs_time);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", folder_preview);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", display_rec_event_name);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", auto_rename_rule);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", photo_ordering_mode);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%s\r\n", skin_file_name);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", disable_folder_count);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", last_played_activation_key);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", enable_stop_menu);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", stop_menu_percentage);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", enable_recycle_bin);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", overnight_auto_delete);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", X);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", Y);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", photo_aspect_ratio);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", empty_bin_percentage);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", mp3_activation_key);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", music_ordering_mode);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", video_ordering_mode);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", recycle_ordering_mode);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", show_header_icons);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", play_resumes_video);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", hide_empty_folders);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", highlight_oldest_recording);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", disable_thumbnails);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", disk_space_format);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", file_icons_left_aligned);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", show_all_files_activation_key);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", gradient_increment);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", list_progress_format);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", footer_progress_format);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", two_tone_increment);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", footer_rec_header_format);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", page_with_arrows);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", recycle_by_deletion_date);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", display_logos);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", preload_video_headers);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", show_remaining_hours);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", show_last_played_icon);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", full_size_display);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", folders_at_end);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", hide_top_level_parent);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", megabytes_per_hour);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", discard_navigation_history);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", enable_component_switching);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", text_justification);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", overnight_copy);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", decode_speed);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", gmt_offset_override);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", masterpiece_mode);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", decode_channel);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", overnight_shutdown);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", mp3_end_mode);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", order_by_track_number);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", preload_mp3_headers);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", paused_mode);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", paused_delay);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", burnout_delay);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", disable_file_details);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", create_thumbnail_key);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", use_numbers_to_search);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", empty_bin_days);
	WriteStrToIniBuf( buffer4 );
	
	TAP_SPrint(buffer4, "%s\r\n", font_name);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", mp3_channel);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", watched_icon_percentage);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", pf_activation_key);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", skip_to_bookmark);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", video_info_format);
	WriteStrToIniBuf( buffer4 );

	TAP_SPrint(buffer4, "%d\r\n", display_toppy_archive);
	WriteStrToIniBuf( buffer4 );

	WriteIniFile();										// write all the data in one pass
	dlfree(dataBuffer_ini);										// must return the memory back to the heap

	dlmalloc_trim(0);
}


//------------------------------------------------------------------
//
char *ReadIniField( void )
{
	int i;
	char readChar;
	char *oldPtr;

	oldPtr = (char *) dataBuffer_ini + dataBufferPtr_ini;

	i=0;
	while ( dataBufferPtr_ini < DATA_BUFFER_SIZE_ini )					// Bounds check
	{
		readChar = dataBuffer_ini[dataBufferPtr_ini];					// read the file one character at a time

		if ( readChar == '\t' ) break;									// looking for TAB delimiter,
		if ( readChar == '\n' ) break;									// or end of line.
		if ( readChar == '\r' )
		{																// Carriage return is followed by new line -> discard them both.
			dataBuffer_ini[dataBufferPtr_ini] = '\0';
			dataBufferPtr_ini++;
			break;
		}
		if ( readChar == '\0' ) break;									// Null terminator signifies end of file

		dataBufferPtr_ini++;
	}

	dataBuffer_ini[dataBufferPtr_ini] = '\0';							// add a terminator to the string
	dataBufferPtr_ini++;
	return oldPtr;														// return a pointer to the start of the current field
}



dword ReadIniDecimal( void )
{
	dword	tmp;
	int i;
	
	strcpy( buffer4, ReadIniField() );										// Read the field
	tmp = 0;
	i = 0;

	while ( buffer4[i] != '\0' )
	{
	    tmp = (tmp * 10) + (buffer4[i] - '0');
		i++;
	}

	return tmp;
}


void SetConfigurationVariables( void )
{
	radio_mode					= ReadIniDecimal();
	strcpy(default_slideshow_directory, ReadIniField());
	slideshow_delay					= ReadIniDecimal();
	jpg_activation_key				= ReadIniDecimal();
	offset_x						= ReadIniDecimal();   
	offset_y						= ReadIniDecimal();
	overnight_batch					= ReadIniDecimal();
	overnight_batch_time			= ReadIniDecimal();
	overnight_batch_day				= overnight_batch_time / 24 / 60;
	overnight_batch_time			= overnight_batch_time - (overnight_batch_day * 24 * 60);
	widescreen_adjustment_factor	= ReadIniDecimal();
	write_log						= ReadIniDecimal();
	verbose 						= ReadIniDecimal();
	filter_flickering				= ReadIniDecimal();
	randomise_mp3s					= ReadIniDecimal();
	randomise_photos				= ReadIniDecimal();
	mp3_mode						= ReadIniDecimal();
	strcpy(default_startup_directory, ReadIniField());
	recurse_subfolders				= ReadIniDecimal();
	thumbnail_offset_x				= ReadIniDecimal();   
	thumbnail_offset_y				= ReadIniDecimal();
	fade_image						= ReadIniDecimal();
	rec_activation_key				= ReadIniDecimal();
	create_scenes					= ReadIniDecimal();
	thumbnail_skip					= ReadIniDecimal();
	scene_skip						= ReadIniDecimal();
	overnight_thumbs				= ReadIniDecimal();
	overnight_thumbs_time			= ReadIniDecimal();
	folder_preview					= ReadIniDecimal();
	display_rec_event_name			= ReadIniDecimal();
	auto_rename_rule				= ReadIniDecimal();
	photo_ordering_mode				= ReadIniDecimal();
	strcpy(skin_file_name, ReadIniField());
	disable_folder_count			= ReadIniDecimal();
	last_played_activation_key		= ReadIniDecimal();
	enable_stop_menu				= ReadIniDecimal();
	stop_menu_percentage			= ReadIniDecimal();
	enable_recycle_bin				= ReadIniDecimal();
	overnight_auto_delete			= ReadIniDecimal();
	X								= ReadIniDecimal();   
	Y								= ReadIniDecimal();
	photo_aspect_ratio				= ReadIniDecimal();
	empty_bin_percentage			= ReadIniDecimal();
	mp3_activation_key				= ReadIniDecimal();
	music_ordering_mode				= ReadIniDecimal();
	video_ordering_mode				= ReadIniDecimal();
	recycle_ordering_mode			= ReadIniDecimal();
	show_header_icons				= ReadIniDecimal();
	play_resumes_video				= ReadIniDecimal();
	hide_empty_folders				= ReadIniDecimal();
	highlight_oldest_recording		= ReadIniDecimal();
	disable_thumbnails				= ReadIniDecimal();
	disk_space_format				= ReadIniDecimal();
	file_icons_left_aligned			= ReadIniDecimal();
	show_all_files_activation_key	= ReadIniDecimal();
	gradient_increment				= ReadIniDecimal();
	list_progress_format			= ReadIniDecimal();
	footer_progress_format			= ReadIniDecimal();
	two_tone_increment				= ReadIniDecimal();
	footer_rec_header_format		= ReadIniDecimal();
	page_with_arrows				= ReadIniDecimal();
	recycle_by_deletion_date		= ReadIniDecimal();
	display_logos					= ReadIniDecimal();
	preload_video_headers			= ReadIniDecimal();
	show_remaining_hours			= ReadIniDecimal();
	show_last_played_icon			= ReadIniDecimal();
	full_size_display				= ReadIniDecimal();
	folders_at_end					= ReadIniDecimal();
	hide_top_level_parent			= ReadIniDecimal();
	megabytes_per_hour				= ReadIniDecimal();
	discard_navigation_history		= ReadIniDecimal();
	enable_component_switching		= ReadIniDecimal();
	text_justification				= ReadIniDecimal();
	overnight_copy					= ReadIniDecimal();
	decode_speed					= ReadIniDecimal();
	gmt_offset_override				= ReadIniDecimal();
	masterpiece_mode				= ReadIniDecimal();
	decode_channel					= ReadIniDecimal();
	overnight_shutdown				= ReadIniDecimal();
	mp3_end_mode					= ReadIniDecimal();
	order_by_track_number			= ReadIniDecimal();
	preload_mp3_headers				= ReadIniDecimal();
	paused_mode						= ReadIniDecimal();
	paused_delay					= ReadIniDecimal();
	burnout_delay					= ReadIniDecimal();
	disable_file_details			= ReadIniDecimal();
	create_thumbnail_key			= ReadIniDecimal();
	use_numbers_to_search			= ReadIniDecimal();
	empty_bin_days					= ReadIniDecimal();
	strcpy(font_name, ReadIniField());
	mp3_channel						= ReadIniDecimal();
	watched_icon_percentage			= ReadIniDecimal();
	pf_activation_key				= ReadIniDecimal();
	skip_to_bookmark				= ReadIniDecimal();
	video_info_format				= ReadIniDecimal();
	display_toppy_archive			= ReadIniDecimal();
}


bool ReadConfigurationFile(void)
{
	TYPE_File *readFile;
	dword fileLength;

	//ChangeDir( PROJECT_DIRECTORY );
	if ( ! TAP_Hdd_Exist( OPTIONS_FILENAME ) ) return FALSE;			// check the photo file exits in the current directory
	
	readFile = TAP_Hdd_Fopen( OPTIONS_FILENAME );
	if ( readFile == NULL ) return FALSE;								// and we can open it ok

	dataBuffer_ini = dlmalloc( DATA_BUFFER_SIZE_ini );				// Read the data in one hit (quicker), then process from RAM
	memset( dataBuffer_ini, '\0', DATA_BUFFER_SIZE_ini );					// set the whole buffer to the string termination character (null)
	dataBufferPtr_ini = 0;

	fileLength = TAP_Hdd_Flen( readFile );								// how big is the file
	if ( fileLength > DATA_BUFFER_SIZE_ini  ) fileLength = DATA_BUFFER_SIZE_ini;	// ensure we don't overflow the buffer
	
	TAP_Hdd_Fread( dataBuffer_ini, fileLength, 1, readFile );			// grab all the data from the file

	TAP_Hdd_Fclose( readFile );
	//ChangeDir("..");											// return to original directory

	SetConfigurationVariables();

	dlfree( dataBuffer_ini );										// must return the memory back to the heap

	dlmalloc_trim(0);

	return TRUE;
}


void LoadConfiguration( void )
{
	ChangeDirMediaManager();

	if ( (!ReadConfigurationFile()))  // If file is invalid, recreate a new one.
	{
		radio_mode		   = OFF;
		randomise_mp3s     = FALSE;
		strcpy(default_slideshow_directory, "/ProgramFiles");
		slideshow_delay   = 5;
		jpg_activation_key    = RKEY_Recall;
		offset_x          = 65;   
		offset_y          = 53;
		overnight_batch   = 0;

		TAP_GetTime(&mjd, &hour, &min, &sec);
		TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
		overnight_batch_time = 0;
		overnight_batch_day = day;
		widescreen_adjustment_factor = 0; 
		write_log = FALSE; 
		verbose   = FALSE;
		filter_flickering = TRUE;
		randomise_photos = FALSE;
		mp3_mode = OFF;
		recurse_subfolders = TRUE;
		thumbnail_offset_x = 50;   
		thumbnail_offset_y = 27;
		strcpy(default_startup_directory, "/ProgramFiles");
		fade_image = OFF;
		rec_activation_key = RKEY_None;
		create_scenes = TRUE;
		thumbnail_skip = 7;
		scene_skip = 10;
		overnight_thumbs = FALSE;
		overnight_thumbs_time = 0;
		folder_preview = FALSE;
		display_rec_event_name = FALSE;
		auto_rename_rule = RENAME_BY_NUMBER;
		photo_ordering_mode = ORDER_BY_DATE;
		strcpy(skin_file_name, "Default.mcf");
		disable_folder_count = TRUE;
		last_played_activation_key = RKEY_None;
		enable_stop_menu = FALSE;
		stop_menu_percentage = 80;
		enable_recycle_bin = TRUE;
		overnight_auto_delete = FALSE;
		photo_aspect_ratio = NO_ASPECT_RATIO_SWITCH;
		empty_bin_percentage = 0;
		X = 50;   
		Y = 45;
		mp3_activation_key = RKEY_None;
		music_ordering_mode = ORDER_BY_NAME;
		video_ordering_mode = ORDER_BY_DATE;
		recycle_ordering_mode = ORDER_BY_DATE;
		show_header_icons = FALSE;
		play_resumes_video = FALSE;
		hide_empty_folders = FALSE;
		highlight_oldest_recording = ORDER_BY_DATE;
		disable_thumbnails = FALSE;
		disk_space_format = PERCENTAGE_USED;
		file_icons_left_aligned = TRUE;
		show_all_files_activation_key = RKEY_Pip;
		gradient_increment = 2;
		list_progress_format = MINS_GONE_MINS_LEFT;
		footer_progress_format = NO_PROGRESS;
		two_tone_increment = FALSE;
		footer_rec_header_format = EVENT_NAME;
		page_with_arrows = FALSE;
		recycle_by_deletion_date = FALSE;
		display_logos = FALSE;
		preload_video_headers = HEADERS_LAZY;
		show_remaining_hours = FALSE;
		show_last_played_icon = FALSE;
		full_size_display = FALSE;
		folders_at_end = FALSE;
		hide_top_level_parent = DATAFILES;
		megabytes_per_hour = 0;
		discard_navigation_history = TRUE;
		enable_component_switching = TRUE;
		text_justification = LEFT_JUSTIFY;
		overnight_copy = OFF;
		decode_speed = DECODE_REAL_TIME;
		gmt_offset_override = 0;
		masterpiece_mode = OFF;
		decode_channel = OFF;
		overnight_shutdown = OFF;
		mp3_end_mode = STOP_ALBUM;
		order_by_track_number = OFF;
		preload_mp3_headers = HEADERS_AND_THUMBNAILS_LAZY;
		paused_mode = OFF;
		paused_delay = 10;
		burnout_delay = 0;
		disable_file_details = FALSE;
		create_thumbnail_key = RKEY_None;
		use_numbers_to_search = OFF;
		empty_bin_days = 0;
		strcpy(font_name, "Default");
		mp3_channel = OFF;
		watched_icon_percentage = 0;
		pf_activation_key = RKEY_None;
		skip_to_bookmark = OFF;
		video_info_format = ALL;
		display_toppy_archive = TRUE;

		SaveConfigurationToFile();
	}
	
	if (overnight_batch_day == 0)
	{
		TAP_GetTime(&mjd, &hour, &min, &sec);
		TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
		overnight_batch_day = day;

		SaveConfigurationToFile();
	}

	if (strncmp(default_startup_directory, "/", 1) != 0)
	{
		strcpy(default_startup_directory, "/ProgramFiles");

		SaveConfigurationToFile();
	}

	if (strlen(skin_file_name) == 0) {
		strcpy(skin_file_name, "Default.mcf");
		SaveConfigurationToFile();
	}

	if (X == 0)	{
		X = 50;
		Y = 45;
		SaveConfigurationToFile();
	}

	if (X > 90 || Y > 53 || offset_x > 118 || offset_y > 68 || thumbnail_offset_x > 80 || thumbnail_offset_y > 50)	{
		if (X > 90) X = 90;
		if (Y > 53)	Y = 53;
		if (offset_x > 118) offset_x = 118;
		if (offset_y > 68) offset_y = 68;
		if (thumbnail_offset_x > 80) thumbnail_offset_x = 80;
		if (thumbnail_offset_y > 50) thumbnail_offset_y = 50;
		SaveConfigurationToFile();
	}

	if (rec_activation_key == 1) {
		rec_activation_key = RKEY_Filelist;
		SaveConfigurationToFile();
	}

	if (last_played_activation_key == 1) {
		last_played_activation_key = RKEY_Slow;
		SaveConfigurationToFile();
	}

	if (show_all_files_activation_key == 0 || show_all_files_activation_key == 1) {
		show_all_files_activation_key = RKEY_Pip;
		SaveConfigurationToFile();
	}

	if (overnight_thumbs == 2)	{
		overnight_thumbs = 1;
		overnight_shutdown = TRUE;
		SaveConfigurationToFile();
	}

	if (overnight_auto_delete == 2)	{
		overnight_auto_delete = 1;
		overnight_shutdown = TRUE;
		SaveConfigurationToFile();
	}

	if (overnight_copy == 4)	{
		overnight_auto_delete = 3;
		overnight_shutdown = TRUE;
		SaveConfigurationToFile();
	}

	if (strcmp(default_slideshow_directory, "Default.mcf") == 0) {
		strcpy(default_slideshow_directory, "/ProgramFiles");
		SaveConfigurationToFile();
	}

	if (strlen(font_name) == 0) {
		strcpy(font_name, "Default");
		SaveConfigurationToFile();
	}

	// set header offsets
	if (isTF5800())
        headerOffset = 4;
	ef (isTF5100c() || isTF5200c())
		headerOffset = -4;
	else
		headerOffset = 0;

	line_height = display_logos ? 30 : 26;
	line_count = display_logos ? 9 : 10;
	line_gap = display_logos ? 2 : 3;

	if (write_log) if (verbose) logText("Loaded config", FALSE);
}

// load the recording progress data in from file
void loadProgressData()
{
	TYPE_File *progress_file;
	word i;
	char *load_dump;

	no_of_progress = 0;
	last_played_key = 0;
	memset(last_played_name, '\0', 100);

	ChangeDirMediaManager();
	strcpy(file_name, "vid_progress.dat");

	if (TAP_Hdd_Exist(file_name)) {
		if (write_log) if (verbose) logText("Reading progress data from file", TRUE);
		progress_file = TAP_Hdd_Fopen(file_name);
		if (progress_file != NULL) {
			TAP_Hdd_Fread(&last_played_key, sizeof(int), 1, progress_file);
			if (last_played_key == -1) {
				TAP_Hdd_Fread(last_played_name, sizeof(char), 100, progress_file);
				TAP_Hdd_Fread(&last_played_cluster, sizeof(int), 1, progress_file);
				TAP_Hdd_Fread(&no_of_progress, sizeof(int), 1, progress_file);
			}
			else {
				no_of_progress = last_played_key;				
				last_played_key = -1;
			}

			if (no_of_progress > 0) {
				load_dump = dlmalloc(sizeof(*progress[0]) * no_of_progress);
				TAP_Hdd_Fread(load_dump, sizeof(*progress[0]), no_of_progress, progress_file);
				for (i = 0; i < no_of_progress; i++) {
					progress[i] = dlmalloc(sizeof(*progress[i]));
					memcpy(progress[i], load_dump, sizeof(*progress[i]));
					load_dump += sizeof(*progress[i]);
				}

				load_dump -= sizeof(*progress[0]) * no_of_progress;
				dlfree(load_dump);
				dlmalloc_trim(0);
			}

			//for (i = 0; i < no_of_progress; i++) {
			//	progress[i] = dlmalloc(sizeof(*progress[i]));
			//	TAP_Hdd_Fread(progress[i], sizeof(*progress[i]), 1, progress_file);
			//}

			TAP_Hdd_Fclose(progress_file);
		}
	}

	ChangeDirPath(curr_dir);
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Read last key %d, last name %s", last_played_key, last_played_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
}

void saveProgressDetails()
{
	TYPE_File *progress_file;
	word i;
	char *save_dump;

	strcpy(file_name, "vid_progress.dat");
	TAP_Hdd_Delete(file_name);
	TAP_Hdd_Create(file_name, ATTR_PROGRAM);
	
	if (write_log) if (verbose) logText("Saving progress data to file", FALSE);
	progress_file = TAP_Hdd_Fopen(file_name);
	if (progress_file != NULL) {
		TAP_Hdd_Fwrite(&last_played_key, sizeof(int), 1, progress_file);
		TAP_Hdd_Fwrite(last_played_name, sizeof(char), 100, progress_file);
		TAP_Hdd_Fwrite(&last_played_cluster, sizeof(int), 1, progress_file);
		TAP_Hdd_Fwrite(&no_of_progress, sizeof(int), 1, progress_file);

		if (no_of_progress > 0) {
			save_dump = dlmalloc(sizeof(*progress[0]) * no_of_progress);

			for (i = 0; i < no_of_progress; i++) {
				memcpy(save_dump, progress[i], sizeof(*progress[i]));
				save_dump += sizeof(*progress[i]);
			}
			save_dump -= sizeof(*progress[0]) * no_of_progress;
			TAP_Hdd_Fwrite(save_dump, sizeof(*progress[i]), no_of_progress, progress_file);
			
			dlfree(save_dump);
			dlmalloc_trim(0);
		}

		//for (i = 0; i < no_of_progress; i++)
		//	TAP_Hdd_Fwrite(progress[i], sizeof(*progress[i]), 1, progress_file);

		TAP_Hdd_Fclose(progress_file);
	}
}

// save the recording progress data to file
void saveProgressDataFromKnown(char *dir)
{
	strcpy(known_dir, dir);
	ChangeDirMediaManager();
	saveProgressDetails();
	ChangeDirPath(known_dir);
}

// save the recording progress data to file
void saveProgressData()
{
	ChangeDirMediaManager();
	saveProgressDetails();
	ChangeDirPath(curr_dir);
}

void updateProgressData(TYPE_File *file, int current_block, int total_block)
{
	int i;
	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, file->name) == 0 && progress[i]->start_cluster == file->startCluster) {
			//if (write_log) if (verbose) TAP_SPrint(log_buffer, "Update progress %d, %d", current_block, total_block);
			//if (write_log) if (verbose) logText(log_buffer, FALSE);
			progress[i]->current_block = current_block;
			progress[i]->total_block = (total_block < current_block) ? current_block : total_block;
		}
	}
}

// adjust the total block for a truncated recording because the duration will have changed
void updateProgressDataForTruncatedRecording(char *name, dword start_cluster, TYPE_RecInfo rec_info)
{
	int i;
	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, name) == 0 && progress[i]->start_cluster == start_cluster) {
			int total_block = (progress[i]->total_block * (rec_info.recordedSec/60)) / rec_info.duration;
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Adjust progress duration old %d, new %d", progress[i]->total_block, total_block);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			progress[i]->total_block = (total_block < progress[i]->current_block) ? progress[i]->current_block : total_block;
		}
	}

	saveProgressData();
}

void renameProgressData(TYPE_File *file, char *old_name, char *new_name)
{
	int i;
	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, old_name) == 0 && progress[i]->start_cluster == file->startCluster)
			strcpy(progress[i]->file_name, new_name);
	}
}

void appendToProgressData(TYPE_File *file, int current_block, int total_block)
{
	// if we don't already have the details, append them to the end
	if (write_log) TAP_SPrint(log_buffer, "Append to progress data %s, %d", file->name, file->startCluster);
	if (write_log) logText(log_buffer, FALSE);
	if (no_of_progress < 512 && getCurrentBlockFromFile(file) == 0) {
		progress[no_of_progress] = dlmalloc(sizeof(*progress[no_of_progress]));
		strcpy(progress[no_of_progress]->file_name, file->name);
		progress[no_of_progress]->start_cluster = file->startCluster;
		progress[no_of_progress]->current_block = current_block;
		progress[no_of_progress]->total_block = (total_block < current_block) ? current_block : total_block;
		no_of_progress++;
	}
}

int getCurrentBlock(char *name, dword start_cluster)
{
	int i; 

	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, name) == 0 && progress[i]->start_cluster == start_cluster) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Found current block for %s, %d, %d", name, progress[i]->current_block, progress[i]->total_block);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			return progress[i]->current_block;
		}
	}

	return 0;
}

int getCurrentBlockFromFile(TYPE_File *file)
{
	int i; 
	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, file->name) == 0 && progress[i]->start_cluster == file->startCluster)
			return progress[i]->current_block;
	}

	return 0;
}

int getCurrentBlockFromScene(char *name)
{
	int skip_position = 0, no_of_scenes = 0; 

	TYPE_File *scene_file;

	ChangeDir("Cache");

	if (TAP_Hdd_Exist(name)) {
		scene_file = TAP_Hdd_Fopen(name);
		if (scene_file != NULL) {
			TAP_Hdd_Fread(&no_of_scenes, sizeof(int), 1, scene_file);
			TAP_Hdd_Fread(&skip_position, sizeof(int), 1, scene_file);
			TAP_Hdd_Fclose(scene_file);
		}
	}

	ChangeDir("..");

	return skip_position;
}

int getTotalBlock(char *name, dword start_cluster)
{
	int i; 
	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, name) == 0 && progress[i]->start_cluster == start_cluster)
			return progress[i]->total_block;
	}

	return 0;
}

int getTotalBlockFromFile(TYPE_File *file)
{
	int i; 
	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, file->name) == 0 && progress[i]->start_cluster == file->startCluster)
			return progress[i]->total_block;
	}

	return 0;
}

void deleteFromProgressFromFile(TYPE_File *file, char *known_dir)
{
	int i, found_idx = -1; 
	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, file->name) == 0 && progress[i]->start_cluster == file->startCluster) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete progress for %s", progress[i]->file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			found_idx = i;
			break;
		}
	}

	if (found_idx >= 0) {
		for (i = found_idx; i < no_of_progress-1; i++) {
			strcpy(progress[i]->file_name, progress[i+1]->file_name);
			progress[i]->start_cluster = progress[i+1]->start_cluster;
			progress[i]->current_block = progress[i+1]->current_block;
			progress[i]->total_block = progress[i+1]->total_block;
		}

		dlfree(progress[no_of_progress-1]);
		no_of_progress--;
	}

	saveProgressDataFromKnown(known_dir);
}

void deleteFromProgressFromDirInfo(char *name, dword start_cluster)
{
	int i, found_idx = -1; 
	for (i = 0; i < no_of_progress; i++) {
		if (strcmp(progress[i]->file_name, name) == 0 && progress[i]->start_cluster == start_cluster) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete progress for %s", progress[i]->file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			found_idx = i;
			break;
		}
	}

	if (found_idx >= 0) {
		for (i = found_idx; i < no_of_progress-1; i++) {
			strcpy(progress[i]->file_name, progress[i+1]->file_name);
			progress[i]->start_cluster = progress[i+1]->start_cluster;
			progress[i]->current_block = progress[i+1]->current_block;
			progress[i]->total_block = progress[i+1]->total_block;
		}

		dlfree(progress[no_of_progress-1]);
		no_of_progress--;
	}

	saveProgressData();
}

void deleteFromProgress(int idx)
{
	int i; 

	for (i = idx; i < no_of_progress-1; i++) {
		strcpy(progress[i]->file_name, progress[i+1]->file_name);
		progress[i]->start_cluster = progress[i+1]->start_cluster;
		progress[i]->current_block = progress[i+1]->current_block;
		progress[i]->total_block = progress[i+1]->total_block;
	}

	dlfree(progress[no_of_progress-1]);
	no_of_progress--;

	saveProgressData();
}

// put first jpeg in folder into structure
void moveAlbumArtToStructure()
{
	int i;
	TYPE_File file, *association_file = NULL;
	char folder_jpg_name[12] = "";
	bool other_jpg_found = FALSE;

	freeMediaFiles();

	ChangeDirPath(mp3_files[current_mp3]->directory);

	if (TAP_Hdd_Exist("Cache")) {
		ChangeDir("Cache");

		strcpy(file_name, mp3_files[current_mp3]->file_name);
		strcat(file_name, ".ass");
		if (TAP_Hdd_Exist(file_name)) {
			if (write_log) if (verbose) logText("Found MP3 art association", FALSE);
			jpeg_files = dlmalloc(sizeof(*jpeg_files) * MEMORY_LIMIT);

			jpeg_files[0] = dlmalloc(sizeof(*jpeg_files[0]));
			memset(jpeg_files[0], 0, sizeof(*jpeg_files[0]));

			jpeg_files[0]->directory = dlmalloc(256 * sizeof(char));
			jpeg_files[0]->file_name = dlmalloc(100 * sizeof(char));
			strcpy(jpeg_files[0]->directory, mp3_files[current_mp3]->directory);
			strcpy(jpeg_files[0]->file_name, file_name);
			no_of_jpegs = 1;
		}
		ef (TAP_Hdd_Exist("album.ass.cache")) {
			if (write_log) if (verbose) logText("Found album art association", FALSE);
			jpeg_files = dlmalloc(sizeof(*jpeg_files) * MEMORY_LIMIT);

			jpeg_files[0] = dlmalloc(sizeof(*jpeg_files[0]));
			memset(jpeg_files[0], 0, sizeof(*jpeg_files[0]));

			jpeg_files[0]->directory = dlmalloc(256 * sizeof(char));
			jpeg_files[0]->file_name = dlmalloc(100 * sizeof(char));
			strcpy(jpeg_files[0]->directory, mp3_files[current_mp3]->directory);
			strcpy(jpeg_files[0]->file_name, "album.ass");
			no_of_jpegs = 1;
		}
		ChangeDir("..");
	}

	if (no_of_jpegs == 0) {
		memset (&file, 0, sizeof(file));
		i = TAP_Hdd_FindFirst(&file);

		while (i--)
		{
			if (isPhoto(file.name)) {
				// populate the file name and folder flag if it is called folder.jpg
				strcpy(file_name, file.name);
				strlwr(file_name);
				if (strcmp(file_name, "folder.jpg") == 0) {
					strcpy(folder_jpg_name, file.name);
					if (write_log) TAP_SPrint(log_buffer, "Album art discovered %s", file.name);
					if (write_log) logText(log_buffer, FALSE);
					break;
				}
				else {
					if (!other_jpg_found) {
						if (write_log) TAP_SPrint(log_buffer, "Album art discovered %s", file.name);
						if (write_log) logText(log_buffer, FALSE);
						jpeg_files = dlmalloc(sizeof(*jpeg_files) * MEMORY_LIMIT);

						jpeg_files[0] = dlmalloc(sizeof(*jpeg_files[0]));
						memset(jpeg_files[0], 0, sizeof(*jpeg_files[0]));

						jpeg_files[0]->directory = dlmalloc(256 * sizeof(char));
						jpeg_files[0]->file_name = dlmalloc(100 * sizeof(char));
						strcpy(jpeg_files[0]->directory, mp3_files[current_mp3]->directory);
						strcpy(jpeg_files[0]->file_name, file.name);
						other_jpg_found = TRUE;
					}
				}
			}

			if (i == 0 || no_of_jpegs == 1 || TAP_Hdd_FindNext(&file) == 0)
				break;
		}

		// overwrite any other jpg found with folder.jpg if it exists
		if (strlen(folder_jpg_name) > 0) {
			if (!other_jpg_found) {
				jpeg_files = dlmalloc(sizeof(*jpeg_files) * MEMORY_LIMIT);

				jpeg_files[0] = dlmalloc(sizeof(*jpeg_files[0]));
				memset(jpeg_files[0], 0, sizeof(*jpeg_files[0]));

				jpeg_files[0]->directory = dlmalloc(256 * sizeof(char));
				jpeg_files[0]->file_name = dlmalloc(100 * sizeof(char));
			}
			strcpy(jpeg_files[0]->directory, mp3_files[current_mp3]->directory);
			strcpy(jpeg_files[0]->file_name, folder_jpg_name);
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Album art is %s", jpeg_files[0]->file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			no_of_jpegs = 1;
		}
		ef (other_jpg_found) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Album art is %s", jpeg_files[0]->file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			no_of_jpegs = 1;
		}
	}

	// check for embedded album art
	if (no_of_jpegs == 0) {
		byte *picture; word *decoded_picture;
		if (playing_id3_info->picture) {
			picture = load_jpg_wembley_style(NULL, playing_id3_info->picture, playing_id3_info->picture_size, &bitmap_width, &bitmap_height);
			if (picture) {
				decoded_picture = decode_jpg_wembley_style(picture, &cached_width, &cached_height, 0);
				if (decoded_picture) {
					strcpy(buffer, mp3_files[current_mp3]->file_name);
					strcat(buffer, ".ass");
					createCacheDirectoryIfNotThere();
					ChangeDir("Cache");
					TAP_Hdd_Create(buffer, ATTR_NORMAL);
					ChangeDir("..");
					cacheToDisk16Bit(buffer, decoded_picture, cached_width, cached_height, FALSE);

					jpeg_files = dlmalloc(sizeof(*jpeg_files) * MEMORY_LIMIT);
					jpeg_files[0] = dlmalloc(sizeof(*jpeg_files[0]));
					memset(jpeg_files[0], 0, sizeof(*jpeg_files[0]));

					jpeg_files[0]->directory = dlmalloc(256 * sizeof(char));
					jpeg_files[0]->file_name = dlmalloc(100 * sizeof(char));
					strcpy(jpeg_files[0]->directory, mp3_files[current_mp3]->directory);
					strcpy(jpeg_files[0]->file_name, buffer);
					no_of_jpegs = 1;
					dlfree(decoded_picture);
					dlmalloc_trim(0);
				}
			}
		}

		//destroy_ID3(id3_info);
		//id3_info = NULL;
	}

	// finall check for default art
	if (no_of_jpegs == 0) {
		ChangeDirProgramFiles();
		if (TAP_Hdd_Exist("DefaultArt.jpg")) {
			if (write_log) if (verbose) logText("Found default album art", FALSE);
			jpeg_files = dlmalloc(sizeof(*jpeg_files) * MEMORY_LIMIT);

			jpeg_files[0] = dlmalloc(sizeof(*jpeg_files[0]));
			memset(jpeg_files[0], 0, sizeof(*jpeg_files[0]));

			jpeg_files[0]->directory = dlmalloc(256 * sizeof(char));
			jpeg_files[0]->file_name = dlmalloc(100 * sizeof(char));
			strcpy(jpeg_files[0]->directory, "/ProgramFiles");
			strcpy(jpeg_files[0]->file_name, "DefaultArt.jpg");
			no_of_jpegs = 1;
		}
	}

	ChangeDirPath(curr_dir);
}

/*void moveMp3HeadersToStructure()
{
	int i;

	for (i = 0; i < no_of_mp3_headers; i++)	{
		if (i == 0)
			mp3_files = dlmalloc(sizeof(*mp3_files) * MEMORY_LIMIT);

		mp3_files[i] = dlmalloc(sizeof(*mp3_files[i]));
		memset(mp3_files[i], 0, sizeof(*mp3_files[i]));

		mp3_files[i]->directory = dlmalloc(strlen(all_mp3_headers[i]->directory) + 1);
		mp3_files[i]->file_name = dlmalloc(strlen(all_mp3_headers[i]->file_name) + 1);
		mp3_files[i]->sort_name = dlmalloc(strlen(all_mp3_headers[i]->file_name) + 2);
		strcpy(mp3_files[i]->directory, all_mp3_headers[i]->directory);
		strcpy(mp3_files[i]->file_name, all_mp3_headers[i]->file_name);
		FormatSortName(mp3_files[i]->sort_name, all_mp3_headers[i]->file_name);
		mp3_files[i]->mjd = all_mp3_headers[i]->mjd;
		mp3_files[i]->hour = all_mp3_headers[i]->hour;
		mp3_files[i]->min = all_mp3_headers[i]->min;

		if (all_mp3_headers[i]->header_loaded) {
			mp3_files[i]->track_number = all_mp3_headers[i]->track_number;
			mp3_files[i]->duration = all_mp3_headers[i]->duration;
		}
	}
	no_of_mp3s = no_of_mp3_headers;
}*/

void movePlaylistToStructure(bool photo)
{
	int i;

	if (photo) {
		freeMediaFiles();
		for (i = 0; i < no_of_playlist_photos; i++)	{
			if (i == 0)
				jpeg_files = dlmalloc(sizeof(*jpeg_files) * MEMORY_LIMIT);

			jpeg_files[i] = dlmalloc(sizeof(*jpeg_files[i]));
			memset(jpeg_files[i], 0, sizeof(*jpeg_files[i]));

			jpeg_files[i]->directory = dlmalloc(256 * sizeof(char));
			jpeg_files[i]->file_name = dlmalloc(100 * sizeof(char));
			strcpy(jpeg_files[i]->directory, photo_playlist[i]->directory);
			strcpy(jpeg_files[i]->file_name, photo_playlist[i]->file_name);
		}
		no_of_jpegs = no_of_playlist_photos;
	}
	else
	{
		freeMP3Structure();
		for (i = 0; i < no_of_playlist_mp3s; i++)
		{
			if (i == 0)
				mp3_files = dlmalloc(sizeof(*mp3_files) * MEMORY_LIMIT);

			mp3_files[i] = dlmalloc(sizeof(*mp3_files[i]));
			memset(mp3_files[i], 0, sizeof(*mp3_files[i]));

			mp3_files[i]->directory = dlmalloc(256 * sizeof(char));
			mp3_files[i]->file_name = dlmalloc(100 * sizeof(char));
			strcpy(mp3_files[i]->directory, mp3_playlist[i]->directory);
			strcpy(mp3_files[i]->file_name, mp3_playlist[i]->file_name);
		}
		no_of_mp3s = no_of_playlist_mp3s;
		free_mp3s = TRUE;
	}
}

void updateAutoDeleteListCount(void)
{
	int  first_idx, last_idx, string_length;
	char text[12];

	// update the current playlist range displayed in the header
	first_idx = auto_delete_idx - auto_delete_highlight + 1;
	last_idx = ((auto_delete_idx - auto_delete_highlight + 10) > (no_of_auto_deletes - 1)) ? no_of_auto_deletes : first_idx + 9;

	TAP_Osd_FillBox(region_mem, X+W-5-80, Y+4, 80, 20, header_bg_colour);
	if (last_idx > 0) 
	{
		TAP_SPrint(text, " %d %s %d", first_idx, to_t, last_idx);
		string_length = getWidth(text, FNT_Size_1622);
		
		drawText(region_mem, X+W-5-string_length, Y+4, X+W-1, text, header_text_colour, COLOR_None, FNT_Size_1622);
	}
}

void drawAutoDeleteListFooter(int idx)
{
	word help_y_offset, help_x_offset = X+W-365;

	// blank out the box
	TAP_Osd_FillBox(region_mem, X, Y+323, W+1, 122+5+1, footer_bg_colour);
	TAP_Osd_FillBox(region_mem, X+(W-380), Y+323, 2, 122+5+1, frame_colour);

	// display standard button help
	drawText(region_mem, help_x_offset, Y+330, -1, recall_t, help_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset, Y+346, -1, play_t, help_text_colour, COLOR_None, FNT_Size_1419);
	if (page_with_arrows)
		drawText(region_mem, help_x_offset, Y+362, -1, "< >", help_text_colour, COLOR_None, FNT_Size_1419);
	else
		drawText(region_mem, help_x_offset, Y+362, -1, "<< >>", help_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset, Y+378, -1, "1:", help_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset, Y+394, -1, "3:", help_text_colour, COLOR_None, FNT_Size_1419);

	drawText(region_mem, help_x_offset+70, Y+330, -1, run_rules_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+70, Y+346, -1, run_all_rules_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+70, Y+362, -1, page_up_down_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+70, Y+378, -1, shuffle_up_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+70, Y+394, -1, shuffle_down_t, body_text_colour, COLOR_None, FNT_Size_1419);

	// display coloured button help keys
	help_x_offset = X+W-365+45;
	drawHelpButton(region_mem, help_x_offset+160, Y+330, RGB8888(240,0,0), COLOR_None, OSD_RED);
	drawHelpButton(region_mem, help_x_offset+160, Y+346, RGB8888(224,224,224), COLOR_None, OSD_WHITE);
	drawHelpButton(region_mem, help_x_offset+160, Y+362, RGB8888(0,224,0), COLOR_None, OSD_GREEN);

	// display coloured button help text
	drawText(region_mem, help_x_offset+160+20+7, Y+330, -1, add_rules_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+160+20+7, Y+346, -1, delete_rules_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+160+20+7, Y+362, -1, delete_all_rules_t, body_text_colour, COLOR_None, FNT_Size_1419);

	// display auto delete rules
	if (no_of_auto_deletes > 0) {
		int i = 0;
		help_y_offset = Y+330;
		drawText(region_mem, X+5, help_y_offset, X+140-1, delete_after_t, info_header_colour, COLOR_None, FNT_Size_1419);
		TAP_SPrint(buffer, "%d %s", auto_delete_list[idx]->delete_after_days, days_t);
		drawText(region_mem, X+140, help_y_offset, X+115+140-1, buffer, info_detail_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 15;
		drawText(region_mem, X+5, help_y_offset, X+140-1, keep_at_least_t, info_header_colour, COLOR_None, FNT_Size_1419);
		TAP_SPrint(buffer, "%d %s", auto_delete_list[idx]->delete_after_min, episodes_t);
		drawText(region_mem, X+140, help_y_offset, X+115+140-1, buffer, info_detail_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 15;
		drawText(region_mem, X+5, help_y_offset, X+140-1, keep_at_most_t, info_header_colour, COLOR_None, FNT_Size_1419);
		TAP_SPrint(buffer, "%d %s", auto_delete_list[idx]->delete_after_max, episodes_t);
		drawText(region_mem, X+140, help_y_offset, X+115+140-1, buffer, info_detail_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 15;
		drawText(region_mem, X+5, help_y_offset, X+140-1, delete_when_disk_t, info_header_colour, COLOR_None, FNT_Size_1419);
		TAP_SPrint(buffer, "%d%s %s", auto_delete_list[idx]->delete_when_disk, "%", full_t);
		drawText(region_mem, X+140, help_y_offset, X+115+140-1, buffer, info_detail_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 15;
	}
}

void drawAutoDeleteListHeader(void)
{
	dword string_length;
	word indent;

	TAP_Osd_FillBox(region_mem, X, Y, W, 30, header_bg_colour);
	if (show_header_icons) 
		TAP_Osd_PutGd(region_mem, X+10, Y, &_axe3Gd, TRUE);
	else
		drawText(region_mem, X+1, Y+6, -1, text_for_help_t, header_text_colour, COLOR_None, FNT_Size_1419);

	if (no_of_auto_deletes == 1)
		TAP_SPrint(buffer, "%s - %d %s", auto_delete_list_t, no_of_auto_deletes, rule_set_t);
	else
		TAP_SPrint(buffer, "%s - %d %s", auto_delete_list_t, no_of_auto_deletes, rule_sets_t);

	string_length = getWidth(buffer, FNT_Size_1926);
	indent = X-5 + ((W+10 - string_length) / 2);
	drawText(region_mem, indent, Y, -1, buffer, header_text_colour, COLOR_None, FNT_Size_1926);
}

void drawAutoDeleteListLine(int line_idx, int data_idx)
{
	int j;
	dword fc;

	j = 30 + (line_idx * 29) + 3;

	if (data_idx < no_of_auto_deletes && line_idx == auto_delete_highlight) {
		initialiseLine(X-5, Y+j, W+10+1, 26, highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
	}
	else {
		initialiseLine(X-5, Y+j, W+10+1, 26, background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
	}
	
	TAP_Osd_FillBox(region_mem, X+W-320, Y+j, 2, 26, frame_colour);
	TAP_Osd_FillBox(region_mem, X+W-240, Y+j, 2, 26, frame_colour);
	TAP_Osd_FillBox(region_mem, X+W-160, Y+j, 2, 26, frame_colour);
	TAP_Osd_FillBox(region_mem, X+W-80, Y+j, 2, 26, frame_colour);

	if (data_idx >= no_of_auto_deletes)
		return;

	if (strcmp(auto_delete_list[data_idx]->file_name, "*") == 0)
		TAP_SPrint(buffer, "All videos in \\DataFiles", auto_delete_list[data_idx]->file_name);
	else
		TAP_SPrint(buffer, "%s", auto_delete_list[data_idx]->file_name);
	drawText(region_mem, X, Y+j+3, X+W-320-1, buffer, fc, COLOR_None, FNT_Size_1622);

	TAP_SPrint(buffer, "%d %s", auto_delete_list[data_idx]->delete_after_days, days_t);
	drawText(region_mem, X+W-320+10, Y+j+3, X+W-240-1, buffer, fc, COLOR_None, FNT_Size_1622);

	TAP_SPrint(buffer, "%d %s", auto_delete_list[data_idx]->delete_after_min, minimum_t);
	drawText(region_mem, X+W-240+10, Y+j+3, X+W-160-1, buffer, fc, COLOR_None, FNT_Size_1622);

	TAP_SPrint(buffer, "%d %s", auto_delete_list[data_idx]->delete_after_max, maximum_t);
	drawText(region_mem, X+W-160+10, Y+j+3, X+W-80-1, buffer, fc, COLOR_None, FNT_Size_1622);

	TAP_SPrint(buffer, "%d%s %s", auto_delete_list[data_idx]->delete_when_disk, "%", full_t);
	drawText(region_mem, X+W-80+10, Y+j+3, X+W-1, buffer, fc, COLOR_None, FNT_Size_1622);
}

void drawAutoDeleteListLines(word start)
{
	int i;

	// draw each line
	for (i = 0; i < 10; i++)
	{
		drawAutoDeleteListLine(i, start + i);
	}

	updateAutoDeleteListCount();
}

void drawAutoDeleteList(bool draw_background)
{
	TAP_ExitNormal();

	// header section
	drawAutoDeleteListHeader();
	
	// 10 list items
	drawBlankFileList(10);

	if (no_of_auto_deletes > 10 && (auto_delete_idx >= (no_of_auto_deletes - 1)))
		auto_delete_highlight = 10 - (no_of_auto_deletes - auto_delete_idx);
	else
		auto_delete_highlight = auto_delete_idx % 10;

	drawAutoDeleteListLines(auto_delete_idx - auto_delete_highlight);

	updateAutoDeleteListCount();

	// populate the footer box
	drawAutoDeleteListFooter(auto_delete_idx);

	if (draw_background)
		drawRoundedRectangle(region, X, Y, W, H, 3, 10, 30, 122, frame_colour, COLOR_None, body_bg_colour, FALSE);
#ifndef WIN32
	drawArea(region, X+(W-380), Y+H-122+6, 2, 122+2, frame_colour);
#endif

	saved_auto_delete_idx = 0;
}

void updateSkinEditorCount(void)
{
	int  first_idx, last_idx, string_length;
	char text[12];

	// update the current playlist range displayed in the header
	first_idx = skin_editor_idx - skin_editor_highlight + 1;
	last_idx = ((skin_editor_idx - skin_editor_highlight + 10) > (no_of_skin_elements - 1)) ? no_of_skin_elements : first_idx + 9;

	TAP_Osd_FillBox(region_mem, X+W-5-80, Y+4, 80, 20, header_bg_colour);
	if (last_idx > 0) 
	{
		TAP_SPrint(text, " %d %s %d", first_idx, to_t, last_idx);
		string_length = getWidth(text, FNT_Size_1622);
		
		drawText(region_mem, X+W-5-string_length, Y+4, X+W-1, text, header_text_colour, COLOR_None, FNT_Size_1622);
	}
}

void drawSkinEditorFooter(int idx)
{
	word help_y_offset, help_x_offset = X+W-160;
	char info_line[80], word_in_line[40];
	word line_pointer, i=0, line_characters, pixels_left, word_count, pixel_skip, pixel_remainder;
	int info_offset_x = X+5;
	int info_offset_y = Y+340, max_info_length;
	info_pointer = 0;

	// blank out the box
	TAP_Osd_FillBox(region_mem, X, Y+323, W+5, 120+7+1, footer_bg_colour);
	TAP_Osd_FillBox(region_mem, X+(W-170), Y+323, 2, 120+7+1, frame_colour);


	// display coloured button help keys
	help_y_offset = Y+330;
	drawHelpButton(region_mem, help_x_offset, help_y_offset, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 16;
	drawHelpButton(region_mem, help_x_offset, help_y_offset, RGB8888(225,20,20), COLOR_None, OSD_RED); help_y_offset += 16;
	drawHelpButton(region_mem, help_x_offset, help_y_offset, RGB8888(20,20,225), COLOR_None, OSD_BLUE); help_y_offset += 16;
	drawHelpButton(region_mem, help_x_offset, help_y_offset, RGB8888(0,224,0), COLOR_None, OSD_GREEN); help_y_offset += 16;
	drawHelpButton(region_mem, help_x_offset, help_y_offset, RGB8888(224,224,0), COLOR_None, OSD_YELLOW); help_y_offset += 16;
	drawHelpButton(region_mem, help_x_offset, help_y_offset, RGB8888(224,224,224), RGB8888(225,20,20), OSD_RECORD); help_y_offset += 16;
	drawText(region_mem, help_x_offset, help_y_offset-1, -1, ok_t, help_text_colour, COLOR_None, FNT_Size_1419);

	// display coloured button help text
	help_y_offset = Y+330;
	drawText(region_mem, help_x_offset+30, help_y_offset, -1, delete_element_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+30, help_y_offset, -1, add_element_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+30, help_y_offset, -1, set_as_default_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+30, help_y_offset, -1, decrease_colour_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+30, help_y_offset, -1, increase_colour_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+30, help_y_offset, -1, save_to_disk_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+30, help_y_offset, -1, test_changes_t, body_text_colour, COLOR_None, FNT_Size_1419);

	if (no_of_skin_elements == 0)
		return;

	// show comment
	memset(buffer, '\0', 100);
	if (strlen(skin_elements[idx]->element_comment) > 0) {
		if (skin_elements[idx]->element_comment[2] == ' ')
			strcpy(buffer, skin_elements[idx]->element_comment+3);
		else
			strcpy(buffer, skin_elements[idx]->element_comment+2);
	}
	max_info_length = strlen(buffer);
	while (max_info_length > info_pointer && i < 4) {
		// get the next line for display
		getInfoLine(info_line, &info_pointer, buffer, W-170-20, FNT_Size_1622);

		info_offset_x = X+5;
		if (info_pointer >= max_info_length || text_justification == LEFT_JUSTIFY)
			// last line so dump it as it it
			drawText(region_mem, info_offset_x, info_offset_y, X+W-170-5, info_line, footer_text_colour, COLOR_None, FNT_Size_1622);
		else {
			// calculate number of characters/words in line
			line_characters = strlen(info_line);
			pixels_left = W-170-15 - getWidth(info_line, FNT_Size_1622);
			line_pointer = 0; 
			word_count = countWordsInLine(info_line);

			// calculate the number of pixels to add between words to stretch the line to the end of display
			pixel_skip = pixels_left / (word_count-1); 
			pixel_remainder = pixels_left % (word_count-1);

			// draw one word at a time
			while (strlen(info_line) >= line_pointer) {
				getWordInLine(info_line, word_in_line, &line_pointer);
				drawText(region_mem, info_offset_x, info_offset_y, X+W-170-5, word_in_line, footer_text_colour, COLOR_None, FNT_Size_1622);

				// calculate the next word position, add on any leftover pixels one at a time until all gone
				info_offset_x += getWidthRounded(word_in_line, FNT_Size_1622, FALSE);
				info_offset_x += pixel_skip;
				if (pixel_remainder > 0) {
					info_offset_x++; 
					pixel_remainder--;
				}
			}
		}
		info_offset_y += 22;
		i++;
	}
}

void drawSkinEditorHeader(void)
{
	dword string_length;
	word indent;

	TAP_Osd_FillBox(region_mem, X, Y, W, 30, header_bg_colour);
	if (show_header_icons)
		TAP_Osd_PutGd(region_mem, X+10, Y, &_rgb3Gd, TRUE);
	else
		drawText(region_mem, X+1, Y+6, -1, text_for_help_t, header_text_colour, COLOR_None, FNT_Size_1419);

	memset(buffer, '\0', 100);
	strncat(buffer, skin_file_name, strlen(skin_file_name)-4);
	TAP_SPrint(buffer2, "%s - %d %s", buffer, no_of_skin_elements, elements_t);

	string_length = getWidth(buffer2, FNT_Size_1926);
	indent = X-5 + ((W+10 - string_length) / 2);
	drawText(region_mem, indent, Y, -1, buffer2, header_text_colour, COLOR_None, FNT_Size_1926);
}

void drawSkinEditorLine(int line_idx, int data_idx)
{
	int j;
	dword fc, fc1, fc2, fc3;

	j = 30 + (line_idx * 29) + 3;

	initialiseLine(X-5, Y+j, W+10+1, 26, background_gradient, body_bg_colour, tt_body_bg_colour);

	TAP_Osd_FillBox(region_mem, X+W-320, Y+j, 2, 26, frame_colour);
	TAP_Osd_FillBox(region_mem, X+W-240, Y+j, 2, 26, frame_colour);
	TAP_Osd_FillBox(region_mem, X+W-160, Y+j, 2, 26, frame_colour);
	TAP_Osd_FillBox(region_mem, X+W-80, Y+j, 2, 26, frame_colour);

	if (data_idx >= no_of_skin_elements)
		return;

	fc = body_text_colour;

	switch (skin_colour_idx) {
		case 0:
			if (line_idx == skin_editor_highlight) {
				initialiseLine(X+W-240+2, Y+j, 80-2, 26, skin_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
				fc1 = highlight_text_colour;
			}
			else {
				fc1 = body_text_colour;
			}
			fc2 = body_text_colour;
			fc3 = body_text_colour;
			break;
		case 1:
			fc1 = body_text_colour;
			if (line_idx == skin_editor_highlight) {
				initialiseLine(X+W-160+2, Y+j, 80-2, 26, skin_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
				fc2 = highlight_text_colour;
			}
			else {
				fc2 = body_text_colour;
			}
			fc3 = body_text_colour;
			break;
		case 2:
			fc1 = body_text_colour;
			fc2 = body_text_colour;
			if (line_idx == skin_editor_highlight) {
				initialiseLine(X+W-80+2, Y+j, 80-2, 26, skin_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
				fc3 = highlight_text_colour;
			}
			else {
				fc3 = body_text_colour;
			}
			break;
	}

	// draw element name
	drawText(region_mem, X, Y+j+3, X+W-320-1, skin_elements[data_idx]->element_name, fc, COLOR_None, FNT_Size_1622);

	// draw colour box appropriate for element
	TAP_Osd_FillBox(region_mem, X+W-320+2, Y+j, 80-2, 26, RGB8888(skin_elements[data_idx]->red, skin_elements[data_idx]->green, skin_elements[data_idx]->blue));

	// draw red number
	TAP_SPrint(buffer, "%d", skin_elements[data_idx]->red);
	if (line_idx == skin_editor_highlight && skin_colour_idx == 0)
		drawText(region_mem, X+W-240+15, Y+j+3, X+W-160-1, "R ", highlight_text_colour, COLOR_None, FNT_Size_1622);
	else
		drawText(region_mem, X+W-240+15, Y+j+3, X+W-160-1, "R ", folder_text_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, X+W-240+40, Y+j+3, X+W-160-1, buffer, fc1, COLOR_None, FNT_Size_1622);

	// draw green number
	TAP_SPrint(buffer, "%d", skin_elements[data_idx]->green);
	if (line_idx == skin_editor_highlight && skin_colour_idx == 1)
		drawText(region_mem, X+W-160+15, Y+j+3, X+W-80-1, "G ", highlight_text_colour, COLOR_None, FNT_Size_1622);
	else
		drawText(region_mem, X+W-160+15, Y+j+3, X+W-80-1, "G ", folder_text_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, X+W-160+40, Y+j+3, X+W-80-1, buffer, fc2, COLOR_None, FNT_Size_1622);

	// draw blue number
	TAP_SPrint(buffer, "%d", skin_elements[data_idx]->blue);
	if (line_idx == skin_editor_highlight && skin_colour_idx == 2)
		drawText(region_mem, X+W-80+15, Y+j+3, X+W-1, "B ", highlight_text_colour, COLOR_None, FNT_Size_1622);
	else
		drawText(region_mem, X+W-80+15, Y+j+3, X+W-1, "B ", folder_text_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, X+W-80+40, Y+j+3, X+W-1, buffer, fc3, COLOR_None, FNT_Size_1622);
}

void drawSkinEditorLines(word start)
{
	int i;

	// draw each line
	for (i = 0; i < 10; i++)
	{
		drawSkinEditorLine(i, start + i);
	}

	updateSkinEditorCount();
}

void drawSkinEditor(bool draw_background)
{
	TAP_ExitNormal();

	// header section
	drawSkinEditorHeader();
	
	// 10 list items
	drawBlankFileList(10);

	drawSkinEditorLines(skin_editor_idx - skin_editor_highlight);

	updateSkinEditorCount();

	// populate the footer box
	drawSkinEditorFooter(skin_editor_idx);

	if (draw_background)
		drawRoundedRectangle(region, X, Y, W, H, 3, 10, 30, 122, frame_colour, COLOR_None, body_bg_colour, FALSE);

#ifndef WIN32
	drawArea(region, X+(W-170), Y+H-121+5, 2, 121+3, frame_colour);
#endif
}

void updatePlaylistCount(void)
{
	int  first_idx, last_idx, string_length;
	char text[12];

	// update the current playlist range displayed in the header
	first_idx = curr_idx - curr_highlight + 1;
	if (photo_playlist_mode) {
		last_idx = ((curr_idx - curr_highlight + 10) > (no_of_playlist_photos - 1)) ? no_of_playlist_photos : first_idx + 9;
	}
	else {
		last_idx = ((curr_idx - curr_highlight + 10) > (no_of_playlist_mp3s - 1)) ? no_of_playlist_mp3s : first_idx + 9;
	}

	TAP_Osd_FillBox(region_mem, X+W-5-100, Y+4, 100, 20, header_bg_colour);
	if (last_idx > 0) 
	{
		TAP_SPrint(text, " %d %s %d", first_idx, to_t, last_idx);
		string_length = getWidth(text, FNT_Size_1622);
		
		drawText(region_mem, X+W-5-string_length, Y+4, X+W-1, text, header_text_colour, header_bg_colour, FNT_Size_1622);
	}
}

void drawPlaylistFooter(int idx)
{
	word help_y_offset, help_x_offset = X+W-365;

	// blank out the box
	TAP_Osd_FillBox(region_mem, X, Y+H-122+1, W+1, 120+7+1, footer_bg_colour);
	TAP_Osd_FillBox(region_mem, X+(W-380), Y+323, 2, 120+7+1, frame_colour);

	// display standard button help
	help_y_offset = Y+330;
	drawText(region_mem, help_x_offset, help_y_offset, -1, ok_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset, help_y_offset, -1, tv_radio_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset, help_y_offset, -1, "1:", help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset, help_y_offset, -1, "3:", help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	if (mp3_playing) {drawText(region_mem, help_x_offset, help_y_offset, -1, stop_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;}
	if (!photo_playlist_mode) drawText(region_mem, help_x_offset, help_y_offset, -1, slow_t, help_text_colour, COLOR_None, FNT_Size_1419);

	help_y_offset = Y+330;
	if (!photo_playlist_mode) {drawText(region_mem, help_x_offset+70, help_y_offset, -1, resume_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;}
	else {drawText(region_mem, help_x_offset+70, help_y_offset, -1, show_photo_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;}
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, photo_playlist_mode ? slideshow_t : play_all_tunes_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, load_playlist_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, shuffle_up_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, shuffle_down_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	if (mp3_playing) {drawText(region_mem, help_x_offset+70, help_y_offset, -1, stop_tune_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;}
	if (!photo_playlist_mode) drawText(region_mem, help_x_offset+70, help_y_offset, -1, search_t, body_text_colour, COLOR_None, FNT_Size_1419);

	// display coloured button help keys
	help_x_offset = X+W-365+45;
	drawHelpButton(region_mem, help_x_offset+160, Y+330, RGB8888(224,224,224), COLOR_None, OSD_WHITE); 
	drawHelpButton(region_mem, help_x_offset+160, Y+346, RGB8888(0,224,0), COLOR_None, OSD_GREEN); 
	drawHelpButton(region_mem, help_x_offset+160, Y+362, RGB8888(224,224,224), RGB8888(225,20,20), OSD_RECORD); 
	if (mp3_playing) {
		drawHelpButton(region_mem, help_x_offset+160, Y+378, RGB8888(240,0,0), COLOR_None, OSD_RED); 
		drawHelpButton(region_mem, help_x_offset+160, Y+394, RGB8888(0,0,224), COLOR_None, OSD_BLUE); 
	}

	// display coloured button help text
	drawText(region_mem, help_x_offset+160+20+7, Y+330, -1, delete_item_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+160+20+7, Y+346, -1, clear_playlist_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+160+20+7, Y+362, -1, save_playlist_t, body_text_colour, COLOR_None, FNT_Size_1419);
	if (mp3_playing) {
		drawText(region_mem, help_x_offset+160+20+7, Y+378, -1, previous_tune_t, body_text_colour, COLOR_None, FNT_Size_1419);
		drawText(region_mem, help_x_offset+160+20+7, Y+394, -1, next_tune_t, body_text_colour, COLOR_None, FNT_Size_1419);
	}

	// populate id3 info for an mp3
	if (!photo_playlist_mode && !disable_file_details && no_of_playlist_mp3s > 0) {
		word id3_y_offset = Y+330; struct media_files *mp3_header;

		// if trying to show details for currently playing mp3, then use saved id3 details (since we can't open the file)
		if (mp3_playing && strcmp(mp3_playlist[idx]->directory, mp3_files[current_mp3]->directory) == 0
						&& strcmp(mp3_playlist[idx]->file_name, mp3_files[current_mp3]->file_name) == 0) {
			copyID3ToID3(TRUE, FALSE);
		}
		ef ((mp3_header = getMp3Header(mp3_playlist[idx]->file_name, mp3_playlist[idx]->directory, 0, 0, 0, FALSE, FALSE, FALSE))
				&& mp3_header->header_loaded) {
			copyMp3HeaderToID3(mp3_header);
		}
		else {
			ChangeDirPath(mp3_playlist[idx]->directory);
			readID3Tag(mp3_playlist[idx]->file_name, FALSE, FALSE);
			ChangeDirPath(curr_dir);
		}

		if (id3_info->artist && strlen(id3_info->artist) > 0) {
			drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->artist, info_header_colour, COLOR_None, FNT_Size_1419);
			id3_y_offset += 15;
		}
		if (id3_info->title && strlen(id3_info->title) > 0) {
			drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->title, info_detail_colour, COLOR_None, FNT_Size_1419);
			id3_y_offset += 15;
		}
		if (id3_info->album && strlen(id3_info->album) > 0) {
			drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->album, info_header_colour, COLOR_None, FNT_Size_1419);
			id3_y_offset += 15;
		}
		if (id3_info->genre_code && strlen(id3_info->genre_code) > 0) {
			drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->genre, info_header_colour, COLOR_None, FNT_Size_1419);
			id3_y_offset += 15;
		}
		if (id3_info->year && strlen(id3_info->year) > 0) {
			drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->year, info_header_colour, COLOR_None, FNT_Size_1419);
			id3_y_offset += 15;
		}

		destroy_ID3(id3_info);
		id3_info = NULL;
	}

	// populate exif info for a jpeg
	if (photo_playlist_mode && !disable_file_details && no_of_playlist_photos > 0) {
		int i = 0;
		help_y_offset = Y+330;
		no_of_details = 0;
		ChangeDirPath(photo_playlist[idx]->directory);
		ProcessFile(photo_playlist[idx]->file_name);
		while (i < no_of_details && i < 5) {
			drawText(region_mem, X+5, help_y_offset, X+110-1, photo_exif[i].heading, info_header_colour, COLOR_None, FNT_Size_1419);
			drawText(region_mem, X+110, help_y_offset, X+115+140-1, photo_exif[i].detail, info_detail_colour, COLOR_None, FNT_Size_1419);
			help_y_offset += 15;
			i++;
		}
		ChangeDirPath(curr_dir);
	}
}

void drawPlaylistHeader(void)
{
	dword string_length;
	word indent;

	TAP_Osd_FillBox(region_mem, X, Y, W, 30, header_bg_colour);
	if (show_header_icons)
		TAP_Osd_PutGd(region_mem, X+10, Y+1, &_playlistGd, TRUE);
	else
		drawText(region_mem, X+1, Y+6, -1, text_for_help_t, header_text_colour, COLOR_None, FNT_Size_1419);

	if (photo_playlist_mode) {
		if (no_of_playlist_photos == 1)
			TAP_SPrint(buffer, "%s - %d %s", photo_playlist_t, no_of_playlist_photos, photo_t);
		else
			TAP_SPrint(buffer, "%s - %d %s", photo_playlist_t, no_of_playlist_photos, photos_t);
		//TAP_SPrint(buffer, "Photo playlist - %s", photo_playlist_name);
	}
	else {
		if (no_of_playlist_mp3s == 1)
			TAP_SPrint(buffer, "%s - %d %s", mp3_playlist_t, no_of_playlist_mp3s, tune_t);
		else
			TAP_SPrint(buffer, "%s - %d %s", mp3_playlist_t, no_of_playlist_mp3s, tunes_t);
	}

	string_length = getWidth(buffer, FNT_Size_1926);
	indent = X-5 + ((W+10 - string_length) / 2);
	drawText(region_mem, indent, Y, -1, buffer, header_text_colour, COLOR_None, FNT_Size_1926);
}

void drawPlaylistLine(int line_idx, int data_idx)
{
	int j;
	dword fc, dc;

	j = 30 + (line_idx * 29);
	j += 3;

	if (data_idx < no_of_files && line_idx == curr_highlight) {
		initialiseLine(X-5, Y+j, W+10+1, 26, highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
		dc = highlight_text_colour;
	}
	else {
		initialiseLine(X-5, Y+j, W+10+1, 26, background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
		dc = detail_text_colour;
	}
	if (!photo_playlist_mode) TAP_Osd_FillBox(region_mem, X+W-80, Y+j, 2, 26, frame_colour);

	if (data_idx >= no_of_files)
		return;

	if (photo_playlist_mode) {
		memset(buffer, '\0', 100);
		strncat(buffer, photo_playlist[data_idx]->file_name, strlen(photo_playlist[data_idx]->file_name)-4);
	}
	else {
		memset(buffer, '\0', 100);
		strncat(buffer, mp3_playlist[data_idx]->file_name, strlen(mp3_playlist[data_idx]->file_name)-4);
	}
	drawText(region_mem, X+5, Y+j+3, X+W-4, buffer, fc, COLOR_None, FNT_Size_1622);

	if (!photo_playlist_mode) {
		struct media_files *mp3_header = getMp3Header(mp3_playlist[data_idx]->file_name, mp3_playlist[data_idx]->directory, 0, 0, 0, TRUE, TRUE, FALSE);

		if (mp3_header && mp3_header->duration > 0) {
			TAP_SPrint(buffer, " %d:%02d", mp3_header->duration / 60, mp3_header->duration % 60);
			drawText(region_mem, X+W-80+5, Y+j+3, X+W-3, buffer, dc, COLOR_None, FNT_Size_1622);
		}
	}
}

void drawPlaylistLines(word start)
{
	int i;

	// draw each line
	for (i = 0; i < 10; i++)
	{
		drawPlaylistLine(i, start + i);
	}

	updatePlaylistCount();
}

void drawPlaylist(bool draw_background)
{
	TAP_ExitNormal();

	// header section
	drawPlaylistHeader();
	
	// 10 list items
	drawBlankFileList(10);

	curr_idx = saved_playlist_idx;
	curr_highlight = saved_playlist_highlight;
	if (curr_highlight < 0) {
		if (no_of_files > 10 && (curr_idx >= (no_of_files - 10)))
			curr_highlight = 10 - (no_of_files - curr_idx);
		else
			curr_highlight = curr_idx % 10;
	}
	drawPlaylistLines(curr_idx - curr_highlight);

	updatePlaylistCount();

	// populate the footer box
	drawPlaylistFooter(curr_idx);

	if (draw_background)
		drawRoundedRectangle(region, X, Y, W, H, 3, 10, 30, 122, frame_colour, COLOR_None, body_bg_colour, FALSE);

#ifndef WIN32
	drawArea(region, X+(W-380), Y+H-121+3, 2, 121+3, frame_colour);
#endif
}

void getMp3InfoString(char *mp3_string, TYPE_PlayInfo play_info, bool include_artist, bool include_position, bool calculate_progress_offset)
{
	char temp[25];
	word mp3_length, mp3_progress;

	memset(mp3_string, '\0', 135);

	// string together the artist and track name
	if (playing_id3_info->title && playing_id3_info->artist 
			&& strlen(playing_id3_info->title) > 0 && strlen(playing_id3_info->artist) > 0) {
		if (include_artist) {
			strcpy(mp3_string, playing_id3_info->artist);
			strcat(mp3_string, " - ");
			strcat(mp3_string, playing_id3_info->title);
		}
		else {
			strcpy(mp3_string, playing_id3_info->title);
		}
	}
	else {
		if (play_info.file)
			strncat(mp3_string, play_info.file->name, strlen(play_info.file->name)-4);
	}

	// string together the number of this mp3 and the total mp3s
	if (include_position) {
		TAP_SPrint(temp, " - %d %s %d %s", current_mp3+1, of_t, no_of_mp3s, tunes_t);
		strcat(mp3_string, temp);
	}

	// get the mp3 progress
	mp3_length = play_info.duration;
	mp3_progress = play_info.currentBlock;
	if (mp3_progress > mp3_length) mp3_progress = mp3_length;
	strcat(mp3_string, " - ");
	if (calculate_progress_offset) 
		mp3_progress_offset = getWidth(mp3_string, FNT_Size_1419);
	TAP_SPrint(temp, "%02d:%02d %s %02d:%02d", mp3_progress / 60, mp3_progress % 60, of_t, mp3_length / 60, mp3_length % 60);
	strcat(mp3_string, temp);
}

void refreshMp3Progress()
{
	TYPE_PlayInfo play_info;
	word mp3_progress, mp3_length, string_length;
	char text[6];

	// for the video manager we display the used disk space
	if (InDataFilesFolder(curr_dir) || recycle_bin_displayed) 
		return;

	if (mp3_progress_offset > 0 || compact_mode_started) {
		if (compact_mode_started && burnout_delay && TAP_GetTick() > (burnout_tick + burnout_delay*100)) {
			compact_offset_x = ((getRandom() % ((compact_art_mode || compact_tv_mode) ? 4 : 6)) + 1) * 45;
			compact_offset_y = ((getRandom() % ((compact_art_mode || compact_tv_mode) ? 6 : 8)) + 1) * 36;
			refreshCompactMode(TRUE);
			burnout_tick = TAP_GetTick();
		}

		// get the mp3 progress
		TAP_Hdd_GetPlayInfo(&play_info);
		mp3_length = play_info.duration;
		mp3_progress = play_info.currentBlock;
		if (mp3_progress > mp3_length) mp3_progress = mp3_length;
		TAP_SPrint(text, "%02d:%02d", mp3_progress / 60, mp3_progress % 60);
		string_length = getWidth(text, FNT_Size_1419);

		if (slideshow_started || album_art_started) {
			TAP_Osd_FillBox(slideshow_started ? region_now : region, mp3_progress_offset, offset_y+450+10+1, string_length+2, 30-4, COLOR_Black);
			drawText(slideshow_started ? region_now : region, mp3_progress_offset, offset_y+VIEW_H+10+5, mp3_progress_offset+string_length, text, body_text_colour, COLOR_None, FNT_Size_1419);
		}
		ef (compact_mode_started) {
			TAP_Osd_FillBox(region, mp3_progress_offset, (compact_art_mode || compact_tv_mode) ? compact_offset_y+192 : compact_offset_y+150, string_length+2, 20, COLOR_Black);
			drawText(region, mp3_progress_offset, (compact_art_mode || compact_tv_mode) ? compact_offset_y+192 : compact_offset_y+152, -1, text, bare_bones_text_colour, COLOR_Black, FNT_Size_1419);
		}
		else {
			TAP_Osd_FillBox(region, mp3_progress_offset, Y+345+124+1, string_length+2, 30-4, COLOR_Black);
			drawText(region, mp3_progress_offset, Y+345+124+5, mp3_progress_offset+string_length, text, body_text_colour, COLOR_None, FNT_Size_1419);
		}
	}
}

void fillDiskSpaceInfoBox(dword percentage, word x, word w, word width_1, word width_2, word colour_1, word colour_2)
{
	if (percentage > 0) gxCircleQuadrant(region, x+5, Y+345+124+11, 10, colour_1, 1, TRUE);
	if (percentage == 100) gxCircleQuadrant(region, x+w-5, Y+345+124+11, 10, colour_1, 2, TRUE);
	if (percentage > 0) gxCircleQuadrant(region, x+5, Y+345+124+17, 10, colour_1, 3, TRUE);
	if (percentage == 100) gxCircleQuadrant(region, x+w-5, Y+345+124+17, 10, colour_1, 4, TRUE);

	if (width_1 > 0) drawArea(region, x-5, Y+345+124+11, 7, 7, colour_1);
	if (width_1 > 0) drawArea(region, x+1, Y+345+124+2, width_1, 13*2, colour_1);
	if (width_2 > 0) drawArea(region, x+1+width_1, Y+345+124+2, width_2, 13*2, colour_2);
}

// for the video manager we display the used disk space
void drawDiskSpaceInfoBox()
{
	dword total_size = 10000, free_size = 1000, recycle_size = 2000, total_percentage = 0, recycle_percentage = 0, normal_percentage = 0, indent;
	word colour, width_1, width_2;

	if (!recycle_bin_displayed && (!InDataFilesFolder(curr_dir) && !thumbnail_mode && !mp3_playing)) {
		TAP_Osd_FillBox(region, X-10, Y+345+124-2, W+20, 30+4, COLOR_None);
		return;
	}

	if (recycle_bin_displayed || (InDataFilesFolder(curr_dir) && !thumbnail_mode)) {
		TAP_Osd_FillBox(region, X-10, Y+345+124-2, W+20, 30+4, COLOR_None);

#ifndef WIN32
		total_size = TAP_Hdd_TotalSize();	// gets total size in MB
		free_size = TAP_Hdd_FreeSize();		// gets free size in MB
		recycle_size = getTotalRecycledFileSize();
#endif
		total_percentage = ((total_size-free_size)*100) / total_size;
		recycle_percentage = recycle_size*100 / total_size;
		normal_percentage = total_percentage - recycle_percentage;
			
		// safety checks
		if (recycle_percentage > total_percentage) {
			recycle_percentage = total_percentage; normal_percentage = 0; recycle_size = total_size;
		}
				
		if (!recycle_bin_displayed) {
			// set the bar colour
			colour = (total_percentage < 50) ? disk_good_colour : (total_percentage < 75) ? disk_medium_colour : disk_bad_colour;

			// work out the width of the bar
			width_1 = (W-(10*2))*normal_percentage/100;
			width_2 = (W-(10*2))*recycle_percentage/100;

			// draw the bar
			drawRoundedRectangle(region, X, Y+1+345+124+5, W, 16, 3, 0, 0, 0, frame_colour, COLOR_None, COLOR_Black, TRUE);
			if (masterpiece_mode == 1) {
				TAP_Osd_FillBox(region, X-5, Y+1+345+124+5-5, width_1, 16+10, colour);
				if (width_2 > 0) TAP_Osd_FillBox(region, X-5+width_1, Y+1+345+124+5-5, width_2, 16+10, recycled_colour == COLOR_None ? colour : recycled_colour);
			}
			else
				fillDiskSpaceInfoBox(total_percentage, X, W, width_1, width_2, colour, recycled_colour == COLOR_None ? colour : recycled_colour);

			switch (disk_space_format) {
				case GB_USED: case GB_USED_LARGE:
					TAP_SPrint(buffer, "%s: %dGB ", disk_space_used_t, (total_size - free_size) / 1024);
					break;
				case PERCENTAGE_USED: case PERCENTAGE_USED_LARGE:
					TAP_SPrint(buffer, "%s: %d%s", disk_space_used_t, total_percentage, "%");
					break;
				case GB_FREE: case GB_FREE_LARGE:
					TAP_SPrint(buffer, "%s: %dGB ", disk_space_free_t, free_size / 1024);
					break;
				case PERCENTAGE_FREE: case PERCENTAGE_FREE_LARGE:
					TAP_SPrint(buffer, "%s: %d%s", disk_space_free_t, (100 - total_percentage), "%");
					break;
			}
			if (show_remaining_hours) {
				TAP_SPrint(buffer2, "  (%d %s)", free_size / ((megabytes_per_hour ? megabytes_per_hour : (isTF5800() ? 30 : 50)) * 60), hours_remain_t);
				strcat(buffer, buffer2);
			}

			switch (disk_space_format) {
				case GB_USED: case PERCENTAGE_USED:	case GB_FREE: case PERCENTAGE_FREE:
					indent = X-10 + (((W+20) - getWidth(buffer, FNT_Size_1419)) / 2);
					drawText(region, indent, Y+345+124+5, X-5+W+10-2-1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
					break;
				case GB_USED_LARGE:	case PERCENTAGE_USED_LARGE:	case GB_FREE_LARGE:	case PERCENTAGE_FREE_LARGE:
					indent = X-10 + (((W+20) - getWidth(buffer, FNT_Size_1622)) / 2);
					drawText(region, indent, Y+345+124+4, X-5+W+10-2-1, buffer, body_text_colour, COLOR_None, FNT_Size_1622);
					break;
			}
		}
		else {
			// set the bar colour
			colour = (normal_percentage < 50) ? disk_good_colour : (normal_percentage < 75) ? disk_medium_colour : disk_bad_colour;

			// work out the width of the half bar
			width_1 = ((W/2-20)-(10*2))*normal_percentage/100;

			// draw the half bar
			drawRoundedRectangle(region, X, Y+1+345+124+5, W/2-20, 16, 3, 0, 0, 0, frame_colour, COLOR_None, COLOR_Black, TRUE);
			if (masterpiece_mode == 1)
				TAP_Osd_FillBox(region, X-5, Y+1+345+124+5-5, width_1, 16+10, colour);
			else
				fillDiskSpaceInfoBox(normal_percentage, X, (W/2-20), width_1, 0, colour, 0);

			// overlay the info text
			switch (disk_space_format) {
				case GB_USED: case GB_FREE:	case GB_USED_LARGE:	case GB_FREE_LARGE:
					TAP_SPrint(buffer, "%s: %dGB ", normal_space_used_t, ((total_size - free_size) - recycle_size) / 1024);
					break;
				case PERCENTAGE_USED: case PERCENTAGE_FREE:	case PERCENTAGE_USED_LARGE:	case PERCENTAGE_FREE_LARGE:
					TAP_SPrint(buffer, "%s: %d%s", normal_space_used_t, normal_percentage, "%");
					break;
			}

			switch (disk_space_format) {
				case GB_USED: case PERCENTAGE_USED:	case GB_FREE: case PERCENTAGE_FREE:
					indent = X-10 + ((((W/2-20)+20) - getWidth(buffer, FNT_Size_1419)) / 2);
					drawText(region, indent, Y+345+124+5, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
					break;
				case GB_USED_LARGE: case PERCENTAGE_USED_LARGE:	case GB_FREE_LARGE:	case PERCENTAGE_FREE_LARGE:
					indent = X-10 + ((((W/2-20)+20) - getWidth(buffer, FNT_Size_1622)) / 2);
					drawText(region, indent, Y+345+124+4, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1622);
					break;
			}

			// set the bar colour
			colour = (recycle_percentage < 50) ? disk_good_colour : (recycle_percentage < 75) ? disk_medium_colour : disk_bad_colour;

			// work out the width of the half bar
			width_1 = ((W/2-20)-(10*2))*recycle_percentage/100;

			// draw the half bar
			drawRoundedRectangle(region, X+(W/2+20), Y+1+345+124+5, W/2-20, 16, 3, 0, 0, 0, frame_colour, COLOR_None, COLOR_Black, TRUE);
			if (masterpiece_mode == 1)
				TAP_Osd_FillBox(region, X+(W/2+20)-5, Y+1+345+124+5-5, width_1, 16+10, colour);
			else
				fillDiskSpaceInfoBox(recycle_percentage, X+(W/2+20), (W/2-20), width_1, 0, colour, 0);

			// overlay the info text
			switch (disk_space_format) {
				case GB_USED: case GB_FREE:	case GB_USED_LARGE:	case GB_FREE_LARGE:
					TAP_SPrint(buffer, "%s: %dGB ", recycle_space_used_t, recycle_size / 1024);
					break;
				case PERCENTAGE_USED: case PERCENTAGE_FREE:	case PERCENTAGE_USED_LARGE:	case PERCENTAGE_FREE_LARGE:
					TAP_SPrint(buffer, "%s: %d%s", recycle_space_used_t, recycle_percentage, "%");
					break;
			}

			switch (disk_space_format) {
				case GB_USED: case PERCENTAGE_USED:	case GB_FREE: case PERCENTAGE_FREE:
					indent = X+(W/2+20)-10 + ((((W/2-20)+20) - getWidth(buffer, FNT_Size_1419)) / 2);
					drawText(region, indent, Y+345+124+5, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
					break;
				case GB_USED_LARGE:	case PERCENTAGE_USED_LARGE:	case GB_FREE_LARGE:	case PERCENTAGE_FREE_LARGE:
					indent = X+(W/2+20)-10 + ((((W/2-20)+20) - getWidth(buffer, FNT_Size_1622)) / 2);
					drawText(region, indent, Y+345+124+4, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1622);
					break;
			}
		}
	}
}

void drawMp3InfoBox() 
{
	word string_length, indent, box_offset_x, box_offset_y, box_width;
	char info[135];
	bool calculate_progress_offset = (mp3_progress_offset == 0) ? TRUE : FALSE;
	TYPE_PlayInfo play_info;

	if (!mp3_playing || mp3_stopping)
		return;
#ifndef WIN32
	if ((slideshow_started && !full_size_display) || album_art_started) {
		box_width = VIEW_W; box_offset_x = offset_x; box_offset_y = offset_y; 
		if (slideshow_started){
			TAP_Osd_DrawRectangle(region_1, box_offset_x-1, box_offset_y+450+10-1, box_width+2, 30, 2, frame_colour);
			TAP_Osd_FillBox(region_1, box_offset_x+1, box_offset_y+450+10+1, box_width-2, 30-4, COLOR_Black);
			if (fade_image) {
				TAP_Osd_DrawRectangle(region_2, box_offset_x-1, box_offset_y+450+10-1, box_width+2, 30, 2, frame_colour);
				TAP_Osd_FillBox(region_2, box_offset_x+1, box_offset_y+450+10+1, box_width-2, 30-4, COLOR_Black);
			}
		}
		else {
			TAP_Osd_DrawRectangle(region, box_offset_x-1, box_offset_y+450+10-1, box_width+2, 30, 2, frame_colour);
			TAP_Osd_FillBox(region, box_offset_x+1, box_offset_y+450+10+1, box_width-2, 30-4, COLOR_Black);
		}
	}
	else {
		box_width = W+10; box_offset_x = X-5; box_offset_y = Y; 

		TAP_Osd_FillBox(region, X-10, Y+345+124-2, W+20, 30+4, COLOR_None);
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Draw rounded rectangle, frame colour %d", frame_colour);
		if (write_log) if (verbose) logText(log_buffer, FALSE);
		drawRoundedRectangle(region, X, Y+1+345+124+5, W, 16, 3, 0, 0, 0, frame_colour, COLOR_None, COLOR_Black, TRUE);
	}

	// construct the mp3 info string
	TAP_Hdd_GetPlayInfo(&play_info);
	getMp3InfoString(info, play_info, TRUE, TRUE, calculate_progress_offset);

	// get string length, and remove artist, then position info if it is too long
	string_length = getWidth(info, FNT_Size_1419);
	if (string_length > box_width-2) {
		if (calculate_progress_offset) mp3_progress_offset = 0;
		getMp3InfoString(info, play_info, FALSE, TRUE, calculate_progress_offset);
		string_length = getWidth(info, FNT_Size_1419);
		if (string_length > box_width-2) {
			if (calculate_progress_offset) mp3_progress_offset = 0;
			getMp3InfoString(info, play_info, FALSE, FALSE, calculate_progress_offset);
			string_length = getWidth(info, FNT_Size_1419);
		}
	}
	if (string_length > box_width-2) string_length = box_width-2; // if info still too long, then curtail it
	
	// draw the constructed mp3 info string to OSD
	indent = box_offset_x + ((box_width - string_length) / 2);
	if (slideshow_started && !full_size_display) {
		drawText(region_1, indent, box_offset_y+450+15, box_offset_x+box_width-1, info, body_text_colour, COLOR_None, FNT_Size_1419);
		if (fade_image) drawText(region_2, indent, box_offset_y+450+15, box_offset_x+box_width-1, info, body_text_colour, COLOR_None, FNT_Size_1419);
	}
	ef (album_art_started)
		drawText(region, indent, box_offset_y+450+15, box_offset_x+box_width-1, info, body_text_colour, COLOR_None, FNT_Size_1419);
	else
		drawText(region, indent, box_offset_y+345+124+5, box_offset_x+box_width-1, info, body_text_colour, COLOR_None, FNT_Size_1419);

	// calculate the offset for the time progress (only do this when the track starts or switching modes)
	if (calculate_progress_offset)
		mp3_progress_offset += indent;
#endif
}

void formatProgressString(char *output, dword watched_mins, word duration, int current_block, int total_block, dword progress_format)
{
	switch (progress_format) {
		case MINS_GONE_MINS_LEFT:
			TAP_SPrint(output, "+%d/-%d", watched_mins, duration - watched_mins);
			break;
		case MINS_GONE:
			TAP_SPrint(output, "%d%s", watched_mins, m_t);
			break;
		case MINS_LEFT:
			TAP_SPrint(output, "-%d%s", duration - watched_mins, m_t);
			break;
		case HOURS_MINS_GONE:
			if (watched_mins > 59)
				TAP_SPrint(output, "%d%s %d%s", watched_mins / 60, h_t, watched_mins % 60, m_t);
			else
				TAP_SPrint(output, "%d%s", watched_mins, m_t);
			break;
		case HOURS_MINS_LEFT:
			if (duration - watched_mins > 59)
				TAP_SPrint(output, "-%d%s %d%s", (duration - watched_mins) / 60, h_t, (duration - watched_mins) % 60, m_t);
			else
				TAP_SPrint(output, "-%d%s", duration - watched_mins, m_t);
			break;
		case PERCENTAGE_GONE:
			if (current_block > 0 && total_block > 0)
				TAP_SPrint(output, "%d%s", current_block * 100 / total_block, "%");
			ef (duration > 0)
				TAP_SPrint(output, "%d%s", watched_mins * 100 / duration, "%");
			break;
		case PERCENTAGE_LEFT:
			if (current_block > 0 && total_block > 0)
				TAP_SPrint(output, "-%d%s", 100 - ((current_block * 100) / total_block), "%");
			ef (duration > 0)
				TAP_SPrint(output, "-%d%s", 100 - ((watched_mins * 100) / duration), "%");
			break;
	}
}

void formatFooterHeader(int idx, word duration, bool no_progress, char *temp, bool draw_logos)
{
	// clear out any old junk in here
	memset(temp, '\0', 256);

	// format the footer rec header string
	switch (footer_rec_header_format) {
		case EVENT_NAME:
			strcpy(temp, dir_info[idx]->event_name); 
			break;
		case CHANNEL_ONLY:
			if (display_logos && dir_info[idx]->attr == ATTR_TS) {
				if (draw_logos) {
					DisplayLogo(region_mem, X+5, Y+330+3-5, dir_info[idx]->service_num, dir_info[idx]->service_type, dir_info[idx]->service_name);
					TAP_Osd_FillBox(region_mem, X+5, Y+330+3-5+30, 60, 9, footer_bg_colour);
					TAP_Osd_FillBox(region_mem, X+5+47, Y+330+3-5, 13, 47, footer_bg_colour);
				}
			}
			else
				strcpy(temp, dir_info[idx]->service_name); 
			break;
		case CHANNEL_PLUS_TIME:
			if (display_logos && dir_info[idx]->attr == ATTR_TS) {
				if (draw_logos) {
					DisplayLogo(region_mem, X+5, Y+330+3-5, dir_info[idx]->service_num, dir_info[idx]->service_type, dir_info[idx]->service_name);
					TAP_Osd_FillBox(region_mem, X+5, Y+330+3-5+30, 60, 9, footer_bg_colour);
					TAP_Osd_FillBox(region_mem, X+5+47, Y+330+3-5, 13, 47, footer_bg_colour);
				}
				if (mjd != 0) {
					TAP_SPrint(temp, "%02d:%02d ~ %02d:%02d", dir_info[idx]->event_start_hour, dir_info[idx]->event_start_min, dir_info[idx]->event_end_hour, dir_info[idx]->event_end_min);
				}
			}
			else {
				strcpy(temp, dir_info[idx]->service_name); 
				if (mjd != 0) {
					TAP_SPrint(buffer, " - %02d:%02d ~ %02d:%02d", dir_info[idx]->event_start_hour, dir_info[idx]->event_start_min, dir_info[idx]->event_end_hour, dir_info[idx]->event_end_min);
					strcat(temp, buffer); 
					if (getWidth(temp, FNT_Size_1622) > (no_progress ? W-150-5 : footer_progress_format == NO_PROGRESS ? W-270-5 : W-335-5))
						strcpy(temp, dir_info[idx]->service_name); 
				}
			}
			break;
		case CHANNEL_PLUS_DATE:
			if (display_logos && dir_info[idx]->attr == ATTR_TS) {
				if (draw_logos) {
					DisplayLogo(region_mem, X+5, Y+330+3-5, dir_info[idx]->service_num, dir_info[idx]->service_type, dir_info[idx]->service_name);
					TAP_Osd_FillBox(region_mem, X+5, Y+330+3-5+30, 60, 9, footer_bg_colour);
					TAP_Osd_FillBox(region_mem, X+5+47, Y+330+3-5, 13, 47, footer_bg_colour);
				}
				if (mjd != 0)
					formatDateString(dir_info[idx]->mjd, temp, FALSE);
			}
			else {
				strcpy(temp, dir_info[idx]->service_name); 
				if (mjd != 0) {
					formatDateString(dir_info[idx]->mjd, buffer, FALSE);
					strcat(temp, " - ");
					strcat(temp, buffer); 
					if (getWidth(temp, FNT_Size_1622) > (no_progress ? W-150-5 : footer_progress_format == NO_PROGRESS ? W-270-5 : W-335-5))
						strcpy(temp, dir_info[idx]->service_name); 
				}
			}
			break;
		case CHANNEL_PLUS_SIZE:
			if (display_logos && dir_info[idx]->attr == ATTR_TS) {
				if (draw_logos) {
					DisplayLogo(region_mem, X+5, Y+330+3-5, dir_info[idx]->service_num, dir_info[idx]->service_type, dir_info[idx]->service_name);
					TAP_Osd_FillBox(region_mem, X+5, Y+330+3-5+30, 60, 9, footer_bg_colour);
					TAP_Osd_FillBox(region_mem, X+5+47, Y+330+3-5, 13, 47, footer_bg_colour);
				}
				if (dir_info[idx]->size > 0) {
					dword mb = dir_info[idx]->size / 1048576;
					if (!isRadioRecording(idx) && (duration > 0))
						formatFileSize(&mb, duration);
					TAP_SPrint(temp, "%d MB", mb);
				}
			}
			else {
				strcpy(temp, dir_info[idx]->service_name); 
				if (dir_info[idx]->size > 0) {
					dword mb = dir_info[idx]->size / 1048576;
					if (!isRadioRecording(idx) && (duration > 0))
						formatFileSize(&mb, duration);
					TAP_SPrint(buffer, " - %d MB", mb);
					strcat(temp, buffer); 
					if (getWidth(temp, FNT_Size_1622) > (no_progress ? W-150-5 : footer_progress_format == NO_PROGRESS ? W-270-5 : W-335-5))
						strcpy(temp, dir_info[idx]->service_name); 
				}
			}
			break;
		case CHANNEL_PLUS_DURATION:
			if (display_logos && dir_info[idx]->attr == ATTR_TS) {
				if (draw_logos) {
					DisplayLogo(region_mem, X+5, Y+330+3-5, dir_info[idx]->service_num, dir_info[idx]->service_type, dir_info[idx]->service_name);
					TAP_Osd_FillBox(region_mem, X+5, Y+330+5-3+30, 60, 9, footer_bg_colour);
					TAP_Osd_FillBox(region_mem, X+5+47, Y+330+3-5, 13, 47, footer_bg_colour);
				}
				if (duration > 0) {
					if (duration > 119)
						TAP_SPrint(temp, " - %d %s %d %s", duration / 60, hours_t, duration % 60, mins_t);
					ef (duration > 59)
						TAP_SPrint(temp, " - %d %s %d %s", duration / 60, hour_t, duration % 60, mins_t);
					else
						TAP_SPrint(temp, " - %d %s", duration, mins_t);
				}
			}
			else {
				strcpy(temp, dir_info[idx]->service_name); 
				if (duration > 0) {
					if (duration > 119)
						TAP_SPrint(buffer, " - %d %s %d %s", duration / 60, hours_t, duration % 60, mins_t);
					ef (duration > 59)
						TAP_SPrint(buffer, " - %d %s %d %s", duration / 60, hour_t, duration % 60, mins_t);
					else
						TAP_SPrint(buffer, " - %d %s", duration, mins_t);
					strcat(temp, buffer); 
					if (getWidth(temp, FNT_Size_1622) > (no_progress ? W-150-5 : footer_progress_format == NO_PROGRESS ? W-270-5 : W-335-5))
						strcpy(temp, dir_info[idx]->service_name); 
				}
			}
			break;
		case CHANNEL_PLUS_EVENT_NAME:
			if (display_logos && dir_info[idx]->attr == ATTR_TS) {
				if (draw_logos) {
					DisplayLogo(region_mem, X+5, Y+330+3-5, dir_info[idx]->service_num, dir_info[idx]->service_type, dir_info[idx]->service_name);
					TAP_Osd_FillBox(region_mem, X+5, Y+330+5-3+30, 60, 9, footer_bg_colour);
					TAP_Osd_FillBox(region_mem, X+5+47, Y+330+3-5, 13, 47, footer_bg_colour);
				}
				strcpy(temp, dir_info[idx]->event_name); 
			}
			else {
				strcpy(temp, dir_info[idx]->service_name); 
				TAP_SPrint(buffer, " - %s", dir_info[idx]->event_name);
				strcat(temp, buffer); 
				if (getWidth(temp, FNT_Size_1622) > (no_progress ? W-150-5 : footer_progress_format == NO_PROGRESS ? W-270-5 : W-335-5))
					strcpy(temp, dir_info[idx]->service_name); 
			}
			break;
		case CHANNEL_PLUS_BIT_RATE:
			if (display_logos && dir_info[idx]->attr == ATTR_TS) {
				dword mb = dir_info[idx]->size / 1048576;
				if (draw_logos) {
					DisplayLogo(region_mem, X+5, Y+330+3-5, dir_info[idx]->service_num, dir_info[idx]->service_type, dir_info[idx]->service_name);
					TAP_Osd_FillBox(region_mem, X+5, Y+330+5-3+30, 60, 9, footer_bg_colour);
					TAP_Osd_FillBox(region_mem, X+5+47, Y+330+3-5, 13, 47, footer_bg_colour);
				}
				
				TAP_SPrint(temp, "%d.%02d GB/%s", ((mb * 60 / duration) / 1024), (((mb * 60 * 100) / duration) / 1024) % 100, h_t);
			}
			else {
				dword mb = dir_info[idx]->size / 1048576;
				strcpy(temp, dir_info[idx]->service_name); 
				TAP_SPrint(buffer, " - %d.%02d GB/%s", ((mb * 60 / duration) / 1024), (((mb * 60 * 100) / duration) / 1024) % 100, h_t);
				strcat(temp, buffer); 
				if (getWidth(temp, FNT_Size_1622) > (no_progress ? W-150-5 : footer_progress_format == NO_PROGRESS ? W-270-5 : W-335-5))
					strcpy(temp, dir_info[idx]->service_name); 
			}
			break;
	}
}

void formatDateString(word mjd, char *text, bool long_format)
{
	TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
	switch (week_day) {
		case 0: TAP_SPrint(text, "%s", mon_t); break;
		case 1: TAP_SPrint(text, "%s", tue_t); break;
		case 2: TAP_SPrint(text, "%s", wed_t); break;
		case 3: TAP_SPrint(text, "%s", thu_t); break;
		case 4: TAP_SPrint(text, "%s", fri_t); break;
		case 5: TAP_SPrint(text, "%s", sat_t); break;
		case 6: TAP_SPrint(text, "%s", sun_t); break;
	}
	TAP_SPrint(buffer2, " %d ", day);
	strcat(text, buffer2);
	switch (month) {
		case 1: TAP_SPrint(buffer2, "%s", jan_t); break;
		case 2: TAP_SPrint(buffer2, "%s", feb_t); break;
		case 3: TAP_SPrint(buffer2, "%s", mar_t); break;
		case 4: TAP_SPrint(buffer2, "%s", apr_t); break;
		case 5: TAP_SPrint(buffer2, "%s", may_t); break;
		case 6: TAP_SPrint(buffer2, "%s", jun_t); break;
		case 7: TAP_SPrint(buffer2, "%s", jul_t); break;
		case 8: TAP_SPrint(buffer2, "%s", aug_t); break;
		case 9: TAP_SPrint(buffer2, "%s", sep_t); break;
		case 10: TAP_SPrint(buffer2, "%s", oct_t); break;
		case 11: TAP_SPrint(buffer2, "%s", nov_t); break;
		case 12: TAP_SPrint(buffer2, "%s", dec_t); break;
	}
	strcat(text, buffer2);

	if (long_format) {
		TAP_SPrint(buffer2, " %d", year);
		strcat(text, buffer2);
	}
}

void drawRecycleBinFile(int line_idx, int data_idx)
{
	word j;
	dword fc, detail_colour;

	j = 30 + (line_idx * 29) + 3;

	if (data_idx >= no_of_files) {
		initialiseLine(X-5, Y+j, W+10+1, 26, background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
		detail_colour = detail_text_colour;
	}
	ef (line_idx == curr_highlight) {
		initialiseLine(X-5, Y+j, W+10+1, 26, highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
		detail_colour = highlight_text_colour;
	}
	ef (recycle_bin_list[data_idx]->folder) {
		initialiseLine(X-5, Y+j, W+10+1, 26, folder_gradient, folder_bg_colour, tt_folder_bg_colour);
		fc = folder_text_colour;
		detail_colour = folder_text_colour;
	}
	else {
		initialiseLine(X-5, Y+j, W+10+1, 26, background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
		detail_colour = detail_text_colour;
	}

	TAP_Osd_FillBox(region_mem, X+W-120, Y+j, 2, 26, frame_colour);

	if (data_idx >= no_of_files)
		return;

	memset(buffer, '\0', 100);
	strncat(buffer, recycle_bin_list[data_idx]->file_name, strlen(recycle_bin_list[data_idx]->file_name)-4);
	drawText(region_mem, X+5, Y+j+3, X+W-120-4, buffer, fc, COLOR_None, FNT_Size_1622);

	if (!recycle_bin_list[data_idx]->folder) {
		if (recycle_by_deletion_date) {
			if (recycle_bin_list[data_idx]->deletion_mjd > 0)
				formatDateString(recycle_bin_list[data_idx]->deletion_mjd, buffer, FALSE);
			else
				TAP_SPrint(buffer, "Invalid date");
		}
		else {
			if (recycle_bin_list[data_idx]->mjd > 0)
				formatDateString(recycle_bin_list[data_idx]->mjd, buffer, FALSE);
			else
				TAP_SPrint(buffer, "Invalid date");
		}
		drawText(region_mem, X+W-120+10, Y+j+3, X+W-3, buffer, detail_colour, COLOR_None, FNT_Size_1622);
	}
}

void clearFileLine(int line_idx, int data_idx, TYPE_PlayInfo play_info, TYPE_RecInfo rec_info_1, TYPE_RecInfo rec_info_2, int y)
{
	if (data_idx >= no_of_files) {
		int line_height = (InDataFilesFolder(curr_dir) && !recycle_bin_displayed && line_count == 9) ? 30 : 26;
		initialiseLine(X-5, Y+y, W+10+1, line_height, background_gradient, body_bg_colour, tt_body_bg_colour);

		if (InDataFilesFolder(curr_dir)) {
			if (display_logos) {
				TAP_Osd_FillBox(region_mem, X+365, Y+y, 2, line_height, frame_colour);
				TAP_Osd_FillBox(region_mem, X+445, Y+y, 2, line_height, frame_colour);
				TAP_Osd_FillBox(region_mem, X+570, Y+y, 2, line_height, frame_colour);
			}
			else {
				TAP_Osd_FillBox(region_mem, X+415, Y+y, 2, line_height, frame_colour);
				TAP_Osd_FillBox(region_mem, X+495, Y+y, 2, line_height, frame_colour);
			}
		}
		else
			TAP_Osd_FillBox(region_mem, X+W-120, Y+y, 2, 26, frame_colour);

		return;
	}

	if (InDataFilesFolder(curr_dir)) {
		if (line_idx == curr_highlight)
			initialiseLine(X-5, Y+y, W+10+1, line_height, highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		else {
			if (play_info.file && play_info.playMode == PLAYMODE_Playing 
					&& strcmp(play_info.file->name, dir_info[data_idx]->file_name) == 0 
					&& play_info.file->startCluster == dir_info[data_idx]->start_cluster
					&& !stop_playing)
				initialiseLine(X-5, Y+y, W+10+1, line_height, playing_gradient, playing_bg_colour, tt_playing_bg_colour);
			ef (play_info.file && play_info.playMode == PLAYMODE_RecPlaying 
					&& strcmp(play_info.file->name, dir_info[data_idx]->file_name) == 0 
					&& play_info.file->startCluster == dir_info[data_idx]->start_cluster
					&& !stop_playing)
				initialiseLine(X-5, Y+y, W+10+1, line_height, chaseplay_gradient, chaseplay_bg_colour, tt_chaseplay_bg_colour);
			ef (IsDataFilesFolder(curr_dir) 
					&& (strcmp(rec_info_1.fileName, dir_info[data_idx]->file_name) == 0
						|| strcmp(rec_info_2.fileName, dir_info[data_idx]->file_name) == 0))
				initialiseLine(X-5, Y+y, W+10+1, line_height, recording_gradient, recording_bg_colour, tt_recording_bg_colour);
			ef (dir_info[data_idx]->folder)
				initialiseLine(X-5, Y+y, W+10+1, line_height, folder_gradient, folder_bg_colour, tt_folder_bg_colour);
			else
				initialiseLine(X-5, Y+y, W+10+1, line_height, background_gradient, body_bg_colour, tt_body_bg_colour);
		}
		if (display_logos) {
			TAP_Osd_FillBox(region_mem, X+365, Y+y, 2, line_height, frame_colour);
			TAP_Osd_FillBox(region_mem, X+445, Y+y, 2, line_height, frame_colour);
			TAP_Osd_FillBox(region_mem, X+570, Y+y, 2, line_height, frame_colour);
		}
		else {
			TAP_Osd_FillBox(region_mem, X+415, Y+y, 2, line_height, frame_colour);
			TAP_Osd_FillBox(region_mem, X+495, Y+y, 2, line_height, frame_colour);
		}
	}
	else  {
		if (line_idx == curr_highlight)
			initialiseLine(X-5, Y+y, W+10+1, 26, highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		ef (dir_info[data_idx]->folder)
			initialiseLine(X-5, Y+y, W+10+1, 26, folder_gradient, folder_bg_colour, tt_folder_bg_colour);
		else
			initialiseLine(X-5, Y+y, W+10+1, 26, background_gradient, body_bg_colour, tt_body_bg_colour);
		TAP_Osd_FillBox(region_mem, X+W-120, Y+y, 2, 26, frame_colour);
	}
}

void setFileLineColours(int line_idx, int data_idx, TYPE_PlayInfo play_info, TYPE_RecInfo rec_info_1, TYPE_RecInfo rec_info_2, dword *fc, dword *bc, dword *detail_colour)
{
	// sort out the colour for the background and text
	if (dir_info[data_idx]->folder) {
		if (line_idx == curr_highlight) {
			*fc = highlight_text_colour;
			*bc = highlight_bg_colour;
			*detail_colour = highlight_text_colour;
		}
		ef (isParentDirectory(dir_info[data_idx]->file_name)) {
			*fc = detail_text_colour;
			*bc = folder_bg_colour;
			*detail_colour = folder_text_colour;
		}
		else  {
			*fc = folder_text_colour;
			*bc = folder_bg_colour;
			*detail_colour = folder_text_colour;
		}
	}
	else {
		if (InDataFilesFolder(curr_dir)) {
			if (play_info.file && play_info.playMode == PLAYMODE_Playing 
					&& strcmp(play_info.file->name, dir_info[data_idx]->file_name) == 0 
					&& play_info.file->startCluster == dir_info[data_idx]->start_cluster
					&& !stop_playing) {
				*fc = playing_text_colour;
				if (line_idx == curr_highlight)
					*bc = highlight_bg_colour;
				else
					*bc = playing_bg_colour;
				*detail_colour = playing_text_colour;
			}	
			ef (play_info.file && play_info.playMode == PLAYMODE_RecPlaying 
					&& strcmp(play_info.file->name, dir_info[data_idx]->file_name) == 0 
					&& play_info.file->startCluster == dir_info[data_idx]->start_cluster
					&& !stop_playing) {
				*fc = chaseplay_text_colour;
				if (line_idx == curr_highlight)
					*bc = highlight_bg_colour;
				else
					*bc = chaseplay_bg_colour;
				*detail_colour = chaseplay_text_colour;
			}
			ef (IsDataFilesFolder(curr_dir) && 
					(strcmp(rec_info_1.fileName, dir_info[data_idx]->file_name) == 0
						|| strcmp(rec_info_2.fileName, dir_info[data_idx]->file_name) == 0)) {
				*fc = recording_text_colour;
				if (line_idx == curr_highlight)
					*bc = highlight_bg_colour;
				else
					*bc = recording_bg_colour;
				*detail_colour = recording_text_colour;
			}			
			else {
				if (line_idx == curr_highlight) {
					*fc = highlight_text_colour;
					*bc = highlight_bg_colour;
					*detail_colour = highlight_text_colour;
				}
				else {
					*fc = body_text_colour;
					*bc = body_bg_colour;
					*detail_colour = detail_text_colour;
				}
			}
		}
		ef (line_idx == curr_highlight) {
			*fc = highlight_text_colour;
			*bc = highlight_bg_colour;
			*detail_colour = highlight_text_colour;
		}
		else {
			*fc = body_text_colour;
			*bc = body_bg_colour;
			*detail_colour = detail_text_colour;
		}
	}
}

void drawFileLineDetails(int data_idx, dword fc, dword bc, dword detail_colour, int y)
{
	if (dir_info[data_idx]->no_of_jpegs > 0)
	{
		if (dir_info[data_idx]->no_of_jpegs == 1)
			TAP_SPrint(buffer, " %d %s", dir_info[data_idx]->no_of_jpegs, photo_t);
		else
			TAP_SPrint(buffer, " %d %s", dir_info[data_idx]->no_of_jpegs, photos_t);
		if (file_icons_left_aligned)
			drawText(region_mem, X+W-120+5, Y+y+3, X+W+5-3, buffer, fc, bc, FNT_Size_1622);
		else
			drawText(region_mem, X+W-120+25+5, Y+y+3, X+W+5-3, buffer, fc, bc, FNT_Size_1622);
	}

	if (dir_info[data_idx]->no_of_mp3s > 0)
	{
		if (dir_info[data_idx]->no_of_mp3s == 1)
			TAP_SPrint(buffer, " %d %s", dir_info[data_idx]->no_of_mp3s, tune_t);
		else
			TAP_SPrint(buffer, " %d %s", dir_info[data_idx]->no_of_mp3s, tunes_t);
		if (file_icons_left_aligned)
			drawText(region_mem, X+W-120+5, Y+y+3, X+W+5-3, buffer, fc, bc, FNT_Size_1622);
		else
			drawText(region_mem, X+W-120+25+5, Y+y+3, X+W+5-3, buffer, fc, bc, FNT_Size_1622);
	}

	if (dir_info[data_idx]->no_of_recs > 0)
	{
		if (dir_info[data_idx]->no_of_recs == 1)
			TAP_SPrint(buffer, "%d %s", dir_info[data_idx]->no_of_recs, video_t);
		else
			TAP_SPrint(buffer, "%d %s", dir_info[data_idx]->no_of_recs, videos_t);
		if (file_icons_left_aligned)
			drawText(region_mem, X+(display_logos ? W-170 : W-120)+10, Y+y+(display_logos ? 5 : 3), (display_logos ? X+W-45-3 : X+W+5-3), buffer, fc, bc, FNT_Size_1622);
		else
			drawText(region_mem, X+(display_logos ? W-170 : W-120)+27+10, Y+y+(display_logos ? 5 : 3), (display_logos ? X+W-45-3 : X+W+5-3), buffer, fc, bc, FNT_Size_1622);
	}
	
	// lop off the mp3 or jpg extension if appropriate
	if (isMp3(dir_info[data_idx]->file_name) || isPhoto(dir_info[data_idx]->file_name)) {
		if (show_all_files)
			strcpy(buffer, dir_info[data_idx]->file_name);
		else {
			memset(buffer, '\0', 100);
			strncat(buffer, dir_info[data_idx]->file_name, strlen(dir_info[data_idx]->file_name)-getExtensionLength(dir_info[data_idx]->file_name));
		}
	}
	ef (isRec(dir_info[data_idx]->file_name)) {
		switch (display_rec_event_name) {
			case DISPLAY_FILE_NAME:
				if (show_all_files)
					strcpy(buffer, dir_info[data_idx]->file_name);
				else {
					memset(buffer, '\0', 100);
					strncat(buffer, dir_info[data_idx]->file_name, strlen(dir_info[data_idx]->file_name)-getExtensionLength(dir_info[data_idx]->file_name));
				}
				break;

			case DISPLAY_EVENT_NAME:
				TAP_SPrint(buffer, "%s", dir_info[data_idx]->event_name);
				break;

			case DISPLAY_SORT_NAME:
				TAP_SPrint(buffer, "%s", dir_info[data_idx]->sort_name);
				break;
		}
	}
	else {
		if (isParentDirectory(dir_info[data_idx]->file_name))
			TAP_SPrint(buffer, "%s", back_up_t);
		else
			TAP_SPrint(buffer, "%s", dir_info[data_idx]->file_name);
	}

	if (InDataFilesFolder(curr_dir)) {
		if (file_icons_left_aligned)
			drawText(region_mem, X+27, Y+y+(display_logos ? 6 : 3), (display_logos ? (X+W-250-((list_progress_format == NO_PROGRESS || list_progress_format == BAR) ? 0 : 60)-3) : (X+W-200-((list_progress_format == NO_PROGRESS || list_progress_format == BAR)? 0 : 60)-3)), buffer, fc, bc, FNT_Size_1622);
		else
			drawText(region_mem, X+5, Y+y+(display_logos ? 6 : 3), (display_logos ? (X+W-250-((list_progress_format == NO_PROGRESS || list_progress_format == BAR) ? 0 : 60)-3) : (X+W-200-((list_progress_format == NO_PROGRESS || list_progress_format == BAR) ? 0 : 60)-3)), buffer, fc, bc, FNT_Size_1622);
	}
	else {
		if (file_icons_left_aligned)
			drawText(region_mem, X+27, Y+y+3, X+W-120-2, buffer, fc, bc, FNT_Size_1622);
		else
			drawText(region_mem, X+5, Y+y+3, X+W-120-2, buffer, fc, bc, FNT_Size_1622);
	}
}

void setEventDetails(TYPE_RecInfo rec_info, struct _dir_info *dir_info)
{
	TYPE_TapEventDE *de_events; TYPE_TapEvent *events;
	int event_number;
	char *extended_info = NULL;

	if (!dir_info->event_name) {
		dir_info->event_name = dlmalloc(sizeof(char) * 100);
		dir_info->description = dlmalloc(sizeof(char) * 1280);
		dir_info->service_name = dlmalloc(sizeof(char) * 24);

		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Get rec event start");
		if (write_log) if (verbose) logText(log_buffer, FALSE);

		de_events = getDEEvent(rec_info.svcType, rec_info.svcNum, &event_number);
		events = getEvent(rec_info.svcType, rec_info.svcNum, &event_number);

		if (de_events && events) {
			char *desc; byte offset;

			offset = de_events->descOffset;
#ifndef WIN32
			if (!desc_ext_installed)
				offset = 128;
#endif
			desc = de_events->eventNameDesc+offset;

			strcpy(dir_info->event_name, de_events->eventNameDesc);
			strcpy(dir_info->description, desc);
			TAP_Channel_GetInfo(rec_info.svcType, rec_info.svcNum, &channel_info);
			strcpy(dir_info->service_name, channel_info.chName);
			dir_info->service_type = rec_info.svcType;
			dir_info->service_num = rec_info.svcNum;
			extended_info = TAP_EPG_GetExtInfo(events);
			if (extended_info) {
				if (strncmp(desc, extended_info, 127) == 0 || strlen(desc) == 0) {
					strcpy(dir_info->description, extended_info);
				}
				else {
					strcat(dir_info->description, "\n");
					strcat(dir_info->description, extended_info);
				}
			}
		}
		else {
			strcpy(dir_info->event_name, "");
			strcpy(dir_info->description, "");
		}
		//if (de_events) TAP_MemFree(de_events);
		//if (events)	TAP_MemFree(events);
		//de_events = NULL; events = NULL;
		dir_info->event_start_hour = ((rec_info.startTime>>8)&0xff);  
		dir_info->event_start_min  = (rec_info.startTime&0xff);  
		dir_info->event_end_hour = ((rec_info.endTime>>8)&0xff);  
		dir_info->event_end_min  = (rec_info.endTime&0xff);
		
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Get rec event end");
		if (write_log) if (verbose) logText(log_buffer, FALSE);
	}

	if (rec_info.svcType == SVC_TYPE_Radio) dir_info->radio = TRUE;

	if (extended_info) TAP_MemFree(extended_info);
	extended_info = NULL;
}

void getRecLineDetails(int data_idx, TYPE_PlayInfo play_info, TYPE_RecInfo rec_info_1, TYPE_RecInfo rec_info_2, word *duration, word *mjd)
{
	// if duration, mjd & name not yet retrieved, then get them from the header
	if (isRec(dir_info[data_idx]->file_name)) {
#ifndef WIN32
		char *extended_info = NULL;
		
		if (play_info.file && play_info.playMode == PLAYMODE_Playing 
				&& strcmp(play_info.file->name, dir_info[data_idx]->file_name) == 0
				&& play_info.file->startCluster == dir_info[data_idx]->start_cluster) {
			if (!dir_info[data_idx]->event_name) {
				TYPE_Header *header = NULL;
				dir_info[data_idx]->event_name = dlmalloc(sizeof(char) * 100);
				dir_info[data_idx]->description = dlmalloc(sizeof(char) * 1280);
				dir_info[data_idx]->service_name = dlmalloc(sizeof(char) * 24);
				strcpy(dir_info[data_idx]->event_name, play_info.evtInfo.eventName);
				strcpy(dir_info[data_idx]->description, play_info.evtInfo.description);
				TAP_Channel_GetInfo(play_info.svcType, play_info.svcNum, &channel_info);
				strcpy(dir_info[data_idx]->service_name, channel_info.chName);
				dir_info[data_idx]->service_type = play_info.svcType;
				dir_info[data_idx]->service_num = play_info.svcNum;
				if (preload_video_headers)
					header = getRecHeader(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster);
				if (header) {
					strcpy(dir_info[data_idx]->description, header->description);
					dir_info[data_idx]->event_start_hour = header->event_start_hour;
					dir_info[data_idx]->event_start_min  = header->event_start_min;
					dir_info[data_idx]->event_end_hour	= header->event_end_hour;
					dir_info[data_idx]->event_end_min	= header->event_end_min;
				}
				else {
					if (playback_ext_info) {
						strcpy(dir_info[data_idx]->description, playback_ext_info);
					}
					else {
						extended_info = TAP_EPG_GetExtInfo(&play_info.evtInfo);
						if (extended_info) {
							if (strncmp(play_info.evtInfo.description, extended_info, 127) == 0 || strlen(play_info.evtInfo.description) == 0)
								strcpy(dir_info[data_idx]->description, extended_info);
							else {
								strcat(dir_info[data_idx]->description, "\n");
								strcat(dir_info[data_idx]->description, extended_info);
							}
						} 
					}
					gmtToLocalTime(play_info.evtInfo.startTime, mjd, &dir_info[data_idx]->event_start_hour, &dir_info[data_idx]->event_start_min, gmt_offset, gmt_offset_override);
					gmtToLocalTime(play_info.evtInfo.endTime, &end_mjd, &dir_info[data_idx]->event_end_hour, &dir_info[data_idx]->event_end_min, gmt_offset, gmt_offset_override);
					//adjustEndTime(dir_info[data_idx]->event_start_hour, dir_info[data_idx]->event_start_min, &dir_info[data_idx]->event_end_hour, &dir_info[data_idx]->event_end_min, play_info.duration);
				}
			}
			//*mjd = (play_info.evtInfo.startTime>>16)&0xffff;
			*duration = play_info.duration;
			if (play_info.svcType == SVC_TYPE_Radio) dir_info[data_idx]->radio = TRUE;

			if (extended_info) TAP_MemFree(extended_info);
			extended_info = NULL;
		}
		ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[data_idx]->file_name) == 0) {
			setEventDetails(rec_info_1, dir_info[data_idx]);
		}
		ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[data_idx]->file_name) == 0) {
			setEventDetails(rec_info_2, dir_info[data_idx]);
		}
		else {
#endif
			if (dir_info[data_idx]->duration == 0 && dir_info[data_idx]->attr != 0)
				LoadHeaderInfo(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster, curr_dir, data_idx, FALSE);
			*duration = dir_info[data_idx]->duration;
			*mjd = dir_info[data_idx]->mjd;
#ifndef WIN32
		}
#endif
	}
}

void drawRecLineDetails(int data_idx, TYPE_PlayInfo play_info, TYPE_RecInfo rec_info_1, TYPE_RecInfo rec_info_2, word duration, word mjd, dword fc, dword bc, dword detail_colour, int y)
{
	dword current_block, total_block, watched_mins = 0;

	word duration_offset = display_logos ? W-250 : W-200, date_offset = display_logos ? W-170 : W-120, logo_offset = display_logos ? W-45 : W;

#ifndef WIN32
	if (play_info.file && isRecPlaying(play_info)
			&& strcmp(play_info.file->name, dir_info[data_idx]->file_name) == 0
			&& play_info.file->startCluster == dir_info[data_idx]->start_cluster
			&& !stop_playing) {

		current_block = getCurrentBlock(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster);
		total_block = getTotalBlock(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster);

		if (total_block > 0) {
			if ((total_block - current_block) < 80) current_block = total_block;

			if (play_info.playMode == PLAYMODE_RecPlaying) {
				if (strcmp(dir_info[data_idx]->file_name, rec_info_1.fileName) == 0)
					watched_mins = current_block*rec_info_1.duration/total_block;
				ef (strcmp(dir_info[data_idx]->file_name, rec_info_2.fileName) == 0)
					watched_mins = current_block*rec_info_2.duration/total_block;
			}
			else
				watched_mins = current_block*play_info.duration/total_block;
		}

		if (displayProgress(watched_mins, current_block, total_block, list_progress_format)) {
			formatProgressString(buffer, watched_mins, play_info.duration, current_block, total_block, list_progress_format);
			drawText(region_mem, X+duration_offset-10-getWidth(buffer, FNT_Size_1419), Y+y+(display_logos ? 6 : 4), X+duration_offset-3, buffer, detail_colour, bc, FNT_Size_1419);
		}

		if (play_info.duration > 59)
			TAP_SPrint(buffer, "%d%s %d%s", play_info.duration / 60, h_t, play_info.duration % 60, m_t);
		else
			TAP_SPrint(buffer, "%d %s", play_info.duration, mins_lower_t);
		drawText(region_mem, X+duration_offset+10, Y+y+(display_logos ? (list_progress_format == BAR && watched_mins > 0) ? 4 : 5 : (list_progress_format == BAR && watched_mins > 0) ? 2 : 3), X+date_offset-3, buffer, detail_colour, bc, FNT_Size_1622);
		if (list_progress_format == BAR && watched_mins > 0) {
			word progress_length = (watched_mins * (date_offset-duration_offset-2)) / play_info.duration;
			TAP_Osd_FillBox(region_mem, X+duration_offset+4, Y+y+(display_logos ? 28 : 24), date_offset-duration_offset-2, 2, progress_bar_bg_colour);
			TAP_Osd_FillBox(region_mem, X+duration_offset+4, Y+y+(display_logos ? 28 : 24), progress_length, 2, playing_bar_colour);
		}

		if (play_info.playMode == PLAYMODE_Playing)
			drawText(region_mem, X+date_offset+10, Y+y+(display_logos ? 5 : 3), X+logo_offset-3, playing_t, detail_colour, bc, FNT_Size_1622);
		else
			drawText(region_mem, X+date_offset+10, Y+y+(display_logos ? 5 : 3), X+logo_offset-3, chasing_t, detail_colour, bc, FNT_Size_1622);
	}	
	ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[data_idx]->file_name) == 0) {
		watched_mins = rec_info_1.recordedSec/60;
		if (displayProgress(watched_mins, watched_mins, rec_info_1.duration, list_progress_format)) {
			formatProgressString(buffer, watched_mins, rec_info_1.duration, watched_mins, rec_info_1.duration, list_progress_format);
			drawText(region_mem, X+duration_offset-10-getWidth(buffer, FNT_Size_1419), Y+y+(display_logos ? 6 : 4), X+duration_offset-3, buffer, detail_colour, bc, FNT_Size_1419);
		}
		if (rec_info_1.duration > 59)
			TAP_SPrint(buffer, "%d%s %d%s", rec_info_1.duration / 60, h_t, rec_info_1.duration % 60, m_t);
		else
			TAP_SPrint(buffer, "%d %s", rec_info_1.duration, mins_lower_t);
		drawText(region_mem, X+duration_offset+10, Y+y+(display_logos ? (list_progress_format == BAR && watched_mins > 0) ? 4 : 5 : (list_progress_format == BAR && watched_mins > 0) ? 2 : 3), X+date_offset-3, buffer, detail_colour, bc, FNT_Size_1622);
		if (list_progress_format == BAR && watched_mins > 0) {
			word progress_length = (watched_mins * (date_offset-duration_offset-2)) / rec_info_1.duration;
			TAP_Osd_FillBox(region_mem, X+duration_offset+4, Y+y+(display_logos ? 28 : 24), date_offset-duration_offset-2, 2, progress_bar_bg_colour);
			TAP_Osd_FillBox(region_mem, X+duration_offset+4, Y+y+(display_logos ? 28 : 24), progress_length, 2, recording_bar_colour);
		}

		drawText(region_mem, X+date_offset+10, Y+y+(display_logos ? 5 : 3), X+logo_offset-3, recording_t, detail_colour, bc, FNT_Size_1622);
	}			
	ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[data_idx]->file_name) == 0) {
		watched_mins = rec_info_2.recordedSec/60;
		if (displayProgress(watched_mins, watched_mins, rec_info_2.duration, list_progress_format)) {
			formatProgressString(buffer, watched_mins, rec_info_2.duration, watched_mins, rec_info_2.duration, list_progress_format);
			drawText(region_mem, X+duration_offset-10-getWidth(buffer, FNT_Size_1419), Y+y+(display_logos ? 6 : 4), X+duration_offset-3, buffer, detail_colour, bc, FNT_Size_1419);
		}
		if (rec_info_2.duration > 59)
			TAP_SPrint(buffer, "%d%s %d%s", rec_info_2.duration / 60, h_t, rec_info_2.duration % 60, m_t);
		else
			TAP_SPrint(buffer, "%d %s", rec_info_2.duration, mins_lower_t);
		drawText(region_mem, X+duration_offset+10, Y+y+(display_logos ? (list_progress_format == BAR && watched_mins > 0) ? 4 : 5 : (list_progress_format == BAR && watched_mins > 0) ? 2 : 3), X+date_offset-3, buffer, detail_colour, bc, FNT_Size_1622);
		if (list_progress_format == BAR && watched_mins > 0) {
			word progress_length = (watched_mins * (date_offset-duration_offset-2)) / rec_info_2.duration;
			TAP_Osd_FillBox(region_mem, X+duration_offset+4, Y+y+(display_logos ? 28 : 24), date_offset-duration_offset-2, 2, progress_bar_bg_colour);
			TAP_Osd_FillBox(region_mem, X+duration_offset+4, Y+y+(display_logos ? 28 : 24), progress_length, 2, recording_bar_colour);
		}

		drawText(region_mem, X+date_offset+10, Y+y+(display_logos ? 5 : 3), X+logo_offset-3, recording_t, detail_colour, bc, FNT_Size_1622);
	}
	else {
#endif
		if (dir_info[data_idx]->attr != ATTR_TS) {
			drawText(region_mem, X+duration_offset+10, Y+y+(display_logos ? 5 : 3), X+duration_offset-3, "Duff", detail_colour, COLOR_None, FNT_Size_1622);
			if (file_icons_left_aligned)
				TAP_Osd_PutGd(region_mem, X, Y+y+(display_logos ? 4 : 2), &_no_entryGd, TRUE);
			else
				TAP_Osd_PutGd(region_mem, X+date_offset+10, Y+y+(display_logos ? 4 : 2), &_no_entryGd, TRUE);
		}
		else {
			current_block = getCurrentBlock(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster);
			total_block = getTotalBlock(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster);
			if (total_block > 0) {
				if ((total_block - current_block) < 80) current_block = total_block;
				watched_mins = (duration*current_block)/total_block;
			}

			if (displayProgress(watched_mins, current_block, total_block, list_progress_format)) {
				formatProgressString(buffer, watched_mins, duration, current_block, total_block, list_progress_format);
				drawText(region_mem, X+duration_offset-10-getWidth(buffer, FNT_Size_1419), Y+y+(display_logos ? 6 : 4), X+duration_offset-3, buffer, detail_colour, bc, FNT_Size_1419);
			}

			if (duration > 59)
				TAP_SPrint(buffer, "%d%s %d%s", duration / 60, h_t, duration % 60, m_t);
			else
				TAP_SPrint(buffer, "%d %s", duration, duration == 1 ? minimum_t : mins_lower_t);
			drawText(region_mem, X+duration_offset+10, Y+y+(display_logos ? (list_progress_format == BAR && watched_mins > 0) ? 4 : 5 : (list_progress_format == BAR && watched_mins > 0) ? 2 : 3), X+date_offset-3, buffer, detail_colour, bc, FNT_Size_1622);
			if (list_progress_format == BAR && watched_mins > 0) {
				word progress_length = (watched_mins * (date_offset-duration_offset-2)) / duration;
				TAP_Osd_FillBox(region_mem, X+duration_offset+4, Y+y+(display_logos ? 28 : 24), date_offset-duration_offset-2, 2, progress_bar_bg_colour);
				TAP_Osd_FillBox(region_mem, X+duration_offset+4, Y+y+(display_logos ? 28 : 24), progress_length, 2, playing_bar_colour);
			}

			if (mjd != 0)
				formatDateString(mjd, buffer, FALSE);
			else
				TAP_SPrint(buffer, invalid_date_t);
			drawText(region_mem, X+date_offset+10, Y+y+(display_logos ? 5 : 3), X+logo_offset-3, buffer, detail_colour, bc, FNT_Size_1622);
		}
#ifndef WIN32
	}
#endif
}

void drawPhotoLineDetails(int data_idx, dword fc, dword bc, dword detail_colour, int y)
{
	// get dimensions (either from structure or from cache)
	struct _dimensions *output_dimensions = getDimensions(dir_info[data_idx]->file_name);

	if (output_dimensions && output_dimensions->width > 0) {
		TAP_SPrint(buffer, " %dx%d", output_dimensions->width, output_dimensions->height);
		fc = detail_text_colour;
	}
	else {
		TAP_SPrint(buffer, " ");
		fc = header_text_colour;
	}
	drawText(region_mem, X+W-120+5, Y+y+3, X+W-3, buffer, detail_colour, bc, FNT_Size_1622);
}

void drawMp3LineDetails(int data_idx, dword fc, dword bc, dword detail_colour, int y)
{
	if (dir_info[data_idx]->duration > 0) {
		TAP_SPrint(buffer, " %d:%02d", dir_info[data_idx]->duration / 60, dir_info[data_idx]->duration % 60);
		drawText(region_mem, X+W-120+5, Y+y+3, X+W-3, buffer, detail_colour, bc, FNT_Size_1622);
	}

	/*if (dir_info[data_idx]->track_number > 0) {
		TAP_SPrint(buffer, " %d", dir_info[data_idx]->track_number);
		drawText(region_mem, X+W-60+5, Y+y+3, X+W-3, buffer, detail_colour, bc, FNT_Size_1622);
	}*/
}

void drawFolderIcons(int data_idx, int y)
{
	bool logos_displayed = (InDataFilesFolder(curr_dir) && display_logos);
	word folder_offset = (display_logos && InDataFilesFolder(curr_dir)) ? W-170 : W-120;

	if (dir_info[data_idx]->folder) {
		if (isParentDirectory(dir_info[data_idx]->file_name)) {
			if (file_icons_left_aligned)
				TAP_Osd_PutGd(region_mem, X, Y+y+(logos_displayed ? 3 : 1), &_back_arrow2Gd, TRUE);
			else
				TAP_Osd_PutGd(region_mem, X+folder_offset+8, Y+y+(logos_displayed ? 3 : 1), &_back_arrow2Gd, TRUE);
		}	
		else {
			if (file_icons_left_aligned)
				TAP_Osd_PutGd(region_mem, X, Y+y+(logos_displayed ? 6 : 4), &_folderGd, TRUE);
			else
				TAP_Osd_PutGd(region_mem, X+folder_offset+10, Y+y+(logos_displayed ? 6 : 4), &_folderGd, TRUE);
		}
	}
}

word getPercentageWatched(word index)
{
	int current_block = getCurrentBlock(dir_info[index]->file_name, dir_info[index]->start_cluster);
	int total_block = getTotalBlock(dir_info[index]->file_name, dir_info[index]->start_cluster);
	if (total_block > 0)
		return (current_block * 100) / total_block;
	return 0;
}

void drawRecIcons(int data_idx, TYPE_PlayInfo play_info, TYPE_RecInfo rec_info_1, TYPE_RecInfo rec_info_2, int y)
{
	word icon_offset = display_logos ? W-50 : W;

	if (isRec(dir_info[data_idx]->file_name)) {
		if (file_icons_left_aligned) {
			if (isMarkedRecording(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster))
				TAP_Osd_PutGd(region_mem, X, Y+y+(display_logos ? 4 : 2), &_marked2Gd, TRUE);
			ef (isSavedRecording(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster))
				TAP_Osd_PutGd(region_mem, X, Y+y+(display_logos ? 4 : 2), &_savedGd, TRUE);
			ef (play_info.file && isRecPlaying(play_info) 
					&& strcmp(play_info.file->name, dir_info[data_idx]->file_name) == 0
					&& play_info.file->startCluster == dir_info[data_idx]->start_cluster
					&& !stop_playing)
				TAP_Osd_PutGd(region_mem, X, Y+y+(display_logos ? 4 : 2), &_playGd, TRUE);
			ef (IsDataFilesFolder(curr_dir) 
					&& (strcmp(rec_info_1.fileName, dir_info[data_idx]->file_name) == 0 
						|| strcmp(rec_info_2.fileName, dir_info[data_idx]->file_name) == 0))
				TAP_Osd_PutGd(region_mem, X, Y+y+(display_logos ? 4 : 2), &_record2Gd, TRUE);
			ef (watched_icon_percentage > 0 && getPercentageWatched(data_idx) >= watched_icon_percentage)
				TAP_Osd_PutGd(region_mem, X, Y+y+(display_logos ? 4 : 2), &_tickGd, TRUE);
     		ef (show_last_played_icon && strcmp(dir_info[data_idx]->file_name, last_played_name) == 0 && dir_info[data_idx]->start_cluster == last_played_cluster)
				TAP_Osd_PutGd(region_mem, X, Y+y+(display_logos ? 5 : 3), &_playedGd, TRUE);
			ef (dir_info[data_idx]->locked) 
				TAP_Osd_PutGd(region_mem, X, Y+y+(display_logos ? 4 : 2), &_padlock5Gd, TRUE);
			ef (dir_info[data_idx]->encryption == 0x01) 
				drawText(region_mem, X+5, Y+y+(display_logos ? 5 : 3), -1, "$", COLOR_Yellow, COLOR_None, FNT_Size_1622);
			ef (dir_info[data_idx]->encryption == 0x02)
				drawText(region_mem, X+5, Y+y+(display_logos ? 5 : 3), -1, "$", COLOR_Green, COLOR_None, FNT_Size_1622);
			ef (dir_info[data_idx]->encryption > 0) 
				drawText(region_mem, X+5, Y+y+(display_logos ? 5 : 3), -1, "$", RGB8888(255,75,15), COLOR_None, FNT_Size_1622);
			ef (isRadioRecording(data_idx)) 
				TAP_Osd_PutGd(region_mem, X+1, Y+y+(display_logos ? 4 : 2), &_radio2Gd, TRUE);
		}
		else {
			if (isMarkedRecording(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster))
				TAP_Osd_PutGd(region_mem, X+icon_offset-17, Y+y+(display_logos ? 4 : 2), &_marked2Gd, TRUE);
			ef (isSavedRecording(dir_info[data_idx]->file_name, dir_info[data_idx]->start_cluster))
				TAP_Osd_PutGd(region_mem, X+icon_offset-17, Y+y+(display_logos ? 4 : 2), &_savedGd, TRUE);
			ef (dir_info[data_idx]->locked) 
				TAP_Osd_PutGd(region_mem, X+icon_offset-15, Y+y+(display_logos ? 4 : 2), &_padlock5Gd, TRUE);
			ef (watched_icon_percentage > 0 && getPercentageWatched(data_idx) >= watched_icon_percentage)
				TAP_Osd_PutGd(region_mem, X+icon_offset-17, Y+y+(display_logos ? 4 : 2), &_tickGd, TRUE);
			ef (show_last_played_icon && strcmp(dir_info[data_idx]->file_name, last_played_name) == 0 && dir_info[data_idx]->start_cluster == last_played_cluster)
				TAP_Osd_PutGd(region_mem, X+icon_offset-17, Y+y+(display_logos ? 5 : 3), &_playedGd, TRUE);
			ef (dir_info[data_idx]->encryption == 0x01) 
				drawText(region_mem, X+icon_offset-15, Y+y+(display_logos ? 5 : 3), -1, "$", COLOR_Yellow, COLOR_None, FNT_Size_1622);
			ef (dir_info[data_idx]->encryption == 0x02) 
				drawText(region_mem, X+icon_offset-15, Y+y+(display_logos ? 5 : 3), -1, "$", COLOR_Green, COLOR_None, FNT_Size_1622);
			ef (dir_info[data_idx]->encryption > 0) 
				drawText(region_mem, X+icon_offset-15, Y+y+(display_logos ? 5 : 3), -1, "$", RGB8888(255,75,15), COLOR_None, FNT_Size_1622);
			ef (isRadioRecording(data_idx)) 
				TAP_Osd_PutGd(region_mem, X+icon_offset-15+1, Y+y+(display_logos ? 4 : 2), &_radio2Gd, TRUE);
		}
		if (display_logos)
			DisplayLogo(region_mem, X+W-45+4, Y+y, dir_info[data_idx]->service_num, dir_info[data_idx]->service_type, dir_info[data_idx]->service_name);
	}
}

void drawFile(int line_idx, int data_idx)
{
	int y;
	dword fc, bc, detail_colour;
	word duration, mjd;
	TYPE_PlayInfo play_info; 
	TYPE_RecInfo rec_info_1, rec_info_2;

	if (recycle_bin_displayed) {
		drawRecycleBinFile(line_idx, data_idx);
		return;
	}

#ifndef WIN32
	TAP_Hdd_GetPlayInfo(&play_info);
	TAP_Hdd_GetRecInfo(0, &rec_info_1);
	TAP_Hdd_GetRecInfo(1, &rec_info_2);
#else
	play_info.duration = 0;
	rec_info_1.duration = 1;
	rec_info_2.duration = 1;
#endif

	if (InDataFilesFolder(curr_dir))
		y = 30 + ((line_idx-1) * (display_logos ? 32 : 29)) + (display_logos ? 33 : 29) + line_gap;
	else
		y = 30 + (line_idx * 29) + 3;

	// clear the line and work out the colours to use
	clearFileLine(line_idx, data_idx, play_info, rec_info_1, rec_info_2, y);

	// stop here if this is just a blank line
	if (data_idx >= no_of_files)
		return;

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Draw file %s", dir_info[data_idx]->file_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	setFileLineColours(line_idx, data_idx, play_info, rec_info_1, rec_info_2, &fc, &bc, &detail_colour);

	// draw the common file details
	getRecLineDetails(data_idx, play_info, rec_info_1, rec_info_2, &duration, &mjd);
	drawFileLineDetails(data_idx, fc, bc, detail_colour, y);

	// draw any context specific file details
	if (existsInPlaylist(curr_dir, dir_info[data_idx]->file_name) >= 0)
		file_icons_left_aligned ? TAP_Osd_PutGd(region_mem, X, Y+y+1, &_playlistGd, TRUE) : TAP_Osd_PutGd(region_mem, InMp3FilesFolder(curr_dir) ? X+W-30 : X+W-120+7, Y+y+1, &_playlistGd, TRUE);
	if (isPhoto(dir_info[data_idx]->file_name) && !(!file_icons_left_aligned && existsInPlaylist(curr_dir, dir_info[data_idx]->file_name) >= 0))
		drawPhotoLineDetails(data_idx, fc, bc, detail_colour, y);
	ef (isRec(dir_info[data_idx]->file_name) && InDataFilesFolder(curr_dir)) {
		drawRecLineDetails(data_idx, play_info, rec_info_1, rec_info_2, duration, mjd, fc, bc, detail_colour, y);
		drawRecIcons(data_idx, play_info, rec_info_1, rec_info_2, y);
	}
	if (isMp3(dir_info[data_idx]->file_name))
		drawMp3LineDetails(data_idx, fc, bc, detail_colour, y);

	// draw any necessary icons
	drawFolderIcons(data_idx, y);
}

bool mp3ArtExists(int data_idx)
{
	// assume we have an mp3 highlighted at this point
	if (TAP_Hdd_Exist("Cache")) {
		ChangeDir("Cache");
		strcpy(file_name, dir_info[data_idx]->file_name);
		strcat(file_name, ".ass");

		if (TAP_Hdd_Exist(file_name))  {
			ChangeDir("..");
			return TRUE;
		}
		
		ChangeDir("..");
	}

	return FALSE;
}

void getKeyboardCharacter(int idx, char *letter_string)
{
	memset(letter_string, '\0', 6);

	switch (idx) {
		case 29:
			strcpy(letter_string, clear_upper_t); break;
		case 30:
			strcpy(letter_string, del_upper_t); break;
		case 31:
			strcpy(letter_string, space_upper_t); break;
		case 32:
			switch (keyboard_case) {
				case KEYBOARD_AUTO:
					strcpy(letter_string, "ABC"); break;
				case KEYBOARD_UPPER:
					strcpy(letter_string, "abc"); break;
				case KEYBOARD_LOWER:
					strcpy(letter_string, "123"); break;
				case KEYBOARD_NUMERIC:
					strcpy(letter_string, "Abc"); break;
			}
			break;
		case 33:
			strcpy(letter_string, save_upper_t); break;
		default:
			letter_string[0] = keyboard_data[idx]; break;
	}
}

void moveKeyboardHighlight(int new_idx, int old_idx)
{
	int old_x_coord, old_y_coord, old_x_idx, old_y_idx, new_x_coord, new_y_coord, new_x_idx, new_y_idx;
	word string_length;
	char letter_string[6];

	new_x_idx = (new_idx) % 9;
	new_y_idx = (new_idx) / 9;
	new_x_coord = X + 22 + 3 + (new_x_idx * 63);
	new_y_coord = Y + 30 + 3 + (new_y_idx * 63);

	old_x_idx = (old_idx) % 9;
	old_y_idx = (old_idx) / 9;
	old_x_coord = X + 22 + 3 + (old_x_idx * 63);
	old_y_coord = Y + 30 + 3 + (old_y_idx * 63);

	if (old_idx > -1)
	{
		if (old_idx == 99) {
			TAP_Osd_FillBox(region_mem, X-5, Y+H-120-39, W+10+1, 39, RGB8888(61,61,61));
			if (cursor_pointer == strlen(keyboard_name))
				drawText(region_mem, X+5, Y+H-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);
			else {
				memset(buffer, '\0', 100);
				memset(buffer2, '\0', 100);
				strncat(buffer, keyboard_name, cursor_pointer);
				strncat(buffer2, keyboard_name+cursor_pointer, strlen(keyboard_name)-cursor_pointer);
				drawText(region_mem, X+5, Y+H-120-30, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1926);
				drawText(region_mem, X+5+getWidth(buffer, FNT_Size_1926)+5, Y+H-120-30, -1, buffer2, body_text_colour, COLOR_None, FNT_Size_1926);
			}
		}
		else {
			getKeyboardCharacter(old_idx, letter_string);
			
			if (gradient_increment)
				TAP_Osd_RestoreBox(region_mem, old_x_coord, old_y_coord, 60, 60, keyboard_bg_gradient);
			else
				TAP_Osd_FillBox(region_mem, old_x_coord, old_y_coord, 60, 60, body_bg_colour);

			if (old_idx < 29) {
				string_length = getWidth(letter_string, FNT_Size_1926);
				drawText(region_mem, old_x_coord+((60-string_length)/2), old_y_coord+19, -1, letter_string, body_text_colour, COLOR_None, FNT_Size_1926);
			}
			else {
				string_length = getWidth(letter_string, FNT_Size_1622);
				drawText(region_mem, old_x_coord+((60-string_length)/2), old_y_coord+19, -1, letter_string, body_text_colour, COLOR_None, FNT_Size_1622);
			}
		}
	}

	if (new_idx == 99) {
		TAP_Osd_FillBox(region_mem, X-5, Y+H-120-39, W+10+1, 39, COLOR_Black);
		if (cursor_pointer == strlen(keyboard_name))
			drawText(region_mem, X+5, Y+H-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);
		else {
			memset(buffer, '\0', 100);
			memset(buffer2, '\0', 100);
			strncat(buffer, keyboard_name, cursor_pointer);
			strncat(buffer2, keyboard_name+cursor_pointer, strlen(keyboard_name)-cursor_pointer);
			drawText(region_mem, X+5, Y+H-120-30, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1926);
			drawText(region_mem, X+5+getWidth(buffer, FNT_Size_1926)+5, Y+H-120-30, -1, buffer2, body_text_colour, COLOR_None, FNT_Size_1926);
		}
		keyboard_offset = old_idx % 9;
	}
	else {
		getKeyboardCharacter(new_idx, letter_string);

		if (gradient_increment)
			TAP_Osd_RestoreBox(region_mem, new_x_coord, new_y_coord, 60, 60, keyboard_highlight_gradient);
		else
			TAP_Osd_FillBox(region_mem, new_x_coord, new_y_coord, 60, 60, highlight_bg_colour);

		if (new_idx < 29) {
			string_length = getWidth(letter_string, FNT_Size_1926);
			drawText(region_mem, new_x_coord+((60-string_length)/2), new_y_coord+19, -1, letter_string, body_text_colour, COLOR_None, FNT_Size_1926);
		}
		else {
			string_length = getWidth(letter_string, FNT_Size_1622);
			drawText(region_mem, new_x_coord+((60-string_length)/2), new_y_coord+19, -1, letter_string, body_text_colour, COLOR_None, FNT_Size_1622);
		}
	}
}

void moveThumbnailHighLight(int old_pos, int new_pos, int old_idx, int new_idx)
{
	int old_x_coord, old_y_coord, old_x_idx, old_y_idx, new_x_coord, new_y_coord, new_x_idx, new_y_idx;
	dword string_length;
	word old_bc, new_bc, old_fc, new_fc;

	new_x_idx = (new_pos+1) % 3 == 0 ? 2 : (new_pos+1) % 3 - 1;
	new_y_idx = (new_pos+1 - new_x_idx) / 3;
	new_x_coord = thumbnail_offset_x + 32 + (new_x_idx * (640 / 3));
	new_y_coord = thumbnail_offset_y + 30 + 23 + (new_y_idx * 157);
	new_bc = highlight_bg_colour;
	new_fc = highlight_text_colour;

	if (old_pos > -1) {
		old_x_idx = (old_pos+1) % 3 == 0 ? 2 : (old_pos+1) % 3 - 1;
		old_y_idx = (old_pos+1 - old_x_idx) / 3;
		old_x_coord = thumbnail_offset_x + 32 + (old_x_idx * (640 / 3));
		old_y_coord = thumbnail_offset_y + 30 + 23 + (old_y_idx * 157);
		old_bc = (dir_info[old_idx]->folder) ? folder_bg_colour : body_bg_colour;
		old_fc = isFolder(old_idx) ? folder_text_colour : body_text_colour;
	}

	if (old_pos > -1)
	{
		TAP_Osd_FillBox(region_mem, old_x_coord-32+2, old_y_coord-23+2, 211, 18, old_bc);
		TAP_Osd_FillBox(region_mem, old_x_coord-32+2, old_y_coord-23+137, 211, 20, old_bc);
		if (InDataFilesFolder(curr_dir)) {
			TAP_Osd_FillBox(region_mem, old_x_coord-32+2, old_y_coord-23+2+18, 32, 120, old_bc);
			TAP_Osd_FillBox(region_mem, old_x_coord-32+27+152, old_y_coord-23+2+18, 34, 120, old_bc);
		}
		else {
			TAP_Osd_FillBox(region_mem, old_x_coord-32+2, old_y_coord-23+2+18, 27, 120, old_bc);
			TAP_Osd_FillBox(region_mem, old_x_coord-32+27+157, old_y_coord-23+2+18, 29, 120, old_bc);
		}

		if (isPhoto(dir_info[old_idx]->file_name)
				|| (isMp3(dir_info[old_idx]->file_name) && mp3ArtExists(old_idx))
				|| isRec(dir_info[old_idx]->file_name)) {
			memset(buffer, '\0', 100);
			strncat(buffer, dir_info[old_idx]->file_name, strlen(dir_info[old_idx]->file_name)-getExtensionLength(dir_info[old_idx]->file_name));
			string_length = getWidth(buffer, FNT_Size_1419);
			if (string_length > 208) string_length = 208;
			drawText(region_mem, old_x_coord-32+2+(208-string_length)/2, old_y_coord+115, old_x_coord-32+2+208-1, buffer, old_fc, COLOR_None, FNT_Size_1419);
		}
		ef (scenes_displayed) {
			TAP_SPrint(buffer, "%s %d - %02d:%02d", scene_t, old_idx+1, scene_skip*(old_idx+1) / 60, scene_skip*(old_idx+1) % 60);
			string_length = getWidth(buffer, FNT_Size_1419);
			if (string_length > 208) string_length = 208;
			drawText(region_mem, old_x_coord-32+2+(208-string_length)/2, old_y_coord+115, old_x_coord-32+2+208-1, buffer, old_fc, COLOR_None, FNT_Size_1419);
		}
		ef (InMp3FilesFolder(curr_dir) && dir_info[old_idx]->folder && !isParentDirectory(dir_info[old_idx]->file_name)) {
			strcpy(buffer, dir_info[old_idx]->file_name);
			string_length = getWidth(buffer, FNT_Size_1419);
			if (string_length > 208) string_length = 208;
			drawText(region_mem, old_x_coord-32+2+(208-string_length)/2, old_y_coord+115, old_x_coord-32+2+208-1, buffer, old_fc, COLOR_None, FNT_Size_1419);
		}
	}

	TAP_Osd_FillBox(region_mem, new_x_coord-32+2, new_y_coord-23+2, 211, 18, new_bc);
	TAP_Osd_FillBox(region_mem, new_x_coord-32+2, new_y_coord-23+137, 211, 20, new_bc);
	if (InDataFilesFolder(curr_dir)) {
		TAP_Osd_FillBox(region_mem, new_x_coord-32+2, new_y_coord-23+2+18, 32, 120, new_bc);
		TAP_Osd_FillBox(region_mem, new_x_coord-32+27+152, new_y_coord-23+2+18, 34, 120, new_bc);
	}
	else {
		TAP_Osd_FillBox(region_mem, new_x_coord-32+2, new_y_coord-23+2+18, 27, 120, new_bc);
		TAP_Osd_FillBox(region_mem, new_x_coord-32+27+157, new_y_coord-23+2+18, 29, 120, new_bc);
	}

	if (isPhoto(dir_info[new_idx]->file_name)
			|| (isMp3(dir_info[new_idx]->file_name) && mp3ArtExists(new_idx))
			|| isRec(dir_info[new_idx]->file_name)) {
		memset(buffer, '\0', 100);
		strncat(buffer, dir_info[new_idx]->file_name, strlen(dir_info[new_idx]->file_name)-getExtensionLength(dir_info[new_idx]->file_name));
		string_length = getWidth(buffer, FNT_Size_1419);
		if (string_length > 208) string_length = 208;
		drawText(region_mem, new_x_coord-32+2+(208-string_length)/2, new_y_coord+115, new_x_coord-32+2+208-1, buffer, new_fc, COLOR_None, FNT_Size_1419);
	}
	ef (scenes_displayed) {
		TAP_SPrint(buffer, "%s %d - %02d:%02d", scene_t, new_idx+1, scene_skip*(new_idx+1) / 60, scene_skip*(new_idx+1) % 60);
		string_length = getWidth(buffer, FNT_Size_1419);
		if (string_length > 208) string_length = 208;
		drawText(region_mem, new_x_coord-32+2+(208-string_length)/2, new_y_coord+115, new_x_coord-32+2+208-1, buffer, new_fc, COLOR_None, FNT_Size_1419);
	}
	ef (InMp3FilesFolder(curr_dir) && dir_info[new_idx]->folder && !isParentDirectory(dir_info[new_idx]->file_name)) {
		strcpy(buffer, dir_info[new_idx]->file_name);
		string_length = getWidth(buffer, FNT_Size_1419);
		if (string_length > 208) string_length = 208;
		drawText(region_mem, new_x_coord-32+2+(208-string_length)/2, new_y_coord+115, new_x_coord-32+2+208-1, buffer, new_fc, COLOR_None, FNT_Size_1419);
	}
}

TYPE_File* getRecThumbnail(char *name)
{
	TYPE_File *thumbnail_file = NULL;

	// assume we have a rec highlighted at this point
	strcpy(file_name, name);
	strcat(file_name, ".tn");

	if (TAP_Hdd_Exist("Cache")) {
		ChangeDir("Cache");
		thumbnail_file = TAP_Hdd_Fopen(file_name);
		ChangeDir("..");
	}

	return thumbnail_file;
}

TYPE_File* getPhotoCache(char *name, bool thumbnail)
{
	TYPE_File *file = NULL;

	// assume we have an mp3 highlighted at this point
	strcpy(file_name, name);
	if (thumbnail)
		strcat(file_name, ".tn");
	else
		strcat(file_name, ".cache");

#ifndef WIN32
	if (TAP_Hdd_Exist("Cache")) {
#endif
		ChangeDir("Cache");
		file = TAP_Hdd_Fopen(file_name);
		ChangeDir("..");
#ifndef WIN32
	}
#endif

	return file;
}

// get reference to the thumbnail file for either album or mp3 art
TYPE_File* getArtThumbnail(bool album_art, int data_idx)
{
	TYPE_File *thumbnail_file = NULL, *association_file = NULL;

	if (album_art) {
		if (TAP_Hdd_Exist("Cache")) {
			ChangeDir("Cache");
			thumbnail_file = TAP_Hdd_Fopen("album.ass");
			ChangeDir("..");
		}
	}
	else {
		// assume we have an mp3 highlighted at this point
		if (TAP_Hdd_Exist("Cache")) {
			ChangeDir("Cache");
			strcpy(file_name, dir_info[data_idx]->file_name);
			strcat(file_name, ".ass");
			thumbnail_file = TAP_Hdd_Fopen(file_name);
			ChangeDir("..");
		}
	}

	return thumbnail_file;
}

// get reference to the album art for this folder
TYPE_File* getAlbumArtThumbnail(int data_idx)
{
	TYPE_File *thumbnail_file = NULL, file;
	int i;

	// look for any user associated album art first
	thumbnail_file = getArtThumbnail(TRUE, -1);

	// no association so check in mp3 folder for any art
	if (thumbnail_file == NULL) {
		// check cache dir for standard album art 
		if (TAP_Hdd_Exist("Cache")) {
			ChangeDir("Cache");

			memset (&file, 0, sizeof(file));
			i = TAP_Hdd_FindFirst(&file);
			while (i--) {
				if (isThumbnail(file.name) && !isRecycledThumbnail(file.name))	{
					thumbnail_file = TAP_Hdd_Fopen(file.name);
					break;
				}

				if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
					break;
			}

			ChangeDir("..");

			if (thumbnail_file != NULL) return thumbnail_file;
		}

		// not there, so check the first subfolder
		memset(&file, 0, sizeof(file));
		i = TAP_Hdd_FindFirst(&file);

		while (i--) {
			if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0) {
				ChangeDir(file.name);

				// look for any user associated album art first
				thumbnail_file = getArtThumbnail(TRUE, -1);

				// if not there, check cache dir for standard album art 
				if (thumbnail_file == NULL && TAP_Hdd_Exist("Cache")) {
					ChangeDir("Cache");

					memset (&file, 0, sizeof(file));
					i = TAP_Hdd_FindFirst(&file);
					while (i--) {
						if (isThumbnail(file.name) && !isRecycledThumbnail(file.name))	{
							thumbnail_file = TAP_Hdd_Fopen(file.name);
							break;
						}

						if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
							break;
					}

					ChangeDir("..");
				}

				ChangeDir("..");
				break;
			}

			if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
				break;
		}
	}

	return thumbnail_file;
}

void drawThumbnail(int line_idx, int data_idx)
{
	TYPE_File	*thumbnail_file;
	word *thumbnail_bitmap = NULL;
	byte *thumbnail_bytes = NULL;

	int i, j, x_coord, y_coord, x_idx, y_idx;
	int thumbnail_width, thumbnail_height;
	dword fc, bc, string_length;

	x_idx = (line_idx+1) % 3 == 0 ? 2 : (line_idx+1) % 3 - 1;
	y_idx = (line_idx+1 - x_idx) / 3;

	x_coord = thumbnail_offset_x + 32 + (x_idx * (640 / 3));
	y_coord = thumbnail_offset_y + 30 + 23 + (y_idx * 157);

	if (data_idx >= no_of_files) {
		TAP_Osd_FillBox(region_mem, x_coord-32+2, y_coord-23+2, 211, 155, body_bg_colour);
		return;
	}

	if (dir_info[data_idx]->folder)
		bc = folder_bg_colour;
	else
		bc = body_bg_colour;

	TAP_Osd_FillBox(region_mem, x_coord-32+2, y_coord-23+2, 211, 155, bc);
	
	thumbnail_file = NULL;
	if (isPhoto(dir_info[data_idx]->file_name) 
		|| (InMp3FilesFolder(curr_dir) && dir_info[data_idx]->folder && !isParentDirectory(dir_info[data_idx]->file_name))
		|| isRec(dir_info[data_idx]->file_name)
		|| scenes_displayed)
	{
		if (isPhoto(dir_info[data_idx]->file_name) || isRec(dir_info[data_idx]->file_name)) {
			strcpy(file_name, dir_info[data_idx]->file_name);
			strcat(file_name, ".tn");

			// change to Cache directory
			ChangeDir("Cache");

			if (TAP_Hdd_Exist(file_name))
				thumbnail_file = TAP_Hdd_Fopen(file_name);

			// back up from cache dir
			ChangeDir("..");
		}
		ef (scenes_displayed) {
			// change to Cache directory
			ChangeDir("Cache");

			if (TAP_Hdd_Exist(dir_info[data_idx]->file_name))
				thumbnail_file = TAP_Hdd_Fopen(dir_info[data_idx]->file_name);

			// back up from cache dir
			ChangeDir("..");
		}
		else {
			ChangeDir(dir_info[data_idx]->file_name);

			thumbnail_file = getAlbumArtThumbnail(data_idx);

			ChangeDir("..");
		}

		if (thumbnail_file != NULL)
		{
			int adjusted_offset_x, adjusted_offset_y, current_position, no_of_scenes;

			if (isRec(dir_info[data_idx]->file_name) || scenes_displayed) {
				TAP_Hdd_Fread(&no_of_scenes, sizeof(int), 1, thumbnail_file);
				TAP_Hdd_Fread(&current_position, sizeof(int), 1, thumbnail_file);
			}
			TAP_Hdd_Fread(&thumbnail_width, sizeof(int), 1, thumbnail_file);
			TAP_Hdd_Fread(&thumbnail_height, sizeof(int), 1, thumbnail_file);
			if (!isRec(dir_info[data_idx]->file_name) && !scenes_displayed) {
				TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, thumbnail_file);
				TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, thumbnail_file);
			}
			if (isGif(dir_info[data_idx]->file_name)) {
				thumbnail_bytes = dlmalloc(sizeof(byte) * thumbnail_width * thumbnail_height);
				if (thumbnail_bytes != NULL)
					TAP_Hdd_Fread(thumbnail_bytes, sizeof(byte), (thumbnail_width * thumbnail_height), thumbnail_file);
			}
			else {
				thumbnail_bitmap = dlmalloc(sizeof(word) * thumbnail_width * thumbnail_height);
				if (thumbnail_bitmap != NULL)
					TAP_Hdd_Fread(thumbnail_bitmap, sizeof(word), (thumbnail_width * thumbnail_height), thumbnail_file);
			}

			if (thumbnail_bitmap != NULL || thumbnail_bytes != NULL) {

				if (isRec(dir_info[data_idx]->file_name) || scenes_displayed)
					adjusted_offset_x = x_coord + 5;
				else 
					adjusted_offset_x = x_coord + (150 - thumbnail_width) / 2;
				adjusted_offset_y = y_coord + (112 - thumbnail_height) / 2;

				if (isGif(dir_info[data_idx]->file_name)) {
					setLut(dir_info[data_idx]->file_name);
					for (j = 0; j < thumbnail_height; j++) 
						for (i = 0; i < thumbnail_width; i++) 
							TAP_Osd_DrawPixmap(region_mem, adjusted_offset_x + i, adjusted_offset_y + j, 1, 1, &thumbnail_bytes[i + j * thumbnail_width], FALSE, OSD_256);
					dlfree(thumbnail_bytes);
				}
				else {
#ifndef WIN32
					TAP_Osd_DrawPixmap(region_mem, adjusted_offset_x, adjusted_offset_y, thumbnail_width, thumbnail_height, thumbnail_bitmap, FALSE, OSD_1555);
#endif
#ifdef WIN32
					for (j = 0; j < thumbnail_height; j++) {
						for (i = 0; i < thumbnail_width; i++)
							TAP_Osd_PutPixel(region_mem, adjusted_offset_x + i, adjusted_offset_y + j, thumbnail_bitmap[i + j * thumbnail_width]);
					}
#endif
					dlfree(thumbnail_bitmap);
				}
				
			}
			if (isRec(dir_info[data_idx]->file_name) || scenes_displayed)
				TAP_Osd_DrawRectangle(region_mem, x_coord-1+5, y_coord-1, 142, 114, 2, frame_colour);
			else
				TAP_Osd_DrawRectangle(region_mem, x_coord-1, y_coord-1, 152, 114, 2, frame_colour);

			TAP_Hdd_Fclose(thumbnail_file);
		}
		else
		{
			// thumbnail missing, so let the user know
			TAP_Osd_DrawRectangle(region_mem, x_coord-1, y_coord-1, 152, 114, 2, frame_colour);
			string_length = getWidth(no_thumbnail_t, FNT_Size_1622);
			drawText(region_mem, x_coord+(150-string_length)/2, y_coord+20, x_coord+150-1, no_thumbnail_t, body_text_colour, bc, FNT_Size_1622);
		}
		
		if (isPhoto(dir_info[data_idx]->file_name)) {
			memset(buffer, '\0', 100);
			strncat(buffer, dir_info[data_idx]->file_name, strlen(dir_info[data_idx]->file_name)-getExtensionLength(dir_info[data_idx]->file_name));
			fc = body_text_colour;
		}
		ef (isRec(dir_info[data_idx]->file_name)) {
			switch (display_rec_event_name) {
				case DISPLAY_FILE_NAME:
					memset(buffer, '\0', 100);
					strncat(buffer, dir_info[data_idx]->file_name, strlen(dir_info[data_idx]->file_name)-4);
					break;

				case DISPLAY_EVENT_NAME:
					TAP_SPrint(buffer, "%s", dir_info[data_idx]->event_name);
					break;

				case DISPLAY_SORT_NAME:
					TAP_SPrint(buffer, "%s", dir_info[data_idx]->sort_name);
					break;
			}
			fc = body_text_colour;
		}
		ef (scenes_displayed) {
			TAP_SPrint(buffer, "%s %d - %02d:%02d", scene_t, data_idx+1, scene_skip*(data_idx+1) / 60, scene_skip*(data_idx+1) % 60);
			fc = body_text_colour;
		}
		else {
			TAP_SPrint(buffer, "%s", dir_info[data_idx]->file_name);
			fc = folder_text_colour;
		}
		string_length = getWidth(buffer, FNT_Size_1419);
		if (string_length > 208) string_length = 208;
		drawText(region_mem, x_coord-32+2+(208-string_length)/2, y_coord+115, x_coord-32+2+208-1, buffer, fc, COLOR_None, FNT_Size_1419);
	}
	ef (isMp3(dir_info[data_idx]->file_name)) {
		thumbnail_file = getArtThumbnail(FALSE, data_idx);
		if (thumbnail_file != NULL) {
			int adjusted_offset_x;
			int adjusted_offset_y;

			TAP_Hdd_Fread(&thumbnail_width, sizeof(int), 1, thumbnail_file);
			TAP_Hdd_Fread(&thumbnail_height, sizeof(int), 1, thumbnail_file);
			TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, thumbnail_file);
			TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, thumbnail_file);
			if (isGif(dir_info[data_idx]->file_name)) {
				thumbnail_bytes = dlmalloc(sizeof(byte) * thumbnail_width * thumbnail_height);
				if (thumbnail_bytes != NULL)
					TAP_Hdd_Fread(thumbnail_bytes, sizeof(byte), (thumbnail_width * thumbnail_height), thumbnail_file);
			}
			else {
				thumbnail_bitmap = dlmalloc(sizeof(word) * thumbnail_width * thumbnail_height);
				if (thumbnail_bitmap != NULL)
					TAP_Hdd_Fread(thumbnail_bitmap, sizeof(word), (thumbnail_width * thumbnail_height), thumbnail_file);
			}
			TAP_Hdd_Fclose(thumbnail_file);

			if (thumbnail_bitmap != NULL || thumbnail_bytes != NULL) {
				// draw the thumbnail
				adjusted_offset_x = x_coord  + (150 - thumbnail_width) / 2;
				adjusted_offset_y = y_coord + (112 - thumbnail_height) / 2;
				TAP_Osd_DrawRectangle(region_mem, x_coord-1, y_coord-1, 152, 114, 2, frame_colour);

				if (isGif(dir_info[data_idx]->file_name)) {
					setLut(dir_info[data_idx]->file_name);
					for (j = 0; j < thumbnail_height; j++) 
						for (i = 0; i < thumbnail_width; i++) 
							TAP_Osd_DrawPixmap(region_mem, adjusted_offset_x + i, adjusted_offset_y + j, 1, 1, &thumbnail_bytes[i + j * thumbnail_width], FALSE, OSD_256);
					dlfree(thumbnail_bytes);
				}
				else {
					TAP_Osd_DrawPixmap(region_mem, adjusted_offset_x, adjusted_offset_y, thumbnail_width, thumbnail_height, thumbnail_bitmap, FALSE, OSD_1555);
					dlfree(thumbnail_bitmap);
				}

				// draw the name underneath
				memset(buffer, '\0', 100);
				strncat(buffer, dir_info[data_idx]->file_name, strlen(dir_info[data_idx]->file_name)-getExtensionLength(dir_info[data_idx]->file_name));
				string_length = getWidth(buffer, FNT_Size_1419);
				if (string_length > 208) string_length = 208;
				drawText(region_mem, x_coord-32+2+(208-string_length)/2, y_coord+115, x_coord-32+2+208-1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);

				dlfree(thumbnail_bitmap);
			}
		}
		else {
			struct media_files *mp3_header;
			if (mp3_playing && strcmp(mp3_files[current_mp3]->directory, curr_dir) == 0
							&& strcmp(mp3_files[current_mp3]->file_name, dir_info[data_idx]->file_name) == 0) {
				copyID3ToID3(TRUE, FALSE);
			}
			ef ((mp3_header = getMp3Header(dir_info[data_idx]->file_name, curr_dir, dir_info[data_idx]->mjd, dir_info[data_idx]->hour, dir_info[data_idx]->min, FALSE, FALSE, FALSE))
					&& mp3_header->header_loaded) {
				copyMp3HeaderToID3(mp3_header);
			}
			else {
				readID3Tag(dir_info[data_idx]->file_name, FALSE, FALSE);
			}

			if (!id3_info->title || strlen(id3_info->title) == 0) {
				memset(buffer, '\0', 100);
				strncat(buffer, dir_info[data_idx]->file_name, strlen(dir_info[data_idx]->file_name)-4);
				string_length = getWidth(buffer, FNT_Size_1419);
				if (string_length > 150) string_length = 150;
				drawText(region_mem, x_coord+(150-string_length)/2, y_coord+30, x_coord+150-1, buffer, folder_text_colour, bc, FNT_Size_1419);
			}
			if (id3_info->artist && strlen(id3_info->artist) > 0) {
				string_length = getWidth(id3_info->artist, FNT_Size_1419);
				if (string_length > 150) string_length = 150;
				drawText(region_mem, x_coord+(150-string_length)/2, y_coord+10, x_coord+150-1, id3_info->artist, body_text_colour, bc, FNT_Size_1419);
			}
			if (id3_info->title && strlen(id3_info->title) > 0) {
				string_length = getWidth(id3_info->title, FNT_Size_1419);
				if (string_length > 150) string_length = 150;
				drawText(region_mem, x_coord+(150-string_length)/2, y_coord+30, x_coord+150-1, id3_info->title, folder_text_colour, bc, FNT_Size_1419);
			}
			if (id3_info->album && strlen(id3_info->album) > 0) {
				string_length = getWidth(id3_info->album, FNT_Size_1419);
				if (string_length > 150) string_length = 150;
				drawText(region_mem, x_coord+(150-string_length)/2, y_coord+70, x_coord+150-1, id3_info->album, body_text_colour, bc, FNT_Size_1419);
			}
			if (id3_info->year && strlen(id3_info->year) > 0) {
				string_length = getWidth(id3_info->year, FNT_Size_1419);
				if (string_length > 150) string_length = 150;
				drawText(region_mem, x_coord+(150-string_length)/2, y_coord+90, x_coord+150-1, id3_info->year, body_text_colour, bc, FNT_Size_1419);
			}

			destroy_ID3(id3_info);
			id3_info = NULL;
		}
	}
	else
	{
		dword fc;

		// display folder name / no of photos
		if (isParentDirectory(dir_info[data_idx]->file_name)) {
			TAP_SPrint(buffer, "%s", back_up_t);
			fc = detail_text_colour;
		}
		else {
			TAP_SPrint(buffer, "%s", dir_info[data_idx]->file_name);
			fc = folder_text_colour;
		}
		string_length = getWidth(buffer, FNT_Size_1622);
		if (string_length > 212) string_length = 208;
		drawText(region_mem, x_coord-32+(212-string_length)/2, y_coord+20, x_coord-32+212-2, buffer, fc, bc, FNT_Size_1622);
		
		// output no of photos in this folder
		if (dir_info[data_idx]->no_of_jpegs > 0)
		{
			if (dir_info[data_idx]->no_of_jpegs == 1)
				TAP_SPrint(buffer, "%d %s", dir_info[data_idx]->no_of_jpegs, photo_t);
			else
				TAP_SPrint(buffer, "%d %s", dir_info[data_idx]->no_of_jpegs, photos_t);
			string_length = getWidth(buffer, FNT_Size_1622);
			drawText(region_mem, x_coord-32+(212-string_length)/2, y_coord+60, x_coord-32+212-2, buffer, folder_text_colour, bc, FNT_Size_1622);
		}

		// output no of mp3s in this folder
		if (dir_info[data_idx]->no_of_mp3s > 0)
		{
			if (dir_info[data_idx]->no_of_mp3s == 1)
				TAP_SPrint(buffer, "%d %s", dir_info[data_idx]->no_of_mp3s, tune_t);
			else
				TAP_SPrint(buffer, "%d %s", dir_info[data_idx]->no_of_mp3s, tunes_t);
			string_length = getWidth(buffer, FNT_Size_1622);
			drawText(region_mem, x_coord-32+(212-string_length)/2, y_coord+60, x_coord-32+212-2, buffer, folder_text_colour, bc, FNT_Size_1622);
		}

		// output no of photos in this folder
		if (dir_info[data_idx]->no_of_recs > 0)
		{
			if (dir_info[data_idx]->no_of_recs == 1)
				TAP_SPrint(buffer, "%d %s", dir_info[data_idx]->no_of_recs, video_t);
			else
				TAP_SPrint(buffer, "%d %s", dir_info[data_idx]->no_of_recs, videos_t);
			string_length = getWidth(buffer, FNT_Size_1622);
			drawText(region_mem, x_coord-32+(212-string_length)/2, y_coord+60, x_coord-32+212-2, buffer, folder_text_colour, bc, FNT_Size_1622);
		}
	}

	if (line_idx == curr_highlight)
		moveThumbnailHighLight(-1, curr_highlight, -1, data_idx);
}

void updateFileCount(void)
{
	int first_idx, last_idx, string_length, lines = InDataFilesFolder(curr_dir) ? line_count : 10;
	char text[12];
	bool more_up = FALSE, more_down = FALSE;

	// update the current photo range displayed in the header
	if (no_of_files == 0) {
		first_idx = 0;
		last_idx = 0;
	}
	else {
		first_idx = curr_idx - curr_highlight + 1;
		last_idx = ((curr_idx - curr_highlight + lines) > (no_of_files - 1)) ? no_of_files : first_idx + lines-1;
	}

	if (last_idx < no_of_files)
		more_down = TRUE;
	if (!more_down && first_idx > 1)
		more_up = TRUE;

	TAP_SPrint(text, " %d %s %d", first_idx, to_t, last_idx);
	string_length = getWidth(text, FNT_Size_1622);
	if (more_up || more_down) {
		TAP_Osd_FillBox(region_mem, X+W-25-100, Y, 100+25, 30, header_bg_colour);
		drawText(region_mem, X+W-25-string_length, Y+4, X+W-20-1, text, header_text_colour, header_bg_colour, FNT_Size_1622);
	}
	else {
		TAP_Osd_FillBox(region_mem, X+W-5-100, Y+4, 100, 20, header_bg_colour);
		drawText(region_mem, X+W-5-string_length, Y+4, X+W-1, text, header_text_colour, header_bg_colour, FNT_Size_1622);
	}

	if (more_up)
		TAP_Osd_PutGd(region_mem, X+W-20, Y+1, &_up_arrowGd, TRUE);
	ef (more_down)
		TAP_Osd_PutGd(region_mem, X+W-20, Y+2, &_down_arrowGd, TRUE);
}

void updateOptionCount(void)
{
	int  first_idx, last_idx, string_length;
	char text[12];
	// update the current options range displayed in the header
	first_idx = curr_idx - curr_highlight + 1;
	last_idx = ((curr_idx - curr_highlight + 10) > (NUMBER_OF_OPTIONS - 1)) ? NUMBER_OF_OPTIONS : first_idx + 9;

	TAP_SPrint(text, " %d %s %d", first_idx, to_t, last_idx);
	string_length = getWidth(text, FNT_Size_1622);
	TAP_Osd_FillBox(region_mem, X+W-5-100, Y+4, 100, 20, header_bg_colour);
	drawText(region_mem, X+W-5-string_length, Y+4, X+W-1, text, header_text_colour, header_bg_colour, FNT_Size_1622);
}

void updateThumbnailCount(void)
{
	int  first_idx, last_idx, string_length;
	char text[15];

	first_idx = curr_idx - curr_highlight + 1;
	last_idx = ((curr_idx - curr_highlight + 9) > (no_of_files - 1)) ? no_of_files : first_idx + 8;

	if (!scenes_displayed) TAP_Osd_FillBox(region_mem, thumbnail_offset_x+4, thumbnail_offset_y+4, 120, 22, header_bg_colour);
	if (existsInPlaylist(curr_dir, dir_info[curr_idx]->file_name) >= 0)
	{
		// mark as playlisted
		TAP_Osd_PutGd(region_mem, thumbnail_offset_x+4, thumbnail_offset_y+3, &_playlistGd, TRUE);
	}
	ef (isPhoto(dir_info[curr_idx]->file_name))
	{
		struct _dimensions* info = getDimensions(dir_info[curr_idx]->file_name);

		if (info && info->width > 0)
		{
			TAP_SPrint(text, " %d x %d", info->width, info->height);
			drawText(region_mem, thumbnail_offset_x+4, thumbnail_offset_y+4, thumbnail_offset_x+150-1, text, header_text_colour, header_bg_colour, FNT_Size_1622);
		}
	}
	 
	TAP_SPrint(text, " %d %s %d", first_idx, to_t, last_idx);
	string_length = getWidth(text, FNT_Size_1622);
	TAP_Osd_FillBox(region_mem, thumbnail_offset_x+640-1-100, thumbnail_offset_y+4, 85, 20, header_bg_colour);
	drawText(region_mem, thumbnail_offset_x-10+640-1-string_length, thumbnail_offset_y+4, thumbnail_offset_x-10+640-1, text, header_text_colour, header_bg_colour, FNT_Size_1622);
}

void drawFiles(word start)
{
	int i, lines = InDataFilesFolder(curr_dir) ? line_count : 10;

	// draw each line
	for (i = 0; i < (recycle_bin_displayed ? 10 : lines); i++)
	{
		drawFile(i, start + i);
	}

	updateFileCount();
}

void drawThumbnails(word start)
{
	int i;
	int finish;

	// draw each thumbnail
	finish = no_of_files > 9 ? 9 : no_of_files;
	for(i = 0; i < finish; i++)
	{
		drawThumbnail(i, start + i);
	}

	// update the current photo range displayed in the header
	updateThumbnailCount();
}

void appendThumbnailFooterString(word indent, dword *string_length, char *text, word color, bool header)
{
	TAP_SPrint(buffer, header ? "%s " : "%s    ", text);
	drawText(region_mem, indent+*string_length, thumbnail_offset_y+526-20, -1, buffer, color, COLOR_None, FNT_Size_1419);
	*string_length = *string_length + getWidth(buffer, FNT_Size_1419);
}

void appendPhotoViewerFooterString(word indent, dword *string_length, char *text, word color, bool header)
{
	TAP_SPrint(buffer, header ? "%s " : "%s   ", text);
	drawText(region, indent+*string_length, offset_y+450+15, -1, buffer, color, COLOR_None, FNT_Size_1419);
	*string_length = *string_length + getWidth(buffer, FNT_Size_1419);
}

void drawPinBox()
{
	word string_length, indent;
	word x = X+110, y = Y+120, w = W-220, h = 150;

	pin_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	// fill with colour
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);

	// title
	string_length = getWidth(please_enter_pin_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, -1, please_enter_pin_t, header_text_colour, COLOR_None, FNT_Size_1926);

	// entry text
	string_length = getWidth("_ _ _ _", FNT_Size_1622);
	if (string_length > w-4) string_length = w-4;
	indent = x + ((w - string_length) / 2);
	drawText(region_mem, indent, y+75, x+w-4, "_ _ _ _", folder_text_colour, COLOR_None, FNT_Size_1622);

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void drawInfoBox(char *title, char *info_line_1, char *info_line_2, bool show_ok, bool save)
{
	dword string_length;
	word indent;
	word x = X+60, y = Y+120, w = W-120, h = 150;

	if (save) info_save = TAP_Osd_SaveBox(region, X+60-10, Y+120-10, W-120+20, 150+20);

	// fill with colour
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30, body_bg_colour);
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);

	// ok box
	if (show_ok) {
		TAP_Osd_DrawRectangle(region_mem, x+((w-62)/2)-1, y+105-1, 60+2, 30+2, 2, frame_colour);
		TAP_Osd_FillBox(region_mem, x+((w-62)/2), y+105, 60, 30, highlight_bg_colour);
		drawText(region_mem, x+((w-62)/2)+15, y+105+4, -1, ok_t, body_text_colour, COLOR_None, FNT_Size_1622);
	}

	// text
	string_length = getWidth(title, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, -1, title, header_text_colour, COLOR_None, FNT_Size_1926);

	if (info_line_2 == NULL || strlen(info_line_2) == 0) {
		// draw first info line
		if (info_line_1 != NULL && strlen(info_line_1) > 0) {
			string_length = getWidth(info_line_1, FNT_Size_1622);
			if (string_length > w-4) string_length = w-4;
			indent = x + ((w - string_length) / 2);
			if (show_ok)
				drawText(region_mem, indent, y+55, x+w-4, info_line_1, folder_text_colour, COLOR_None, FNT_Size_1622);
			else
				drawText(region_mem, indent, y+75, x+w-4, info_line_1, folder_text_colour, COLOR_None, FNT_Size_1622);
		}
	}
	else {
		// draw first info line
		if (info_line_1 != NULL && strlen(info_line_1) > 0) {
			string_length = getWidth(info_line_1, FNT_Size_1622);
			if (string_length > w-4) string_length = w-4;
			indent = x + ((w - string_length) / 2);
			if (show_ok)
				drawText(region_mem, indent, y+45, x+w-4, info_line_1, folder_text_colour, COLOR_None, FNT_Size_1622);
			else
				drawText(region_mem, indent, y+65, x+w-4, info_line_1, folder_text_colour, COLOR_None, FNT_Size_1622);
		}

		// draw second info line (if there is one)
		if (info_line_2 != NULL && strlen(info_line_2) > 0) {
			string_length = getWidth(info_line_2, FNT_Size_1622);
			if (string_length > w-4) string_length = w-4;
			indent = x + ((w - string_length) / 2);
			if (show_ok)
				drawText(region_mem, indent, y+79, x+w-4, info_line_2, folder_text_colour, COLOR_None, FNT_Size_1622);
			else
				drawText(region_mem, indent, y+95, x+w-4, info_line_2, folder_text_colour, COLOR_None, FNT_Size_1622);
		}
	}

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void drawConfirmationBox()
{
	dword string_length;
	word indent;
	word x = X+60, y = Y+120, w = W-120, h = 150;
	
	if (confirm_video_job) {
		region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
		region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
		TAP_ExitNormal();
	}

	yes_no_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	// fill with colour
	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30, body_bg_colour);
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);
	TAP_Osd_FillBox(region_mem, x, y+h, w, 5, body_bg_colour);

	// yes/no boxes
	TAP_Osd_DrawRectangle(region_mem, x+((w-158)/2)-1, y+100-1, 70+2, 30+2, 2, frame_colour);
	TAP_Osd_DrawRectangle(region_mem, x+((w-158)/2)+100-1, y+100-1, 70+2, 30+2, 2, frame_colour);
	if (yes_selected)
	{
		TAP_Osd_FillBox(region_mem, x+((w-158)/2), y+100, 70, 30, highlight_bg_colour);
		TAP_Osd_FillBox(region_mem, x+((w-158)/2)+100, y+100, 70, 30, header_bg_colour);
	}
	else
	{
		TAP_Osd_FillBox(region_mem, x+((w-158)/2), y+100, 70, 30, header_bg_colour);
		TAP_Osd_FillBox(region_mem, x+((w-158)/2)+100, y+100, 70, 30, highlight_bg_colour);
	}

	if (choose_multi_play_mode) {
		drawText(region_mem, x+((w-158)/2)+5, y+100+4, -1, decode_t, body_text_colour, COLOR_None, FNT_Size_1622); 
		drawText(region_mem, x+((w-158)/2)+100+17, y+100+4, -1, play_t, body_text_colour, COLOR_None, FNT_Size_1622); 
	}
	else {
		drawText(region_mem, x+((w-158)/2)+20, y+100+4, -1, yes_t, body_text_colour, COLOR_None, FNT_Size_1622); 
		drawText(region_mem, x+((w-158)/2)+100+25, y+100+4, -1, no_t, body_text_colour, COLOR_None, FNT_Size_1622); 
	}

	// text
	if (stop_active_rec) {
		string_length = getWidth(stop_video_t, FNT_Size_1926);
		indent = x-5 + ((w+10 - string_length) / 2);
		drawText(region_mem, indent, y, -1, stop_video_t, header_text_colour, COLOR_None, FNT_Size_1926); 
	}
	ef (confirm_video_job) {
		string_length = getWidth(video_job_t, FNT_Size_1926);
		indent = x-5 + ((w+10 - string_length) / 2);
		drawText(region_mem, indent, y, -1, video_job_t, header_text_colour, COLOR_None, FNT_Size_1926); 
	}
	ef (choose_multi_play_mode) {
		string_length = getWidth(choose_batch_mode_t, FNT_Size_1926);
		indent = x-5 + ((w+10 - string_length) / 2);
		drawText(region_mem, indent, y, -1, choose_batch_mode_t, header_text_colour, COLOR_None, FNT_Size_1926); 
	}
	else {
		string_length = getWidth(confirm_delete_t, FNT_Size_1926);
		indent = x-5 + ((w+10 - string_length) / 2);
		drawText(region_mem, indent, y, -1, confirm_delete_t, header_text_colour, COLOR_None, FNT_Size_1926); 
	}

	if (!stop_menu_displayed && !choose_multi_play_mode && !confirm_video_job) {
		if (recycle_bin_displayed) {
			if (!delete_all && !smart_delete) {
				memset(buffer2, '\0', 100);
				strncat(buffer2, recycle_bin_list[curr_idx]->file_name, strlen(recycle_bin_list[curr_idx]->file_name)-getExtensionLength(recycle_bin_list[curr_idx]->file_name));
			}
		}
		ef (!auto_deletes_displayed)
			strcpy(buffer2, dir_info[curr_idx]->file_name);
	}

	if (choose_multi_play_mode) {
		if (overnight_play) {
			hour = overnight_thumbs_time / 60;
			min  = overnight_thumbs_time % 60;
			TAP_SPrint(buffer, "%s %s %02d:%02d", decode_or_play_t, at_t, hour, min);
		}
		else
			TAP_SPrint(buffer, decode_or_play_t);
	}
	ef (confirm_video_job)
		TAP_SPrint(buffer, "%s?", run_now_t);
	ef (auto_deletes_displayed)
		TAP_SPrint(buffer, "%s?", delete_all_rule_sets_t);
	ef (smart_delete)
		TAP_SPrint(buffer, "%s '%d%s' %s?", empty_bin_till_disk_t, empty_bin_percentage, "%", full_t);
	ef (delete_all)
		TAP_SPrint(buffer, "%s?", delete_all_files_t);
	ef (stop_menu_displayed)
		TAP_SPrint(buffer, "%s '%s'?", delete_file_t, playing_file.name);
	ef ((recycle_bin_displayed && recycle_bin_list[curr_idx]->folder) || (!recycle_bin_displayed && dir_info[curr_idx]->folder))
		TAP_SPrint(buffer, "%s '%s'?", delete_folder_t, buffer2);
	ef (stop_active_rec)
		TAP_SPrint(buffer, "%s '%s'?", stop_video_t, buffer2);
	else
		TAP_SPrint(buffer, "%s '%s'?", delete_file_t, buffer2);

	string_length = getWidth(buffer, FNT_Size_1622);
	if (string_length > w-4) string_length = w-4;
	indent = x + ((w - string_length) / 2);
	drawText(region_mem, indent, y+55, x+w-4, buffer, body_text_colour, COLOR_None, FNT_Size_1622); 

	drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 0, frame_colour, COLOR_None, body_bg_colour, FALSE);

	TAP_Osd_Copy(region_mem, region, x, y, w, 30, x, y, FALSE);
	TAP_Osd_Copy(region_mem, region, x-5, y+30, w+10+1, h-30, x-5, y+30, FALSE);
}

void toggleConfirmation()
{
	word x = X+60, y = Y+120, w = W-120, h = 150;

	// yes/no boxes
	TAP_Osd_DrawRectangle(region_mem, x+((w-158)/2)-1, y+100-1, 70+2, 30+2, 2, frame_colour);
	TAP_Osd_DrawRectangle(region_mem, x+((w-158)/2)+100-1, y+100-1, 70+2, 30+2, 2, frame_colour);
	if (yes_selected)
	{
		TAP_Osd_FillBox(region_mem, x+((w-158)/2), y+100, 70, 30, highlight_bg_colour);
		TAP_Osd_FillBox(region_mem, x+((w-158)/2)+100, y+100, 70, 30, header_bg_colour);
	}
	else
	{
		TAP_Osd_FillBox(region_mem, x+((w-158)/2), y+100, 70, 30, header_bg_colour);
		TAP_Osd_FillBox(region_mem, x+((w-158)/2)+100, y+100, 70, 30, highlight_bg_colour);
	}

	if (choose_multi_play_mode) {
		drawText(region_mem, x+((w-158)/2)+5, y+100+4, -1, decode_t, body_text_colour, COLOR_None, FNT_Size_1622);
		drawText(region_mem, x+((w-158)/2)+100+17, y+100+4, -1, play_t, body_text_colour, COLOR_None, FNT_Size_1622);
	}
	else {
		drawText(region_mem, x+((w-158)/2)+20, y+100+4, -1, yes_t, body_text_colour, COLOR_None, FNT_Size_1622);
		drawText(region_mem, x+((w-158)/2)+100+25, y+100+4, -1, no_t, body_text_colour, COLOR_None, FNT_Size_1622);
	}

	TAP_Osd_Copy(region_mem, region, x, y, w, h, x, y, FALSE);
}

bool isGifThumbnail(char *name)
{
    strcpy(file_name, name);
    strlwr(file_name);

	if (strlen(file_name) < 7) return FALSE;

    if (strcmp(file_name + strlen(file_name) - 6, "gif.tn" ) == 0)
        return TRUE;

    return FALSE;
}

void drawFooterMiniatureThumbnail(TYPE_File *thumbnail_file, word position, bool recording, int idx, char *name)
{
	int i, j, yy, adjusted_offset_x, adjusted_offset_y, min_width, min_height, thumbnail_width, thumbnail_height, skip, no_of_scenes;
	word *thumbnail_bitmap, *mini_bitmap;
	byte *thumbnail_bytes, *mini_bytes;

	if (recording) TAP_Hdd_Fread(&no_of_scenes, sizeof(int), 1, thumbnail_file);
	if (recording) TAP_Hdd_Fread(&skip, sizeof(int), 1, thumbnail_file);
	TAP_Hdd_Fread(&thumbnail_width, sizeof(int), 1, thumbnail_file);
	TAP_Hdd_Fread(&thumbnail_height, sizeof(int), 1, thumbnail_file);
	if (!recording) TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, thumbnail_file);
	if (!recording) TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, thumbnail_file);
	if (isGifThumbnail(name)) {
		thumbnail_bytes = dlmalloc(sizeof(byte) * thumbnail_width * thumbnail_height);
		if (thumbnail_bytes != NULL)
			TAP_Hdd_Fread(thumbnail_bytes, sizeof(byte), (thumbnail_width * thumbnail_height), thumbnail_file);
	}
	else {
		thumbnail_bitmap = dlmalloc(sizeof(word) * thumbnail_width * thumbnail_height);
		if (thumbnail_bitmap != NULL)
			TAP_Hdd_Fread(thumbnail_bitmap, sizeof(word), (thumbnail_width * thumbnail_height), thumbnail_file);
	}
	TAP_Hdd_Fclose(thumbnail_file);

	min_width = (thumbnail_width / 2) - 1;
	min_height = (thumbnail_height / 2) - 1;

	switch (position) {
		case 0:
			adjusted_offset_x = X-5+((W-380-152)/2)-1 + (75 - min_width) / 2;
			adjusted_offset_y = Y+327 + (57 - min_height) / 2;
			if (InDataFilesFolder(curr_dir)) adjusted_offset_x = X+W-150+3 + (75 - min_width) / 2;
			if (strcmp(dir_info[curr_idx]->file_name, "DataFiles") == 0) adjusted_offset_x += 2;
			break;
		case 1:
			adjusted_offset_x = X-5+((W-380-152)/2)+78 + (75 - min_width) / 2;
			adjusted_offset_y = Y+327 + (57 - min_height) / 2;
			if (InDataFilesFolder(curr_dir)) adjusted_offset_x = X+W-150+3+75 + (75 - min_width) / 2;
			if (strcmp(dir_info[curr_idx]->file_name, "DataFiles") == 0) adjusted_offset_x -= 4;
			break;
		case 2:
			adjusted_offset_x = X-5+((W-380-152)/2)-1 + (75 - min_width) / 2;
			adjusted_offset_y = Y+327+60 + (57 - min_height) / 2;
			if (InDataFilesFolder(curr_dir)) adjusted_offset_x = X+W-150+3 + (75 - min_width) / 2;
			if (strcmp(dir_info[curr_idx]->file_name, "DataFiles") == 0) adjusted_offset_x += 2;
			break;
		case 3:
			adjusted_offset_x = X-5+((W-380-152)/2)+78 + (75 - min_width) / 2;
			adjusted_offset_y = Y+327+60 + (57 - min_height) / 2;
			if (InDataFilesFolder(curr_dir)) adjusted_offset_x = X+W-150+3+75 + (75 - min_width) / 2;
			if (strcmp(dir_info[curr_idx]->file_name, "DataFiles") == 0) adjusted_offset_x -= 4;
			break;
	}

	if (isGifThumbnail(name)) {
		memset(file_name, '\0', 100);
		strncat(file_name, name, strlen(name)-3);
		ChangeDir("..");
		setLut(file_name);
		ChangeDir("Cache");
		TAP_Osd_DrawRectangle(region_mem, adjusted_offset_x-1, adjusted_offset_y-1, min_width+2, min_height+2, 1, image_border_colour);
		mini_bytes = dlmalloc(sizeof(byte) * min_width * min_height);
		for (j = 0; j < min_height; j++) {
			yy = (j * thumbnail_height / min_height) * thumbnail_width;
			for (i = 0; i < min_width; i++) { 
				mini_bytes[i + j * min_width] = thumbnail_bytes[yy + i * thumbnail_width / min_width];
			}
		}

		TAP_Osd_DrawPixmap(region_mem, adjusted_offset_x, adjusted_offset_y, min_width, min_height, mini_bytes, FALSE, OSD_256);

		dlfree(mini_bytes);
		dlfree(thumbnail_bytes);
	}
	else {
		TAP_Osd_DrawRectangle(region_mem, adjusted_offset_x-1, adjusted_offset_y-1, min_width+2, min_height+2, 1, image_border_colour);
		mini_bitmap = dlmalloc(sizeof(word) * min_width * min_height);
		for (j = 0; j < min_height; j++) {
			yy = (j * thumbnail_height / min_height) * thumbnail_width;
			for (i = 0; i < min_width; i++) { 
				//TAP_Osd_PutPixel(region_mem, adjusted_offset_x + i, adjusted_offset_y + j, thumbnail_bitmap[yy + i * thumbnail_width / min_width]);
				mini_bitmap[i + j * min_width] = thumbnail_bitmap[yy + i * thumbnail_width / min_width];
			}
		}
#ifndef WIN32
		TAP_Osd_DrawPixmap(region_mem, adjusted_offset_x, adjusted_offset_y, min_width, min_height, mini_bitmap, FALSE, OSD_1555);
#endif
#ifdef WIN32
		for (j = 0; j < min_height; j++) 
			for (i = 0; i < min_width; i++) 
				TAP_Osd_PutPixel(region_mem, adjusted_offset_x + i, adjusted_offset_y + j, mini_bitmap[i + j * min_width]);
#endif

		dlfree(mini_bitmap);
		dlfree(thumbnail_bitmap);
	}
}

void *getThumbnailRawData(TYPE_File *thumbnail_file, int *thumbnail_width, int *thumbnail_height, bool recording, bool gif)
{
	int current_position, no_of_scenes;
	int max_width = recording ? 140 : 150, max_height = 112; 
	void *thumbnail_data = NULL;

	if (recording) TAP_Hdd_Fread(&no_of_scenes, sizeof(int), 1, thumbnail_file);
	if (recording) TAP_Hdd_Fread(&current_position, sizeof(int), 1, thumbnail_file);
	TAP_Hdd_Fread(thumbnail_width, sizeof(int), 1, thumbnail_file);
	TAP_Hdd_Fread(thumbnail_height, sizeof(int), 1, thumbnail_file);
	if (!recording) TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, thumbnail_file);
	if (!recording)TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, thumbnail_file);

	if (gif) {
		thumbnail_data = dlmalloc(sizeof(byte) * *thumbnail_width * *thumbnail_height);
		if (thumbnail_data != NULL)
			TAP_Hdd_Fread(thumbnail_data, sizeof(byte), (*thumbnail_width * *thumbnail_height), thumbnail_file);
	}
	else {
		thumbnail_data = dlmalloc(sizeof(word) * *thumbnail_width * *thumbnail_height);
		if (thumbnail_data != NULL)
			TAP_Hdd_Fread(thumbnail_data, sizeof(word), (*thumbnail_width * *thumbnail_height), thumbnail_file);
	}
	TAP_Hdd_Fclose(thumbnail_file);

	return thumbnail_data;
}

void drawFooterThumbnail(TYPE_File *thumbnail_file, TYPE_Header *preloaded_header, bool recording, int idx)
{
	int i, j, adjusted_offset_x, adjusted_offset_y, thumbnail_width, thumbnail_height;
	int max_width = recording ? 140 : 150, max_height = 112; 
	bool release_memory = TRUE;
	word *thumbnail_bitmap = NULL;
	byte *thumbnail_bytes = NULL;

	if (preloaded_header && preloaded_header->thumbnail) {
		thumbnail_bitmap = preloaded_header->thumbnail;
		thumbnail_width = preloaded_header->thumbnail_width;
		thumbnail_height = preloaded_header->thumbnail_height;
		release_memory = FALSE;
	}
	ef (isGif(dir_info[idx]->file_name))
		thumbnail_bytes = (byte *) getThumbnailRawData(thumbnail_file, &thumbnail_width, &thumbnail_height, recording, TRUE);
	else
		thumbnail_bitmap = (word *) getThumbnailRawData(thumbnail_file, &thumbnail_width, &thumbnail_height, recording, FALSE);

	if (thumbnail_bytes == NULL && thumbnail_bitmap == NULL)
		return;

	if (recording)
		adjusted_offset_x = X+W-150+8;
	else
		adjusted_offset_x = X-5+((W-380-150)/2) + (max_width - thumbnail_width) / 2;
	adjusted_offset_y = Y+330 + (max_height - thumbnail_height) / 2;
	TAP_Osd_DrawRectangle(region_mem, adjusted_offset_x-1, adjusted_offset_y-1, thumbnail_width+2, thumbnail_height+2, 1, image_border_colour);

	if (isGif(dir_info[idx]->file_name)) {
		setLut(dir_info[idx]->file_name);
		for (j = 0; j < thumbnail_height; j++) 
			for (i = 0; i < thumbnail_width; i++) 
				TAP_Osd_DrawPixmap(region_mem, adjusted_offset_x + i, adjusted_offset_y + j, 1, 1, &thumbnail_bytes[i + j * thumbnail_width], FALSE, OSD_256);
		dlfree(thumbnail_bytes);
	}
	else {
#ifndef WIN32
		TAP_Osd_DrawPixmap(region_mem, adjusted_offset_x, adjusted_offset_y, thumbnail_width, thumbnail_height, thumbnail_bitmap, FALSE, OSD_1555);
#endif
#ifdef WIN32
		for (j = 0; j < thumbnail_height; j++) 
			for (i = 0; i < thumbnail_width; i++) 
				TAP_Osd_PutPixel(region_mem, adjusted_offset_x + i, adjusted_offset_y + j, thumbnail_bitmap[i + j * thumbnail_width]);
#endif
		if (release_memory) dlfree(thumbnail_bitmap);
	}
}

bool recordingThumbnailExists(char *name, bool scene)
{
	strcpy(file_name, name);
	strcat(file_name, ".tn");
	if (scene)
		strcat(file_name, ".1");

	// check whether the thumbnail exists
	if (TAP_Hdd_Exist("Cache")) {
		ChangeDir("Cache");
		if (TAP_Hdd_Exist(file_name)) {
			ChangeDir("..");
			return TRUE;
		}
		ChangeDir("..");
	}

	return FALSE;
}

word doAutoDeletes()
{
	word i, j, rules_idx, found_idx, deleted_files = 0;

	// cycle round the matched names
	for (i = 0; i < no_of_matched_recordings; i++) {

		// find the auto delete rules for this matched name
		for (j = 0; j < no_of_auto_deletes; j++) {
			if (strcmp(recordings_episode_count[i]->matched_name, auto_delete_list[j]->file_name) == 0) {
				rules_idx = j;
				break;
			}
		}

		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete using rule %s, checking %d recordings", auto_delete_list[rules_idx]->file_name, recordings_episode_count[i]->no_of_episodes);
		if (write_log) if (verbose) logText(log_buffer, FALSE);

		// first pass deletes all recs which are too old
		if (auto_delete_list[rules_idx]->delete_after_days > 0) {

			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check max days");
			if (write_log) if (verbose) logText(log_buffer, FALSE);

			// first off, position idx in right place in recordings table
			for (j = 0; j < no_of_recordings; j++) {
				if (strcmp(recordings_extract[j]->matched_name, recordings_episode_count[i]->matched_name) == 0) {
					found_idx = j;
					break;
				}
			}

			// then check all the matching recordings
			j = found_idx;
			while (j < no_of_recordings && recordings_extract[j]->file_name != NULL && strcmp(recordings_extract[j]->matched_name, recordings_episode_count[i]->matched_name) == 0) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check file %s", recordings_extract[j]->file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				TAP_GetTime(&mjd, &hour, &min, &sec);
				if (mjd - recordings_extract[j]->mjd > auto_delete_list[rules_idx]->delete_after_days) {
					if (auto_delete_list[rules_idx]->delete_after_min == 0 || recordings_episode_count[i]->no_of_episodes > auto_delete_list[rules_idx]->delete_after_min) {
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete file %s according to date rule", recordings_extract[j]->file_name);
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						if (enable_recycle_bin)
							doRecycle(recordings_extract[j]->file_name, recordings_extract[j]->start_cluster, recordings_extract[j]->directory, recordings_extract[j]->mjd, recordings_extract[j]->hour, recordings_extract[j]->min, recordings_extract[j]->size, FALSE, TRUE);
						else
							doDelete(recordings_extract[j]->file_name, recordings_extract[j]->start_cluster, recordings_extract[j]->directory, FALSE, TRUE);
						recordings_episode_count[i]->no_of_episodes--;
						deleted_files++;
					}
				}

				j++;
			}
		}

		// second pass deletes all recs which exceed max episodes
		if (auto_delete_list[rules_idx]->delete_after_max > 0) {

			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check max episodes");
			if (write_log) if (verbose) logText(log_buffer, FALSE);

			// first off, position idx in right place in recordings table
			for (j = 0; j < no_of_recordings; j++) {
				if (strcmp(recordings_extract[j]->matched_name, recordings_episode_count[i]->matched_name) == 0) {
					found_idx = j;
					break;
				}
			}

			// then check all the matching recordings
			j = found_idx;
			while (j < no_of_recordings && recordings_extract[j]->file_name != NULL && strcmp(recordings_extract[j]->matched_name, recordings_episode_count[i]->matched_name) == 0) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check file %s", recordings_extract[j]->file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				if (recordings_episode_count[i]->no_of_episodes > auto_delete_list[rules_idx]->delete_after_max) {
					if (auto_delete_list[rules_idx]->delete_after_min == 0 || recordings_episode_count[i]->no_of_episodes > auto_delete_list[rules_idx]->delete_after_min) {
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete file %s according to max episodes", recordings_extract[j]->file_name);
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						if (enable_recycle_bin)
							doRecycle(recordings_extract[j]->file_name, recordings_extract[j]->start_cluster, recordings_extract[j]->directory, recordings_extract[j]->mjd, recordings_extract[j]->hour, recordings_extract[j]->min, recordings_extract[j]->size, FALSE, TRUE);
						else
							doDelete(recordings_extract[j]->file_name, recordings_extract[j]->start_cluster, recordings_extract[j]->directory, FALSE, TRUE);
						recordings_episode_count[i]->no_of_episodes--;
						deleted_files++;
					}
				}

				j++;
			}
		}

		// third pass deletes all recs which break hard disk size limit
		if (auto_delete_list[rules_idx]->delete_when_disk > 0) {

			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check free disk space");
			if (write_log) if (verbose) logText(log_buffer, FALSE);

			// first off, position idx in right place in recordings table
			for (j = 0; j < no_of_recordings; j++) {
				if (strcmp(recordings_extract[j]->matched_name, recordings_episode_count[i]->matched_name) == 0) {
					found_idx = j;
					break;
				}
			}

			// then check all the matching recordings
			j = found_idx;
			while (j < no_of_recordings && recordings_extract[j]->file_name != NULL && strcmp(recordings_extract[j]->matched_name, recordings_episode_count[i]->matched_name) == 0) {
				dword free_size = TAP_Hdd_FreeSize(), total_size = TAP_Hdd_TotalSize(), percentage_full;
				if (total_size == 0) total_size = 250000;
				if (free_size > total_size) free_size = total_size;
				percentage_full = (total_size-free_size)*100 / total_size;
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check file %s", recordings_extract[j]->file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				if (percentage_full > auto_delete_list[rules_idx]->delete_when_disk && recordings_episode_count[i]->no_of_episodes > auto_delete_list[rules_idx]->delete_after_min) {
					if (auto_delete_list[rules_idx]->delete_after_min == 0 || recordings_episode_count[i]->no_of_episodes > auto_delete_list[rules_idx]->delete_after_min) {
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete file %s according to hard disk size", recordings_extract[j]->file_name);
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						if (enable_recycle_bin)
							doRecycle(recordings_extract[j]->file_name, recordings_extract[j]->start_cluster, recordings_extract[j]->directory, recordings_extract[j]->mjd, recordings_extract[j]->hour, recordings_extract[j]->min, recordings_extract[j]->size, FALSE, TRUE);
						else
							doDelete(recordings_extract[j]->file_name, recordings_extract[j]->start_cluster, recordings_extract[j]->directory, FALSE, TRUE);
						recordings_episode_count[i]->no_of_episodes--;
						deleted_files++;
					}
				}

				j++;
			}
		}
	}

	return deleted_files;
}

void extractRecordingData(TYPE_File file, char *directory, int rules_idx)
{
	TYPE_RecInfo rec_info_1, rec_info_2;
	word i, j;
	bool matched = FALSE;

	TAP_Hdd_GetRecInfo(0, &rec_info_1);
	TAP_Hdd_GetRecInfo(1, &rec_info_2);
		
	// ignore any active recordings
	if (strcmp(rec_info_1.fileName, file.name) == 0 || strcmp(rec_info_2.fileName, file.name) == 0)
		return;

	if (rules_idx > -1) {

		//if (strncmp(buffer, buffer2, strlen(buffer2)) == 0) {
		if (containsSubstring(file.name, auto_delete_list[rules_idx]->file_name) >= 0
				|| (strcmp(auto_delete_list[rules_idx]->file_name, "*") == 0 && IsDataFilesFolder(directory))) {

			// increment the episode count (if table entry exists yet)
			for (j = 0; j < no_of_matched_recordings; j++) {
				if (strcmp(auto_delete_list[rules_idx]->file_name, recordings_episode_count[j]->matched_name) == 0) {
					recordings_episode_count[j]->no_of_episodes++;
					matched = TRUE;
					break;
				}
			}
			
			// if no entry found in episode count table, then add it
			if (!matched) {
				if (no_of_matched_recordings == 0)
					recordings_episode_count = dlmalloc(sizeof(*recordings_episode_count) * 512);

				recordings_episode_count[no_of_matched_recordings] = dlmalloc(sizeof(*recordings_episode_count[no_of_matched_recordings]));
				memset(recordings_episode_count[no_of_matched_recordings], 0, sizeof(*recordings_episode_count[no_of_matched_recordings]));
				recordings_episode_count[no_of_matched_recordings]->matched_name = dlmalloc(100 * sizeof(char));
				strcpy(recordings_episode_count[no_of_matched_recordings]->matched_name, auto_delete_list[rules_idx]->file_name);
				recordings_episode_count[no_of_matched_recordings]->no_of_episodes = 1;
				no_of_matched_recordings++;
				matched = TRUE;
			}
		}
	}
	else {
		for (i = 0; i < no_of_auto_deletes; i++) {

			//if (strncmp(buffer, buffer2, strlen(buffer2)) == 0) {
			if (containsSubstring(file.name, auto_delete_list[i]->file_name) >= 0
					|| (strcmp(auto_delete_list[i]->file_name, "*") == 0 && IsDataFilesFolder(directory))) {

				// increment the episode count (if table entry exists yet)
				for (j = 0; j < no_of_matched_recordings; j++) {
					if (strcmp(auto_delete_list[i]->file_name, recordings_episode_count[j]->matched_name) == 0) {
						recordings_episode_count[j]->no_of_episodes++;
						matched = TRUE;
						break;
					}
				}
				
				// if no entry found in episode count table, then add it
				if (!matched) {
					if (no_of_matched_recordings == 0)
						recordings_episode_count = dlmalloc(sizeof(*recordings_episode_count) * 512);

					recordings_episode_count[no_of_matched_recordings] = dlmalloc(sizeof(*recordings_episode_count[no_of_matched_recordings]));
					memset(recordings_episode_count[no_of_matched_recordings], 0, sizeof(*recordings_episode_count[no_of_matched_recordings]));

					recordings_episode_count[no_of_matched_recordings]->matched_name = dlmalloc(100 * sizeof(char));
					strcpy(recordings_episode_count[no_of_matched_recordings]->matched_name, auto_delete_list[i]->file_name);
					recordings_episode_count[no_of_matched_recordings]->no_of_episodes = 1;
					no_of_matched_recordings++;
					matched = TRUE;
				}

				break;
			}
		}
	}

	// if this recording matches a delete rule set, then add entry to table
	if (matched) {
		if (no_of_recordings == 0)
			recordings_extract = dlmalloc(sizeof(*recordings_extract) * 512);

		recordings_extract[no_of_recordings] = dlmalloc(sizeof(*recordings_extract[no_of_recordings]));
		memset(recordings_extract[no_of_recordings], 0, sizeof(*recordings_extract[no_of_recordings]));

		recordings_extract[no_of_recordings]->file_name = dlmalloc(100 * sizeof(char));
		recordings_extract[no_of_recordings]->matched_name = dlmalloc(100 * sizeof(char));
		recordings_extract[no_of_recordings]->directory = dlmalloc(256 * sizeof(char));
		strcpy(recordings_extract[no_of_recordings]->file_name, file.name);
		if (rules_idx > -1)
			strcpy(recordings_extract[no_of_recordings]->matched_name, auto_delete_list[rules_idx]->file_name);
		else
			strcpy(recordings_extract[no_of_recordings]->matched_name, auto_delete_list[i]->file_name);
		strcpy(recordings_extract[no_of_recordings]->directory, directory);
		recordings_extract[no_of_recordings]->start_cluster = file.startCluster;
		recordings_extract[no_of_recordings]->mjd = file.mjd;
		recordings_extract[no_of_recordings]->hour = file.hour;
		recordings_extract[no_of_recordings]->min = file.min;
		recordings_extract[no_of_recordings]->size = file.size;
		no_of_recordings++;
	}
}

word runAutoDeleteRules(int rules_idx)
{
	word deleted_files;

	no_of_recordings = 0; no_of_matched_recordings = 0;

	ChangeDirDataFiles();
	parseAllFiles(LOAD_AUTO_DELETE_RULES, rules_idx, FALSE);

	qsort(recordings_episode_count, no_of_matched_recordings, sizeof(recordings_episode_count[0]), compareMatchedRecordings);
	qsort(recordings_extract, no_of_recordings, sizeof(recordings_extract[0]), compareRecordings);
	deleted_files = doAutoDeletes();

	freeAutoDeleteMemory();

	ChangeDirPath(curr_dir);

	return deleted_files;
}

static dword tap_id;
static char tap_title[MAX_PROGRAM_NAME+1], tap_author[MAX_AUTHOR_NAME+1], tap_desc[MAX_DESCRIPTION+1], tap_etc[MAX_ETCINFO_STR+1];

void extractTapHeaderInfo(char *file_name)
{
	TYPE_File   *file;
    byte        *buffer;
	word id1, id2, id3, id4;

	// initialise variables
	tap_id = 0;
	memset(tap_title, '\0', MAX_PROGRAM_NAME+1); memset(tap_author, '\0', MAX_AUTHOR_NAME+1);
	memset(tap_desc, '\0', MAX_DESCRIPTION+1); memset(tap_etc, '\0', MAX_ETCINFO_STR+1);

	file = TAP_Hdd_Fopen(file_name); 
    if (file == NULL) 
        return;

    buffer = (byte *) dlmalloc(64+MAX_PROGRAM_NAME+MAX_AUTHOR_NAME+MAX_DESCRIPTION+MAX_ETCINFO_STR);
    if (buffer == NULL) {TAP_Hdd_Fclose(file); return;}
	TAP_Hdd_Fread(buffer, 64+MAX_PROGRAM_NAME+MAX_AUTHOR_NAME+MAX_DESCRIPTION+MAX_ETCINFO_STR, 1, file);
	TAP_Hdd_Fclose(file);

	id1 = buffer[32]; id2 = buffer[33]; id3 = buffer[34]; id4 = buffer[35];
	tap_id = (id1<<24) + (id2<<16) + (id3<<8) + id4;
	//tap_id = 0x8000acdc;
	memcpy(tap_title, buffer+64, MAX_PROGRAM_NAME);   
	tap_title[MAX_PROGRAM_NAME]='\0';
	memcpy(tap_author, buffer+64+MAX_PROGRAM_NAME, MAX_AUTHOR_NAME);   
	tap_author[MAX_AUTHOR_NAME]='\0';
	memcpy(tap_desc, buffer+64+MAX_PROGRAM_NAME+MAX_AUTHOR_NAME, MAX_DESCRIPTION);   
	tap_desc[MAX_DESCRIPTION]='\0';
	memcpy(tap_etc, buffer+64+MAX_PROGRAM_NAME+MAX_AUTHOR_NAME+MAX_DESCRIPTION, MAX_ETCINFO_STR);   
	tap_etc[MAX_ETCINFO_STR]='\0';

	dlfree(buffer);
	buffer = NULL;
	dlmalloc_trim(0);
}

void saveThumbnailToDisk(char *file_name, word *pixels, int width, int height, int skip_position, int no_of_scenes)
{
	TYPE_File *pixel_file;

	// write the scene to disk
	//if (write_log) if (verbose) logText("Save the scene to disk", FALSE);
	if (TAP_Hdd_Exist(file_name)) TAP_Hdd_Delete(file_name);
	TAP_Hdd_Create(file_name, ATTR_NORMAL);
	pixel_file = TAP_Hdd_Fopen(file_name);
	if (pixel_file != NULL) {
		TAP_Hdd_Fwrite(&no_of_scenes, sizeof(int), 1, pixel_file);
		TAP_Hdd_Fwrite(&skip_position, sizeof(int), 1, pixel_file);
		TAP_Hdd_Fwrite(&width, sizeof(int), 1, pixel_file);
		TAP_Hdd_Fwrite(&height, sizeof(int), 1, pixel_file);
		TAP_Hdd_Fwrite(pixels, sizeof(word), (width * height), pixel_file);
		TAP_Hdd_Fclose(pixel_file);
	}
}

void createRecordingThumbnail(char *recording_name, dword start_cluster, bool thumbnail, bool scenes, bool force_thumbnail, bool force_scenes, bool already_playing)
{
	TYPE_PlayInfo play_info;
	TYPE_RecInfo rec_info_1, rec_info_2;
	TYPE_Header *preloaded_header;
	TYPE_File rec_file;
	int no_of_scenes, skip_position, width = 140, height = 112, i;
	word *pixels;
	bool playing = FALSE;

	if (!already_playing) {
		getRecHeaderDetail(recording_name);
		if (svcType == SVC_TYPE_Radio 
				|| (isTF5800() 
					&& TAP_Channel_GetInfo(svcType, svcNum, &channel_info) == 1
					&& channel_info.logicalChNum >= 700 && channel_info.logicalChNum < 800)) {
			return;
		}
	}

	strcpy(file_name, recording_name);
	strcat(file_name, ".tn");

	// only create thumb if not already there, or force creation specified
	if (thumbnail && (!recordingThumbnailExists(recording_name, FALSE) || force_thumbnail)) {
		// if we are recording this file, then cannot create thumbnail
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		if (strcmp(rec_info_1.fileName, recording_name) == 0 || strcmp(rec_info_2.fileName, recording_name) == 0) {
			TAP_Delay(200);
			return;
		}

		// play the vid and skip to x mins in
		if (!already_playing) {
			TAP_Print("Play recording %s\r\n", recording_name);
			TAP_Hdd_PlayTs(recording_name);
			TAP_Hdd_GetPlayInfo(&play_info);
			stop_playing = TRUE;
			if (play_info.svcType == SVC_TYPE_Radio) {
				TAP_Hdd_ChangePlaybackPos(play_info.totalBlock);
				TAP_Delay(200);
				return;
			}
		}

		playing = TRUE;
		if (thumbnail_skip == 0)
			skip_position = 0;
		if (play_info.duration < 10 || play_info.duration <= thumbnail_skip)
			skip_position = play_info.totalBlock / 2;
		else
			skip_position = (play_info.totalBlock * thumbnail_skip) / play_info.duration;
		if (!create_scenes || scene_skip == 0)
			no_of_scenes = 0;
		else
			no_of_scenes = (play_info.duration / scene_skip);
		if (play_info.duration % scene_skip == 0) no_of_scenes--;
		TAP_Print("Skip to block %d of %d\r\n", skip_position, play_info.totalBlock);
		if (!already_playing) {
			TAP_Hdd_ChangePlaybackPos(skip_position);
			TAP_Delay(/*masterpiece_mode ? 400 :*/ 200);
		}
		
		pixels = dlmalloc(sizeof(word)*width*height);
		if (pixels == NULL) {
			if (!already_playing) TAP_Hdd_ChangePlaybackPos(play_info.totalBlock);
			TAP_Delay(200);
			return;
		}

		// capture the screen 
		TAP_Print("Capture the thumbnail\r\n");
		captureVideo(pixels, width, height);

		// change to the directory now if it is a real time capture (do this after the video capture)
		if (already_playing) {
			if (!ChangeDirCurrentRecording(playing_file.name, playing_file.startCluster, &rec_file)) {
				if (pixels) dlfree(pixels);
				pixels = NULL;
				return;
			}
		}

		// change to cache dir
		if (!TAP_Hdd_Exist("Cache")) TAP_Hdd_Create("Cache", ATTR_FOLDER);
		ChangeDir("Cache");

		// save it to disk
		saveThumbnailToDisk(file_name, pixels, width, height, skip_position, no_of_scenes);

		if (pixels) dlfree(pixels);
		pixels = NULL;

		ChangeDir("..");
		
		// set the thumbnail into header data
		if (preload_video_headers == HEADERS_AND_THUMBNAILS || preload_video_headers == HEADERS_AND_THUMBNAILS_LAZY) {
			preloaded_header = getRecHeader(recording_name, start_cluster);
			if (preloaded_header)
				extractHeaderThumbnail(preloaded_header, recording_name);
		}

		/*if (!masterpiece_mode)*/ if (!already_playing) {
			TAP_Hdd_ChangePlaybackPos(play_info.totalBlock);
			TAP_Delay(200);
		}
	}
	
	// only create scenes if not already there, or force creation specified (and config says to do so)
	if (create_scenes && scenes && scene_skip > 0 && (!recordingThumbnailExists(recording_name, TRUE) || force_scenes)) {
		// if we are recording this file, then cannot create scenese
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		if (strcmp(rec_info_1.fileName, recording_name) == 0 || strcmp(rec_info_2.fileName, recording_name) == 0) {
			TAP_Delay(200);
			return;
		}

		// create the scenes at the defined intervals
		i = 1;
		while (i < 64) {
			// work out the scene file name
			TAP_SPrint(file_name, "%s.tn.%d", recording_name, i);
	
			// calculate the position to skip to (and start the rec if not done so i.e. thumb was already there)
			if (!playing) {
				TAP_Print("Play recording %s\r\n", recording_name);
				TAP_Hdd_PlayTs(recording_name);
				TAP_Hdd_GetPlayInfo(&play_info);
				stop_playing = TRUE;
				if (play_info.svcType == SVC_TYPE_Radio) {
					TAP_Hdd_ChangePlaybackPos(play_info.totalBlock);
					TAP_Delay(200);
					return;
				}
				playing = TRUE;
			}

			skip_position = play_info.totalBlock*i*1000 / ((play_info.duration*1000 / scene_skip));
			no_of_scenes = (play_info.duration / scene_skip);
			if (play_info.duration % scene_skip == 0) no_of_scenes--;
			if (skip_position >= play_info.totalBlock || play_info.duration <= scene_skip) {
				TAP_Hdd_ChangePlaybackPos(play_info.totalBlock);
				TAP_Delay(200);
				return;
			}

			TAP_Print("Skip to block %d of %d\r\n", skip_position, play_info.totalBlock);
			TAP_Hdd_ChangePlaybackPos(skip_position);
			TAP_Delay(200);

			pixels = dlmalloc(sizeof(word)*width*height);
			if (pixels == NULL) {
				TAP_Hdd_ChangePlaybackPos(play_info.totalBlock);
				TAP_Delay(200);
				return;
			}

			// capture the screen 
			TAP_Print("Capture scene %d\r\n", i);
			captureVideo(pixels, width, height);

			// change to cache dir
			if (!TAP_Hdd_Exist("Cache")) TAP_Hdd_Create("Cache", ATTR_FOLDER);
			ChangeDir("Cache");

			// save it to disk
			TAP_Print("Save scene %d, %s\r\n", i, file_name);
			saveThumbnailToDisk(file_name, pixels, width, height, skip_position, no_of_scenes);

			if (pixels) dlfree(pixels);
			pixels = NULL;

			ChangeDir("..");

			i++;
		}

		TAP_Hdd_ChangePlaybackPos(play_info.totalBlock);
		TAP_Delay(200);
	}

	dlmalloc_trim(0);
}

void createAllRecordingThumbnails(bool from_batch)
{
	TYPE_PlayInfo play_info;

	ChangeDirDataFiles();
	parseAllFiles(CREATE_THUMBNAILS, 0, FALSE);

	//if (!from_batch) {
		do {
			TAP_SystemProc();
			TAP_Hdd_GetPlayInfo(&play_info);
		}
		while (play_info.playMode == PLAYMODE_Playing);
	//}

	if (stop_playing) {
		//if (from_batch)
			stop_playing = FALSE;
		//else
		//	TAP_GenerateEvent(EVT_KEY, RKEY_Stop, 0);
	}

	ChangeDirPath(curr_dir);
}

bool isDuffRec(TYPE_File rec_file)
{
	TYPE_File   *file;
    byte        *buffer;
	char rec_tag[5];

	// initialise variables
	recDuration = 0; 
	memset(rec_tag,	'\0', 5);

	//if (rec_file.attr != ATTR_TS)
		//return TRUE;

	file = TAP_Hdd_Fopen(rec_file.name); 
    if (file == NULL) 
        return TRUE;

    buffer = (byte *) dlmalloc(BUFFER_SIZE);
    if (buffer == NULL) {TAP_Hdd_Fclose(file); return TRUE;}
    TAP_Hdd_Fread(buffer, BUFFER_SIZE, 1, file);
    TAP_Hdd_Fclose(file);

	strncat(rec_tag, buffer, 4);
    recDuration = buffer[REC_DURATION_OFFSET]*256 + buffer[REC_DURATION_OFFSET+1];

	dlfree(buffer);
	buffer = NULL;

	dlmalloc_trim(0);

	if (strcmp(rec_tag, "TFrc") != 0 /*|| recDuration == 0*/ || (file->size < 1048576 && recDuration < 60))
		return TRUE;

	return FALSE;
}

word getRecHeaderDetail(char *name)
{
	TYPE_File   *file;
    byte        *buffer;
	char rec_tag[5];

	// initialise variables
	recDuration = 0; 
	memset(rec_tag,	'\0', 5);

	file = TAP_Hdd_Fopen(name); 
    if (file == NULL) 
        return 0;

    buffer = (byte *) dlmalloc(BUFFER_SIZE);
    if (buffer == NULL) {TAP_Hdd_Fclose(file); return 0;}
    TAP_Hdd_Fread(buffer, BUFFER_SIZE, 1, file);
    TAP_Hdd_Fclose(file);

	strncat(rec_tag, buffer, 4);
    recDuration = buffer[REC_DURATION_OFFSET]*256 + buffer[REC_DURATION_OFFSET+1];

	svcNum = buffer[SVC_NUM_OFFSET]*256 + buffer[SVC_NUM_OFFSET+1];
	svcType = buffer[SVC_TYPE_OFFSET];

	dlfree(buffer);
	buffer = NULL;
	dlmalloc_trim(0);

	if (strcmp(rec_tag, "TFrc") != 0 /*|| recDuration == 0*/ || (file->size < 1048576 && recDuration < 60))
		return 0;

    return svcNum;
}

TYPE_Header *getRecHeader(char *name, dword start_cluster)
{
	word i;

	for (i = 0; i < no_of_rec_headers; i++) {
		if (strcmp(all_rec_headers[i]->file_name, name) == 0 && all_rec_headers[i]->start_cluster == start_cluster)
			return all_rec_headers[i];
	}

	return NULL;
}

void copyPreloadedHeaderToDirInfo(TYPE_Header *preloaded_header, int idx)
{
	dir_info[idx]->duration			= preloaded_header->duration;
	if (preloaded_header->mjd > 0) dir_info[idx]->mjd = preloaded_header->mjd;
	dir_info[idx]->event_start_hour	= preloaded_header->event_start_hour;
	dir_info[idx]->event_start_min	= preloaded_header->event_start_min; 
	dir_info[idx]->event_end_hour	= preloaded_header->event_end_hour;
	dir_info[idx]->event_end_min		= preloaded_header->event_end_min;
	dir_info[idx]->service_type		= preloaded_header->service_type;
	strcpy(dir_info[idx]->event_name, preloaded_header->event_name);
	strcpy(dir_info[idx]->description, preloaded_header->description);
	strcpy(dir_info[idx]->service_name, preloaded_header->service_name);
	dir_info[idx]->service_num = preloaded_header->service_num;
	dir_info[idx]->attr = preloaded_header->attr;
	dir_info[idx]->radio = preloaded_header->radio;
}

void formatDescription(char *description)
{
	if (strlen(extInfo) > 0) {
		if (strncmp(eventDescName, extInfo, 127) == 0 || strlen(eventDescName) == 0)
			strcpy(description, (strlen(extInfo) > 0 && extInfo[0] < 0x20) ? extInfo+1 : extInfo);
		else {
			word i, j = 0, colon = TRUE;
			char *temp_info = dlmalloc(extInfoLength+100);

			strcpy(description, (strlen(eventDescName) > 0 && eventDescName[0] < 0x20) ? eventDescName+1 : eventDescName);

			memset(temp_info, '\0', extInfoLength+100);
			for (i = 0; i < extInfoLength; i++) {
				if (extInfo[i] == 5) 
					continue;

				if (extInfo[i] == '\0') {
					if (colon) {
						temp_info[j] = ':'; j++;
						temp_info[j] = ' '; j++;
					}
					else {
						temp_info[j] = '\n'; j++;
					}
					colon = colon ? FALSE : TRUE;
				}
				else {
					temp_info[j] = extInfo[i]; j++;
				}
			}
			strcpy(extInfo, temp_info);
			dlfree(temp_info);
			
			strcat(description, "\n");
			strcat(description, "\n");
			strcat(description, extInfo);
		}
	}
	else {
		strcpy(description, (strlen(eventDescName) > 0 && eventDescName[0] < 0x20) ? eventDescName+1 : eventDescName);
	}
}

void copyHeaderToPreloadedHeader(TYPE_Header *preloaded_header)
{
	dword utc_time;

	preloaded_header->duration = recDuration;

	// then use the gmt offset from flash
	//preloaded_header->mjd = eventStartMJD;
	utc_time = (eventStartMJD<<16) + (eventStartHour<<8) + eventStartMin; 
	gmtToLocalTime(utc_time, &preloaded_header->mjd, &preloaded_header->event_start_hour, &preloaded_header->event_start_min, gmt_offset, gmt_offset_override);
	utc_time = (eventEndMJD<<16) + (eventEndHour<<8) + eventEndMin; 
	gmtToLocalTime(utc_time, &end_mjd, &preloaded_header->event_end_hour, &preloaded_header->event_end_min, gmt_offset, gmt_offset_override);

	preloaded_header->service_type		= svcType;
	strcpy(preloaded_header->event_name, (strlen(eventName) > 0 && eventName[0] < 0x20) ? eventName+1 : eventName);
	strcpy(preloaded_header->service_name, (strlen(serviceName) > 0 && serviceName[0] < 0x20) ? serviceName+1 : serviceName);
	formatDescription(preloaded_header->description);
	preloaded_header->service_num = svcNum;
	preloaded_header->attr = ATTR_TS;
	if (svcType == SVC_TYPE_Radio) preloaded_header->radio = TRUE;

	if (write_log) TAP_SPrint(log_buffer, "Rec: %s, mjd: %d, hour: %d, min: %d", preloaded_header->event_name, eventStartMJD, eventStartHour, eventStartMin);
	if (write_log) logText(log_buffer, FALSE);
}

void copyHeaderToDirInfo(int idx)
{
	dword utc_time;

	dir_info[idx]->duration = recDuration;

	// then use the gmt offset from flash
	//if (eventStartMJD > 0) dir_info[idx]->mjd = eventStartMJD;
	utc_time = (eventStartMJD<<16) + (eventStartHour<<8) + eventStartMin; 
	gmtToLocalTime(utc_time, &dir_info[idx]->mjd, &dir_info[idx]->event_start_hour, &dir_info[idx]->event_start_min, gmt_offset, gmt_offset_override);
	utc_time = (eventEndMJD<<16) + (eventEndHour<<8) + eventEndMin; 
	gmtToLocalTime(utc_time, &end_mjd, &dir_info[idx]->event_end_hour, &dir_info[idx]->event_end_min, gmt_offset, gmt_offset_override);

	dir_info[idx]->service_type		= svcType;
	strcpy(dir_info[idx]->event_name, (strlen(eventName) > 0 && eventName[0] < 0x20) ? eventName+1 : eventName);
	strcpy(dir_info[idx]->service_name, (strlen(serviceName) > 0 && serviceName[0] < 0x20) ? serviceName+1 : serviceName);
	formatDescription(dir_info[idx]->description);
	dir_info[idx]->service_num = svcNum;
	dir_info[idx]->attr = ATTR_TS;
	if (svcType == SVC_TYPE_Radio) dir_info[idx]->radio = TRUE;

	if (write_log) TAP_SPrint(log_buffer, "Rec: %s, mjd: %d, hour: %d, min: %d", dir_info[idx]->event_name, eventStartMJD, eventStartHour, eventStartMin);
	if (write_log) logText(log_buffer, FALSE);
}

TYPE_Header *initialiseNewHeader(char *name, dword start_cluster, char *directory)
{
	all_rec_headers[no_of_rec_headers] = dlmalloc(sizeof(*all_rec_headers[no_of_rec_headers])); 
	memset(all_rec_headers[no_of_rec_headers], 0, sizeof (*all_rec_headers[no_of_rec_headers]));
	
	// initialize some of the fields
	all_rec_headers[no_of_rec_headers]->file_name = dlmalloc(strlen(name)+1); 
	all_rec_headers[no_of_rec_headers]->directory = dlmalloc(strlen(directory)+1); 
	all_rec_headers[no_of_rec_headers]->event_name = dlmalloc(eventNameLength+2); 
	all_rec_headers[no_of_rec_headers]->description = dlmalloc(strlen(eventDescName)+extInfoLength+20); 
	all_rec_headers[no_of_rec_headers]->service_name = dlmalloc(strlen(serviceName)+1); 

	strcpy(all_rec_headers[no_of_rec_headers]->file_name, name);
	strcpy(all_rec_headers[no_of_rec_headers]->directory, directory);
	all_rec_headers[no_of_rec_headers]->start_cluster = start_cluster;
	strcpy(all_rec_headers[no_of_rec_headers]->event_name, "");
	strcpy(all_rec_headers[no_of_rec_headers]->description, "");
	strcpy(all_rec_headers[no_of_rec_headers]->service_name, "");
	no_of_rec_headers++;

	return all_rec_headers[no_of_rec_headers-1];
}

void initialiseDirInfoMemory(int idx, word event_size, word description_size)
{
	if (!dir_info[idx]->event_name) dir_info[idx]->event_name = dlmalloc(event_size);
	if (!dir_info[idx]->description) dir_info[idx]->description = dlmalloc(description_size);
	if (!dir_info[idx]->service_name) dir_info[idx]->service_name = dlmalloc(sizeof(char) * 24);
	strcpy(dir_info[idx]->event_name, "");
	strcpy(dir_info[idx]->description, "");
	strcpy(dir_info[idx]->service_name, "");
}

void extractHeaderInfo(char *rec_tag, byte *buffer, TYPE_File *file)
{
	strncat(rec_tag, buffer, 4);
    recDuration = buffer[REC_DURATION_OFFSET]*256 + buffer[REC_DURATION_OFFSET+1];
	recDuration = recDuration == 0 ? 1 : recDuration;

	if (strcmp(rec_tag, "TFrc") != 0 /*|| recDuration == 0*/ || (file->size < 1048576 && recDuration < 60)) {
		if (write_log) TAP_SPrint(log_buffer, "Invalid header for %s, size: %d, duration: %d", file->name, file->size, recDuration);
		if (write_log) logText(log_buffer, FALSE);
		return;
	}

    svcNum = buffer[SVC_NUM_OFFSET]*256 + buffer[SVC_NUM_OFFSET+1];
    svcType = buffer[SVC_TYPE_OFFSET];
    memcpy(serviceName, (buffer+SERVICE_NAME_OFFSET), SERVICE_NAME_LENGTH);   
	serviceName[SERVICE_NAME_LENGTH]='\0';
    parentalRating = buffer[PARENTAL_RATING_OFFSET+headerOffset];
    eventNameLength = buffer[EVENT_NAME_LENGTH_OFFSET+headerOffset];
	eventNameLength = min(eventNameLength, EVENT_NAME_MAX_LENGTH);  //Make sure we don't exceed our limit.
    memcpy(eventName, (buffer+EVENT_NAME_OFFSET+headerOffset), eventNameLength);   
	eventName[eventNameLength]='\0';
	if (strlen(eventName) < eventNameLength)
		eventName[0] = '\0'; 
	else
		memcpy(eventDescName, (buffer+EVENT_NAME_OFFSET+headerOffset+eventNameLength), EVENT_DESC_MAX_LENGTH); 
    extInfoLength = buffer[EXT_INFO_LENGTH_OFFSET+headerOffset]*256 + buffer[EXT_INFO_LENGTH_OFFSET+headerOffset+1];
    extInfoLength = min(extInfoLength, EXT_INFO_MAX_LENGTH);  //Make sure we don't exceed our limit.
    memcpy(extInfo, (buffer+EXT_INFO_OFFSET+headerOffset), extInfoLength);   
    extInfo[extInfoLength]='\0';
	if (strlen(extInfo) < extInfoLength)
		extInfo[0] = '\0'; 
    eventDuration = buffer[EVENT_DURATION_OFFSET+headerOffset]*256 + buffer[EVENT_DURATION_OFFSET+headerOffset+1];
    eventStartMJD = buffer[EVENT_STARTMJD_OFFSET+headerOffset]*256 + buffer[EVENT_STARTMJD_OFFSET+headerOffset+1];
    eventStartHour = buffer[EVENT_STARTHOUR_OFFSET+headerOffset];
    eventStartMin = buffer[EVENT_STARTMIN_OFFSET+headerOffset];
	if (eventStartHour > 23 || eventStartMin > 59) {
		eventStartHour = 0;
		eventStartMin = 0;
	}
    eventEndMJD = buffer[EVENT_ENDMJD_OFFSET+headerOffset]*256 + buffer[EVENT_ENDMJD_OFFSET+headerOffset+1];
    eventEndHour = buffer[EVENT_ENDHOUR_OFFSET+headerOffset];
    eventEndMin = buffer[EVENT_ENDMIN_OFFSET+headerOffset];
	if (eventEndHour > 23 || eventEndMin > 59) {
		eventEndHour = 0;
		eventEndMin = 0;
	}
}

void updateHeader(char *old_name, char *new_name, char *old_dir, char *new_dir)
{
	word i;

	if (!preload_video_headers)
		return;

	for (i = 0; i < no_of_rec_headers; i++) {
		if (strcmp(all_rec_headers[i]->file_name, old_name) == 0 && strcmp(all_rec_headers[i]->directory, old_dir) == 0) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Update header for %s", old_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);

			dlfree(all_rec_headers[i]->file_name); all_rec_headers[i]->file_name = dlmalloc(strlen(new_name)+1);
			dlfree(all_rec_headers[i]->directory); all_rec_headers[i]->directory = dlmalloc(strlen(new_dir)+1);
			strcpy(all_rec_headers[i]->file_name, new_name);
			strcpy(all_rec_headers[i]->directory, new_dir);
			break;
		}
	}
}

// delete all header data for this folder
void updateHeaderForDir(char *old_dir, char *new_dir)
{
	word i;

	if (!preload_video_headers)
		return;

	for (i = 0; i < no_of_rec_headers; i++) {
		if (strcmp(all_rec_headers[i]->directory, old_dir) == 0) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Update header for %s", all_rec_headers[i]->file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);

			dlfree(all_rec_headers[i]->directory); all_rec_headers[i]->directory = dlmalloc(strlen(new_dir)+1);
			strcpy(all_rec_headers[i]->directory, new_dir);
		}
	}
}

void deleteRecHeader(char *name, dword start_cluster)
{
	int i, found_idx = -1; 

	if (!preload_video_headers)
		return;

	for (i = 0; i < no_of_rec_headers; i++) {
		if (strcmp(all_rec_headers[i]->file_name, name) == 0 && all_rec_headers[i]->start_cluster == start_cluster) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete header for %s, at %d of %d", name, i, no_of_rec_headers);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			found_idx = i;
			break;
		}
	}

	if (found_idx >= 0) {
		dlfree(all_rec_headers[found_idx]->file_name);
		dlfree(all_rec_headers[found_idx]->directory);
		dlfree(all_rec_headers[found_idx]->description);
		dlfree(all_rec_headers[found_idx]->event_name);
		dlfree(all_rec_headers[found_idx]->service_name);
		if (all_rec_headers[found_idx]->thumbnail) dlfree(all_rec_headers[found_idx]->thumbnail);

		for (i = found_idx; i < no_of_rec_headers-1; i++) {
			memmove(all_rec_headers[i], all_rec_headers[i+1], sizeof(*all_rec_headers[i]));
		}

		dlfree(all_rec_headers[no_of_rec_headers-1]);
		no_of_rec_headers--;
	}

	dlmalloc_trim(0);
}

// delete all header data for this folder
void deleteRecHeaderForDir(char *directory)
{
	int i, found_idx = -1, saved_no_of_headers = no_of_rec_headers;

	if (!preload_video_headers)
		return;

	for (i = saved_no_of_headers-1; i >= 0; i--) {
		if (strcmp(all_rec_headers[i]->directory, directory) == 0)
			deleteRecHeader(all_rec_headers[i]->file_name, all_rec_headers[i]->start_cluster);
	}
}

void deleteAllRecHeaders()
{
	word i;

	for (i = 0; i < no_of_rec_headers; i++) {
		dlfree(all_rec_headers[i]->file_name);
		dlfree(all_rec_headers[i]->directory);
		dlfree(all_rec_headers[i]->description);
		dlfree(all_rec_headers[i]->event_name);
		dlfree(all_rec_headers[i]->service_name);
		if (all_rec_headers[i]->thumbnail) {
			dlfree(all_rec_headers[i]->thumbnail);
		}
		dlfree(all_rec_headers[i]);
	}

	dlmalloc_trim(0);
	no_of_rec_headers = 0;
}

void LoadHeaderInfo(char *name, dword start_cluster, char *directory, int idx, bool notify)
{
	TYPE_Header *preloaded_header;
    TYPE_File   *file;
    byte        *buffer;
	dword		file_size;
	char rec_tag[5];

	// initialise variables
	recVersion = 0; recDuration = 0; svcNum = 0; svcType = 0; parentalRating = 0; eventNameLength = 0; extInfoLength = 0; eventDuration = 0; 
	eventStartMJD = 0; eventStartHour = 0; eventStartMin = 0; eventEndMJD = 0; eventEndHour = 0; eventEndMin = 0;
	memset(serviceName,		'\0', SERVICE_NAME_LENGTH);
	memset(eventName,		'\0', EVENT_NAME_MAX_LENGTH);
	memset(eventDescName,	'\0', EVENT_DESC_MAX_LENGTH);
	memset(extInfo,			'\0', EXT_INFO_MAX_LENGTH);
	memset(rec_tag,			'\0', 5);

	// initialise dir info bits and see if we already have header loaded
	if (idx >= 0) {
		// if already loaded, then copy contents to dir info, otherwise must be new, so read header
		if (preload_video_headers) {
			preloaded_header = getRecHeader(name, start_cluster);
			if (preloaded_header) {
				initialiseDirInfoMemory(idx, strlen(preloaded_header->event_name)+1, strlen(preloaded_header->description)+1);
				copyPreloadedHeaderToDirInfo(preloaded_header, idx);
				return;
			}
		}
	}

	// open the rec file
    file = TAP_Hdd_Fopen(name); 
	if (file == NULL) {
		if (idx >= 0)
			initialiseDirInfoMemory(idx, 1, 1);
        return;
	}

	// read the header in
    buffer = (byte *) dlmalloc(BUFFER_SIZE);
    if (buffer == NULL) {
		TAP_Hdd_Fclose(file); 
		if (idx >= 0)
			initialiseDirInfoMemory(idx, 1, 1);
		return;
	}

    TAP_Hdd_Fread(buffer, BUFFER_SIZE, 1, file);

	// populate the header data
	extractHeaderInfo(rec_tag, buffer, file);
		
	// if we get here then we need to create a new header entry
	if (preload_video_headers) {
		preloaded_header = getRecHeader(name, start_cluster);
		if (!preloaded_header) {
			preloaded_header = initialiseNewHeader(name, start_cluster, directory);
			if (preload_video_headers == HEADERS_AND_THUMBNAILS || preload_video_headers == HEADERS_AND_THUMBNAILS_LAZY)
				extractHeaderThumbnail(preloaded_header, name);

			if (notify) {
				TAP_SPrint(buffer, "%d", no_of_rec_headers);
				TAP_Osd_FillBox(region, 50+2+(360-4)-55, 50, 55, 25, header_bg_colour);
				drawText(region, 50+2+(360-4)-50, 50, -1, buffer, header_text_colour, COLOR_None, FNT_Size_1926);
			}
		}
	}

	// check for a duff recording
	if (strcmp(rec_tag, "TFrc") != 0 /*|| recDuration == 0*/ || (file->size < 1048576 && recDuration < 60)) {
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Duff recording %s", name);
		if (write_log) if (verbose) logText(log_buffer, FALSE);

		if (idx >= 0) {
			if (preload_video_headers) {
				preloaded_header->attr = 0;
				preloaded_header->mjd = 0;
			}
			dir_info[idx]->attr = 0;
			dir_info[idx]->mjd = 0;
		}
		else {
			preloaded_header->attr = 0;
			preloaded_header->mjd = 0;
		}
	}
	else {
		if (idx >= 0) {
			if (preload_video_headers) {
				copyHeaderToPreloadedHeader(preloaded_header);
				initialiseDirInfoMemory(idx, eventNameLength+1, EVENT_DESC_MAX_LENGTH+extInfoLength+20);
				copyPreloadedHeaderToDirInfo(preloaded_header, idx);
			}
			else {
				initialiseDirInfoMemory(idx, eventNameLength+1, EVENT_DESC_MAX_LENGTH+extInfoLength+20);
				copyHeaderToDirInfo(idx);
			}
		}
		else {
			copyHeaderToPreloadedHeader(preloaded_header);
		}
	}

	dlfree(buffer);
	dlmalloc_trim(0);
	buffer = NULL;

	TAP_Hdd_Fclose(file);
}

void refreshFooterProgress(int idx)
{
	TYPE_PlayInfo play_info; 
	TYPE_RecInfo rec_info_1, rec_info_2;
	dword progress_colour, watched_mins = 0;
	int total_block = 0, current_block = 0;
	word duration = 0, footer_offset_y = Y+330+2;

	TAP_Hdd_GetPlayInfo(&play_info);
	TAP_Hdd_GetRecInfo(0, &rec_info_1);
	TAP_Hdd_GetRecInfo(1, &rec_info_2);

	if (play_info.file && play_info.playMode == PLAYMODE_Playing 
			&& strcmp(play_info.file->name, dir_info[idx]->file_name) == 0
			&& play_info.file->startCluster == dir_info[idx]->start_cluster) {
		current_block = getCurrentBlockFromFile(play_info.file);
		total_block = getTotalBlockFromFile(play_info.file);
		if (total_block > 0) {
			watched_mins = current_block*play_info.duration/total_block;
			duration = play_info.duration;
		}
		progress_colour = playing_bar_colour;
	}
	ef (play_info.file && play_info.playMode == PLAYMODE_RecPlaying 
			&& strcmp(play_info.file->name, dir_info[idx]->file_name) == 0
			&& play_info.file->startCluster == dir_info[idx]->start_cluster) {
		current_block = getCurrentBlockFromFile(play_info.file);
		total_block = getTotalBlockFromFile(play_info.file);

		if (total_block > 0) {
			if (strcmp(dir_info[idx]->file_name, rec_info_1.fileName) == 0) {
				watched_mins = current_block*rec_info_1.duration/total_block;
				duration = rec_info_1.duration;
			}
			ef (strcmp(dir_info[idx]->file_name, rec_info_2.fileName) == 0) {
				watched_mins = current_block*rec_info_2.duration/total_block;
				duration = rec_info_2.duration;
			}
		}
		progress_colour = chaseplay_bar_colour;
	}
	ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[idx]->file_name) == 0) {
		current_block = watched_mins = rec_info_1.recordedSec/60;
		total_block = duration = rec_info_1.duration;
		progress_colour = recording_bar_colour;
	}			
	ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[idx]->file_name) == 0) {
		current_block = watched_mins = rec_info_2.recordedSec/60;
		total_block = duration = rec_info_2.duration;
		progress_colour = recording_bar_colour;
	}
	else {
		current_block = getCurrentBlock(dir_info[idx]->file_name, dir_info[idx]->start_cluster);
		total_block = getTotalBlock(dir_info[idx]->file_name, dir_info[idx]->start_cluster);
		if (total_block > 0) {
			if ((total_block - current_block) < 80) current_block = total_block;
			duration = dir_info[idx]->duration;
			watched_mins = (duration*current_block)/total_block;
		}
		progress_colour = COLOR_Green;
	}
	
	if (display_logos && dir_info[idx]->attr == ATTR_TS && footer_rec_header_format != EVENT_NAME)
		TAP_Osd_FillBox(region_mem, X+5+47+5,  footer_offset_y-7, W-150-5-47-5+((disable_file_details && disable_thumbnails) ? 150 : 0), 31, footer_bg_colour);
	else
		TAP_Osd_FillBox(region_mem, X+5, footer_offset_y-7, W-150-5+((disable_file_details && disable_thumbnails) ? 150 : 0), 31, footer_bg_colour);

	if (displayProgress(watched_mins, current_block, total_block, footer_progress_format)) {
		word progress_offset;
		formatProgressString(buffer, watched_mins, duration, current_block, total_block, footer_progress_format);
		progress_offset = (disable_file_details && disable_thumbnails) ? (list_progress_format != BAR ? X+W-115-getWidth(buffer, FNT_Size_1419) : X+W-10-getWidth(buffer, FNT_Size_1419)) : (list_progress_format != BAR ? X+W-265-getWidth(buffer, FNT_Size_1419) : X+W-160-getWidth(buffer, FNT_Size_1419));
		drawText(region_mem, progress_offset, footer_offset_y-1, -1, buffer, footer_text_colour, footer_bg_colour, FNT_Size_1419);
	}

	if (total_block > 0 && list_progress_format != BAR && ((current_block*100/total_block) > 0 || displayProgress(watched_mins, current_block, total_block, footer_progress_format))) {
		TAP_Osd_DrawRectangle(region_mem, (disable_file_details && disable_thumbnails) ? X+W-115+10-3 : X+W-265+10-3, footer_offset_y+7-5, 90+4, 5+7, 2, image_border_colour);
		TAP_Osd_FillBox(region_mem, (disable_file_details && disable_thumbnails) ? X+W-115+10-1 : X+W-265+10-1, footer_offset_y+7-3, 90, 5+3, progress_bar_bg_colour);
		TAP_Osd_FillBox(region_mem, (disable_file_details && disable_thumbnails) ? X+W-115+10-1 : X+W-265+10-1, footer_offset_y+7-3, (current_block*100 / total_block)*90/100, 5+3, progress_colour);
	}

	formatFooterHeader(idx, duration, (total_block == 0 || ((current_block*100 / total_block) == 0)), temp, FALSE);

	if (display_logos && dir_info[idx]->attr == ATTR_TS && footer_rec_header_format != EVENT_NAME)
		drawText(region_mem, X+5+47+10, footer_offset_y-1, ((total_block == 0 || ((current_block*100 / total_block) == 0)) ? X+W-150-5 : footer_progress_format == NO_PROGRESS ? X+W-270-5 : X+W-335-5), temp, info_header_colour, footer_bg_colour, FNT_Size_1622);
	else
		drawText(region_mem, X+5, footer_offset_y-1, ((total_block == 0 || ((current_block*100 / total_block) == 0)) ? X+W-150-5 : footer_progress_format == NO_PROGRESS ? X+W-270-5 : X+W-335-5), temp, info_header_colour, footer_bg_colour, FNT_Size_1622);
}

void drawRecordingFileListFooter(int idx)
{
	TYPE_PlayInfo play_info; 
	TYPE_RecInfo rec_info_1, rec_info_2;
	TYPE_File *thumbnail_file, file;
	dword string_length, progress_colour, file_size, recorded_sec, watched_mins = 0;
	word help_x_offset, help_y_offset, i, preview_count, duration;
	int total_block = 0, current_block = 0;

	// blank out the box
	TAP_Osd_FillBox(region_mem, X, Y+323, W+5, 120+7+1, footer_bg_colour);
	if (!disable_file_details || !disable_thumbnails)
		TAP_Osd_FillBox(region_mem, X+W-150, Y+323, 2, 120+7+1, frame_colour);
	
	if (no_of_files == 0)
		return;

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Draw file footer %s", dir_info[idx]->file_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	// if a recording folder, then display 4 miniature thumbnails
	if (folder_preview && isFolder(idx)) {
		word thumbnail_count = 0;
		ChangeDir(dir_info[idx]->file_name);

		// display the first few recs in dir
		help_x_offset = X+5;
		help_y_offset = Y+330+2;
		drawText(region_mem, help_x_offset, help_y_offset, -1, videos_in_folder_t, info_header_colour, COLOR_None, FNT_Size_1622);
		help_y_offset += 25;

		preview_count = 0; 
		memset (&file, 0, sizeof(file));
		i = TAP_Hdd_FindFirst(&file);

		while (i--)	{
			if (isRec(file.name))	{
				memset(file_name, '\0', 100);
				strncat(file_name, file.name, strlen(file.name)-4);
				drawText(region_mem, help_x_offset, help_y_offset, X+W-150-5, file_name, info_detail_colour, COLOR_None, FNT_Size_1622);
				help_y_offset += 20;
				preview_count++;
			}

			if (i == 0 || TAP_Hdd_FindNext(&file) == 0 || preview_count == 4)
				break;
		}

#ifndef WIN32
		if (TAP_Hdd_Exist("Cache")) {
#endif
			ChangeDir("Cache");

			memset (&file, 0, sizeof(file));
			i = TAP_Hdd_FindFirst(&file);

			while (i--)	{
				if (isThumbnail(file.name) && !isRecycledThumbnail(file.name))	{
					thumbnail_file = TAP_Hdd_Fopen(file.name);
					drawFooterMiniatureThumbnail(thumbnail_file, thumbnail_count, TRUE, idx, file.name);
					thumbnail_count++;
				}

				if (i == 0 || TAP_Hdd_FindNext(&file) == 0 || thumbnail_count == 4)
					break;
			}

			ChangeDir("..");
#ifndef WIN32
		}
#endif
		ChangeDir("..");
	}

	// fill in recording title and description
	if (isRec(dir_info[idx]->file_name)) {
		bool break_line;
		word line_pointer, i = 0, j, line_characters, pixels_left, word_count, pixel_skip, pixel_remainder;
		char info_line[80], word_in_line[40];
		help_x_offset = X+5;
		help_y_offset = Y+330+2;

		if (!isValidRec(idx)) {
			TAP_SPrint(buffer, "This video is invalid, %s", dir_info[idx]->size < 1048576 ? "and should be deleted." : "but can be fixed.");
			drawText(region_mem, help_x_offset, help_y_offset-1, -1, buffer, info_detail_colour, COLOR_None, FNT_Size_1622);
			return;
		}

		strcpy(eventName, ""); strcpy(eventDescName, ""); strcpy(extInfo, ""); strcpy(serviceName, "");
		file_size = 0; duration = 0; mjd = 0; eventStartHour = 0; eventEndHour = 0; eventStartMin = 0; eventEndMin = 0;

		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);

		strcpy(eventName,	dir_info[idx]->event_name);
		strcpy(extInfo,		dir_info[idx]->description);
		strcpy(serviceName, dir_info[idx]->service_name);
		svcType			= dir_info[idx]->service_type;
		mjd				= dir_info[idx]->mjd;
		file_size		= dir_info[idx]->size;
		eventStartHour	= dir_info[idx]->event_start_hour;
		eventStartMin	= dir_info[idx]->event_start_min;
		eventEndHour	= dir_info[idx]->event_end_hour;
		eventEndMin		= dir_info[idx]->event_end_min;

		if (play_info.file && play_info.playMode == PLAYMODE_Playing 
				&& strcmp(play_info.file->name, dir_info[idx]->file_name) == 0
				&& play_info.file->startCluster == dir_info[idx]->start_cluster) {
			current_block = getCurrentBlock(dir_info[idx]->file_name, dir_info[idx]->start_cluster);
			total_block = getTotalBlock(dir_info[idx]->file_name, dir_info[idx]->start_cluster);
			if (total_block > 0)
				watched_mins = current_block*play_info.duration/total_block;
			duration		= play_info.duration;

			progress_colour = playing_bar_colour;
		}	
		ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[idx]->file_name) == 0) {
			current_block = watched_mins = rec_info_1.recordedSec/60;
			total_block = duration = rec_info_1.duration;
			recorded_sec = rec_info_1.recordedSec;

			progress_colour = recording_bar_colour;
		}			
		ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[idx]->file_name) == 0) {
			current_block = watched_mins = rec_info_2.recordedSec/60;
			total_block = duration = rec_info_2.duration;
			recorded_sec = rec_info_2.recordedSec;

			progress_colour = recording_bar_colour;
		}
		else {
			if (dir_info[idx]->duration == 0 && dir_info[idx]->attr != 0)
				LoadHeaderInfo(dir_info[idx]->file_name, dir_info[idx]->start_cluster, curr_dir, idx, FALSE);
			current_block = getCurrentBlock(dir_info[idx]->file_name, dir_info[idx]->start_cluster);
			total_block = getTotalBlock(dir_info[idx]->file_name, dir_info[idx]->start_cluster);
			duration = dir_info[idx]->duration;
			if (total_block > 0) {
				if ((total_block - current_block) < 80) current_block = total_block;
				watched_mins = current_block*duration/total_block;
			}

			progress_colour = playing_bar_colour;
		}

		if (play_info.playMode == PLAYMODE_RecPlaying 
				&& strcmp(play_info.file->name, dir_info[idx]->file_name) == 0
				&& play_info.file->startCluster == dir_info[idx]->start_cluster) {
			current_block = getCurrentBlock(dir_info[idx]->file_name, dir_info[idx]->start_cluster);
			total_block = getTotalBlock(dir_info[idx]->file_name, dir_info[idx]->start_cluster);

			if (total_block > 0) {
				if (strcmp(dir_info[idx]->file_name, rec_info_1.fileName) == 0) {
					watched_mins = current_block*rec_info_1.duration/total_block;
					duration = rec_info_1.duration;
				}
				ef (strcmp(dir_info[idx]->file_name, rec_info_2.fileName) == 0) {
					watched_mins = current_block*rec_info_2.duration/total_block;
					duration = rec_info_2.duration;
				}
			}
		
			progress_colour = chaseplay_bar_colour;
		}

		if (displayProgress(watched_mins, current_block, total_block, footer_progress_format)) {
			word progress_offset;
			formatProgressString(buffer, watched_mins, duration, current_block, total_block, footer_progress_format);
			progress_offset = (disable_file_details && disable_thumbnails) ? (list_progress_format != BAR ? X+W-115-getWidth(buffer, FNT_Size_1419) : X+W-10-getWidth(buffer, FNT_Size_1419)) : (list_progress_format != BAR ? X+W-265-getWidth(buffer, FNT_Size_1419) : X+W-160-getWidth(buffer, FNT_Size_1419));
			drawText(region_mem, progress_offset, help_y_offset-1, -1, buffer, footer_text_colour, footer_bg_colour, FNT_Size_1419);
		}

		if (total_block > 0 && list_progress_format != BAR && ((current_block*100/total_block) > 0 || displayProgress(watched_mins, current_block, total_block, footer_progress_format))) {
			TAP_Osd_DrawRectangle(region_mem, (disable_file_details && disable_thumbnails) ? X+W-115+10-3 : X+W-265+10-3, help_y_offset+7-5, 90+4, 5+7, 2, image_border_colour);
			TAP_Osd_FillBox(region_mem, (disable_file_details && disable_thumbnails) ? X+W-115+10-1 : X+W-265+10-1, help_y_offset+7-3, 90, 5+3, progress_bar_bg_colour);
			TAP_Osd_FillBox(region_mem, (disable_file_details && disable_thumbnails) ? X+W-115+10-1 : X+W-265+10-1, help_y_offset+7-3, (current_block*100 / total_block)*90/100, 5+3, progress_colour);
		}

		formatFooterHeader(idx, duration, (total_block == 0 || ((current_block*100 / total_block) == 0)), temp, TRUE);

		if (display_logos && footer_rec_header_format != EVENT_NAME && dir_info[idx]->attr == ATTR_TS)
			drawText(region_mem, help_x_offset+47+10, help_y_offset-1, ((total_block == 0 || ((current_block*100 / total_block) == 0)) ? X+W-150-5 : footer_progress_format == NO_PROGRESS ? X+W-270-5 : X+W-335-5), temp, info_header_colour, footer_bg_colour, FNT_Size_1622);
		else
			drawText(region_mem, help_x_offset, help_y_offset-1, ((total_block == 0 || ((current_block*100 / total_block) == 0)) ? X+W-150-5 : footer_progress_format == NO_PROGRESS ? X+W-270-5 : X+W-335-5), temp, info_header_colour, footer_bg_colour, FNT_Size_1622);

		help_y_offset += 29; info_pointer = 0;
		while (strlen(extInfo) > info_pointer && i < 4) {
			break_line = getInfoLine(info_line, &info_pointer, extInfo, (disable_file_details && disable_thumbnails) ? W-20 : W-150-20, FNT_Size_1622);

			help_x_offset = X+5;
			if (strlen(info_line) == 0) continue;

			if (info_pointer >= strlen(extInfo) || break_line || text_justification == LEFT_JUSTIFY) {
				drawText(region_mem, help_x_offset, help_y_offset, (disable_file_details && disable_thumbnails) ? X+W-5 : X+W-150-5, info_line, info_detail_colour, footer_bg_colour, FNT_Size_1622);
			}
			else {
				line_characters = strlen(info_line);
				pixels_left = (disable_file_details && disable_thumbnails) ? W-15 - getWidth(info_line, FNT_Size_1622) : W-150-15 - getWidth(info_line, FNT_Size_1622);
				line_pointer = 0; j = 0;
				word_count = countWordsInLine(info_line);

				pixel_skip = pixels_left / (word_count-1); 
				pixel_remainder = pixels_left % (word_count-1);

				while (strlen(info_line) >= line_pointer) {
					getWordInLine(info_line, word_in_line, &line_pointer);
					drawText(region_mem, help_x_offset, help_y_offset, (disable_file_details && disable_thumbnails) ? X+W-5 : X+W-150-5, word_in_line, info_detail_colour, footer_bg_colour, FNT_Size_1622);

					help_x_offset += getWidthRounded(word_in_line, FNT_Size_1622, FALSE);
					help_x_offset += pixel_skip;
					if (pixel_remainder > 0) {
						help_x_offset++;
						pixel_remainder--;
					}
					j++;
				}
			}
			help_y_offset += 20;
			i++;
		}

		// draw radio for a radio rec
		if (!disable_thumbnails && isRadioRecording(idx))
			TAP_Osd_PutGd(region_mem, X+W-150+8+16, Y+330+12, &_radio7Gd, TRUE);
		else {
			// try to get the thumb if so set
			TYPE_Header *preloaded_header = NULL;
			thumbnail_file = NULL;
			if (!disable_thumbnails) {
				if (preload_video_headers == HEADERS_AND_THUMBNAILS || preload_video_headers == HEADERS_AND_THUMBNAILS_LAZY)
					preloaded_header = getRecHeader(dir_info[idx]->file_name, dir_info[idx]->start_cluster);
				if (!preloaded_header || !preloaded_header->thumbnail)
					thumbnail_file = getPhotoCache(dir_info[idx]->file_name, TRUE);
			}

			// draw thumbnail for a video rec
			if (thumbnail_file || (preloaded_header && preloaded_header->thumbnail))
				drawFooterThumbnail(thumbnail_file, preloaded_header, TRUE, idx);
			ef (!disable_file_details || !disable_thumbnails) {
				// if no thumbnail, or thumbnails are turned off, then display the details
				word indent;
				dword mb = file_size / 1048576;
				if (!isRadioRecording(idx))
					formatFileSize(&mb, duration);
				help_x_offset = X+W-150+2;
				help_y_offset = Y+330;

				// channel name
				string_length = getWidth(serviceName, FNT_Size_1419);
				if (string_length > 150-4) string_length = 150-4;
				indent = help_x_offset+2 + ((150-4 - string_length) / 2);
				drawText(region_mem, indent, help_y_offset, help_x_offset+150-2, serviceName, info_header_colour, footer_bg_colour, FNT_Size_1419);
				help_y_offset += 19;

				// date stamp
				if (mjd == 0) 
					TAP_SPrint(buffer, invalid_date_t);
				else {
					formatDateString(mjd, buffer, FALSE);
				}
				string_length = getWidth(buffer, FNT_Size_1419);
				indent = help_x_offset + ((150 - string_length) / 2);
				drawText(region_mem, indent, help_y_offset, -1, buffer, info_detail_colour, footer_bg_colour, FNT_Size_1419);
				help_y_offset += 19;
		
				// time stamp
				if (mjd == 0) 
					TAP_SPrint(buffer, invalid_time_t);
				else {
					TAP_SPrint(buffer, "%02d:%02d - %02d:%02d", eventStartHour, eventStartMin, eventEndHour, eventEndMin);
				}
				string_length = getWidth(buffer, FNT_Size_1419);
				indent = help_x_offset + ((150 - string_length) / 2);
				drawText(region_mem, indent, help_y_offset, -1, buffer, info_detail_colour, footer_bg_colour, FNT_Size_1419);
				help_y_offset += 19;

				// viewed/recorded percentage
				if (IsDataFilesFolder(curr_dir) 
						&& (strcmp(rec_info_1.fileName, dir_info[idx]->file_name) == 0 
							|| strcmp(rec_info_2.fileName, dir_info[idx]->file_name) == 0)) {
					TAP_SPrint(buffer, "%d%s %s", recorded_sec/60*100 / duration, "%", recorded_t);
					string_length = getWidth(buffer, FNT_Size_1419);
					indent = help_x_offset + ((150 - string_length) / 2);
					drawText(region_mem, indent, help_y_offset, -1, buffer, info_detail_colour, footer_bg_colour, FNT_Size_1419);
					help_y_offset += 19;
				} 
				ef (total_block > 0) {
					TAP_SPrint(buffer, "%d%s %s", current_block*100 / total_block, "%", watched_t);
					string_length = getWidth(buffer, FNT_Size_1419);
					indent = help_x_offset + ((150 - string_length) / 2);
					drawText(region_mem, indent, help_y_offset, -1, buffer, info_detail_colour, footer_bg_colour, FNT_Size_1419);
					help_y_offset += 19;
				}
				ef (mb > 0 && dir_info[idx]->attr == ATTR_TS) {
					TAP_SPrint(buffer, "%d.%02d GB/%s", ((mb * 60 / duration) / 1024), (((mb * 60 * 100) / duration) / 1024) % 100, h_t);
					string_length = getWidth(buffer, FNT_Size_1419);
					indent = help_x_offset + ((150 - string_length) / 2);
					drawText(region_mem, indent, help_y_offset, -1, buffer, info_detail_colour, footer_bg_colour, FNT_Size_1419);
					help_y_offset += 19;
				}

				// duration
				if (duration > 119)
					TAP_SPrint(buffer, "%d %s %d %s", duration / 60, hours_t, duration % 60, mins_t);
				ef (duration > 59)
					TAP_SPrint(buffer, "%d %s %d %s", duration / 60, hour_t, duration % 60, mins_t);
				else
					TAP_SPrint(buffer, "%d %s", duration, mins_t);
				string_length = getWidth(buffer, FNT_Size_1419);
				indent = help_x_offset + ((150 - string_length) / 2);
				drawText(region_mem, indent, help_y_offset, -1, buffer, info_detail_colour, footer_bg_colour, FNT_Size_1419);
				help_y_offset += 19;

				// file size
				TAP_SPrint(buffer, "%d MB", mb);
				string_length = getWidth(buffer, FNT_Size_1419);
				indent = help_x_offset + ((150 - string_length) / 2);
				drawText(region_mem, indent, help_y_offset, -1, buffer, info_detail_colour, footer_bg_colour, FNT_Size_1419);
			}
		}
	}
}

void drawRecycleBinFileListFooter(int idx)
{
	word help_x_offset, help_y_offset;

	// blank out the box
	TAP_Osd_FillBox(region_mem, X, Y+323, W+1, 120+7+1, footer_bg_colour);
	TAP_Osd_FillBox(region_mem, X+(W-380), Y+323, 2, 120+7+1, frame_colour);

	// display standard button help
	help_x_offset = X+W-365;
	drawText(region_mem, help_x_offset, Y+330, -1, pause_t, help_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+70, Y+330, -1, reorder_t, body_text_colour, COLOR_None, FNT_Size_1419);
	if (page_with_arrows)
		drawText(region_mem, help_x_offset, Y+346, -1, "< >", help_text_colour, COLOR_None, FNT_Size_1419);
	else
		drawText(region_mem, help_x_offset, Y+346, -1, "<< >>", help_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+70, Y+346, -1, page_up_down_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset, Y+362, -1, recall_t, help_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+70, Y+362, -1, smart_delete_t, body_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset, Y+378, -1, exit_t, help_text_colour, COLOR_None, FNT_Size_1419);
	drawText(region_mem, help_x_offset+70, Y+378, -1, return_t, body_text_colour, COLOR_None, FNT_Size_1419);

	// display coloured button help keys
	help_x_offset = X+W-365+45;
	help_y_offset = Y+330;
	drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(224,224,0), COLOR_None, OSD_YELLOW); 
	help_y_offset += 16;
	drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(224,224,224), COLOR_None, OSD_WHITE); 
	help_y_offset += 16;
	drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(0,224,0), COLOR_None, OSD_GREEN); 

	// display coloured button help text
	help_y_offset = Y+330;
	drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, restore_file_t, body_text_colour, COLOR_None, FNT_Size_1419);
	help_y_offset += 16;
	drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, delete_file_t, body_text_colour, COLOR_None, FNT_Size_1419);
	help_y_offset += 16;
	drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, empty_bin_t, body_text_colour, COLOR_None, FNT_Size_1419);

	// display recycle details
	if (no_of_recycles > 0) {
		help_y_offset = Y+330;
		memset(buffer, '\0', 100);
		strncat(buffer, recycle_bin_list[idx]->file_name, strlen(recycle_bin_list[idx]->file_name)-4);
		drawText(region_mem, X+5, help_y_offset, X+235-1, file_name_t, info_header_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 15;
		drawText(region_mem, X+5, help_y_offset, X+235-1, buffer, info_detail_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 25;
		drawText(region_mem, X+5, help_y_offset, X+235-1, folder_t, info_header_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 15;
		TAP_SPrint(buffer, recycle_bin_list[idx]->directory+1);
		drawText(region_mem, X+5, help_y_offset, X+235-1, buffer, info_detail_colour, COLOR_None, FNT_Size_1419);
	}
}

void drawFileListFooter(int idx)
{
	TYPE_File *thumbnail_file, file;
	word help_x_offset, help_y_offset, i;
	char play_help_t[20] = "", ok_help_t[20] = "", delete_t[20] = "";
	bool delete_file_available = FALSE, move_available = FALSE, info_available = FALSE, details_displayed = FALSE;
	bool playlist_available = FALSE, ok_available = FALSE, search_available = FALSE;

	// call a special method for the recording list or recycle bin, since they are so different
	if (recycle_bin_displayed) {
		drawRecycleBinFileListFooter(idx);
		return;
	}
	ef (InDataFilesFolder(curr_dir)) {
		drawRecordingFileListFooter(idx);
		return;
	}

	if (no_of_files == 0)
		return;

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Draw file footer %s", dir_info[idx]->file_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	if (InMp3FilesFolder(curr_dir))
		search_available = TRUE;

	// is delete help displayed
	if (!isParentDirectory(dir_info[idx]->file_name) && !isFolder(idx)) {
		delete_file_available = TRUE;
		strcpy(delete_t, delete_file_t);
	}
	ef (isFolder(idx)
			&& strcmp(dir_info[idx]->file_name, "ProgramFiles") != 0
			&& strcmp(dir_info[idx]->file_name, "DataFiles") != 0
			&& strcmp(dir_info[idx]->file_name, "MP3") != 0
			&& strcmp(dir_info[idx]->file_name, "Auto Start") != 0) {
		delete_file_available = TRUE;
		strcpy(delete_t, delete_folder_t);
	}

	// is move displayed
	if (!isParentDirectory(dir_info[idx]->file_name)
			&& strcmp(dir_info[idx]->file_name, "ProgramFiles") != 0
			&& strcmp(dir_info[idx]->file_name, "DataFiles") != 0
			&& strcmp(dir_info[idx]->file_name, "MP3") != 0
			&& strcmp(dir_info[idx]->file_name, "Auto Start") != 0)
		move_available = TRUE;

	// is info available
	if (isJpg(dir_info[idx]->file_name)) {
		info_available = TRUE;
	}

	// what does the ok button help say
	if (isMp3(dir_info[idx]->file_name)) {
		ok_available = TRUE;
		strcpy(ok_help_t, play_tune_t);
	}
	ef (isPhoto(dir_info[idx]->file_name)) {
		ok_available = TRUE;
		strcpy(ok_help_t, show_photo_t);
	}
	ef (isSkin(dir_info[idx]->file_name)) {
		ok_available = TRUE;
		TAP_SPrint(ok_help_t, "%s %s", load_t, skin_t);
	}
	ef (isLog(dir_info[idx]->file_name)) {
		ok_available = TRUE;
		strcpy(ok_help_t, show_log_t);
	}
	ef (isTAP(dir_info[idx]->file_name)) {
		//int tap_id = HDD_TAP_GetIDByFileName(dir_info[idx]->file_name);
		
		//if (HDD_TAP_isRunning(tap_id))
		//	TAP_SPrint(ok_help_t, "%s TAP", "Stop");
		//else
			TAP_SPrint(ok_help_t, "%s TAP", load_t);
		ok_available = TRUE;
	}
	ef (isFolder(idx) || isParentDirectory(dir_info[idx]->file_name)) {
		ok_available = TRUE;
		strcpy(ok_help_t, change_dir_t);		
	}

	// what does the play button help say
	if (isFolder(idx)) {
		if (strcmp(dir_info[idx]->file_name, "DataFiles") == 0)
			strcpy(play_help_t, slideshow_t);
		else
			strcpy(play_help_t, play_folder_t);
	}
	ef (InMp3FilesFolder(curr_dir))
		strcpy(play_help_t, play_all_tunes_t);
	else 
		strcpy(play_help_t, slideshow_t);

	if (strcmp(dir_info[idx]->file_name, "DataFiles") != 0 && (isMp3(dir_info[idx]->file_name) || isPhoto(dir_info[idx]->file_name) || isFolder(idx)))
		playlist_available = TRUE;

	// blank out the box
	TAP_Osd_FillBox(region_mem, X, Y+323, W+1, 122+5+1, footer_bg_colour);
	TAP_Osd_FillBox(region_mem, X+(W-380), Y+323, 2, 122+5+1, frame_colour);

	// display standard button help
	help_x_offset = X+W-365;
	help_y_offset = Y+330;
	drawText(region_mem, help_x_offset, help_y_offset, -1, play_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	if (ok_available) {drawText(region_mem, help_x_offset, help_y_offset, -1, ok_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;}
	drawText(region_mem, help_x_offset, help_y_offset, -1, recall_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset, help_y_offset, -1, page_with_arrows ? "< >" : "<< >>", help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset, help_y_offset, -1, guide_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset, help_y_offset, -1, opts_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	if (info_available) {drawText(region_mem, help_x_offset, help_y_offset, -1, info_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;}
	if (search_available) drawText(region_mem, help_x_offset, help_y_offset, -1, slow_t, help_text_colour, COLOR_None, FNT_Size_1419);

	help_y_offset = Y+330;
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, play_help_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	if (ok_available) {drawText(region_mem, help_x_offset+70, help_y_offset, -1, ok_help_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;}
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, toggle_view_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, page_up_down_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, playlist_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	drawText(region_mem, help_x_offset+70, help_y_offset, -1, extra_options_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;
	if (info_available) {drawText(region_mem, help_x_offset+70, help_y_offset, -1, exif_data_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 16;}
	if (search_available)drawText(region_mem, help_x_offset+70, help_y_offset, -1, search_t, body_text_colour, COLOR_None, FNT_Size_1419);
	
	// display coloured button help keys
	help_x_offset = X+W-365+45;
	help_y_offset = Y+330;
	drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(0,224,0), COLOR_None, OSD_GREEN); 
	help_y_offset += 16;

	if (move_available) {
		drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(224,224,0), COLOR_None, OSD_YELLOW); 
		help_y_offset += 16;
	}
	if (delete_file_available) {
		drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(224,224,224), COLOR_None, OSD_WHITE); 
		help_y_offset += 16;
	}
	if (playlist_available) {
		drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(224,224,224), RGB8888(225,20,20), OSD_RECORD); 
		help_y_offset += 16;
	}
	if (mp3_playing) {
		if (!masterpiece_mode) {
			drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(225,20,20), COLOR_None, OSD_RED); 
			drawHelpButton(region_mem, help_x_offset+160, help_y_offset+16, RGB8888(20,20,225), COLOR_None, OSD_BLUE); 
			drawHelpButton(region_mem, help_x_offset+160, help_y_offset+32, RGB8888(224,224,224), COLOR_DarkGray, OSD_STOP); 
		}
	}

	// display coloured button help text
	help_y_offset = Y+330;
	drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, new_folder_t, body_text_colour, COLOR_None, FNT_Size_1419);
	help_y_offset += 16;

	if (move_available) {
		drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, move_file_t, body_text_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 16;
	}
	if (delete_file_available) {
		drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, delete_t, body_text_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 16;
	}
	if (playlist_available) {
		drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, add_to_playlist_t, body_text_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 16;
	}
	if (mp3_playing) {
		drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, previous_tune_t, body_text_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 16;
		drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, next_tune_t, body_text_colour, COLOR_None, FNT_Size_1419);
		help_y_offset += 16;
		drawText(region_mem, help_x_offset+180+7, help_y_offset, -1, stop_tune_t, body_text_colour, COLOR_None, FNT_Size_1419);
	}

	// if a photo folder, then display 4 miniature thumbnails
	if (folder_preview && !InMp3FilesFolder(curr_dir) && isFolder(idx)) {
		word thumbnail_count = 0;
		ChangeDir(dir_info[idx]->file_name);
#ifndef WIN32
		if (TAP_Hdd_Exist("Cache")) {
#endif
			ChangeDir("Cache");

			memset (&file, 0, sizeof(file));
			i = TAP_Hdd_FindFirst(&file);

			while (i--)	{
				if (isThumbnail(file.name) && !isRecycledThumbnail(file.name))	{
					thumbnail_file = TAP_Hdd_Fopen(file.name);
					if (strcmp(dir_info[idx]->file_name, "DataFiles") == 0)
						drawFooterMiniatureThumbnail(thumbnail_file, thumbnail_count, TRUE, idx, file.name);
					else
						drawFooterMiniatureThumbnail(thumbnail_file, thumbnail_count, FALSE, idx, file.name);
					thumbnail_count++;
				}

				if (i == 0 || TAP_Hdd_FindNext(&file) == 0 || thumbnail_count == 4)
					break;
			}

			ChangeDir("..");
#ifndef WIN32
		}
#endif
		ChangeDir("..");
	}

	// if an mp3 folder, then look for any album art to display
	if (folder_preview && InMp3FilesFolder(curr_dir) && isFolder(idx)) {
		ChangeDir(dir_info[idx]->file_name);
		thumbnail_file = getAlbumArtThumbnail(idx);
		if (thumbnail_file)
			drawFooterThumbnail(thumbnail_file, NULL, FALSE, idx);
		ChangeDir("..");
	}

	// populate id3 info for an mp3 (or thumbnail)
	if (isMp3(dir_info[idx]->file_name)) {

		thumbnail_file = NULL;
		//if (!disable_thumbnails)
		//	thumbnail_file = getArtThumbnail(FALSE, idx);
	
		//if (thumbnail_file) {
		//	drawFooterThumbnail(thumbnail_file, NULL, FALSE, idx);
		//	details_displayed = TRUE;
		//}
		if (!disable_file_details) {
			word id3_y_offset = Y+330; struct media_files *mp3_header;

			// if trying to show details for currently playing mp3, then use saved id3 details (since we can't open the file)
			if (mp3_playing && strcmp(curr_dir, mp3_files[current_mp3]->directory) == 0
							&& strcmp(dir_info[idx]->file_name, mp3_files[current_mp3]->file_name) == 0) {
				copyID3ToID3(TRUE, FALSE);
			}
			ef ((mp3_header = getMp3Header(dir_info[idx]->file_name, curr_dir, dir_info[idx]->mjd, dir_info[idx]->hour, dir_info[idx]->min, FALSE, FALSE, FALSE))
					&& mp3_header->header_loaded) {
				copyMp3HeaderToID3(mp3_header);
			}
			else {
				readID3Tag(dir_info[idx]->file_name, FALSE, FALSE);
			}

			if (id3_info->artist && strlen(id3_info->artist) > 0) {
				drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->artist, info_header_colour, COLOR_None, FNT_Size_1419);
				id3_y_offset += 17;
			}
			if (id3_info->title && strlen(id3_info->title) > 0) {
				drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->title, info_detail_colour, COLOR_None, FNT_Size_1419);
				id3_y_offset += 17;
			}
			if (id3_info->album && strlen(id3_info->album) > 0) {
				drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->album, info_header_colour, COLOR_None, FNT_Size_1419);
				id3_y_offset += 17;
			}
			if (id3_info->genre_code && strlen(id3_info->genre_code) > 0) {
				drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->genre, info_header_colour, COLOR_None, FNT_Size_1419);
				id3_y_offset += 17;
			}
			if (id3_info->year && strlen(id3_info->year) > 0) {
				drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, id3_info->year, info_header_colour, COLOR_None, FNT_Size_1419);
				id3_y_offset += 17;
			}
			//if (id3_info->bitrate > 0) {
			//	TAP_SPrint(buffer, "%d Kbps", id3_info->bitrate);
			//	drawText(region_mem, X+5, id3_y_offset, X+(W-380)-1, buffer, info_header_colour, COLOR_None, FNT_Size_1419);
			//}

			destroy_ID3(id3_info);
			id3_info = NULL;
			details_displayed = TRUE;
		}
	}
	// populate exif info for a jpeg (or thumbnail)
	ef (isPhoto(dir_info[idx]->file_name)) {

		thumbnail_file = NULL;
		if (!disable_thumbnails)
			thumbnail_file = getPhotoCache(dir_info[idx]->file_name, TRUE);
			
		if (thumbnail_file) {
			drawFooterThumbnail(thumbnail_file, NULL, FALSE, idx);
			details_displayed = TRUE;
		}
		ef (isJpg(dir_info[idx]->file_name) && !disable_file_details) {
			int i = 0;
			help_y_offset = Y+330;
			no_of_details = 0;
			ProcessFile(dir_info[idx]->file_name);
			while (i < no_of_details && i < 6) {
				drawText(region_mem, X+5, help_y_offset, X+110-1, photo_exif[i].heading, info_header_colour, COLOR_None, FNT_Size_1419);
				drawText(region_mem, X+110, help_y_offset, X+115+140-1, photo_exif[i].detail, info_detail_colour, COLOR_None, FNT_Size_1419);
				help_y_offset += 17;
				i++;
			}
			details_displayed = TRUE;
		}
	}
	// populate exif info for a jpeg (or thumbnail)
	ef (isTAP(dir_info[idx]->file_name) && !disable_file_details) {

		help_y_offset = Y+330;
		extractTapHeaderInfo(dir_info[idx]->file_name);
		drawText(region_mem, X+5, help_y_offset, X+(W-380)-1, tap_title, info_detail_colour, COLOR_None, FNT_Size_1419); help_y_offset += 17;
		drawText(region_mem, X+5, help_y_offset, X+(W-380)-1, tap_desc, info_header_colour, COLOR_None, FNT_Size_1419); help_y_offset += 17;
		drawText(region_mem, X+5, help_y_offset, X+(W-380)-1, tap_author, info_header_colour, COLOR_None, FNT_Size_1419); help_y_offset += 17;
		drawText(region_mem, X+5, help_y_offset, X+(W-380)-1, tap_etc, info_header_colour, COLOR_None, FNT_Size_1419); help_y_offset += 17;
		TAP_SPrint(buffer, "Id: 0x%8.8x", tap_id);
		drawText(region_mem, X+5, help_y_offset, X+(W-380)-1, buffer, info_header_colour, COLOR_None, FNT_Size_1419);
		details_displayed = TRUE;
	}

	if (!details_displayed && !dir_info[idx]->folder) {
		word local_mjd = dir_info[idx]->mjd, local_hour = dir_info[idx]->hour, local_min = dir_info[idx]->min;
		dword utc_time = (local_mjd<<16) + (local_hour<<8) + local_min; 
		help_y_offset = Y+330;

		formatDateString(local_mjd, buffer, TRUE);
		drawText(region_mem, X+5, help_y_offset, X+(W-380)-1, buffer, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 21;
		TAP_SPrint(buffer, "%02d:%02d", local_hour, local_min);
		drawText(region_mem, X+5, help_y_offset, X+(W-380)-1, buffer, info_detail_colour, COLOR_None, FNT_Size_1622); help_y_offset += 42;

		if (dir_info[idx]->size < 1024)
			TAP_SPrint(buffer, "%d B", dir_info[idx]->size);
		ef (dir_info[idx]->size < 10486)
			TAP_SPrint(buffer, "%d KB", dir_info[idx]->size / 1024);
		else
			TAP_SPrint(buffer, "%d.%d%d MB", dir_info[idx]->size / 1048576, (dir_info[idx]->size % 1048576) / 104858, (dir_info[idx]->size % 104858) / 10486);
		drawText(region_mem, X+5, help_y_offset, X+(W-380)-1, buffer, info_header_colour, COLOR_None, FNT_Size_1622); help_y_offset += 21;
	}

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Drawn file footer %s", dir_info[idx]->file_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
}

void drawThumbnailGridFooter() 
{
	dword string_length;
	word indent;

	// populate the footer box
	if (scenes_displayed) {
		TAP_SPrint(buffer, "%s %s    << >> %s", ok_play_t, play_scene_t, page_up_down_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (isRec(dir_info[curr_idx]->file_name)) {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s    %s %s", play_t, play_video_t, ok_t, resume_video_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (isMp3(dir_info[curr_idx]->file_name)) {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s    %s %s", play_t, play_all_tunes_t, ok_t, play_tune_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (isPhoto(dir_info[curr_idx]->file_name)) {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s    %s %s", play_t, slideshow_t, ok_t, show_photo_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (isSkin(dir_info[curr_idx]->file_name)) {
		TAP_SPrint(buffer, "%s %s    %s %s %s    << >> %s    %s %s", play_t, slideshow_t, ok_t, load_t, skin_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (isTAP(dir_info[curr_idx]->file_name)) {
		//int tap_id = HDD_TAP_GetIDByFileName(dir_info[curr_idx]->file_name);
		
		//if (HDD_TAP_isRunning(tap_id))
		//	TAP_SPrint(buffer, "%s %s    %s %s TAP   << >> %s    %s %s", play_t, slideshow_t, ok_t, "Stop", page_up_down_t, white_t, delete_t);
		//else
			TAP_SPrint(buffer, "%s %s    %s %s TAP   << >> %s    %s %s", play_t, slideshow_t, ok_t, load_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (InDataFilesFolder(curr_dir) && isFolder(curr_idx)) {
		TAP_SPrint(buffer, "%s %s    << >> %s    %s %s", ok_t, change_dir_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (InDataFilesFolder(curr_dir) && isParentDirectory(dir_info[curr_idx]->file_name)) {
		TAP_SPrint(buffer, "%s %s    << >> %s", ok_play_t, change_dir_t, page_up_down_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (InMp3FilesFolder(curr_dir) && isFolder(curr_idx)) {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s    %s %s", play_t, play_folder_t, ok_t, change_dir_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (InMp3FilesFolder(curr_dir) && isParentDirectory(dir_info[curr_idx]->file_name)) {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s", play_t, play_all_tunes_t, ok_t, change_dir_t, page_up_down_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (isFolder(curr_idx)
			&& strcmp(dir_info[curr_idx]->file_name, "ProgramFiles") != 0
			&& strcmp(dir_info[curr_idx]->file_name, "DataFiles") != 0
			&& strcmp(dir_info[curr_idx]->file_name, "MP3") != 0
			&& strcmp(dir_info[curr_idx]->file_name, "Auto Start") != 0) {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s    %s %s", play_t, slideshow_folder_t, ok_t, change_dir_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (isFolder(curr_idx)) {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s", play_t, slideshow_folder_t, ok_play_t, change_dir_t, page_up_down_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	ef (isParentDirectory(dir_info[curr_idx]->file_name)) {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s", play_t, slideshow_t, ok_play_t, change_dir_t, page_up_down_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}
	else  {
		TAP_SPrint(buffer, "%s %s    %s %s    << >> %s    %s %s", play_t, slideshow_t, ok_t, show_log_t, page_up_down_t, white_t, delete_t);
		string_length = getWidth(buffer, FNT_Size_1419);
	}

	indent = thumbnail_offset_x + ((640 - string_length) / 2);

	TAP_Osd_FillBox(region_mem, thumbnail_offset_x+1, thumbnail_offset_y+526-22, 640-1, 20, footer_bg_colour);

	string_length = 0;

	if (scenes_displayed) {
		appendThumbnailFooterString(indent, &string_length, ok_play_t, help_text_colour, TRUE);
		appendThumbnailFooterString(indent, &string_length, play_scene_t, body_text_colour, FALSE);
		appendThumbnailFooterString(indent, &string_length, "<< >>", help_text_colour, TRUE);
		appendThumbnailFooterString(indent, &string_length, page_up_down_t, body_text_colour, FALSE);
		return;
	}

	if (isRec(dir_info[curr_idx]->file_name)) {
		appendThumbnailFooterString(indent, &string_length, play_t, help_text_colour, TRUE);
		appendThumbnailFooterString(indent, &string_length, play_video_t, body_text_colour, FALSE);
		appendThumbnailFooterString(indent, &string_length, ok_t, help_text_colour, TRUE);
		appendThumbnailFooterString(indent, &string_length, resume_video_t, body_text_colour, FALSE);
		appendThumbnailFooterString(indent, &string_length, "<< >>", help_text_colour, TRUE);
		appendThumbnailFooterString(indent, &string_length, page_up_down_t, body_text_colour, FALSE);
		appendThumbnailFooterString(indent, &string_length, white_t, help_text_colour, TRUE);
		appendThumbnailFooterString(indent, &string_length, delete_t, body_text_colour, FALSE);
		return;
	}

	if (!InDataFilesFolder(curr_dir)) {
		appendThumbnailFooterString(indent, &string_length, play_t, help_text_colour, TRUE);
		if (isMp3(dir_info[curr_idx]->file_name) || (InMp3FilesFolder(curr_dir) && isParentDirectory(dir_info[curr_idx]->file_name)))
			appendThumbnailFooterString(indent, &string_length, play_all_tunes_t, body_text_colour, FALSE);
		ef (InMp3FilesFolder(curr_dir) && isFolder(curr_idx))
			appendThumbnailFooterString(indent, &string_length, play_folder_t, body_text_colour, FALSE);
		ef (isFolder(curr_idx))
			appendThumbnailFooterString(indent, &string_length, slideshow_folder_t, body_text_colour, FALSE);
		else
			appendThumbnailFooterString(indent, &string_length, slideshow_t, body_text_colour, FALSE);
	}

	appendThumbnailFooterString(indent, &string_length, ok_t, help_text_colour, TRUE);
	if (isMp3(dir_info[curr_idx]->file_name))
		appendThumbnailFooterString(indent, &string_length, play_tune_t, body_text_colour, FALSE);
	ef (dir_info[curr_idx]->folder)
		appendThumbnailFooterString(indent, &string_length, change_dir_t, body_text_colour, FALSE);
	ef (isPhoto(dir_info[curr_idx]->file_name))
		appendThumbnailFooterString(indent, &string_length, show_photo_t, body_text_colour, FALSE);
	ef (isSkin(dir_info[curr_idx]->file_name)) {
		TAP_SPrint(buffer, "%s %s", load_t, skin_t);
		appendThumbnailFooterString(indent, &string_length, buffer, body_text_colour, FALSE);
	}
	ef (isTAP(dir_info[curr_idx]->file_name)) {
		//int tap_id = HDD_TAP_GetIDByFileName(dir_info[curr_idx]->file_name);
		
		//if (HDD_TAP_isRunning(tap_id))
		//	TAP_SPrint(buffer, "%s TAP", "Stop");
		//else
			TAP_SPrint(buffer, "%s TAP", load_t);
		appendThumbnailFooterString(indent, &string_length, buffer, body_text_colour, FALSE);
	}
	else
		appendThumbnailFooterString(indent, &string_length, show_log_t, body_text_colour, FALSE);

	appendThumbnailFooterString(indent, &string_length, "<< >>", help_text_colour, TRUE);
	appendThumbnailFooterString(indent, &string_length, page_up_down_t, body_text_colour, FALSE);

	if (!isParentDirectory(dir_info[curr_idx]->file_name)
		    && strcmp(dir_info[curr_idx]->file_name, "ProgramFiles") != 0
			&& strcmp(dir_info[curr_idx]->file_name, "DataFiles") != 0
			&& strcmp(dir_info[curr_idx]->file_name, "MP3") != 0
			&& strcmp(dir_info[curr_idx]->file_name, "Auto Start") != 0)
	{
		appendThumbnailFooterString(indent, &string_length, white_t, help_text_colour, TRUE);
		appendThumbnailFooterString(indent, &string_length, delete_t, body_text_colour, FALSE);
	}
}

void drawFileListHeader(void)
{
	dword string_length;
	word indent;

	TAP_Osd_FillBox(region_mem, X, Y, W+5, 30, header_bg_colour);
	if (show_header_icons) {
		if (recycle_bin_displayed)
			TAP_Osd_PutGd(region_mem, X+10, Y, &_trashcan2Gd, TRUE);
		ef (InMp3FilesFolder(curr_dir))
			TAP_Osd_PutGd(region_mem, X+10, Y, &_noteGd, TRUE);
		ef (InDataFilesFolder(curr_dir))
			TAP_Osd_PutGd(region_mem, X+10, Y, &_reelGd, TRUE);
		else
			TAP_Osd_PutGd(region_mem, X+10, Y, &_cameraGd, TRUE);
	}
	else
		drawText(region_mem, X+1, Y+6, -1, text_for_help_t, header_text_colour, header_bg_colour, FNT_Size_1419);

#ifdef WIN32
	if (recycle_bin_displayed) {
		TAP_SPrint(buffer, "%s - %d %s", recycle_bin_t, no_of_files, files_t);
		switch (recycle_ordering_mode) {
			case ORDER_BY_NAME:					strcat(buffer, " [by name]"); break;
			case ORDER_BY_NAME_DESC:			strcat(buffer, " [by rev. name]"); break;
			case ORDER_BY_DATE:					strcat(buffer, " [by date]"); break;
			case ORDER_BY_DATE_DESC:			strcat(buffer, " [by rev. date]"); break;
		}
	}
	ef (InMp3FilesFolder(curr_dir))
		TAP_SPrint(buffer, "%s - %d tunes", "File list", local_no_of_mp3s);
	ef (InDataFilesFolder(curr_dir))
		TAP_SPrint(buffer, "%s - %d videos", "File list", local_no_of_recs);
	ef (!InFolder(curr_dir, default_startup_directory))
		TAP_SPrint(buffer, "%s - %d %s", "File list", no_of_files, "files");
	else
		TAP_SPrint(buffer, "%s - %d photos", "File list", local_no_of_jpegs);
#endif
#ifndef WIN32
	ExtractLastField(curr_dir, buffer);
	if (recycle_bin_displayed) {
		if (no_of_files == 1)
			TAP_SPrint(buffer, "%s - %d %s", recycle_bin_t, no_of_files, file_t);
		else
			TAP_SPrint(buffer, "%s - %d %s", recycle_bin_t, no_of_files, files_t);
		strcat(buffer, " ");
		switch (recycle_ordering_mode) {
			case ORDER_BY_NAME:			strcat(buffer, by_name_t); break;
			case ORDER_BY_NAME_DESC:	strcat(buffer, by_rev_name_t); break;
			case ORDER_BY_DATE:			strcat(buffer, by_date_t); break;
			case ORDER_BY_DATE_DESC:	strcat(buffer, by_rev_date_t); break;
		}
	}
	ef (InMp3FilesFolder(curr_dir)) {
		if (local_no_of_mp3s == 1)
			TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_mp3s, tune_t);
		else
			TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_mp3s, tunes_t);
	}
	ef (InDataFilesFolder(curr_dir)) {
		if (local_no_of_recs == 1)
			TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_recs, video_t);
		else
			TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_recs, videos_t);
	}
	ef (!InFolder(curr_dir, default_startup_directory)) {
		if (no_of_files == 1)
			TAP_SPrint(buffer, "%s - %d %s", buffer+1, no_of_files, "files");
		else
			TAP_SPrint(buffer, "%s - %d %s", buffer+1, no_of_files, "files");
	}
	else {
		if (local_no_of_jpegs == 1)
			TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_jpegs, photo_t);
		else
			TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_jpegs, photos_t);
	}
#endif

	string_length = getWidth(buffer, FNT_Size_1926);
	if (string_length > W-200) string_length = W-200;
	indent = X+100 + ((W-200 - string_length) / 2);
	drawText(region_mem, indent, Y, X+100+W-200, buffer, header_text_colour, header_bg_colour, FNT_Size_1926);
}

void drawThumbnailGridHeader(void)
{
	dword string_length;
	word indent;

	TAP_Osd_FillBox(region_mem, thumbnail_offset_x+1, thumbnail_offset_y+1, 640-2, 29, header_bg_colour);

#ifdef WIN32
	if (InMp3FilesFolder(curr_dir))
		TAP_SPrint(buffer, "%s - %d %s", "File list", local_no_of_mp3s, tunes_t);
	else
		TAP_SPrint(buffer, "%s - %d %s", "File list", local_no_of_jpegs, photos_t);
#endif
#ifndef WIN32
	if (scenes_displayed) {
		extractRecordingName(dir_info[0]->file_name, buffer);
		memset(file_name, '\0', 100);
		strncat(file_name, buffer, strlen(buffer)-4);
		if (no_of_files == 1)
			TAP_SPrint(buffer, "%s - %d %s", file_name, no_of_files, scene_t);
		else
			TAP_SPrint(buffer, "%s - %d %s", file_name, no_of_files, scenes_t);
	}
	else {
		ExtractLastField(curr_dir, buffer);
		if (InMp3FilesFolder(curr_dir)) {
			if (local_no_of_mp3s == 1)
				TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_mp3s, tune_t);
			else
				TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_mp3s, tunes_t);
		}
		ef (InDataFilesFolder(curr_dir)) {
			if (local_no_of_recs == 1)
				TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_recs, video_t);
			else
				TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_recs, videos_t);
		}
		else {
			if (local_no_of_jpegs == 1)
				TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_jpegs, photo_t);
			else
				TAP_SPrint(buffer, "%s - %d %s", buffer+1, local_no_of_jpegs, photos_t);
		}
	}
#endif

	string_length = getWidth(buffer, FNT_Size_1622);
	indent = thumbnail_offset_x + ((640 - string_length) / 2);
	drawText(region_mem, indent, thumbnail_offset_y+4, -1, buffer, header_text_colour, COLOR_None, FNT_Size_1622);
}

void initialiseLine(int x, int y, int w, int height, byte *gradient, word colour, word tt_colour)
{
	if (gradient_increment)
		TAP_Osd_RestoreBox(region_mem, x, y, w, height, gradient);
	ef (two_tone_increment) {
		TAP_Osd_FillBox(region_mem, x, y, w, two_tone_increment, colour);
		TAP_Osd_FillBox(region_mem, x, y+two_tone_increment, W+10+1, height-two_tone_increment, tt_colour);
	}
	else
		TAP_Osd_FillBox(region_mem, x, y, w, height, colour);
}

void drawBlankFileList(word no_of_lines)
{
	int i, y = 30, line_height = (no_of_lines == 10) ? 26 : 30, line_gap = (no_of_lines == 10) ? 3 : 2;

	TAP_Osd_FillBox(region_mem, X-5, Y+y, W+10+1, 3, frame_colour);
	y += 3;

	for (i = 0; i < no_of_lines; i++)
	{
		y += line_height;
		
		TAP_Osd_FillBox(region_mem, X-5, Y+y, W+10+1, line_gap, frame_colour);
		y += line_gap;
	}

	// footer section
	if (no_of_lines == 9) TAP_Osd_FillBox(region_mem, X-5, Y+y, W+10+1, 2, frame_colour);
	if (!menu_displayed) TAP_Osd_FillBox(region_mem, X+235, Y+y+(no_of_lines == 9 ? 2 : 0), 2, 120+1, frame_colour);
}

void drawBlankThumbnailGrid()
{
	int i, y = 30;

	// outer border
	TAP_Osd_DrawRectangle(region_mem, thumbnail_offset_x, thumbnail_offset_y, 640, 526, 2, frame_colour);

	// fill whole area
	TAP_Osd_FillBox(region_mem, thumbnail_offset_x+1, thumbnail_offset_y+1, 640-2, 526-2, body_bg_colour);
	
	// vertical grid lines
	for (i = 0; i < 4; i++)
	{
		TAP_Osd_FillBox(region_mem, thumbnail_offset_x+1, thumbnail_offset_y+y, 640-2, 3, frame_colour);
		y += 157;
	}

	// horizontal grid lines
	TAP_Osd_FillBox(region_mem, thumbnail_offset_x+(640/3), thumbnail_offset_y+30, 2, 526-50, frame_colour);
	TAP_Osd_FillBox(region_mem, thumbnail_offset_x+(640/3)+(640/3), thumbnail_offset_y+30, 2, 526-50, frame_colour);
}

void drawStopMenuLine(int line_idx)
{
	int y;
	dword fc;

	y = 30 + (line_idx * 29) + 3;

	if (line_idx == stop_menu_highlight) {
		initialiseLine(X+200-5, Y+100+y, W-400+10+1, 26, stop_menu_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
	}
	else {
		initialiseLine(X+200-5, Y+100+y, W-400+10+1, 26, stop_menu_background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
	}

	switch (line_idx) {
		case 0:
			TAP_SPrint(buffer, "%s", delete_video_t);
			break;
		case 1:
			TAP_SPrint(buffer, "%s", stop_video_t);
			break;
		case 2:
			TAP_SPrint(buffer, "%s", resume_video_t);
			break;
		case 3:
			TAP_SPrint(buffer, "%s", trim_video_to_start_t);
			break;
		case 4:
			TAP_SPrint(buffer, "%s", trim_video_to_end_t);
			break;
		case 5:
			TAP_SPrint(buffer, "%s", split_video_t);
			break;
	}

	drawText(region_mem, X+200+5, Y+100+y+3, X+200+W-400-3, buffer, fc, COLOR_None, FNT_Size_1622);
}

void drawStopMenuLines()
{
	int i;

	for (i = 0; i < no_of_stop_options; i++)
		drawStopMenuLine(i);
}

void drawStopMenu()
{
	int i, j = 30;
	word x = X+200, y = Y+100, w = W-400, h = 30+(29*no_of_stop_options)+3+40, string_length, indent;

	TAP_ExitNormal();

	region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
	region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(stop_menu_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, -1, stop_menu_t, header_text_colour, COLOR_None, FNT_Size_1926);
	
	// menu items
	for (i = 0; i < no_of_stop_options; i++)
	{
		TAP_Osd_FillBox(region_mem, x-5, y+j, w+10+1, 3, frame_colour);
		j += 3;

		initialiseLine(x-5, y+j, w+10+1, 26, stop_menu_background_gradient, body_bg_colour, tt_body_bg_colour);
		j += 26;
	}

	// footer section
	TAP_Osd_FillBox(region_mem, x-5, y+j, w+10+1, 3, frame_colour);
	TAP_Osd_FillBox(region_mem, x, y+j+3, w+1, 40+5, footer_bg_colour);

	drawStopMenuLines();

	// populate the footer box
	drawText(region_mem, x+97, y+30+(29*no_of_stop_options)+12, -1, ok_t, help_text_colour, COLOR_None, FNT_Size_1622);

	drawRoundedRectangle(region, x, y, w, h, 3, no_of_stop_options, 30, 40, frame_colour, COLOR_None, body_bg_colour, FALSE);

	copyMemoryToStopMenu();
}

void drawOptionLine(int line_idx)
{
	int y, offset_y = Y+40+((10-no_of_options)/2)*29;
	dword fc;

	y = 30 + (line_idx * 29) + 3;

	if (line_idx == options_highlight) {
		initialiseLine(X+150-5, offset_y+y, W-300+10+1, 26, options_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
	}
	else {
		initialiseLine(X+150-5, offset_y+y, W-300+10+1, 26, options_background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
	}

	if (sort_options) {
		switch (line_idx) {
			case 0:	TAP_SPrint(buffer, "%s", by_date_option_t);	break;
			case 1:	TAP_SPrint(buffer, "%s", by_name_option_t);	break;
			case 2:	TAP_SPrint(buffer, "%s", no_of_options == 6 ? by_size_option_t : by_rev_date_option_t);	break;
			case 3:	TAP_SPrint(buffer, "%s", no_of_options == 6 ? by_rev_date_option_t : by_rev_name_option_t);	break;
			case 4:	TAP_SPrint(buffer, "%s", by_rev_name_option_t);	break;
			case 5:	TAP_SPrint(buffer, "%s", by_rev_size_option_t);	break;
		}
	}
	ef (InDataFilesFolder(curr_dir)) {
		switch (line_idx) {
			case 0:	TAP_SPrint(buffer, "%s", create_video_thumbnail_t);	break;
			case 1:	TAP_SPrint(buffer, "%s", create_video_scenes_t); break;
			case 2:	TAP_SPrint(buffer, "%s", delete_video_thumb_scenes_t);break;
			case 3:	TAP_SPrint(buffer, "%s", delete_folder_thumbs_scenes_t); break;
			case 4:	TAP_SPrint(buffer, "%s", recycle_bin_t); break;
			case 5:	TAP_SPrint(buffer, "%s", rename_t);	break;
			case 6:	TAP_SPrint(buffer, "%s", new_folder_t);	break;
			case 7:	TAP_SPrint(buffer, "%s", move_t); break;
			//case 8:	TAP_SPrint(buffer, "%s", sort_by_name_date_t); break;
		}
	}
	ef (InMp3FilesFolder(curr_dir)) {
		switch (line_idx) {
			case 0:	TAP_SPrint(buffer, "%s", delete_art_association_t);	break;
			case 1:	TAP_SPrint(buffer, "%s", recycle_bin_t); break;
			case 2:	TAP_SPrint(buffer, "%s", rename_t);	break;
			case 3:	TAP_SPrint(buffer, "%s", new_folder_t);	break;
			case 4:	TAP_SPrint(buffer, "%s", move_t); break;
			//case 5:	TAP_SPrint(buffer, "%s", sort_by_name_date_t); break;
		}
	}
	else {
		switch (line_idx) {
			case 0:	TAP_SPrint(buffer, "%s", associate_photo_with_album_t);	break;
			case 1:	TAP_SPrint(buffer, "%s", associate_photo_with_tune_t); break;
			case 2:	TAP_SPrint(buffer, "%s", delete_photo_cache_t);	break;
			case 3:	TAP_SPrint(buffer, "%s", delete_folder_cache_t); break;
			case 4:	TAP_SPrint(buffer, "%s", recycle_bin_t); break;
			case 5:	TAP_SPrint(buffer, "%s", rename_t);	break;
			case 6:	TAP_SPrint(buffer, "%s", new_folder_t);	break;
			case 7:	TAP_SPrint(buffer, "%s", move_t); break;
			//case 8:	TAP_SPrint(buffer, "%s", sort_by_name_date_t); break;
		}
	}
	drawText(region_mem, X+150+5, offset_y+y+3, X+150+W-300-3, buffer, fc, COLOR_None, FNT_Size_1622);
}

void drawOptionLines()
{
	word i;

	for (i = 0; i < no_of_options; i++)
		drawOptionLine(i);
}

void drawOptionsList()
{
	int i, j = 30;
	word x = X+150, y = Y+40+((10-no_of_options)/2)*29, w = W-300, h = 30+(29*no_of_options)+3+40, string_length, indent;

	TAP_ExitNormal();

	options_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	if (sort_options) {
		string_length = getWidth(sort_by_name_date_t, FNT_Size_1926);
		indent = x-5 + ((w+10 - string_length) / 2);
		drawText(region_mem, indent, y, -1, sort_by_name_date_t, header_text_colour, COLOR_None, FNT_Size_1926);
	}
	else {
		string_length = getWidth(options_list_t, FNT_Size_1926);
		indent = x-5 + ((w+10 - string_length) / 2);
		drawText(region_mem, indent, y, -1, options_list_t, header_text_colour, COLOR_None, FNT_Size_1926);
	}

	
	// list items
	for (i = 0; i < no_of_options; i++)
	{
		TAP_Osd_FillBox(region_mem, x-5, y+j, w+10+1, 3, frame_colour);
		j += 3;

		initialiseLine(x-5, y+j, w+10+1, 26, options_background_gradient, body_bg_colour, tt_body_bg_colour);
		j += 26;
	}

	// footer section
	TAP_Osd_FillBox(region_mem, x-5, y+j, w+10+1, 3, frame_colour);
	TAP_Osd_FillBox(region_mem, x, y+j+3, w+1, 40+5, footer_bg_colour);
	
	drawOptionLines();
	
	// populate the footer box
	drawText(region_mem, x+147, y+30+(29*no_of_options)+12, -1, ok_t, help_text_colour, COLOR_None, FNT_Size_1622);

	drawRoundedRectangle(region, x, y, w, h, 3, no_of_options, 30, 40, frame_colour, COLOR_None, body_bg_colour, FALSE);

	copyMemoryToOptions();
}

void drawBlankMoveFolderList()
{
	int i, y = 30;
	for (i = 0; i < 8; i++)
	{
		TAP_Osd_FillBox(region_mem, X+150-5, Y+50+y, W-300+10+1, 3, frame_colour);
		y += 3;

		initialiseLine(X+150-5, Y+50+y, W-300+10+1, 26, options_background_gradient, body_bg_colour, tt_body_bg_colour);
		y += 26;
	}

	// footer section
	TAP_Osd_FillBox(region_mem, X+150-5, Y+50+y, W-300+10+1, 3, frame_colour);
	TAP_Osd_FillBox(region_mem, X+150, Y+50+y+3, W-300+1, 70+5, footer_bg_colour);
}

void drawMoveFolder(int line_idx, int data_idx)
{
	int y;
	dword fc;

	if (data_idx >= no_of_move_folders)
		return;

	y = 30 + (line_idx * 29) + 3;
		
	ExtractLastField(move_folders[data_idx], buffer);

	if (line_idx == move_folder_highlight) {
		initialiseLine(X+150-5, Y+50+y, W-300+10+1, 26, options_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
	}
	else {
		initialiseLine(X+150-5, Y+50+y, W-300+10+1, 26, options_background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = (isParentDirectory(buffer+1)) ? detail_text_colour : folder_text_colour;
	}

	if (isParentDirectory(buffer+1)) {
		ExtractDirectory(tracked_dir, temp);
		ExtractLastField(temp, buffer);
		TAP_Osd_PutGd(region_mem, X+150, Y+50+y+1, &_back_arrow2Gd, TRUE);
	}
	else {
		TAP_Osd_PutGd(region_mem, X+150, Y+50+y+4, &_folderGd, TRUE);
	}
	drawText(region_mem, X+150+27, Y+50+y+3, X+150+W-300-3, buffer+1, fc, COLOR_None, FNT_Size_1622);
}

void drawMoveFolders(word start)
{
	int i;

	// draw each line
	for(i = 0; i < 8; i++)
	{
		drawMoveFolder(i, start + i);
	}
}

void drawMoveFolderList(bool save_screen)
{
	word string_length, indent;
	word x = X+150, y = Y+50, w = W-300, h = 30+(29*8)+3+70;

	TAP_ExitNormal();

	if (save_screen) move_folder_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	// header section
	TAP_Osd_FillBox(region_mem, X+150, Y+50, W-300, 30, header_bg_colour);
	string_length = getWidth(move_to_folder_t, FNT_Size_1926);
	indent = X+150-5 + ((W-300+10 - string_length) / 2);
	drawText(region_mem, indent, Y+50, -1, move_to_folder_t, header_text_colour, COLOR_None, FNT_Size_1926);
	
	// 10 list items
	drawBlankMoveFolderList();

	move_folder_idx = 0; move_folder_highlight = 0;
	drawMoveFolders(0);

	drawText(region_mem, X+150+32, Y+50+290, -1, ok_t, help_text_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, X+150+62, Y+50+290, -1, change_dir_t, body_text_colour, COLOR_None, FNT_Size_1622);
	drawHelpButton(region_mem, X+150+192, Y+50+290+2, RGB8888(224,224,0), COLOR_None, OSD_YELLOW);
	drawText(region_mem, X+150+222, Y+50+290, -1, move_t, body_text_colour, COLOR_None, FNT_Size_1622);
	drawRoundedRectangle(region, x, y, w, h, 3, 8, 30, 70, frame_colour, COLOR_None, body_bg_colour, FALSE);

	copyMemoryToMoveFolders();
}

void drawLoadPlaylistLine(int line_idx, int data_idx)
{
	int y;
	dword fc;

	if (data_idx >= no_of_playlists)
		return;
	
	y = 30 + (line_idx * 29) + 3;

	if (line_idx == load_playlist_highlight) {
		initialiseLine(X+150-5, Y+50+y, W-300+10+1, 26, options_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
	}
	else {
		initialiseLine(X+150-5, Y+50+y, W-300+10+1, 26, options_background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
	}

	memset(buffer, '\0', 100);
	if (photo_playlist_mode)
		strncat(buffer, photo_playlists[data_idx], strlen(photo_playlists[data_idx])-4);
	else
		strncat(buffer, mp3_playlists[data_idx], strlen(mp3_playlists[data_idx])-4);
	drawText(region_mem, X+150+5, Y+50+y+3, X+150+W-300-3, buffer, fc, COLOR_None, FNT_Size_1622);
}

void drawLoadPlaylists(word start)
{
	int i;

	// draw each line
	for(i = 0; i < 8; i++)
	{
		drawLoadPlaylistLine(i, start + i);
	}
}

void drawLoadPlaylist()
{
	word string_length, indent;
	word x = X+150, y = Y+50, w = W-300, h = 30+(29*8)+3+70;

	TAP_ExitNormal();

	load_playlist_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(playlists_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, -1, playlists_t, header_text_colour, COLOR_None, FNT_Size_1926);
	
	// 8 list items
	drawBlankMoveFolderList();

	load_playlist_idx = 0; load_playlist_highlight = 0;
	drawLoadPlaylists(0);

	drawText(region_mem, X+150+62, Y+50+290, -1, ok_t, help_text_colour, COLOR_None, FNT_Size_1622);
	drawText(region_mem, X+150+92, Y+50+290, -1, load_t, body_text_colour, COLOR_None, FNT_Size_1622);
	drawHelpButton(region_mem, X+150+172-10, Y+50+290, RGB8888(224,224,224), COLOR_None, OSD_WHITE);
	drawText(region_mem, X+150+192, Y+50+290, -1, delete_t, body_text_colour, COLOR_None, FNT_Size_1622);

	drawRoundedRectangle(region, x, y, w, h, 3, 8, 30, 70, frame_colour, COLOR_None, body_bg_colour, FALSE);

	copyMemoryToMoveFolders();
}

void drawLoadSkinLine(int line_idx, int data_idx)
{
	int y;
	dword fc;

	if (data_idx >= skin_count)
		return;

	y = 30 + (line_idx * 29) + 3;

	if (line_idx == load_skin_highlight) {
		initialiseLine(X+150-5, Y+50+y, W-300+10+1, 26, options_highlight_gradient, highlight_bg_colour, tt_highlight_bg_colour);
		fc = highlight_text_colour;
	}
	else {
		initialiseLine(X+150-5, Y+50+y, W-300+10+1, 26, options_background_gradient, body_bg_colour, tt_body_bg_colour);
		fc = body_text_colour;
	}

	memset(buffer, '\0', 100);
	strncat(buffer, skins[data_idx].skin_name, strlen(skins[data_idx].skin_name)-4);
	drawText(region_mem, X+150+5, Y+50+y+3, X+150+W-300-3, buffer, fc, COLOR_None, FNT_Size_1622);
}

void drawLoadSkins(word start)
{
	int i;

	// draw each line
	for(i = 0; i < 8; i++)
	{
		drawLoadSkinLine(i, start + i);
	}
}

void drawLoadSkinList()
{
	word string_length, indent;
	word x = X+150, y = Y+50, w = W-300, h = 30+(29*8)+3+70;

	TAP_ExitNormal();

	load_skin_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(skins_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, -1, skins_t, header_text_colour, COLOR_None, FNT_Size_1926);
	
	// 8 list items
	drawBlankMoveFolderList();

	load_skin_idx = 0; load_skin_highlight = 0;
	drawLoadSkins(0);

	TAP_SPrint(buffer, "%s %s", ok_t, load_t);
	string_length = getWidth(buffer, FNT_Size_1622);
	indent = x-5 + ((w+10 - string_length) / 2);
	TAP_SPrint(buffer, "%s ", ok_t);
	drawText(region_mem, indent, Y+50+290, -1, buffer, help_text_colour, COLOR_None, FNT_Size_1622);
	string_length = getWidth(buffer, FNT_Size_1622);
	indent += string_length;
	drawText(region_mem, indent, Y+50+290, -1, load_t, body_text_colour, COLOR_None, FNT_Size_1622);

	drawRoundedRectangle(region, x, y, w, h, 3, 8, 30, 70, frame_colour, COLOR_None, body_bg_colour, FALSE);

	copyMemoryToMoveFolders();
}

void drawSkinElement(int line_idx, int data_idx)
{
	int y;
	dword fc, bc;

	if (data_idx >= no_of_insert_elements)
		return;

	y = 30 + (line_idx * 29);

	y += 3;

	if (line_idx == skin_element_highlight) {
		bc = highlight_bg_colour;
		fc = highlight_text_colour;
	}
	else {
		bc = body_bg_colour;
		fc = body_text_colour;
	}

	TAP_Osd_FillBox(region_mem, X+150-5, Y+50+y, W-300+10+1, 26, bc);
	drawText(region_mem, X+150+5, Y+50+y+3, X+150+W-300-3, insert_elements[data_idx], fc, COLOR_None, FNT_Size_1622);
}

void drawSkinElements(word start)
{
	int i;

	// draw each line
	for (i = 0; i < 8; i++)
	{
		drawSkinElement(i, start + i);
	}
}

void drawSkinElementList()
{
	word string_length, indent;
	word x = X+150, y = Y+50, w = W-300, h = 30+(29*8)+3+70;

	TAP_ExitNormal();

	skin_element_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	// header section
	TAP_Osd_FillBox(region_mem, x, y, w, 30, header_bg_colour);
	string_length = getWidth(skin_elements_t, FNT_Size_1926);
	indent = x-5 + ((w+10 - string_length) / 2);
	drawText(region_mem, indent, y, -1, skin_elements_t, header_text_colour, COLOR_None, FNT_Size_1926);
	
	// 8 list items
	drawBlankMoveFolderList();

	load_skin_idx = 0; load_skin_highlight = 0;
	drawSkinElements(0);

	TAP_SPrint(buffer, "%s %s", ok_t, load_t);
	string_length = getWidth(buffer, FNT_Size_1622);
	indent = x-5 + ((w+10 - string_length) / 2);
	TAP_SPrint(buffer, "%s ", ok_t);
	drawText(region_mem, indent, Y+50+290, -1, buffer, help_text_colour, COLOR_None, FNT_Size_1622);
	string_length = getWidth(buffer, FNT_Size_1622);
	indent += string_length;
	drawText(region_mem, indent, Y+50+290, -1, load_t, body_text_colour, COLOR_None, FNT_Size_1622);
	//drawHelpButton(region_mem, X+150+150-10, Y+50+290+2, RGB8888(224,224,224), COLOR_None, OSD_WHITE);
	//drawText(region_mem, X+150+170, Y+50+290, -1, "Delete", body_text_colour, COLOR_None, FNT_Size_1622);

	drawRoundedRectangle(region, x, y, w, h, 3, 8, 30, 70, frame_colour, COLOR_None, body_bg_colour, FALSE);

	copyMemoryToMoveFolders();
}

void drawFileList(bool draw_background, bool prefill_area)
{
	word lines = (InDataFilesFolder(curr_dir) && !recycle_bin_displayed) ? line_count : 10, scroll_height;

	TAP_ExitNormal();

	// header section
	drawFileListHeader();
	
	// 10 list items
	drawBlankFileList(lines); 

	// get starting point
	curr_idx = recycle_bin_displayed ? saved_recycle_idx : getNavHistoryIndex();
	curr_highlight = recycle_bin_displayed ? saved_recycle_highlight : getNavHistoryHighlight();
	if (curr_highlight < 0) {
		if (no_of_files > lines && (curr_idx >= (no_of_files - lines)))
			curr_highlight = lines - (no_of_files - curr_idx);
		else
			curr_highlight = curr_idx % lines;
	}
	ef (no_of_files > lines && ((curr_idx - curr_highlight) > (no_of_files - lines))) {
		curr_idx = no_of_files - 1;
		curr_highlight = lines-1;
	}
	ef (no_of_files <= lines && (curr_highlight != curr_idx))
		curr_highlight = curr_idx;
	ef (curr_highlight > (lines - 1))
		curr_highlight = lines - 1;


	drawFiles(curr_idx - curr_highlight);

	updateFileCount();

	// populate the footer box
	drawFileListFooter(curr_idx);
	
	// delete any old info box at the bottom
	if (!InDataFilesFolder(curr_dir) && !mp3_playing)
		TAP_Osd_FillBox(region_mem, X-1, Y+345+119-1, W+2, 35, COLOR_None);

	// reset flags and pointers
	if (!recycle_bin_displayed) rollbackNavHistory();

	if (draw_background) 
		drawRoundedRectangle(region, X, Y, W, H, 3, lines, 30, 122, frame_colour, COLOR_None, prefill_area ? body_bg_colour : COLOR_None, FALSE);

#ifndef WIN32
	if (recycle_bin_displayed)
		drawArea(region, X+(W-380), Y+H-121+5, 2, 121+3, frame_colour);
	ef (InDataFilesFolder(curr_dir))
		if (!disable_file_details || !disable_thumbnails)
			drawArea(region, X+W-150, Y+H-121+5, 2, 121+3, frame_colour);
	else
		drawArea(region, X+(W-380), Y+H-121+5, 2, 121+3, frame_colour);
#endif

	//drawScrollBar(curr_idx, curr_highlight, lines);
}

void drawThumbnailGrid()
{
	word start_list;

	TAP_ExitNormal();

#ifndef WIN32
	TAP_Osd_SetTransparency(region,255);
#endif

	// draw grid
	drawBlankThumbnailGrid();
	
	// header section
	drawThumbnailGridHeader();
	
	curr_idx = 0;
	//curr_highlight = back_to_parent ? saved_dir_idx : saved_file_idx;
	curr_highlight = getNavHistoryIndex();
	start_list = curr_highlight < 9 ? 0 : curr_highlight - 8;
	if (curr_highlight > 8)	curr_highlight = 8;
	drawThumbnails(start_list);
	//curr_idx = back_to_parent ? saved_dir_idx : saved_file_idx;
	curr_idx = getNavHistoryIndex();

	updateThumbnailCount();

	// populate the footer box
	drawThumbnailGridFooter();
	
	// reset flags and pointers
	rollbackNavHistory();
}

void highlightLastRecording()
{
	word i;

	if (no_of_files == 0)
		return;

	// highlight first rec we find
	for (i = no_of_files-1; i > 0; i--) {
		if (isRec(dir_info[i]->file_name)) {
			saveNavHistory(i, -1, FALSE);
			return;
		}
	}

	// if no recs, then highlight first entry
	saveNavHistory(0, 0, FALSE);
}

void highlightFirstRecording()
{
	word i;

	if (no_of_files == 0)
		return;

	// highlight first rec we find
	for (i = 0; i < no_of_files; i++) {
		if (isRec(dir_info[i]->file_name)) {
			saveNavHistory(i, -1, FALSE);
			return;
		}
	}

	// if no recs, then highlight first entry
	saveNavHistory(0, 0, FALSE);
}

void highlightRecording()
{
	TYPE_PlayInfo play_info; 
	TYPE_RecInfo rec_info_1, rec_info_2;
	int i;
	TAP_Hdd_GetPlayInfo(&play_info);
	TAP_Hdd_GetRecInfo(0, &rec_info_1);
	TAP_Hdd_GetRecInfo(1, &rec_info_2);

	// highlight first or last recording, depending on options
	if (!navHistoryExists()) {
		if (video_ordering_mode == ORDER_BY_DATE) {
			if (highlight_oldest_recording)
				highlightFirstRecording();
			else
				highlightLastRecording();
		}
		ef (video_ordering_mode == ORDER_BY_DATE_DESC) {
			if (highlight_oldest_recording)
				highlightLastRecording();
			else
				highlightFirstRecording();
		}
	}

	// override to highlight any recordings
	for (i = 0; i < no_of_files; i++) {
		if (IsDataFilesFolder(curr_dir) 
				&& (strcmp(rec_info_1.fileName, dir_info[i]->file_name) == 0 
					|| strcmp(rec_info_2.fileName, dir_info[i]->file_name) == 0)) {
			saveNavHistory(i, -1, TRUE);
			break;
		}
	}

	// override again to highlight any playbacks
	if (play_info.file && isRecPlaying(play_info)) {
		for (i = 0; i < no_of_files; i++) {
			if (strcmp(play_info.file->name, dir_info[i]->file_name) == 0
					&& play_info.file->startCluster == dir_info[i]->start_cluster) {
				saveNavHistory(i, -1, TRUE);
				break;
			}
		}
	}
}

void resetVideoHistory()
{
	if (video_ordering_mode == ORDER_BY_DATE) {
		if (highlight_oldest_recording)
			highlightFirstRecording();
		else
			highlightLastRecording();
	}
	ef (video_ordering_mode == ORDER_BY_DATE_DESC) {
		if (highlight_oldest_recording)
			highlightLastRecording();
		else
			highlightFirstRecording();
	}
	else
		saveNavHistory(0, 0, FALSE);
}

void drawInitialListing(bool populate_files)
{
	if (write_log) if (verbose) logText("Displaying file list", FALSE);
	region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
	region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);

	// switch aspect with WSSKiller
	TAP_GenerateEvent(EVT_KEY, WSS_43, 0);

	if (populate_files) populateFiles();

	if (InDataFilesFolder(curr_dir)) {
		highlightRecording();
	}
	
	if (thumbnail_mode) {
		drawThumbnailGrid(FALSE);
	}
	else {
		drawFileList(TRUE, FALSE);
	}
	copyMemoryToWindow();

	drawDiskSpaceInfoBox();
	//logMemory("After initial display", FALSE);
	window_displayed = TRUE;
}

void drawKeys()
{
	word string_length, i, j;
	byte letter, start_letter;
	char letter_string[2], shift_upper_t[6];
	word x = X, y = Y, h = H, w = W;

	switch (keyboard_case) {
		case KEYBOARD_AUTO:
			start_letter = (cursor_pointer == 0 || keyboard_name[cursor_pointer-1] == ' ') ? 65 : 97;
			strcpy(shift_upper_t, "ABC"); break;
		case KEYBOARD_UPPER:	
			start_letter = 65;
			strcpy(shift_upper_t, "abc"); break;
		case KEYBOARD_LOWER:
			start_letter = 97;
			strcpy(shift_upper_t, "123"); break;
		case KEYBOARD_NUMERIC:
			start_letter = 39;
			strcpy(shift_upper_t, "Abc"); break;
	}

	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-120-30-42, body_bg_colour);
	TAP_Osd_FillBox(region_mem, x-5, y+30, w+10+1, 3, frame_colour);
	TAP_Osd_FillBox(region_mem, x-5, y+30+(4*63), w+10+1, 3, frame_colour);

	// 4 rows, 9 columns
	for (i = 1; i < 4; i++)	{
		TAP_Osd_FillBox(region_mem, x-5, y+30+(i*63), w+10+1, 3, frame_colour);
	}
	for (i = 0; i < 10; i++)	{
		TAP_Osd_FillBox(region_mem, x+22+(i*63), y+30, 3, h-120-30-42, frame_colour);
	}

	for (i = 0; i < 36; i++)
		keyboard_data[i] = 0;
	letter = start_letter;
	letter_string[1] = '\0';
	for (i = 0; i < 4; i++)	{
		if (gradient_increment) {
			TAP_Osd_RestoreBox(region_mem, x-5, y+30+(i*63)+3, 27, 60, keyboard_filler_gradient);
			TAP_Osd_RestoreBox(region_mem, x+22+(9*63)+3, y+30+(i*63)+3, 27, 60, keyboard_filler_gradient);
		}
		for (j = 0; j < 9; j++)	{
			if (gradient_increment)
				TAP_Osd_RestoreBox(region_mem, x+22+(j*63)+3, y+30+(i*63)+3, 60, 60, keyboard_bg_gradient);

			if (letter < start_letter+26) {
				letter_string[0] = letter;
				if (keyboard_case == KEYBOARD_NUMERIC && letter == (start_letter+26-2)) letter_string[0] = '_';
				if (keyboard_case == KEYBOARD_NUMERIC && letter == (start_letter+26-1)) letter_string[0] = '~';
				string_length = getWidth(letter_string, FNT_Size_1926);
				drawText(region_mem, x+22+(j*63)+((66-string_length)/2), y+30+(i*63)+22, -1, letter_string, body_text_colour, COLOR_None, FNT_Size_1926);
				keyboard_data[i*9+j] = letter;
				if (keyboard_case == KEYBOARD_NUMERIC && letter == (start_letter+26-2)) keyboard_data[i*9+j] = '_';
				if (keyboard_case == KEYBOARD_NUMERIC && letter == (start_letter+26-1)) keyboard_data[i*9+j] = '~';
			}
			letter++;
			//if (letter >= start_letter+26) break;
		}
		//if (letter >= start_letter+26) break;
	}

	string_length = getWidth(clear_upper_t, FNT_Size_1622);
	drawText(region_mem, x+22+(2*63)+((66-string_length)/2), y+30+(3*63)+22, -1, clear_upper_t, body_text_colour, COLOR_None, FNT_Size_1622);
	keyboard_data[30] = 301;
	string_length = getWidth(del_upper_t, FNT_Size_1622);
	drawText(region_mem, x+22+(3*63)+((66-string_length)/2), y+30+(3*63)+22, -1, del_upper_t, body_text_colour, COLOR_None, FNT_Size_1622);
	keyboard_data[29] = 300;
	string_length = getWidth(space_upper_t, FNT_Size_1622);
	drawText(region_mem, x+22+(4*63)+((66-string_length)/2), y+30+(3*63)+22, -1, space_upper_t, body_text_colour, COLOR_None, FNT_Size_1622);
	keyboard_data[31] = 302;
	string_length = getWidth(shift_upper_t, FNT_Size_1622);
	drawText(region_mem, x+22+(5*63)+((66-string_length)/2), y+30+(3*63)+22, -1, shift_upper_t, body_text_colour, COLOR_None, FNT_Size_1622);
	keyboard_data[32] = 303;
	string_length = getWidth(save_upper_t, FNT_Size_1622);
	drawText(region_mem, x+22+(6*63)+((66-string_length)/2), y+30+(3*63)+22, -1, save_upper_t, body_text_colour, COLOR_None, FNT_Size_1622);
}

void drawKeyboardFooter()
{
	word help_y_offset = Y+350, help_x_offset = X+135;

	// blank out the box
	TAP_Osd_FillBox(region_mem, X, Y+323+4, W, 122+2, footer_bg_colour);

	// display standard button help
	drawText(region_mem, help_x_offset, help_y_offset, -1, "<<", help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset, help_y_offset, -1, ">>", help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset, help_y_offset, -1, pause_t, help_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset, help_y_offset, -1, exit_t, help_text_colour, COLOR_None, FNT_Size_1419);
	help_y_offset = Y+350;
	drawText(region_mem, help_x_offset+50, help_y_offset, -1, delete_char_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset+50, help_y_offset, -1, space_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset+50, help_y_offset, -1, shift_case_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset+50, help_y_offset, -1, return_t, body_text_colour, COLOR_None, FNT_Size_1419);

	// display coloured button help keys
	help_y_offset = Y+350;
	drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(224,224,224), COLOR_None, OSD_WHITE); help_y_offset += 15;
	drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(224,224,224), RGB8888(225,20,20), OSD_RECORD); help_y_offset += 15;
	drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(225,20,20), COLOR_None, OSD_RED); help_y_offset += 15;
	drawHelpButton(region_mem, help_x_offset+160, help_y_offset, RGB8888(20,20,225), COLOR_None, OSD_BLUE);

	// display coloured button help text
	help_y_offset = Y+350;
	drawText(region_mem, help_x_offset+160+20+7, help_y_offset, -1, clear_all_chars_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset+160+20+7, help_y_offset, -1, save_and_return_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset+160+20+7, help_y_offset, -1, move_cursor_back_t, body_text_colour, COLOR_None, FNT_Size_1419); help_y_offset += 15; 
	drawText(region_mem, help_x_offset+160+20+7, help_y_offset, -1, move_cursor_forward_t, body_text_colour, COLOR_None, FNT_Size_1419);
}

void drawKeyboardHeader()
{
	word string_length, indent;

	TAP_Osd_FillBox(region_mem, X, Y, W, 30, header_bg_colour);
	if (auto_deletes_displayed || auto_delete_update_displayed)
		strcpy(buffer, rule_keyword_t);
	ef (new_folder)
		strcpy(buffer, name_new_folder_t);
	ef (search_mp3s)
		strcpy(buffer, search_string_t);
	ef (playlist_displayed)
		strcpy(buffer, name_new_playlist_t);
	else
		strcpy(buffer, name_file_t);

	string_length = getWidth(buffer, FNT_Size_1926);
	indent = X-5 + ((W+10 - string_length) / 2);
	drawText(region_mem, indent, Y, -1, buffer, header_text_colour, COLOR_None, FNT_Size_1926);
	
	switch (keyboard_case) {
		case KEYBOARD_AUTO:
			strcpy(buffer, "[Abc]"); break;
		case KEYBOARD_UPPER:
			strcpy(buffer, "[ABC]"); break;
		case KEYBOARD_LOWER:
			strcpy(buffer, "[abc]"); break;
		case KEYBOARD_NUMERIC:
			strcpy(buffer, "[123]"); break;
	}
	drawText(region_mem, X+W-50, Y+2, -1, buffer, header_text_colour, COLOR_None, FNT_Size_1622);
}

void drawKeyboard(bool draw_background)
{
	word x = X, y = Y, h = H, w = W;

	TAP_Osd_FillBox(region_mem, x-5, y+30+3, w+10+1, h-30-3, body_bg_colour);
	
	drawKeyboardHeader();	
	drawKeys();

	// footer section
	TAP_Osd_FillBox(region_mem, x-5, y+h-120-39, w+10+1, 39, RGB8888(61,61,61));
	TAP_Osd_FillBox(region_mem, x, y+h-120, w+1, 120, footer_bg_colour);
	TAP_Osd_FillBox(region_mem, x-5, y+h-120, w+10+1, 3, frame_colour);

	drawText(region_mem, x+5, y+h-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);

	moveKeyboardHighlight(keyboard_idx, -1);
	
	// populate the footer box
	drawKeyboardFooter();

	if (draw_background)
		drawRoundedRectangle(region, x, y, w, h, 3, 0, 30, 118, frame_colour, COLOR_None, body_bg_colour, FALSE);
}

void cacheToDisk8Bit(byte *data, int width, int height, bool thumbnail)
{
	TYPE_File	*cached_file;
	dword size_of_word = sizeof(word), free_size;

	// write decoded data to file if enough room
	free_size = TAP_Hdd_FreeSize(); // gets free size in MB
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Free disc space for caching %d", free_size);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	if (TAP_Hdd_FreeSize() > 10)
	{
		ChangeDir("Cache");
		strcpy(file_name, jpeg_files[current_jpeg]->file_name);
		if (thumbnail)
		{
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Cache thumbnail photo %s", file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			strcat(file_name, ".tn");			
		}
		else
		{
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Cache full size size photo %s: %d x %d", file_name, width, height);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			strcat(file_name, ".cache");
		}
		
		TAP_Hdd_Create(file_name, ATTR_NORMAL);
		cached_file = TAP_Hdd_Fopen(file_name);
		TAP_Hdd_Fwrite(&width, sizeof(int), 1, cached_file);
		TAP_Hdd_Fwrite(&height, sizeof(int), 1, cached_file);
		TAP_Hdd_Fwrite(&bitmap_width, sizeof(int), 1, cached_file);
		TAP_Hdd_Fwrite(&bitmap_height, sizeof(int), 1, cached_file);
		TAP_Hdd_Fwrite(data, sizeof(byte), (width * height), cached_file);
		TAP_Hdd_Fclose(cached_file);
		ChangeDir("..");
	}
}

void cacheToDisk16Bit(char *name, word *data, int width, int height, bool thumbnail)
{
	TYPE_File	*cached_file;
	dword size_of_word = sizeof(word), free_size;

	// write decoded data to file if enough room
	free_size = TAP_Hdd_FreeSize(); // gets free size in MB
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Free disc space for caching %d", free_size);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	if (TAP_Hdd_FreeSize() > 10)
	{
		ChangeDir("Cache");
		strcpy(file_name, name);
		if (thumbnail)
		{
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Cache thumbnail photo %s", file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			strcat(file_name, ".tn");			
		}
		else
		{
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Cache full size size photo %s: %d x %d", file_name, width, height);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			strcat(file_name, ".cache");
		}
		
		TAP_Hdd_Create(file_name, ATTR_NORMAL);
		cached_file = TAP_Hdd_Fopen(file_name);
		TAP_Hdd_Fwrite(&width, sizeof(int), 1, cached_file);
		TAP_Hdd_Fwrite(&height, sizeof(int), 1, cached_file);
		TAP_Hdd_Fwrite(&bitmap_width, sizeof(int), 1, cached_file);
		TAP_Hdd_Fwrite(&bitmap_height, sizeof(int), 1, cached_file);
		TAP_Hdd_Fwrite(data, sizeof(word), (width * height), cached_file);
		TAP_Hdd_Fclose(cached_file);
		ChangeDir("..");
	}
}

void cache8Bit(byte *pixmap, int width, int height, bool thumbnail)
{
	int i, j, yy, xl, yl;

	// otherwise get dimensions, write to memory, then save to disk
	getDrawDimensionsAndOffset(width, height, &xl, &yl, NULL, NULL, 0, TRUE, thumbnail, FALSE, full_size_display, FALSE, FALSE);

	// put cache in memory
	byte_data = dlmalloc(sizeof(byte) * (xl * yl));
	if (!byte_data)
		return;

	for (j = 0; j < yl; j++) 
	{
		yy = (j*height/yl)*width;
		for (i=0; i<xl; i++) 
			byte_data[i + (j * xl)] = pixmap[yy + i * width / xl];
	}

	// save to disk
	cacheToDisk8Bit(byte_data, xl, yl, thumbnail);

	// finally free the memory
	dlfree(byte_data);
	dlmalloc_trim(0);
	byte_data = NULL;
}

void cache16Bit(word *pixmap, int width, int height, bool thumbnail, bool bitmap)
{
	int i, j, yy, xl, yl;
	
	// if using Wembley version and this is the full cache, then save bitmap direct
	if (!thumbnail && isJpg(jpeg_files[current_jpeg]->file_name)) {
		cacheToDisk16Bit(jpeg_files[current_jpeg]->file_name, jpeg_bitmap, width, height, thumbnail);
		return;
	}

	// otherwise get dimensions, write to memory, then save to disk
	getDrawDimensionsAndOffset(width, height, &xl, &yl, NULL, NULL, 0, TRUE, thumbnail, FALSE, full_size_display, FALSE, FALSE);

	// put cache in memory
	if (thumbnail) {
		thumbnail_data = dlmalloc(sizeof(word) * (xl * yl));
		if (!thumbnail_data)
			return;
	}
	else {
		cached_data = dlmalloc(sizeof(word) * (xl * yl));
		if (!cached_data)
			return;		
	}

	for (j = 0; j < yl; j++) 
	{
		yy = (j*height/yl)*width;
		for (i=0; i<xl; i++) {
			if (thumbnail)
				thumbnail_data[i + (j * xl)] = pixmap[yy + i * width / xl];
			else
				cached_data[i + (j * xl)] = pixmap[yy + i * width / xl];
		}
	}

	// save to disk
	cacheToDisk16Bit(jpeg_files[current_jpeg]->file_name, thumbnail ? thumbnail_data : cached_data, xl, yl, thumbnail);

	// finally free the memory
	//if (bitmap) {
	//	dlfree(cached_data);
	//  dlmalloc_trim(0);
	//	cached_data = NULL;
	//}
}

void cacheGIF(byte *pixmap)
{
	cache8Bit(pixmap, bitmap_width, bitmap_height, FALSE);
	cache8Bit(pixmap, bitmap_width, bitmap_height, TRUE);
}

void cacheJPEG(word *pixmap)
{
	if (isJpg(jpeg_files[current_jpeg]->file_name)) {
		cache16Bit(pixmap, cached_width, cached_height, FALSE, FALSE);
		cache16Bit(pixmap, cached_width, cached_height, TRUE, FALSE);
	}
	else {
		cache16Bit(pixmap, bitmap_width, bitmap_height, FALSE, TRUE);
		cache16Bit(pixmap, bitmap_width, bitmap_height, TRUE, TRUE);
	}
}

bool drawGIF(byte *pixmap, int width, int height, int actual_offset_x, int actual_offset_y, int xl, int yl)
{
	int i, j, yy;

	// clear the OSD
	TAP_Osd_FillBox(region_mem, 0, 0, 720, 576, COLOR_Black);

	setLut(jpeg_files[current_jpeg]->file_name);

	TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);

	for (j = 0; j < yl; j++) {
		yy = (j*height/yl)*width;
		for (i = 0; i < xl; i++) {
			if (rotated_degrees == 0) {
				TAP_Osd_DrawPixmap(region, actual_offset_x + i, actual_offset_y + j, 1, 1, &pixmap[yy + i * width / xl], FALSE, OSD_256);
			}
			ef (rotated_degrees == 90) {
				TAP_Osd_DrawPixmap(region, actual_offset_x + (yl - j), actual_offset_y + i, 1, 1, &pixmap[yy + i * width / xl], FALSE, OSD_256);
			}
			ef (rotated_degrees == 180) {
				TAP_Osd_DrawPixmap(region, actual_offset_x + (xl - i), actual_offset_y + (yl - j), 1, 1, &pixmap[yy + i * width / xl], FALSE, OSD_256);
			}
			ef (rotated_degrees == 270) {
				TAP_Osd_DrawPixmap(region, actual_offset_x + j, actual_offset_y + (xl - i), 1, 1, &pixmap[yy + i * width / xl], FALSE, OSD_256);
			}
		}
	}
	//TAP_Osd_Copy(region_mem, region, actual_offset_x, actual_offset_y, xl, yl, actual_offset_x, actual_offset_y, FALSE);

	// cache decoded data to file if not yet done so
	if (!draw_from_cache) cacheGIF(pixmap);

	return TRUE;
}

// filters image data to reduce flickering
void interlaceFlickerFilter(int width, int height, word *image_data, bool rotated) 
{
    word x, y;
	word p1, p2;
	word r, g, b;

	if (filter_flickering) {
		if (rotated) {
			for (x = 0; x < height; x++) {
				for (y = 0; y < width-1; y++) {
					p1 = image_data[y*height + x];
					p2 = image_data[(y+1)*height + x];
					r = (((p1 >> 10) & 31) + ((p2 >> 10) & 31)) >> 1;
					g = (((p1 >> 5) & 31) + ((p2 >> 5) & 31)) >> 1;
					b = ((p1 & 31) + (p2 & 31)) >> 1;
					image_data[y*height + x] = RGB8888(r<<3,g<<3,b<<3);
				}
			}
		}
		else {
			for (x = 0; x < width; x++) {
				for (y = 0; y < height-1; y++) {
					p1 = image_data[y*width + x];
					p2 = image_data[(y+1)*width + x];
					r = (((p1 >> 10) & 31) + ((p2 >> 10) & 31)) >> 1;
					g = (((p1 >> 5) & 31) + ((p2 >> 5) & 31)) >> 1;
					b = ((p1 & 31) + (p2 & 31)) >> 1;
					image_data[y*width + x] = RGB8888(r<<3,g<<3,b<<3);
				}
			}
		}
	}
}

bool drawJPEG(word *pixmap, int width, int height, int actual_offset_x, int actual_offset_y, int xl, int yl)
{
	int i, j, yy;

	// initialise cache memory
	cached_data = dlmalloc(sizeof(word) * (xl * yl));
	if (!cached_data)
		return FALSE;
	memset(cached_data, 0, (xl * yl));

	// now draw the photo to memory at display size 
	for (j = 0; j < yl; j++) {
		yy = (j*height/yl)*width;
		for (i = 0; i < xl; i++) {
			switch (rotated_degrees) {
				case 0:	cached_data[i + (j * xl)] = pixmap[yy + i * width / xl]; break;
				case 90: cached_data[(yl - j - 1) + (i * yl)] = pixmap[yy + i * width / xl]; break;
				case 180: cached_data[(xl - i - 1) + ((yl - j - 1) * xl)] = pixmap[yy + i * width / xl]; break;
				case 270: cached_data[j + ((xl - i - 1) * yl)] = pixmap[yy + i * width / xl]; break;
			}
		}
	}

	// anti-flickering filter to be applied before drawing
	interlaceFlickerFilter(xl, yl, cached_data, (rotated_degrees == 90 || rotated_degrees == 270));

#ifndef WIN32
	TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);

	if (rotated_degrees == 0 || rotated_degrees == 180) 
		TAP_Osd_DrawPixmap(region, actual_offset_x, actual_offset_y, xl, yl, cached_data, FALSE, OSD_1555);
	else
		TAP_Osd_DrawPixmap(region, actual_offset_x, actual_offset_y, yl, xl, cached_data, FALSE, OSD_1555);
#else
	if (full_size_display)
		TAP_Osd_FillBox(region_mem, 0, 0, 720, 576, COLOR_Black);
	else
		TAP_Osd_FillBox(region_mem, offset_x, offset_y, 600, 450, COLOR_Black);

	if (rotated_degrees == 0 || rotated_degrees == 180) {
		for (j = 0; j < yl; j++) {
			for (i = 0; i < xl; i++) 
			{
				TAP_Osd_PutPixel(region_mem, actual_offset_x + i, actual_offset_y + j, cached_data[i + j * xl]);
			}
		}
	}
	else {
		for (j = 0; j < xl; j++) 
			for (i = 0; i < yl; i++) 
				TAP_Osd_PutPixel(region_mem, actual_offset_x + i, actual_offset_y + j, cached_data[i + j * yl]);
	}
#endif

	// free the memory
	dlfree(cached_data);
	dlmalloc_trim(0);
	cached_data = NULL;

	// cache decoded data to file if not yet done so
	if (!draw_from_cache) cacheJPEG(pixmap);

	return TRUE;
}

int compareSkins(const void *s1, const void *s2)
{
	skin_1 = *(struct _skins *) s1;
	skin_2 = *(struct _skins *) s2;

	if (strlen(skin_1.skin_name) == 0)
		return 1;

	if (strlen(skin_2.skin_name) == 0)
		return -1;

	// if we get here, default to order by name
	return strcmp(skin_1.skin_name, skin_2.skin_name);
}

int compareStrings (const void *s1, const void *s2)
{
	char *string_1 = *(char **) s1;
	char *string_2 = *(char **) s2;

	return strcmp(string_1, string_2);
}

int compareArtists (const void *s1, const void *s2)
{
	char *string_1 = *(char **) s1;
	char *string_2 = *(char **) s2;

	// check for artist name starting with "The " and sort accordingly
	strcpy(buffer, string_1); strlwr(buffer);
	strcpy(buffer2, string_2); strlwr(buffer2);

	strcpy(buffer3, (strlen(buffer) > 4 && strncmp(buffer, "the ", 4) == 0) ? string_1+4 : string_1);
	strcpy(buffer4, (strlen(buffer2) > 4 && strncmp(buffer2, "the ", 4) == 0) ? string_2+4 : string_2);

	return strcmp(buffer3, buffer4);
}

int compareDimensions(const void *s1, const void *s2)
{
	dimension_1 = *(struct _dimensions **) s1;
	dimension_2 = *(struct _dimensions **) s2;

	if (strlen(dimension_1->file_name) == 0)
		return 1;

	if (strlen(dimension_2->file_name) == 0)
		return -1;

	return strcmp(dimension_1->file_name, dimension_2->file_name);
}

bool drawRadioChannelName()
{
	// if radio is on, then draw the name of the station
	TAP_Channel_GetCurrent(&tv_radio, &channel_number);
	if (tv_radio == SVC_TYPE_Radio)
	{
		TAP_Channel_GetInfo(tv_radio, channel_number, &channel_info);
		TAP_SPrint(buffer, "%s", channel_info.chName);
		TAP_Osd_FillBox(region_1, offset_x+120, offset_y-20, 150, 18, COLOR_Black);
		drawText(region_1, offset_x+120, offset_y-20, offset_x+120+150, buffer, header_text_colour, COLOR_None, FNT_Size_1419);
		if (fade_image) {
			TAP_Osd_FillBox(region_2, offset_x+120, offset_y-20, 150, 18, COLOR_Black);
			drawText(region_2, offset_x+120, offset_y-20, offset_x+120+150, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
		}
		return TRUE;
	}

	return FALSE;
}

#define JPEG_SUCCESS 0
#define JPEG_NO_LOAD 1
#define JPEG_NO_DECODE 2
#define JPEG_NO_MEMORY 3

void drawPhotoViewer(bool decode_error)
{
	char info[135];
	dword string_length;
	word indent;
	
	if (decode_error) {
		TAP_Osd_FillBox(region, offset_x, offset_y, 600, 450, COLOR_Black);

		// output helpful error detail message
		if (no_of_jpegs == 0) {
			strcpy(info, no_album_art_to_display_t);
			string_length = getWidth(info, FNT_Size_1926);
			indent = offset_x + ((VIEW_W - string_length) / 2);
			drawText(region, indent, offset_y+200, -1, info, header_text_colour, COLOR_None, FNT_Size_1926);
		}
		else {
			strcpy(info, jpeg_files[current_jpeg]->file_name);
			switch (decode_error) {
				case JPEG_NO_LOAD:
					TAP_SPrint(buffer2, " %s.", refused_to_load_t); break;
				case JPEG_NO_DECODE:
					TAP_SPrint(buffer2, " %s. %d x %d", refused_to_decode_t, bitmap_width, bitmap_height); break;
				case JPEG_NO_MEMORY:
					TAP_SPrint(buffer2, " %s. %d x %d", "ran out of system memory", bitmap_width, bitmap_height); break;
			}
			strcat(info, buffer2);
			string_length = getWidth(info, FNT_Size_1926);
			indent = offset_x + ((VIEW_W - string_length) / 2);
			drawText(region, indent, offset_y+200, -1, info, header_text_colour, COLOR_None, FNT_Size_1926);
		}
	}

	if (slideshow_started) {
		// draw the current status of the slideshow
		TAP_Osd_FillBox(region, offset_x, offset_y-20, 600, 18, COLOR_Black);
		TAP_SPrint(info, "%s...", slideshow_paused ? paused_t : playing_t);
		drawText(region, offset_x, offset_y-20, -1, info, body_text_colour, COLOR_Black, FNT_Size_1419);
			
		// draw photo count and name of photo
		TAP_SPrint(info, "%d %s %d", current_jpeg+1, of_t, no_of_jpegs);
		string_length = getWidth(info, FNT_Size_1419);
		indent = offset_x + ((VIEW_W - string_length) / 2);
		drawText(region, indent, offset_y-20, -1, info, body_text_colour, COLOR_None, FNT_Size_1419);
		memset(info, '\0', 135);
		strncat(info, jpeg_files[current_jpeg]->file_name, strlen(jpeg_files[current_jpeg]->file_name)-getExtensionLength(jpeg_files[current_jpeg]->file_name));
		string_length = getWidth(info, FNT_Size_1419);
		if (string_length > 250) string_length = 250;
		indent = offset_x + (VIEW_W - string_length);
		drawText(region, indent, offset_y-20, offset_x+VIEW_W, info, body_text_colour, COLOR_None, FNT_Size_1419);

		drawRadioChannelName();
	}
	ef (album_art_started) {
		word string_offset;

		// string together album name and year
		memset(info, '\0', 135);
		if (playing_id3_info->album && strlen(playing_id3_info->album) > 0)
			TAP_SPrint(info, "%s %s", taken_from_the_album_t, playing_id3_info->album);
		
		if (playing_id3_info->year && strlen(playing_id3_info->year) > 0) {
			TAP_SPrint(buffer2, ", %s %s", produced_in_t, playing_id3_info->year);
			strcat(info, buffer2);
		}

		string_length = getWidth(info, FNT_Size_1419);
		string_offset = offset_x + ((VIEW_W - string_length) / 2);
		TAP_Osd_FillBox(region, offset_x, offset_y-20, VIEW_W, 18, COLOR_Black);

		indent = string_offset;
		if (playing_id3_info->album && strlen(playing_id3_info->album) > 0) {
			TAP_SPrint(info, "%s ", taken_from_the_album_t);
			drawText(region, indent, offset_y-20, -1, info, body_text_colour, COLOR_None, FNT_Size_1419);
			indent += getWidth(info, FNT_Size_1419);
			TAP_SPrint(info, "%s", playing_id3_info->album);
			drawText(region, indent, offset_y-20, -1, info, info_header_colour, COLOR_None, FNT_Size_1419);
			indent += getWidth(info, FNT_Size_1419);
		}
		if (playing_id3_info->year && strlen(playing_id3_info->year) > 0) {
			TAP_SPrint(info, ", %s ", produced_in_t);
			drawText(region, indent, offset_y-20, -1, info, body_text_colour, COLOR_None, FNT_Size_1419);
			indent += getWidth(info, FNT_Size_1419);
			TAP_SPrint(info, "%s", playing_id3_info->year);
			drawText(region, indent, offset_y-20, -1, info, info_header_colour, COLOR_None, FNT_Size_1419);
		}
	}

	// draw the rectangular frame
	TAP_Osd_DrawRectangle(region, offset_x-1, offset_y-1, VIEW_W+2, VIEW_H+2, 2, frame_colour);

	// add an info box down the bottom, either with help or MP3 info
	TAP_Osd_DrawRectangle(region, offset_x-1, offset_y+450+10-1, VIEW_W+2, 30, 2, frame_colour);
	if (mp3_playing) {
		drawMp3InfoBox();
	}
	else {
		TAP_SPrint(buffer, "%s %s   %s %s   < > %s   << >> %s   %s %s", pause_t, pause_t, play_t, resume_t, previous_next_t, rotate_t, exit_t, return_t);
		string_length = getWidth(buffer, FNT_Size_1419);
		indent = offset_x + ((VIEW_W - string_length) / 2);

		string_length = 0;
		appendPhotoViewerFooterString(indent, &string_length, pause_t, folder_text_colour, TRUE);
		appendPhotoViewerFooterString(indent, &string_length, pause_t, body_text_colour, FALSE);
		appendPhotoViewerFooterString(indent, &string_length, play_t, folder_text_colour, TRUE);
		appendPhotoViewerFooterString(indent, &string_length, resume_t, body_text_colour, FALSE);
		appendPhotoViewerFooterString(indent, &string_length, "< >", folder_text_colour, TRUE);
		appendPhotoViewerFooterString(indent, &string_length, previous_next_t, body_text_colour, FALSE);
		appendPhotoViewerFooterString(indent, &string_length, "<< >>", folder_text_colour, TRUE);
		appendPhotoViewerFooterString(indent, &string_length, rotate_t, body_text_colour, FALSE);
		appendPhotoViewerFooterString(indent, &string_length, exit_t, folder_text_colour, TRUE);
		appendPhotoViewerFooterString(indent, &string_length, return_t, body_text_colour, FALSE);
	}
}

void handleExitMp3(bool exit_mode)
{
	if (write_log) logText("Exit MP3 mode", FALSE);
	
	if (exit_mode) {
		if (screensaver_started)
			exitScreensaver();
		ef (album_art_started)
			exitAlbumArt();
		ef (compact_mode_started)
			exitCompactMode();
		ef (blank_screen_started)
			exitBlankScreen();
	}

	if (mp3_playlist_playing) {
		if (getHistoryLength(FALSE) == no_of_mp3s)
			clearHistory(FALSE);
		savePlaylistHistory();
	}

	freeMP3Structure();
	destroy_ID3(id3_info);
	destroy_ID3(playing_id3_info);
	id3_info = NULL;
	playing_id3_info = NULL;
	mp3_playing = FALSE;
	clearHistory(FALSE);
	clearFolderHistory();

	if (window_displayed) {
		if (playlist_displayed) {
			drawPlaylistFooter(curr_idx);
			copyMemoryToWindow();
		}
		ef (!thumbnail_mode) {
			drawFileListFooter(curr_idx);
			copyMemoryToWindow();
		}
		
		TAP_Osd_FillBox(region, X-10, Y+345+124-2, W+20, 30+4, COLOR_None);
	}

	if (mp3_channel)
		TAP_Channel_Start(1, saved_channel_number, saved_tv_radio);
}

void processMP3(void)
{
	TYPE_PlayInfo play_info;

	// if we are in the process of stopping a track, then wait
	if (!mp3_playing || mp3_stopping)
		return;

#ifndef WIN32
    TAP_Hdd_GetPlayInfo(&play_info);

	// refresh the time display
	if (play_info.playMode == PLAYMODE_Mp3) {

		if (screensaver_started || (slideshow_started && full_size_display))
			return;

		if (menu_displayed 
				|| playlist_displayed 
				|| skin_editor_displayed 
				|| keyboard_displayed 
				|| (window_displayed && !thumbnail_mode) 
				|| (slideshow_started && !full_size_display) 
				|| (album_art_started && !full_size_display) 
				|| compact_mode_started) {
			word mp3_progress = play_info.currentBlock;

			if (mp3_progress != displayed_mp3_progress) {
				refreshMp3Progress();
				displayed_mp3_progress = mp3_progress;
			}
		}
	}
	else {
		if (write_log) if (verbose) logText("MP3 stopped", FALSE);
		
		if (single_mp3_mode) {
			handleExitMp3(TRUE);
			return;
		}

		// check the end mode
		if (getHistoryLength(FALSE) == no_of_mp3s) {
			switch (mp3_end_mode) { 
				case STOP_ALBUM:
					if (write_log) logText("End of album, stop playing", FALSE);
					handleExitMp3(TRUE);
					return;
				case REPEAT_ALBUM:
					if (write_log) logText("End of album, repeat", FALSE);
					break;
				case NEXT_ALBUM:
					if (write_log) logText("End of album, play next album", FALSE);
					handleChangeFolder(TRUE, TRUE);
					return;
			}
		}

		// choose the next track and play it
		current_mp3 = getNextMp3(TRUE);

		ChangeDirPath(mp3_files[current_mp3]->directory);
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play MP3 %d %s", current_mp3, mp3_files[current_mp3]->file_name);
		if (write_log) if (verbose) logText(log_buffer, FALSE);
		playMp3(mp3_files[current_mp3]->file_name);

		// refresh the mp3 info box
		if (!(window_displayed && thumbnail_mode) 
				&& !screensaver_started 
				&& !compact_mode_started 
				&& !blank_screen_started 
				&& !(slideshow_started && full_size_display))
			drawMp3InfoBox();

		// highlight the current mp3 if appropriate
		if (window_displayed)
			moveMP3Highlight();

		// change back to original path
		ChangeDirPath(curr_dir);
	}
#endif
}

void refreshLine(char *name)
{
	int idx = curr_idx - curr_highlight, i;

	if (thumbnail_mode) {
		/*for (i = 0; i < 9; i++) {
			if (idx+i >= no_of_files) break;
			if (strcmp(dir_info[idx+i].file_name, name) == 0) {
				drawThumbnail(i, idx+i);
				copyMemoryToWindow();
			}
		}*/
	}
	else {
		for (i = 0; i < line_count; i++) {
			if (idx+i >= no_of_files) break;
			if (strcmp(dir_info[idx+i]->file_name, name) == 0) {
				drawFile(i, idx+i);
				if (i == curr_highlight)
					refreshFooterProgress(idx+i);
				copyMemoryToWindow();
			}
		}
	}
}

void processRec(void)
{
	bool playing_finished = FALSE, recording_2_finished = FALSE, recording_1_finished = FALSE, recording_on_1 = FALSE, recording_on_2 = FALSE;
	TYPE_PlayInfo play_info;
	TYPE_RecInfo rec_info_1, rec_info_2;
	TAP_Hdd_GetPlayInfo(&play_info);
	recording_on_1 = TAP_Hdd_GetRecInfo(0, &rec_info_1) && ((rec_info_1.recType == RECTYPE_Normal) || (rec_info_1.recType == RECTYPE_Copy));
	recording_on_2 = TAP_Hdd_GetRecInfo(1, &rec_info_2) && ((rec_info_2.recType == RECTYPE_Normal) || (rec_info_2.recType == RECTYPE_Copy));

	// reset the playing flag if we have started/stopped playing
	if (play_info.file && isRecPlaying(play_info) && !rec_playing && !stop_playing) {
		if (write_log) logText("Playback started", FALSE);
		memcpy(&playing_file, play_info.file, sizeof(playing_file));
		rec_playing = TRUE;
		rec_playing_type = play_info.playMode;
		update_progress_tick = TAP_GetTick();
		append_to_progress_data = TRUE;
		reload_header = FALSE;
	}
	ef ((play_info.playMode != PLAYMODE_Playing && play_info.playMode != PLAYMODE_RecPlaying) && rec_playing) {
		if (write_log) logText("Playback stopped", FALSE);
		rec_playing = FALSE;
		
		playing_finished = TRUE;
		if (!overnight_play && rec_playing_type == PLAYMODE_Playing) {
			strcpy(last_played_name, playing_file.name);
			last_played_cluster = playing_file.startCluster;
		}
		rec_playing_type = PLAYMODE_None;
		stop_playing = FALSE;
		if (playback_ext_info) {
			dlfree(playback_ext_info);
			playback_ext_info = NULL;
		}

		saveProgressData();

		if (reload_header) {
			TYPE_File rec_file;
			if (ChangeDirCurrentRecording(playing_file.name, playing_file.startCluster, &rec_file)) {
				deleteFromProgressFromFile(&rec_file, tracked_dir);
				if (preload_video_headers)
					LoadHeaderInfo(playing_file.name, playing_file.startCluster, tracked_dir, -1, FALSE);
			}
			
			ChangeDirPath(curr_dir);
		}
	}

	// update the current playback progress
	if (isRecPlaying(play_info)
			&& play_info.file 
			&& (play_info.currentBlock > 0) 
			&& !stop_playing
			&& TAP_GetTick() > (update_progress_tick + 1000)) {

		if (append_to_progress_data) {
			if (play_info.playMode == PLAYMODE_RecPlaying) {
				dword total_block;
				if (strcmp(rec_info_1.fileName, play_info.file->name) == 0) {
					total_block = (rec_info_1.duration*60) * (play_info.totalBlock / rec_info_1.recordedSec);
					appendToProgressData(play_info.file, play_info.currentBlock, total_block);
				}
				ef (strcmp(rec_info_2.fileName, play_info.file->name) == 0) {
					total_block = (rec_info_2.duration*60) * (play_info.totalBlock / rec_info_2.recordedSec);
					appendToProgressData(play_info.file, play_info.currentBlock, total_block);
				}
			}
			else
				appendToProgressData(play_info.file, play_info.currentBlock, play_info.totalBlock);
			append_to_progress_data = FALSE;
		}

		if (play_info.playMode == PLAYMODE_RecPlaying) {
			dword total_block;
			if (strcmp(rec_info_1.fileName, play_info.file->name) == 0) {
				total_block = (rec_info_1.duration*60) * (play_info.totalBlock / rec_info_1.recordedSec);
				updateProgressData(play_info.file, play_info.currentBlock, total_block);
			}
			ef (strcmp(rec_info_2.fileName, play_info.file->name) == 0) {
				total_block = (rec_info_2.duration*60) * (play_info.totalBlock / rec_info_2.recordedSec);
				updateProgressData(play_info.file, play_info.currentBlock, total_block);
			}
		}
		else
			updateProgressData(play_info.file, play_info.currentBlock, play_info.totalBlock);
	}

	// monitor the playing/recording info every sec
	if (TAP_GetTick() > (refresh_rec_tick + 100)) {
	
		// if the playing names differ (i.e. some other app has started a different playback)
		if (isRecPlaying(play_info)
				&& play_info.file 
				&& (strcmp(playing_file.name, play_info.file->name) != 0 || playing_file.startCluster != play_info.file->startCluster)) {
			memcpy(&playing_file, play_info.file, sizeof(playing_file));
			update_progress_tick = TAP_GetTick();
			append_to_progress_data = TRUE;
		}

		// reset the recording flag if we have started/stopped playing
		if (recording_on_1 && !rec_recording_1) {
			if (write_log) logText("Recording 1 started", FALSE);
			strcpy(recording_1_name, rec_info_1.fileName);
			rec_recording_1 = TRUE;
		}
		ef (!recording_on_1 && rec_recording_1) {
			if (write_log) logText("Recording 1 stopped", FALSE);
			rec_recording_1 = FALSE;
			recording_1_finished = TRUE;
		}

		// reset the recording flag if we have started/stopped playing
		if (recording_on_2 && !rec_recording_2) {
			if (write_log) logText("Recording 2 started", FALSE);
			strcpy(recording_2_name, rec_info_2.fileName);
			rec_recording_2 = TRUE;
		}
		ef (!recording_on_2 && rec_recording_2) {
			if (write_log) logText("Recording 2 stopped", FALSE);
			rec_recording_2 = FALSE;
			recording_2_finished = TRUE;
		}

		// if the rec names differ, then we have back to back recordings, so adjust the name
		if (recording_on_1 && strcmp(recording_1_name, rec_info_1.fileName) != 0)
			strcpy(recording_1_name, rec_info_1.fileName);
		if (recording_on_2 && strcmp(recording_2_name, rec_info_2.fileName) != 0)
			strcpy(recording_2_name, rec_info_2.fileName);
		
		if (window_displayed && !recycle_bin_displayed && !auto_deletes_displayed && !auto_delete_update_displayed && InDataFilesFolder(curr_dir)
				&& (rec_playing || rec_recording_1 || rec_recording_2 || playing_finished || recording_1_finished || recording_2_finished)) {
			
			if (rec_playing || playing_finished)
				refreshLine(playing_file.name);

			if (rec_recording_1 || recording_1_finished) 
				refreshLine(recording_1_name);

			if (rec_recording_2 || recording_2_finished) 
				refreshLine(recording_2_name);
		}

		refresh_rec_tick = TAP_GetTick();
	}

	// if this was a marked recording, then play the next in sequence
	if (multi_play_started && playing_finished) {
		play_next_recording = TRUE;
		play_next_tick = TAP_GetTick();
	}
}

void processScreensaver1(void)
{
	int i, j;
	dword random_position;
	int thumbnail_width, thumbnail_height;
	word *thumbnail_bitmap;
	byte *thumbnail_bytes;

	TAP_ExitNormal();

	// attempt to draw a thumbnail in a random position
	if (show_jpeg)
	{
		TYPE_File *thumbnail_file;

		show_jpeg = FALSE;

		ChangeDirPath(jpeg_files[current_jpeg]->directory);
		strcpy(file_name, jpeg_files[current_jpeg]->file_name);
		strcat(file_name, ".tn");

		// change to Cache directory
		createCacheDirectoryIfNotThere();
		ChangeDir("Cache");

		if (TAP_Hdd_Exist(file_name))
		{
			if (write_log) if (verbose) logText("Reading thumbnail in from cache", FALSE);
			thumbnail_file = TAP_Hdd_Fopen(file_name);
			if (thumbnail_file != NULL)
			{
				int ss_offset_x, ss_offset_y, x_coord, y_coord;

				TAP_Hdd_Fread(&thumbnail_width, sizeof(int), 1, thumbnail_file);
				TAP_Hdd_Fread(&thumbnail_height, sizeof(int), 1, thumbnail_file);
				TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, thumbnail_file);
				TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, thumbnail_file);
				if (isGif(jpeg_files[current_jpeg]->file_name)) {
					thumbnail_bytes = dlmalloc(sizeof(byte) * thumbnail_width * thumbnail_height);
					if (thumbnail_bytes != NULL)
						TAP_Hdd_Fread(thumbnail_bytes, sizeof(byte), (thumbnail_width * thumbnail_height), thumbnail_file);
				}
				else {
					thumbnail_bitmap = dlmalloc(sizeof(word) * thumbnail_width * thumbnail_height);
					if (thumbnail_bitmap != NULL)
						TAP_Hdd_Fread(thumbnail_bitmap, sizeof(word), (thumbnail_width * thumbnail_height), thumbnail_file);
				}
				TAP_Hdd_Fclose(thumbnail_file);

				random_position = getRandom();
				x_coord = (random_position % 16) % 4;
				y_coord = (random_position % 16) / 4;
				ss_offset_x = 53 + x_coord * (150+3);
				ss_offset_y = 45 + y_coord * (112+3);
				TAP_Osd_FillBox(region_mem, ss_offset_x, ss_offset_y, 150, 112, COLOR_Black);
				ss_offset_x += (150 - thumbnail_width) / 2;
				ss_offset_y += (112 - thumbnail_height) / 2;

				if (isGif(jpeg_files[current_jpeg]->file_name)) {
					setLut(jpeg_files[current_jpeg]->file_name);
					TAP_Osd_FillBox(region_mem, ss_offset_x-((150 - thumbnail_width) / 2), ss_offset_y-((112 - thumbnail_height) / 2), 150, 112, COLOR_Black);
					for (j = 0; j < thumbnail_height; j++) 
						for (i = 0; i < thumbnail_width; i++) 
							TAP_Osd_DrawPixmap(region_mem, ss_offset_x + i, ss_offset_y + j, 1, 1, &thumbnail_bytes[i + j * thumbnail_width], FALSE, OSD_256);
					dlfree(thumbnail_bytes);

					TAP_Osd_Copy(region_mem, region, 0, 0, 720, 576, 0, 0, FALSE); 
				}
				else {
#ifndef WIN32
					TAP_Osd_FillBox(region, ss_offset_x-((150 - thumbnail_width) / 2), ss_offset_y-((112 - thumbnail_height) / 2), 150, 112, COLOR_Black);
					TAP_Osd_DrawPixmap(region, ss_offset_x, ss_offset_y, thumbnail_width, thumbnail_height, thumbnail_bitmap, FALSE, OSD_1555); 
					dlfree(thumbnail_bitmap);
#endif 
#ifdef WIN32
					TAP_Osd_FillBox(region_mem, ss_offset_x-((150 - thumbnail_width) / 2), ss_offset_y-((112 - thumbnail_height) / 2), 150, 112, COLOR_Black);
					for (j = 0; j < thumbnail_height; j++) {
						for (i = 0; i < thumbnail_width; i++) {
							TAP_Osd_PutPixel(region_mem, ss_offset_x + i, ss_offset_y + j, thumbnail_bitmap[i + j * thumbnail_width]);
						}
					}
					dlfree(thumbnail_bitmap);

					TAP_Osd_Copy(region_mem, region, 0, 0, 720, 576, 0, 0, FALSE); 
#endif
				}
			}

			// back up from cache dir
			ChangeDir("..");
		}

		tick = TAP_GetTick();		
		current_jpeg = getNextJpeg(TRUE);
	}

	// if delay between images has elapsed, then flag to display next one
	if (TAP_GetTick() >= (tick + (screensaver_delay * 100)) && no_of_jpegs > 1)
	{
		if (!show_jpeg)
			if (write_log) if (verbose) logText("Show JPEG", FALSE);
		show_jpeg = TRUE;
	}
}

void processScreensaver2(void)
{
	int i, j;
	int cache_width, cache_height;
	word *cache_bitmap;
	byte *cache_bytes;

	TAP_ExitNormal();

	// attempt to draw a photo pixel by pixel
	if (show_jpeg)
	{
		TYPE_File *cache_file = NULL;

		show_jpeg = FALSE;

		ChangeDirPath(jpeg_files[current_jpeg]->directory);
		strcpy(file_name, jpeg_files[current_jpeg]->file_name);
		strcat(file_name, ".cache");

		// change to Cache directory
		createCacheDirectoryIfNotThere();
		ChangeDir("Cache");

		if (TAP_Hdd_Exist(file_name))
		{
			if (write_log) if (verbose) logText("Reading JPEG in from cache", FALSE);
			cache_file = TAP_Hdd_Fopen(file_name);
			if (cache_file != NULL)
			{
				int ss_offset_x, ss_offset_y;

				TAP_Hdd_Fread(&cache_width, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&cache_height, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, cache_file);
				if (isGif(jpeg_files[current_jpeg]->file_name)) {
					setLut(jpeg_files[current_jpeg]->file_name);
					cache_bytes = dlmalloc(sizeof(byte) * cache_width * cache_height);
					if (cache_bytes != NULL)
						TAP_Hdd_Fread(cache_bytes, sizeof(byte), (cache_width * cache_height), cache_file);
				}
				else {
					cache_bitmap = dlmalloc(sizeof(word) * cache_width * cache_height);
					if (cache_bitmap != NULL)
						TAP_Hdd_Fread(cache_bitmap, sizeof(word), (cache_width * cache_height), cache_file);
				}
				TAP_Hdd_Fclose(cache_file);

				ss_offset_x = (717 - cache_width) / 2;
				ss_offset_y = (539 - cache_height) / 2;
				TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
				reverse_screensaver = reverse_screensaver ? FALSE : TRUE;

				if (reverse_screensaver) {
					for (j = cache_height - 1; j >= 0; j--) {
						for (i = cache_width - 1; i >= 0; i--) {
							if (isGif(jpeg_files[current_jpeg]->file_name))
								TAP_Osd_DrawPixmap(region, ss_offset_x + i, ss_offset_y + j, 1, 1, &cache_bytes[i + j * cache_width], FALSE, OSD_256);
							else
								TAP_Osd_PutPixel(region, ss_offset_x + i, ss_offset_y + j, cache_bitmap[i + j * cache_width]);
						}
#ifndef WIN32
						TAP_Delay(1);
#endif
					}
				}
				else {
					for (j = 0; j < cache_height; j++) {
						for (i = 0; i < cache_width; i++) {
							if (isGif(jpeg_files[current_jpeg]->file_name))
								TAP_Osd_DrawPixmap(region, ss_offset_x + i, ss_offset_y + j, 1, 1, &cache_bytes[i + j * cache_width], FALSE, OSD_256);
							else
								TAP_Osd_PutPixel(region, ss_offset_x + i, ss_offset_y + j, cache_bitmap[i + j * cache_width]);
						}
#ifndef WIN32
						TAP_Delay(1);
#endif
					}
				}

				if (isGif(jpeg_files[current_jpeg]->file_name))
					dlfree(cache_bytes);
				else
					dlfree(cache_bitmap);

				dlmalloc_trim(0);
			}

			// back up from cache dir
			ChangeDir("..");
		}

		tick = TAP_GetTick();
		current_jpeg = getNextJpeg(TRUE);
	}

	// if delay between images has elapsed, then flag to display next one
	if (TAP_GetTick() >= (tick + (screensaver_delay * 100)) && no_of_jpegs > 1)
	{
		if (!show_jpeg)
			if (write_log) if (verbose) logText("Show JPEG", FALSE);
		show_jpeg = TRUE;
	}
}

void processScreensaver3(void)
{
	int i, j, yy;
	int cache_width, cache_height, display_width, display_height;
	word *cache_bitmap;
	word *cache_bytes;

	TAP_ExitNormal();

	// attempt to draw a photo which gradually gets larger
	if (enlarge_jpeg)
	{
		TYPE_File *cache_file = NULL;

		enlarge_jpeg = FALSE;

		ChangeDirPath(jpeg_files[current_jpeg]->directory);
		strcpy(file_name, jpeg_files[current_jpeg]->file_name);
		strcat(file_name, ".cache");

		// change to Cache directory
		createCacheDirectoryIfNotThere();
		ChangeDir("Cache");

		if (TAP_Hdd_Exist(file_name))
		{
			if (write_log) if (verbose) logText("Reading JPEG in from cache", FALSE);
			cache_file = TAP_Hdd_Fopen(file_name);
			if (cache_file != NULL)
			{
				int ss_offset_x, ss_offset_y;

				// read in the cached photo
				TAP_Hdd_Fread(&cache_width, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&cache_height, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, cache_file);
				if (isGif(jpeg_files[current_jpeg]->file_name)) {
					setLut(jpeg_files[current_jpeg]->file_name);
					cache_bytes = dlmalloc(sizeof(byte) * cache_width * cache_height);
					if (cache_bytes != NULL)
						TAP_Hdd_Fread(cache_bytes, sizeof(byte), (cache_width * cache_height), cache_file);
				}
				else {
					cache_bitmap = dlmalloc(sizeof(word) * cache_width * cache_height);
					if (cache_bitmap != NULL)
						TAP_Hdd_Fread(cache_bitmap, sizeof(word), (cache_width * cache_height), cache_file);
				}
				TAP_Hdd_Fclose(cache_file);

				// before first display of this photo, blank the OSD, and reset reverse flag
				if ((reverse_screensaver && shrink_factor > 10) || (!reverse_screensaver && shrink_factor < 1)) {
					TAP_Osd_FillBox(region_mem, 0, 0, 720, 576, COLOR_Black);
					reverse_screensaver = reverse_screensaver ? FALSE : TRUE;
					shrink_factor = reverse_screensaver ? 1 : 10;
				}

				// calculate the current dimensions
				display_width = cache_width / shrink_factor;				
				display_height = cache_height / shrink_factor;				
				ss_offset_x = (717 - display_width) / 2;
				ss_offset_y = (539 - display_height) / 2;
				
				if (shrink_factor == 1) {
					// delay before the full display, otherwise it is too quick
#ifndef WIN32
					TAP_Delay(40);
					
					if (isGif(jpeg_files[current_jpeg]->file_name))
						TAP_Osd_DrawPixmap(region_mem, ss_offset_x, ss_offset_y, cache_width, cache_height, cache_bytes, FALSE, OSD_256);
					else
						TAP_Osd_DrawPixmap(region_mem, ss_offset_x, ss_offset_y, cache_width, cache_height, cache_bitmap, FALSE, OSD_1555);
#endif
				} 
				else {
					// draw intermediate size photo to OSD
					if (reverse_screensaver) TAP_Osd_FillBox(region_mem, 0, 0, 720, 576, COLOR_Black);
					for (j = 0; j < display_height; j++) {
						yy = (j*cache_height/display_height)*cache_width;
						for (i = 0; i < display_width; i++) {
							if (isGif(jpeg_files[current_jpeg]->file_name))
								TAP_Osd_DrawPixmap(region_mem, ss_offset_x + i, ss_offset_y + j, 1, 1, &cache_bytes[yy + i * cache_width / display_width], FALSE, OSD_256);
							else
								TAP_Osd_PutPixel(region_mem, ss_offset_x + i, ss_offset_y + j, cache_bitmap[yy + i * cache_width / display_width]);
						}
					}
				}
				TAP_Osd_Copy(region_mem, region, 0, 0, 720, 576, 0, 0, FALSE); 

				// need to put in another display between full and half size
				if ((reverse_screensaver && shrink_factor == 1) || (!reverse_screensaver && shrink_factor == 2)) {
#ifndef WIN32
					TAP_Delay(50);
#endif
					if (reverse_screensaver) {
						display_width -= display_width / 4;				
						display_height -= display_height / 4;				
						TAP_Osd_FillBox(region_mem, 0, 0, 720, 576, COLOR_Black);
					}
					else {
						display_width += display_width / 2;				
						display_height += display_height / 2;			
					}
					ss_offset_x = (717 - display_width) / 2;
					ss_offset_y = (539 - display_height) / 2;
					for (j = 0; j < display_height; j++) {
						yy = (j*cache_height/display_height)*cache_width;
						for (i = 0; i < display_width; i++) {
							if (isGif(jpeg_files[current_jpeg]->file_name))
								TAP_Osd_DrawPixmap(region_mem, ss_offset_x + i, ss_offset_y + j, 1, 1, &cache_bytes[yy + i * cache_width / display_width], FALSE, OSD_256);
							else
								TAP_Osd_PutPixel(region_mem, ss_offset_x + i, ss_offset_y + j, cache_bitmap[yy + i * cache_width / display_width]);
						}
					}
					TAP_Osd_Copy(region_mem, region, 0, 0, 720, 576, 0, 0, FALSE); 
				}
				
				shrink_factor = reverse_screensaver ? shrink_factor + 1 : shrink_factor - 1;

				if (isGif(jpeg_files[current_jpeg]->file_name))
					dlfree(cache_bytes);
				else
					dlfree(cache_bitmap);

				dlmalloc_trim(0);
			}

			// back up from cache dir
			ChangeDir("..");
		}

		tick = TAP_GetTick();		

		// when we have finished with this photo, reset the shrink factor and get next photo
		if (cache_file == NULL || shrink_factor < 1 || shrink_factor > 10) {
			current_jpeg = getNextJpeg(TRUE);
		}
	}

	// if delay between enlargements has elapsed, then flag to enlarge
	if (TAP_GetTick() >= (tick + (screensaver_delay * 50)))
	{
		if (!enlarge_jpeg)
			if (write_log) if (verbose) logText("Enlarge JPEG", FALSE);
		enlarge_jpeg = TRUE;
	}
}

void processScreensaver4(void)
{
	#define TOP 0
	#define RIGHT 1
	#define BOTTOM 2
	#define LEFT 3
	int i, j;
	int cache_width, cache_height;
	word *cache_bitmap;
	word *cache_bytes;
	
	TAP_ExitNormal();

	// attempt to draw a thumbnail pixel by pixel
	if (show_jpeg)
	{
		TYPE_File *cache_file = NULL;

		show_jpeg = FALSE;

		ChangeDirPath(jpeg_files[current_jpeg]->directory);
		strcpy(file_name, jpeg_files[current_jpeg]->file_name);
		strcat(file_name, ".cache");

		// change to Cache directory
		createCacheDirectoryIfNotThere();
		ChangeDir("Cache");

		if (TAP_Hdd_Exist(file_name))
		{
			word side, top_offset, bottom_offset, left_offset, right_offset;

			if (write_log) if (verbose) logText("Reading JPEG in from cache", FALSE);
			cache_file = TAP_Hdd_Fopen(file_name);
			if (cache_file != NULL)
			{
				int ss_offset_x, ss_offset_y;

				TAP_Hdd_Fread(&cache_width, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&cache_height, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, cache_file);
				if (isGif(jpeg_files[current_jpeg]->file_name)) {
					setLut(jpeg_files[current_jpeg]->file_name);
					cache_bytes = dlmalloc(sizeof(byte) * cache_width * cache_height);
					if (cache_bytes != NULL)
						TAP_Hdd_Fread(cache_bytes, sizeof(byte), (cache_width * cache_height), cache_file);
				}
				else {
					cache_bitmap = dlmalloc(sizeof(word) * cache_width * cache_height);
					if (cache_bitmap != NULL)
						TAP_Hdd_Fread(cache_bitmap, sizeof(word), (cache_width * cache_height), cache_file);
				}
				TAP_Hdd_Fclose(cache_file);

				ss_offset_x = (717 - cache_width) / 2;
				ss_offset_y = (539 - cache_height) / 2;
				TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
				reverse_screensaver = reverse_screensaver ? FALSE : TRUE;

				if (reverse_screensaver) {
					side = TOP;
					top_offset = (cache_height / 2) + 1; bottom_offset = (cache_height / 2) - 1;	
					left_offset = top_offset; right_offset = cache_width - top_offset;
					while (TRUE) {
						switch (side) {
							case TOP:
								for (i = left_offset+1; i < right_offset; i++) {
									if (isGif(jpeg_files[current_jpeg]->file_name))
										TAP_Osd_DrawPixmap(region, ss_offset_x + i, ss_offset_y + top_offset, 1, 1, &cache_bytes[i + top_offset * cache_width], FALSE, OSD_256);
									else
										TAP_Osd_PutPixel(region, ss_offset_x + i, ss_offset_y + top_offset, cache_bitmap[i + top_offset * cache_width]);
								}
								top_offset--;
								break;
							case BOTTOM:
								for (i = left_offset+1; i < right_offset; i++) {
									if (isGif(jpeg_files[current_jpeg]->file_name))
										TAP_Osd_DrawPixmap(region, ss_offset_x + i, ss_offset_y + bottom_offset, 1, 1, &cache_bytes[i + bottom_offset * cache_width], FALSE, OSD_256);
									else
										TAP_Osd_PutPixel(region, ss_offset_x + i, ss_offset_y + bottom_offset, cache_bitmap[i + bottom_offset * cache_width]);
								}
								bottom_offset++;
								break;
							case LEFT:
								for (j = top_offset+1; j < bottom_offset; j++) {
									if (isGif(jpeg_files[current_jpeg]->file_name))
										TAP_Osd_DrawPixmap(region, ss_offset_x + left_offset, ss_offset_y + j, 1, 1, &cache_bytes[left_offset + j * cache_width], FALSE, OSD_256);
									else
										TAP_Osd_PutPixel(region, ss_offset_x + left_offset, ss_offset_y + j, cache_bitmap[left_offset + j * cache_width]);
								}
								left_offset--;
								break;
							case RIGHT:
								for (j = top_offset+1; j < bottom_offset; j++) {
									if (isGif(jpeg_files[current_jpeg]->file_name))
										TAP_Osd_DrawPixmap(region, ss_offset_x + right_offset, ss_offset_y + j, 1, 1, &cache_bytes[right_offset + j * cache_width], FALSE, OSD_256);
									else
										TAP_Osd_PutPixel(region, ss_offset_x + right_offset, ss_offset_y + j, cache_bitmap[right_offset + j * cache_width]);
								}
								right_offset++;
								break;
						}
#ifndef WIN32
						TAP_Delay(1);
#endif

						// break out of the loop when we have finished the photo
						if (top_offset == 0 || left_offset == 0)
							break;

						// set next side to draw
						side = (side + 1) % 4;
					}
				}
				else {
					side = TOP;
					top_offset = 0; left_offset = 0;
					bottom_offset = cache_height - 1;
					right_offset = cache_width - 1;
					while (TRUE) {
						switch (side) {
							case TOP:
								for (i = left_offset; i < right_offset+1; i++) {
									if (isGif(jpeg_files[current_jpeg]->file_name))
										TAP_Osd_DrawPixmap(region, ss_offset_x + i, ss_offset_y + top_offset, 1, 1, &cache_bytes[i + top_offset * cache_width], FALSE, OSD_256);
									else
										TAP_Osd_PutPixel(region, ss_offset_x + i, ss_offset_y + top_offset, cache_bitmap[i + top_offset * cache_width]);
								}
								top_offset++;
								break;
							case BOTTOM:
								for (i = left_offset; i < right_offset+1; i++) {
									if (isGif(jpeg_files[current_jpeg]->file_name))
										TAP_Osd_DrawPixmap(region, ss_offset_x + i, ss_offset_y + bottom_offset, 1, 1, &cache_bytes[i + bottom_offset * cache_width], FALSE, OSD_256);
									else
										TAP_Osd_PutPixel(region, ss_offset_x + i, ss_offset_y + bottom_offset, cache_bitmap[i + bottom_offset * cache_width]);
								}
								bottom_offset--;
								break;
							case LEFT:
								for (j = top_offset; j < bottom_offset+1; j++) {
									if (isGif(jpeg_files[current_jpeg]->file_name))
										TAP_Osd_DrawPixmap(region, ss_offset_x + left_offset, ss_offset_y + j, 1, 1, &cache_bytes[left_offset + j * cache_width], FALSE, OSD_256);
									else
										TAP_Osd_PutPixel(region, ss_offset_x + left_offset, ss_offset_y + j, cache_bitmap[left_offset + j * cache_width]);
								}
								left_offset++;
								break;
							case RIGHT:
								for (j = top_offset; j < bottom_offset+1; j++) {
									if (isGif(jpeg_files[current_jpeg]->file_name))
										TAP_Osd_DrawPixmap(region, ss_offset_x + right_offset, ss_offset_y + j, 1, 1, &cache_bytes[right_offset + j * cache_width], FALSE, OSD_256);
									else
										TAP_Osd_PutPixel(region, ss_offset_x + right_offset, ss_offset_y + j, cache_bitmap[right_offset + j * cache_width]);
								}
								right_offset--;
								break;
						}
#ifndef WIN32
						TAP_Delay(1);
#endif
						// break out of the loop when we have finished the photo
						if (top_offset > (cache_height / 2) || left_offset > (cache_width / 2))
							break;

						// set next side to draw
						side = (side + 1) % 4;
					}
				}

				if (isGif(jpeg_files[current_jpeg]->file_name))
					dlfree(cache_bytes);
				else
					dlfree(cache_bitmap);

				dlmalloc_trim(0);
			}

			// back up from cache dir
			ChangeDir("..");
		}

		tick = TAP_GetTick();
		current_jpeg = getNextJpeg(TRUE);
	}

	// if delay between images has elapsed, then flag to display next one
	if (TAP_GetTick() >= (tick + (screensaver_delay * 100)) && no_of_jpegs > 1)
	{
		if (!show_jpeg)
			if (write_log) if (verbose) logText("Show JPEG", FALSE);
		show_jpeg = TRUE;
	}
}

bool puzzlePieceExists(int puzzle_piece_number)
{
	int i;
	for (i = 0; i < 16; i++) {
		if (puzzle_history[i] == puzzle_piece_number)
			return TRUE;
	}

	return FALSE;
}

void savePuzzleHistory(int puzzle_piece_number)
{
	int i;
	for (i = 16-1; i > 0; i--)
		puzzle_history[i] = puzzle_history[i-1];

	puzzle_history[0] = puzzle_piece_number;
}

void processScreensaver5(void)
{
	int i, j;
	int cache_width, cache_height;
	int ss_offset_x, ss_offset_y, x_coord, y_coord, puzzle_piece_width, puzzle_piece_height, cache_offset_x, cache_offset_y;
	dword random_position;
	word *cache_bitmap;
	word *cache_bytes;
	
	TAP_ExitNormal();

	// attempt to draw a thumbnail pixel by pixel
	if (puzzle_jpeg)
	{
		TYPE_File *cache_file = NULL;

		puzzle_jpeg = FALSE;

		// before first display of this photo, blank the OSD, and reset the puzzle history
		if (puzzle_counter == 0) {
			TAP_Osd_FillBox(region_mem, 0, 0, 720, 576, COLOR_Black);
			cache_bitmap = NULL;
			for (i = 0; i < 16; i++) 
				puzzle_history[i] = -1;
			TAP_Delay(100);
		}

		ChangeDirPath(jpeg_files[current_jpeg]->directory);
		strcpy(file_name, jpeg_files[current_jpeg]->file_name);
		strcat(file_name, ".cache");

		// change to Cache directory
		createCacheDirectoryIfNotThere();
		ChangeDir("Cache");

		if (TAP_Hdd_Exist(file_name))
		{
			if (write_log) if (verbose) logText("Reading JPEG in from cache", FALSE);
			cache_file = TAP_Hdd_Fopen(file_name);
			if (cache_file != NULL)
			{
				TAP_Hdd_Fread(&cache_width, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&cache_height, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, cache_file);
				TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, cache_file);
				if (isGif(jpeg_files[current_jpeg]->file_name)) {
					setLut(jpeg_files[current_jpeg]->file_name);
					cache_bytes = dlmalloc(sizeof(byte) * cache_width * cache_height);
					if (cache_bytes != NULL)
						TAP_Hdd_Fread(cache_bytes, sizeof(byte), (cache_width * cache_height), cache_file);
				}
				else {
					cache_bitmap = dlmalloc(sizeof(word) * cache_width * cache_height);
					if (cache_bitmap != NULL)
						TAP_Hdd_Fread(cache_bitmap, sizeof(word), (cache_width * cache_height), cache_file);
				}
				TAP_Hdd_Fclose(cache_file);

				puzzle_piece_width = cache_width / 4;
				puzzle_piece_height = cache_height / 4;
			}
		}

		// back up from cache dir
		ChangeDir("..");

		if (cache_bitmap != NULL) {
			// set up the coordinates to draw this piece of the puzzle at
			random_position = getRandom() % 16;
			while (puzzlePieceExists(random_position))
				random_position = getRandom() % 16;
			x_coord = (random_position) % 4;
			y_coord = (random_position) / 4;
			ss_offset_x = ((717 - cache_width) / 2) + x_coord * puzzle_piece_width;
			ss_offset_y = ((539 - cache_height) / 2) + y_coord * puzzle_piece_height;
			cache_offset_x = x_coord * puzzle_piece_width;
			cache_offset_y = y_coord * puzzle_piece_height;

			TAP_Osd_FillBox(region_mem, ss_offset_x, ss_offset_y, puzzle_piece_width, puzzle_piece_height, COLOR_Black);
			for (j = 0; j < puzzle_piece_height; j++) {
				for (i = 0; i < puzzle_piece_width; i++) {
					if (isGif(jpeg_files[current_jpeg]->file_name))
						TAP_Osd_DrawPixmap(region_mem, ss_offset_x + i, ss_offset_y + j, 1, 1, &cache_bytes[(cache_offset_x + i) + (cache_offset_y + j) * cache_width], FALSE, OSD_256);
					else
						TAP_Osd_PutPixel(region_mem, ss_offset_x + i, ss_offset_y + j, cache_bitmap[(cache_offset_x + i) + (cache_offset_y + j) * cache_width]);
				}
			}

			TAP_Osd_Copy(region_mem, region, 0, 0, 720, 576, 0, 0, FALSE); 

			savePuzzleHistory(random_position);
			puzzle_counter++;

			if (isGif(jpeg_files[current_jpeg]->file_name)) {
				dlfree(cache_bytes);
				cache_bytes = NULL;
			}
			else {
				dlfree(cache_bitmap);
				cache_bitmap = NULL;
			}

			dlmalloc_trim(0);
		}

		tick = TAP_GetTick();

		// when we have finished with this puzzle, reset the puzzle counter and get the next photo
		if (cache_file == NULL || puzzle_counter == 16) {
			current_jpeg = getNextJpeg(TRUE);
			puzzle_counter = 0;
		}
	}

	// if delay between images has elapsed, then flag to display next one
	if (TAP_GetTick() >= (tick + (screensaver_delay * 50)))
	{
		if (!puzzle_jpeg)
			if (write_log) if (verbose) logText("Puzzle JPEG", FALSE);
		puzzle_jpeg = TRUE;
	}
}

void processScreensaver()
{
	if (!screensaver_started)
		return;

	// after switching aspect ratio, wait 2 secs before starting screensaver
	if (idle_before_photo_display) {
		if (TAP_GetTick() < (tick_draw_photo + 200))
			return;

		if (play_mp3) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play MP3 %s after 2 secs", mp3_files[current_mp3]->file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			ChangeDirPath(mp3_files[current_mp3]->directory);
			playMp3(mp3_files[current_mp3]->file_name);
			play_mp3 = FALSE;
		}

		TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
		idle_before_photo_display = FALSE;
	}

	switch (photo_mode) {
		case SCREENSAVER1:
			processScreensaver1();
			break;
		case SCREENSAVER2:
			processScreensaver2();
			break;
		case SCREENSAVER3:
			processScreensaver3();
			break;
		case SCREENSAVER4:
			processScreensaver4();
			break;
		case SCREENSAVER5:
			processScreensaver5();
			break;
	}
}

void processDrawSuccessfulJpeg()
{
	int width, height, actual_offset_x, actual_offset_y, xl, yl;
	bool drawn_ok;

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Displaying photo %s", jpeg_files[current_jpeg]->file_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	
	show_jpeg = FALSE;
	force_display = FALSE;
	drawing_jpeg = TRUE;

	if (draw_from_cache || (isJpg(jpeg_files[current_jpeg]->file_name))) {
		width = cached_width, height = cached_height;
	}
	else {
		width = bitmap_width, height = bitmap_height;
	}

	if (rotated_degrees == 90 || rotated_degrees == 270)
		getDrawDimensionsAndOffset(width, height, &xl, &yl, &actual_offset_x, &actual_offset_y, widescreen_adjustment_factor, FALSE, FALSE, TRUE, full_size_display, album_art_started, FALSE);
	else
		getDrawDimensionsAndOffset(width, height, &xl, &yl, &actual_offset_x, &actual_offset_y, widescreen_adjustment_factor, FALSE, FALSE, FALSE, full_size_display, album_art_started, FALSE);
	if (!full_size_display) {actual_offset_x += offset_x; actual_offset_y += offset_y;}

	// draw the JPEG into memory
	if (isGif(jpeg_files[current_jpeg]->file_name))
		drawn_ok = drawGIF(jpeg_data, width, height, actual_offset_x, actual_offset_y, xl, yl);
	else
		drawn_ok = drawJPEG(jpeg_bitmap, width, height, actual_offset_x, actual_offset_y, xl, yl);

	if (!full_size_display) 
		drawPhotoViewer(drawn_ok ? JPEG_SUCCESS : JPEG_NO_MEMORY);

#ifdef WIN32
	if (full_size_display) 
		TAP_Osd_Copy(region_mem, region, 0, 0, 720, 576, 0, 0, FALSE);
	else
		TAP_Osd_Copy(region_mem, region, offset_x, offset_y, 600, 450, offset_x, offset_y, FALSE);
#endif
	
	previous_jpeg = current_jpeg;
	current_jpeg = getNextJpeg(TRUE);

	// free all relevant memory
	freeMemory();
	
	// reset counter so that next image is displayed in x secs
	tick = TAP_GetTick();

	drawing_jpeg = FALSE;
}

void processDrawFailedJpeg()
{
	// stop the next from being processed until we have displayed our message screen
	show_jpeg = FALSE;
	drawing_jpeg = TRUE;
	force_display = FALSE;
	jpeg_failed = FALSE;

	TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
	drawPhotoViewer(jpeg_data == NULL ? JPEG_NO_LOAD : JPEG_NO_DECODE);

	previous_jpeg = current_jpeg;
	current_jpeg = getNextJpeg(TRUE);
	
	freeMemory();

	// reset counter so that next image is displayed in x secs
	tick = TAP_GetTick();

	drawing_jpeg = FALSE;
}

void fadeImage()
{
#ifndef WIN32
	int transparency;

	if (apply_fade_image && !album_art_started) {
		switch (fade_state) {
			case SHOW_PLANE1: 
				TAP_Osd_Delete(region_2);
				region_2 = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_Plane2);
				region = region_2;
				region_now = region_1;
				fade_state = FADE_TO_PLANE2; 
				break; 

			case FADE_TO_PLANE2:
				transparency = 255;
	
				while (transparency > 0) {
					transparency -= 3;
					TAP_Osd_SetTransparency(region_1, transparency);
					TAP_Delay(1);
				}

				region = region_1;
				region_now = region_2;
				fade_state = FADE_TO_PLANE1; 
				break;
			case FADE_TO_PLANE1: 
				transparency = 0;

				while (transparency < 255) {
					transparency += 3;
					TAP_Osd_SetTransparency(region_1, transparency);
					TAP_Delay(1);
				}

				TAP_Osd_Delete(region_2);
				region_2 = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_Plane2);
				region = region_2;
				region_now = region_1;
				fade_state = FADE_TO_PLANE2; 
				break;
		}
	}
#endif
}

void processDrawJpeg()
{
	if (show_jpeg && !drawing_jpeg && (!slideshow_paused || force_display)) {

		// draw image or message (it may not have decoded)
		if (jpeg_bitmap == NULL && jpeg_failed) {
			processDrawFailedJpeg();
		}
		ef (jpeg_bitmap != NULL && !jpeg_failed) {
			processDrawSuccessfulJpeg();
		}

		// fade to image if so configured
		fadeImage();
	}
}

void processBatchCache()
{
	if (jpeg_bitmap != NULL || jpeg_failed) {
		if (jpeg_bitmap != NULL)
		{
			if (isGif(jpeg_files[current_jpeg]->file_name))
				cacheGIF(jpeg_data);
			else 
				cacheJPEG(jpeg_bitmap);
		}

		jpeg_failed = FALSE;
	}

	previous_jpeg = current_jpeg;
	current_jpeg++;

	freeMemory();
}

void loadAndDecodeJpeg()
{
	// attempt to load and decode JPEG
	if (jpeg_data == NULL && !jpeg_failed && no_of_jpegs > 0)
	{
		TYPE_File	*loaded_file;
		struct _dimensions *dims;

		ChangeDirPath(jpeg_files[current_jpeg]->directory);
		strcpy(file_name, jpeg_files[current_jpeg]->file_name);
		strcat(file_name, ".cache");

		// change to Cache directory
		createCacheDirectoryIfNotThere();
		ChangeDir("Cache");

		if (TAP_Hdd_Exist(file_name))
		{
			// if batch job, then stop here as it is already cached
			if (batch_job_started) {
				ChangeDir(".."); 
				memory_delay = 0;
				return;
			}
				
			logMemory("Before loading from cache", FALSE);

			if (write_log) if (verbose) logText("Reading JPEG in from cache", FALSE);
			loaded_file = TAP_Hdd_Fopen(file_name);
			if (loaded_file != NULL)
			{
				dword cache_size = TAP_Hdd_Flen(loaded_file);
				TAP_Hdd_Fread(&cached_width, sizeof(int), 1, loaded_file);
				TAP_Hdd_Fread(&cached_height, sizeof(int), 1, loaded_file);
				TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, loaded_file);
				TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, loaded_file);
				if (isGif(jpeg_files[current_jpeg]->file_name)) {
					jpeg_data = dlmalloc(sizeof(byte) * cached_width * cached_height);
					if (jpeg_data != NULL)
						TAP_Hdd_Fread(jpeg_data, sizeof(byte), (cached_width * cached_height), loaded_file);
					else
						jpeg_failed = TRUE;
					TAP_Hdd_Fclose(loaded_file);
					jpeg_bitmap = dummy_bitmap;
				}
				else {
					jpeg_bitmap = dlmalloc(sizeof(word) * cached_width * cached_height);
					if (jpeg_bitmap != NULL)
						TAP_Hdd_Fread(jpeg_bitmap, sizeof(word), (cached_width * cached_height), loaded_file);
					else
						jpeg_failed = TRUE;
					TAP_Hdd_Fclose(loaded_file);
					jpeg_data = dummy_data;
				}
				draw_from_cache = TRUE;
			}
			else
			{
				jpeg_failed = TRUE;
			}

			logMemory("After loading from cache", TRUE);

			// back up from cache dir
			ChangeDir(".."); 

			if ((slideshow_started || batch_job_started) && memory_delay != 2) {
				memory_delay = 2;
			} 
		}
		else
		{
			// back up from cache dir
			ChangeDir("..");

			logMemory("Before load", FALSE);

			// attempt to load raw JPEG data
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Attempting to load photo %s", jpeg_files[current_jpeg]->file_name);
			if (write_log) if (verbose) logText(log_buffer, TRUE);
			
			if (isBmp(jpeg_files[current_jpeg]->file_name))
				jpeg_data = dummy_data;
			ef (isGif(jpeg_files[current_jpeg]->file_name)) {
				jpeg_data = LoadGifDirect(jpeg_files[current_jpeg]->file_name, &bitmap_width, &bitmap_height);
				jpeg_bitmap = dummy_bitmap;
			}
			else
				jpeg_data = load_jpg_wembley_style(jpeg_files[current_jpeg]->file_name, NULL, 0, &bitmap_width, &bitmap_height);

			draw_from_cache = FALSE;

			if ((slideshow_started || batch_job_started) && memory_delay != 6) {
				memory_delay = 6;
			}
		}

		// if JPEG cannot be read, then probably not enough memory
		if (jpeg_data == NULL && !draw_from_cache)
		{
			if (write_log) TAP_SPrint(log_buffer, "Load of %s failed", jpeg_files[current_jpeg]->file_name);
			if (write_log) logText(log_buffer, FALSE);
			jpeg_failed = TRUE;
		}
		else
		{
			if (!draw_from_cache && jpeg_bitmap == NULL)
			{
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Load of %s successful", jpeg_files[current_jpeg]->file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				logMemory("After load", FALSE);

				// decode raw JPEG stream
				if (isBmp(jpeg_files[current_jpeg]->file_name))
					jpeg_bitmap = loadAndDecodeBitmap(jpeg_files[current_jpeg]->file_name, &bitmap_width, &bitmap_height);
				else
					jpeg_bitmap = decode_jpg_wembley_style(jpeg_data, &cached_width, &cached_height, 0);
			}

			// if JPEG cannot be decoded, then output error
			if (jpeg_bitmap == NULL)
			{
				if (write_log) TAP_SPrint(log_buffer, "Decode of %s failed", jpeg_files[current_jpeg]->file_name);
				if (write_log) logText(log_buffer, FALSE);
				jpeg_failed = TRUE;
			}
			else
			{
				if (!draw_from_cache) {
					if (write_log) TAP_SPrint(log_buffer, "Decode of %s successful", jpeg_files[current_jpeg]->file_name);
					if (write_log) logText(log_buffer, FALSE);
					logMemory("After load", FALSE);
				}
			}
		}

		// load and add dimension details if not there, also set rotation
		loadDimensions();
		dims = getDimensions(jpeg_files[current_jpeg]->file_name);
			
		if (dims != NULL) {
			rotated_degrees = dims->rotation * 90;
		}
		else {
			dimensions[no_of_dimensions] = dlmalloc(sizeof(*dimensions[no_of_dimensions]));
			strcpy(dimensions[no_of_dimensions]->file_name, jpeg_files[current_jpeg]->file_name);
			dimensions[no_of_dimensions]->width = bitmap_width;
			dimensions[no_of_dimensions]->height = bitmap_height;
			dimensions[no_of_dimensions]->rotation = rotated_degrees = 0;
			no_of_dimensions++;
			saveDimensions();
		}
		
	}
}

// after switching aspect ratio, wait 2 secs before starting slideshow
bool handleIdleBeforePhotoDisplay()
{
	if (idle_before_photo_display) {
		if (TAP_GetTick() < (tick_draw_photo + 200))
			return TRUE;

		if (play_mp3) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play MP3 %s after 2 secs", mp3_files[current_mp3]->file_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			ChangeDirPath(mp3_files[current_mp3]->directory);
			playMp3(mp3_files[current_mp3]->file_name);
			play_mp3 = FALSE;
		}

		idle_before_photo_display = FALSE;
	}

	return FALSE;
}

// handle all aspects of slideshow, batch caching job or album art display
void processJPEG(bool album_art)
{
	// nothing to do if not slideshow, batch job or album art to display
	if (!slideshow_started && !batch_job_started && !album_art)
		return;

	// handle any potential delay for aspect switching
	if (slideshow_started)
		if (handleIdleBeforePhotoDisplay()) return;

	// this may be true if in album art mode, so want to show photo viewer
	if (no_of_jpegs == 0)
		jpeg_failed = TRUE;

	if (memory_delay_elapsed) {

		// load and decode jpeg if not already done
		loadAndDecodeJpeg();

		// process batch job caching, or draw image
		if (batch_job_started)
			processBatchCache();
		else
			processDrawJpeg();
	}

	// if delay between images has elapsed, then flag to display next image
	if (slideshow_started && (TAP_GetTick() >= (tick + ((slideshow_delay - 1) * 100))) && no_of_jpegs > 1) {
		if (!show_jpeg)	if (write_log) if (verbose) logText("Show JPEG", FALSE);
		show_jpeg = TRUE;
	}

	// if delay to free memory has elapsed, then flag ok to process next image
	if (TAP_GetTick() >= (tick_one_sec + (memory_delay * 100))) {
		if (!memory_delay_elapsed) {
			if (write_log) TAP_SPrint(log_buffer, "Memory delay of %d secs elapsed", memory_delay);
			if (write_log) logText(log_buffer, FALSE);
			logMemory("After memory delay", FALSE);
		}
		memory_delay_elapsed = TRUE;
	}
}

void switchAspectRatio()
{
#ifndef WIN32
	TAP_EnterNormal();
	TAP_Osd_SetTransparency(region, 255);
	toppy_tv_ratio = (*TAP_GetSystemVar)(SYSVAR_TvRatio);
	toppy_tv_format = (*TAP_GetSystemVar)(SYSVAR_16_9_Display);
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Current aspect is %d", toppy_tv_ratio);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	switch (photo_aspect_ratio) {
		case NO_ASPECT_RATIO_SWITCH: 
			break;
		case SWITCH_TO_4_3_CENTER:	
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Switch to %d", SWITCH_TO_4_3_CENTER);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			(*TAP_SetSystemVar)(SYSVAR_TvRatio, SCREEN_RATIO_4_3); 
			(*TAP_SetSystemVar)(SYSVAR_16_9_Display, DISPLAY_MODE_CenterExtract); 
			idle_before_photo_display = TRUE;
			tick_draw_photo = TAP_GetTick();
			break;
		case SWITCH_TO_4_3_LETTER:	
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Switch to %d", SWITCH_TO_4_3_LETTER);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			(*TAP_SetSystemVar)(SYSVAR_TvRatio, SCREEN_RATIO_4_3); 
			(*TAP_SetSystemVar)(SYSVAR_16_9_Display, DISPLAY_MODE_LetterBox);
			idle_before_photo_display = TRUE;
			tick_draw_photo = TAP_GetTick();
			break;
		case SWITCH_TO_16_9: 
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Switch to %d", SCREEN_RATIO_16_9);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			(*TAP_SetSystemVar)(SYSVAR_TvRatio, SCREEN_RATIO_16_9);
			idle_before_photo_display = TRUE;
			tick_draw_photo = TAP_GetTick();
			break;
	}
	TAP_ExitNormal();
#endif
}

void startBlankScreen(bool mp3)
{
	if (write_log) if (verbose) logText("Start Blank screen", FALSE);
	recreateWindow();
	TAP_Osd_SetTransparency(region, 255);

	blank_screen_started = TRUE;

	if (!mp3 || mp3_playing)
		TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
}

void startCompactMode(bool mp3)
{
	if (write_log) if (verbose) logText("Start Compact mode", FALSE);
	recreateWindow();
	TAP_Osd_SetTransparency(region, 255);
	
	compact_mode_started = TRUE;
	compact_art_mode = (mp3 && mp3_mode == COMPACT_ART) ? TRUE : FALSE;
	compact_tv_mode = ((mp3 && mp3_mode == COMPACT_TV) || (!mp3 && radio_mode == COMPACT_TV)) ? TRUE : FALSE;
	burnout_tick = TAP_GetTick();
	compact_offset_x = (compact_art_mode || compact_tv_mode) ? 120 : 190; compact_offset_y = (compact_art_mode || compact_tv_mode) ? 150 : 190;

	if (!mp3 || mp3_playing) {
		refreshCompactMode(mp3);
		if (compact_help_displayed)
			refreshCompactModeHelp(mp3);
	}
}

void startAlbumArt()
{
	if (write_log) if (verbose) logText("Start Album art", FALSE);
	recreateWindow();

	switchAspectRatio();

	album_art_started = TRUE;
	saved_fsd = full_size_display;

	if (!idle_before_photo_display && mp3_playing)
		refreshAlbumArt();
}

void startScreensaver(bool switching)
{
	if (no_of_jpegs == 0)
        return;

	if (write_log) if (verbose) logText("Start screensaver", FALSE);

	TAP_ExitNormal();
		
    if (screensaver_started == TRUE)
        return;
    
    screensaver_started = TRUE;

	// create osd region
    region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
	region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
	
	if (!switching) switchAspectRatio();
	
	shrink_factor = 11;
	puzzle_counter = 0;
	enlarge_jpeg = TRUE;
	puzzle_jpeg = TRUE;
	reverse_screensaver = TRUE;
	current_jpeg = getNextJpeg(TRUE);
	show_jpeg = TRUE;
	tick = TAP_GetTick();

	if (!idle_before_photo_display)
		TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
}

void startSlideshow()
{
	TYPE_OsdBaseInfo osd_base_info_plane2;

	if (no_of_jpegs == 0)
        return;

	if (write_log) if (verbose) logText("Start slideshow", FALSE);
	
    if (slideshow_started == TRUE)
        return;
    
	slideshow_started = TRUE;
	jpeg_failed = FALSE;
	photo_mode = OFF;
	fade_state = SHOW_PLANE1;
	apply_fade_image = fade_image;
	memory_delay = 2;

	if (fade_image) {
#ifndef WIN32
		if (firmware_hacks_enabled && isTF5800()) {
			//toppy_mheg_status = exTAP_MHEG_Status();
			toppy_mheg_status = InteractiveGetStatus();
			if (write_log) TAP_SPrint(log_buffer, "MHEG status is %d", toppy_mheg_status);
			if (write_log) logText(log_buffer, FALSE);
			if (toppy_mheg_status > 0) {
				if (write_log) logText("Disable MHEG", FALSE);
				//exTAP_MHEG_Disable(TRUE);
				InteractiveSetStatus(TRUE);
			}
		}
#endif
		// create osd region in plane 2, and check it has been created as 16-bit
		region_2 = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_Plane2);

		TAP_Osd_GetBaseInfo(&osd_base_info_plane2);
		if (write_log) TAP_SPrint(log_buffer, "Plane 2 has %d bytes per pixel", osd_base_info_plane2.bytePerPixel);
		if (write_log) logText(log_buffer, FALSE);
		TAP_Osd_Delete(region_2);
		region_2 = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_Plane2);

		TAP_Osd_GetBaseInfo(&osd_base_info_plane2);
		if (write_log) TAP_SPrint(log_buffer, "Recreated Plane 2 has %d bytes per pixel", osd_base_info_plane2.bytePerPixel);
		if (write_log) logText(log_buffer, FALSE);
		if (osd_base_info_plane2.bytePerPixel != 2)
			apply_fade_image = FALSE;
	}

#ifdef WIN32
	apply_fade_image = FALSE;
#endif

    region_1 = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
	region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
	region = region_1;
	region_now = region_1;

	switchAspectRatio();

	TAP_Osd_FillBox(region_mem, 0, 0, 720, 576, COLOR_Black);

	// display a 'processing' message
	drawProcessingMessage(region, loading_and_decoding_t, FALSE, FALSE, TRUE);

	previous_jpeg = current_jpeg;
}

void switchBackAspectRatio()
{
#ifndef WIN32
	TAP_EnterNormal();
	TAP_Osd_SetTransparency(region, 255-toppy_transparency);
	if (photo_aspect_ratio != NO_ASPECT_RATIO_SWITCH) {
		(*TAP_SetSystemVar)(SYSVAR_TvRatio, toppy_tv_ratio);
		(*TAP_SetSystemVar)(SYSVAR_16_9_Display, toppy_tv_format); 
		if (!external_slideshow) {
			idle_before_window_display = TRUE;
			tick_draw_window = TAP_GetTick();
		}
	}
	TAP_ExitNormal();
#endif
}

void endBlankScreen()
{
	if (write_log) if (verbose) logText("End Blank screen", FALSE);

    TAP_Osd_Delete(region);
	TAP_Osd_Delete(region_mem);
	TAP_Osd_SetTransparency(region, 255-toppy_transparency);

	if (!external_slideshow) {
		region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
		region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
	}

	mp3_progress_offset = 0;
	radio_slideshow = FALSE;
	blank_screen_started = FALSE;
	external_slideshow = FALSE;
}

void endCompactMode()
{
	if (write_log) if (verbose) logText("End Compact mode", FALSE);

	if (compact_tv_mode)
		TAP_Channel_Stop(CHANNEL_Sub);

    TAP_Osd_Delete(region);
	TAP_Osd_Delete(region_mem);
	TAP_Osd_SetTransparency(region, 255-toppy_transparency);

	if (!external_slideshow) {
		region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
		region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
	}

	mp3_progress_offset = 0;
	radio_slideshow = FALSE;
	compact_mode_started = FALSE;
	external_slideshow = FALSE;
}

void endAlbumArt()
{
	if (write_log) if (verbose) logText("End album art", FALSE);

    if (album_art_started == FALSE)
    {
	    region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
		TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
	    TAP_Osd_Delete(region);
        return;
    }

	if (write_log) if (verbose) logText("Deleting OSD", FALSE);
	TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);

    TAP_Osd_Delete(region);
	TAP_Osd_Delete(region_mem);

	switchBackAspectRatio();

	mp3_progress_offset = 0;
	album_art_started = FALSE;
	full_size_display = saved_fsd;
	clearHistory(TRUE);

	freeMemory();
	freeMediaFiles();

	region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
	region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
}

void endScreensaver(bool switching)
{
	if (write_log) if (verbose) logText("End screensaver", FALSE);

    if (screensaver_started == FALSE)
    {
	    region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
		TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
	    TAP_Osd_Delete(region);
        return;
    }

	if (write_log) if (verbose) logText("Deleting OSD", FALSE);
    screensaver_started = FALSE;
	TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
    TAP_Osd_Delete(region);
	TAP_Osd_Delete(region_mem);

	if (!switching) switchBackAspectRatio();

	mp3_progress_offset = 0;

	freeMemory();
	clearHistory(TRUE);

	if (switching || !external_slideshow) {
		region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
		region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
	}
	
	if (!switching) {
		external_slideshow = FALSE;
		paused_slideshow = FALSE;
		radio_slideshow = FALSE;
		freeMediaFiles();
	}
}

void endSlideshow(bool switching)
{
	if (write_log) if (verbose) logText("End slideshow", FALSE);

	if (write_log) if (verbose) logText("Deleting OSD", FALSE);
    
	if (!switching) {
		TAP_Osd_FillBox(region_1, 0, 0, 720, 576, COLOR_Black);
		TAP_Osd_Delete(region_1);
		if (fade_image) TAP_Osd_Delete(region_2);
		TAP_Osd_Delete(region_mem);
		switchBackAspectRatio();
	}

	freeMemory();
	
	if (!show_jpeg)
		show_jpeg = TRUE;

	slideshow_started = FALSE;
	slideshow_paused = FALSE;
	rotated_degrees = 0;
	mp3_progress_offset = 0;

	clearHistory(TRUE);
	freeMediaFiles();

	if (!switching && !external_slideshow) {

#ifndef WIN32
		if (firmware_hacks_enabled && fade_image && toppy_mheg_status > 0 && isTF5800()) {
			if (write_log) logText("Enable MHEG", FALSE);
			//exTAP_MHEG_Disable(FALSE);
			InteractiveSetStatus(FALSE);
		}
#endif

		region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
		region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);
	}

	external_slideshow = FALSE;
	paused_slideshow = FALSE;
	radio_slideshow = FALSE;
}

bool isFolder(int idx)
{
    return dir_info[idx]->folder && !isParentDirectory(dir_info[idx]->file_name);
}

void countJPEGs()
{
	int i, j, deleted_folders = 0, subfolder_count;
	TYPE_File file;

	// find the files...
	for (j = 0; j < no_of_files; j++)
	{
		if (dir_info[j]->folder 
			&& !isParentDirectory(dir_info[j]->file_name) 
			&& !isMp3Directory(dir_info[j]->file_name)
			&&  strcmp(dir_info[j]->file_name, "Auto Start") != 0)
		{
			subfolder_count = 0;
			dir_info[j]->no_of_jpegs = 0;

			ChangeDir(dir_info[j]->file_name);
			i = TAP_Hdd_FindFirst(&file);

			while (i--)
			{
				if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0)
					subfolder_count++;

				if (isPhoto(file.name))
					dir_info[j]->no_of_jpegs++;

				if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
					break;
			}
			
			if (hide_empty_folders && !show_all_files && dir_info[j]->no_of_jpegs == 0 && subfolder_count == 0)
			{
				strcpy(dir_info[j]->file_name, "");
				strcpy(dir_info[j]->sort_name, "");
				deleted_folders++;
			}

			ChangeDir("..");
		}
	}

	no_of_files = no_of_files - deleted_folders;
}

void countMP3s()
{
	int i, j, deleted_folders = 0, subfolder_count;
	TYPE_File file;

	// find the files...
	for (j = 0; j < no_of_files; j++)
	{
		if (dir_info[j]->folder && !isParentDirectory(dir_info[j]->file_name))
		{
			subfolder_count = 0;
			dir_info[j]->no_of_mp3s = 0;

			ChangeDir(dir_info[j]->file_name);
			i = TAP_Hdd_FindFirst(&file);

			while (i--)
			{
				if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0)
					subfolder_count++;

				if (isMp3(file.name))
					dir_info[j]->no_of_mp3s++;

				if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
					break;
			}
			
			if (hide_empty_folders && !show_all_files && dir_info[j]->no_of_mp3s == 0 && subfolder_count == 0)
			{
				strcpy(dir_info[j]->file_name, "");
				strcpy(dir_info[j]->sort_name, "");
				deleted_folders++;
			}

			ChangeDir("..");
		}
	}

	no_of_files = no_of_files - deleted_folders;
}

void countRecs()
{
	int i, j, deleted_folders = 0, subfolder_count;
	TYPE_File file;

	// find the files...
	for (j = 0; j < no_of_files; j++) {
		if (dir_info[j]->folder && !isParentDirectory(dir_info[j]->file_name))
		{
			subfolder_count = 0;
			dir_info[j]->no_of_recs = 0;

			ChangeDir(dir_info[j]->file_name);
			i = TAP_Hdd_FindFirst(&file);

			while (i--)
			{
				if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0)
					subfolder_count++;

				if (isRec(file.name))
					dir_info[j]->no_of_recs++;

				if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
					break;
			}
			
			if (hide_empty_folders && !show_all_files && dir_info[j]->no_of_recs == 0 && subfolder_count == 0) {
				strcpy(dir_info[j]->file_name, "");
				strcpy(dir_info[j]->sort_name, "");
				deleted_folders++;
			}

			ChangeDir("..");
		}
	}

	no_of_files = no_of_files - deleted_folders;
}

int compareJPEGs(const void *s1, const void *s2)
{
	int compare_value;
	jpeg_file_1 = *(struct media_files **) s1;
	jpeg_file_2 = *(struct media_files **) s2;

	if (strlen(jpeg_file_1->file_name) == 0)
		return 1;

	if (strlen(jpeg_file_2->file_name) == 0)
		return -1;

	if (do_order_by_track_number)
		return jpeg_file_1->track_number < jpeg_file_2->track_number ? -1 : 1;

	compare_value = strcmp(jpeg_file_1->directory, jpeg_file_2->directory);
	if (compare_value != 0)	return compare_value;

	if ((InMp3FilesFolder(curr_dir) && music_ordering_mode == ORDER_BY_DATE)
			|| (!InMp3FilesFolder(curr_dir) && photo_ordering_mode == ORDER_BY_DATE)) {
		if (jpeg_file_1->mjd < jpeg_file_2->mjd)
			return -1;
		ef (jpeg_file_1->mjd > jpeg_file_2->mjd)
			return 1;
		else {
			if (((jpeg_file_1->hour * 60) + jpeg_file_1->min) < ((jpeg_file_2->hour * 60) + jpeg_file_2->min))
				return -1;
			ef (((jpeg_file_1->hour * 60) + jpeg_file_1->min) > ((jpeg_file_2->hour * 60) + jpeg_file_2->min))
				return 1;
		}
	}

	if ((InMp3FilesFolder(curr_dir) && music_ordering_mode == ORDER_BY_DATE_DESC)
			|| (!InMp3FilesFolder(curr_dir) && photo_ordering_mode == ORDER_BY_DATE_DESC)) {
		if (jpeg_file_2->mjd < jpeg_file_1->mjd)
			return -1;
		ef (jpeg_file_2->mjd > jpeg_file_1->mjd)
			return 1;
		else {
			if (((jpeg_file_2->hour * 60) + jpeg_file_2->min) < ((jpeg_file_1->hour * 60) + jpeg_file_1->min))
				return -1;
			ef (((jpeg_file_2->hour * 60) + jpeg_file_2->min) > ((jpeg_file_1->hour * 60) + jpeg_file_1->min))
				return 1;
		}
	}

	if ((InMp3FilesFolder(curr_dir) && music_ordering_mode == ORDER_BY_NAME_DESC)
			|| (!InMp3FilesFolder(curr_dir) && photo_ordering_mode == ORDER_BY_NAME_DESC))
		return strcmp(jpeg_file_2->sort_name, jpeg_file_1->sort_name);

	return strcmp(jpeg_file_1->sort_name, jpeg_file_2->sort_name);
}

int compareMatchedRecordings(const void *s1, const void *s2)
{
	episodes_1 = *(struct _recordings_episode_count **) s1;
	episodes_2 = *(struct _recordings_episode_count **) s2;

	if (strlen(episodes_1->matched_name) == 0)
		return 1;

	if (strlen(episodes_2->matched_name) == 0)
		return -1;

	return strcmp(episodes_1->matched_name, episodes_2->matched_name);
}

int compareRecycling(const void *s1, const void *s2)
{
	int return_value = 0;
	recycle_1 = *(struct _recycle_bin_list **) s1;
	recycle_2 = *(struct _recycle_bin_list **) s2;

	if (strlen(recycle_1->file_name) == 0)
		return 1;

	if (strlen(recycle_2->file_name) == 0)
		return -1;

	if (recycle_1->folder && !recycle_2->folder)
		return -1;

	if (!recycle_1->folder && recycle_2->folder)
		return 1;

	if (recycle_ordering_mode == ORDER_BY_NAME 
			|| (recycle_1->folder && recycle_2->folder)) {
		return_value = strcmp(recycle_1->file_name, recycle_2->file_name);
		if (return_value == 0)
			return_value = strcmp(recycle_1->directory, recycle_2->directory);
	}
	ef (recycle_ordering_mode == ORDER_BY_NAME_DESC) {
		return_value = strcmp(recycle_2->file_name, recycle_1->file_name);
		if (return_value == 0)
			return_value = strcmp(recycle_2->directory, recycle_1->directory);
	}
	ef (recycle_ordering_mode == ORDER_BY_DATE) {
		if (recycle_by_deletion_date) {
			if (recycle_1->deletion_mjd < recycle_2->deletion_mjd)
				return_value = -1;
			ef (recycle_1->deletion_mjd > recycle_2->deletion_mjd)
				return_value = 1;
			else {
				if (((recycle_1->deletion_hour * 60) + recycle_1->deletion_min) < ((recycle_2->deletion_hour * 60) + recycle_2->deletion_min))
					return_value = -1;
				ef (((recycle_1->deletion_hour * 60) + recycle_1->deletion_min) > ((recycle_2->deletion_hour * 60) + recycle_2->deletion_min))
					return_value = 1;
			}
		}
		else {
			if (recycle_1->mjd < recycle_2->mjd)
				return_value = -1;
			ef (recycle_1->mjd > recycle_2->mjd)
				return_value = 1;
			else {
				if (((recycle_1->hour * 60) + recycle_1->min) < ((recycle_2->hour * 60) + recycle_2->min))
					return_value = -1;
				ef (((recycle_1->hour * 60) + recycle_1->min) > ((recycle_2->hour * 60) + recycle_2->min))
					return_value = 1;
			}
		}

		if (return_value == 0) {
			return_value = strcmp(recycle_1->file_name, recycle_2->file_name);
			if (return_value == 0)
				return_value = strcmp(recycle_1->directory, recycle_2->directory);
		}
	}
	ef (recycle_ordering_mode == ORDER_BY_DATE_DESC) {
		if (recycle_by_deletion_date) {
			if (recycle_2->deletion_mjd < recycle_1->deletion_mjd)
				return_value = -1;
			ef (recycle_2->deletion_mjd > recycle_1->deletion_mjd)
				return_value = 1;
			else {
				if (((recycle_2->deletion_hour * 60) + recycle_2->deletion_min) < ((recycle_1->deletion_hour * 60) + recycle_1->deletion_min))
					return_value = -1;
				ef (((recycle_2->deletion_hour * 60) + recycle_2->deletion_min) > ((recycle_1->deletion_hour * 60) + recycle_1->deletion_min))
					return_value = 1;
			}
		}
		else {
			if (recycle_2->mjd < recycle_1->mjd)
				return_value = -1;
			ef (recycle_2->mjd > recycle_1->mjd)
				return_value = 1;
			else {
				if (((recycle_2->hour * 60) + recycle_2->min) < ((recycle_1->hour * 60) + recycle_1->min))
					return_value = -1;
				ef (((recycle_2->hour * 60) + recycle_2->min) > ((recycle_1->hour * 60) + recycle_1->min))
					return_value = 1;
			}
		}

		if (return_value == 0) {
			return_value = strcmp(recycle_1->file_name, recycle_2->file_name);
			if (return_value == 0)
				return_value = strcmp(recycle_1->directory, recycle_2->directory);
		}
	}

	return return_value;
}

int compareRecordings(const void *s1, const void *s2)
{
	int return_value = 0;

	extract_1 = *(struct _recordings_extract **) s1;
	extract_2 = *(struct _recordings_extract **) s2;

	if (strlen(extract_1->file_name) == 0)
		return 1;

	if (strlen(extract_2->file_name) == 0)
		return -1;

	// order by name, then date
	if (strcmp(extract_1->matched_name, extract_2->matched_name) == 0) {
		if (extract_1->mjd < extract_2->mjd)
			return -1;
		ef (extract_1->mjd > extract_2->mjd)
			return 1;
		else {
			if (((extract_1->hour * 60) + extract_1->min) < ((extract_2->hour * 60) + extract_2->min))
				return -1;
			ef (((extract_1->hour * 60) + extract_1->min) > ((extract_2->hour * 60) + extract_2->min))
				return 1;
		}

		// possible to get here if the same matched name, and the same deletion time, so finally check file name
		return_value = strcmp(extract_1->file_name, extract_2->file_name);
		if (return_value == 0)
			return_value = strcmp(extract_1->directory, extract_2->directory);

		return return_value;
	}

	return strcmp(extract_1->matched_name, extract_2->matched_name);
}

int compareFiles(const void *s1, const void *s2)
{
	bool ordering_mode;
	info_1 = *(struct _dir_info **) s1;
	info_2 = *(struct _dir_info **) s2;

	if (InDataFilesFolder(curr_dir))
		ordering_mode = video_ordering_mode;
	ef (InMp3FilesFolder(curr_dir))
		ordering_mode = music_ordering_mode;
	else
		ordering_mode = photo_ordering_mode;

	if (strlen(info_1->sort_name) == 0)
		return 1;

	if (strlen(info_2->sort_name) == 0)
		return -1;

	if (isParentDirectory(info_1->file_name))
		return -1;

	if (isParentDirectory(info_2->file_name))
		return 1;

	if (info_1->folder && !info_2->folder)
		return folders_at_end ? 1 : -1;

	if (!info_1->folder && info_2->folder)
		return folders_at_end ? -1 : 1;

	if (info_1->folder && info_2->folder)
		return strcmp(info_1->sort_name, info_2->sort_name);

	if (isPhotoLog(info_1->sort_name))
		return 1;

	if (isPhotoLog(info_2->sort_name))
		return -1;

	if (strcmp(info_1->file_name, "..") == 0)
		return -1;

	if (strcmp(info_2->file_name, "..") == 0)
		return 1;

	if (do_order_by_track_number)
		return info_1->track_number < info_2->track_number ? -1 : 1;

	// order by name
	if (ordering_mode == ORDER_BY_NAME || (ordering_mode != ORDER_BY_NAME_DESC && info_1->folder && info_2->folder)) {
		if (strcmp(info_1->sort_name, info_2->sort_name) != 0)
			return strcmp(info_1->sort_name, info_2->sort_name);
	}

	// order by reverse name
	if (ordering_mode == ORDER_BY_NAME_DESC || (ordering_mode != ORDER_BY_NAME && info_1->folder && info_2->folder)) {
		if (strcmp(info_2->sort_name, info_1->sort_name) != 0)
			return strcmp(info_2->sort_name, info_1->sort_name);
	}

	// only check size ordering if they are both files
	if (!info_1->folder && !info_2->folder) {
		// order by size
		if (ordering_mode == ORDER_BY_SIZE) {
			if (info_1->size < info_2->size)
				return -1;
			ef (info_1->size > info_2->size)
				return 1;
		}

		// order by reverse size
		if (ordering_mode == ORDER_BY_SIZE_DESC) {
			if (info_2->size < info_1->size)
				return -1;
			ef (info_2->size > info_1->size)
				return 1;
		}
	}

	if (ordering_mode == ORDER_BY_DATE || (ordering_mode != ORDER_BY_DATE_DESC && strcmp(info_1->sort_name, info_2->sort_name) == 0)) {
		if (info_1->mjd < info_2->mjd)
			return -1;
		ef (info_1->mjd > info_2->mjd)
			return 1;
		else {
			if (((info_1->hour * 60) + info_1->min) < ((info_2->hour * 60) + info_2->min))
				return -1;
			ef (((info_1->hour * 60) + info_1->min) > ((info_2->hour * 60) + info_2->min))
				return 1;
		}
	}

	// order by reverse date
	if (ordering_mode == ORDER_BY_DATE_DESC || (ordering_mode != ORDER_BY_DATE && strcmp(info_1->sort_name, info_2->sort_name) == 0)) {
		if (info_2->mjd < info_1->mjd)
			return -1;
		ef (info_2->mjd > info_1->mjd)
			return 1;
		else {
			if (((info_2->hour * 60) + info_2->min) < ((info_1->hour * 60) + info_1->min))
				return -1;
			ef (((info_2->hour * 60) + info_2->min) > ((info_1->hour * 60) + info_1->min))
				return 1;
		}
	}

	// if we get here, default to order by name
	return strcmp(info_1->sort_name, info_2->sort_name);
}

// create the cache subdirectory if it does not exist
bool createCacheDirectoryIfNotThere()
{
#ifndef WIN32
	if (!TAP_Hdd_Exist("Cache"))
	{
		if (write_log) if (verbose) logText("Creating Cache directory", FALSE);
		TAP_Hdd_Create("Cache", ATTR_FOLDER);
		return TRUE;
	}
#endif
	return FALSE;
}


void populateJPEGsRecursively(bool recursive)
{
	TYPE_File file;
	int subfolder_count = 0, i;
	char **subfolders = dlmalloc(sizeof(*subfolders) * 512);

	memset (&file, 0, sizeof (file));
	i = TAP_Hdd_FindFirst(&file);

	while(i-- && no_of_jpegs < MEMORY_LIMIT && subfolder_count < 512)
	{
		if (isPhoto(file.name))
		{
			if (no_of_jpegs == 0) {
				jpeg_files = dlmalloc(sizeof(*jpeg_files) * MEMORY_LIMIT);
			}

			jpeg_files[no_of_jpegs] = dlmalloc(sizeof(*jpeg_files[no_of_jpegs]));
			memset(jpeg_files[no_of_jpegs], 0, sizeof(*jpeg_files[no_of_jpegs]));

			// populate the file name and folder flag
			jpeg_files[no_of_jpegs]->directory = dlmalloc(strlen(tracked_dir) + 1);
			jpeg_files[no_of_jpegs]->file_name = dlmalloc(strlen(file.name) + 1);
			jpeg_files[no_of_jpegs]->sort_name = dlmalloc(strlen(file.name) + 2);
			strcpy(jpeg_files[no_of_jpegs]->directory, tracked_dir);
			strcpy(jpeg_files[no_of_jpegs]->file_name, file.name);
			FormatSortName(jpeg_files[no_of_jpegs]->sort_name, file.name);
			jpeg_files[no_of_jpegs]->mjd = file.mjd;
			jpeg_files[no_of_jpegs]->hour = file.hour;
			jpeg_files[no_of_jpegs]->min = file.min;
			no_of_jpegs++;
		}
		ef (file.attr == ATTR_FOLDER && strcmp(file.name, "MP3") != 0 && strcmp(file.name, "Cache") != 0)	
		{
			if (recursive && recurse_subfolders)
			{
				subfolders[subfolder_count] = dlmalloc(100 * sizeof(char));
				strcpy(subfolders[subfolder_count], file.name);
				subfolder_count++;
			}
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	if (recursive && recurse_subfolders)
	{
		for (i = 0; i < subfolder_count; i++)
		{
			ChangeDir(subfolders[i]);
			populateJPEGsRecursively(TRUE);
			ChangeDir("..");
		}

		for (i = 0; i < subfolder_count; i++)
		{
			dlfree(subfolders[i]);
			subfolders[i] = NULL;
		}
		dlfree(subfolders);
		subfolders = NULL;
	}

	dlmalloc_trim(0);
}

void populateJPEGs(bool recursive, bool show_message)
{
	freeMediaFiles();
	strcpy(buffer4, "");

	if (recursive && recurse_subfolders && show_message) {
		processing_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);
		drawProcessingMessage(region, searching_for_images_t, FALSE, FALSE, TRUE);
	}

	populateJPEGsRecursively(recursive);

	qsort(jpeg_files, no_of_jpegs, sizeof(jpeg_files[0]), compareJPEGs);

	if (recursive && recurse_subfolders && show_message) {
		TAP_Osd_RestoreBox(region, 0, 0, 720, 576, processing_save);
		TAP_MemFree(processing_save);
		processing_save = NULL;
	}

}

void populateMP3sRecursively(bool recursive)
{
	TYPE_File file;
	struct media_files *mp3_header;
	int subfolder_count = 0, i;
	char **subfolders = dlmalloc(sizeof(*subfolders) * 2048);

	i = TAP_Hdd_FindFirst(&file);
	while(i-- && no_of_mp3s < MEMORY_LIMIT && subfolder_count < 2048)
	{
		if (isMp3(file.name))
		{
			if (no_of_mp3s == 0)
				mp3_files = dlmalloc(sizeof(*mp3_files) * MEMORY_LIMIT);

			mp3_files[no_of_mp3s] = dlmalloc(sizeof(*mp3_files[no_of_mp3s]));
			memset(mp3_files[no_of_mp3s], 0, sizeof(*mp3_files[no_of_mp3s]));

			// populate the file name and folder flag
			mp3_files[no_of_mp3s]->directory = dlmalloc(strlen(tracked_dir) + 1);
			mp3_files[no_of_mp3s]->file_name = dlmalloc(strlen(file.name) + 1);
			mp3_files[no_of_mp3s]->sort_name = dlmalloc(strlen(file.name) + 2);
			strcpy(mp3_files[no_of_mp3s]->directory, tracked_dir);
			strcpy(mp3_files[no_of_mp3s]->file_name, file.name);
			FormatSortName(mp3_files[no_of_mp3s]->sort_name, file.name);
			mp3_files[no_of_mp3s]->mjd = file.mjd;
			mp3_files[no_of_mp3s]->hour = file.hour;
			mp3_files[no_of_mp3s]->min = file.min;

			if ((mp3_header = getMp3Header(file.name, tracked_dir, file.mjd, file.hour, file.min, TRUE, FALSE, FALSE))
					&& mp3_header->header_loaded) {
				mp3_files[no_of_mp3s]->track_number = mp3_header->track_number;
				mp3_files[no_of_mp3s]->duration = mp3_header->duration;
			}

			no_of_mp3s++;
		}
		ef (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0)	
		{
			if (recursive && recurse_subfolders)
			{
				subfolders[subfolder_count] = dlmalloc(100 * sizeof(char));
				strcpy(subfolders[subfolder_count], file.name);
				subfolder_count++;
			}
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	if (recursive && recurse_subfolders)
	{
		for (i = 0; i < subfolder_count; i++)
		{
			ChangeDir(subfolders[i]);
			populateMP3sRecursively(TRUE);
			ChangeDir("..");
		}

		for (i = 0; i < subfolder_count; i++)
		{
			dlfree(subfolders[i]);
			subfolders[i] = NULL;
		}
		dlfree(subfolders);
		subfolders = NULL;
	}

	dlmalloc_trim(0);
}

void populateMP3s(bool recursive, bool show_message)
{
	freeMP3Structure();

	// if recursive mode then display the processing message
	if (recursive && recurse_subfolders && show_message) {
		processing_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);
		drawProcessingMessage(region, searching_for_mp3s_t, FALSE, FALSE, TRUE);
	}

	// recursive method to gather all the mp3s
	if (preload_mp3_headers && strcmp(tracked_dir, "/MP3") == 0) {
		if (!mp3s_loaded) {
			strcpy(known_dir, tracked_dir);
			loadMp3Headers(TRUE, FALSE, TRUE);
			ChangeDirPath(known_dir);
		}
		mp3_files = all_mp3_headers;
		no_of_mp3s = no_of_mp3_headers;
		free_mp3s = FALSE;
		//moveMp3HeadersToStructure();
	}
	else {
		populateMP3sRecursively(recursive);
		free_mp3s = TRUE;
	}

	// now we have them all sort them
	if (order_by_track_number && no_of_mp3s  > 0 && no_of_mp3s <= 32) 
		checkTrackNumberOrdering(FALSE, no_of_mp3s);
	qsort(mp3_files, no_of_mp3s, sizeof(mp3_files[0]), compareJPEGs);
	do_order_by_track_number = FALSE;

	// if recursive mode then delete the processing message
	if (recursive && recurse_subfolders && show_message) {
		TAP_Osd_RestoreBox(region, 0, 0, 720, 576, processing_save);
		TAP_MemFree(processing_save);
		processing_save = NULL;
	}
}

void checkTrackNumberOrdering(bool dir_display, int no_of_items)
{
	word i, j = 0, k, track_numbers[32];
	for (i = 0; i < 32; i++)
		track_numbers[i] = 0;

	do_order_by_track_number = TRUE;
	for (i = 0; i < no_of_items; i++) {
		if (dir_display) {
			if (!isMp3(dir_info[i]->file_name))
				continue;

			if (dir_info[i]->track_number == 0) {
				do_order_by_track_number = FALSE;
				break;
			}

			for (k = 0; k < j; k++) {
				if (track_numbers[k] == dir_info[i]->track_number) {
					do_order_by_track_number = FALSE;
					break;
				}
			}
			
			track_numbers[j] = dir_info[i]->track_number;
			j++;
		}
		else {
			if (mp3_files[i]->track_number == 0) {
				do_order_by_track_number = FALSE;
				break;
			}

			for (k = 0; k < j; k++) {
				if (track_numbers[k] == mp3_files[i]->track_number) {
					do_order_by_track_number = FALSE;
					break;
				}
			}
			
			track_numbers[j] = mp3_files[i]->track_number;
			j++;
		}
	}
}

void populateFiles()
{
	int i, total_no_of_files = 0;
	TYPE_File file;
	bool include_mp3s = FALSE, include_jpegs = FALSE, include_recs = FALSE;
	local_no_of_jpegs = 0; local_no_of_mp3s = 0; local_no_of_recs = 0;

	if (write_log) if (verbose) logText("Populating file list", FALSE);

	if (InMp3FilesFolder(curr_dir))
		include_mp3s = TRUE;
	ef (InDataFilesFolder(curr_dir))
		include_recs = TRUE;
	else
		include_jpegs = TRUE;

	freeDirInfo();

	// find the files...
    memset (&file, 0, sizeof(file));
	i = TAP_Hdd_FindFirst(&file);

	while(i-- && no_of_files < 2048)
	{
		if (include_jpegs && isPhoto(file.name)) {
			dir_info[no_of_files] = dlmalloc(sizeof(*dir_info[no_of_files])); 
			memset(dir_info[no_of_files], 0, sizeof (*dir_info[no_of_files]));

			dir_info[no_of_files]->file_name = dlmalloc(strlen(file.name)+1);
			dir_info[no_of_files]->sort_name = dlmalloc(strlen(file.name)+2);
			strcpy(dir_info[no_of_files]->file_name, file.name);
			FormatSortName(dir_info[no_of_files]->sort_name, file.name);
			dir_info[no_of_files]->folder = FALSE;
			dir_info[no_of_files]->size = file.size;
			dir_info[no_of_files]->hour = file.hour;
			dir_info[no_of_files]->min = file.min;
			dir_info[no_of_files]->mjd = file.mjd;
			local_no_of_jpegs++;
			no_of_files++;
		}
		ef (include_mp3s && isMp3(file.name)) {
			struct media_files *mp3_header;
			dir_info[no_of_files] = dlmalloc(sizeof(*dir_info[no_of_files])); 
			memset(dir_info[no_of_files], 0, sizeof (*dir_info[no_of_files]));

			dir_info[no_of_files]->file_name = dlmalloc(strlen(file.name)+1);
			dir_info[no_of_files]->sort_name = dlmalloc(strlen(file.name)+2);
			strcpy(dir_info[no_of_files]->file_name, file.name);
			FormatSortName(dir_info[no_of_files]->sort_name, file.name);
			dir_info[no_of_files]->folder = FALSE;
			dir_info[no_of_files]->size = file.size;
			dir_info[no_of_files]->hour = file.hour;
			dir_info[no_of_files]->min = file.min;
			dir_info[no_of_files]->mjd = file.mjd;

			if ((mp3_header = getMp3Header(file.name, tracked_dir, file.mjd, file.hour, file.min, TRUE, FALSE, FALSE))
					&& mp3_header->header_loaded) {
				dir_info[no_of_files]->track_number = mp3_header->track_number;
				dir_info[no_of_files]->duration = mp3_header->duration;
			}

			local_no_of_mp3s++;
			no_of_files++;
		}
		ef (include_recs && isRec(file.name)) {
			dir_info[no_of_files] = dlmalloc(sizeof(*dir_info[no_of_files])); 
			memset(dir_info[no_of_files], 0, sizeof (*dir_info[no_of_files]));

			dir_info[no_of_files]->file_name = dlmalloc(strlen(file.name)+1);
			dir_info[no_of_files]->sort_name = dlmalloc(strlen(file.name)+2);
			strcpy(dir_info[no_of_files]->file_name, file.name);
			FormatSortName(dir_info[no_of_files]->sort_name, file.name);
			dir_info[no_of_files]->folder = FALSE;
			dir_info[no_of_files]->start_cluster = file.startCluster;
			dir_info[no_of_files]->size = file.size;
			dir_info[no_of_files]->hour = file.hour;
			dir_info[no_of_files]->min = file.min;
			dir_info[no_of_files]->mjd = file.mjd;
			dir_info[no_of_files]->attr = file.attr;
			dir_info[no_of_files]->encryption = file.crypt;
			if (file.skip == LOCKED_FILE) dir_info[no_of_files]->locked = TRUE;
			local_no_of_recs++;
			no_of_files++;
		}
		ef (isPhotoLog(file.name)
				|| (isTAP(file.name) /*&& (strcmp(curr_dir, "/ProgramFiles") == 0 || strcmp(curr_dir, "/ProgramFiles/Auto Start") == 0)*/)
				|| (isSkin(file.name) && (strcmp(curr_dir, "/ProgramFiles/Settings/Skins") == 0))) {
			dir_info[no_of_files] = dlmalloc(sizeof(*dir_info[no_of_files])); 
			memset(dir_info[no_of_files], 0, sizeof (*dir_info[no_of_files]));

			dir_info[no_of_files]->file_name = dlmalloc(strlen(file.name)+1);
			dir_info[no_of_files]->sort_name = dlmalloc(strlen(file.name)+2);
			strcpy(dir_info[no_of_files]->file_name, file.name);
			FormatSortName(dir_info[no_of_files]->sort_name, file.name);
			dir_info[no_of_files]->size = file.size;
			dir_info[no_of_files]->hour = file.hour;
			dir_info[no_of_files]->min = file.min;
			dir_info[no_of_files]->mjd = file.mjd;
			dir_info[no_of_files]->folder = FALSE;
			no_of_files++;
		}
		ef (file.attr == ATTR_PARENT && (show_all_files || (hide_top_level_parent != ALWAYS && !(hide_top_level_parent == DATAFILES && strcmp(curr_dir, "/DataFiles") == 0)))) {
			dir_info[no_of_files] = dlmalloc(sizeof(*dir_info[no_of_files])); 
			memset(dir_info[no_of_files], 0, sizeof (*dir_info[no_of_files]));

			dir_info[no_of_files]->file_name = dlmalloc(strlen(file.name)+1);
			dir_info[no_of_files]->sort_name = dlmalloc(strlen(file.name)+2);
			strcpy(dir_info[no_of_files]->file_name, file.name);
			strcpy(dir_info[no_of_files]->sort_name, file.name);
			dir_info[no_of_files]->folder = TRUE;
			no_of_files++;
		}
		ef (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0 && strcmp(file.name, "CutFiles") != 0 && !isRecycled(file.name)) {
			dir_info[no_of_files] = dlmalloc(sizeof(*dir_info[no_of_files])); 
			memset(dir_info[no_of_files], 0, sizeof (*dir_info[no_of_files]));

			dir_info[no_of_files]->file_name = dlmalloc(strlen(file.name)+1);
			dir_info[no_of_files]->sort_name = dlmalloc(strlen(file.name)+2);
			strcpy(dir_info[no_of_files]->file_name, file.name);
			if (include_mp3s && strcmp(curr_dir, "/MP3") == 0) {
				// check for artist name starting with "The " and sort accordingly
				strcpy(file_name, file.name);
				strlwr(file_name);
				if (strlen(file_name) > 4 && strncmp(file_name, "the ", 4) == 0)
					strcpy(dir_info[no_of_files]->sort_name, file.name+4);
				else
					strcpy(dir_info[no_of_files]->sort_name, file.name);
			}
			else {
				FormatSortName(dir_info[no_of_files]->sort_name, file.name);
			}
			dir_info[no_of_files]->folder = TRUE;
			no_of_files++;
		}
		ef (show_all_files && file.attr != ATTR_DELETED && file.attr != ATTR_THIS && !isRecycled(file.name)
				&& strcmp(file.name, "__RECYCLE__") != 0 
				&& strcmp(file.name, "__ROOT__") != 0
				&& strcmp(file.name, "__temprec__.ss") != 0
				&& strcmp(file.name, "__temprec__.ts") != 0) {
			// populate any other files if show all is selected
			dir_info[no_of_files] = dlmalloc(sizeof(*dir_info[no_of_files])); 
			memset(dir_info[no_of_files], 0, sizeof (*dir_info[no_of_files]));

			dir_info[no_of_files]->file_name = dlmalloc(strlen(file.name)+1);
			dir_info[no_of_files]->sort_name = dlmalloc(strlen(file.name)+2);
			strcpy(dir_info[no_of_files]->file_name, file.name);
			FormatSortName(dir_info[no_of_files]->sort_name, file.name);
			dir_info[no_of_files]->size = file.size;
			dir_info[no_of_files]->hour = file.hour;
			dir_info[no_of_files]->min = file.min;
			dir_info[no_of_files]->mjd = file.mjd;
			if (file.attr == ATTR_FOLDER)
				dir_info[no_of_files]->folder = TRUE;
			else
				dir_info[no_of_files]->folder = FALSE;
			no_of_files++;
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}
	
	if (include_jpegs && local_no_of_jpegs > 0)
		loadDimensions();

	if (!show_all_files && order_by_track_number && include_mp3s && local_no_of_mp3s  > 0 && local_no_of_mp3s <= 32) 
		checkTrackNumberOrdering(TRUE, no_of_files);

	total_no_of_files = no_of_files;

	if (!disable_folder_count) {
		if (include_jpegs)
			countJPEGs();
		ef (include_mp3s)
			countMP3s();
		ef (include_recs)
			countRecs();
	}

	qsort(dir_info, total_no_of_files, sizeof(dir_info[0]), compareFiles);
	do_order_by_track_number = FALSE;

	logMemory("After populating file list", TRUE);
}

bool populateMoveFolders()
{
	TYPE_File file;
	int i;
	char parent_folder[256];
	no_of_move_folders = 0;

	ExtractDirectory(tracked_dir, parent_folder);
	
	if (write_log) if (verbose) logText("Populating move folders", FALSE);

	// find the files...
    memset (&file, 0, sizeof(file));
	i = TAP_Hdd_FindFirst(&file);

	while(i-- && no_of_files < 256)
	{
		if (strcmp(file.name, "Cache") != 0 && strcmp(file.name, "CutFiles") != 0 && !isRecycled(file.name)
				&& (file.attr == ATTR_FOLDER || (file.attr == ATTR_PARENT && strcmp(parent_folder, "/") != 0))) {
			memset (&move_folders[no_of_move_folders], 0, sizeof(move_folders[no_of_move_folders]));
			move_folders[no_of_move_folders] = dlmalloc(256 * sizeof(char));
			strcpy(move_folders[no_of_move_folders], tracked_dir);
			if (strcmp(tracked_dir, "/") != 0)
				strcat(move_folders[no_of_move_folders], "/");
			strcat(move_folders[no_of_move_folders], file.name);
			no_of_move_folders++;
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	qsort(move_folders, no_of_move_folders, sizeof(move_folders[0]), compareStrings);

	if (no_of_move_folders == 0 || (no_of_move_folders == 1 && strcmp(parent_folder, "/") != 0))
		return FALSE;

	return TRUE;
}

void populateScenes(char *name)
{
	char rec_name[100];
	int i, total_no_of_files = 0;
	
	strcpy(rec_name, name);

	freeDirInfo();
	
	if (TAP_Hdd_Exist("Cache")) {
		TYPE_File *first_scene = NULL;
		ChangeDir("Cache");

		TAP_SPrint(file_name, "%s.tn.1", rec_name);
		first_scene = TAP_Hdd_Fopen(file_name);
		if (first_scene != NULL) {
			TAP_Hdd_Fread(&no_of_files, sizeof(int), 1, first_scene);
			TAP_Hdd_Fclose(first_scene);

			for (i = 1; i <= no_of_files; i++) {
				// populate the file name 
				dir_info[i-1] = dlmalloc(sizeof(*dir_info[i-1])); 
				memset(dir_info[i-1], 0, sizeof (*dir_info[i-1]));

				dir_info[i-1]->file_name = dlmalloc(100 * sizeof(char));
				TAP_SPrint(file_name, "%s.tn.%d", rec_name, i);
				strcpy(dir_info[i-1]->file_name, file_name);
			}
		}

		ChangeDir("..");
	}
}

void handleSearchKey()
{
	if (InMp3FilesFolder(curr_dir) || (playlist_displayed && !photo_playlist_mode)) {
		// search for MP3s
		memset(keyboard_name, '\0', 100);
		cursor_pointer = 0;
		new_folder = FALSE;
		search_mp3s = TRUE;
		handleKeyboardKey();
	}
}

void handleStartMP3ModeKey(void)
{
	if (mp3_playing && mp3_mode != OFF) {
		if (playlist_displayed) {
			saved_playlist_idx = curr_idx;
			saved_playlist_highlight = curr_highlight;
		}
		else
			saveNavHistory(curr_idx, curr_highlight, FALSE);
		startMP3Mode(mp3_mode, FALSE);
	}
}

/* move all files individually, recursing as we go for subfolders */
void doMoveFolder(char *move_folder_name)
{
	TYPE_File file;
	word subfolder_count = 0, i;
	char **subfolders = dlmalloc(sizeof(*subfolders) * 128);

	strcpy(from_dir, tracked_dir);
	strcpy(temp, to_dir_saved);
	strcat(temp, from_dir+strlen(from_dir_saved));
	ExtractDirectory(temp, to_dir);
	ChangeDirPath(to_dir);
	if (!TAP_Hdd_Exist(move_folder_name)) TAP_Hdd_Create(move_folder_name, ATTR_FOLDER);
	ChangeDirPath(from_dir);
	strcat(to_dir, "/");
	strcat(to_dir, move_folder_name);

	i = TAP_Hdd_FindFirst(&file);
	while (i-- && subfolder_count < 512)
	{
		// save the folder for a later move (but ignore cache, since this will get done as a byproduct of moves)
		if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0) {
			subfolders[subfolder_count] = dlmalloc(100 * sizeof(char));
			strcpy(subfolders[subfolder_count], file.name);
			subfolder_count++;
		}
		// else everything but this dir, parent dir, deleted files, or recycle (243?)
		ef (file.attr != ATTR_FOLDER && file.attr != ATTR_THIS && file.attr != ATTR_PARENT && file.attr != ATTR_DELETED
				&& (strcmp(file.name, "__RECYCLE__") != 0)) {

			// move the file
			strcpy(move_file_name, file.name);
			doMove(file.mjd, file.hour, file.min);	

			// if it failed for some reason then stop for safety's sake
			if (!move_successful) {

				for (i = 0; i < subfolder_count; i++)
				{
					dlfree(subfolders[i]);
					subfolders[i] = NULL;
				}
				dlmalloc_trim(0);
				return;
			}
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	for (i = 0; i < subfolder_count; i++)
	{
		ChangeDir(subfolders[i]);
		doMoveFolder(subfolders[i]);
		ChangeDir("..");
	}

	for (i = 0; i < subfolder_count; i++)
	{
		dlfree(subfolders[i]);
		subfolders[i] = NULL;
	}
	dlfree(subfolders);
	subfolders = NULL;

	dlmalloc_trim(0);
}

/*bool moveAvailable()
{
	return (api_move_available || debug_move_available);
}*/

bool move(char *from_dir, char *to_dir, char *move_file_name)
{
	bool moved = FALSE;

#ifndef WIN32
	moved = HDD_Move(move_file_name, from_dir, to_dir);
#endif

	return moved;
}

void doMove(word file_mjd, word file_hour, word file_min)
{
#ifndef WIN32
	int result;
	bool renamed = FALSE, moved = FALSE;
	dword rename_rule = auto_rename_rule;

	ExtractExtension(move_file_name, extension);

	// get and call the undocumented move function
	//TAP_Hdd_Move = TAP_GetSystemProc(oTAP_Hdd_Move);
	strcpy(old_name, move_file_name);
	strcpy(new_name, move_file_name);

	switch (auto_rename_rule) {

		case RENAME_BY_NUMBER:
		case RENAME_BY_DATE:
		case RENAME_BY_DATE_AND_TIME:
		case RENAME_BY_DATE_ALWAYS:
		case RENAME_BY_DATE_AND_TIME_ALWAYS:

			// strip off the extension for renaming
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename %s if necessary", old_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			memset(move_file_name, '\0', 100);
			strncat(move_file_name, new_name, strlen(new_name)-strlen(extension));

			// append the relevant stamp (if not a recording, then downgrade the 'always' rename rules to 'if clash')
			if (!isRec(old_name)) {
				if (auto_rename_rule == RENAME_BY_DATE_ALWAYS)
					rename_rule = RENAME_BY_DATE;
				ef (auto_rename_rule == RENAME_BY_DATE_AND_TIME_ALWAYS)
					rename_rule = RENAME_BY_DATE_AND_TIME;
			}
			renamed = appendToName(rename_rule, move_file_name, extension, from_dir, to_dir, file_mjd, file_hour, file_min);

			// if move file name has been appended to, then replace the extension and rename the physical file
			strcat(move_file_name, extension);
			if (renamed) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Renamed %s to %s, now do physical rename", old_name, move_file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				strcpy(new_name, move_file_name);
				doRename(old_name, new_name, FALSE, FALSE);
			}
			
			break;
	}

	// move the file
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Move %s, from %s to %s", move_file_name, from_dir, to_dir);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	//moved = TAP_Hdd_Move(from_dir, to_dir, move_file_name);
	moved = move(from_dir, to_dir, move_file_name);

	// if move failed, then flag and return, otherwise check for any cache files that also need moving
	if (!moved) {
		if (write_log) if (verbose) logText("Move failed", FALSE);
		move_successful = FALSE;
		return;
	}

	// rename the recycled details if needs be
	if (isRecycled(old_name))
		renameRecycle(old_name, from_dir, new_name, to_dir, from_dir);

	// move the rec header location if needs be
	if (isRec(old_name))
		updateHeader(old_name, new_name, from_dir, to_dir);

	// move all thumbnails and scene, cache and association
	if (TAP_Hdd_Exist("Cache")) {
		if (isPhoto(move_file_name) || isMp3(move_file_name) || isRec(move_file_name)
				|| isRecycledPhoto(move_file_name) || isRecycledMp3(move_file_name) || isRecycledRec(move_file_name)) {
			TYPE_File *first_scene;
			int i, no_of_scenes = 0;
			ChangeDirPath(to_dir);
			if (!TAP_Hdd_Exist("Cache")) TAP_Hdd_Create("Cache", ATTR_FOLDER);
			ChangeDirPath(from_dir);
			strcpy(buffer4, from_dir); strcat(buffer4, "/Cache");
			strcpy(buffer5, to_dir); strcat(buffer5, "/Cache");

			ChangeDir("Cache");

			// cache
			TAP_SPrint(file_name, "%s.cache", move_file_name);
			if (TAP_Hdd_Exist(file_name)) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Move %s, from %s to %s", file_name, buffer4, buffer5);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				//TAP_Hdd_Move(buffer4, buffer5, file_name);
				moved = move(buffer4, buffer5, file_name);
			}

			// association
			TAP_SPrint(file_name, "%s.ass", move_file_name);
			if (TAP_Hdd_Exist(file_name)) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Move %s, from %s to %s", file_name, buffer4, buffer5);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				//TAP_Hdd_Move(buffer4, buffer5, file_name);
				moved = move(buffer4, buffer5, file_name);
			}

			// thumbnail
			TAP_SPrint(file_name, "%s.tn", move_file_name);
			if (TAP_Hdd_Exist(file_name)) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Move %s, from %s to %s", file_name, buffer4, buffer5);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				//TAP_Hdd_Move(buffer4, buffer5, file_name);
				moved = move(buffer4, buffer5, file_name);
			}

			// scenes
			TAP_SPrint(file_name, "%s.tn.1", move_file_name);
			first_scene = TAP_Hdd_Fopen(file_name);
			if (first_scene != NULL) {
				TAP_Hdd_Fread(&no_of_scenes, sizeof(int), 1, first_scene);
				TAP_Hdd_Fclose(first_scene);
			}
			for (i = 1; i <= no_of_scenes; i++) {
				TAP_SPrint(file_name, "%s.tn.%d", move_file_name, i);
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Move %s, from %s to %s", file_name, buffer4, buffer5);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				//TAP_Hdd_Move(buffer4, buffer5, file_name);
				moved = move(buffer4, buffer5, file_name);
			}

			ChangeDir("..");
		}
	}
#endif
}

void doDelete(char *file_to_delete, dword start_cluster, char *directory, bool folder, bool change_dir)
{
	TYPE_PlayInfo play_info;
	TYPE_RecInfo rec_info_1, rec_info_2;
	TYPE_File *file;
	int i;

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete file %s", file_to_delete);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	if (change_dir)
		ChangeDirPath(directory);

	// if an mp3, then stop playback
	if (isMp3(file_to_delete)) {
		if (mp3_playing && strcmp(mp3_files[current_mp3]->file_name, file_to_delete) == 0) {
			handleStopKey(TRUE);
		}
		deleteMp3Header(file_to_delete, directory);
	}

	// if a rec, then stop playback or recording first
	if (isRec(file_to_delete)) {
		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		
		if (play_info.file && play_info.playMode == PLAYMODE_Playing 
				&& strcmp(play_info.file->name, file_to_delete) == 0
				&& play_info.file->startCluster == start_cluster) {
			TAP_Hdd_StopTs();
		}
		ef (IsDataFilesFolder(directory) && strcmp(rec_info_1.fileName, file_to_delete) == 0) {
			if (play_info.file && play_info.playMode == PLAYMODE_RecPlaying 
					&& strcmp(play_info.file->name, file_to_delete) == 0
					&& play_info.file->startCluster == start_cluster)
				TAP_Hdd_StopTs();

			TAP_Hdd_StopRecord(0);

			if (!TAP_Hdd_Exist(file_to_delete))
				return;
		}
		ef (IsDataFilesFolder(directory) && strcmp(rec_info_2.fileName, file_to_delete) == 0) {
			if (play_info.file && play_info.playMode == PLAYMODE_RecPlaying 
					&& strcmp(play_info.file->name, file_to_delete) == 0
					&& play_info.file->startCluster == start_cluster)
				TAP_Hdd_StopTs();
			TAP_Hdd_StopRecord(1);

			if (!TAP_Hdd_Exist(file_to_delete))
				return;
		}

		// then delete the progress data
		file = TAP_Hdd_Fopen(file_to_delete);
		if (file) {
			deleteFromProgressFromFile(file, directory);
			TAP_Hdd_Fclose(file);
		}

		deleteRecHeader(file_to_delete, start_cluster);
	}
	ef (InDataFilesFolder(directory) && folder) {
		strcpy(temp2, directory);
		strcat(temp2, "/");
		strcat(temp2, file_to_delete);
		deleteRecHeaderForDir(temp2);
	}

	TAP_Hdd_Rename(file_to_delete, "ToBeDeleted.tmp");
	TAP_Hdd_Delete("ToBeDeleted.tmp"); 
	
	// for a skin file, delete skin from list
	if (isSkin(file_to_delete) && (strcmp(directory, "/ProgramFiles") == 0 || strcmp(directory, "/ProgramFiles/Settings/Skins") == 0)) {
		int found_idx = -1; 
		for (i = 0; i < skin_count; i++) {
			if (strcmp(skins[i].skin_name, file_to_delete) == 0 && skins[i].in_skins_folder == (strcmp(directory, "/ProgramFiles/Settings/Skins") == 0)) {
				found_idx = i;
				break;
			}
		}

		if (found_idx >= 0) {
			for (i = found_idx; i < skin_count-1; i++) {
				strcpy(skins[i].skin_name, skins[i+1].skin_name);
				skins[i].in_skins_folder = skins[i+1].in_skins_folder;
			}
			dlfree(skins[skin_count-1].skin_name);

			skin_count--;

			if (current_skin > found_idx && current_skin > 0)
				current_skin--;
		}
	}

	// tidy up any other files (cache, association, thumbnails, scenes etc)
	if (isPhoto(file_to_delete) || isRec(file_to_delete) || isMp3(file_to_delete)
			|| isRecycledPhoto(file_to_delete) || isRecycledRec(file_to_delete) || isRecycledMp3(file_to_delete)) {
		
		if (TAP_Hdd_Exist("Cache")) {
			ChangeDir("Cache");
			if (isPhoto(file_to_delete) || isMp3(file_to_delete)
					|| isRecycledPhoto(file_to_delete) || isRecycledMp3(file_to_delete)) {
				strcpy(file_name, file_to_delete);
				strcat(file_name, ".cache");
				if (TAP_Hdd_Exist(file_name)) {
					TAP_Hdd_Rename(file_name, "ToBeDeleted.tmp");
					TAP_Hdd_Delete("ToBeDeleted.tmp");
				}
				strcpy(file_name, file_to_delete);
				strcat(file_name, ".ass");
				if (TAP_Hdd_Exist(file_name)) {
					TAP_Hdd_Rename(file_name, "ToBeDeleted.tmp");
					TAP_Hdd_Delete("ToBeDeleted.tmp");
				}
			}

			strcpy(file_name, file_to_delete);
			strcat(file_name, ".tn");
			if (TAP_Hdd_Exist(file_name)) {
				TAP_Hdd_Rename(file_name, "ToBeDeleted.tmp");
				TAP_Hdd_Delete("ToBeDeleted.tmp");
			}

			// for a rec, also delete any scenes 
			if (isRec(file_to_delete) || isRecycledRec(file_to_delete)) {
				TYPE_File *first_scene = NULL;
				int no_of_scenes = 0;
				TAP_SPrint(file_name, "%s.tn.1", file_to_delete);
				first_scene = TAP_Hdd_Fopen(file_name);
				if (first_scene != NULL) {
					TAP_Hdd_Fread(&no_of_scenes, sizeof(int), 1, first_scene);
					TAP_Hdd_Fclose(first_scene);
				}
				for (i = 1; i <= no_of_scenes; i++) {
					TAP_SPrint(file_name, "%s.tn.%d", file_to_delete, i);
					TAP_Hdd_Rename(file_name, "ToBeDeleted.tmp");
					TAP_Hdd_Delete("ToBeDeleted.tmp");
				}
			}
			ChangeDir("..");
		}
	}
}

void doProgressTidy()
{
	TYPE_File rec_file;
	TYPE_PlayInfo play_info;
	TYPE_RecInfo rec_info_1, rec_info_2;
	int i;

	if (no_of_progress == 0)
		return;

	// check entries starting at the end
	for (i = no_of_progress-1; i >= 0; i--)
	{
		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		if ((play_info.file && play_info.playMode == PLAYMODE_Playing && strcmp(play_info.file->name, progress[i]->file_name) == 0)
				|| strcmp(rec_info_1.fileName, progress[i]->file_name) == 0
				|| strcmp(rec_info_2.fileName, progress[i]->file_name) == 0)
			continue;

		if (!ChangeDirCurrentRecording(progress[i]->file_name, progress[i]->start_cluster, &rec_file))
			deleteFromProgress(i);
	}
}

void doPlaylistTidy()
{
	TYPE_File file;
	int subfolder_count = 0, i;

	ChangeDirPlaylists();

	// first, check the default playlists
	doNamedPlaylistTidy(TRUE, "photo.pl");
	doNamedPlaylistTidy(FALSE, "mp3.pl");

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Tidy playlists");
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	ChangeDirPlaylists();

	// then check all other playlists
	i = TAP_Hdd_FindFirst(&file);
	while (i--) {
		if (isPhotoPlaylist(file.name)) 
		{
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check photo playlist %s", file.name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			doNamedPlaylistTidy(TRUE, file.name);
		}
		ef (isMp3Playlist(file.name)) 
		{
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check music playlist %s", file.name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			doNamedPlaylistTidy(FALSE, file.name);
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	// put back the original playlists
	if (strlen(photo_playlist_name) != 0) {
		strcpy(file_name, photo_playlist_name);
		strcat(file_name, ".ppl");
		loadNamedPlaylist(TRUE, file_name);
	}
	else {
		loadNamedPlaylist(TRUE, "photo.pl");
	}

	if (strlen(mp3_playlist_name) != 0) {
		strcpy(file_name, mp3_playlist_name);
		strcat(file_name, ".mpl");
		loadNamedPlaylist(FALSE, file_name);
	}
	else
		loadNamedPlaylist(FALSE, "mp3.pl");
}

void doFileTidy()
{
	word x = offset_x+120+2+10, y = offset_y+200, w = 360;
	TYPE_File file;
	int subfolder_count = 0, i;
	char **subfolders = dlmalloc(sizeof(*subfolders) * 2048);

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Tidy folder %s", tracked_dir);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	TAP_SPrint(buffer, "Tidying %s", tracked_dir);

	TAP_Osd_FillBox(region, x, y, w-5, 25, header_bg_colour);
	drawText(region, x, y, x+w-5, buffer, header_text_colour, COLOR_None, FNT_Size_1926);

	// check the Cache folder for obsolete files
	if (TAP_Hdd_Exist("Cache")) {
		ChangeDir("Cache");

		i = TAP_Hdd_FindFirst(&file);
		while (i--) {
			
			//TAP_Print("Check %s\r\n", file.name);

			// pop any .del files not listed in bin, into bin
			if (isRecycled(file.name)) 
			{
				// delete if not in recycle bin list
				if (existsInRecycleBinList(file.name, tracked_dir) < 0) {
					if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete file %s, %d", file.name, file.attr);
					if (write_log) if (verbose) logText(log_buffer, FALSE);
					if (file.attr == ATTR_FOLDER)
						appendToRecycleBinList(file.name, file.startCluster, tracked_dir, file.mjd, file.hour, file.min, file.size, TRUE);
					else
						appendToRecycleBinList(file.name, file.startCluster, tracked_dir, file.mjd, file.hour, file.min, file.size, FALSE);
				}
			}
			ef ((strcmp(file.name, "album.ass") != 0 && strcmp(file.name, "album.ass.cache") != 0)
					&& (isCache(file.name) || isThumbnail(file.name) || isScene(file.name) || isArtAssociation(file.name)))	
			{
				// chop off the extension
				strcpy(file_name, file.name);
				if (isCache(file.name))
					file_name[strlen(file.name) - 6] = '\0';     
				ef (isScene(file.name))
					file_name[strlen(file.name) - getExtensionLength(file.name) - 3] = '\0';   
				ef (isArtAssociation(file.name))
					file_name[strlen(file.name) - 4] = '\0';    
				else
					file_name[strlen(file.name) - 3] = '\0';  

				// check song associations (the full photo form has .cache ext which we just stripped)
				if (isArtAssociation(file_name))
					file_name[strlen(file_name) - 4] = '\0'; 

				// if corresponding file no longer exists, then delete Cache file
				ChangeDir("..");
				if (!TAP_Hdd_Exist(file_name)) {
					ChangeDir("Cache");
					if (enable_recycle_bin)
						doRecycle(file.name, file.startCluster, tracked_dir, file.mjd, file.hour, file.min, file.size, FALSE, FALSE);
					else
						doDelete(file.name, file.startCluster, tracked_dir, FALSE, FALSE);
				}
				else {
					ChangeDir("Cache");
				}
			}

			if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
				break;
		}

		ChangeDir("..");
	}

	// get all subfolders to check recursively, and put any .del files not listed in bin, in the bin
	i = TAP_Hdd_FindFirst(&file);
	while (i-- && subfolder_count < 2048) {
		
		// pop any .del files not listed in bin, into bin
		if (isRecycled(file.name)) 
		{
			// delete if not in recycle bin list
			if (existsInRecycleBinList(file.name, tracked_dir) < 0) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete file %s, %d", file.name, file.attr);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				if (file.attr == ATTR_FOLDER)
					appendToRecycleBinList(file.name, file.startCluster, tracked_dir, file.mjd, file.hour, file.min, file.size, TRUE);
				else
					appendToRecycleBinList(file.name, file.startCluster, tracked_dir, file.mjd, file.hour, file.min, file.size, FALSE);
			}
		}

		// add subfolder to list for recursion
		if (file.attr == ATTR_FOLDER 
				&& strcmp(file.name, "__ROOT__") != 0 
				&& strcmp(file.name, "__RECYCLE__") != 0
				&& strcmp(file.name, "Cache") != 0)	
		{

			subfolders[subfolder_count] = dlmalloc(100 * sizeof(char));
			strcpy(subfolders[subfolder_count], file.name);
			subfolder_count++;
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	for (i = 0; i < subfolder_count; i++)
	{
		ChangeDir(subfolders[i]);
		doFileTidy();
		ChangeDir("..");
	}

	for (i = 0; i < subfolder_count; i++)
	{
		dlfree(subfolders[i]);
		subfolders[i] = NULL;
	}
	dlfree(subfolders);
	subfolders = NULL;

	dlmalloc_trim(0);
}

void handleTidy()
{
	word x = offset_x+120+2+10, y = offset_y+200, w = 360;

	// display a 'processing' message
	processing_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);
	drawProcessingMessage(region, tidying_started_t, TRUE, FALSE, TRUE);
	TAP_Delay(50);

	// tidy rogue files, recycle bin & playlists
	ChangeToRoot(NULL);
	doFileTidy();
	TAP_Osd_FillBox(region, x, y, w-10, 25, header_bg_colour);
	drawText(region, x, y, x+w-10, tidying_recycle_bin_t, header_text_colour, COLOR_None, FNT_Size_1926);
	doRecycleBinTidy();
	TAP_Osd_FillBox(region, x, y, w-10, 25, header_bg_colour);
	drawText(region, x, y, x+w-10, tidying_playlists_t, header_text_colour, COLOR_None, FNT_Size_1926);
	doPlaylistTidy();
	TAP_Osd_FillBox(region, x, y, w-10, 25, header_bg_colour);
	drawText(region, x, y, x+w-5, tidying_recording_progress_t, header_text_colour, COLOR_None, FNT_Size_1926);
	doProgressTidy();
	TAP_Osd_FillBox(region, x, y, w-10, 25, header_bg_colour);
	drawText(region, x, y, x+w-5, tidying_finished_t, header_text_colour, COLOR_None, FNT_Size_1926);
	TAP_Delay(50);
	ChangeDirMediaManager();
	saveNavHistory(0, 0, TRUE);

	// delete the 'processing' message
	TAP_Osd_RestoreBox(region, 0, 0, 720, 576, processing_save);
	TAP_MemFree(processing_save);
	processing_save = NULL;
}

word emptyRecycleBin(bool smart_delete)
{
	int i, deleted_files = 0;

	if (!smart_delete) {
		// delete everything
		for (i = 0; i < no_of_files; i++)
			doDelete(recycle_bin_list[i]->file_name, recycle_bin_list[i]->start_cluster, recycle_bin_list[i]->directory, FALSE, TRUE);

		removeAllFromRecycleBinList();
		deleted_files = no_of_files;
	}
	else {
		// delete
		int bin_size = no_of_recycles;
		dword free_size, total_size, percentage_full, saved_ordering = recycle_ordering_mode;

		if (empty_bin_percentage > 0) {
			// order by date with oldest first
			recycle_ordering_mode = ORDER_BY_DATE;
			qsort(recycle_bin_list, no_of_recycles, sizeof(recycle_bin_list[0]), compareRecycling);

			// check how full the disk is
			free_size = TAP_Hdd_FreeSize();
			total_size = TAP_Hdd_TotalSize();
			if (total_size == 0) total_size = 250000;
			if (free_size > total_size) free_size = total_size;
			percentage_full = (total_size-free_size)*100 / total_size;

			// cycle round recycle bin entries until disk space ok
			while (percentage_full > empty_bin_percentage && no_of_recycles > 0) {

				// do the physical delete
				doDelete(recycle_bin_list[0]->file_name, recycle_bin_list[0]->start_cluster, recycle_bin_list[0]->directory, FALSE, TRUE);
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Remove entry %s", recycle_bin_list[0]->file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				removeFromRecycleBinList(0);
				deleted_files++;

				// check how full the disk is
				free_size = TAP_Hdd_FreeSize();
				total_size = TAP_Hdd_TotalSize();
				if (total_size == 0) total_size = 250000;
				if (free_size > total_size) free_size = total_size;
				percentage_full = (total_size-free_size)*100 / total_size;
			}

			recycle_ordering_mode = saved_ordering;
			qsort(recycle_bin_list, no_of_recycles, sizeof(recycle_bin_list[0]), compareRecycling);
		}

		if (empty_bin_days > 0) {
			TAP_GetTime(&mjd, &hour, &min, &sec);

			for (i = (no_of_recycles-1); i >= 0; i--) {
				if ((mjd - recycle_bin_list[i]->deletion_mjd) > empty_bin_days) {

					// do the physical delete
					doDelete(recycle_bin_list[i]->file_name, recycle_bin_list[i]->start_cluster, recycle_bin_list[i]->directory, FALSE, TRUE);
					if (write_log) if (verbose) TAP_SPrint(log_buffer, "Remove entry %s", recycle_bin_list[i]->file_name);
					if (write_log) if (verbose) logText(log_buffer, FALSE);
					removeFromRecycleBinList(i);
					deleted_files++;
				}
			}
		}
	}

	saveRecycleBinList();

	return deleted_files;
}

dword handleConfirmationBoxEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_VolUp :
		case RKEY_VolDown :

			// toggle between yes and no being selected
			yes_selected = yes_selected == TRUE ? FALSE : TRUE;
			toggleConfirmation();
			break;

		case RKEY_Ok :

			// if yes selected, then delete file and redisplay list, otherwise just delete confirmation box
			if (yes_selected)
			{
				TAP_MemFree(yes_no_save);
				yes_no_save = NULL;

				if (choose_multi_play_mode) {
					multi_play_batch_mode = MULTI_DECODE;
					if (overnight_play) {
						showJobDuration();
						
						// save the selected recs for later decoding
						saveSavedRecordings();
						clearMarkedRecordings();
						saveNavHistory(curr_idx, curr_highlight, FALSE);
						drawFileList(FALSE, FALSE);
						copyMemoryToWindow();
						window_displayed = TRUE;
					}
					else {
						TYPE_PlayInfo play_info;
						multi_play_started = TRUE;

						if (decode_channel)
							TAP_Channel_Start(1, SVC_TYPE_Tv, decode_channel == 30000 ? getRecHeaderDetail(marked_recordings[0].file_name) : decode_channel - 1);
						TAP_Channel_GetCurrent(&tv_radio, &current_channel_number);

						TAP_Hdd_PlayTs(marked_recordings[0].file_name);
						TAP_Delay(50);
						TAP_Hdd_ChangePlaybackPos(0);

						// if there was already a playback in progress, then update the details with the new playback
						TAP_Hdd_GetPlayInfo(&play_info);
						handlePlaybackWhenExistingPlayback(play_info);

						// kick off the fast copy if a decode batch job
						copy_recording = TRUE;
						copy_successful = FALSE;
						copy_step = 0;
						copy_delay = 400;

						handleExitKey(TRUE, TRUE);
					}

					choose_multi_play_mode = FALSE;
					confirmation_box_displayed = FALSE;
					return 0;
				}
				ef (confirm_video_job) {
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					TAP_EnterNormal();
					handleVideoBatchJob(FALSE);
					confirmation_box_displayed = FALSE;
					confirm_video_job = FALSE;
					return 0;
				}
				ef (smart_delete)
					// do the deletion now (smart_delete & delete_all only apply to the recycle bin)
					emptyRecycleBin(TRUE);
				ef (delete_all)
					// do the deletion now (smart_delete & delete_all only apply to the recycle bin)
					emptyRecycleBin(FALSE);
				ef (delete_active_rec) {
					if (enable_recycle_bin)
						doRecycle(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, curr_dir, dir_info[curr_idx]->mjd, dir_info[curr_idx]->hour, dir_info[curr_idx]->min, dir_info[curr_idx]->size, FALSE, FALSE);
					else
						doDelete(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, curr_dir, FALSE, FALSE);
				}
				ef (stop_active_rec) {
					TYPE_RecInfo rec_info_1, rec_info_2;

					TAP_Hdd_GetRecInfo(0, &rec_info_1);
					TAP_Hdd_GetRecInfo(1, &rec_info_2);
				
					if (write_log) if (verbose) logText("Stop video recording", FALSE);

					// stop recording 1
					if (IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0) {
						if (rec_info_1.recordedSec < 120)
							deleteFromProgressFromDirInfo(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster);
						else
							updateProgressDataForTruncatedRecording(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, rec_info_1);

						TAP_Hdd_StopRecord(0);
					}
						
					// stop recording 2
					if (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0) {
						if (rec_info_2.recordedSec < 120)
							deleteFromProgressFromDirInfo(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster);
						else
							updateProgressDataForTruncatedRecording(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, rec_info_2);

						TAP_Hdd_StopRecord(1);
					}

					// if file no longer there, then must have been a rec < 2 mins, so just refresh list
					saveNavHistory(curr_idx, curr_highlight, FALSE);
					if (!TAP_Hdd_Exist(dir_info[curr_idx]->file_name)) {
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rec file %s gone after stop", dir_info[curr_idx]->file_name);
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						populateFiles();
					}

					if (thumbnail_mode)	{
						drawThumbnailGrid(FALSE);
					}
					else {
						drawFileList(FALSE, FALSE);
					}
					copyMemoryToWindow();
	
					stop_active_rec = FALSE;
					confirmation_box_displayed = FALSE;
					window_displayed = TRUE;
					return 0;
				}
				else {
					if (stop_menu_displayed) {
						TYPE_File rec_file;

						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Attempt to locate %s directory", playing_file.name);
						if (write_log) if (verbose) logText(log_buffer, TRUE);
						if (ChangeDirCurrentRecording(playing_file.name, playing_file.startCluster, &rec_file)) {
							if (write_log) if (verbose) logText("Located directory", FALSE);
							doDelete(playing_file.name, playing_file.startCluster, tracked_dir, FALSE, FALSE);
						}
						else {
							if (write_log) if (verbose) logText("Failed to locate directory", FALSE);
						}
						ChangeDirPath(curr_dir);
					}
					else {
						if (recycle_bin_displayed) {
							doDelete(recycle_bin_list[curr_idx]->file_name, recycle_bin_list[curr_idx]->start_cluster, recycle_bin_list[curr_idx]->directory, FALSE, TRUE);
							removeFromRecycleBinList(curr_idx);
							saveRecycleBinList();
						}
						ef (auto_deletes_displayed) {
							removeAllFromAutoDeleteList();
						}
						else
							doDelete(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, curr_dir, dir_info[curr_idx]->folder, FALSE);
					}
				}

				if (stop_menu_displayed) {
					ChangeDirPath(curr_dir);
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					TAP_EnterNormal();
					stop_menu_displayed = FALSE;
				}
				ef (auto_deletes_displayed) {
					auto_delete_idx = 0, auto_delete_highlight = 0;
					drawAutoDeleteList(FALSE);
					copyMemoryToWindow();
					window_displayed = TRUE;
				}
				else {
					if (thumbnail_mode && !recycle_bin_displayed) {
						if (curr_idx == (no_of_files - 1))	{
							curr_idx--;
							curr_highlight = curr_highlight == 0 ? 2 : curr_highlight - 1;
						}
						populateFiles();
						drawBlankThumbnailGrid();
						drawThumbnails(curr_idx - curr_highlight);
						drawThumbnailGridHeader();
						drawThumbnailGridFooter();
						updateThumbnailCount();
						window_displayed = TRUE;
					}
					else {
						if (smart_delete) {
							if (curr_idx > no_of_recycles - 1) {
								curr_idx = 0;
								curr_highlight = 0;
							}
						}
						else {
							// if at end of list, then move idx up
							if (no_of_files > 1)
								adjustIndexForDelete(&curr_idx, &curr_highlight, no_of_files, (InDataFilesFolder(curr_dir) && !recycle_bin_displayed) ? line_count : 10);							
						}

						if (recycle_bin_displayed) {
							no_of_files = no_of_recycles;
							saved_recycle_idx = curr_idx; saved_recycle_highlight = curr_highlight;
						}
						else {
							populateFiles();
							saveNavHistory(curr_idx, curr_highlight, FALSE);
						}
						drawFileList(FALSE, FALSE);
						window_displayed = TRUE;
					}
					copyMemoryToWindow();
					drawDiskSpaceInfoBox();
				}
			}
			else
			{
				if (choose_multi_play_mode) {
					TYPE_PlayInfo play_info;
					multi_play_batch_mode = MULTI_PLAY;
					if (overnight_play) {
						showJobDuration();

						// save the selected recs for later playback
						saveSavedRecordings();
						clearMarkedRecordings();
						saveNavHistory(curr_idx, curr_highlight, FALSE);
						drawFileList(FALSE, FALSE);
						copyMemoryToWindow();
						window_displayed = TRUE;
					}
					else {
						multi_play_started = TRUE;
						TAP_Hdd_PlayTs(marked_recordings[0].file_name);
						TAP_Delay(50);
						TAP_Hdd_ChangePlaybackPos(0);

						// if there was already a playback in progress, then update the details with the new playback
						TAP_Hdd_GetPlayInfo(&play_info);
						handlePlaybackWhenExistingPlayback(play_info);
						handleExitKey(TRUE, TRUE);
					}
					
					TAP_MemFree(yes_no_save);
					yes_no_save = NULL;
					
					choose_multi_play_mode = FALSE;
					confirmation_box_displayed = FALSE;
					return 0;
				}
				ef (stop_menu_displayed) {
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					TAP_EnterNormal();
					stop_menu_displayed = FALSE;
				}
				ef (confirm_video_job) {
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					TAP_EnterNormal();
					confirm_video_job = FALSE;
				}
				else {
					TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, yes_no_save);
					TAP_Osd_RestoreBox(region, 0, 0, 720, 576, yes_no_save);
					window_displayed = TRUE;
				}
				TAP_MemFree(yes_no_save);
				yes_no_save = NULL;
			}

			smart_delete = FALSE;
			delete_all = FALSE;
			delete_active_rec = FALSE;
			stop_active_rec = FALSE;
			confirmation_box_displayed = FALSE;
			break;

		case RKEY_Exit:
			// delete info OSD and return to file list
			if (choose_multi_play_mode) {
				if (write_log) if (verbose) logText("Exit confirmation box", FALSE);
				TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, yes_no_save);
				TAP_Osd_RestoreBox(region, 0, 0, 720, 576, yes_no_save);
				TAP_MemFree(yes_no_save);
				yes_no_save = NULL;
					
				choose_multi_play_mode = FALSE;
				confirmation_box_displayed = FALSE;
				window_displayed = TRUE;
			}
			break;
	}

	return 0;
}

dword handleInfoBoxEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_Ok :

			//TAP_Osd_RestoreBox(region_mem, X+60-2, Y+100-2, W-120+14, 150+14, info_save);
			//TAP_Osd_RestoreBox(region, X+60-2, Y+100-2, W-120+14, 150+14, info_save);
			TAP_MemFree(info_save);
			info_save = NULL;

			if (stop_menu_displayed) {
				ChangeDirPath(curr_dir);
				TAP_Osd_Delete(region);
				TAP_Osd_Delete(region_mem);
				TAP_EnterNormal();
				stop_menu_displayed = FALSE;
			}
			ef (auto_deletes_displayed) {
				drawAutoDeleteList(FALSE);
				copyMemoryToWindow();
				drawDiskSpaceInfoBox();
				window_displayed = TRUE;
			}
			ef (thumbnail_mode || scenes_displayed) {
				drawBlankThumbnailGrid();
				drawThumbnails(curr_idx - curr_highlight);
				drawThumbnailGridHeader();
				drawThumbnailGridFooter();
				updateThumbnailCount();
				copyMemoryToWindow();
				drawDiskSpaceInfoBox();
				window_displayed = TRUE;
			}
			else {
				saveNavHistory(curr_idx, curr_highlight, FALSE);
				drawFileList(FALSE, FALSE);
				copyMemoryToWindow();
				drawDiskSpaceInfoBox();
				window_displayed = TRUE;
			}

			info_box_displayed = FALSE;
			break;
	}

	return 0;
}

void handlePinNumber(dword param1)
{
	TYPE_PlayInfo play_info;
	word string_length, indent;
	word x = X+110, y = Y+120, w = W-220, h = 150;

	switch (param1)
	{
		case RKEY_0: entered_pin[pin_counter] = '0';	break;
		case RKEY_1: entered_pin[pin_counter] = '1';	break;
		case RKEY_2: entered_pin[pin_counter] = '2';	break;
		case RKEY_3: entered_pin[pin_counter] = '3';	break;
		case RKEY_4: entered_pin[pin_counter] = '4';	break;
		case RKEY_5: entered_pin[pin_counter] = '5';	break;
		case RKEY_6: entered_pin[pin_counter] = '6';	break;
		case RKEY_7: entered_pin[pin_counter] = '7';	break;
		case RKEY_8: entered_pin[pin_counter] = '8';	break;
		case RKEY_9: entered_pin[pin_counter] = '9';	break;
	}

	pin_counter++;
	switch (pin_counter) {
		case 1:
			TAP_SPrint(buffer, "# _ _ _");
			break;
		case 2:
			TAP_SPrint(buffer, "# # _ _");
			break;
		case 3:
			TAP_SPrint(buffer, "# # # _");
			break;
		case 4:
			TAP_SPrint(buffer, "# # # #");
			break;
	}

	string_length = getWidth(buffer, FNT_Size_1622);
	indent = x + ((w - string_length) / 2);
	TAP_Osd_FillBox(region_mem, x+5, y+70, w-10, 50, body_bg_colour);
	drawText(region_mem, indent, y+75, x+w-4, buffer, folder_text_colour, COLOR_None, FNT_Size_1622);
	TAP_Osd_Copy(region_mem, region, x, y, w, h, x, y, FALSE);

	if (pin_counter == 4) {
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Entered PIN is %s", entered_pin);
		if (write_log) if (verbose) logText(log_buffer, FALSE);
		pin_box_displayed = FALSE;
		TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, pin_save);
		TAP_Osd_RestoreBox(region, 0, 0, 720, 576, pin_save);
		TAP_MemFree(pin_save);
		pin_save = NULL;

		if (strcmp(toppy_pin, entered_pin) == 0) {
			if (pin_play_type == PLAY_FROM_SCENE) {
				extractRecordingName(dir_info[curr_idx]->file_name, file_name);
				TAP_Hdd_PlayTs(file_name);
			}
			else {
				TAP_Hdd_PlayTs(dir_info[curr_idx]->file_name);
			}

			TAP_Hdd_GetPlayInfo(&play_info);

			if (pin_play_type == PLAY_FROM_START) {
				if (isRadioRecording(curr_idx)) {
					TAP_Delay(50);
					TAP_Hdd_ChangePlaybackPos(0);
				}
				else
					gotoAccurateBookmark(2);
			}

			if (pin_play_type == PLAY_FROM_LAST_WATCHED) {
				if (play_info.playMode == PLAYMODE_Playing && play_info.file) {
					int current_block, total_block;

					// if there was already a playback in progress, then update the details with the new playback
					handlePlaybackWhenExistingPlayback(play_info);

					saveExtendedInfo();
					current_block = getCurrentBlockFromFile(play_info.file);
					total_block = getTotalBlockFromFile(play_info.file);
					if (isRadioRecording(curr_idx)) {
						// deduct a minute due to firmware bug, and then delay, also due to firmware bug
						word blocks_in_a_minute = play_info.totalBlock / play_info.duration;
						current_block = (current_block - blocks_in_a_minute < 0) ? 0 : (current_block - blocks_in_a_minute);
						TAP_Delay(50);
						TAP_Hdd_ChangePlaybackPos(current_block);
					}
					else {
						if (current_block >= total_block) current_block = 0;

						if (current_block > 50)
							TAP_Hdd_ChangePlaybackPos(current_block);
						else
							gotoAccurateBookmark(2);
					}
				}
			}

			if (pin_play_type == PLAY_FROM_SCENE) {
				int skip_position;

				// if there was already a playback in progress, then update the details with the new playback
				handlePlaybackWhenExistingPlayback(play_info);

				saveExtendedInfo();
				skip_position = getCurrentBlockFromScene(dir_info[curr_idx]->file_name);
				if (play_info.playMode == PLAYMODE_Playing && skip_position > play_info.totalBlock) skip_position = 0;
				TAP_Hdd_ChangePlaybackPos(skip_position);
				scenes_displayed = FALSE;
			}

			handleExitKey(TRUE, TRUE);
		}
		else {
			// display info message			
			TAP_SPrint(buffer, "%s", wrong_pin_t);
			drawInfoBox(invalid_pin_t, buffer, NULL, TRUE, TRUE);
			info_box_displayed = TRUE;
			window_displayed = FALSE;
		}
	}
}

dword handlePinBoxEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_0:

			handlePinNumber(param1);
			break;

		case RKEY_1:

			handlePinNumber(param1);
			break;

		case RKEY_2:

			handlePinNumber(param1);
			break;

		case RKEY_3:

			handlePinNumber(param1);
			break;

		case RKEY_4:

			handlePinNumber(param1);
			break;

		case RKEY_5:

			handlePinNumber(param1);
			break;

		case RKEY_6:

			handlePinNumber(param1);
			break;

		case RKEY_7:

			handlePinNumber(param1);
			break;

		case RKEY_8:

			handlePinNumber(param1);
			break;

		case RKEY_9:

			handlePinNumber(param1);
			break;

		case RKEY_Exit:

			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, pin_save);
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, pin_save);
			TAP_MemFree(pin_save);
			pin_save = NULL;
			pin_box_displayed = FALSE;
			window_displayed = TRUE;
			break;
	}

	return 0;
}

void handleAutoDeleteUpdateKey()
{
	if (write_log) if (verbose) logText("Displaying auto delete update box", FALSE);
	auto_delete_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);
	auto_delete_update_displayed = TRUE;
	auto_delete_update_idx = auto_delete_update_highlight = 0;
	drawAutoDeleteUpdateBox();
}

dword handleAutoDeleteListEventKey(dword param1)
{
	word deleted_files;

	switch(param1)
	{
		case RKEY_Menu:

			handleMenuKey();
			break;

		case RKEY_Recall :
		
			// run the auto delete rules now
			if (no_of_auto_deletes == 0 || no_of_marked_recordings > 0)
				break;
				
			// display a 'processing' message
			processing_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);
			drawProcessingMessage(region, running_auto_del_t, FALSE, FALSE, TRUE);

			deleted_files = runAutoDeleteRules(auto_delete_idx);

			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, processing_save);
			TAP_MemFree(processing_save);
			processing_save = NULL;

			drawDiskSpaceInfoBox();

			// display info message
			if (deleted_files == 1)
				TAP_SPrint(buffer, "%d %s", deleted_files, file_deleted_t);
			else
				TAP_SPrint(buffer, "%d %s", deleted_files, files_deleted_t);
			drawInfoBox(auto_delete_results_t, buffer, NULL, TRUE, TRUE);
			info_box_displayed = TRUE;
			window_displayed = FALSE;

			break;

		case RKEY_Play :

			// run all the auto delete rules now
			if (no_of_auto_deletes == 0 || no_of_marked_recordings > 0)
				break;
				
			// display a 'processing' message
			processing_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);
			drawProcessingMessage(region, running_auto_del_t, FALSE, FALSE, TRUE);

			deleted_files = runAutoDeleteRules(-1);

			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, processing_save);
			TAP_MemFree(processing_save);
			processing_save = NULL;

			drawDiskSpaceInfoBox();

			// display info message
			TAP_SPrint(buffer, "'%d' %s", deleted_files, files_deleted_t);
			drawInfoBox(auto_delete_results_t, buffer, NULL, TRUE, TRUE);
			info_box_displayed = TRUE;
			window_displayed = FALSE;

			break;

		case RKEY_Ok :

			// update the auto delete rules
			if (no_of_auto_deletes == 0)
				break;
			
			new_auto_delete = FALSE;
			copyAutoDeleteEntry(auto_delete_idx);
			handleAutoDeleteUpdateKey();
			break;

		case RKEY_White :

			// delete auto delete rule
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete auto delete rules %d", auto_delete_idx);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			if (no_of_auto_deletes == 0)
				break;

			saved_idx = auto_delete_idx;

			// if at end of list and only one page full, then move idx & highlight up
			if (no_of_auto_deletes > 0)
				adjustIndexForDelete(&auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);

			removeFromAutoDeleteList(saved_idx);
			drawAutoDeleteList(FALSE);
			copyMemoryToWindow();
			break;

		case RKEY_Green :

			// delete all auto delete
			if (no_of_auto_deletes == 0)
				break;

			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			drawConfirmationBox();
			window_displayed = FALSE;
			break;

		case RKEY_Red :
		case RKEY_9 :

			// create new rule set
			appendToAutoDeleteList("");
			saved_auto_delete_idx = auto_delete_idx; saved_auto_delete_highlight = auto_delete_highlight;
			auto_delete_idx = no_of_auto_deletes - 1;
			auto_delete_highlight = (auto_delete_idx < 10) ? auto_delete_idx : 9;
			new_auto_delete = TRUE;
			memset(keyboard_name, '\0', 100);
			cursor_pointer = 0;
			new_folder = FALSE;
			handleKeyboardKey();
			break;

		case RKEY_1:

			// shuffle entry up
			if (auto_delete_idx > 0) {
				moveAutoDeleteEntryUp(auto_delete_idx);
				shuffleUpFileList(AUTO_DELETE_NAVIGATION, &auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);
			}
			break;

		case RKEY_3:

			// shuffle entry down
			if (auto_delete_idx < no_of_auto_deletes - 1) {
				moveAutoDeleteEntryDown(auto_delete_idx);
				shuffleDownFileList(AUTO_DELETE_NAVIGATION, &auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);
			}
			break;

		case RKEY_Exit :
		case RKEY_TvSat :

			if (write_log) if (verbose) logText("Exit auto delete list", FALSE);
			saveAutoDeleteList();
			auto_deletes_displayed = FALSE;
			//saved_auto_delete_idx = 0;
#ifndef WIN32
			ChangeDirPath(curr_dir);
#endif
			populateFiles();

			if (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(FALSE, FALSE);
			}
			copyMemoryToWindow();
			window_displayed = TRUE;
			break;

		case RKEY_Text:

			handleHelpKey();
			break;

		case RKEY_ChUp :

			shuffleUpFileList(AUTO_DELETE_NAVIGATION, &auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(AUTO_DELETE_NAVIGATION, &auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);
			break;
		
		case RKEY_VolDown :

			if (page_with_arrows)
				pageBackFileList(AUTO_DELETE_NAVIGATION, &auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);
			break;
		
		case RKEY_VolUp :
			
			if (page_with_arrows)
				pageForwardFileList(AUTO_DELETE_NAVIGATION, &auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);
			break;

		case RKEY_Rewind :

			if (!page_with_arrows)
				pageBackFileList(AUTO_DELETE_NAVIGATION, &auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);
			break;

		case RKEY_Forward :

			if (!page_with_arrows)
				pageForwardFileList(AUTO_DELETE_NAVIGATION, &auto_delete_idx, &auto_delete_highlight, no_of_auto_deletes, 10);
			break;
	}

	return 0;
}

dword handleSkinEditorEventKey(dword param1)
{
	word i;
	bool skin_exists;

	switch(param1)
	{
		case RKEY_Menu:

			//handleMenuKey();
			handleLoadSkinKey();
			break;

		case RKEY_Text:
		case RKEY_Play:

			handleHelpKey();
			break;

		case RKEY_TvRadio:

			handleLoadSkinKey();
			break;
				
		case RKEY_Ok :

			if (no_of_skin_elements == 0)
				return 0;

			// apply new skin to current display
			loadSkinElementsFromMemory(no_of_skin_elements, W, 30);
			drawSkinEditor(FALSE);
			copyMemoryToWindow();
			drawMp3InfoBox();
			drawDiskSpaceInfoBox();
			break;

		case RKEY_Record :
		case RKEY_9:
		
			// save new skin to disk
			memset(keyboard_name, '\0', 100);
			strncat(keyboard_name, skin_file_name, strlen(skin_file_name)-4);
			cursor_pointer = strlen(keyboard_name);
			new_folder = FALSE;
			handleKeyboardKey();
			break;
		
		case RKEY_White:
		case RKEY_7:

			if (no_of_skin_elements == 0)
				return 0;

			saved_idx = skin_editor_idx;

			// if at end of list, then move idx up
			adjustIndexForDelete(&skin_editor_idx, &skin_editor_highlight, no_of_skin_elements, 10);

			// shuffle up recycles and delete last entry
			for (i = saved_idx; i < (no_of_skin_elements-1); i++)
			{
				strcpy(skin_elements[i]->element_name, skin_elements[i+1]->element_name);
				strcpy(skin_elements[i]->element_comment, skin_elements[i+1]->element_comment);
				skin_elements[i]->red = skin_elements[i+1]->red;
				skin_elements[i]->green = skin_elements[i+1]->green;
				skin_elements[i]->blue = skin_elements[i+1]->blue;
			}
			dlfree(skin_elements[no_of_skin_elements-1]->element_name);
			skin_elements[no_of_skin_elements-1]->element_name = NULL;
			dlfree(skin_elements[no_of_skin_elements-1]->element_comment);
			skin_elements[no_of_skin_elements-1]->element_comment = NULL;
			dlfree(skin_elements[no_of_skin_elements-1]);
			skin_elements[no_of_skin_elements-1] = NULL;
			no_of_skin_elements--;

			// redraw the editor
			drawSkinEditor(FALSE);
			copyMemoryToWindow();
			drawMp3InfoBox();
			drawDiskSpaceInfoBox();
			break;

		case RKEY_Red:
		case RKEY_8:

			handleSkinElementKey();
			break;

		case RKEY_Blue:

			if (strcmp(tracked_dir, "/ProgramFiles") != 0 && strcmp(tracked_dir, "/ProgramFiles/Settings/Skins") != 0)
				return 0;

			// see if in list
			skin_exists = skinInList(skin_file_name, strcmp(tracked_dir, "/ProgramFiles/Settings/Skins") == 0);

			// add if not there
			if (!skin_exists) {
				skins[skin_count].skin_name = dlmalloc(100);
				strcpy(skins[skin_count].skin_name, skin_file_name);
				skins[skin_count].in_skins_folder = (strcmp(tracked_dir, "/ProgramFiles/Settings/Skins") == 0);
				skin_count++;
				qsort(skins, skin_count, sizeof(skins[0]), compareSkins);
			}

			// switch to this skin
			for (i = 0; i < skin_count; i++)
			{
				if (strcmp(skins[i].skin_name, skin_file_name) == 0 && skins[i].in_skins_folder == (strcmp(tracked_dir, "/ProgramFiles/Settings/Skins") == 0))
					current_skin = i;
			}

			ChangeDirMediaManager();
			SaveConfigurationToFile();
			ChangeDirPath(curr_dir);

			// display info message
			TAP_SPrint(buffer, "%s", new_skin_is_t);
			memset(buffer2, '\0', 100);
			strncat(buffer2, skin_file_name, strlen(skin_file_name)-4);
			drawInfoBox(skin_change_t, buffer, buffer2, FALSE, TRUE);
			TAP_Delay(150);
			TAP_Osd_RestoreBox(region_mem, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
			TAP_Osd_RestoreBox(region, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
			TAP_MemFree(info_save);
			info_save = NULL;
			break;

		case RKEY_Yellow:
		
			if (no_of_skin_elements == 0)
				return 0;

			switch (skin_colour_idx) {
				case 0:
					skin_elements[skin_editor_idx]->red = (skin_elements[skin_editor_idx]->red + 1) % 256; break;
				case 1:
					skin_elements[skin_editor_idx]->green = (skin_elements[skin_editor_idx]->green + 1) % 256; break;
				case 2:
					skin_elements[skin_editor_idx]->blue = (skin_elements[skin_editor_idx]->blue + 1) % 256; break;
			}
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;

		case RKEY_Green:

			if (no_of_skin_elements == 0)
				return 0;

			switch (skin_colour_idx) {
				case 0:
					skin_elements[skin_editor_idx]->red = skin_elements[skin_editor_idx]->red == 0 ? 255 : skin_elements[skin_editor_idx]->red - 1; break;
				case 1:
					skin_elements[skin_editor_idx]->green = skin_elements[skin_editor_idx]->green == 0 ? 255 : skin_elements[skin_editor_idx]->green - 1; break;
				case 2:
					skin_elements[skin_editor_idx]->blue = skin_elements[skin_editor_idx]->blue == 0 ? 255 : skin_elements[skin_editor_idx]->blue - 1; break;
			}
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;

		case RKEY_1:

			if (no_of_skin_elements == 0)
				return 0;

			skin_elements[skin_editor_idx]->red = skin_elements[skin_editor_idx]->red > 240 ? 15 - (256 - skin_elements[skin_editor_idx]->red) : skin_elements[skin_editor_idx]->red + 15;
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;

		case RKEY_4:

			if (no_of_skin_elements == 0)
				return 0;

			skin_elements[skin_editor_idx]->red = skin_elements[skin_editor_idx]->red < 15 ? 256 - (15 - skin_elements[skin_editor_idx]->red) : skin_elements[skin_editor_idx]->red - 15;
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;
		
		case RKEY_2:

			if (no_of_skin_elements == 0)
				return 0;

			skin_elements[skin_editor_idx]->green = skin_elements[skin_editor_idx]->green > 240 ? 15 - (256 - skin_elements[skin_editor_idx]->green) : skin_elements[skin_editor_idx]->green + 15;
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;

		case RKEY_5:

			if (no_of_skin_elements == 0)
				return 0;

			skin_elements[skin_editor_idx]->green = skin_elements[skin_editor_idx]->green < 15 ? 256 - (15 - skin_elements[skin_editor_idx]->green) : skin_elements[skin_editor_idx]->green - 15;
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;

		case RKEY_3:

			if (no_of_skin_elements == 0)
				return 0;

			skin_elements[skin_editor_idx]->blue = skin_elements[skin_editor_idx]->blue > 240 ? 15 - (256 - skin_elements[skin_editor_idx]->blue) : skin_elements[skin_editor_idx]->blue + 15;
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;

		case RKEY_6:

			if (no_of_skin_elements == 0)
				return 0;

			skin_elements[skin_editor_idx]->blue = skin_elements[skin_editor_idx]->blue < 15 ? 256 - (15 - skin_elements[skin_editor_idx]->blue) : skin_elements[skin_editor_idx]->blue - 15;
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;

		case RKEY_Exit :

			if (write_log) if (verbose) logText("Exit skin editor", FALSE);
			for (i = 0; i < no_of_skin_elements; i++) {
				if (skin_elements[i]) {
					if (skin_elements[i]->element_name) {
						dlfree(skin_elements[i]->element_name);
						skin_elements[i]->element_name = NULL;
					}
					if (skin_elements[i]->element_comment) {
						dlfree(skin_elements[i]->element_comment);
						skin_elements[i]->element_comment = NULL;
					}
					dlfree(skin_elements[i]);
					skin_elements[i] = NULL;
				}
			}

			if (skin_elements) {
				dlfree(skin_elements);
				skin_elements = NULL;
			}

			dlmalloc_trim(0);

			// swap skin back to standard one
			strcpy(skin_file_name, skins[current_skin].skin_name);
			if (skins[current_skin].in_skins_folder)
				ChangeDirSkins();
			else
				ChangeDirProgramFiles();
			loadSkinElements(W, 30);
			ChangeDirPath(curr_dir);
			if (thumbnail_mode) {
				TAP_Osd_Delete(region);
				region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
			}
			strcpy(file_name, dir_info[curr_idx]->file_name);
			populateFiles();
			for (i = 0; i < no_of_files; i++) {
				if (strcmp(dir_info[i]->file_name, file_name) == 0) {
					saveNavHistory(i, -1, TRUE);
					break;
				}
			}
		
			skin_editor_displayed = FALSE;
			if (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(TRUE, TRUE);
				drawMp3InfoBox();
			}
			copyMemoryToWindow();
			break;

		case RKEY_ChUp :

			shuffleUpFileList(SKIN_EDITOR_NAVIGATION, &skin_editor_idx, &skin_editor_highlight, no_of_skin_elements, 10);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(SKIN_EDITOR_NAVIGATION, &skin_editor_idx, &skin_editor_highlight, no_of_skin_elements, 10);
			break;

		case RKEY_Rewind :

			pageBackFileList(SKIN_EDITOR_NAVIGATION, &skin_editor_idx, &skin_editor_highlight, no_of_skin_elements, 10);
			break;

		case RKEY_Forward :

			pageForwardFileList(SKIN_EDITOR_NAVIGATION, &skin_editor_idx, &skin_editor_highlight, no_of_skin_elements, 10);
			break;

		case RKEY_VolUp :
			
			if (no_of_skin_elements == 0)
				break;

			skin_colour_idx = (skin_colour_idx + 1) % 3;
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;

		case RKEY_VolDown :

			if (no_of_skin_elements == 0)
				break;

			skin_colour_idx = skin_colour_idx == 0 ? 2 : skin_colour_idx - 1;
			drawSkinEditorLine(skin_editor_highlight, skin_editor_idx);
			copyMemoryToWindow();
			break;
	}

	return 0;
}

dword handleSkinElementEventKey(dword param1)
{
	word i;

	switch (param1)
	{
		case RKEY_Ok :

			if (write_log) if (verbose) logText("Insert skin elements", FALSE);

			// insert the new element at the end
			if (no_of_skin_elements == 0)
				skin_elements = dlmalloc(sizeof(*skin_elements) * 256);
			skin_elements[no_of_skin_elements] = dlmalloc(sizeof(*skin_elements[no_of_skin_elements])); 
			memset(skin_elements[no_of_skin_elements], 0, sizeof (*skin_elements[no_of_skin_elements]));

			skin_elements[no_of_skin_elements]->element_name = dlmalloc(40);
			skin_elements[no_of_skin_elements]->element_comment = dlmalloc(256);
			strcpy(skin_elements[no_of_skin_elements]->element_name, insert_elements[skin_element_idx]);
			strcpy(skin_elements[no_of_skin_elements]->element_comment, "// ");
			for (i = 0; i < SKIN_ELEMENT_COUNT; i++) {
				if (strcmp(skin_element_names[i].name, skin_elements[no_of_skin_elements]->element_name) == 0) {
					strcat(skin_elements[no_of_skin_elements]->element_comment, skin_element_names[i].description);
					break;
				}
			}
			skin_elements[no_of_skin_elements]->red = 0;
			skin_elements[no_of_skin_elements]->green = 0;
			skin_elements[no_of_skin_elements]->blue = 0;
			no_of_skin_elements++;

			// reset the highlight line to the last element
			skin_editor_idx = no_of_skin_elements - 1;
			skin_editor_highlight = (no_of_skin_elements > 10) ? 9 : no_of_skin_elements - 1;

			// free any memory
			TAP_MemFree(skin_element_save);
			skin_element_save = NULL;
			for (i = 0; i < no_of_insert_elements; i++) {
				if (insert_elements[i] != NULL) {
					dlfree(insert_elements[i]);
					insert_elements[i] = NULL;
				}
			}
			dlmalloc_trim(0);

			// redraw the screen
			skin_elements_displayed = FALSE;
			window_displayed = TRUE;
			drawSkinEditor(FALSE);
			copyMemoryToWindow();
			break;

		case RKEY_Exit :
					
			// return to file list
			if (write_log) if (verbose) logText("Exit skin elements", FALSE);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, skin_element_save);
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, skin_element_save);
			TAP_MemFree(skin_element_save);
			skin_element_save = NULL;
			for (i = 0; i < no_of_insert_elements; i++) {
				if (insert_elements[i] != NULL) {
					dlfree(insert_elements[i]);
					insert_elements[i] = NULL;
				}
			}
			dlmalloc_trim(0);
			skin_elements_displayed = FALSE;
			window_displayed = TRUE;
			break;

		case RKEY_ChUp :

			shuffleUpFileList(SKIN_ELEMENT_NAVIGATION, &skin_element_idx, &skin_element_highlight, no_of_insert_elements, 8);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(SKIN_ELEMENT_NAVIGATION, &skin_element_idx, &skin_element_highlight, no_of_insert_elements, 8);
			break;
		
		case RKEY_Rewind :

			pageBackFileList(SKIN_ELEMENT_NAVIGATION, &skin_element_idx, &skin_element_highlight, no_of_insert_elements, 8);
			break;

		case RKEY_Forward :

			pageForwardFileList(SKIN_ELEMENT_NAVIGATION, &skin_element_idx, &skin_element_highlight, no_of_insert_elements, 8);
			break;
	}

	return 0;
}

dword handleRecycleBinEventKey(dword param1)
{
	bool renamed = FALSE;

	switch(param1)
	{
		case RKEY_Menu:
			
			handleMenuKey();
			break;
			
		case RKEY_White :

			// delete highlighted file permanently
			if (no_of_files == 0)
				break;

			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete file %d for ever", curr_idx);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			drawConfirmationBox();
			window_displayed = FALSE;
			break;

		case RKEY_Green :

			// empty bin
			if (no_of_files == 0)
				break;

			if (write_log) if (verbose) logText("Delete all files for ever", FALSE);
			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			delete_all = TRUE;
			drawConfirmationBox();
			window_displayed = FALSE;
			break;

		case RKEY_Yellow :

			// restore file
			if (no_of_files == 0)
				break;

			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Restore file %s in %s from recycle bin", recycle_bin_list[curr_idx]->file_name, recycle_bin_list[curr_idx]->directory);
			if (write_log) if (verbose) logText(log_buffer, FALSE);

			memset(buffer2, '\0', 100);
			strncat(buffer2, recycle_bin_list[curr_idx]->file_name, strlen(recycle_bin_list[curr_idx]->file_name)-4);
			if (recycle_bin_list[curr_idx]->folder)
				TAP_SPrint(buffer, "%s '%s'", restoring_folder_t, buffer2);
			else
				TAP_SPrint(buffer, "%s '%s'", restoring_file_t, buffer2);
			drawInfoBox(restoring_file_t, buffer, from_recycle_bin_t, FALSE, TRUE);

			// strip off the extension for renaming
			ChangeDirPath(recycle_bin_list[curr_idx]->directory);
			strcpy(old_name, recycle_bin_list[curr_idx]->file_name);
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename %s", old_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			memset(file_name, '\0', 100);
			strncat(file_name, old_name, strlen(old_name)-4);

			strcpy(to_dir, recycle_bin_list[curr_idx]->directory);
			strcpy(from_dir, recycle_bin_list[curr_idx]->directory);
			ExtractExtension(file_name, extension);
				
			if (strlen(extension) > 0) {
				memset(new_name, '\0', 100);
				strncat(new_name, file_name, strlen(file_name)-strlen(extension));
			}
			else 
				strcpy(new_name, file_name);

			// append the relevant stamp
			renamed = appendToName(RENAME_BY_NUMBER, new_name, extension, from_dir, to_dir, recycle_bin_list[curr_idx]->mjd, recycle_bin_list[curr_idx]->hour, recycle_bin_list[curr_idx]->min);

			// if move file name has been appended to, then replace the extension and rename the physical file
			if (strlen(extension) > 0) {
				strcat(new_name, extension);
			}
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Renamed %s to %s, now do physical rename", old_name, new_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			doRename(old_name, new_name, FALSE, recycle_bin_list[curr_idx]->folder);

			ChangeDirPath(curr_dir);
			removeFromRecycleBinList(curr_idx);
			saveRecycleBinList();

			// if at end of list, then move idx up
			if (no_of_files > 1)
				adjustIndexForDelete(&curr_idx, &curr_highlight, no_of_files, 10);

			//populateRecycleBin();
			no_of_files--;
			saved_recycle_idx = curr_idx; saved_recycle_highlight = curr_highlight; 
			drawFileList(FALSE, FALSE);
			copyMemoryToWindow();
			drawDiskSpaceInfoBox();

			TAP_MemFree(info_save);
			info_save = NULL;
			break;

		case RKEY_Recall:

			// empty bin
			if (no_of_files == 0 || empty_bin_percentage == 0)
				break;

			if (write_log) if (verbose) logText("Empty bin till limit reached", FALSE);
			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			smart_delete = TRUE;
			drawConfirmationBox();
			window_displayed = FALSE;
			break;

#ifdef WIN32
		case RKEY_Ok:
#endif
		case RKEY_Pause:

			handleReorderKey();
			break;

		case RKEY_Exit :
		case RKEY_6 :

			if (write_log) if (verbose) logText("Exit recycle bin", FALSE);
			saveRecycleBinList();
			no_of_files = 0;
			recycle_bin_displayed = FALSE;
			populateFiles();

			if (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(FALSE, FALSE);
				drawMp3InfoBox();
				drawDiskSpaceInfoBox();
			}
			copyMemoryToWindow();
			window_displayed = TRUE;
			break;

		case RKEY_Text:

			handleHelpKey();
			break;

		case RKEY_ChUp :

			shuffleUpFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;
		
		case RKEY_VolUp :
			
			if (page_with_arrows)
				pageForwardFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_VolDown :

			if (page_with_arrows)
				pageBackFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_Rewind :

			if (!page_with_arrows)
				pageBackFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_Forward :

			if (!page_with_arrows)
				pageForwardFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;
	}

	return 0;
}

void startPlaylistSlideshow(bool single)
{
	TAP_Osd_Delete(region);
	TAP_Osd_Delete(region_mem);
	mp3_progress_offset = 0;
	window_displayed = FALSE;
	force_display = single ? TRUE : FALSE;
	slideshow_paused = single ? TRUE : FALSE;
	saveNamedPlaylist(TRUE, "photo.pl");
	saveNamedPlaylist(FALSE, "mp3.pl");
	movePlaylistToStructure(TRUE);
	current_jpeg = curr_idx;
	if (randomise_photos) saveHistory(TRUE, curr_idx);
	saved_playlist_idx = curr_idx;
	saved_playlist_highlight = curr_highlight;
	startSlideshow(); 
}

void startPlaylistMp3s(bool resume)
{
	if (mp3_playing)
		handleStopMp3(TRUE, TRUE);
	saveNamedPlaylist(FALSE, "mp3.pl");
	saveNamedPlaylist(TRUE, "photo.pl");
	movePlaylistToStructure(FALSE);
	mp3_playlist_playing = TRUE;
	current_mp3 = curr_idx;
	if (resume) {
		loadPlaylistHistory();
		if (mp3_history[0] >= 0)
			current_mp3 = mp3_history[mp3_history_pointer];
		else
			saveHistory(FALSE, current_mp3);
	}
	else
		saveHistory(FALSE, current_mp3);
	saved_playlist_idx = curr_idx;
	saved_playlist_highlight = curr_highlight;
	
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play MP3 %d %s", current_mp3, mp3_files[current_mp3]->file_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	
	handleKickoffMp3Mode();
	ChangeDirPath(curr_dir);
}

dword handlePlaylistEventKey(dword param1)
{
	switch(param1)
	{
		case RKEY_Menu:

			handleMenuKey();
			break;

		case RKEY_VolUp :
		case RKEY_VolDown :

			// switch between photo and mp3 playlists
			photo_playlist_mode = photo_playlist_mode ? FALSE : TRUE;
			no_of_files = photo_playlist_mode ? no_of_playlist_photos : no_of_playlist_mp3s;
			saved_playlist_idx = 0;
			saved_playlist_highlight = 0;
			drawPlaylist(FALSE);
			copyMemoryToWindow();
			break;

		case RKEY_TvSat:
			
			handleStartMP3ModeKey();
			break;

		case RKEY_TvRadio:
			
			handleLoadPlaylistKey();
			break;

		case RKEY_Slow:
			
			handleSearchKey();
			break;

		case RKEY_Record:

			memset(keyboard_name, '\0', 100);
			if (photo_playlist_mode)
				strcpy(keyboard_name, photo_playlist_name);
			else
				strcpy(keyboard_name, mp3_playlist_name);
			cursor_pointer = strlen(keyboard_name);
			new_folder = FALSE;
			handleKeyboardKey();
			break;

		case RKEY_Text:

			handleHelpKey();
			break;

		case RKEY_Play :

			// play the playlist
			if (no_of_files == 0)
				break;
			
			if (photo_playlist_mode)
				startPlaylistSlideshow(FALSE);
			else
				startPlaylistMp3s(FALSE);

			break;

		case RKEY_Ok :

			// play the playlist
			if (no_of_files == 0)
				break;
			
			if (photo_playlist_mode)
				startPlaylistSlideshow(TRUE);
			else
				startPlaylistMp3s(TRUE);

			break;

		case RKEY_White :

			// delete highlighted file from playlist
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete playlist item %d", curr_idx);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			if (no_of_files == 0)
				break;

			removeFromPlaylist(photo_playlist_mode, curr_idx);
			adjustIndexForDelete(&curr_idx, &curr_highlight, no_of_files, 10);
			no_of_files--;
			
			saved_playlist_idx = curr_idx; saved_playlist_highlight = curr_highlight;
			drawPlaylist(FALSE);
			updatePlaylistCount();
			copyMemoryToWindow();
			break;

		case RKEY_Stop:

			handleStopKey(TRUE);
			break;

		case RKEY_Green :

			// delete all files from playlist
			if (no_of_files == 0)
				break;

			removeAllFromPlaylist(photo_playlist_mode);
			no_of_files = 0;
			drawPlaylist(FALSE);
			copyMemoryToWindow();
			break;

		case RKEY_Red:

			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:

			handleChangeTrack(TRUE);
			break;

		case RKEY_1:

			// shuffle entry down
			if (curr_idx > 0) {
				movePlalistEntryUp(photo_playlist_mode, curr_idx);
				shuffleUpFileList(PLAYLIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			}
			break;

		case RKEY_3:

			// shuffle entry up
			if (curr_idx < no_of_files - 1) {
				movePlalistEntryDown(photo_playlist_mode, curr_idx);
				shuffleDownFileList(PLAYLIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			}
			break;

		case RKEY_Exit :
		case RKEY_Guide :

			saveNamedPlaylist(TRUE, "photo.pl");
			saveNamedPlaylist(FALSE, "mp3.pl");
			if (write_log) if (verbose) logText("Exit playlist", FALSE);
			no_of_files = 0;
			playlist_displayed = FALSE;
			saved_playlist_idx = 0;
			saved_playlist_highlight = 0;
#ifndef WIN32
			ChangeDirPath(curr_dir);
#endif
			populateFiles();

			if (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(FALSE, FALSE);
				drawMp3InfoBox();
			}
			copyMemoryToWindow();
			window_displayed = TRUE;
			break;

		case RKEY_ChUp :

			shuffleUpFileList(PLAYLIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(PLAYLIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_Rewind :

			pageBackFileList(PLAYLIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_Forward :

			pageForwardFileList(PLAYLIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;
	}

	return 0;
}

dword handleBackgroundEvent(dword param1)
{
    // Tell the firmware that we've drawn our own background on starting MP3/Radio playback
    if (param1 == 0)
		return 1;

	return param1;
}

void getAllFolders()
{
	TYPE_File file;
	int subfolder_count = 0, i;
	char **subfolders = dlmalloc(sizeof(*subfolders) * 512);

	memset (&file, 0, sizeof (file));
	i = TAP_Hdd_FindFirst(&file);

	while (i-- && all_folders_count < 1024 && subfolder_count < 512)
	{
		if (file.attr == ATTR_FOLDER && strcmp(file.name, "DataFiles") != 0 && strcmp(file.name, "Cache") != 0)
		{
			strcpy(temp, tracked_dir);
			strcat(temp, "/");
			strcat(temp, file.name);

			if (all_folders_count == 0) 
				all_folders = dlmalloc(sizeof(*all_folders) * 8192);

			all_folders[all_folders_count] = dlmalloc(strlen(temp) + 1);
			strcpy(all_folders[all_folders_count], temp);
			all_folders_count++;

			subfolders[subfolder_count] = dlmalloc(strlen(file.name) + 1);
			strcpy(subfolders[subfolder_count], file.name);
			subfolder_count++;
		}

		if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
			break;
	}

	for (i = 0; i < subfolder_count; i++)
	{
		ChangeDir(subfolders[i]);
		getAllFolders();
		ChangeDir("..");
	}

	for (i = 0; i < subfolder_count; i++)
	{
		dlfree(subfolders[i]);
		subfolders[i] = NULL;
	}
	dlfree(subfolders);
	subfolders = NULL;

	dlmalloc_trim(0);
}

bool active()
{
	return slideshow_started 
		|| screensaver_started 
		|| album_art_started 
		|| compact_mode_started 
		|| blank_screen_started 
		|| window_displayed 
		|| menu_displayed
		|| keyboard_displayed
		|| options_displayed
		|| load_playlist_displayed
		|| load_skin_displayed
		|| skin_elements_displayed
		|| confirmation_box_displayed
		|| info_box_displayed
		|| pin_box_displayed
		|| stop_menu_displayed
		|| move_folders_displayed
		|| log_displayed
		|| info_displayed
		|| rec_info_displayed
		|| help_displayed;
}

void handleDelays()
{
	if (skip_to_letter) {	
		if (TAP_GetTick() > (letter_tick + 150)) {
			word i; bool redrawn = FALSE;
			for (i = 0; i < no_of_files; i++) {
				char c1[2], c2[2];
				strncpy(c1, dir_info[i]->sort_name, 1); c1[1] = '\0';
				strncpy(c2, lookup_letter, 1); c2[1] = '\0'; 
				strlwr(c1); strlwr(c2);
				if (c1[0] == c2[0]) {
					saveNavHistory(i, -1, FALSE);
					if (thumbnail_mode)
						drawThumbnailGrid();
					else
						drawFileList(FALSE, FALSE);
					copyMemoryToWindow();
					redrawn = TRUE;
					break;
				}
			}
			if (!redrawn)
				TAP_Osd_RestoreBox(region, offset_x+40-2, thumbnail_mode ? thumbnail_offset_y+1-2 : offset_y-10-2, 30+4, 30+4, processing_save);
			TAP_MemFree(processing_save);
			processing_save = NULL;
			saved_letter = 0;
			skip_to_letter = FALSE;
		}
	}

	// let pause kick in playing next vid in multi play mode
	if (play_next_recording) {
		if (TAP_GetTick() > (play_next_tick + 200)) {
			playNextRecording();
			play_next_recording = FALSE;
		}	
	}

	// let pause kick in before displaying stop menu
	if (idle_before_stop_menu_display) {
		if (TAP_GetTick() > (tick_draw_stop_menu + 20)) {
			stop_menu_displayed = TRUE;
			drawStopMenu();
			idle_before_stop_menu_display = FALSE;
		}	
	}

	// after switching aspect ratio, wait 2 secs before redisplaying file list
	if (idle_before_window_display && !mp3_stopping && (TAP_GetTick() > (tick_draw_window + 200))) {
		if (write_log) if (verbose) logText("Draw window after 2 secs", FALSE);

		if (draw_playlist) {
			drawPlaylist(TRUE);
			drawMp3InfoBox();
			draw_playlist = FALSE;
		}
		else {
			if (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(TRUE, FALSE);
				drawMp3InfoBox();
			}
		}
		copyMemoryToWindow();
		window_displayed = TRUE;

		if (stop_mp3) {
			handleStopKey(TRUE);
			stop_mp3 = FALSE;
		}

		idle_before_window_display = FALSE;
	}

	// after switching aspect ratio, wait 2 secs before redisplaying file list
	if (idle_before_initial_display && (TAP_GetTick() > (tick_draw_window + 300))) {
		if (write_log) if (verbose) logText("Draw window after 3 secs", FALSE);

		drawInitialListing(FALSE);

		idle_before_initial_display = FALSE;
	}

	// after switching aspect ratio, wait 2 secs before drawing album art
	if (album_art_started && idle_before_photo_display && (TAP_GetTick() > (tick_draw_photo + 200))) {

		if (play_mp3) {
			ChangeDirPath(mp3_files[current_mp3]->directory);
			playMp3(mp3_files[current_mp3]->file_name);
			play_mp3 = FALSE;
		}

		if (!play_mp3)
			refreshAlbumArt();

		idle_before_photo_display = FALSE;
	}

	// automatically run video job if not confirmation within 10 secs
	if (confirm_video_job) {
		if (TAP_GetTick() > (timeout_tick + 1000)) {
			if (overnight_thumbs || overnight_copy) {
				yes_selected = TRUE;
				handleConfirmationBoxEventKey(RKEY_Ok);
			}
			else {
				handleVideoBatchJob(FALSE);
				confirm_video_job = FALSE;				
			}
		}	
	}

	if (log_memory_tick > 0 && TAP_GetTick() > (log_memory_tick + (100 * 60 * 60))) {
		logMemory("Periodic mem check", TRUE);
		//closeLogfile();
		log_memory_tick = TAP_GetTick();
	}	
}

void copyRecording()
{
	TYPE_PlayInfo play_info;

	if (copy_recording && (TAP_GetTick() > (copy_tick + copy_delay))) {

		TAP_Hdd_GetPlayInfo(&play_info);

		// safety check that the playback was not stopped
		if (play_info.playMode != PLAYMODE_Playing) {
			copy_recording = FALSE; 
			copy_successful = FALSE;
			return;
		}

		switch (copy_step) {
			case 0:	
				// if there has been an error within the last sec, then abort
				if (copy_error_tick > (TAP_GetTick() - 100)) {
					if (write_log) logText("Abandon decode", FALSE);
					TAP_Hdd_ChangePlaybackPos(play_info.totalBlock);
					copy_recording = FALSE; 
					copy_successful = FALSE;
					break;
				}

				// slightly faster
				if (decode_speed != DECODE_REAL_TIME) {
					if (write_log) logText("Fast forward", FALSE);
					TAP_GenerateEvent(EVT_KEY, RKEY_Forward, 0); 
				}
				copy_tick = TAP_GetTick();
				copy_delay = 200;
				copy_step++; 
				break;
			case 1:
				// quite fast
				if (decode_speed == DECODE_FOUR_TIMES || decode_speed == DECODE_SIX_TIMES) {
					if (write_log) logText("Fast forward", FALSE);
					TAP_GenerateEvent(EVT_KEY, RKEY_Forward, 0); 
				}
				copy_tick = TAP_GetTick();
				copy_delay = 200;
				copy_step++; 
				break;
			case 2:
				// full steam ahead
				if (decode_speed == DECODE_SIX_TIMES) {
					if (write_log) logText("Fast forward", FALSE);
					TAP_GenerateEvent(EVT_KEY, RKEY_Forward, 0); 
				}
				copy_tick = TAP_GetTick();
				copy_delay = 200;
				copy_step++; 
				break;
			case 3:
				// finally start the copy
				if (write_log) logText("Copy", FALSE);
				TAP_GenerateEvent(EVT_KEY, RKEY_Record, 0); 
				copy_tick = TAP_GetTick();
				copy_delay = 0;
				copy_step++; 
				break;
			case 4:
				copy_recording = FALSE; 
				copy_successful = TRUE;
				break;
		}
	}
}

void trimRecording()
{
	TYPE_PlayInfo play_info;

	if (trim_recording) {
		//if (TAP_GetTick() > trim_tick + 10) {
			switch (stop_menu_idx) {
				case 3:
					switch (trim_step) {
						case 0:
							if (TAP_GetTick() > (trim_tick + 50)) {
								TAP_EnterNormal();
								trim_step++; 
							}
							break;
						case 1:
							TAP_GenerateEvent(EVT_KEY, RKEY_Pause, 0); 
							trim_step++; 
							break;
						case 2:
							TAP_GenerateEvent(EVT_KEY, RKEY_Play, 0); 
							trim_step++; 
							break;
						case 3:
							TAP_GenerateEvent(EVT_KEY, RKEY_White, 0); 
							trim_tick = TAP_GetTick();
							TAP_Hdd_GetPlayInfo(&play_info);
							arrow_press_length = (play_info.currentBlock/5000+1)*100 + 25;
							trim_step++; 
							break;
						case 4:
							TAP_GenerateEvent(EVT_KEY, RKEY_VolDown, 0); 
							if (TAP_GetTick() > (trim_tick + arrow_press_length))
								trim_step++;
							break;
						case 5:
							TAP_GenerateEvent(EVT_KEY, RKEY_Blue, 0); 
							trim_step++; 
							break;
						case 6:
							TAP_GenerateEvent(EVT_KEY, RKEY_Ok, 0); 
							trim_step++; 
							break;
						case 7:
							TAP_GenerateEvent(EVT_KEY, RKEY_Play, 0); 
							trim_recording = FALSE; 
							reload_header = TRUE;
							break;
					}
					break;
				
				case 4:
					switch (trim_step) {
						case 0:
							if (TAP_GetTick() > (trim_tick + 50)) {
								TAP_EnterNormal();
								trim_step++; 
							}
							break;
						case 1:
							TAP_GenerateEvent(EVT_KEY, RKEY_Pause, 0); 
							trim_step++; 
							break;
						case 2:
							TAP_GenerateEvent(EVT_KEY, RKEY_Play, 0); 
							trim_tick = TAP_GetTick();
							trim_step++; 
							break;
						case 3:
							TAP_GenerateEvent(EVT_KEY, RKEY_White, 0); 
							trim_tick = TAP_GetTick();
							TAP_Hdd_GetPlayInfo(&play_info);
							arrow_press_length = ((play_info.totalBlock-play_info.currentBlock)/5000+1)*100 + 25;
							trim_step++; 
							break;
						case 4:
							TAP_GenerateEvent(EVT_KEY, RKEY_VolUp, 0); 
							if (TAP_GetTick() > (trim_tick + arrow_press_length)) {
								TAP_Hdd_GetPlayInfo(&play_info);
								trim_step++;
							}
							break;
						case 5:
							TAP_GenerateEvent(EVT_KEY, RKEY_Blue, 0); 
							trim_step++; 
							break;
						case 6:
							TAP_GenerateEvent(EVT_KEY, RKEY_Ok, 0); 
							trim_step++; 
							break;
						case 7:
							trim_recording = FALSE; 
							reload_header = TRUE;
							break;
					}
					break;

				case 5:
					switch (trim_step) {
						case 0:
							if (TAP_GetTick() > (trim_tick + 50)) {
								TAP_EnterNormal();
								trim_step++; 
							}
							break;
						case 1:
							TAP_GenerateEvent(EVT_KEY, RKEY_Pause, 0); 
							trim_step++; 
							break;
						case 2:
							TAP_GenerateEvent(EVT_KEY, RKEY_Play, 0); 
							trim_tick = TAP_GetTick();
							trim_step++;
							break;
						case 3:
							TAP_GenerateEvent(EVT_KEY, RKEY_White, 0); 
							trim_tick = TAP_GetTick();
							TAP_Hdd_GetPlayInfo(&play_info);
							arrow_press_length = (play_info.currentBlock/5000+1)*100 + 25;
							trim_step++;
							break;
						case 4:
							TAP_GenerateEvent(EVT_KEY, RKEY_VolDown, 0);
							if (TAP_GetTick() > (trim_tick + arrow_press_length))
								trim_step++;
							break;
						case 5:
							TAP_GenerateEvent(EVT_KEY, RKEY_Blue, 0); 
							trim_step++;
							break;
						case 6:
							TAP_GenerateEvent(EVT_KEY, RKEY_VolDown, 0); 
							trim_step++;
							break;
						case 7:
							TAP_GenerateEvent(EVT_KEY, RKEY_Ok, 0); 
							trim_step++;
							break;
						case 8:
							trim_recording = FALSE; 
							break; 
					}
					break;
			}

			//trim_tick = TAP_GetTick();
		//}
	}
}

void handleExternalMode(TYPE_PlayInfo play_info)
{
	if (batch_job_started || play_info.playMode == PLAYMODE_Mp3)
		return;

	if (paused_mode) {
		was_paused = isPaused(play_info);
		if (was_paused) {
			if (was_playing) {
				if (!paused_slideshow
					    && !TAP_Channel_IsStarted(0)
						&& !active() 
						&& !(OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
						&& TAP_GetTick() > (paused_tick + (paused_delay*100))) {
					if (write_log) if (verbose) logText("Start paused mode", FALSE);
					startExternalMode(paused_mode, FALSE, FALSE);
					was_playing = FALSE;
				}
			}
		}
		else {
			was_playing = TRUE;
		}
	}

	if (radio_mode) {
		TAP_Channel_GetCurrent(&tv_radio, &channel_number);
		if (isPlaying(play_info))
			TAP_Channel_GetInfo(play_info.svcType, play_info.svcNum, &channel_info);
		else
			TAP_Channel_GetInfo(tv_radio, channel_number, &channel_info);
		
		if ((!isPlaying(play_info) 
					&& (tv_radio == SVC_TYPE_Radio 
						|| (isTF5800() && channel_info.logicalChNum >= 700 && channel_info.logicalChNum < 800)))
				|| (isPlaying(play_info) 
					&& (play_info.svcType == SVC_TYPE_Radio 
						|| (isTF5800() && channel_info.logicalChNum >= 700 && channel_info.logicalChNum < 800)))) {

			if (radio_slideshow)
				refreshRadioProgress();

			if (was_tv) {
				if (!was_radio)
					paused_tick = TAP_GetTick();

				if (!radio_slideshow 
						&& !TAP_Channel_IsStarted(0)
						&& !active() 
						&& !(OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
						&& TAP_GetTick() > (paused_tick + (8*100))) {
					if (write_log) if (verbose) logText("Start radio mode", FALSE);
					startExternalMode(radio_mode, FALSE, TRUE);
					was_tv = FALSE;
				}
			}
			was_radio = TRUE;
		}
		else {
			if (radio_slideshow)
				exitRadioSlideshow();

			if (was_radio)
				was_radio = FALSE;
			was_tv = TRUE;
		}
	}
}

void blinkKeyboardCursor()
{
	// blink keyboard cursor
	if (keyboard_displayed && TAP_GetTick() > (cursor_tick+50)) {
		word string_length;
		memset(buffer, '\0', 100);
		strncat(buffer, keyboard_name, cursor_pointer);
		string_length = getWidth(buffer, FNT_Size_1926);
		if (blink_on) {
			TAP_Osd_FillBox(region, X+5+string_length+1, Y+H-120-33, 2, 28, body_text_colour);
			blink_on = FALSE;
		}
		else {
			TAP_Osd_FillBox(region, X+5+string_length+1, Y+H-120-33, 2, 28, keyboard_idx == 99 ? COLOR_Black : RGB8888(61,61,61));
			blink_on = TRUE;
		}
		cursor_tick = TAP_GetTick();
	}
}

void handleCopyBatchJob()
{
	TYPE_RecInfo rec_info_1, rec_info_2;
	TAP_Hdd_GetRecInfo(0, &rec_info_1);
	TAP_Hdd_GetRecInfo(0, &rec_info_2);

	if (((!(rec_info_1.recType == RECTYPE_Normal || rec_info_1.recType == RECTYPE_Copy)
			&& !(rec_info_2.recType == RECTYPE_Normal || rec_info_2.recType == RECTYPE_Copy)))) {	

		if (overnight_copy == AUTO_COPY	|| overnight_copy == AUTO_COPY_ALL) {
			ChangeDirDataFiles();
			no_of_marked_recordings = 0;
			parseAllFiles(LOAD_DECODINGS, 0, FALSE);
			multi_play_batch_mode = MULTI_DECODE;
		}
		else {
			loadSavedRecordings(TRUE);
		}
		
		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Multi play %d vids at %02d:%02d", no_of_marked_recordings, hour, min);
		if (write_log) logText(log_buffer, FALSE);
		
		if (no_of_marked_recordings > 0) {
			
			if (write_log) TAP_SPrint(log_buffer, "Play multi %s, %s at %d", marked_recordings[0].directory, marked_recordings[0].file_name, TAP_GetTick());
			if (write_log) logText(log_buffer, FALSE);

			// ensure a timer is not due to start before the job would finish
			/*if (multi_play_batch_mode == MULTI_DECODE) {
				TYPE_TimerInfo timer_info;
				int no_of_timers = TAP_Timer_GetTotalNum(), i;
				dword next_timer_time = 0, next_timer_due_mins;
				word timer_mjd; byte timer_hour, timer_min, job_duration = 0;

				// get the earliest timer time
				if (write_log) TAP_SPrint(log_buffer, "Check %d timers", no_of_timers);
				if (write_log) logText(log_buffer, FALSE);
				for (i = 0; i < no_of_timers; i++) {
					TAP_Timer_GetInfo(i, &timer_info);
					if (next_timer_time == 0 || timer_info.startTime < next_timer_time)
						next_timer_time = timer_info.startTime;
				}

				// extract the time details
				timer_mjd  = next_timer_time >> 16 & 0xffff;
				timer_hour = next_timer_time >> 8 & 0xff;  
				timer_min  = next_timer_time & 0xff;  
				if (write_log) TAP_SPrint(log_buffer, "First timer is %02d:%02d", timer_hour, timer_min);
				if (write_log) logText(log_buffer, FALSE);

				// get the current time, and use to calculate difference in mins between timer time
				TAP_GetTime(&mjd, &hour, &min, &sec);
				timer_hour += (timer_mjd - mjd) * 24;
				next_timer_due_mins = (timer_hour*60 + timer_min) - (hour*60 + min);
				if (write_log) TAP_SPrint(log_buffer, "It will fire in %d mins", next_timer_due_mins);
				if (write_log) logText(log_buffer, FALSE);

				// calculate the approx job duration
				for (i = 0; i < no_of_marked_recordings; i++) {
					ChangeDirPath(marked_recordings[0].directory);
					getRecHeaderDetail(marked_recordings[0].file_name);
					job_duration += recDuration;
				}

				// adjust for decode speed
				switch (decode_speed) {
					case DECODE_REAL_TIME:	break;
					case DECODE_TWO_TIMES:	job_duration /= 2; break;
					case DECODE_FOUR_TIMES:	job_duration /= 4; break;
					case DECODE_SIX_TIMES:	job_duration /= 6; break;
				}
				if (write_log) TAP_SPrint(log_buffer, "Job will take approx %d mins", job_duration);
				if (write_log) logText(log_buffer, FALSE);

				// if next timer starts before job would finish, then skip to thumbs
				if (next_timer_due_mins < (job_duration + 15)) {
					if (write_log) logText("Abandon decode job due to timer clash\r\n", FALSE);
					copy_tick = TAP_GetTick();	
					thumbnail_batch_job = TRUE;
					ChangeDirPath(curr_dir);
					copy_batch_job = FALSE;
					return;
				}
			}*/

			ChangeDirPath(marked_recordings[0].directory);

			if (multi_play_batch_mode == MULTI_DECODE) {
				if (decode_channel)
					TAP_Channel_Start(1, SVC_TYPE_Tv, decode_channel == 30000 ? getRecHeaderDetail(marked_recordings[0].file_name) : decode_channel - 1);
				TAP_Channel_GetCurrent(&tv_radio, &current_channel_number);
			}

			TAP_Hdd_PlayTs(marked_recordings[0].file_name);
			TAP_Delay(50);
			TAP_Hdd_ChangePlaybackPos(0);
			multi_play_started = TRUE;
			overnight_play = TRUE;

			// kick off the fast copy if a decode batch job
			if (multi_play_batch_mode == MULTI_DECODE) {
				copy_recording = TRUE;
				copy_successful = FALSE;
				copy_step = 0;
				copy_delay = 400;
				copy_tick = TAP_GetTick();
			}

			// safe to delete the file now, so it wont get kicked off again
			if (overnight_copy != AUTO_COPY	&& overnight_copy != AUTO_COPY_ALL) {
				ChangeDirMediaManager();
				TAP_Hdd_Delete("vid_saved.dat");
			}
		}
		else {
			// create the thumbnails, then shutdown
			copy_tick = TAP_GetTick();	
			thumbnail_batch_job = TRUE;
		}
	}
	ChangeDirPath(curr_dir);
	copy_batch_job = FALSE;
}

void handleVideoBatchJobConfirmation()
{
	if (confirm_video_job)
		return;

	if (active() || OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
		return;

	TAP_GetTime(&mjd, &hour, &min, &sec);
	TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
	time = hour * 60 + min;
	//time = 120;

	if (time == overnight_thumbs_time 
			&& (last_thumb_run == 0 || (TAP_GetTick() > (last_thumb_run + (2*60*100))))) {

		last_thumb_run = TAP_GetTick();
		timeout_tick = TAP_GetTick();
		confirm_video_job = TRUE;

		if (overnight_thumbs || overnight_copy) {
			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			drawConfirmationBox();
		}
	}
}

void handleVideoBatchJob(bool confirm)
{
	TYPE_PlayInfo play_info;

	if (!overnight_thumbs 
			&& !overnight_auto_delete 
			&& !overnight_copy 
			&& !preload_video_headers
			&& empty_bin_percentage == 0
			&& empty_bin_days == 0) 
		return;

	// after a suitable delay, start the decode/play job
	if (copy_batch_job && (TAP_GetTick() > copy_tick + 200)) {
		handleCopyBatchJob();
		return;
	}

	// after a suitable delay, start the thumbnail job
	if (thumbnail_batch_job && (TAP_GetTick() > copy_tick + 400)) {
		handleThumbnailsBatchJob();
		overnightShutdown();
		return;
	}

	// check if it is time to run the job
	if (confirm) {
		handleVideoBatchJobConfirmation();
		return;
	}
	
#ifndef WIN32
	// if it is, then get the current play info
	TAP_Hdd_GetPlayInfo(&play_info);
#endif

	// do the auto deletes
	if (overnight_auto_delete && play_info.playMode != PLAYMODE_Playing) {
		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Started auto delete job at %02d:%02d", hour, min);
		if (write_log) logText(log_buffer, TRUE);

		runAutoDeleteRules(-1);

		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Finished auto delete job at %02d:%02d", hour, min);
		if (write_log) logText(log_buffer, FALSE);
	}

	// empty the bin
	if ((empty_bin_percentage > 0 || empty_bin_days > 0) && play_info.playMode != PLAYMODE_Playing) {
		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Started to purge recycle bin %02d:%02d", hour, min);
		if (write_log) logText(log_buffer, TRUE);

		emptyRecycleBin(TRUE);

		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Finished purging recycle bin at %02d:%02d", hour, min);
		if (write_log) logText(log_buffer, FALSE);
	}

	// recreate the video headers
	if (preload_video_headers && play_info.playMode != PLAYMODE_Playing) {
		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Started to reload headers %02d:%02d", hour, min);
		if (write_log) logText(log_buffer, TRUE);

		ChangeDirDataFiles();
		deleteAllRecHeaders();
		parseAllFiles(LOAD_HEADERS, 0, FALSE);
		ChangeDirPath(curr_dir);

		TAP_GetTime(&mjd, &hour, &min, &sec);
		if (write_log) TAP_SPrint(log_buffer, "Finished reloading headers at %02d:%02d", hour, min);
		if (write_log) logText(log_buffer, FALSE);
	}

	// delay before running the overnight copy
	if (overnight_copy && play_info.playMode != PLAYMODE_Playing) {

		// if there is a saved video file, then play/decode them after a brief delay
		ChangeDirMediaManager();
		if (TAP_Hdd_Exist("vid_saved.dat") || overnight_copy == AUTO_COPY || overnight_copy == AUTO_COPY_ALL) {
			copy_tick = TAP_GetTick();			
			copy_batch_job = TRUE;
		}
		ChangeDirPath(curr_dir);
	}

	// create the thumbnails then shutdown (unless copy has been initiated, in which case do it after that)
	if (!copy_batch_job) {
		copy_tick = TAP_GetTick();	
		thumbnail_batch_job = TRUE;
	}
}

void handlePhotoBatchJob()
{
	if (overnight_batch && !active())
	{
		int i;

		if (OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
			return;

		TAP_GetTime(&mjd, &hour, &min, &sec);
		TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
		time = hour * 60 + min;

		if (write_log) if (verbose) logText("Batch cache job start", FALSE);
		if (overnight_batch == CACHE_NOW
			|| ((time > overnight_batch_time) && (time < 360) && (day != overnight_batch_day)))
		{
			logMemory("Before batch job starts", FALSE);

			overnight_batch = FALSE;
			ChangeDirMediaManager();
			SaveConfigurationToFile();
			ChangeToRoot(NULL);
#ifndef WIN32
			// always put the root directory in first
			if (write_log) TAP_SPrint(log_buffer, "Starting batch cache process at %02d:%02d", hour, min);
			if (write_log) logText(log_buffer, FALSE);
			
			all_folders_count = 0;
			all_folders = dlmalloc(sizeof(*all_folders) * 8192);
			all_folders[all_folders_count] = dlmalloc(2);
			strcpy(all_folders[all_folders_count], "/");
			all_folders_count++;
			logMemory("Before getting folders", FALSE);
			getAllFolders();
			logMemory("After getting folders", FALSE);
#else 
			all_folders_count = 0;
			all_folders = dlmalloc(sizeof(*all_folders) * 8192);
			all_folders[all_folders_count] = dlmalloc(2);
			strcpy(all_folders[all_folders_count], "/");
			all_folders_count++;
			all_folders[all_folders_count] = dlmalloc(20);
			strcpy(all_folders[all_folders_count], "/ProgramFiles");
			all_folders_count++;
#endif
			for (i = 0; i < all_folders_count; i++)
			{
				if (write_log) TAP_SPrint(log_buffer, "Discovered folder %s", all_folders[i]);
				if (write_log) logText(log_buffer, FALSE);
			}
			populateJPEGs(FALSE, FALSE);
			//deleteDimensions();
			current_jpeg = 0;
			all_folders_idx = 0;
			batch_job_started = TRUE;
			memory_delay = 2;
		}
	}

	if (batch_job_started)
	{
		// if we have reached the end of the photos, then flag to stop
		if ((no_of_jpegs == 0 || current_jpeg == no_of_jpegs) && (all_folders_idx == (all_folders_count - 1)))
		{
			batch_job_started = FALSE;
			freeMediaFiles();
			freeAllFolders();
			freeDimensions();
			TAP_GetTime(&mjd, &hour, &min, &sec);
			if (write_log) TAP_SPrint(log_buffer, "Finished batch cache process at %02d:%02d", hour, min);
			if (write_log) logText(log_buffer, FALSE);
			ChangeDirPath(curr_dir);
		}

		// if we are merely at the end of the current folder, then switch to the next one
		if ((no_of_jpegs == 0 || current_jpeg == no_of_jpegs) && all_folders_idx < (all_folders_count - 1))
		{
			all_folders_idx++;
			if (write_log) TAP_SPrint(log_buffer, "Change to dir %s", all_folders[all_folders_idx]);
			if (write_log) logText(log_buffer, FALSE);
			ChangeDirPath(all_folders[all_folders_idx]);
			populateJPEGs(FALSE, FALSE);
			//deleteDimensions();
			current_jpeg = 0;

			// if there are no jpegs in this folder, then keep trying until we find one that has, or we reach the end
			while (no_of_jpegs == 0 && all_folders_idx < (all_folders_count - 1))
			{
				all_folders_idx++;
				if (write_log) TAP_SPrint(log_buffer, "Change to dir %s", all_folders[all_folders_idx]);
				if (write_log) logText(log_buffer, FALSE);
				ChangeDirPath(all_folders[all_folders_idx]);
				populateJPEGs(FALSE, FALSE);
				//deleteDimensions();
				current_jpeg = 0;
			}

			if (write_log) TAP_SPrint(log_buffer, "Caching %d files in dir %s", no_of_jpegs, all_folders[all_folders_idx]);
			if (write_log) logText(log_buffer, FALSE);
		}
	}
}

#define EVT_INIT 999

void renameAndMoveFiles()
{
	TYPE_File file;
	word i;

#ifndef WIN32
	// rename ini file if necessary
	ChangeDirProgramFiles();
	if (!TAP_Hdd_Exist("MediaManager.ini")) {
		if (TAP_Hdd_Exist("photo.ini")) {
			TAP_Hdd_Rename("photo.ini", "MediaManager.ini");
			TAP_Hdd_Delete("photo.ini");
		}
	}

	// create settings dirs if necessary and move stuff to MM sub dir
	ChangeDirPlaylists();
	ChangeDir("..");

	// if no ini file in MM dir, then do the moves
	if (!TAP_Hdd_Exist("MediaManager.ini")) {

		for (i = 0; i < 10000; i++)
			TAP_SystemProc();

		// back to PF
		ChangeDirProgramFiles();

		// move the main files
		if (TAP_Hdd_Exist("MediaManager.ini")) move("/ProgramFiles", "/ProgramFiles/Settings/MediaManager", "MediaManager.ini");
		if (TAP_Hdd_Exist("auto_delete.dat"))  move("/ProgramFiles", "/ProgramFiles/Settings/MediaManager", "auto_delete.dat");
		if (TAP_Hdd_Exist("recycle_bin.dat"))  move("/ProgramFiles", "/ProgramFiles/Settings/MediaManager", "recycle_bin.dat");
		if (TAP_Hdd_Exist("vid_progress.dat")) move("/ProgramFiles", "/ProgramFiles/Settings/MediaManager", "vid_progress.dat");
	
		// now do any playlists
		i = TAP_Hdd_FindFirst(&file);
		while (i--) {
			if (isPlaylist(file.name))
				move("/ProgramFiles", "/ProgramFiles/Settings/MediaManager/Playlists", file.name);

			if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
				break;
		}
	}
#endif
}

#ifndef WIN32
#include "FBLib_flash.h"
#endif

void getGmtOffset()
{
#ifndef WIN32
	short*                DST_addr;
	TYPE_ClockSetup       *ClockSetting;

	gmt_offset = 0;

	if (!LibInitialized) InitTAPex ();
	if (!LibInitialized) {
		if (write_log) logText("FireBirdLib: Not initialized", FALSE);
		return;
	}

	if (FlashOffset == 0) {
		if (write_log) logText("FireBirdLib: Flash library hasn't been initialized", FALSE);
		return;
	}

	ClockSetting = (TYPE_ClockSetup*) (FlashGetBlockStartAddress(7) + 4);
	gmt_offset = ClockSetting->UTCOffset / 60;
	if (write_log) TAP_SPrint(log_buffer, "Offset = %d hour(s)", gmt_offset);
	if (write_log) logText(log_buffer, TRUE);
#endif
}

void populateDefaultDirectories()
{
	TYPE_File file;
	word i;

	memset(&default_directories[no_of_files], 0, sizeof(default_directories[no_of_files]));
	default_directories[no_of_files] = dlmalloc(2);
	strcpy(default_directories[no_of_files], "/");
	no_of_files++;
	memset(&default_directories[no_of_files], 0, sizeof(default_directories[no_of_files]));
	default_directories[no_of_files] = dlmalloc(9);
	strcpy(default_directories[no_of_files], "Playlist");
	no_of_files++;

	// load directories under Root into array for use by options screen
	if (write_log) logText("Load startup directories", FALSE);
	ChangeToRoot(NULL);
    i = TAP_Hdd_FindFirst(&file);
    while(i-- && no_of_files < 128) {
        if (file.attr == ATTR_FOLDER 
				&& strcmp(file.name, "Cache") != 0
				&& strcmp(file.name, "__ROOT__") != 0
				&& strcmp(file.name, "__RECYCLE__") != 0) {
			memset(&default_directories[no_of_files], 0, sizeof(default_directories[no_of_files]));
			default_directories[no_of_files] = dlmalloc(strlen(file.name)+1+1);
			strcpy(default_directories[no_of_files], "/");
			strcat(default_directories[no_of_files], file.name);
			no_of_files++;
        }

        if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
            break;
    }

	// load directories under ProgramFiles into array for use by options screen
	ChangeDirProgramFiles();
    i = TAP_Hdd_FindFirst(&file);
    while(i-- && no_of_files < 128) {
        if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0) {
			memset(&default_directories[no_of_files], 0, sizeof(default_directories[no_of_files]));
			default_directories[no_of_files] = dlmalloc(strlen("/ProgramFiles/")+strlen(file.name)+1);
			strcpy(default_directories[no_of_files], "/ProgramFiles/");
			strcat(default_directories[no_of_files], file.name);
			no_of_files++;
        }

        if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
            break;
    }

#ifndef WIN32
	// load directories under Photos into array for use by options screen (if it exists)
	ChangeToRoot(NULL);
	if (TAP_Hdd_Exist("Photos")) {
		ChangeDir("Photos");
		i = TAP_Hdd_FindFirst(&file);
		while(i-- && no_of_files < 128) {
			if (file.attr == ATTR_FOLDER && strcmp(file.name, "Cache") != 0) {
				memset(&default_directories[no_of_files], 0, sizeof(default_directories[no_of_files]));
				default_directories[no_of_files] = dlmalloc(strlen("/Photos/")+strlen(file.name)+1);
				strcpy(default_directories[no_of_files], "/Photos/");
				strcat(default_directories[no_of_files], file.name);
				no_of_files++;
			}

			if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
				break;
		}
	}
#endif

    default_folder_count = no_of_files;
    qsort(default_directories, default_folder_count, sizeof(default_directories[0]), compareStrings);

	// find the idx of the configured default directories
	for (i = 0; i < default_folder_count; i++)
	{
		if (strcmp(default_directories[i], default_slideshow_directory) == 0)
            current_def_slideshow_folder = i;
		if (strcmp(default_directories[i], default_startup_directory) == 0)
            current_def_startup_folder = i;
	}

	no_of_files = 0;
}

void setActivationIndexes()
{
	word i;

	for (i = 0; i < NUMBER_OF_ACTIVATIONS; i++)
	{
		if (jpg_activation_key == activation_options[i])
			current_jpg_activation_key = i;
		ef (mp3_activation_key == activation_options[i])
			current_mp3_activation_key = i;
		ef (rec_activation_key == activation_options[i])
			current_rec_activation_key = i;
		ef (pf_activation_key == activation_options[i])
			current_pf_activation_key = i;

		if (last_played_activation_key == activation_options[i])
			current_last_played_activation_key = i;
		if (create_thumbnail_key == activation_options[i])
			current_create_thumbnail_key = i;
	}
}

void loadDataFiles()
{
	if (write_log) logText("Load playlists, auto delete rules, progress data and recycle bin", FALSE);
	TAP_SPrint(log_buffer, "%s %s %s...", loading_t, data_t, files_t);
	drawProcessingMessage(region, log_buffer, TRUE, TRUE, FALSE);
	loadAutoDeleteList();
	loadProgressData();
	loadRecycleBinList();
	loadSavedRecordings(FALSE);
	loadNamedPlaylist(TRUE, "photo.pl");
	loadNamedPlaylist(FALSE, "mp3.pl");
	qsort(recycle_bin_list, no_of_recycles, sizeof(recycle_bin_list[0]), compareRecycling);
}

void loadMp3Headers(bool show_message, bool initialisation, bool force)
{
	if (preload_mp3_headers == HEADERS || preload_mp3_headers == HEADERS_AND_THUMBNAILS || force) {
		if (show_message) {
			TAP_SPrint(log_buffer, "%s MP3 %s...", loading_t, headers_t);
			drawProcessingMessage(region, log_buffer, TRUE, initialisation ? TRUE : FALSE, initialisation ? FALSE : TRUE);
		}

		logMemory("Before loading mp3 headers", FALSE);
		ChangeDirMp3();
		id3_info = create_ID3(NULL);
		parseAllFiles(LOAD_SEARCH_MP3S, 0, TRUE);
		destroy_ID3(id3_info);
		id3_info = NULL;
		mp3s_loaded = TRUE;
		logMemory("After loading mp3 headers", FALSE);
	}
}

void loadRecHeaders()
{
	// to speed up archive access, preload all rec headers
	if (preload_video_headers == HEADERS || preload_video_headers == HEADERS_AND_THUMBNAILS) {
		TAP_SPrint(log_buffer, "%s %s %s...", loading_t, video_t, headers_t);
		drawProcessingMessage(region, log_buffer, TRUE, TRUE, FALSE);

		logMemory("Before loading video headers", FALSE);
		ChangeDirDataFiles();
		parseAllFiles(LOAD_HEADERS, 0, TRUE);
		logMemory("After loading video headers", FALSE);
	}
}

void initialiseSkins()
{
	if (write_log) logText("Load skins", FALSE);
	checkForDefaultSkin();
	loadSkins();
	loadSkinElements(W, 30);
}

/*void initialiseExTap()
{
#ifndef WIN32
	firmware_hacks_enabled = TRUE;
	if (exTAP_Init() < 0) {
		if (write_log) logText("Firmware too old (or new) for hacks", FALSE);
		firmware_hacks_enabled = FALSE;
	}
#endif
}*/

/*void locateEEPROM()
{
#ifndef WIN32
	eeprom_offset = getEEPROMOffset();
	if (write_log) TAP_SPrint(log_buffer, "Eeprom offset is 0x%8.8x", eeprom_offset);
	if (write_log) logText(log_buffer, FALSE);
#endif
}*/

void logMemory(char *message, bool log_verbose)
{
	if (log_verbose && !verbose)
		return;

	if (write_log) TAP_MemInfo(&heap_size, &free_size, &available_size);
	if (write_log) TAP_SPrint(log_buffer, "%s, Free mem: %d, Available mem: %d", message, free_size, available_size);
	if (write_log) logText(log_buffer, log_verbose);
}

void handleInitialisation()
{
	TAP_Print("\nStarting TAP in TSR mode\n");

	// initialise the Osd
	TAP_ExitNormal();
	region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);

	// save the original transparency and seed random number generator
	//TAP_Print("Seed random\r\n");
	toppy_transparency = TAP_GetSystemVar(SYSVAR_OsdAlpha);
	seedRandom();
	is_ozzie = isOzzie();

#ifndef WIN32
	//StartTAPExtensions();
	//TAP_Print("Init FB lib\n");
	firmware_hacks_enabled = InitTAPex();
	InitTAPAPIFix();
	desc_ext_installed = PatchIsInstalled((dword*) 0x80000000, "De");
#endif

	// set all history to -1
	clearHistory(FALSE);
	clearHistory(TRUE);
	clearAllNavHistory();
	ChangeDirRootFromUnknown();
	ChangeDirProgramFiles();

	if (write_log) TAP_SPrint(log_buffer, "FB lib loaded: %d", firmware_hacks_enabled);
	if (write_log) logText(log_buffer, TRUE);

	// handle any migration to \ProgramFiles\Settings
	//logText("Rename and move files", TRUE);
	renameAndMoveFiles();

	// load in all the configuration options
	//logText("Load config", TRUE);
	LoadConfiguration();

	// open the log file
	if (write_log) openLogfile();
	log_memory_tick = TAP_GetTick();
	logMemory("At startup", FALSE);

	// load in any custom fonts
	//logText("Load fonts", TRUE);
	loadFonts();
	logMemory("After loading fonts", FALSE);

	// load the skins, and set up the colour scheme from the configured skin
	//logText("Load skins", TRUE);
	initialiseSkins();
	logMemory("After loading skins", FALSE);

	// initialize the graphics engine
	setupGraphics();

	// display a 'processing' message now skins and fonts are loaded
	drawProcessingMessage(region, init_mm_t, TRUE, TRUE, FALSE);

	// load the logos into memory
	//logText("Load logos", TRUE);
	CacheLogos();
	logMemory("After loading logos", FALSE);

	// initialise the exTap library
	//initialiseExTap();

	//Initialize the flash library
	//logText("Get GMT Offset", TRUE);
	getGmtOffset();

	// find the eeprom offset for PIN retrieval
	//locateEEPROM();

	// populate the possible list of default directories
	//logText("Populate default directories", TRUE);
	populateDefaultDirectories();
	logMemory("After loading default folders", FALSE);
	
	// find the idx of the activation keys
	setActivationIndexes();
	
	// set up default directories
	strcpy(curr_dir, default_startup_directory);
	strcpy(saved_jpg_current_dir, default_startup_directory);
	strcpy(saved_rec_current_dir, "/DataFiles");
	strcpy(saved_mp3_current_dir, "/MP3");
	strcpy(saved_pf_current_dir, "/ProgramFiles");

	// to speed up archive access, preload all headers
	//logText("Load rec headers", TRUE);
	loadRecHeaders();
	//logText("Load mp3 headers", TRUE);
	loadMp3Headers(TRUE, TRUE, FALSE);

	// load in the playlists, auto delete data, progress data, and recycle bin
	loadDataFiles();
	logMemory("After loading data files", FALSE);

	// load the channel names into memory
	populateChannels();

	// change to the initial startup directory
	ChangeDirPath(default_startup_directory);

	// finally delete the processing message
	TAP_Osd_Delete(region);
	TAP_EnterNormal();

	logMemory("After initialisation", FALSE);
}

static bool busy = FALSE;

dword handleIdleEvent(dword param1)
{
	TYPE_PlayInfo play_info;
	dword state, sub_state;

	if (busy) return param1;
    busy = TRUE; 

	// first off, handle any queued events
	handleEvent();

#ifndef WIN32
    TAP_Hdd_GetPlayInfo(&play_info);
#endif

	handleDelays();
	trimRecording();
	copyRecording();

	TAP_GetState(&state, &sub_state);
    if (state == STATE_Normal)
    {
		blinkKeyboardCursor();

		processMP3();
#ifndef WIN32
		processRec();
#endif
		processJPEG(FALSE);
		processScreensaver();

#ifndef WIN32
		handleVideoBatchJob(TRUE);
#endif
		handlePhotoBatchJob();	
    }

#ifndef WIN32
	handleExternalMode(play_info);
#endif

	busy = FALSE;
	return param1;
}

dword handleOtherEventKey(dword param1)
{
	TYPE_PlayInfo play_info;
	dword state, sub_state;

	TAP_GetState(&state, &sub_state);

#ifndef WIN32
	// ignore if PiP
	//if (TAP_Channel_IsStarted(0)) 
	//	return param1;
#endif

	if ((state != STATE_Normal) || (sub_state != SUBSTATE_Normal) || batch_job_started) {
		return param1;
	}
    
	// bar access to standard archive if in multi play mode
	if (multi_play_started && param1 == RKEY_Ok)
		return 0;

	// if Toppy in normal state, then check for activation key
	if (jpg_activation_key && (param1 == jpg_activation_key))
	{
		if (OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
			return param1;

		if ((param1 == RKEY_Ok) && (OsdActive(150, 390, 400, 510))) 
			return param1; 

		if (!jpg_navigation) {
			ChangeDirPath(saved_jpg_current_dir);
			strcpy(curr_dir, saved_jpg_current_dir);
			jpg_navigation = TRUE;
			rec_navigation = FALSE;
			mp3_navigation = FALSE;
			pf_navigation = FALSE;
			restoreNavHistory();
		}
		drawInitialListing(TRUE);
		return 0;
	}

	// also look out for archive key and open up in DataFiles if appropriate
	if (rec_activation_key && (param1 == rec_activation_key))
	{
		if (OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
			return param1;

		if ((param1 == RKEY_Ok) && (OsdActive(150, 390, 400, 510))) 
			return param1; 

		if (!rec_navigation) {
			ChangeDirPath(saved_rec_current_dir);
			strcpy(curr_dir, saved_rec_current_dir);
			rec_navigation = TRUE;
			mp3_navigation = FALSE;
			jpg_navigation = FALSE;
			pf_navigation = FALSE;
			restoreNavHistory();
		}
		drawInitialListing(TRUE);
		return 0;
	}

	// also look out for mp3 key and open up in MP3 if appropriate
	if (mp3_activation_key && (param1 == mp3_activation_key))
	{
		if (OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
			return param1;

		if ((param1 == RKEY_Ok) && (OsdActive(150, 390, 400, 510))) 
			return param1; 

		if (!mp3_navigation) {
			ChangeDirPath(saved_mp3_current_dir);
			strcpy(curr_dir, saved_mp3_current_dir);
			mp3_navigation = TRUE;
			rec_navigation = FALSE;
			jpg_navigation = FALSE;
			pf_navigation = FALSE;
			restoreNavHistory();
		}

		drawInitialListing(TRUE);
		return 0;
	}

	// also look out for file manager key and open up in \ProgramFiles if appropriate
	if (pf_activation_key && (param1 == pf_activation_key))
	{
		if (OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
			return param1;

		if ((param1 == RKEY_Ok) && (OsdActive(150, 390, 400, 510))) 
			return param1; 

		if (!pf_navigation) {
			ChangeDirPath(saved_pf_current_dir);
			strcpy(curr_dir, saved_pf_current_dir);
			mp3_navigation = FALSE;
			rec_navigation = FALSE;
			jpg_navigation = FALSE;
			pf_navigation = TRUE;
			restoreNavHistory();
		}

		drawInitialListing(TRUE);
		return 0;
	}

	// redirect ok to open mm archive
	if (rec_activation_key && param1 == RKEY_Ok) {
		TAP_Hdd_GetPlayInfo(&play_info);

		if (play_info.playMode == PLAYMODE_Playing) {
			TAP_GenerateEvent(EVT_KEY, rec_activation_key, 0);
			return 0;
		}
	}

	if (param1 == RKEY_Stop) {

		if (stop_playing) {
			stop_playing = FALSE; 
			return param1;
		}
		ef (multi_play_started) {
			finishMultiPlay(TRUE);
            return param1;
		}
		ef (enable_stop_menu) {
			TYPE_RecInfo rec_info_1, rec_info_2;
			bool copying_on_1 = TAP_Hdd_GetRecInfo(0, &rec_info_1) && rec_info_1.recType == RECTYPE_Copy;
			bool copying_on_2 = TAP_Hdd_GetRecInfo(1, &rec_info_2) && rec_info_2.recType == RECTYPE_Copy;
			dword seconds_progress;

			if (copying_on_1 || copying_on_2)
				return param1;

			if (OsdActive(50, 10, 200, 40) || OsdActive(50, 150, 200, 300))
				return param1;

			TAP_Hdd_GetPlayInfo(&play_info);

			if (play_info.playMode == PLAYMODE_Playing) {
		
				int percentage = play_info.currentBlock*100 / play_info.totalBlock;

				// if less than five secs since start TAP_Hdd_PlayTs, then do nothing
				/*if (TAP_GetTick() < (update_progress_tick + 500)) {
					if (write_log) TAP_SPrint(log_buffer, "Only %d seconds since started", (TAP_GetTick() - update_progress_tick) / 100);
					if (write_log) logText(log_buffer, FALSE);
					return param1;
				}

				// if less than five secs since start of playback, then do nothing
				seconds_progress = ((60 * play_info.currentBlock * play_info.duration) / play_info.totalBlock);
				if (seconds_progress < 5) {
					if (write_log) TAP_SPrint(log_buffer, "Only %d seconds through", seconds_progress);
					if (write_log) logText(log_buffer, FALSE);
					return param1;
				}*/
		
				if (enable_stop_menu == 3 || stop_menu_percentage == 0 || percentage >= stop_menu_percentage) {

					// double check that we handle the correct recording
					if (play_info.file && strcmp(playing_file.name, play_info.file->name) != 0)
						memcpy(&playing_file, play_info.file, sizeof(playing_file));

					stop_menu_idx = (enable_stop_menu == 3 && percentage < stop_menu_percentage) ? 1 : (enable_stop_menu == 2) ? 1 : 0; 
					stop_menu_highlight =  (enable_stop_menu == 3 && percentage < stop_menu_percentage) ? 1 : (enable_stop_menu == 2) ? 1 : 0;

					handleStopMenu();
				}
				else {
					return param1;
				}

				return 0;
			}
		}
	}

	if (last_played_activation_key && (param1 == last_played_activation_key)) {
		TYPE_File rec_file;
		TAP_Hdd_GetPlayInfo(&play_info);

		if (isPlaying(play_info)) 
			return 0;

		if (strlen(last_played_name) > 0) {
			int last_played_block = getCurrentBlock(last_played_name, last_played_cluster);
			if (write_log) TAP_SPrint(log_buffer, "Resume %s at block %d", last_played_name, last_played_block);
			if (write_log) logText(log_buffer, FALSE);

			if (ChangeDirCurrentRecording(last_played_name, last_played_cluster, &rec_file)) {
				if (write_log) if (verbose) logText("Located directory", FALSE);
				//TAP_Hdd_Fclose(rec_file);

				TAP_Hdd_PlayTs(last_played_name);
				if (last_played_block > 0) {
					TAP_Hdd_GetPlayInfo(&play_info);
					if (play_info.svcType == SVC_TYPE_Radio) {
						word blocks_in_a_minute = play_info.totalBlock / play_info.duration;
						last_played_block = (last_played_block - blocks_in_a_minute < 0) ? 0 : (last_played_block - blocks_in_a_minute);
						TAP_Delay(50);
					}
					TAP_Hdd_ChangePlaybackPos(last_played_block > 50 ? last_played_block - 50 : last_played_block);
				}
				ChangeDirPath(curr_dir);
				return 0;
			}
			ChangeDirPath(curr_dir);
		}
		return 0;
	}

	if (create_thumbnail_key && (param1 == create_thumbnail_key)) {
		TAP_Hdd_GetPlayInfo(&play_info);

		if (play_info.playMode != PLAYMODE_Playing) 
			return param1;

		createRecordingThumbnail(playing_file.name, playing_file.startCluster, TRUE, FALSE, TRUE, FALSE, TRUE);
		ChangeDirPath(curr_dir);
	}

	if (param1 == RKEY_0 || param1 == RKEY_TvSat) {
		TAP_Channel_GetCurrent(&tv_radio, &channel_number);
		if (tv_radio == SVC_TYPE_Radio && (radio_mode == COMPACT || radio_mode == COMPACT_TV)) {
			startExternalMode(radio_mode, FALSE, TRUE);
		}
	}

	return param1;
}

void exitRadioSlideshow()
{
	if (screensaver_started)
		exitScreensaver();
	ef (slideshow_started)
		exitSlideshow();
	ef (compact_mode_started)
		exitCompactMode();
	ef (blank_screen_started)
		exitBlankScreen();

	if (was_radio)
		was_radio = FALSE;
	was_tv = TRUE;
}

void exitBlankScreen()
{
	if (write_log) if (verbose) logText("Exit Blank screen", FALSE);
	
	ChangeDirPath(curr_dir);

	if (external_slideshow) {
		endBlankScreen();
		TAP_EnterNormal();
		return;
	}

	// if we were in playlist before compact mode started, then makes sense to return to playlist
	if (playlist_displayed) {
		if (write_log) if (verbose) logText("Display playlist", FALSE);
		no_of_files = no_of_playlist_mp3s;
		setPlaylistIndex();

		endBlankScreen();

		drawPlaylist(TRUE);
		drawMp3InfoBox();
		copyMemoryToWindow();
		window_displayed = TRUE;
		return;
	}

	populateFiles();

	if (write_log) if (verbose) logText("Set highlighted line", FALSE);
	if (mp3_playing && strcmp(curr_dir, mp3_files[current_mp3]->directory) == 0)
		setReturnIndex(mp3_files[current_mp3]->file_name);

	endBlankScreen();

	if (write_log) if (verbose) logText("Draw file list", FALSE);
	if (thumbnail_mode) {
		drawThumbnailGrid(FALSE);
	}
	else {
		drawFileList(TRUE, FALSE);
		drawMp3InfoBox();
	}
	copyMemoryToWindow();
	window_displayed = TRUE;

	if (write_log) if (verbose) logText("Exited Blank screen", FALSE);
}

void exitCompactMode()
{
	if (write_log) if (verbose) logText("Exit Compact mode", FALSE);

	ChangeDirPath(curr_dir);

	if (external_slideshow) {
		endCompactMode();
		TAP_EnterNormal();
		return;
	}

	// if we were in playlist before compact mode started, then makes sense to return to playlist
	if (playlist_displayed) {
		no_of_files = no_of_playlist_mp3s;
		setPlaylistIndex();

		endCompactMode();

		drawPlaylist(TRUE);
		drawMp3InfoBox();
		copyMemoryToWindow();
		window_displayed = TRUE;
		return;
	}
	
	populateFiles();

	if (write_log) if (verbose) logText("Set highlighted line", FALSE);
	if (mp3_playing && strcmp(curr_dir, mp3_files[current_mp3]->directory) == 0)
		setReturnIndex(mp3_files[current_mp3]->file_name);

	endCompactMode();

	if (write_log) if (verbose) logText("Draw file list", FALSE);
	if (thumbnail_mode) {
		drawThumbnailGrid(FALSE);
	}
	else {
		drawFileList(TRUE, FALSE);
		drawMp3InfoBox();
	}
	copyMemoryToWindow();
	window_displayed = TRUE;

	if (write_log) if (verbose) logText("Exited Compact mode", FALSE);
}

void exitAlbumArt(void)
{
	if (write_log) if (verbose) logText("Exit album art", FALSE);
	
	ChangeDirPath(curr_dir);

	// if we were in playlist before album art started, then makes sense to return to playlist
	if (playlist_displayed) {

		if (write_log) if (verbose) logText("Display playlist", FALSE);
		no_of_files = no_of_playlist_mp3s;

		setPlaylistIndex();

		endAlbumArt();
	
		if (idle_before_window_display) {
			draw_playlist = TRUE;
			return;
		}

		drawPlaylist(TRUE);
		drawMp3InfoBox();
		copyMemoryToWindow();
		window_displayed = TRUE;
		return;
	}

	populateFiles();

	if (write_log) if (verbose) logText("Set highlighted line", FALSE);
	if (mp3_playing && strcmp(curr_dir, mp3_files[current_mp3]->directory) == 0)
		setReturnIndex(mp3_files[current_mp3]->file_name);

	endAlbumArt();

	if (idle_before_window_display) {
		draw_playlist = FALSE;
		return;
	}

	if (write_log) if (verbose) logText("Draw list", FALSE);
	if (thumbnail_mode) {
		drawThumbnailGrid(FALSE);
	}
	else {
		drawFileList(TRUE, FALSE);
		drawMp3InfoBox();
	}
	copyMemoryToWindow();
	window_displayed = TRUE;

	if (write_log) if (verbose) logText("Exited album art", FALSE);
}

void exitScreensaver(void)
{
	if (write_log) if (verbose) logText("Exit screensaver", FALSE);
	
	if (external_slideshow) {
		endScreensaver(FALSE);
		ChangeDirPath(curr_dir);
		TAP_EnterNormal();
		return;
	}

	// if we were in playlist before slideshow started, then makes sense to return to playlist
	if (playlist_displayed) {
		if (write_log) if (verbose) logText("Display playlist", FALSE);
		if (photo_playlist_mode) {
			no_of_files = no_of_playlist_photos;
			saved_playlist_idx = previous_jpeg;
			saved_playlist_highlight = -1;
		}
		else {
			no_of_files = no_of_playlist_mp3s;
			setPlaylistIndex();
		}

		endScreensaver(FALSE);
		ChangeDirPath(curr_dir);

		if (idle_before_window_display) {
			draw_playlist = TRUE;
			return;
		}
		
		drawPlaylist(TRUE);
		drawMp3InfoBox();
		window_displayed = TRUE;
		copyMemoryToWindow();
		return;
	}

	ChangeDirPath(curr_dir);
	populateFiles();

	if (write_log) if (verbose) logText("Set highlighted line", FALSE);
	if (mp3_playing && InMp3FilesFolder(curr_dir) && strcmp(curr_dir, mp3_files[current_mp3]->directory) == 0)
		setReturnIndex(mp3_files[current_mp3]->file_name);
	ef (!InMp3FilesFolder(curr_dir) && strcmp(curr_dir, jpeg_files[previous_jpeg]->directory) == 0)
		setReturnIndex(jpeg_files[previous_jpeg]->file_name);

	endScreensaver(FALSE);

	if (idle_before_window_display) {
		draw_playlist = FALSE;
		return;
	}
		
	if (write_log) if (verbose) logText("Draw file list", FALSE);
	if (thumbnail_mode) {
		drawThumbnailGrid(FALSE);
	}
	else {
		drawFileList(TRUE, FALSE);
		drawMp3InfoBox();
	}
	window_displayed = TRUE;
	copyMemoryToWindow();

	if (write_log) if (verbose) logText("Exited screensaver", FALSE);
}

void exitSlideshow(void)
{
	if (write_log) if (verbose) logText("Exit slideshow", FALSE);
	TAP_Osd_FillBox(region_now, offset_x, offset_y-20, 100, 18, COLOR_Black);
	drawText(region_now, offset_x, offset_y-20, -1, exiting_t, body_text_colour, COLOR_None, FNT_Size_1419);
	
	if (external_slideshow) {
		endSlideshow(FALSE);
		ChangeDirPath(curr_dir);
		TAP_EnterNormal();
		return;
	}

	// if we were in playlist before slideshow started, then makes sense to return to playlist
	if (playlist_displayed) {
		if (write_log) if (verbose) logText("Display playlist", FALSE);
		if (photo_playlist_mode) {
			no_of_files = no_of_playlist_photos;
			saved_playlist_idx = previous_jpeg;
			saved_playlist_highlight = -1;
		}
		else {
			no_of_files = no_of_playlist_mp3s;
			if (mp3_playing)
				setPlaylistIndex();
			else {
				saved_playlist_idx = 0;
				saved_playlist_highlight = -1;
			}
		}

		endSlideshow(FALSE);
		ChangeDirPath(curr_dir);

		if (idle_before_window_display) {
			draw_playlist = TRUE;
			return;
		}
		
		drawPlaylist(TRUE);
		drawMp3InfoBox();
		window_displayed = TRUE;
		copyMemoryToWindow();
		return;
	}

	ChangeDirPath(curr_dir);
	populateFiles();

	if (mp3_playing && InMp3FilesFolder(curr_dir) && strcmp(curr_dir, mp3_files[current_mp3]->directory) == 0)
		setReturnIndex(mp3_files[current_mp3]->file_name);
	ef (!InMp3FilesFolder(curr_dir) && strcmp(curr_dir, jpeg_files[previous_jpeg]->directory) == 0)
		setReturnIndex(jpeg_files[previous_jpeg]->file_name);

	endSlideshow(FALSE);

	if (idle_before_window_display) {
		draw_playlist = FALSE;
		return;
	}

	if (thumbnail_mode) {
		drawThumbnailGrid(FALSE);
	}
	else {
		drawFileList(TRUE, FALSE);
		drawMp3InfoBox();
	}
	window_displayed = TRUE;
	copyMemoryToWindow();
}

void moveMP3Highlight()
{
	// if playlist displayed in mp3 mode and we are listening to the playlist, then refresh place in list
	if (playlist_displayed)	{
		if (/*mp3_playlist_selection && */!photo_playlist_mode) {
			if (setPlaylistIndex() != -1) {
				drawPlaylist(FALSE);
				copyMemoryToWindow();
			}
		}
	}
	// otherwise refresh place in list if we are in the current mp3 directory
	ef (strcmp(curr_dir, mp3_files[current_mp3]->directory) == 0) {
		setReturnIndex(mp3_files[current_mp3]->file_name);

		if (thumbnail_mode) {
			drawThumbnailGrid(FALSE);
		}
		else {
			drawFileList(FALSE, FALSE);
		}
		copyMemoryToWindow();
	}
}

/* change to a new mp3 artist folder (retains a simple history) */
void handleChangeFolder(bool forward, bool force)
{
	if (mp3_playing || force) {
		if (write_log) if (verbose) logText("Change MP3 folder", TRUE);
				
		// if we are in root or playing from /MP3, then nowhere to go
		if (strcmp(curr_dir, "/") == 0 || (strcmp(curr_dir, "/MP3") == 0 && mp3s_in_current_folder))
			return;

		if (!forward) {
			// no history means we are in the playlist
			if (folder_history[0] == NULL)
				return;

			// if we are going backwards, then get the previous folder
			ChangeDirPath(getNextFolder(FALSE));

			// populate the mp3s
			populateMP3s(TRUE, FALSE);
		}
		else {
			if (folder_history_pointer > 0) {
				// if we have gone backwards, then retrace our path forwards
				ChangeDirPath(getNextFolder(TRUE));

				populateMP3s(TRUE, FALSE);
			}
			else {
				// change to the next appropriate folder
				if (ChangeDirFolder()) {

					word i;
				
					// populate the mp3s
					populateMP3s(TRUE, FALSE);

					// if none available, then try up to 10 different folders
					i = 0;
					while (no_of_mp3s == 0 && i < 10) {
						ChangeDirFolder();
						populateMP3s(TRUE, FALSE);
						i++;
					}

					// save the folder history if we have actually changed to a valid artist
					if (no_of_mp3s > 0)
						saveFolderHistory(tracked_dir);
				}

				// if no other albums available, then return to original choice
				if (no_of_mp3s == 0) {
					ChangeDirPath(curr_dir);
					populateMP3s(TRUE, FALSE);
				}
			}
		}

		// stop the current mp3 and reset stuff
		if (mp3_playing) {
			mp3_playing = FALSE;
#ifndef WIN32
			TAP_Hdd_StopMp3();
#endif
		}

		// play the new mp3s
		clearHistory(FALSE);
		if (randomise_mp3s)
			current_mp3 = getNextMp3(TRUE);
		else {
			current_mp3 = 0;
			saveHistory(FALSE, current_mp3);
		}
		ChangeDirPath(mp3_files[current_mp3]->directory);
		playMp3(mp3_files[current_mp3]->file_name);

		// refresh the mp3 info box
		if (!(window_displayed && thumbnail_mode) 
				&& !screensaver_started 
				&& !compact_mode_started 
				&& !blank_screen_started 
				&& !(slideshow_started && full_size_display))
			drawMp3InfoBox();

		// highlight the current mp3 if appropriate
		if (window_displayed)
			moveMP3Highlight();

		// return to original directory
		ChangeDirPath(curr_dir);
	}
}

void handleChangeTrack(bool forward)
{
	if (!mp3_playing)
		return;

	if (write_log) TAP_SPrint(log_buffer, "Play next MP3, history length is %d of %d", FALSE, getHistoryLength(FALSE), no_of_mp3s);
	if (write_log) logText(log_buffer, FALSE);
	single_mp3_mode = FALSE;

	TAP_Hdd_StopMp3();

	if (getHistoryLength(FALSE) == no_of_mp3s) {
		switch (mp3_end_mode) { 
			case STOP_ALBUM:
				if (write_log) logText("End of album, stop playing", FALSE);
				handleExitMp3(TRUE);
				return;
			case REPEAT_ALBUM:
				if (write_log) logText("End of album, repeat", FALSE);
				break;
			case NEXT_ALBUM:
				if (write_log) logText("End of album, play next album", FALSE);
				handleChangeFolder(TRUE, TRUE);
				return;
		}
	}
	
	// choose the next track and play it
	current_mp3 = getNextMp3(forward);
	ChangeDirPath(mp3_files[current_mp3]->directory);
	playMp3(mp3_files[current_mp3]->file_name);
	
	// refresh the mp3 info box
	if (!(window_displayed && thumbnail_mode) 
			&& !screensaver_started 
			&& !compact_mode_started 
			&& !blank_screen_started 
			&& !(slideshow_started && full_size_display))
		drawMp3InfoBox();

	// highlight the current mp3 if appropriate
	if (window_displayed)
		moveMP3Highlight();

	// change back to original path
	ChangeDirPath(curr_dir);
}

dword handleSlideshowEventKey(dword param1)
{
	TYPE_PlayInfo play_info;
	struct _dimensions *dims;

	switch(param1)
	{
		case RKEY_Exit :
			
			exitSlideshow();
			break;

		case RKEY_Ok:

			if (write_log) if (verbose) logText("Return to photo folder", FALSE);
				
			if (external_slideshow) {
				exitSlideshow();
				break;
			}

			// if we were in playlist before slideshow started, then makes sense to return to playlist
			if ((playlist_displayed && photo_playlist_mode)
					|| (mp3_slideshow && strcmp(default_slideshow_directory, "Playlist") == 0)) {
				if (write_log) if (verbose) logText("Display playlist", FALSE);
				no_of_files = no_of_playlist_photos;
				saved_playlist_idx = previous_jpeg;
				saved_playlist_highlight = -1;
				photo_playlist_mode = TRUE;
				if (mp3_slideshow) {
					playlist_displayed = TRUE;
					if (!discard_navigation_history)
						copyNavHistory();
					clearJpgNavHistory();
					strcpy(curr_dir, default_startup_directory);
					jpg_navigation = TRUE;
					mp3_navigation = FALSE;
					rec_navigation = FALSE;
					pf_navigation = FALSE;
				}

				endSlideshow(FALSE);
				ChangeDirPath(curr_dir);

				if (idle_before_window_display) {
					draw_playlist = TRUE;
					return 0;
				}

				drawPlaylist(TRUE);
				drawMp3InfoBox();
				copyMemoryToWindow();
				window_displayed = TRUE;
				break;
			}

			// reset current dir and history if coming from an mp3 slideshow (must be default slideshow dir)
			if (mp3_slideshow) {
				if (!discard_navigation_history)
					copyNavHistory();
				clearJpgNavHistory();
				strcpy(curr_dir, default_slideshow_directory);
				jpg_navigation = TRUE;
				mp3_navigation = FALSE;
				rec_navigation = FALSE;
				pf_navigation = FALSE;
			}
			ChangeDirPath(curr_dir);
			populateFiles(TRUE);

			if (strcmp(curr_dir, jpeg_files[previous_jpeg]->directory) == 0)
				setReturnIndex(jpeg_files[previous_jpeg]->file_name);

			endSlideshow(FALSE);
			
			if (idle_before_window_display) {
				draw_playlist = FALSE;
				playlist_displayed = FALSE;
				return 0;
			}

			if (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(TRUE, FALSE);
				drawMp3InfoBox();
			}
			copyMemoryToWindow();
			playlist_displayed = FALSE;
			window_displayed = TRUE;
			break;

		case RKEY_Red:

			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:

			handleChangeTrack(TRUE);
			break;

		case RKEY_VolUp :
			if (write_log) if (verbose) logText("Right arrow: Show next photo", FALSE);
			show_jpeg = TRUE;
			force_display = TRUE;
			rotated_degrees = 0;
			if (!full_size_display) {
				TAP_Osd_FillBox(region_now, offset_x, offset_y-20, 100, 18, COLOR_Black);
				TAP_SPrint(buffer, "%s...", next_t);
				drawText(region_now, offset_x, offset_y-20, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
			}
			break;

		case RKEY_VolDown :
			if (write_log) if (verbose) logText("Left arrow: Show previous photo", FALSE);

			// since we already have the next one ready, need to go back twice
			current_jpeg = getNextJpeg(FALSE);
			freeMemory();
			jpeg_failed = FALSE;
			show_jpeg = TRUE;
			force_display = TRUE;
			rotated_degrees = 0;
			if (!full_size_display) {
				TAP_Osd_FillBox(region_now, offset_x, offset_y-20, 100, 18, COLOR_Black);
				TAP_SPrint(buffer, "%s...", previous_t);
				drawText(region_now, offset_x, offset_y-20, offset_x+150, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
			}
			break;

		case RKEY_Rewind :
			if (write_log) if (verbose) logText("Rewind: Rotate anti-clockwise", FALSE);
			current_jpeg = previous_jpeg;
			freeMemory();
			jpeg_failed = FALSE;
			show_jpeg = TRUE;
			force_display = TRUE;
			if (!full_size_display) {
				TAP_Osd_FillBox(region_now, offset_x, offset_y-20, 100, 18, COLOR_Black);
				TAP_SPrint(buffer, "%s...", rotating_t);
				drawText(region_now, offset_x, offset_y-20, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
			}

			// save the new rotation details
			ChangeDirPath(jpeg_files[current_jpeg]->directory);
			loadDimensions();
			dims = getDimensions(jpeg_files[current_jpeg]->file_name);
			if (dims) {
				rotated_degrees = ((dims->rotation == 0) ? 3 : dims->rotation - 1) * 90;
				dims->rotation = rotated_degrees / 90;
			}
			else {
				dimensions[no_of_dimensions] = dlmalloc(sizeof(*dimensions[no_of_dimensions]));
				strcpy(dimensions[no_of_dimensions]->file_name, jpeg_files[current_jpeg]->file_name);
				rotated_degrees = 270;
				dimensions[no_of_dimensions]->rotation = rotated_degrees / 90;
				no_of_dimensions++;
			}
			saveDimensions();
			break;

		case RKEY_Forward :
			if (write_log) if (verbose) logText("FF: Rotate clockwise", FALSE);
			current_jpeg = previous_jpeg;
			freeMemory();
			jpeg_failed = FALSE;
			show_jpeg = TRUE;
			force_display = TRUE;
			rotated_degrees = (rotated_degrees + 90) % 360;
			if (!full_size_display) {
				TAP_Osd_FillBox(region_now, offset_x, offset_y-20, 100, 18, COLOR_Black);
				TAP_SPrint(buffer, "%s...", rotating_t);
				drawText(region_now, offset_x, offset_y-20, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
			}

			// save the new rotation details
			ChangeDirPath(jpeg_files[current_jpeg]->directory);
			loadDimensions();
			dims = getDimensions(jpeg_files[current_jpeg]->file_name);
			if (dims) {
				rotated_degrees = ((dims->rotation == 3) ? 0 : dims->rotation + 1) * 90;
				dims->rotation = rotated_degrees / 90;
			}
			else {
				dimensions[no_of_dimensions] = dlmalloc(sizeof(*dimensions[no_of_dimensions]));
				strcpy(dimensions[no_of_dimensions]->file_name, jpeg_files[current_jpeg]->file_name);
				rotated_degrees = 90;
				dimensions[no_of_dimensions]->rotation = rotated_degrees / 90;
				no_of_dimensions++;
			}
			saveDimensions();
			break;

		case RKEY_Recall :
			if (write_log) if (verbose) logText("Ok: Display full screen", FALSE);
			mp3_progress_offset = 0;
			current_jpeg = previous_jpeg;
			freeMemory();
			full_size_display = full_size_display == TRUE ? FALSE : TRUE;
			jpeg_failed = FALSE;
			show_jpeg = TRUE;
			force_display = TRUE;
			rotated_degrees = 0;
			fade_state = SHOW_PLANE1;
			region = region_1;

			TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
#ifndef WIN32
			TAP_Osd_SetTransparency(region_1, 255);
#endif
			break;

		case RKEY_Pause :

			if (paused_slideshow) {
				if (write_log) if (verbose) logText("End paused slideshow", FALSE);
				exitSlideshow();
				return param1;
			}

			if (write_log) if (verbose) logText("Pausing slideshow", FALSE);
			slideshow_paused = TRUE;
			if (!full_size_display) {
				TAP_Osd_FillBox(region_now, offset_x, offset_y-20, 100, 18, COLOR_Black);
				TAP_SPrint(buffer, "%s...", paused_t);
				drawText(region_now, offset_x, offset_y-20, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
			}
			break;

		case RKEY_Play :

			if (paused_slideshow) {
				if (write_log) if (verbose) logText("End paused slideshow", FALSE);
				exitSlideshow();
				return param1;
			}

			if (slideshow_paused)
			{
				if (write_log) if (verbose) logText("Restarting slideshow", FALSE);
				slideshow_paused = FALSE;
				rotated_degrees = 0;
				if (!full_size_display) {
					TAP_Osd_FillBox(region_now, offset_x, offset_y-20, 100, 18, COLOR_Black);
					TAP_SPrint(buffer, "%s...", playing_t);
					drawText(region_now, offset_x, offset_y-20, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1419);
				}
			}
			break;

		case RKEY_TvRadio :

			TAP_Hdd_GetPlayInfo(&play_info);
			if (!radio_slideshow || isPlaying(play_info))
				return 0;

			exitSlideshow();
			return param1;

		case RKEY_Stop :
			
			if (radio_slideshow) {
				exitSlideshow();
				TAP_Hdd_GetPlayInfo(&play_info);
				if (isPlaying(play_info))
					return param1;
			}

			handleStopKey(TRUE);
			break;
	}

	return 0;
}

void handleRestartTrack()
{
	if (!mp3_playing)
		return;

	if (write_log) if (verbose) logText("Restart the current track", FALSE);
	ChangeDirPath(mp3_files[current_mp3]->directory);
	mp3_playing = FALSE;
	TAP_Hdd_StopMp3();
	playMp3(mp3_files[current_mp3]->file_name);

	// change back to original path
	ChangeDirPath(curr_dir);
}

void handleToggleRandomMp3()
{
	if (!mp3_playing)
		return;

	if (write_log) if (verbose) logText("Toggle random/sequential play mode", FALSE);
	randomise_mp3s = randomise_mp3s ? FALSE : TRUE;
	ChangeDirMediaManager();
	SaveConfigurationToFile();

	// stop the current mp3 and reset stuff
	handleStopMp3(FALSE, FALSE);

	// play the mp3s in new mode
	if (randomise_mp3s)
		current_mp3 = getNextMp3(TRUE);
	else {
		current_mp3 = 0;
		saveHistory(FALSE, current_mp3);
	}
	
	ChangeDirPath(mp3_files[current_mp3]->directory);
	playMp3(mp3_files[current_mp3]->file_name);
}

dword handleBlankScreenEventKey(dword param1)
{
	TYPE_PlayInfo play_info;

	switch(param1)
	{
		case RKEY_Exit :
			
			exitBlankScreen();
			break;
		
		case RKEY_Red:
		case RKEY_VolDown :

			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:
		case RKEY_VolUp :

			handleChangeTrack(TRUE);
			break;

		case RKEY_Rewind :
			
			handleChangeFolder(FALSE, FALSE);
			break;

		case RKEY_Forward :

			handleChangeFolder(TRUE, FALSE);
			break;

		case RKEY_Play :
		
			handleRestartTrack();
			break;

		case RKEY_Pause :

			handleToggleRandomMp3();
			break;

		case RKEY_TvRadio :
			
			TAP_Hdd_GetPlayInfo(&play_info);
			if (!radio_slideshow || isPlaying(play_info))
				return 0;

			exitBlankScreen();
			return param1;

		case RKEY_Stop :

			exitBlankScreen();
			
			TAP_Hdd_GetPlayInfo(&play_info);
			if (radio_slideshow && isPlaying(play_info))
				return param1;

			// stop mp3 and exit, since it makes no sense to stay here once mp3 has stopped
			handleStopKey(TRUE);
			break;
	}

	return 0;
}

dword handleCompactModeEventKey(dword param1)
{
	TYPE_PlayInfo play_info;

	switch(param1)
	{
		case RKEY_Exit :
			
			exitCompactMode();
			break;
		
		case RKEY_Text :

			if (compact_offset_x != 190 || compact_offset_y != 190 || compact_art_mode || compact_tv_mode  || radio_slideshow)
				break;

			// toggle the help box on and off
			if (compact_help_displayed) {
				TAP_Osd_FillBox(region, 190-10, 430-10, 340+20, 80+20, COLOR_None);
				compact_help_displayed = FALSE;
			}
			else {
				refreshCompactModeHelp(external_slideshow ? FALSE : TRUE);
				compact_help_displayed = TRUE;
			}

			break;

		case RKEY_Red:
		case RKEY_VolDown :

			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:
		case RKEY_VolUp :

			handleChangeTrack(TRUE);
			break;

		case RKEY_ChDown :

			if (compact_art_mode) {
				int total_tv_channels, total_radio_channels;
				TAP_Osd_FillBox(region, compact_offset_x+460-200-15-1, compact_offset_y+38-1, 200+2, 200+2, COLOR_None);
				TAP_Osd_DrawRectangle(region, compact_offset_x+460-200-15-1, compact_offset_y+58-4, 200+2, 160+8, 2, bare_bones_border_colour);

				TAP_Channel_GetTotalNum(&total_tv_channels, &total_radio_channels);
				TAP_Channel_Start(CHANNEL_Sub, SVC_TYPE_Tv, total_tv_channels-1);
				TAP_Channel_Scale(CHANNEL_Sub, compact_offset_x+460-200-15, compact_offset_y+58, 200, 160, TRUE);
				compact_art_mode = FALSE;
				compact_tv_mode = TRUE;

				refreshCompactChannel();
			}
			ef (compact_tv_mode) {
				TAP_Channel_GetCurrentSubTV(&channel_number);
				if (channel_number > 0 || radio_slideshow) {
					TAP_Channel_Move(CHANNEL_Sub, -1);
					refreshCompactChannel();
				}
				else {
					compact_tv_mode = FALSE;
					compact_art_mode = TRUE;
					TAP_Channel_Stop(CHANNEL_Sub);
					refreshCompactMode(TRUE);
				}
			}
			break;

		case RKEY_ChUp :

			if (compact_art_mode) {
				TAP_Osd_FillBox(region, compact_offset_x+460-200-15-1, compact_offset_y+38-1, 200+2, 200+2, COLOR_None);
				TAP_Osd_DrawRectangle(region, compact_offset_x+460-200-15-1, compact_offset_y+58-4, 200+2, 160+8, 2, bare_bones_border_colour);

				TAP_Channel_Start(CHANNEL_Sub, SVC_TYPE_Tv, 0);
				TAP_Channel_Scale(CHANNEL_Sub, compact_offset_x+460-200-15, compact_offset_y+58, 200, 160, TRUE);
				compact_art_mode = FALSE;
				compact_tv_mode = TRUE;

				refreshCompactChannel();
			}
			ef (compact_tv_mode) {
				int total_tv_channels, total_radio_channels;
				TAP_Channel_GetTotalNum(&total_tv_channels, &total_radio_channels);
				TAP_Channel_GetCurrentSubTV(&channel_number);
				if (channel_number < (total_tv_channels-1) || radio_slideshow) {
					TAP_Channel_Move(CHANNEL_Sub, 1);
					refreshCompactChannel();
				}
				else {
					compact_tv_mode = FALSE;
					compact_art_mode = TRUE;
					TAP_Channel_Stop(CHANNEL_Sub);
					refreshCompactMode(TRUE);
				}
			}
			break;

		case RKEY_Rewind :
			
			handleChangeFolder(FALSE, FALSE);
			break;

		case RKEY_Forward :

			handleChangeFolder(TRUE, FALSE);
			break;

		case RKEY_Play :
		
			handleRestartTrack();
			break;

		case RKEY_Pause :

			handleToggleRandomMp3();
			break;

		case RKEY_TvRadio :
			
			TAP_Hdd_GetPlayInfo(&play_info);
			if (!radio_slideshow || isPlaying(play_info))
				return 0;

			exitCompactMode();
			return param1;

		case RKEY_Guide :
			
			TAP_Hdd_GetPlayInfo(&play_info);
			if (!radio_slideshow || isPlaying(play_info))
				return 0;

			exitCompactMode();
			return param1;

		case RKEY_Stop :

			exitCompactMode();
			
			TAP_Hdd_GetPlayInfo(&play_info);
			if (radio_slideshow && isPlaying(play_info))
				return param1;

			// stop mp3 and exit, since it makes no sense to stay here once mp3 has stopped
			handleStopKey(TRUE);
			break;
	}

	return 0;
}

dword handleAlbumArtEventKey(dword param1)
{
	switch(param1)
	{
		case RKEY_Exit :
			
			exitAlbumArt();
			break;
		
		case RKEY_Recall :

			// full screen toggle
			if (write_log) if (verbose) logText("Ok: Toggle album art full screen", FALSE);
			mp3_progress_offset = 0;
			current_jpeg = 0;
			jpeg_failed = FALSE;
			show_jpeg = TRUE;
			force_display = TRUE;
			memory_delay_elapsed = TRUE;

			TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_Black);
			toggleAlbumArt();
			break;

		case RKEY_Red:
		case RKEY_VolDown :

			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:
		case RKEY_VolUp :

			handleChangeTrack(TRUE);
			break;

		case RKEY_Rewind :
			
			handleChangeFolder(FALSE, FALSE);
			break;

		case RKEY_Forward :

			handleChangeFolder(TRUE, FALSE);
			break;

		case RKEY_Play :
		
			handleRestartTrack();
			break;
		
		case RKEY_Pause :

			handleToggleRandomMp3();
			break;

		case RKEY_Stop :

			// stop mp3 and exit, since it makes no sense to stay here once mp3 has stopped
			exitAlbumArt();
			if (idle_before_window_display)
				stop_mp3 = TRUE;
			else
				handleStopKey(TRUE);
			break;
	}

	return 0;
}

dword handleScreensaverEventKey(dword param1)
{
	TYPE_PlayInfo play_info;

	switch(param1)
	{
		case RKEY_Exit :
	
			exitScreensaver();
			break;

		case RKEY_Recall :
			
			endScreensaver(TRUE);
			photo_mode = (photo_mode + 1) % 10;
			while (photo_mode == OFF || photo_mode == SLIDESHOW || photo_mode == ALBUM_ART || photo_mode == COMPACT || photo_mode == COMPACT_ART || photo_mode == COMPACT_TV || photo_mode == BLANK_SCREEN)
				photo_mode = (photo_mode + 1) % 10;

			if (external_slideshow)
				startExternalMode(photo_mode, TRUE, radio_slideshow ? TRUE : FALSE);
			else
				startMP3Mode(photo_mode, TRUE);
			break;

		case RKEY_Red:

			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:

			handleChangeTrack(TRUE);
			break;

		case RKEY_Rewind :
			
			handleChangeFolder(FALSE, FALSE);
			break;

		case RKEY_Forward :

			handleChangeFolder(TRUE, FALSE);
			break;

		case RKEY_Play :
		
			if (paused_slideshow) {
				if (write_log) if (verbose) logText("End paused screensaver", FALSE);
				exitScreensaver();
				return param1;
			}

			if (mp3_playing)
				handleRestartTrack();
			break;

		case RKEY_Pause :

			if (paused_slideshow) {
				if (write_log) if (verbose) logText("End paused screensaver", FALSE);
				exitScreensaver();
				return param1;
			}

			handleToggleRandomMp3();
			break;

		case RKEY_TvRadio :
			
			TAP_Hdd_GetPlayInfo(&play_info);
			if (!radio_slideshow || isPlaying(play_info))
				return 0;

			exitScreensaver();
			return param1;

		case RKEY_Stop :

			exitScreensaver();
			
			TAP_Hdd_GetPlayInfo(&play_info);
			if (radio_slideshow && isPlaying(play_info))
				return param1;

			if (idle_before_window_display)
				stop_mp3 = TRUE;
			else
				handleStopKey(TRUE);
			break;
	}

	return 0;
}

dword handleInfoEventKey(dword param1)
{
	switch(param1)
	{
		case RKEY_Exit :
		case RKEY_Info :
			// delete info OSD and return to file list
			if (write_log) if (verbose) logText("Exit info", FALSE);
			info_displayed = FALSE;
			TAP_Osd_RestoreBox(region, X, Y, W, H, info_save);
			TAP_Osd_RestoreBox(region_mem, X, Y, W, H, info_save);
			TAP_MemFree(info_save);
			info_save = NULL;
			window_displayed = TRUE;
			break;
	}

	return 0;
}

dword handleRecInfoEventKey(dword param1)
{
	switch(param1)
	{
		case RKEY_Exit :
		case RKEY_Info :
			// delete info OSD and return to file list
			if (write_log) if (verbose) logText("Exit recording info", FALSE);
			rec_info_displayed = FALSE;
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, rec_info_save);
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, rec_info_save);
			TAP_MemFree(rec_info_save);
			rec_info_save = NULL;
			window_displayed = TRUE;
			break;
		
		case RKEY_Recall :
			smaller_font = smaller_font ? FALSE : TRUE;
			info_pointer = page_pointers[page_number];
			drawRecDetailLines(-1);
			copyMemoryToRecInfoViewer();
			break;

		//case RKEY_ChDown :

			//if (info_overflow && info_pointer < strlen(extInfo)) {
			//	drawRecDetailLines(SCROLL_DOWN);
			//}
			//break;

		//case RKEY_ChUp :

			//if (info_overflow && info_start_pointer > 0) {
			//	drawRecDetailLines(SCROLL_UP);
			//}
			//break;

		case RKEY_Forward :
		case RKEY_ChDown :
		case RKEY_VolUp :

			if (info_pointer < strlen(extInfo)) {
				page_number++;
				page_pointers[page_number] = info_pointer;
				drawRecDetailLines(PAGE_DOWN);
				copyMemoryToRecInfoViewer();
			}
			break;

		case RKEY_Rewind :
		case RKEY_ChUp :
		case RKEY_VolDown :

			if (page_number > 0) {
				page_number--;
				info_pointer = page_pointers[page_number];
				drawRecDetailLines(PAGE_UP);
				copyMemoryToRecInfoViewer();
			}
			break;
	}

	return 0;
}

dword handleHelpEventKey(dword param1)
{
	switch(param1)
	{
		case RKEY_Exit :
		case RKEY_Text :
			// delete info OSD and return to file list
			if (write_log) if (verbose) logText("Exit recording help", FALSE);
			help_displayed = FALSE;
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, help_save);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, help_save);
			TAP_MemFree(help_save);
			help_save = NULL;
			window_displayed = TRUE;
			break;
	}

	return 0;
}

dword handleLogEventKey(dword param1)
{
	switch(param1)
	{
		case RKEY_ChUp :
			
			break;

		case RKEY_ChDown :
			
			break;

		case RKEY_Rewind :
			if (page_number > 0)
			{
				page_number--;
				//TAP_Hdd_Fseek(log_file, page_pointers[page_number], 0);
				log_read_so_far = page_pointers[page_number];
				drawLogLines();
				TAP_Osd_Copy(region_mem, region, X, Y, W, 30, X, Y, FALSE);
				TAP_Osd_Copy(region_mem, region, X-5, Y+30, W+10+1, H-30, X-5, Y+30, FALSE);
			}
			break;

		case RKEY_Forward :
			if (!log_eof)
			{
				page_number++;
				drawLogLines();
				TAP_Osd_Copy(region_mem, region, X, Y, W, 30, X, Y, FALSE);
				TAP_Osd_Copy(region_mem, region, X-5, Y+30, W+10+1, H-30, X-5, Y+30, FALSE);
			}
			break;

		case RKEY_Recall :
			smaller_font = smaller_font ? FALSE : TRUE;
			log_read_so_far = page_pointers[page_number];
			drawLogLines();
			TAP_Osd_Copy(region_mem, region, X, Y, W, 30, X, Y, FALSE);
			TAP_Osd_Copy(region_mem, region, X-5, Y+30, W+10+1, H-30, X-5, Y+30, FALSE);
			break;

		case RKEY_Ok :
			/*while (!log_eof)
			{
				page_number++;
				drawLogLines();
			}
			TAP_Hdd_Fseek(log_file, page_pointers[page_number], 0);
			log_read_so_far = page_pointers[page_number];
			drawLogLines();
			TAP_Osd_Copy(region_mem, region, 0, 0, 720, 576, 0, 0, FALSE);*/
			break;

		case RKEY_Exit :
			// release memory, delete log OSD and return to file list
			if (write_log) if (verbose) logText("Exit log", FALSE);
			dlfree(log_data);
			dlmalloc_trim(0);

			log_displayed = FALSE;
			if (thumbnail_mode) {
				recreateWindow();
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(TRUE, FALSE);
				drawMp3InfoBox();
			}
			copyMemoryToWindow();
			window_displayed = TRUE;
			smaller_font = FALSE;
			break;
	}

	return 0;
}

dword handleAutoDeleteUpdateEventKey(dword param1)
{
	switch(param1)
	{
		case RKEY_VolUp :
			switch(auto_delete_update_idx)
			{
				case 1:
					auto_delete_list[auto_delete_idx]->delete_after_days = (auto_delete_list[auto_delete_idx]->delete_after_days + 1) % 366;
					break;
				
				case 2:
					auto_delete_list[auto_delete_idx]->delete_after_min = (auto_delete_list[auto_delete_idx]->delete_after_min + 1) % 101;
					break;

				case 3:
					auto_delete_list[auto_delete_idx]->delete_after_max = (auto_delete_list[auto_delete_idx]->delete_after_max + 1) % 101;
					break;

				case 4:
					auto_delete_list[auto_delete_idx]->delete_when_disk = (auto_delete_list[auto_delete_idx]->delete_when_disk + 1) % 100;
					break;
			}
			drawAutoDeleteUpdateBoxLine(auto_delete_update_idx);
			copyMemoryToRecInfoViewer();
			break;

		case RKEY_VolDown :
			switch(auto_delete_update_idx)
			{
				case 1:
					auto_delete_list[auto_delete_idx]->delete_after_days = auto_delete_list[auto_delete_idx]->delete_after_days == 0 ? 365 : auto_delete_list[auto_delete_idx]->delete_after_days - 1;
					break;

				case 2:
					auto_delete_list[auto_delete_idx]->delete_after_min = auto_delete_list[auto_delete_idx]->delete_after_min == 0 ? 100 : auto_delete_list[auto_delete_idx]->delete_after_min - 1;
					break;

				case 3:
					auto_delete_list[auto_delete_idx]->delete_after_max = auto_delete_list[auto_delete_idx]->delete_after_max == 0 ? 100 : auto_delete_list[auto_delete_idx]->delete_after_max - 1;
					break;
				
				case 4:
					auto_delete_list[auto_delete_idx]->delete_when_disk = auto_delete_list[auto_delete_idx]->delete_when_disk == 0 ? 99 : auto_delete_list[auto_delete_idx]->delete_when_disk - 1;
					break;

			}
			drawAutoDeleteUpdateBoxLine(auto_delete_update_idx);
			copyMemoryToRecInfoViewer();
			break;

		case RKEY_Ok :
			
			switch(auto_delete_update_idx)
			{
				case 0:
					memset(keyboard_name, '\0', 100);
					strcpy(keyboard_name, auto_delete_list[auto_delete_idx]->file_name);
					cursor_pointer = strlen(keyboard_name);
					new_folder = FALSE;
					handleKeyboardKey();
					break;

				case 5:
					// save options, and return to file list
					if (write_log) if (verbose) logText("Exit auto delete update", FALSE);

					// stop the save if no name entered
					if (strlen(auto_delete_list[auto_delete_idx]->file_name) == 0)
						break;

					// stop the save if min > max
					if (auto_delete_list[auto_delete_idx]->delete_after_max > 0 
							&& auto_delete_list[auto_delete_idx]->delete_after_min > auto_delete_list[auto_delete_idx]->delete_after_max)
						break;

					saveAutoDeleteList();

					TAP_Osd_RestoreBox(region, 0, 0, 720, 576, auto_delete_save);
					TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, auto_delete_save);
					TAP_MemFree(auto_delete_save);
					auto_delete_save = NULL;
					auto_delete_update_displayed = FALSE;

					if (auto_deletes_displayed) {
						drawAutoDeleteList(FALSE);
						copyMemoryToWindow();
						drawDiskSpaceInfoBox();
					}
					break;
			}

			break;

		case RKEY_Exit :

			// discard options, and return to file list
			if (write_log) if (verbose) logText("Exit auto delete update and discard changes", FALSE);

			if (new_auto_delete) {
				rollbackAutoDeleteList();
				auto_delete_idx = saved_auto_delete_idx; auto_delete_highlight = saved_auto_delete_highlight;
			}
			else {
				restoreAutoDeleteEntry(auto_delete_idx);
			}

			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, auto_delete_save);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, auto_delete_save);
			TAP_MemFree(auto_delete_save);
			auto_delete_save = NULL;
			auto_delete_update_displayed = FALSE;
			break;

		case RKEY_ChUp :

			auto_delete_update_idx = auto_delete_update_idx == 0 ? (no_of_delete_options - 1) : auto_delete_update_idx - 1;
			auto_delete_update_highlight = auto_delete_update_idx;
			drawAutoDeleteUpdateBoxLine(auto_delete_update_idx);
			drawAutoDeleteUpdateBoxLine((auto_delete_update_idx == (no_of_delete_options - 1)) ? 0 : auto_delete_update_idx + 1);
			copyMemoryToRecInfoViewer();
			break;

		case RKEY_ChDown :

			auto_delete_update_idx = (auto_delete_update_idx + 1) % no_of_delete_options;
			auto_delete_update_highlight = auto_delete_update_idx;
			drawAutoDeleteUpdateBoxLine(auto_delete_update_idx);
			drawAutoDeleteUpdateBoxLine(auto_delete_update_idx == 0 ? no_of_delete_options - 1 : auto_delete_update_idx - 1);
			copyMemoryToRecInfoViewer();
			break;
	}

	return 0;
}

void handleExitMenu(bool permanent_exit)
{
	// save options, delete menu OSD and return to file list
	SaveConfigurationToFile();
	if (write_log)
		openLogfile();
	else
		closeLogfile();
	if (write_log) if (verbose) logText("Exit menu", FALSE);

	no_of_files = 0;
	menu_displayed = FALSE;
	saved_menu_idx = curr_idx;
	saved_menu_highlight = curr_highlight;

	ChangeDirPath(curr_dir);

	if (permanent_exit) {
		handleExitKey(TRUE, TRUE);
	}
	else {
		if (skin_editor_displayed) {
			drawSkinEditor(FALSE);
			drawMp3InfoBox();
		}
		ef (playlist_displayed) {
			no_of_files = photo_playlist_mode ? no_of_playlist_photos : no_of_playlist_mp3s;
			drawPlaylist(FALSE);
			drawMp3InfoBox();
		}
		ef (scenes_displayed) {
			drawThumbnailGrid(FALSE);
		}
		ef (auto_deletes_displayed) {
			drawAutoDeleteList(FALSE);
		}
		ef (recycle_bin_displayed) {
			no_of_files = no_of_recycles;
			qsort(recycle_bin_list, no_of_recycles, sizeof(recycle_bin_list[0]), compareRecycling);
			drawFileList(FALSE, FALSE);
		}
		else {
			populateFiles();

			if (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(FALSE, FALSE);
				drawMp3InfoBox();
			}
		}
		copyMemoryToWindow();
		drawDiskSpaceInfoBox();
		window_displayed = TRUE;
	}
}

dword handleMenuEventKey(dword param1)
{
	switch(param1)
	{
		case RKEY_Red:

			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:

			handleChangeTrack(TRUE);
			break;

		case RKEY_VolUp :
			switch(curr_idx)
			{
				case JPG_ACTIVATION_KEY:
					current_jpg_activation_key = (current_jpg_activation_key + 1) % NUMBER_OF_ACTIVATIONS;
					jpg_activation_key = activation_options[current_jpg_activation_key];
					while((jpg_activation_key != RKEY_None && (jpg_activation_key == mp3_activation_key || jpg_activation_key == rec_activation_key))
							|| (mp3_activation_key == RKEY_None && jpg_activation_key == RKEY_None && rec_activation_key == RKEY_None)) {
						current_jpg_activation_key = (current_jpg_activation_key + 1) % NUMBER_OF_ACTIVATIONS;
						jpg_activation_key = activation_options[current_jpg_activation_key];
					}
					break;

				case MP3_ACTIVATION_KEY:
					current_mp3_activation_key = (current_mp3_activation_key + 1) % NUMBER_OF_ACTIVATIONS;
					mp3_activation_key = activation_options[current_mp3_activation_key];
					while((mp3_activation_key != RKEY_None && (mp3_activation_key == jpg_activation_key || mp3_activation_key == rec_activation_key))
							|| (mp3_activation_key == RKEY_None && jpg_activation_key == RKEY_None && rec_activation_key == RKEY_None)) {
						current_mp3_activation_key = (current_mp3_activation_key + 1) % NUMBER_OF_ACTIVATIONS;
						mp3_activation_key = activation_options[current_mp3_activation_key];
					}
					break;

				case REC_ACTIVATION_KEY:
					current_rec_activation_key = (current_rec_activation_key + 1) % NUMBER_OF_ACTIVATIONS;
					rec_activation_key = activation_options[current_rec_activation_key];
					while((rec_activation_key != RKEY_None && (rec_activation_key == jpg_activation_key || rec_activation_key == mp3_activation_key))
							|| (mp3_activation_key == RKEY_None && jpg_activation_key == RKEY_None && rec_activation_key == RKEY_None)) {
						current_rec_activation_key = (current_rec_activation_key + 1) % NUMBER_OF_ACTIVATIONS;
						rec_activation_key = activation_options[current_rec_activation_key];
					}
					break;

				case PF_ACTIVATION_KEY:
					current_pf_activation_key = (current_pf_activation_key + 1) % NUMBER_OF_ACTIVATIONS;
					pf_activation_key = activation_options[current_pf_activation_key];
					break;

				case DEFAULT_SLIDESHOW_DIRECTORY:
					current_def_slideshow_folder = (current_def_slideshow_folder + 1) % default_folder_count;
					strcpy(default_slideshow_directory, default_directories[current_def_slideshow_folder]);
					if (strcmp(default_directories[current_def_slideshow_folder], "/MP3") == 0 || strcmp(default_directories[current_def_slideshow_folder], "/DataFiles") == 0) {
						current_def_slideshow_folder = (current_def_slideshow_folder + 1) % default_folder_count;
						strcpy(default_slideshow_directory, default_directories[current_def_slideshow_folder]);
					}
					break;

				case DEFAULT_STARTUP_DIRECTORY:
					current_def_startup_folder = (current_def_startup_folder + 1) % default_folder_count;
					strcpy(default_startup_directory, default_directories[current_def_startup_folder]);
					if (strcmp(default_startup_directory, "Playlist") == 0) {
						current_def_startup_folder = (current_def_startup_folder + 1) % default_folder_count;
						strcpy(default_startup_directory, default_directories[current_def_startup_folder]);
					}
					break;

				case RADIO_MODE:
					radio_mode = (radio_mode + 1) % 12;
					while (radio_mode == ALBUM_ART || radio_mode == COMPACT_ART) 
						radio_mode = (radio_mode + 1) % 12;
					break;
				
				case MP3_MODE:
					mp3_mode = (mp3_mode + 1) % 12;
					break;
				
				case RANDOMISE_PHOTOS:
					randomise_photos = randomise_photos ? FALSE : TRUE;
					break;

				case RANDOMISE_MP3S:
					randomise_mp3s = randomise_mp3s ? FALSE : TRUE;
					break;
				
				case SLIDESHOW_DELAY:
					slideshow_delay = (slideshow_delay == 120) ? 2 : (slideshow_delay + 1); // from 2 to 120
					break;

				case WIDESCREEN_ADJUSTMENT_FACTOR:
					widescreen_adjustment_factor = (widescreen_adjustment_factor + 1) % 100;
					break;
				
				case FILTER_FLICKERING:
					filter_flickering = filter_flickering ? FALSE : TRUE;
					break;

				case FADE_IMAGE:
					fade_image = fade_image ? FALSE : TRUE;
					break;
				
				case PHOTO_ASPECT_RATIO:
					photo_aspect_ratio = (photo_aspect_ratio + 1) % 4;
					break;

				case OVERNIGHT_BATCH:
					overnight_batch = (overnight_batch + 1) % 3;
					break;

				case OVERNIGHT_BATCH_TIME:
					overnight_batch_time = (overnight_batch_time + 1) % 360;

					TAP_GetTime(&mjd, &hour, &min, &sec);
					TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);

					overnight_batch_day = day;
					break;

				case DISPLAY_REC_EVENT_NAME:
					display_rec_event_name = (display_rec_event_name + 1) % 3;
					break;

				case HIGHLIGHT_OLDEST_RECORDING:
					highlight_oldest_recording = highlight_oldest_recording ? FALSE : TRUE;
					break;

				case LAST_PLAYED_ACTIVATION_KEY:
					current_last_played_activation_key = (current_last_played_activation_key + 1) % NUMBER_OF_ACTIVATIONS;
					last_played_activation_key = activation_options[current_last_played_activation_key];
					break;

				case CREATE_THUMBNAIL_KEY:
					current_create_thumbnail_key = (current_create_thumbnail_key + 1) % NUMBER_OF_ACTIVATIONS;
					create_thumbnail_key = activation_options[current_create_thumbnail_key];
					break;

				case PLAY_RESUMES_VIDEO:
					play_resumes_video = (play_resumes_video + 1) % 3;
					break;

				case LIST_PROGRESS_FORMAT:
					list_progress_format = (list_progress_format + 1) % 9;
					break;

				case FOOTER_PROGRESS_FORMAT:
					footer_progress_format = (footer_progress_format + 1) % 8;
					break;

				case FOOTER_REC_HEADER_FORMAT:
					footer_rec_header_format = (footer_rec_header_format + 1) % 8;
					break;

				case VIDEO_INFO_FORMAT:
					video_info_format = (video_info_format + 1) % 2;
					break;

				case DISPLAY_LOGOS:
					display_logos = display_logos ? FALSE : TRUE;
					line_height = display_logos ? 30 : 26;
					line_count = display_logos ? 9 : 10;
					line_gap = display_logos ? 2 : 3;
					break;

				case PRELOAD_VIDEO_HEADERS:
					preload_video_headers = (preload_video_headers + 1) % 5;
					//if (!preload_video_headers) deleteAllRecHeaders();
					break;

				case CREATE_SCENES:
					create_scenes = create_scenes ? FALSE : TRUE;
					break;

				case THUMBNAIL_SKIP:
					thumbnail_skip = (thumbnail_skip == 60) ? 1 : (thumbnail_skip + 1); // from 1 to 60
					break;

				case SCENE_SKIP:
					scene_skip = (scene_skip == 60) ? 1 : (scene_skip + 1); // from 1 to 60
					break;

				case OVERNIGHT_THUMBS:
					overnight_thumbs = (overnight_thumbs + 1) % 2;
					break;

				case OVERNIGHT_AUTO_DELETE:
					overnight_auto_delete = (overnight_auto_delete + 1) % 2;
					break;

				case OVERNIGHT_COPY:
					overnight_copy = (overnight_copy + 1) % 4;
					break;

				case DECODE_SPEED:
					decode_speed = (decode_speed + 1) % 4;
					break;

				case DECODE_CHANNEL:
					decode_channel = (decode_channel == 0) ? 30000 : (decode_channel == 30000) ? 1 : (decode_channel + 1) % 1000;
					break;

				case MP3_CHANNEL:
					mp3_channel = (mp3_channel + 1) % (no_of_tv_channels + 1);
					break;

				case OVERNIGHT_SHUTDOWN:
					overnight_shutdown = overnight_shutdown ? FALSE : TRUE;
					break;

				case GMT_OFFSET_OVERRIDE:
					gmt_offset_override = (gmt_offset_override + 1) % 12;
					break;

				case MASTERPIECE_MODE:
					masterpiece_mode = (masterpiece_mode + 1) % 2;
					recreateWindow();
					drawOptionsMenu(curr_idx, curr_highlight, TRUE);
					copyMemoryToMenu();
					drawMp3InfoBox();
					drawDiskSpaceInfoBox();
					break;

				case SKIP_TO_BOOKMARK:
					skip_to_bookmark = skip_to_bookmark ? FALSE : TRUE;
					break;

				case DISPLAY_TOPPY_ARCHIVE:
					display_toppy_archive = display_toppy_archive ? FALSE : TRUE;
					break;

				case OVERNIGHT_THUMBS_TIME:
					overnight_thumbs_time = (overnight_thumbs_time + 5) % 1440;
					break;

				case ENABLE_STOP_MENU:
					enable_stop_menu = (enable_stop_menu + 1) % 4;
					break;

				case STOP_MENU_PERCENTAGE:
					stop_menu_percentage = (stop_menu_percentage == 99) ? 0 : (stop_menu_percentage + 1); // from 0 to 99
					break;
				
				case ENABLE_RECYCLE_BIN:
					enable_recycle_bin = enable_recycle_bin ? FALSE : TRUE;
					break;

				case EMPTY_BIN_PERCENTAGE:
					empty_bin_percentage = (empty_bin_percentage + 1) % 101;
					break;

				case WATCHED_ICON_PERCENTAGE:
					watched_icon_percentage = (watched_icon_percentage + 1) % 101;
					break;

				case EMPTY_BIN_DAYS:
					empty_bin_days = (empty_bin_days + 1) % 366;
					break;

				case RECYCLE_BY_DELETION_DATE:
					recycle_by_deletion_date = recycle_by_deletion_date ? FALSE : TRUE;
					break;
				
				case RECURSE_SUBFOLDERS:
					recurse_subfolders = recurse_subfolders ? FALSE : TRUE;
					break;

				case FOLDER_PREVIEW:
					folder_preview = folder_preview ? FALSE : TRUE;
					break;

				case AUTO_RENAME_RULE:
					auto_rename_rule = (auto_rename_rule + 1) % 6;
					break;

				case DISABLE_FOLDER_COUNT:
					disable_folder_count = disable_folder_count ? FALSE : TRUE;
					break;

				case HIDE_EMPTY_FOLDERS:
					hide_empty_folders = hide_empty_folders ? FALSE : TRUE;
					break;

				case SHOW_HEADER_ICONS:
					show_header_icons = show_header_icons ? FALSE : TRUE;
					drawOptionsMenu(curr_idx, curr_highlight, FALSE);
					copyMemoryToMenu();
					break;

				case FILE_ICONS_LEFT_ALIGNED:
					file_icons_left_aligned = file_icons_left_aligned ? FALSE : TRUE;
					break;

				case DISABLE_FILE_DETAILS:
					disable_file_details = disable_file_details ? FALSE : TRUE;
					break;

				case DISABLE_THUMBNAILS:
					disable_thumbnails = disable_thumbnails ? FALSE : TRUE;
					break;

				case DISK_SPACE_FORMAT:
					disk_space_format = (disk_space_format + 1) % 8;
					drawDiskSpaceInfoBox();
					break;

				case GRADIENT_INCREMENT:
					if (!two_tone_increment) {
						gradient_increment = (gradient_increment + 1) % 11;
						createGradients(W, 30);
						drawOptionsMenu(curr_idx, curr_highlight, FALSE);
						copyMemoryToMenu();
					}
					break;

				case TWO_TONE_INCREMENT:
					if (!gradient_increment) {
						two_tone_increment = (two_tone_increment + 1) % 26;
						createTwoTones();
						drawOptionsMenu(curr_idx, curr_highlight, FALSE);
						copyMemoryToMenu();
					}
					break;

				case PAGE_WITH_ARROWS:
					page_with_arrows = page_with_arrows ? FALSE : TRUE;
					break;

				case PHOTO_ORDERING_MODE:
					photo_ordering_mode = (photo_ordering_mode + 1) % 6;
					while (photo_ordering_mode == ORDER_BY_SIZE || photo_ordering_mode == ORDER_BY_SIZE_DESC)
						photo_ordering_mode = (photo_ordering_mode + 1) % 6;
					break;

				case MUSIC_ORDERING_MODE:
					music_ordering_mode = (music_ordering_mode + 1) % 6;
					while (music_ordering_mode == ORDER_BY_SIZE || music_ordering_mode == ORDER_BY_SIZE_DESC)
						music_ordering_mode = (music_ordering_mode + 1) % 6;
					break;

				case VIDEO_ORDERING_MODE:
					video_ordering_mode = (video_ordering_mode + 1) % 6;
					break;

				case RECYCLE_ORDERING_MODE:
					recycle_ordering_mode = (recycle_ordering_mode + 1) % 6;
					while (recycle_ordering_mode == ORDER_BY_SIZE || recycle_ordering_mode == ORDER_BY_SIZE_DESC)
						recycle_ordering_mode = (recycle_ordering_mode + 1) % 6;
					break;

				case FILE_LIST_X:
					X = (X == 90) ? 8 : (X + 1); // from 8 to 90
					recreateWindow();
					drawOptionsMenu(curr_idx, curr_highlight, TRUE);
					copyMemoryToMenu();
					drawMp3InfoBox();
					drawDiskSpaceInfoBox();
					return 0;

				case FILE_LIST_Y:
					Y = (Y == 53) ? 8 : (Y + 1); // from 8 to 53
					recreateWindow();
					drawOptionsMenu(curr_idx, curr_highlight, TRUE);
					copyMemoryToMenu();
					drawMp3InfoBox();
					drawDiskSpaceInfoBox();
					return 0;

				case OFFSET_X:
					offset_x = (offset_x + 1) % 119;
					break;

				case OFFSET_Y:
					offset_y = (offset_y + 1) % 69;
					break;
				
				case THUMBNAIL_OFFSET_X:
					thumbnail_offset_x = (thumbnail_offset_x + 1) % 81;
					break;

				case THUMBNAIL_OFFSET_Y:
					thumbnail_offset_y = (thumbnail_offset_y + 1) % 51;
					break;

				case SHOW_ALL_FILES_ACTIVATION_KEY:
					show_all_files_activation_key = (show_all_files_activation_key == RKEY_Pip) ? RKEY_PipSwap : RKEY_Pip;
					break;

				case WRITE_LOG:
					write_log = write_log ? FALSE : TRUE;
					break;

				case VERBOSE:
					verbose = verbose ? FALSE : TRUE;
					break;

				case SKIN_FILE_NAME:
					current_skin = (current_skin + 1) % skin_count;
					strcpy(skin_file_name, skins[current_skin].skin_name);
					if (skins[current_skin].in_skins_folder)
						ChangeDirSkins();
					else
						ChangeDirProgramFiles();
					loadSkinElements(W, 30);
					ChangeDirMediaManager();
					//TAP_Osd_Delete(region);
					//region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
					drawOptionsMenu(curr_idx, curr_highlight, TRUE);
					copyMemoryToMenu();
					drawMp3InfoBox();
					drawDiskSpaceInfoBox();
					return 0;

				case FONT_NAME:
					current_font = (current_font + 1) % font_count;
					strcpy(font_name, fonts[current_font].font_name);
					drawOptionsMenu(curr_idx, curr_highlight, FALSE);
					copyMemoryToMenu();
					return 0;

				case SHOW_REMAINING_HOURS:
					show_remaining_hours = show_remaining_hours ? FALSE : TRUE;
					drawDiskSpaceInfoBox();
					break;

				case SHOW_LAST_PLAYED_ICON:
					show_last_played_icon = show_last_played_icon ? FALSE : TRUE;
					break;

				case FULL_SIZE_DISPLAY:
					full_size_display = full_size_display ? FALSE : TRUE;
					break;

				case FOLDERS_AT_END:
					folders_at_end = folders_at_end ? FALSE : TRUE;
					break;

				case HIDE_TOP_LEVEL_PARENT:
					hide_top_level_parent = (hide_top_level_parent + 1) % 3;
					break;

				case MEGABYTES_PER_HOUR:
					megabytes_per_hour = (megabytes_per_hour + 1) % 101;
					drawDiskSpaceInfoBox();
					break;

				case DISCARD_NAVIGATION_HISTORY:
					discard_navigation_history = discard_navigation_history ? FALSE : TRUE;
					break;

				case ENABLE_COMPONENT_SWITCHING:
					enable_component_switching = (enable_component_switching + 1) % 3;
					break;

				case TEXT_JUSTIFICATION:
					text_justification = text_justification ? FALSE : TRUE;
					drawOptionsFooter();
					copyMemoryToMenu();
					break;

				case MP3_END_MODE:
					mp3_end_mode = (mp3_end_mode + 1) % 3;
					break;

				case ORDER_BY_TRACK_NUMBER:
					order_by_track_number = order_by_track_number ? FALSE : TRUE;
					break;

				case USE_NUMBERS_TO_SEARCH:
					use_numbers_to_search = use_numbers_to_search ? FALSE : TRUE;
					break;
				
				case PRELOAD_MP3_HEADERS:
					preload_mp3_headers = (preload_mp3_headers + 1) % 5;
					mp3s_loaded = FALSE;
					break;

				case PAUSED_MODE:
					paused_mode = (paused_mode + 1) % 11;
					while (paused_mode == ALBUM_ART || paused_mode == BLANK_SCREEN || paused_mode == COMPACT || paused_mode == COMPACT_ART || paused_mode == COMPACT_TV) 
						paused_mode = (paused_mode + 1) % 11;
					break;

				case PAUSED_DELAY:
					paused_delay = (paused_delay + 1) % 601;
					break;

				case BURNOUT_DELAY:
					burnout_delay = (burnout_delay + 15) % 615;
					break;
			}
			drawOption(curr_highlight, curr_idx);
			copyMemoryToMenu();
			break;

		case RKEY_VolDown :
			switch(curr_idx)
			{
				case JPG_ACTIVATION_KEY:
					current_jpg_activation_key = current_jpg_activation_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_jpg_activation_key - 1;
					jpg_activation_key = activation_options[current_jpg_activation_key];
					while((jpg_activation_key != RKEY_None && (jpg_activation_key == mp3_activation_key || jpg_activation_key == rec_activation_key))
							|| (mp3_activation_key == RKEY_None && jpg_activation_key == RKEY_None && rec_activation_key == RKEY_None)) {
						current_jpg_activation_key = current_jpg_activation_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_jpg_activation_key - 1;
						jpg_activation_key = activation_options[current_jpg_activation_key];
					}
					break;

				case MP3_ACTIVATION_KEY:
					current_mp3_activation_key = current_mp3_activation_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_mp3_activation_key - 1;
					mp3_activation_key = activation_options[current_mp3_activation_key];
					while((mp3_activation_key != RKEY_None && (mp3_activation_key == jpg_activation_key || mp3_activation_key == rec_activation_key))
							|| (mp3_activation_key == RKEY_None && jpg_activation_key == RKEY_None && rec_activation_key == RKEY_None)) {
						current_mp3_activation_key = current_mp3_activation_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_mp3_activation_key - 1;
						mp3_activation_key = activation_options[current_mp3_activation_key];
					}
					break;

				case REC_ACTIVATION_KEY:
					current_rec_activation_key = current_rec_activation_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_rec_activation_key - 1;
					rec_activation_key = activation_options[current_rec_activation_key];
					while((rec_activation_key != RKEY_None && (rec_activation_key == jpg_activation_key || rec_activation_key == mp3_activation_key)) 
							|| (mp3_activation_key == RKEY_None && jpg_activation_key == RKEY_None && rec_activation_key == RKEY_None)) {
						current_rec_activation_key = current_rec_activation_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_rec_activation_key - 1;
						rec_activation_key = activation_options[current_rec_activation_key];
					}
					break;
				
				case PF_ACTIVATION_KEY:
					current_pf_activation_key = current_pf_activation_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_pf_activation_key - 1;
					pf_activation_key = activation_options[current_pf_activation_key];
					break;

				case DEFAULT_SLIDESHOW_DIRECTORY:
					current_def_slideshow_folder = current_def_slideshow_folder == 0 ? default_folder_count - 1 : current_def_slideshow_folder - 1;
					strcpy(default_slideshow_directory, default_directories[current_def_slideshow_folder]);
					if (strcmp(default_directories[current_def_slideshow_folder], "/MP3") == 0 || strcmp(default_directories[current_def_slideshow_folder], "/DataFiles") == 0) {
						current_def_slideshow_folder = current_def_slideshow_folder == 0 ? default_folder_count - 1 : current_def_slideshow_folder - 1;
						strcpy(default_slideshow_directory, default_directories[current_def_slideshow_folder]);
					}
					break;

				case DEFAULT_STARTUP_DIRECTORY:
					current_def_startup_folder = current_def_startup_folder == 0 ? default_folder_count - 1 : current_def_startup_folder - 1;
					strcpy(default_startup_directory, default_directories[current_def_startup_folder]);
					if (strcmp(default_directories[current_def_startup_folder], "Playlist") == 0) {
						current_def_startup_folder = current_def_startup_folder == 0 ? default_folder_count - 1 : current_def_startup_folder - 1;
						strcpy(default_startup_directory, default_directories[current_def_startup_folder]);
					}
					break;

				case RADIO_MODE:
					radio_mode = radio_mode == 0 ? 11 : radio_mode - 1;
					while (radio_mode == ALBUM_ART || radio_mode == COMPACT_ART) 
						radio_mode = radio_mode == 0 ? 11 : radio_mode - 1;
					break;

				case MP3_MODE:
					mp3_mode = mp3_mode == 0 ? 11 : mp3_mode - 1;
					break;

				case RANDOMISE_PHOTOS:
					randomise_photos = randomise_photos ? FALSE : TRUE;
					break;

				case RANDOMISE_MP3S:
					randomise_mp3s = randomise_mp3s ? FALSE : TRUE;
					break;

				case SLIDESHOW_DELAY:
					slideshow_delay = slideshow_delay == 2 ? 120 : slideshow_delay - 1; // from 2 to 120
					break;

				case WIDESCREEN_ADJUSTMENT_FACTOR:
					widescreen_adjustment_factor = widescreen_adjustment_factor == 0 ? 100 : widescreen_adjustment_factor - 1;
					break;

				case FILTER_FLICKERING:
					filter_flickering = filter_flickering ? FALSE : TRUE;
					break;

				case FADE_IMAGE:
					fade_image = fade_image ? FALSE : TRUE;
					break;

				case PHOTO_ASPECT_RATIO:
					photo_aspect_ratio = photo_aspect_ratio == 0 ? 3 : photo_aspect_ratio - 1;
					break;

				case OVERNIGHT_BATCH:
					overnight_batch = overnight_batch == 0 ? 2 : overnight_batch - 1;
					break;

				case OVERNIGHT_BATCH_TIME:
					overnight_batch_time = (overnight_batch_time == 0) ? 360 : overnight_batch_time - 1;

					TAP_GetTime(&mjd, &hour, &min, &sec);
					TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);

					overnight_batch_day = day;
					break;

				case DISPLAY_REC_EVENT_NAME:
					display_rec_event_name = display_rec_event_name == 0 ? 2 : display_rec_event_name - 1;
					break;

				case HIGHLIGHT_OLDEST_RECORDING:
					highlight_oldest_recording = highlight_oldest_recording ? FALSE : TRUE;
					break;

				case LAST_PLAYED_ACTIVATION_KEY:
					current_last_played_activation_key = current_last_played_activation_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_last_played_activation_key - 1;
					last_played_activation_key = activation_options[current_last_played_activation_key];
					break;

				case CREATE_THUMBNAIL_KEY:
					current_create_thumbnail_key = current_create_thumbnail_key == 0 ? NUMBER_OF_ACTIVATIONS-1 : current_create_thumbnail_key - 1;
					create_thumbnail_key = activation_options[current_create_thumbnail_key];
					break;

				case PLAY_RESUMES_VIDEO:
					play_resumes_video = play_resumes_video == 0 ? 2 : play_resumes_video - 1;
					break;

				case LIST_PROGRESS_FORMAT:
					list_progress_format = list_progress_format == 0 ? 8 : list_progress_format - 1;
					break;

				case FOOTER_PROGRESS_FORMAT:
					footer_progress_format = footer_progress_format == 0 ? 7 : footer_progress_format - 1;
					break;

				case FOOTER_REC_HEADER_FORMAT:
					footer_rec_header_format = footer_rec_header_format == 0 ? 7 : footer_rec_header_format - 1;
					break;

				case VIDEO_INFO_FORMAT:
					video_info_format = video_info_format == 0 ? 1 : video_info_format - 1;
					break;

				case DISPLAY_LOGOS:
					display_logos = display_logos ? FALSE : TRUE;
					line_height = display_logos ? 30 : 26;
					line_count = display_logos ? 9 : 10;
					line_gap = display_logos ? 2 : 3;
					break;

				case PRELOAD_VIDEO_HEADERS:
					preload_video_headers = preload_video_headers == 0 ? 4 : preload_video_headers - 1;
					//if (!preload_video_headers) deleteAllRecHeaders();
					break;

				case CREATE_SCENES:
					create_scenes = create_scenes ? FALSE : TRUE;
					break;

				case THUMBNAIL_SKIP:
					thumbnail_skip = (thumbnail_skip == 1) ? 60 : (thumbnail_skip - 1); // from 1 to 60
					break;

				case SCENE_SKIP:
					scene_skip = (scene_skip == 1) ? 60 : (scene_skip - 1); // from 1 to 60
					break;

				case OVERNIGHT_THUMBS:
					overnight_thumbs = overnight_thumbs == 0 ? 1 : overnight_thumbs - 1;
					break;

				case OVERNIGHT_AUTO_DELETE:
					overnight_auto_delete = overnight_auto_delete == 0 ? 1 : overnight_auto_delete - 1;
					break;

				case OVERNIGHT_COPY:
					overnight_copy = overnight_copy == 0 ? 3 : overnight_copy - 1;
					break;

				case DECODE_SPEED:
					decode_speed = decode_speed == 0 ? 3 : decode_speed - 1;
					break;

				case DECODE_CHANNEL:
					decode_channel = (decode_channel == 0) ? 999 : (decode_channel == 30000) ? 0 : (decode_channel == 1) ? 30000 : decode_channel - 1;
					break;

				case MP3_CHANNEL:
					mp3_channel = mp3_channel == 0 ? no_of_tv_channels : mp3_channel - 1;
					break;

				case OVERNIGHT_SHUTDOWN:
					overnight_shutdown = overnight_shutdown ? FALSE : TRUE;
					break;

				case GMT_OFFSET_OVERRIDE:
					gmt_offset_override = gmt_offset_override == 0 ? 11 : gmt_offset_override - 1;
					break;

				case MASTERPIECE_MODE:
					masterpiece_mode = masterpiece_mode == 0 ? 1 : masterpiece_mode - 1;
					recreateWindow();
					drawOptionsMenu(curr_idx, curr_highlight, TRUE);
					copyMemoryToMenu();
					drawMp3InfoBox();
					drawDiskSpaceInfoBox();
					break;

				case SKIP_TO_BOOKMARK:
					skip_to_bookmark = skip_to_bookmark ? FALSE : TRUE;
					break;

				case DISPLAY_TOPPY_ARCHIVE:
					display_toppy_archive = display_toppy_archive ? FALSE : TRUE;
					break;

				case OVERNIGHT_THUMBS_TIME:
					overnight_thumbs_time = (overnight_thumbs_time == 0) ? 1435 : (overnight_thumbs_time - 5);
					break;

				case ENABLE_STOP_MENU:
					enable_stop_menu = enable_stop_menu == 0 ? 3 : enable_stop_menu - 1;
					break;

				case STOP_MENU_PERCENTAGE:
					stop_menu_percentage = (stop_menu_percentage == 0) ? 99 : stop_menu_percentage - 1;
					break;

				case ENABLE_RECYCLE_BIN:
					enable_recycle_bin = enable_recycle_bin ? FALSE : TRUE;
					break;

				case EMPTY_BIN_PERCENTAGE:
					empty_bin_percentage = empty_bin_percentage == 0 ? 100 : empty_bin_percentage - 1;
					break;

				case WATCHED_ICON_PERCENTAGE:
					watched_icon_percentage = watched_icon_percentage == 0 ? 100 : watched_icon_percentage - 1;
					break;

				case EMPTY_BIN_DAYS:
					empty_bin_days = empty_bin_days == 0 ? 365 : empty_bin_days - 1;
					break;

				case RECYCLE_BY_DELETION_DATE:
					recycle_by_deletion_date = recycle_by_deletion_date ? FALSE : TRUE;
					break;

				case RECURSE_SUBFOLDERS:
					recurse_subfolders = recurse_subfolders ? FALSE : TRUE;
					break;

				case FOLDER_PREVIEW:
					folder_preview = folder_preview ? FALSE : TRUE;
					break;

				case AUTO_RENAME_RULE:
					auto_rename_rule = auto_rename_rule == 0 ? 5 : auto_rename_rule - 1;
					break;

				case DISABLE_FOLDER_COUNT:
					disable_folder_count = disable_folder_count ? FALSE : TRUE;
					break;

				case HIDE_EMPTY_FOLDERS:
					hide_empty_folders = hide_empty_folders ? FALSE : TRUE;
					break;

				case SHOW_HEADER_ICONS:
					show_header_icons = show_header_icons ? FALSE : TRUE;
					break;

				case FILE_ICONS_LEFT_ALIGNED:
					file_icons_left_aligned = file_icons_left_aligned ? FALSE : TRUE;
					break;

				case DISABLE_FILE_DETAILS:
					disable_file_details = disable_file_details ? FALSE : TRUE;
					break;

				case DISABLE_THUMBNAILS:
					disable_thumbnails = disable_thumbnails ? FALSE : TRUE;
					break;

				case DISK_SPACE_FORMAT:
					disk_space_format = disk_space_format == 0 ? 7 : disk_space_format - 1;
					drawDiskSpaceInfoBox();
					break;

				case GRADIENT_INCREMENT:
					if (!two_tone_increment) {
						gradient_increment = gradient_increment == 0 ? 10 : gradient_increment - 1;
						createGradients(W, 30);
						drawOptionsMenu(curr_idx, curr_highlight, FALSE);
						copyMemoryToMenu();
					}
					break;

				case TWO_TONE_INCREMENT:
					if (!gradient_increment) {
						two_tone_increment = two_tone_increment == 0 ? 25 : two_tone_increment - 1;
						createTwoTones();
						drawOptionsMenu(curr_idx, curr_highlight, FALSE);
						copyMemoryToMenu();
					}
					break;

				case PAGE_WITH_ARROWS:
					page_with_arrows = page_with_arrows ? FALSE : TRUE;
					break;

				case PHOTO_ORDERING_MODE:
					photo_ordering_mode = photo_ordering_mode == 0 ? 5 : photo_ordering_mode - 1;
					while (photo_ordering_mode == ORDER_BY_SIZE || photo_ordering_mode == ORDER_BY_SIZE_DESC)
						photo_ordering_mode = photo_ordering_mode == 0 ? 5 : photo_ordering_mode - 1;
					break;

				case MUSIC_ORDERING_MODE:
					music_ordering_mode = music_ordering_mode == 0 ? 5 : music_ordering_mode - 1;
					while (music_ordering_mode == ORDER_BY_SIZE || music_ordering_mode == ORDER_BY_SIZE_DESC)
						music_ordering_mode = music_ordering_mode == 0 ? 5 : music_ordering_mode - 1;
					break;

				case VIDEO_ORDERING_MODE:
					video_ordering_mode = video_ordering_mode == 0 ? 5 : video_ordering_mode - 1;
					break;

				case RECYCLE_ORDERING_MODE:
					recycle_ordering_mode = recycle_ordering_mode == 0 ? 5 : recycle_ordering_mode - 1;
					while (recycle_ordering_mode == ORDER_BY_SIZE || recycle_ordering_mode == ORDER_BY_SIZE_DESC)
						recycle_ordering_mode = recycle_ordering_mode == 0 ? 5 : recycle_ordering_mode - 1;
					break;

				case FILE_LIST_X:
					X = (X == 8) ? 90 : X - 1;
					recreateWindow();
					drawOptionsMenu(curr_idx, curr_highlight, TRUE);
					copyMemoryToMenu();
					drawMp3InfoBox();
					drawDiskSpaceInfoBox();
					return 0;

				case FILE_LIST_Y:
					Y = (Y == 8) ? 53 : Y - 1;
					recreateWindow();
					drawOptionsMenu(curr_idx, curr_highlight, TRUE);
					copyMemoryToMenu();
					drawMp3InfoBox();
					drawDiskSpaceInfoBox();
					return 0;

				case OFFSET_X:
					offset_x = offset_x == 0 ? 118 : offset_x - 1;
					break;

				case OFFSET_Y:
					offset_y = offset_y == 0 ? 68 : offset_y - 1;
					break;

				case THUMBNAIL_OFFSET_X:
					thumbnail_offset_x = thumbnail_offset_x == 0 ? 80 : thumbnail_offset_x - 1;
					break;

				case THUMBNAIL_OFFSET_Y:
					thumbnail_offset_y = thumbnail_offset_y == 0 ? 50 : thumbnail_offset_y - 1;
					break;
				
				case SHOW_ALL_FILES_ACTIVATION_KEY:
					show_all_files_activation_key = (show_all_files_activation_key == RKEY_Pip) ? RKEY_PipSwap : RKEY_Pip;
					break;

				case WRITE_LOG:
					write_log = write_log ? FALSE : TRUE;
					break;

				case VERBOSE:
					verbose = verbose ? FALSE : TRUE;
					break;

				case SKIN_FILE_NAME:
					current_skin = current_skin == 0 ? skin_count - 1 : current_skin - 1;
					strcpy(skin_file_name, skins[current_skin].skin_name);
					if (skins[current_skin].in_skins_folder)
						ChangeDirSkins();
					else
						ChangeDirProgramFiles();
					loadSkinElements(W, 30);
					ChangeDirMediaManager();
					//TAP_Osd_Delete(region);
					//region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
					drawOptionsMenu(curr_idx, curr_highlight, TRUE);
					copyMemoryToMenu();
					drawMp3InfoBox();
					drawDiskSpaceInfoBox();
					return 0;

				case FONT_NAME:
					current_font = current_font == 0 ? font_count - 1 : current_font - 1;
					strcpy(font_name, fonts[current_font].font_name);
					drawOptionsMenu(curr_idx, curr_highlight, FALSE);
					copyMemoryToMenu();
					return 0;

				case SHOW_REMAINING_HOURS:
					show_remaining_hours = show_remaining_hours ? FALSE : TRUE;
					drawDiskSpaceInfoBox();
					break;

				case SHOW_LAST_PLAYED_ICON:
					show_last_played_icon = show_last_played_icon ? FALSE : TRUE;
					break;

				case FULL_SIZE_DISPLAY:
					full_size_display = full_size_display ? FALSE : TRUE;
					break;

				case FOLDERS_AT_END:
					folders_at_end = folders_at_end ? FALSE : TRUE;
					break;

				case HIDE_TOP_LEVEL_PARENT:
					hide_top_level_parent = hide_top_level_parent == 0 ? 2 : hide_top_level_parent - 1;
					break;

				case MEGABYTES_PER_HOUR:
					megabytes_per_hour = megabytes_per_hour == 0 ? 100 : megabytes_per_hour - 1;
					drawDiskSpaceInfoBox();
					break;

				case DISCARD_NAVIGATION_HISTORY:
					discard_navigation_history = discard_navigation_history ? FALSE : TRUE;
					break;

				case ENABLE_COMPONENT_SWITCHING:
					enable_component_switching = enable_component_switching == 0 ? 2 : enable_component_switching - 1;
					break;

				case TEXT_JUSTIFICATION:
					text_justification = text_justification ? FALSE : TRUE;
					drawOptionsFooter();
					copyMemoryToMenu();
					break;
				
				case MP3_END_MODE:
					mp3_end_mode = mp3_end_mode == 0 ? 2 : mp3_end_mode - 1;
					break;

				case ORDER_BY_TRACK_NUMBER:
					order_by_track_number = order_by_track_number ? FALSE : TRUE;
					break;

				case USE_NUMBERS_TO_SEARCH:
					use_numbers_to_search = use_numbers_to_search ? FALSE : TRUE;
					break;

				case PRELOAD_MP3_HEADERS:
					preload_mp3_headers = preload_mp3_headers == 0 ? 4 : preload_mp3_headers - 1;
					mp3s_loaded = FALSE;
					break;

				case PAUSED_MODE:
					paused_mode = paused_mode == 0 ? 11 : paused_mode - 1;
					while (paused_mode == ALBUM_ART || paused_mode == BLANK_SCREEN || paused_mode == COMPACT || paused_mode == COMPACT_ART || paused_mode == COMPACT_TV) 
						paused_mode = paused_mode == 0 ? 11 : paused_mode - 1;
					break;

				case PAUSED_DELAY:
					paused_delay = paused_delay == 0 ? 600 : paused_delay - 1;
					break;

				case BURNOUT_DELAY:
					burnout_delay = burnout_delay == 0 ? 600 : burnout_delay - 15;
					break;
			}
			drawOption(curr_highlight, curr_idx);
			copyMemoryToMenu();
			break;

		case RKEY_ChUp :

			shuffleUpFileList(MENU_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			if (options[curr_idx].divider)
				shuffleUpFileList(MENU_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(MENU_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			if (options[curr_idx].divider)
				shuffleDownFileList(MENU_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_Rewind :

			pageBackFileList(MENU_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_Forward :

			pageForwardFileList(MENU_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_Recall :

			// tidy hard disk
			if (curr_idx == TIDY_HARD_DISK)
				handleTidy();
			break;

		case RKEY_Ok :

			// run video job
			if (curr_idx == RUN_VIDEO_JOB) {
			    manual_batch_job = TRUE;
				handleExitMenu(TRUE);
				handleVideoBatchJob(FALSE);
				break;
			}

			// reload mp3 headers
			if (curr_idx == RELOAD_MP3_HEADERS) {
				deleteAllMp3Headers();
				processing_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);
				loadMp3Headers(TRUE, FALSE, FALSE);
				TAP_Osd_RestoreBox(region, 0, 0, 720, 576, processing_save);
				TAP_MemFree(processing_save);
				processing_save = NULL;
				ChangeDirMediaManager();
				break;
			}

			// reload skins
			if (curr_idx == RELOAD_SKINS) {
				loadSkins();
				ChangeDirMediaManager();
				break;
			}

			// exit TAP
			if (curr_idx == EXIT_TAP) {
				int i;

				TAP_Osd_Delete(region);
				TAP_Osd_Delete(region_mem);
				TAP_EnterNormal();
			
				exitTap();
			}

			break;

		case RKEY_Exit :
		case RKEY_Menu :

			handleExitMenu(FALSE);
			break;
	}

	return 0;
}

// takes a passed in mode (albumart, screensaver1, screensaver2 etc), and whether this is a switch from another mode
void startExternalMode(dword mode, bool switching, bool radio)
{
	region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
	region_mem = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_MemRgn);

	if (!switching && (mode != COMPACT && mode != COMPACT_TV && mode != BLANK_SCREEN)) {
		if (strcmp(default_slideshow_directory, "Playlist") == 0) {
			movePlaylistToStructure(TRUE);
		}
		else {
			ChangeDirPath(default_slideshow_directory);

			if (radio_mode == SLIDESHOW)
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Start radio slideshow in %s", default_slideshow_directory);
			else
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Start radio screensaver in %s", default_slideshow_directory);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			populateJPEGs(TRUE, TRUE);
		}
	}

	TAP_Osd_Delete(region);
	TAP_Osd_Delete(region_mem);

	if (no_of_jpegs == 0 && (mode != COMPACT && mode != COMPACT_TV && mode != BLANK_SCREEN))
		return;

	TAP_ExitNormal();

	force_display = FALSE;
	window_displayed = FALSE;
	slideshow_paused = FALSE;

	if (mode == SLIDESHOW) {
		current_jpeg = 0;
		if (randomise_photos)
			current_jpeg = getNextJpeg(TRUE);
		startSlideshow();
	}
	ef (mode == BLANK_SCREEN) {
		startBlankScreen(FALSE);
	}
	ef (mode == COMPACT || mode == COMPACT_TV) {
		startCompactMode(FALSE);
	}
	else {
		startScreensaver(switching);
	}

	if (slideshow_started || screensaver_started || blank_screen_started || compact_mode_started) {
		external_slideshow = TRUE;
		if (radio) radio_slideshow = TRUE; 
		else paused_slideshow = TRUE;
		photo_mode = mode;
	}
}

bool findMp3SlideshowFolder()
{
	TYPE_File *folder_file;

	strcpy(from_dir, default_slideshow_directory);

	ChangeDirPath(mp3_files[current_mp3]->directory);
	ChangeDir("Cache");
	strcpy(file_name, mp3_files[current_mp3]->file_name);
	strcat(file_name, ".folder.ass");
	if (TAP_Hdd_Exist(file_name)) {
		folder_file = TAP_Hdd_Fopen(file_name);
		if (folder_file) {
			TAP_Hdd_Fread(from_dir, sizeof(char), 256, folder_file);
			TAP_Hdd_Fclose(folder_file);
		}
	}
	else {
		strcpy(file_name, "album.folder.ass");
		if (TAP_Hdd_Exist(file_name)) {
			folder_file = TAP_Hdd_Fopen(file_name);
			if (folder_file) {
				TAP_Hdd_Fread(from_dir, sizeof(char), 256, folder_file);
				TAP_Hdd_Fclose(folder_file);
			}
		}
	}

	if (strcmp(from_dir, from_dir_saved) != 0) {
		strcpy(from_dir_saved, from_dir);
		return TRUE;
	}

	return FALSE;
}

void startMp3Slideshow(bool first_mp3)
{
	bool new_folder = first_mp3 ? TRUE : findMp3SlideshowFolder();

	if (new_folder) {
		
		if (write_log) TAP_SPrint(log_buffer, "Start slideshow in new folder %s", from_dir_saved);
		if (write_log) logText(log_buffer, FALSE);
		if (!first_mp3) {
			if (slideshow_started)
				endSlideshow(TRUE);

			if (strcmp(from_dir_saved, "Playlist") == 0)
				movePlaylistToStructure(TRUE);
			else {
				ChangeDirPath(from_dir_saved);
				populateJPEGs(TRUE, FALSE);
			}
		}

		if (first_mp3) 
			startSlideshow();
		else {
			current_jpeg = 0;
			if (randomise_photos)
				current_jpeg = getNextJpeg(TRUE);
			slideshow_started = TRUE;
			previous_jpeg = current_jpeg; 
			
			// flag to recreate plane 2 if fading
			if (apply_fade_image) recreate_plane2 = TRUE;
		}
		mp3_slideshow = TRUE;
	}
}

// takes a passed in mode (albumart, screensaver1, screensaver2 etc), and whether this is a switch from another mode
void startMP3Mode(dword mode, bool switching)
{
	if (!mp3_mode)
		return;

	if (write_log) if (verbose) logText("Start MP3 Mode", FALSE);
	logMemory("At start of MP3 mode", FALSE);

	// only populate the jpeg structure if not switching and not album art
	if (!switching && (mode != ALBUM_ART && mode != COMPACT && mode != COMPACT_ART && mode != COMPACT_TV && mode != BLANK_SCREEN)) {
		if (mode == SLIDESHOW)
			findMp3SlideshowFolder();
		else
			strcpy(from_dir_saved, default_slideshow_directory);
		
		if (strcmp(from_dir_saved, "Playlist") == 0) {
			movePlaylistToStructure(TRUE);
		}
		else {
			ChangeDirPath(from_dir_saved);
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Start MP3 screensaver in %s", from_dir_saved);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			populateJPEGs(TRUE, TRUE);
			logMemory("After populating JPEGs", FALSE);
		}
	}

	if (mode != ALBUM_ART && mode != COMPACT && mode != COMPACT_ART && mode != COMPACT_TV && mode != BLANK_SCREEN && no_of_jpegs == 0)
		return;

	TAP_ExitNormal();
	
	TAP_Osd_Delete(region);
	TAP_Osd_Delete(region_mem);

	mp3_progress_offset = 0;
	force_display = FALSE;
	window_displayed = FALSE;
	slideshow_paused = FALSE;

	if (mode == SLIDESHOW)
		startMp3Slideshow(TRUE);
	ef (mode == ALBUM_ART)
		startAlbumArt();
	ef (mode == COMPACT || mode == COMPACT_ART || mode == COMPACT_TV)
		startCompactMode(TRUE);
	ef (mode == BLANK_SCREEN)
		startBlankScreen(TRUE);
	else
		startScreensaver(switching);

	photo_mode = mode;
}

void handleEnterPinNumber()
{
#ifndef WIN32
	word pin;

	memset(toppy_pin, '\0', 5);
	//DeterminePIN(toppy_pin, eeprom_offset);
	pin = GetEEPROMPin();
	TAP_SPrint (toppy_pin, "%4.4d", pin);

	if (write_log) TAP_SPrint(log_buffer, "Toppy PIN is %s", toppy_pin);
	if (write_log) logText(log_buffer, FALSE);
#endif
	memset(entered_pin, '\0', 5);
	pin_counter = 0;
	drawPinBox();
	pin_box_displayed = TRUE;
	window_displayed = FALSE;
}

bool handleDeleteCachedPhoto(void)
{
	if (isPhoto(dir_info[curr_idx]->file_name)) 
	{
		if (TAP_Hdd_Exist("Cache")) 
		{
			// change to cache dir
			ChangeDir("Cache");

			// delete cache and thumbnail files
			strcpy(file_name, dir_info[curr_idx]->file_name);
			strcat(file_name, ".cache");
			TAP_Hdd_Delete(file_name);
			strcpy(file_name, dir_info[curr_idx]->file_name);
			strcat(file_name, ".tn");
			TAP_Hdd_Delete(file_name);

			// return to starting dir
			ChangeDir("..");

			// display info message
			TAP_SPrint(buffer, "%s %s '%s'", deleted_cache_t, for_t, dir_info[curr_idx]->file_name);
			drawInfoBox(deleted_cache_t, buffer, NULL, TRUE, TRUE);
			info_box_displayed = TRUE;
			window_displayed = FALSE;
			return TRUE;
		}
	}

	return FALSE;
}

bool handleDeleteAllCachedPhotos(void)
{
	if (!InMp3FilesFolder(curr_dir)) 
	{
		if (TAP_Hdd_Exist("Cache")) 
		{
			// delete and recreate cache dir
			TAP_Hdd_Delete("Cache");
			TAP_Hdd_Create("Cache", ATTR_FOLDER);

			// display info message
			ExtractLastField(curr_dir, buffer2);
			TAP_SPrint(buffer, "%s %s '%s'", deleted_cache_t, for_folder_t, buffer2+1);
			drawInfoBox(deleted_cache_t, buffer, NULL, TRUE, TRUE);
			info_box_displayed = TRUE;
			window_displayed = FALSE;
			return TRUE;
		}
	}

	return FALSE;
}

bool handleDeleteRecordingThumbnail(void)
{
	if (no_of_files == 0)
		return FALSE;

	if (isRec(dir_info[curr_idx]->file_name)) 
	{
		if (TAP_Hdd_Exist("Cache")) 
		{
			TYPE_Header *preloaded_header;
			TYPE_File *first_scene = NULL;
			int no_of_scenes = 0, i;

			// change to cache dir
			ChangeDir("Cache");

			// delete thumbnail file
			strcpy(file_name, dir_info[curr_idx]->file_name);
			strcat(file_name, ".tn");
			TAP_Hdd_Delete(file_name);

			// delete any scenes
			TAP_SPrint(file_name, "%s.tn.1", dir_info[curr_idx]->file_name);
			first_scene = TAP_Hdd_Fopen(file_name);
			if (first_scene != NULL) {
				TAP_Hdd_Fread(&no_of_scenes, sizeof(int), 1, first_scene);
				TAP_Hdd_Fclose(first_scene);
			}
			for (i = 1; i <= no_of_scenes; i++) {
				TAP_SPrint(file_name, "%s.tn.%d", dir_info[curr_idx]->file_name, i);
				TAP_Hdd_Delete(file_name);
			}

			// return to starting dir
			ChangeDir("..");

			// delete the thumbnail data from header
			if (preload_video_headers == HEADERS_AND_THUMBNAILS || preload_video_headers == HEADERS_AND_THUMBNAILS_LAZY) {
				preloaded_header = getRecHeader(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster);
				if (preloaded_header && preloaded_header->thumbnail) {
					dlfree(preloaded_header->thumbnail);
					preloaded_header->thumbnail = NULL;
					dlmalloc_trim(0);
				}
			}

			// display info message
			TAP_SPrint(buffer, "%s '%s'", deleted_thumbs_scenes_for_t, dir_info[curr_idx]->file_name);
			drawInfoBox(deleted_t, buffer, NULL, TRUE, TRUE);
			info_box_displayed = TRUE;
			window_displayed = FALSE;
			return TRUE;
		}
	}

	return FALSE;
}

bool handleDeleteAllRecordingThumbnails(void)
{
	if (InDataFilesFolder(curr_dir)) 
	{
		if (TAP_Hdd_Exist("Cache")) 
		{
			TYPE_Header *preloaded_header;
			word i;

			// delete and recreate cache dir
			TAP_Hdd_Delete("Cache");
			TAP_Hdd_Create("Cache", ATTR_FOLDER);

			// delete the thumbnail data from headers
			if (preload_video_headers == HEADERS_AND_THUMBNAILS || preload_video_headers == HEADERS_AND_THUMBNAILS_LAZY) {
				for (i = 0; i < no_of_files; i++) {
					preloaded_header = getRecHeader(dir_info[i]->file_name, dir_info[i]->start_cluster);
					if (preloaded_header && preloaded_header->thumbnail) {
						dlfree(preloaded_header->thumbnail);
						preloaded_header->thumbnail = NULL;
						dlmalloc_trim(0);
					}
				}
			}

			// display info message
			ExtractLastField(curr_dir, buffer2);
			TAP_SPrint(buffer, "%s %s '%s'", deleted_thumbs_scenes_for_t, folder_lower_t, buffer2+1);
			drawInfoBox(deleted_t, buffer, NULL, TRUE, TRUE);
			info_box_displayed = TRUE;
			window_displayed = FALSE;
			return TRUE;
		}
	}

	return FALSE;
}

void handleChangeDirKey()
{
	if (no_of_files == 0)
		return;

	if (!isParentDirectory(dir_info[curr_idx]->file_name) && ChangeDir(dir_info[curr_idx]->file_name))
	{
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Change directory to %s", dir_info[curr_idx]->file_name);
		if (write_log) if (verbose) logText(log_buffer, FALSE);

		if (!multi_play_started && no_of_marked_recordings > 0)
			clearMarkedRecordings();

		strcpy(curr_dir, tracked_dir);

		saveNavHistory(curr_idx, curr_highlight, FALSE);
		populateFiles();
		
		if (InDataFilesFolder(curr_dir)) {

			// if we are going to a rec dir, highlight appropriate recording
			resetVideoHistory();

			if (thumbnail_mode)	{
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(FALSE, FALSE);
				drawMp3InfoBox();
			}
		}
		else {
			// otherwise proceed as normal
			saveNavHistory(0, 0, FALSE);
			if (thumbnail_mode)	{
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(FALSE, FALSE);  
				drawMp3InfoBox();
			}
		}

		copyMemoryToWindow();
		drawDiskSpaceInfoBox();
	}
}

void handleReturnToParentKey()
{
	if (strcmp(curr_dir, "/") != 0)
	{
		if (write_log) if (verbose) logText("Change to parent directory", FALSE);

		if (!multi_play_started && no_of_marked_recordings > 0)
			clearMarkedRecordings();

		ChangeDir("..");

		strcpy(curr_dir, tracked_dir);

		populateFiles();

		if (thumbnail_mode) {
			drawThumbnailGrid(FALSE);
		}
		else {
			drawFileList(FALSE, FALSE);
			drawMp3InfoBox();
		}

		copyMemoryToWindow();
		drawDiskSpaceInfoBox();
	}
}

bool appendToName(dword rename_rule, char *name, char *extension, char *from_dir, char *to_dir, word file_mjd, word file_hour, word file_min)
{
	int i;
	bool renamed = FALSE;
	
	switch (rename_rule) {

		// rename by number if file already exists
		case RENAME_BY_NUMBER:
			if (strcmp(from_dir, to_dir) != 0) ChangeDirPath(to_dir);

			// first check whether the same named file exists
			if (strlen(extension) > 0)
				TAP_SPrint(file_name, "%s%s", name, extension);
			else
				strcpy(file_name, name);
			if (TAP_Hdd_Exist(file_name)) {
				// check for matching number extensions one at a time
				for (i = 2; i < 64; i++) {
					if (strlen(extension) > 0)
						TAP_SPrint(file_name, "%s-%d%s", name, i, extension);
					else
						TAP_SPrint(file_name, "%s-%d", name, i);
					if (!TAP_Hdd_Exist(file_name)) {
						// append number to move name
						memset(name, '\0', 100);
						if (strlen(extension) > 0)
							strncat(name, file_name, strlen(file_name)-strlen(extension));
						else
							strcpy(name, file_name);
						renamed = TRUE;
						break;
					}
				}
			}

			if (strcmp(from_dir, to_dir) != 0) ChangeDirPath(from_dir);
			break;

		// rename by date if file already exists
		case RENAME_BY_DATE:

			if (hasDateStamp(name))
				break;

			if (strcmp(from_dir, to_dir) != 0) ChangeDirPath(to_dir);
			
			// first check whether the same named file exists
			if (strlen(extension) > 0)
				TAP_SPrint(file_name, "%s%s", name, extension);
			else
				strcpy(file_name, name);
			if (TAP_Hdd_Exist(file_name)) {
				if (file_mjd > 0)
					mjd = file_mjd;
				else
					TAP_GetTime(&mjd, &hour, &min, &sec);
				TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
				TAP_SPrint(file_name, "%s %02d-%02d-%04d", name, day, month, year);
				strcpy(name, file_name);
				renamed = TRUE;
			}

			if (strcmp(from_dir, to_dir) != 0) ChangeDirPath(from_dir);
			break;

		// rename by date unless already date stamped
		case RENAME_BY_DATE_ALWAYS:

			if (hasDateStamp(name))
				break;

			if (file_mjd > 0)
				mjd = file_mjd;
			else
				TAP_GetTime(&mjd, &hour, &min, &sec);
			TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
			TAP_SPrint(file_name, "%s %02d-%02d-%04d", name, day, month, year);
			strcpy(name, file_name);
			renamed = TRUE;
			break;

		// rename by date and time if file already exists
		case RENAME_BY_DATE_AND_TIME:

			if (hasDateStamp(name))
				break;

			if (strcmp(from_dir, to_dir) != 0) ChangeDirPath(to_dir);
			
			// first check whether the same named file exists
			if (strlen(extension) > 0)
				TAP_SPrint(file_name, "%s%s", name, extension);
			else
				strcpy(file_name, name);
			if (TAP_Hdd_Exist(file_name)) {
				if (file_mjd > 0) {
					mjd = file_mjd; hour = file_hour; min = file_min;
				}
				else
					TAP_GetTime(&mjd, &hour, &min, &sec);
				TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
				TAP_SPrint(file_name, "%s %02d-%02d-%04d %02d%02d", name, day, month, year, hour, min);
				strcpy(name, file_name);
				renamed = TRUE;
			}

			if (strcmp(from_dir, to_dir) != 0) ChangeDirPath(from_dir);
			break;

		// rename by date and time unless already date stamped
		case RENAME_BY_DATE_AND_TIME_ALWAYS:

			if (hasDateStamp(name))
				break;

			if (file_mjd > 0) {
				mjd = file_mjd; hour = file_hour; min = file_min;
			}
			else
				TAP_GetTime(&mjd, &hour, &min, &sec);
			TAP_ExtractMjd(mjd, &year, &month, &day, &week_day);
			TAP_SPrint(file_name, "%s %02d-%02d-%04d %02d%02d", name, day, month, year, hour, min);
			strcpy(name, file_name);
			renamed = TRUE;
			break;
	}

	return renamed;
}

void doSingleMove(char *name, bool folder, word mjd, word hour, word min, bool save_box)
{
	if (folder) {
		TAP_SPrint(buffer, "%s '%s'", moving_folder_t, name);
		TAP_SPrint(buffer2, "%s '%s'", to_folder_t, to_dir);
		drawInfoBox(moving_folder_t, buffer, buffer2, FALSE, FALSE);
	}
	else {
		TAP_SPrint(buffer, "%s '%s'", moving_file_t, name);
		TAP_SPrint(buffer2, "%s '%s'", to_folder_t, to_dir);
		drawInfoBox(moving_file_t, buffer, buffer2, FALSE, save_box);
	}

	if (folder) {
		// append a numerical stamp if necessary
		strcpy(buffer, name);
		appendToName(RENAME_BY_NUMBER, buffer, "", from_dir, to_dir, 0, 0, 0);

		strcpy(from_dir_saved, from_dir); strcpy(to_dir_saved, to_dir); 
		strcat(from_dir_saved, "/"); strcat(from_dir_saved, name);
		strcat(to_dir_saved, "/"); strcat(to_dir_saved, buffer);

		// do the file copies (but do not delete the old dir just yet)
		ChangeDir(name);
		doMoveFolder(buffer);

		// if all files moved successfully, then now safe to delete the old dir
		ChangeDirPath(curr_dir);
		if (move_successful) 
			TAP_Hdd_Delete(name);
	}
	else {
		strcpy(move_file_name, name);
		doMove(mjd, hour, min);
	}
}

void handleMove()
{
	// default to false, in case of validation failure
	move_successful = FALSE;

	// construct the 'to' dir, by appending the new folder, or chopping off the last folder (if parent chosen)
	ExtractLastField(move_folders[move_folder_idx], buffer);
	if (isParentDirectory(buffer+1)) {
		ExtractDirectory(move_folders[move_folder_idx], from_dir);
		ExtractDirectory(from_dir, to_dir);
	}
	else {
		strcpy(to_dir, move_folders[move_folder_idx]);
	}
	strcpy(from_dir, curr_dir);

	/*if (!moveAvailable()) {
		TAP_SPrint(buffer, "%s", "Move function unavailable");
		drawInfoBox(error_t, buffer, NULL, FALSE, TRUE);
		TAP_Delay(200);
		TAP_Osd_RestoreBox(region_mem, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
		TAP_Osd_RestoreBox(region, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
		TAP_MemFree(info_save);
		info_save = NULL;
		return;
	}*/

	// check we are not moving to the same folder
	if (strcmp(from_dir, to_dir) == 0) {
		TAP_SPrint(buffer, "%s", from_and_to_t);
		TAP_SPrint(buffer2, "%s.", are_both_same_t);
		drawInfoBox(error_t, buffer, buffer2, FALSE, TRUE);
		TAP_Delay(200);
		TAP_Osd_RestoreBox(region_mem, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
		TAP_Osd_RestoreBox(region, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
		TAP_MemFree(info_save);
		info_save = NULL;
		return;
	}

	// check we are not moving folder within itself
	if (no_of_marked_recordings == 0 && dir_info[curr_idx]->folder) {
		strcpy(temp, from_dir);
		strcat(temp, "/"); strcat(temp, dir_info[curr_idx]->file_name);
		if (strlen(to_dir) >= strlen(temp) && strncmp(temp, to_dir, strlen(temp)) == 0) {
			TAP_SPrint(buffer, "%s", attempting_to_move_folder_t);
			TAP_SPrint(buffer2, "%s.", within_itself_t);
			drawInfoBox(error_t, buffer, buffer2, FALSE, TRUE);
			TAP_Delay(200);
			TAP_Osd_RestoreBox(region_mem, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
			TAP_Osd_RestoreBox(region, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
			TAP_MemFree(info_save);
			info_save = NULL;
			return;
		}
	}
	
	// default to true, will get reset to false if any errors occur
	move_successful = TRUE;

	if (no_of_marked_recordings > 0) {
		word i;
		for (i = 0; i < no_of_marked_recordings; i++)
			doSingleMove(marked_recordings[i].file_name, FALSE, marked_recordings[i].mjd, marked_recordings[i].hour, marked_recordings[i].min, (i == 0));
	}
	else {
		doSingleMove(dir_info[curr_idx]->file_name, dir_info[curr_idx]->folder, dir_info[curr_idx]->mjd, dir_info[curr_idx]->hour, dir_info[curr_idx]->min, TRUE);
	}

	if (!move_successful) {
		TAP_SPrint(buffer, "%s,", one_or_more_moves_failed_t);
		TAP_SPrint(buffer2, "%s", please_check_your_files_t);
		drawInfoBox(warning_t, buffer, buffer2, FALSE, TRUE);
		TAP_Delay(200);
		TAP_Osd_RestoreBox(region_mem, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
		TAP_Osd_RestoreBox(region, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
		TAP_MemFree(info_save);
		info_save = NULL;
		return;
	}

	// redisplay the file list
	move_folders_displayed = FALSE;
	ChangeDirPath(curr_dir);

	if (no_of_marked_recordings == 0) {
		if (thumbnail_mode) {
			if (curr_idx == (no_of_files - 1))	{
				curr_idx--;
				curr_highlight = curr_highlight == 0 ? 2 : curr_highlight - 1;
			}
		}
		else {
			// if at end of list, then move idx up
			if (no_of_files > 1)
				adjustIndexForDelete(&curr_idx, &curr_highlight, no_of_files, (InDataFilesFolder(curr_dir) ? line_count : 10));
			saveNavHistory(curr_idx, curr_highlight, FALSE);
		}
	}
	populateFiles();
	if (no_of_marked_recordings > 0) {
		resetVideoHistory();
		clearMarkedRecordings();
	}

	if (thumbnail_mode) {
		drawBlankThumbnailGrid();
		drawThumbnails(curr_idx - curr_highlight);
		drawThumbnailGridHeader();
		drawThumbnailGridFooter();
		updateThumbnailCount();
		copyMemoryToWindow();
	}
	else {
		drawFileList(FALSE, FALSE);
		copyMemoryToWindow();
		drawMp3InfoBox();
		drawDiskSpaceInfoBox();
	}

	window_displayed = TRUE;

	TAP_MemFree(info_save);
	info_save = NULL;
}

// start a copy of this recording
void handleRecordKey()
{
	if (no_of_files == 0)
		return;

	// deal with a selection for a batch decode
	if (no_of_marked_recordings > 0) {
		confirmation_box_displayed = TRUE;
		yes_selected = FALSE;
		choose_multi_play_mode = TRUE;
		overnight_play = TRUE;
		drawConfirmationBox();
		window_displayed = FALSE;
		return;
	}

	// deal with a straight copy
	if (isValidRec(curr_idx)) {
		TYPE_PlayInfo play_info;
		TYPE_RecInfo rec_info_1, rec_info_2;

		if (multi_play_started)
			return;

		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		TAP_Hdd_GetPlayInfo(&play_info);

		// abort if this is a current recording or it is locked
		if ((IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0)
				|| (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0)
				|| dir_info[curr_idx]->locked
				|| isRadioRecording(curr_idx)) {
			return;
		}

		// abort if any type of recording
		//if ((rec_info_1.recType == RECTYPE_Normal || rec_info_1.recType == RECTYPE_Copy)
		//		|| (rec_info_2.recType == RECTYPE_Normal || rec_info_2.recType == RECTYPE_Copy))
		//	return;

		if (decode_channel)
			TAP_Channel_Start(1, SVC_TYPE_Tv, decode_channel == 30000 ? dir_info[curr_idx]->service_num : decode_channel - 1);

		// exit the display and play from the start
		TAP_Hdd_PlayTs(dir_info[curr_idx]->file_name);
		handleExitKey(TRUE, TRUE);
		TAP_Hdd_GetPlayInfo(&play_info);
		
		if (play_info.playMode == PLAYMODE_Playing && play_info.file) {

			TAP_Hdd_ChangePlaybackPos(0);

			// if there was already a playback in progress, then update the details with the new playback
			handlePlaybackWhenExistingPlayback(play_info);

			copy_recording = TRUE;
			copy_successful = FALSE;
			copy_step = 0;
			copy_delay = 400;
			copy_tick = TAP_GetTick();
		}
	}
}

void handleOkKey(void)
{
	TYPE_PlayInfo play_info;

	if (no_of_files == 0)
		return;

	if (!multi_play_started && InDataFilesFolder(curr_dir) && no_of_marked_recordings > 1) {
		if (selectionContainsEncodedVideos()) {
			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			choose_multi_play_mode = TRUE;
			overnight_play = FALSE;
			drawConfirmationBox();
			window_displayed = FALSE;
		}
		else {
			multi_play_batch_mode = MULTI_PLAY;
			multi_play_started = TRUE;
			TAP_Hdd_PlayTs(marked_recordings[0].file_name);
			TAP_Delay(50);
			TAP_Hdd_ChangePlaybackPos(0);

			// if there was already a playback in progress, then update the details with the new playback
			TAP_Hdd_GetPlayInfo(&play_info);
			handlePlaybackWhenExistingPlayback(play_info);
			handleExitKey(TRUE, TRUE);
		}
	}
	ef (dir_info[curr_idx]->folder) {
		if (isParentDirectory(dir_info[curr_idx]->file_name)) {
			handleReturnToParentKey();
		}
		else {
			handleChangeDirKey();
		}
	}
	ef (isSkin(dir_info[curr_idx]->file_name))	{
		handleSkinEditorKey();
	}
	ef (isLog(dir_info[curr_idx]->file_name))	{
		closeLogfile();
		log_file = TAP_Hdd_Fopen(dir_info[curr_idx]->file_name);
		if (log_file == NULL) 
			return;	

		log_size = TAP_Hdd_Flen(log_file);
		//if ((log_size > 0) && (log_size % 512) == 0) {
		//	log_size = log_size + 512;
		//}
	
		log_data = dlmalloc(log_size);
		if (!log_data) {
			TAP_Hdd_Fclose(log_file);
			return;
		}

		TAP_Hdd_Fread(log_data, log_size, 1, log_file);
		TAP_Hdd_Fclose(log_file);

		if (write_log) if (verbose) logText("Displaying log viewer", FALSE);
		mp3_progress_offset = 0;
		if (thumbnail_mode)
			recreateWindow();
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		page_number = 0;
		drawLogViewer(TRUE);
		log_displayed = TRUE;
		window_displayed = FALSE;
	}
	ef (isMp3(dir_info[curr_idx]->file_name)) {

		word i;

		if (write_log) if (verbose) logText("Playing MP3", FALSE);
		if (mp3_playing) 
			handleStopMp3(TRUE, TRUE);
		populateMP3s(FALSE, TRUE);
				
		//current_mp3 = curr_idx - (no_of_files - no_of_mp3s);
		for (i = 0; i < no_of_mp3s; i++) {
			if (strcmp(mp3_files[i]->file_name, dir_info[curr_idx]->file_name) == 0) {
				current_mp3 = i;
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play MP3 %d %s", current_mp3, dir_info[curr_idx]->file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				break;
			}
		}

		mp3_playlist_playing = FALSE;
		mp3s_in_current_folder = TRUE;
		saveHistory(FALSE, current_mp3);
		saveFolderHistory(curr_dir);

		saveNavHistory(curr_idx, curr_highlight, FALSE);
		handleKickoffMp3Mode();
		single_mp3_mode = TRUE;
	}
	ef (scenes_displayed) {
		int skip_position;

		if (scenes_are_locked) {
			pin_play_type = PLAY_FROM_SCENE;
			handleEnterPinNumber();
			return;
		}

		extractRecordingName(dir_info[curr_idx]->file_name, file_name);
		TAP_Hdd_PlayTs(file_name);

		// if there was already a playback in progress, then update the details with the new playback
		TAP_Hdd_GetPlayInfo(&play_info);
		handlePlaybackWhenExistingPlayback(play_info);

		saveExtendedInfo();
		skip_position = getCurrentBlockFromScene(dir_info[curr_idx]->file_name);
		if (play_info.playMode == PLAYMODE_Playing && skip_position > play_info.totalBlock) skip_position = 0;
		TAP_Hdd_ChangePlaybackPos(skip_position);
		handleExitKey(TRUE, TRUE);
		scenes_displayed = FALSE;
	}
	ef (isRec(dir_info[curr_idx]->file_name)) {
		TYPE_RecInfo rec_info_1, rec_info_2;
		int current_block, total_block;

		if (multi_play_started)
			return;

		// attempt to fix a duff recording
		if (!isValidRec(curr_idx))
			if (!fixRecording())
				return;

		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);

		if (IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0) {
			TAP_Channel_Start(1, rec_info_1.svcType, rec_info_1.svcNum);

			// if there was already a playback in progress, then update the details with the new playback
			TAP_Hdd_GetPlayInfo(&play_info);
			handlePlaybackWhenExistingPlayback(play_info);

			saveExtendedInfo();
			current_block = getCurrentBlock(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster);
			if (isRadioRecording(curr_idx))
				TAP_Delay(50);
			if (current_block > 0)
				TAP_Hdd_ChangePlaybackPos(current_block > 50 ? current_block - 50 : current_block);
			else
				gotoAccurateBookmark(0);
		}
		ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0) {
			TAP_Channel_Start(1, rec_info_2.svcType, rec_info_2.svcNum);

			// if there was already a playback in progress, then update the details with the new playback
			TAP_Hdd_GetPlayInfo(&play_info);
			handlePlaybackWhenExistingPlayback(play_info);

			saveExtendedInfo();
			current_block = getCurrentBlock(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster);
			if (isRadioRecording(curr_idx))
				TAP_Delay(50);
			if (current_block > 0)
				TAP_Hdd_ChangePlaybackPos(current_block > 50 ? current_block - 50 : current_block);
			else
				gotoAccurateBookmark(1);
		}
		else {
			if (dir_info[curr_idx]->locked) {
				pin_play_type = PLAY_FROM_LAST_WATCHED;
				handleEnterPinNumber();
				return;
			}

			TAP_Hdd_PlayTs(dir_info[curr_idx]->file_name);
			TAP_Hdd_GetPlayInfo(&play_info);
			if (play_info.playMode == PLAYMODE_Playing && play_info.file) {
				
				// if there was already a playback in progress, then update the details with the new playback
				handlePlaybackWhenExistingPlayback(play_info);

				saveExtendedInfo();
				current_block = getCurrentBlockFromFile(play_info.file);
				total_block = getTotalBlockFromFile(play_info.file);
				if (isRadioRecording(curr_idx)) {
					// deduct a minute due to firmware bug, and then delay, also due to firmware bug
					word blocks_in_a_minute = play_info.totalBlock / play_info.duration;
					current_block = (current_block - blocks_in_a_minute < 0) ? 0 : (current_block - blocks_in_a_minute);
					TAP_Delay(50);
					TAP_Hdd_ChangePlaybackPos(current_block);
				}
				else {
					if (current_block >= total_block) current_block = 0;
					
					if (current_block > 50)
						TAP_Hdd_ChangePlaybackPos(current_block);
					else
						gotoAccurateBookmark(2);
				}
			}
		}

		handleExitKey(TRUE, TRUE);
	}
	ef (isPhoto(dir_info[curr_idx]->file_name)) {
		int i;

		// otherwise a file was chosen, so attempt to display photo
		if (write_log) if (verbose) TAP_SPrint(log_buffer, "Picked file %s", dir_info[curr_idx]->file_name);
		if (write_log) if (verbose) logText(log_buffer, FALSE);
		TAP_Osd_Delete(region);
		TAP_Osd_Delete(region_mem);
		mp3_progress_offset = 0;
		window_displayed = FALSE;
		populateJPEGs(FALSE, TRUE);

		for (i = 0; i < no_of_jpegs; i++) {
			if (strcmp(jpeg_files[i]->file_name, dir_info[curr_idx]->file_name) == 0) {
				current_jpeg = i;
				break;
			}
		}
	
		if (randomise_photos) saveHistory(TRUE, current_jpeg);
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		slideshow_paused = TRUE;
		force_display = TRUE;
		startSlideshow(); 
	}
	ef (isTAP(dir_info[curr_idx]->file_name)) {
		int tap_id;

#ifndef WIN32
		TAP_Osd_Delete(region);
		TAP_Osd_Delete(region_mem);

		//tap_id = HDD_TAP_GetIDByFileName(dir_info[curr_idx]->file_name);

		//if (HDD_TAP_isRunning(tap_id)) {
		//	if (write_log) TAP_SPrint(log_buffer, "Stop TAP %s", dir_info[curr_idx]->file_name);
		//	if (write_log) logText(log_buffer, FALSE);
		//	HDD_TAP_Terminate(tap_id);
		//}
		//else {
			if (write_log) TAP_SPrint(log_buffer, "Load TAP %s", dir_info[curr_idx]->file_name);
			if (write_log) logText(log_buffer, FALSE);
			//TAP_Start(dir_info[curr_idx]->file_name);
			HDD_TAP_Start(dir_info[curr_idx]->file_name, FALSE, NULL, NULL);
		//}

		handleExitKey(TRUE, FALSE);
		window_displayed = FALSE;
#endif
	}
}

void handlePlayKey(void)
{
	TYPE_PlayInfo play_info;

	if (no_of_files == 0)
		return;

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play %s", dir_info[curr_idx]->file_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	
	if (!multi_play_started && InDataFilesFolder(curr_dir) && no_of_marked_recordings > 1) {
		if (selectionContainsEncodedVideos()) {
			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			choose_multi_play_mode = TRUE;
			overnight_play = FALSE;
			drawConfirmationBox();
			window_displayed = FALSE;
		}
		else {
			multi_play_batch_mode = MULTI_PLAY;
			multi_play_started = TRUE;
			TAP_Hdd_PlayTs(marked_recordings[0].file_name);
			TAP_Delay(50);
			TAP_Hdd_ChangePlaybackPos(0);

			// if there was already a playback in progress, then update the details with the new playback
			TAP_Hdd_GetPlayInfo(&play_info);
			handlePlaybackWhenExistingPlayback(play_info);
			handleExitKey(TRUE, TRUE);
		}
	}
	ef (isFolder(curr_idx))
	{
		ChangeDir(dir_info[curr_idx]->file_name);
		if (InMp3FilesFolder(curr_dir) || strcmp(dir_info[curr_idx]->file_name, "MP3") == 0)
		{
			if (mp3_playing)
				handleStopMp3(TRUE, TRUE);
			populateMP3s(TRUE, TRUE);
			if (no_of_mp3s > 0)
			{	
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play all %d MP3s in folder %s", no_of_mp3s, dir_info[curr_idx]->file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				if (randomise_mp3s)
					current_mp3 = getNextMp3(TRUE);
				else {
					current_mp3 = 0;
					saveHistory(FALSE, current_mp3);
				}
				strcpy(from_dir, curr_dir);
				strcat(from_dir, "/");
				strcat(from_dir, dir_info[curr_idx]->file_name);
				saveFolderHistory(from_dir);
				
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play MP3 %d %s", current_mp3, mp3_files[current_mp3]->file_name);
				if (write_log) if (verbose) logText(log_buffer, FALSE);

				mp3_playlist_playing = FALSE;
				mp3s_in_current_folder = FALSE;
				strcpy(mp3_folder, dir_info[curr_idx]->file_name);

				saveNavHistory(curr_idx, curr_highlight, FALSE);
				handleKickoffMp3Mode();

				ChangeDirPath(curr_dir);
			}
			else
			{
				ChangeDir("..");
			}
		}
		ef (InDataFilesFolder(curr_dir)) {
			TYPE_File file;
			int i;

			if (!multi_play_started && no_of_marked_recordings == 0) {
				i = TAP_Hdd_FindFirst(&file);

				while (i--)
				{
					handleMarkFile(file.name, tracked_dir, file.startCluster, file.mjd, file.hour, file.min, file.size, (file.skip == LOCKED_FILE));

					if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
						break;
				}

				if (no_of_marked_recordings > 0) {
					multi_play_batch_mode = MULTI_PLAY;
					multi_play_started = TRUE;
					TAP_Hdd_PlayTs(marked_recordings[0].file_name);
					TAP_Delay(50);
					TAP_Hdd_ChangePlaybackPos(0);

					// if there was already a playback in progress, then update the details with the new playback
					TAP_Hdd_GetPlayInfo(&play_info);
					handlePlaybackWhenExistingPlayback(play_info);
					handleExitKey(TRUE, TRUE);
				}
			}

			ChangeDir("..");
		}
		else
		{
			populateJPEGs(TRUE, TRUE);
			if (no_of_jpegs > 0)
			{	
				TAP_Osd_Delete(region);
				TAP_Osd_Delete(region_mem);
				mp3_progress_offset = 0;
				window_displayed = FALSE;
				saveNavHistory(curr_idx, curr_highlight, FALSE);
				force_display = FALSE;
				current_jpeg = 0;
				if (randomise_photos)
					current_jpeg = getNextJpeg(TRUE);
				startSlideshow(); 

				ChangeDirPath(curr_dir);
			}
			else
			{
				ChangeDir("..");
			}
		}
	}
	ef (InMp3FilesFolder(curr_dir))
	{
		if (mp3_playing)
			handleStopMp3(TRUE, TRUE);
		populateMP3s(FALSE, TRUE);
		if (no_of_mp3s > 0)
		{
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Play all %d MP3s in folder %s", no_of_mp3s, curr_dir);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			current_mp3 = 0;
			if (isMp3(dir_info[curr_idx]->file_name)) {
				word i;

				for (i = 0; i < no_of_mp3s; i++) {
					if (strcmp(dir_info[curr_idx]->file_name, mp3_files[i]->file_name) == 0) {
						current_mp3 = i;
						break;
					}
				}

				saveHistory(FALSE, current_mp3);
			}
			else {
				if (randomise_mp3s)
					current_mp3 = getNextMp3(TRUE);
				else {
					current_mp3 = 0;
					saveHistory(FALSE, current_mp3);
				}
			}
			saveFolderHistory(curr_dir);
			mp3_playlist_playing = FALSE;
			mp3s_in_current_folder = TRUE;

			if (show_all_files)
				saveNavHistory(0, 0, FALSE);
			else
				saveNavHistory(no_of_files - no_of_mp3s + current_mp3, -1, FALSE);
		
			handleKickoffMp3Mode();
		}
	}
	ef (local_no_of_jpegs > 0)
	{
		// if its a directory then delete window and start displaying piccies
		populateJPEGs(FALSE, TRUE);
		TAP_Osd_Delete(region);
		TAP_Osd_Delete(region_mem);
		mp3_progress_offset = 0;
		window_displayed = FALSE;
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		force_display = FALSE;
		current_jpeg = 0;
		if (isPhoto(dir_info[curr_idx]->file_name)) {
			word i;

			for (i = 0; i < no_of_jpegs; i++) {
				if (strcmp(dir_info[curr_idx]->file_name, jpeg_files[i]->file_name) == 0) {
					current_jpeg = i;
					break;
				}
			}

			if (randomise_photos) saveHistory(TRUE, current_jpeg);
		}
		ef (randomise_photos) {
			current_jpeg = getNextJpeg(TRUE);
		}
		startSlideshow(); 
	}
	ef (scenes_displayed) {
		int skip_position;

		if (scenes_are_locked) {
			pin_play_type = PLAY_FROM_SCENE;
			handleEnterPinNumber();
			return;
		}

		extractRecordingName(dir_info[curr_idx]->file_name, file_name);
		TAP_Hdd_PlayTs(file_name);

		// if there was already a playback in progress, then update the details with the new playback
		TAP_Hdd_GetPlayInfo(&play_info);
		handlePlaybackWhenExistingPlayback(play_info);

		saveExtendedInfo();
		skip_position = getCurrentBlockFromScene(dir_info[curr_idx]->file_name);
		if (play_info.playMode == PLAYMODE_Playing && skip_position > play_info.totalBlock) skip_position = 0;
		TAP_Hdd_ChangePlaybackPos(skip_position);
		handleExitKey(TRUE, TRUE);
		scenes_displayed = FALSE;
	}
	ef (isRec(dir_info[curr_idx]->file_name)) {
		TYPE_RecInfo rec_info_1, rec_info_2;
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);

		if (multi_play_started)
			return;

		// attempt to fix a duff recording
		if (!isValidRec(curr_idx))
			if (!fixRecording())
				return;

		if (IsDataFilesFolder(curr_dir) && strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0) {
			TAP_Channel_Start(1, rec_info_1.svcType, rec_info_1.svcNum);

			// if there was already a playback in progress, then update the details with the new playback
			TAP_Hdd_GetPlayInfo(&play_info);
			handlePlaybackWhenExistingPlayback(play_info);
			saveExtendedInfo();

			gotoAccurateBookmark(0);
		}
		ef (IsDataFilesFolder(curr_dir) && strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0) {
			TAP_Channel_Start(1, rec_info_2.svcType, rec_info_2.svcNum);

			// if there was already a playback in progress, then update the details with the new playback
			TAP_Hdd_GetPlayInfo(&play_info);
			handlePlaybackWhenExistingPlayback(play_info);
			saveExtendedInfo();

			gotoAccurateBookmark(1);
		}
		else {
			if (dir_info[curr_idx]->locked) {
				pin_play_type = PLAY_FROM_START;
				handleEnterPinNumber();
				return;
			}
			else {
				TAP_Hdd_PlayTs(dir_info[curr_idx]->file_name);
				if (isRadioRecording(curr_idx)) {
					TAP_Delay(50);
					TAP_Hdd_ChangePlaybackPos(0);
				}
				else
					gotoAccurateBookmark(2);

				saveExtendedInfo();

				// if there was already a playback in progress, then update the details with the new playback
				TAP_Hdd_GetPlayInfo(&play_info);
				handlePlaybackWhenExistingPlayback(play_info);
			}
		}

		handleExitKey(TRUE, TRUE);
	}
			
}

void handleStopKey(bool mp3)
{
	if (mp3 && mp3_playing)
	{
		mp3_stopping = TRUE;
		if (write_log) if (verbose) logText("Stop MP3 playing", TRUE);

		TAP_Hdd_StopMp3();
		handleExitMp3(FALSE);

		if (write_log) if (verbose) logText("Stopped MP3 playing", FALSE);
		mp3_stopping = FALSE;
	}

	if (!mp3)
	{
		TYPE_File *file;
		TYPE_PlayInfo play_info;
		TYPE_RecInfo rec_info_1, rec_info_2;

		if (no_of_files == 0)
			return;

		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);

		if (stop_playing) {
			/*if (masterpiece_mode) {
				if (write_log) if (verbose) logText("Stop video playback", TRUE);
				TAP_Hdd_StopTs();
				if (write_log) if (verbose) logText("Stopped video playback", TRUE);
			}*/
			
			// if we just created a thumbnail, then flag to say so
			stop_playing = FALSE;
		}
		ef (play_info.file && isRecPlaying(play_info)
				&& (multi_play_started 
					|| (strcmp(play_info.file->name, dir_info[curr_idx]->file_name) == 0
						&& play_info.file->startCluster == dir_info[curr_idx]->start_cluster))) {
			dword seconds_progress;

			// if less than ten secs since start TAP_Hdd_PlayTs, then do nothing
			//if (TAP_GetTick() < (update_progress_tick + 1000))
			//	return;

			// if less than ten secs since start of playback, then do nothing
			/*seconds_progress = ((60 * play_info.currentBlock * play_info.duration) / play_info.totalBlock);
			if (seconds_progress < 10) {
				if (write_log) TAP_SPrint(log_buffer, "Only %d seconds through", seconds_progress);
				if (write_log) logText(log_buffer, FALSE);
				return;
			}*/

			if (multi_play_started) {
				finishMultiPlay(TRUE);
				drawFiles(curr_idx - curr_highlight);
				copyMemoryToWindow();
			}

			if (play_info.playMode == PLAYMODE_Playing) {
				if (write_log) if (verbose) logText("Stop video playback", TRUE);
				TAP_Hdd_StopTs();
				if (write_log) if (verbose) logText("Stopped video playback", FALSE);
			}
			else {
				TAP_Hdd_StopTs();
				TAP_Channel_Start(1, play_info.svcType, play_info.svcNum);
			}
		}
		ef (IsDataFilesFolder(curr_dir) 
				&& (strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0
					|| strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0)) {

			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			stop_active_rec = TRUE;
			drawConfirmationBox();
			window_displayed = FALSE;
		}
		ef (no_of_saved_recordings > 0) {
			deleteSavedRecordings();

			drawInfoBox(deleted_t, delete_saved_t, NULL, FALSE, TRUE);
			TAP_Delay(200);
			TAP_Osd_RestoreBox(region_mem, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
			TAP_Osd_RestoreBox(region, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
			TAP_MemFree(info_save);
			info_save = NULL;

			drawFiles(curr_idx - curr_highlight);
			copyMemoryToWindow();
		}
		else {
			if (isRec(dir_info[curr_idx]->file_name)) {
				file = TAP_Hdd_Fopen(dir_info[curr_idx]->file_name);
				if (file != NULL) {
					int current_block = getCurrentBlockFromFile(file);
					int total_block = getTotalBlockFromFile(file);

					if (total_block > 0)
						deleteFromProgressFromFile(file, curr_dir);
					else {
						appendToProgressData(file, 1000, 1000);
						saveProgressData();
					}

					TAP_Hdd_Fclose(file);
					if (thumbnail_mode) {
						drawThumbnail(curr_highlight, curr_idx);
					}
					else {
						drawFile(curr_highlight, curr_idx);
						refreshFooterProgress(curr_idx);
					}
					copyMemoryToWindow();
				}
			}
		}
	}
}

void handleExitKey(bool permanent_exit, bool delete_osd)
{
	if (mp3_playing) {
		handleStopMp3(TRUE, TRUE);
		freeMP3Structure();
		destroy_ID3(id3_info);
		id3_info = NULL;
	}

	if (permanent_exit) { 
		saveNavHistoryOnExit();

		freeDirInfo();
		freeDimensions();
	}

	if (!multi_play_started && no_of_marked_recordings > 0)
		clearMarkedRecordings();

	if (write_log) if (verbose) logText("Exit list", FALSE);

	if (delete_osd) {
		TAP_Osd_Delete(region);
		TAP_Osd_Delete(region_mem);
		window_displayed = FALSE;
	}

	mp3_progress_offset = 0;
	if (permanent_exit /*|| masterpiece_mode*/) TAP_EnterNormal();

	// switch back aspect with WSSKiller
	TAP_GenerateEvent(EVT_KEY, WSS_Auto, 0);
}

// toggle display mode
void handleToggleKey()
{
	if (!playlist_displayed)
	{
		if (write_log) if (verbose) logText("Toggle display mode", FALSE);
		mp3_progress_offset = 0;
		recreateWindow();
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		if (thumbnail_mode)	{
#ifndef WIN32
		TAP_Osd_SetTransparency(region, 255-toppy_transparency);
#endif
			thumbnail_mode = FALSE;
			drawFileList(TRUE, FALSE);
			drawMp3InfoBox();
		}
		else {
			thumbnail_mode = TRUE;
			drawThumbnailGrid(FALSE);
		}
		copyMemoryToWindow();
		drawDiskSpaceInfoBox();
	}
}

bool handleRenameKey()
{
	if (no_of_files == 0)
		return FALSE;

	// if we are playing or recording this file, then cannot rename
	if (isRec(dir_info[curr_idx]->file_name)) {
		TYPE_PlayInfo play_info;
		TYPE_RecInfo rec_info_1, rec_info_2;
		
		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		if ((play_info.file && play_info.playMode == PLAYMODE_Playing && strcmp(play_info.file->name, dir_info[curr_idx]->file_name) == 0)
				|| strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0
				|| strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0)
			return FALSE;
	}

	// do not rename any of the standard folder names
	if (isFolder(curr_idx) &&
			(strcmp(dir_info[curr_idx]->file_name, "ProgramFiles") == 0
			|| strcmp(dir_info[curr_idx]->file_name, "DataFiles") == 0
			|| strcmp(dir_info[curr_idx]->file_name, "MP3") == 0
			|| strcmp(dir_info[curr_idx]->file_name, "Auto Start") == 0))
		return FALSE;

	if (!isParentDirectory(dir_info[curr_idx]->file_name)) {
		memset(keyboard_name, '\0', 100);
		if (isFolder(curr_idx))
			strcpy(keyboard_name, dir_info[curr_idx]->file_name);
		ef (isRec(dir_info[curr_idx]->file_name) 
				|| isMp3(dir_info[curr_idx]->file_name) 
				|| isPhoto(dir_info[curr_idx]->file_name)
				|| isSkin(dir_info[curr_idx]->file_name))
			strncat(keyboard_name, dir_info[curr_idx]->file_name, strlen(dir_info[curr_idx]->file_name)-getExtensionLength(dir_info[curr_idx]->file_name));
		else
			strcpy(keyboard_name, dir_info[curr_idx]->file_name);
		cursor_pointer = strlen(keyboard_name);
		new_folder = FALSE;
		handleKeyboardKey();

		return TRUE;
	}

	return FALSE;
}

bool handleNewFolderKey()
{
	memset(keyboard_name, '\0', 100);
	if (no_of_files > 0 && isRec(dir_info[curr_idx]->file_name))
		strncat(keyboard_name, dir_info[curr_idx]->file_name, strlen(dir_info[curr_idx]->file_name)-4);
	new_folder = TRUE;
	cursor_pointer = strlen(keyboard_name);
	handleKeyboardKey();
	return TRUE;
}

void handleKeyboardKey()
{
	keyboard_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);

	if (thumbnail_mode)
		recreateWindow();
	keyboard_displayed = TRUE;
	window_displayed = FALSE;
	if (!search_mp3s) {
		if (playlist_displayed) {
			saved_playlist_idx = curr_idx;
			saved_playlist_highlight = curr_highlight;
		}
		else {
			saveNavHistory(curr_idx, curr_highlight, FALSE);
		}
	}
	keyboard_idx = 0;
	keyboard_case = KEYBOARD_AUTO;
	if (thumbnail_mode)
		drawKeyboard(TRUE);	
	else
		drawKeyboard(FALSE);	
	copyMemoryToKeyboard();
	drawMp3InfoBox();
	drawDiskSpaceInfoBox();
}

void handleAutoDeleteListKey()
{
	if (!auto_deletes_displayed)
	{
		if (write_log) if (verbose) logText("Display auto deletes", FALSE);
		freeDirInfo();
		if (thumbnail_mode)
			recreateWindow();
		auto_deletes_displayed = TRUE;
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		//saved_auto_delete_idx = 0;
		auto_delete_idx = 0;
		if (thumbnail_mode)
			drawAutoDeleteList(TRUE);
		else
			drawAutoDeleteList(FALSE);
		copyMemoryToWindow();
		drawDiskSpaceInfoBox();
	}
}

void handleSkinEditorKey()
{
	if (!skin_editor_displayed)
	{
		if (write_log) if (verbose) logText("Display skin editor", FALSE);

		if (thumbnail_mode)
			recreateWindow();

		skin_editor_displayed = TRUE;
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		skin_editor_idx = 0; skin_editor_highlight = 0; skin_colour_idx = 0;

		// swap skins while we are editing
		strcpy(skin_file_name, dir_info[curr_idx]->file_name);
		loadSkinElements(W, 30);

		// load skin elements into memory and then display editor
		populateSkinElements(dir_info[curr_idx]->file_name, &no_of_skin_elements);
		drawSkinEditor(TRUE);
		copyMemoryToWindow();
		drawMp3InfoBox();
		drawDiskSpaceInfoBox();
	}
}

bool handleRecycleBinKey()
{
	if (/*enable_recycle_bin &&*/ !recycle_bin_displayed)
	{
		if (write_log) if (verbose) logText("Display recycle bin", FALSE);
		if (thumbnail_mode) 
			recreateWindow();
		recycle_bin_displayed = TRUE;
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		freeDirInfo();
		no_of_files = no_of_recycles;
		saved_recycle_idx = 0;
		saved_recycle_highlight = 0;
		if (thumbnail_mode)
			drawFileList(TRUE, FALSE);
		else
			drawFileList(FALSE, FALSE);
		copyMemoryToWindow();
		drawMp3InfoBox();
		drawDiskSpaceInfoBox();

		return TRUE;
	}

	return FALSE;
}

void handleMarkFile(char *file_name, char *dir, dword start_cluster, word mjd, word hour, word min, dword size, bool locked)
{
	TYPE_RecInfo rec_info_1, rec_info_2;

	if (no_of_files == 0)
		return;

	// if locked or we are recording this file then can not multi play
	TAP_Hdd_GetRecInfo(0, &rec_info_1);
	TAP_Hdd_GetRecInfo(1, &rec_info_2);
	if (locked || strcmp(rec_info_1.fileName, file_name) == 0
			   || strcmp(rec_info_2.fileName, file_name) == 0)
		return;

	if (isMarkedRecording(file_name, start_cluster)) {
		removeFromMarkedRecordings(file_name, dir, start_cluster);
		if (!thumbnail_mode) {
			drawFile(curr_highlight, curr_idx);
			copyMemoryToWindow();
		}
	}
	ef (isRec(file_name)) {
		appendToMarkedRecordings(file_name, dir, start_cluster, mjd, hour, min, size);
		if (!thumbnail_mode) {
			drawFile(curr_highlight, curr_idx);
			copyMemoryToWindow();
		}
	}
}

void handlePlaylistKey()
{
	if (!playlist_displayed)
	{
		if (write_log) if (verbose) logText("Display playlist", FALSE);
		if (thumbnail_mode)
			recreateWindow();

		if (InMp3FilesFolder(curr_dir) || strcmp(dir_info[curr_idx]->file_name, "MP3") == 0) {
			freeDirInfo();
			photo_playlist_mode = FALSE;
			no_of_files = no_of_playlist_mp3s;
		}
		else {
			freeDirInfo();
			photo_playlist_mode = TRUE;
			no_of_files = no_of_playlist_photos;
		}
		playlist_displayed = TRUE;
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		saved_playlist_idx = 0;
		saved_playlist_highlight = 0;
		drawPlaylist(TRUE);
		drawMp3InfoBox();
		copyMemoryToWindow();
	}
}

void handleBrowseScenesKey()
{
	if (no_of_files == 0)
		return;

	if (isRec(dir_info[curr_idx]->file_name) && !isRadioRecording(curr_idx) && no_of_marked_recordings == 0) {
		// first check that at least one scene exists
		if (!TAP_Hdd_Exist("Cache")) return;
		ChangeDir("Cache");
		TAP_SPrint(file_name, "%s.tn.1", dir_info[curr_idx]->file_name);
		if (!TAP_Hdd_Exist(file_name)) {
			ChangeDir("..");
			return;
		}
		ChangeDir("..");

		// scenes exist, so safe to display scene browser
		if (write_log) if (verbose) logText("Display scenes", FALSE);
		recreateWindow();
		scenes_displayed = TRUE;
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		saved_scene_idx = 0;
		scenes_are_locked = dir_info[curr_idx]->locked ? TRUE : FALSE;
		populateScenes(dir_info[curr_idx]->file_name);
		saveNavHistory(0, 0, FALSE);
		drawThumbnailGrid(FALSE);
		copyMemoryToWindow();
	}
}

bool handleMoveKey()
{
	if (no_of_files == 0)
		return FALSE;

	//if (no_of_marked_recordings > 0)
	//	return FALSE;

	if (isRec(dir_info[curr_idx]->file_name) && no_of_marked_recordings == 0) {
		TYPE_PlayInfo play_info;
		TYPE_RecInfo rec_info_1, rec_info_2;

		// if we are playing or recording this file, then cannot move
		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		if ((play_info.file && play_info.playMode == PLAYMODE_Playing && strcmp(play_info.file->name, dir_info[curr_idx]->file_name) == 0)
				|| strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0
				|| strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0)
			return FALSE;
	}

	if (no_of_marked_recordings > 0 || 
			(!isParentDirectory(dir_info[curr_idx]->file_name)
					&& strcmp(dir_info[curr_idx]->file_name, "DataFiles") != 0
					&& strcmp(dir_info[curr_idx]->file_name, "MP3") != 0
					&& strcmp(dir_info[curr_idx]->file_name, "ProgramFiles") != 0
					&& strcmp(dir_info[curr_idx]->file_name, "Auto Start") != 0)) {
		if (write_log) if (verbose) logText("Display move folders", FALSE);
		move_folders_displayed = TRUE;
		window_displayed = FALSE;
		strcpy(move_file_name, dir_info[curr_idx]->file_name);
		populateMoveFolders();
		drawMoveFolderList(TRUE);
		return TRUE;
	}
	
	return FALSE;
}

void handleLoadPlaylistKey()
{
	if (write_log) if (verbose) logText("Display load playlists", FALSE);
	load_playlist_displayed = TRUE;
	window_displayed = FALSE;
	loadPlaylistFiles(photo_playlist_mode);
	if (photo_playlist_mode)
		no_of_playlists = no_of_photo_playlists;
	else
		no_of_playlists = no_of_mp3_playlists;
	load_playlist_idx = 0, load_playlist_highlight = 0;
	drawLoadPlaylist();
}

void handleLoadSkinKey()
{
	if (write_log) if (verbose) logText("Display load skins", FALSE);
	load_skin_displayed = TRUE;
	window_displayed = FALSE;
	load_skin_idx = 0, load_skin_highlight = 0;
	drawLoadSkinList();
}

bool definedBySkin(char *element_name)
{
	word i;

	for (i = 0; i < no_of_skin_elements; i++) {
		if (strcmp(element_name, skin_elements[i]->element_name) == 0)
			return TRUE;
	}

	return FALSE;
}

void handleSkinElementKey()
{
	word i;

	if (write_log) if (verbose) logText("Display insert elements", FALSE);
	skin_elements_displayed = TRUE;
	window_displayed = FALSE;
	skin_element_idx = 0, skin_element_highlight = 0;

	// load insert elements
	no_of_insert_elements = 0;
	for (i = 0; i < SKIN_ELEMENT_COUNT; i++) {
		if (!definedBySkin(skin_element_names[i].name)) {
			insert_elements[no_of_insert_elements] = dlmalloc(40);
			strcpy(insert_elements[no_of_insert_elements], skin_element_names[i].name);
			no_of_insert_elements++;
		}
	}

	drawSkinElementList();
}

void handleStopMenu()
{
	if (write_log) if (verbose) logText("Display stop menu", FALSE);
	no_of_stop_options = 6;
	TAP_GenerateEvent(EVT_KEY, RKEY_Pause, 0);
	idle_before_stop_menu_display = TRUE;
	tick_draw_stop_menu = TAP_GetTick();
}

void handleOptionsListKey()
{
	if (write_log) if (verbose) logText("Display options list", FALSE);
	options_displayed = TRUE;
	window_displayed = FALSE;
	options_idx = 0; options_highlight = 0;
	if (recycle_bin_displayed) {
		no_of_options = 4;
		options_idx = (recycle_ordering_mode == 3) ? 2 : (recycle_ordering_mode == 4) ? 3 : recycle_ordering_mode; 
		options_highlight = (recycle_ordering_mode == 3) ? 2 : (recycle_ordering_mode == 4) ? 3 : recycle_ordering_mode; 
	}
	ef (InDataFilesFolder(curr_dir)) {
		no_of_options = sort_options ? 6 : 8;
		if (sort_options) {
			options_idx = video_ordering_mode; 
			options_highlight = video_ordering_mode; 
		}
	}
	ef (InMp3FilesFolder(curr_dir)) {
		no_of_options = sort_options ? 4 : 5;
		if (sort_options) {
			options_idx = (music_ordering_mode == 3) ? 2 : (music_ordering_mode == 4) ? 3 : music_ordering_mode; 
			options_highlight = (music_ordering_mode == 3) ? 2 : (music_ordering_mode == 4) ? 3 : music_ordering_mode; 
		}
	}
	else {
		no_of_options = sort_options ? 4 : 8;
		if (sort_options) {
			options_idx = (photo_ordering_mode == 3) ? 2 : (photo_ordering_mode == 4) ? 3 : photo_ordering_mode; 
			options_highlight = (photo_ordering_mode == 3) ? 2 : (photo_ordering_mode == 4) ? 3 : photo_ordering_mode; 
		}
	}
	drawOptionsList();
}

void handleInfoKey()
{
	if (isJpg(dir_info[curr_idx]->file_name) || isMp3(dir_info[curr_idx]->file_name))
	{
		no_of_details = 0;
		if (isJpg(dir_info[curr_idx]->file_name))
			ProcessFile(dir_info[curr_idx]->file_name);
		else {
			char channelmode[4][20] ={"Stereo","Joint Stereo","Dual Channel","Single Channel"};
			char mpeg_version[3][10] ={"MPEG 1","MPEG 2","MPEG 2.5"};
			char mpeg_layer[5][10] ={"","Layer I","Layer II","Layer III","Reserved"};

			// if trying to show details for currently playing mp3, then use saved id3 details (since we can't open the file)
			if (mp3_playing && strcmp(curr_dir, mp3_files[current_mp3]->directory) == 0
							&& strcmp(dir_info[curr_idx]->file_name, mp3_files[current_mp3]->file_name) == 0) 
				copyID3ToID3(TRUE, FALSE);
			else
				readID3Tag(dir_info[curr_idx]->file_name, FALSE, FALSE);

			if (id3_info->artist && strlen(id3_info->artist) > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Artist");
				TAP_SPrint(photo_exif[no_of_details].detail, id3_info->artist);
				photo_exif[no_of_details].detail[40] = '\0';
				no_of_details++;
			}
			if (id3_info->title && strlen(id3_info->title) > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Title");
				TAP_SPrint(photo_exif[no_of_details].detail, id3_info->title);
				photo_exif[no_of_details].detail[40] = '\0';
				no_of_details++;
			}
			if (id3_info->album && strlen(id3_info->album) > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Album");
				TAP_SPrint(photo_exif[no_of_details].detail, id3_info->album);
				photo_exif[no_of_details].detail[40] = '\0';
				no_of_details++;
			}
			if (id3_info->genre_code && strlen(id3_info->genre_code) > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Genre");
				TAP_SPrint(photo_exif[no_of_details].detail, id3_info->genre);
				no_of_details++;
			}
			if (id3_info->year && strlen(id3_info->year) > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Year");
				TAP_SPrint(photo_exif[no_of_details].detail, id3_info->year);
				no_of_details++;
			}
			TAP_SPrint(photo_exif[no_of_details].heading, "Level");
			TAP_SPrint(photo_exif[no_of_details].detail, "%s %s", mpeg_version[id3_info->mp3_version], mpeg_layer[id3_info->mp3_layer]);
			no_of_details++;
			TAP_SPrint(photo_exif[no_of_details].heading, "Channels");
			TAP_SPrint(photo_exif[no_of_details].detail, "%s", channelmode[id3_info->channels]);
			no_of_details++;
			if (id3_info->bitrate > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Bitrate");
				TAP_SPrint(photo_exif[no_of_details].detail, "%d Kbps", id3_info->bitrate);
				no_of_details++;
			}
			else {
				TAP_SPrint(photo_exif[no_of_details].heading, "Bitrate");
				TAP_SPrint(photo_exif[no_of_details].detail, "Variable");
				no_of_details++;
			}
			if (id3_info->samplerate > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Frequency");
				TAP_SPrint(photo_exif[no_of_details].detail, "%d Hz", id3_info->samplerate);
				no_of_details++;
			}
			if (id3_info->duration > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Length");
				TAP_SPrint(photo_exif[no_of_details].detail, "%d:%02d", id3_info->duration / 60, id3_info->duration % 60);
				no_of_details++;
			}
			if (id3_info->track_number > 0) {
				TAP_SPrint(photo_exif[no_of_details].heading, "Track");
				TAP_SPrint(photo_exif[no_of_details].detail, "%d", id3_info->track_number);
				no_of_details++;
			}
			if (strlen(id3_info->id3v1_version) > 0 || strlen(id3_info->id3v2_version)) {
				TAP_SPrint(photo_exif[no_of_details].heading, "ID3 tag");
				if (strlen(id3_info->id3v1_version) > 0 && strlen(id3_info->id3v2_version) > 0)
					TAP_SPrint(photo_exif[no_of_details].detail, "ID3v%s & ID3v%s", id3_info->id3v1_version, id3_info->id3v2_version);
				ef (strlen(id3_info->id3v1_version) > 0)
					TAP_SPrint(photo_exif[no_of_details].detail, "ID3v%s", id3_info->id3v1_version);
				ef (strlen(id3_info->id3v2_version) > 0)
					TAP_SPrint(photo_exif[no_of_details].detail, "ID3v%s", id3_info->id3v2_version);
				no_of_details++;
			}

			destroy_ID3(id3_info);
			id3_info = NULL;
		}
		if (no_of_details > 0)
		{
			if (write_log) if (verbose) logText("Displaying info viewer", FALSE);
			info_displayed = TRUE;
			window_displayed = FALSE;
			drawInfoViewer();
		}
	}
	ef (!dir_info[curr_idx]->folder)
	{
		no_of_details = 2;

		TAP_SPrint(photo_exif[0].heading, "Date");
		formatDateString(dir_info[curr_idx]->mjd, buffer, TRUE);
		TAP_SPrint(buffer2, "%s ~ %02d:%02d", buffer, dir_info[curr_idx]->hour, dir_info[curr_idx]->min);
		TAP_SPrint(photo_exif[0].detail, buffer2);

		TAP_SPrint(photo_exif[1].heading, "Size");
		if (dir_info[curr_idx]->size < 1024)
			TAP_SPrint(buffer, "%d B", dir_info[curr_idx]->size);
		ef (dir_info[curr_idx]->size < 10486)
			TAP_SPrint(buffer, "%d KB", dir_info[curr_idx]->size / 1024);
		else
			TAP_SPrint(buffer, "%d.%d%d MB", dir_info[curr_idx]->size / 1048576, (dir_info[curr_idx]->size % 1048576) / 104858, (dir_info[curr_idx]->size % 104858) / 10486);
		TAP_SPrint(photo_exif[1].detail, buffer);

		if (write_log) if (verbose) logText("Displaying info viewer", FALSE);
		info_displayed = TRUE;
		window_displayed = FALSE;
		drawInfoViewer();
	}
}

void handleRecInfoKey()
{
	if (no_of_files == 0)
		return;

	if (isValidRec(curr_idx))
	{
		if (write_log) if (verbose) logText("Displaying recording info viewer", FALSE);
		rec_info_displayed = TRUE;
		window_displayed = FALSE;
		smaller_font = FALSE;
		drawRecInfoViewer();
	}
}

void handleHelpKey()
{
	if (skin_editor_displayed)
	{
		if (write_log) if (verbose) logText("Displaying skin editor help viewer", FALSE);
		help_displayed = TRUE;
		window_displayed = FALSE;
		drawSkinEditorHelpViewer();
	}
	ef (auto_deletes_displayed)
	{
		if (write_log) if (verbose) logText("Displaying auto delete help viewer", FALSE);
		help_displayed = TRUE;
		window_displayed = FALSE;
		drawAutoDeleteHelpViewer();
	}
	ef (recycle_bin_displayed)
	{
		if (write_log) if (verbose) logText("Displaying recycle bin help viewer", FALSE);
		help_displayed = TRUE;
		window_displayed = FALSE;
		drawRecycleBinHelpViewer();
	}
	ef (playlist_displayed)
	{
		if (write_log) if (verbose) logText("Displaying playlist help viewer", FALSE);
		help_displayed = TRUE;
		window_displayed = FALSE;
		drawPlaylistHelpViewer();
	}
	ef (InDataFilesFolder(curr_dir))
	{
		if (write_log) if (verbose) logText("Displaying recording help viewer", FALSE);
		help_displayed = TRUE;
		window_displayed = FALSE;
		drawRecHelpViewer();
	}
	ef (InMp3FilesFolder(curr_dir)) {
		if (write_log) if (verbose) logText("Displaying mp3 help viewer", FALSE);
		help_displayed = TRUE;
		window_displayed = FALSE;
		drawMp3HelpViewer();
	}
	else {
		if (write_log) if (verbose) logText("Displaying photo help viewer", FALSE);
		help_displayed = TRUE;
		window_displayed = FALSE;
		drawJpgHelpViewer();
	}
}

void handleReorder(dword idx)
{
	dword ordering_mode = idx;
	if (no_of_options == 4) {
		if (idx == 2)
			ordering_mode = 3;
		ef (idx == 3)
			ordering_mode = 4;
	}

	if (recycle_bin_displayed)
		recycle_ordering_mode = ordering_mode;
	ef (InDataFilesFolder(curr_dir))
		video_ordering_mode = ordering_mode;
	ef (InMp3FilesFolder(curr_dir))
		music_ordering_mode = ordering_mode;
	else
		photo_ordering_mode = ordering_mode;

	ChangeDirMediaManager();
	SaveConfigurationToFile();
	ChangeDirPath(curr_dir);

	if (recycle_bin_displayed) {
		saved_recycle_idx = 0; saved_recycle_highlight = 0;
	}
	ef (InDataFilesFolder(curr_dir)) {
		resetVideoHistory();
	}
	else
		saveNavHistory(0, 0, FALSE);

	if (recycle_bin_displayed)
		qsort(recycle_bin_list, no_of_recycles, sizeof(recycle_bin_list[0]), compareRecycling);
	else
		qsort(dir_info, no_of_files, sizeof(dir_info[0]), compareFiles);

	if (thumbnail_mode && !recycle_bin_displayed)
		drawThumbnailGrid(FALSE);
	else {
		drawFileList(FALSE, FALSE);
		drawMp3InfoBox();
	}
	copyMemoryToWindow();
	window_displayed = TRUE;
}

void handleReorderKey()
{
	sort_options = TRUE;
	handleOptionsListKey();
}

// create thumbnail or scenes for highlighted recording
bool handleCreateRecordingThumbnail(bool scenes)
{
	TYPE_PlayInfo play_info;
	TYPE_RecInfo rec_info_1, rec_info_2;

	if (no_of_files == 0)
		return FALSE;

	if (scenes && !create_scenes)
		return FALSE;

	if (isRadioRecording(curr_idx))
		return FALSE;

	if (isValidRec(curr_idx)) {
		// if we are playing or recording this file, then cannot create thumbnail
		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		if ((play_info.file && play_info.playMode == PLAYMODE_Playing && strcmp(play_info.file->name, dir_info[curr_idx]->file_name) == 0)
				|| strcmp(rec_info_1.fileName, dir_info[curr_idx]->file_name) == 0
				|| strcmp(rec_info_2.fileName, dir_info[curr_idx]->file_name) == 0)
			return FALSE;

		handleExitKey(FALSE, TRUE);
		createRecordingThumbnail(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, !scenes, scenes, !scenes, scenes, FALSE);

		do {
			TAP_SystemProc();
			TAP_Hdd_GetPlayInfo(&play_info);
		}
		while (play_info.playMode == PLAYMODE_Playing);

		if (stop_playing) {
			stop_playing = FALSE;
			//TAP_GenerateEvent(EVT_KEY, RKEY_Stop, 0);
		}

		saveNavHistory(curr_idx, curr_highlight, FALSE);
		idle_before_initial_display = TRUE;
		tick_draw_window = TAP_GetTick();
		//drawInitialListing(FALSE);

		return TRUE;
	}

	return FALSE;
}

void handleMenuKey()
{
	if (write_log) if (verbose) logText("Displaying options menu", FALSE);
	if (thumbnail_mode)
		recreateWindow();

	if (playlist_displayed) {
		saved_playlist_idx = curr_idx;
		saved_playlist_highlight = curr_highlight;
	}
	ef (scenes_displayed)
		saved_scene_idx = curr_idx;
	ef (recycle_bin_displayed) {
		saved_recycle_idx = curr_idx;
		saved_recycle_highlight = curr_highlight;
	}
	ef (auto_deletes_displayed) {}
	ef (window_displayed) {
		saveNavHistory(curr_idx, curr_highlight, FALSE);
		freeDirInfo();
	}
	curr_idx = 1;
	curr_highlight = 1;

	ChangeDirMediaManager();
	no_of_files = NUMBER_OF_OPTIONS;
	menu_displayed = TRUE;
	if (thumbnail_mode)
		drawOptionsMenu(saved_menu_idx, saved_menu_highlight, TRUE);
	else
		drawOptionsMenu(saved_menu_idx, saved_menu_highlight, FALSE);
	copyMemoryToMenu();
	window_displayed = FALSE;
	drawMp3InfoBox();
	drawDiskSpaceInfoBox();
}

void handleAppendToPlaylistKey()
{
	if (dir_info[curr_idx]->folder && !isParentDirectory(dir_info[curr_idx]->file_name)) {
		appendDirectoryToPlaylist(dir_info[curr_idx]->file_name);
	}
	ef (isPhoto(dir_info[curr_idx]->file_name)) {
		int found_idx = existsInPlaylist(curr_dir, dir_info[curr_idx]->file_name);
		if (found_idx >= 0) {
			removeFromPlaylist(TRUE, found_idx);
		} 
		else {
			appendToPlaylist(TRUE, curr_dir, dir_info[curr_idx]->file_name, TRUE);
		}
	}
	ef (isMp3(dir_info[curr_idx]->file_name)) {
		int found_idx = existsInPlaylist(curr_dir, dir_info[curr_idx]->file_name);
		if (found_idx >= 0) {
			removeFromPlaylist(FALSE, found_idx);
		}
		else {
			appendToPlaylist(FALSE, curr_dir, dir_info[curr_idx]->file_name, TRUE);
		}
	}
}

void doRecycle(char *file_to_delete, dword start_cluster, char *directory, word mjd, word hour, word min, dword size, bool folder, bool change_dir)
{
	TYPE_PlayInfo play_info;
	TYPE_RecInfo rec_info_1, rec_info_2;
	TYPE_File *file;
	char delete_name[100];
	bool renamed = FALSE;

	strcpy(delete_name, file_to_delete);

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Move file %s in %s to recycle bin", delete_name, directory);
	if (write_log) if (verbose) logText(log_buffer, FALSE);

	if (change_dir)
		ChangeDirPath(directory);

	// if an mp3, then stop playback
	if (isMp3(delete_name)) {
		if (mp3_playing && strcmp(mp3_files[current_mp3]->file_name, delete_name) == 0) {
			handleStopKey(TRUE);
		}
		deleteMp3Header(delete_name, directory);
	}

	// if a rec, then stop playback or recording first
	if (isRec(delete_name)) {
		TAP_Hdd_GetPlayInfo(&play_info);
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		
		// rec is already stopped if coming from stop menu
		if (!stop_menu_displayed) {
			if (play_info.file && play_info.playMode == PLAYMODE_Playing 
					&& strcmp(play_info.file->name, delete_name) == 0
					&& play_info.file->startCluster == start_cluster) {
				if (write_log) if (verbose) logText("Stop vid", TRUE);
				TAP_Hdd_StopTs();
				if (write_log) if (verbose) logText("Stopped vid", FALSE);
			}
			ef (IsDataFilesFolder(directory) && strcmp(rec_info_1.fileName, delete_name) == 0) {
				if (play_info.file && play_info.playMode == PLAYMODE_RecPlaying 
						&& strcmp(play_info.file->name, delete_name) == 0
						&& play_info.file->startCluster == start_cluster) {
					if (write_log) if (verbose) logText("Stop vid", TRUE);
					TAP_Hdd_StopTs();
					if (write_log) if (verbose) logText("Stopped vid", FALSE);
				}
				TAP_Hdd_StopRecord(0);

				if (!TAP_Hdd_Exist(delete_name))
					return;
			}
			ef (IsDataFilesFolder(directory) && strcmp(rec_info_2.fileName, delete_name) == 0) {
				if (play_info.file && play_info.playMode == PLAYMODE_RecPlaying 
						&& strcmp(play_info.file->name, delete_name) == 0
						&& play_info.file->startCluster == start_cluster) {
					if (write_log) if (verbose) logText("Stop vid", TRUE);
					TAP_Hdd_StopTs();
					if (write_log) if (verbose) logText("Stopped vid", FALSE);
				}
				TAP_Hdd_StopRecord(1);

				if (!TAP_Hdd_Exist(delete_name))
					return;
			}
		}

		// then delete the progress data
		file = TAP_Hdd_Fopen(delete_name);
		if (file) {
			deleteFromProgressFromFile(file, directory);
			TAP_Hdd_Fclose(file);
		}

		deleteRecHeader(file_to_delete, start_cluster);
	}
	ef (InDataFilesFolder(directory) && folder) {
		strcpy(temp2, directory);
		strcat(temp2, "/");
		strcat(temp2, file_to_delete);
		deleteRecHeaderForDir(temp2);
	}

	// for a skin file, delete skin from list
	if (isSkin(delete_name) && (strcmp(directory, "/ProgramFiles") == 0 || strcmp(directory, "/ProgramFiles/Settings/Skins") == 0)) {
		int i, found_idx = -1; 
		for (i = 0; i < skin_count; i++) {
			if (strcmp(skins[i].skin_name, file_to_delete) == 0 && skins[i].in_skins_folder == (strcmp(directory, "/ProgramFiles/Settings/Skins") == 0)) {
				found_idx = i;
				break;
			}
		}

		if (found_idx >= 0) {
			for (i = found_idx; i < skin_count-1; i++) {
				strcpy(skins[i].skin_name, skins[i+1].skin_name);
				skins[i].in_skins_folder = skins[i+1].in_skins_folder;
			}
			dlfree(skins[skin_count-1].skin_name);

			skin_count--;

			if (current_skin > found_idx && current_skin > 0)
				current_skin--;
		}
	}

	strcpy(to_dir, directory);
	strcpy(from_dir, directory);
	
	ExtractExtension(delete_name, extension);
	if (strlen(extension) > 0)
		strcat(extension, ".del");
	else
		strcpy(extension, ".del");

	// strip off the extension for renaming
	strcpy(old_name, delete_name);
	strcpy(new_name, delete_name);
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename %s", old_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	if (!folder) {
		memset(delete_name, '\0', 100);
		strncat(delete_name, new_name, strlen(new_name)-getExtensionLength(new_name));
	}

	// append the relevant stamp
	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename %s, extension %s", delete_name, extension);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	renamed = appendToName(RENAME_BY_NUMBER, delete_name, extension, from_dir, to_dir, mjd, hour, min);

	// if move file name has been appended to, then replace the extension and rename the physical file
	strcat(delete_name, extension);

	if (write_log) if (verbose) TAP_SPrint(log_buffer, "Renamed %s to %s, now do physical rename", old_name, delete_name);
	if (write_log) if (verbose) logText(log_buffer, FALSE);
	strcpy(new_name, delete_name);
	doRename(old_name, new_name, FALSE, folder);

	if (write_log) if(verbose) logText("Append to recycle list and sort", FALSE);
	appendToRecycleBinList(new_name, start_cluster, directory, mjd, hour, min, size, folder);
	qsort(recycle_bin_list, no_of_recycles, sizeof(recycle_bin_list[0]), compareRecycling);
}

bool doSingleRecycle(char *name, dword start_cluster, bool folder, word mjd, word hour, word min, dword size, bool save_box)
{
	TYPE_RecInfo rec_info_1, rec_info_2;

	// if a rec, then stop playback or recording first
	if (isRec(name)) {
		TAP_Hdd_GetRecInfo(0, &rec_info_1);
		TAP_Hdd_GetRecInfo(1, &rec_info_2);
		
		if (IsDataFilesFolder(curr_dir) 
				&& (strcmp(rec_info_1.fileName, name) == 0
					|| strcmp(rec_info_2.fileName, name) == 0)) {
			confirmation_box_displayed = TRUE;
			yes_selected = FALSE;
			delete_active_rec = TRUE;
			drawConfirmationBox();
			window_displayed = FALSE;
			return FALSE;
		}
	}
	if (folder)
		TAP_SPrint(buffer, "%s '%s'", moving_folder_t, name);
	else
		TAP_SPrint(buffer, "%s '%s'", moving_file_t, name);
	drawInfoBox(moving_file_t, buffer, to_recycle_bin_t, FALSE, save_box);
	doRecycle(name, start_cluster, curr_dir, mjd, hour, min, size, folder, FALSE);
	return TRUE;
}

void handleDeleteFileKey()
{
	if (!stop_menu_displayed && no_of_files == 0)
		return;

	if (!stop_menu_displayed) {

		if (isPhotoLog(dir_info[curr_idx]->file_name) && write_log)
			closeLogfile();

		if (strcmp(dir_info[curr_idx]->file_name, skin_file_name) == 0 
				|| (no_of_marked_recordings > 0 && !enable_recycle_bin)) {
			return;
		}

		if (isParentDirectory(dir_info[curr_idx]->file_name)
				|| strcmp(dir_info[curr_idx]->file_name, "ProgramFiles") == 0
				|| strcmp(dir_info[curr_idx]->file_name, "DataFiles") == 0
				|| strcmp(dir_info[curr_idx]->file_name, "MP3") == 0
				|| strcmp(dir_info[curr_idx]->file_name, "Auto Start") == 0)
			return;
	}
	
	if (enable_recycle_bin && !recycle_bin_displayed) {

		if (stop_menu_displayed) {
			TYPE_File rec_file;
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Attempt to locate %s directory", playing_file.name);
			if (write_log) if (verbose) logText(log_buffer, TRUE);
			if (ChangeDirCurrentRecording(playing_file.name, playing_file.startCluster, &rec_file)) {
				dword size;

				if (write_log) if (verbose) logText("Located directory", FALSE);
				mjd = rec_file.mjd; hour = rec_file.hour; min = rec_file.min; size = rec_file.size;
				TAP_SPrint(buffer, "%s '%s'", moving_file_t, playing_file.name);
				drawInfoBox(moving_file_t, buffer, to_recycle_bin_t, FALSE, TRUE);
				doRecycle(playing_file.name, playing_file.startCluster, tracked_dir, mjd, hour, min, size, FALSE, FALSE);
			}
			else {
				if (write_log) if (verbose) logText("Failed to locate directory", FALSE);
				ChangeDirPath(curr_dir);
				return;
			}

			ChangeDirPath(curr_dir);
		}
		else {
			bool recycled = TRUE;
			if (no_of_marked_recordings > 0) {
				word i;
				for (i = 0; i < no_of_marked_recordings; i++)
					doSingleRecycle(marked_recordings[i].file_name, marked_recordings[i].start_cluster, FALSE, marked_recordings[i].mjd, marked_recordings[i].hour, marked_recordings[i].min, marked_recordings[i].size, (i == 0));
			}
			else {
				recycled = doSingleRecycle(dir_info[curr_idx]->file_name, dir_info[curr_idx]->start_cluster, dir_info[curr_idx]->folder, dir_info[curr_idx]->mjd, dir_info[curr_idx]->hour, dir_info[curr_idx]->min, dir_info[curr_idx]->size, TRUE);
			}
			if (!recycled) return;
		}
		
		if (!stop_menu_displayed) {
			if (no_of_marked_recordings == 0) {
				if (thumbnail_mode) {
					if (curr_idx == (no_of_files - 1))	{
						curr_idx--;
						curr_highlight = curr_highlight == 0 ? 2 : curr_highlight - 1;
					}
				}
				else {
					// if at end of list, then move idx up
					if (no_of_files > 1)
						adjustIndexForDelete(&curr_idx, &curr_highlight, no_of_files, (InDataFilesFolder(curr_dir) ? line_count : 10));
					saveNavHistory(curr_idx, curr_highlight, FALSE);
				}
			}
			populateFiles();
			if (no_of_marked_recordings > 0) {
				resetVideoHistory();
				clearMarkedRecordings();
			}
		}
				
		TAP_Delay(100);

		if (stop_menu_displayed) {
			ChangeDirPath(curr_dir);
			TAP_Osd_Delete(region);
			TAP_Osd_Delete(region_mem);
			TAP_EnterNormal();
			stop_menu_displayed = FALSE;
		}
		ef (thumbnail_mode) {
			drawBlankThumbnailGrid();
			drawThumbnails(curr_idx - curr_highlight);
			drawThumbnailGridHeader();
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			drawDiskSpaceInfoBox();
		}
		else {
			drawFileList(FALSE, FALSE);
			copyMemoryToWindow();
			drawDiskSpaceInfoBox();
		}
		//info_box_displayed = TRUE;
		//window_displayed = FALSE;

		TAP_MemFree(info_save);
		info_save = NULL;
	}
	else {
		confirmation_box_displayed = TRUE;
		yes_selected = FALSE;
		drawConfirmationBox();
		window_displayed = FALSE;
	}
}

bool handleAssociateArt(bool album_art)
{
	TYPE_File *association_file, *file;
	word *bitmap = NULL;
	byte *bytes = NULL;
	int width, height;

	if (!mp3_playing)
		return FALSE;

	// only create association if an mp3 is playing and a photo/folder is highlighted
	if (isFolder(curr_idx)) {
		ChangeDirPath(mp3_files[current_mp3]->directory);
		if (!TAP_Hdd_Exist("Cache")) TAP_Hdd_Create("Cache", ATTR_FOLDER);
		ChangeDir("Cache");

		// create the file (delete the old one if there)
		if (album_art) {
			strcpy(file_name, "album.folder.ass");
		}
		else {
			strcpy(file_name, mp3_files[current_mp3]->file_name);
			strcat(file_name, ".folder.ass");
		}

		if (TAP_Hdd_Exist(file_name)) TAP_Hdd_Delete(file_name);
		TAP_Hdd_Create(file_name, ATTR_NORMAL);						
		association_file = TAP_Hdd_Fopen(file_name);
		if (association_file == NULL) {
			ChangeDirPath(curr_dir);
			return FALSE; 							
		}

		// finally write the folder details to the file
		strcpy(from_dir, curr_dir);
		strcat(from_dir, "/");
		strcat(from_dir, dir_info[curr_idx]->file_name);

		TAP_Hdd_Fwrite(from_dir, sizeof(char), 256, association_file);
		TAP_Hdd_Fclose(association_file);

		// display info message
		TAP_SPrint(buffer, "'%s' %s", dir_info[curr_idx]->file_name, is_now_the_art_t);
		if (album_art) {
			ExtractLastField(mp3_files[current_mp3]->directory, buffer3);
			TAP_SPrint(buffer2, "%s '%s'", for_the_album_t, buffer3+1);
		}
		else {
			TAP_SPrint(buffer2, "%s '%s'", for_the_tune_t, mp3_files[current_mp3]->file_name);
		}
		drawInfoBox(association_created_t, buffer, buffer2, TRUE, TRUE);
		info_box_displayed = TRUE;
		window_displayed = FALSE;

		ChangeDirPath(curr_dir);
		return TRUE;
	}

	if (isPhoto(dir_info[curr_idx]->file_name)) {
		file = getPhotoCache(dir_info[curr_idx]->file_name, TRUE);
		if (file == NULL) {
			ChangeDirPath(curr_dir);
			return FALSE; 							
		}

		TAP_Hdd_Fread(&width, sizeof(int), 1, file);
		TAP_Hdd_Fread(&height, sizeof(int), 1, file);
		TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, file);
		TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, file);
		if (isGif(dir_info[curr_idx]->file_name)) {
			bytes = dlmalloc(sizeof(byte) * width * height);
			if (bytes != NULL)
				TAP_Hdd_Fread(bytes, sizeof(byte), (width * height), file);
		}
		else {
			bitmap = dlmalloc(sizeof(word) * width * height);
			if (bitmap != NULL)
				TAP_Hdd_Fread(bitmap, sizeof(word), (width * height), file);
		}
		TAP_Hdd_Fclose(file);

		if (bitmap == NULL && bytes == NULL) {
			ChangeDirPath(curr_dir);
			return FALSE; 							
		}

		// change to the mp3 directory
		ChangeDirPath(mp3_files[current_mp3]->directory);

		if (!TAP_Hdd_Exist("Cache")) TAP_Hdd_Create("Cache", ATTR_FOLDER);
		ChangeDir("Cache");

		// create the file (delete the old one if there)
		if (album_art) {
			strcpy(file_name, "album.ass");
		}
		else {
			strcpy(file_name, mp3_files[current_mp3]->file_name);
			strcat(file_name, ".ass");
		}
		if (TAP_Hdd_Exist(file_name)) TAP_Hdd_Delete(file_name);
		TAP_Hdd_Create(file_name, ATTR_NORMAL);						
		association_file = TAP_Hdd_Fopen(file_name);
		if (association_file == NULL) {
			if (isGif(dir_info[curr_idx]->file_name)) {
				dlfree(bytes);
				bytes = NULL;
			}
			else {
				dlfree(bitmap);
				bitmap = NULL;
			}
			dlmalloc_trim(0);
			ChangeDirPath(curr_dir);
			return FALSE; 							
		}

		// finally write the thumbnail bitmap to the mp3 area (basically a copy)
		TAP_Hdd_Fwrite(&width, sizeof(int), 1, association_file);
		TAP_Hdd_Fwrite(&height, sizeof(int), 1, association_file);
		TAP_Hdd_Fwrite(&bitmap_width, sizeof(int), 1, association_file);
		TAP_Hdd_Fwrite(&bitmap_height, sizeof(int), 1, association_file);
		if (isGif(dir_info[curr_idx]->file_name)) {
			TAP_Hdd_Fwrite(bytes, sizeof(byte), (width * height), association_file);
			dlfree(bytes);
			bytes = NULL;
		}
		else {
			TAP_Hdd_Fwrite(bitmap, sizeof(word), (width * height), association_file);
			dlfree(bitmap);
			bitmap = NULL;
		}
		dlmalloc_trim(0);
		TAP_Hdd_Fclose(association_file);
		
		ChangeDirPath(curr_dir);
		file = getPhotoCache(dir_info[curr_idx]->file_name, FALSE);
		if (file == NULL) {
			ChangeDirPath(curr_dir);
			return FALSE; 							
		}

		TAP_Hdd_Fread(&width, sizeof(int), 1, file);
		TAP_Hdd_Fread(&height, sizeof(int), 1, file);
		TAP_Hdd_Fread(&bitmap_width, sizeof(int), 1, file);
		TAP_Hdd_Fread(&bitmap_height, sizeof(int), 1, file);
		if (isGif(dir_info[curr_idx]->file_name)) {
			bytes = dlmalloc(sizeof(byte) * width * height);
			if (bytes != NULL)
				TAP_Hdd_Fread(bytes, sizeof(byte), (width * height), file);
		}
		else {
			bitmap = dlmalloc(sizeof(word) * width * height);
			if (bitmap != NULL)
				TAP_Hdd_Fread(bitmap, sizeof(word), (width * height), file);
		}
		TAP_Hdd_Fclose(file);

		if (bitmap == NULL && bytes == NULL) {
			ChangeDirPath(curr_dir);
			return FALSE; 							
		}

		// change to the mp3 directory
		ChangeDirPath(mp3_files[current_mp3]->directory);

		if (!TAP_Hdd_Exist("Cache")) TAP_Hdd_Create("Cache", ATTR_FOLDER);
		ChangeDir("Cache");

		// create the file (delete the old one if there)
		if (album_art) {
			strcpy(file_name, "album.ass.cache");
		}
		else {
			strcpy(file_name, mp3_files[current_mp3]->file_name);
			strcat(file_name, ".ass.cache");
		}
		if (TAP_Hdd_Exist(file_name)) TAP_Hdd_Delete(file_name);
		TAP_Hdd_Create(file_name, ATTR_NORMAL);						
		association_file = TAP_Hdd_Fopen(file_name);
		
		// if can't create then return to current directory
		if (association_file == NULL) {
			if (isGif(dir_info[curr_idx]->file_name)) {
				dlfree(bytes);
				bytes = NULL;
			}
			else {
				dlfree(bitmap);
				bitmap = NULL;
			}
			dlmalloc_trim(0);
			ChangeDirPath(curr_dir);
			return FALSE; 							
		}

		// finally write the full size bitmap to the mp3 area (basically a copy)
		TAP_Hdd_Fwrite(&width, sizeof(int), 1, association_file);
		TAP_Hdd_Fwrite(&height, sizeof(int), 1, association_file);
		TAP_Hdd_Fwrite(&bitmap_width, sizeof(int), 1, association_file);
		TAP_Hdd_Fwrite(&bitmap_height, sizeof(int), 1, association_file);
		if (isGif(dir_info[curr_idx]->file_name)) {
			TAP_Hdd_Fwrite(bytes, sizeof(byte), (width * height), association_file);
			dlfree(bytes);
			bytes = NULL;
		}
		else {
			TAP_Hdd_Fwrite(bitmap, sizeof(word), (width * height), association_file);
			dlfree(bitmap);
			bitmap = NULL;
		}
		dlmalloc_trim(0);
		TAP_Hdd_Fclose(association_file);

		// display info message
		TAP_SPrint(buffer, "'%s' %s", dir_info[curr_idx]->file_name, is_now_the_art_t);
		if (album_art) {
			ExtractLastField(mp3_files[current_mp3]->directory, buffer3);
			TAP_SPrint(buffer2, "%s '%s'", for_the_album_t, buffer3+1);
		}
		else {
			TAP_SPrint(buffer2, "%s '%s'", for_the_tune_t, mp3_files[current_mp3]->file_name);
		}
		drawInfoBox(association_created_t, buffer, buffer2, TRUE, TRUE);
		info_box_displayed = TRUE;
		window_displayed = FALSE;
		// return to whence we came
		ChangeDirPath(curr_dir);

		return TRUE;
	}

	return FALSE;
}

bool handleDeleteArtAssociation()
{
	char association_name[100];
	bool deleted = FALSE;

	// if an mp3 folder highlighted, delete album art, if an mp3 highlighted, delete mp3 art
	if (isMp3(dir_info[curr_idx]->file_name)) {
		if (TAP_Hdd_Exist("Cache")) {
			ChangeDir("Cache");

			// delete the association with mp3 if it is there
			strcpy(association_name, dir_info[curr_idx]->file_name);		
			strcat(association_name, ".ass");
			if (TAP_Hdd_Exist(association_name)) {
				TAP_Hdd_Delete(association_name);
				deleted = TRUE;
			}

			strcpy(association_name, dir_info[curr_idx]->file_name);		
			strcat(association_name, ".folder.ass");
			if (TAP_Hdd_Exist(association_name)) {
				TAP_Hdd_Delete(association_name);
				deleted = TRUE;
			}

			// delete the association with mp3 if it is there
			strcpy(association_name, dir_info[curr_idx]->file_name);		
			strcat(association_name, ".ass.cache");
			if (TAP_Hdd_Exist(association_name)) {
				TAP_Hdd_Delete(association_name);
			}
			ChangeDir("..");
		}
	}
	ef (InMp3FilesFolder(curr_dir) && dir_info[curr_idx]->folder && !isParentDirectory(dir_info[curr_idx]->file_name))
	{
		// change to the mp3 directory
		ChangeDir(dir_info[curr_idx]->file_name);

		if (TAP_Hdd_Exist("Cache")) {
			ChangeDir("Cache");
			
			// delete the association with album if it is there
			if (TAP_Hdd_Exist("album.ass")) {
				TAP_Hdd_Delete("album.ass");
				deleted = TRUE;
			}

			if (TAP_Hdd_Exist("album.folder.ass")) {
				TAP_Hdd_Delete("album.folder.ass");
				deleted = TRUE;
			}

			// delete the association with album if it is there
			if (TAP_Hdd_Exist("album.ass.cache")) {
				TAP_Hdd_Delete("album.ass.cache");
			}

			ChangeDir("..");
		}

		// return to whence we came
		ChangeDir("..");
	}

	if (deleted) {
		// display info message
		TAP_SPrint(buffer, "%s %s '%s'", art_deleted_t, for_t, dir_info[curr_idx]->file_name);
		drawInfoBox(art_deleted_t, buffer, NULL, TRUE, TRUE);
		info_box_displayed = TRUE;
		window_displayed = FALSE;
		return TRUE;
	}

	return FALSE;
}

void handleRightArrowAction()
{
	if (enable_component_switching) {
		
		//if (InMp3FilesFolder(curr_dir)) {
		if (mp3_navigation) {
			saveNavHistoryOnExit();
			strcpy(curr_dir, discard_navigation_history ? default_startup_directory : saved_jpg_current_dir);
			rec_navigation = FALSE;
			mp3_navigation = FALSE;
			pf_navigation = FALSE;
			jpg_navigation = TRUE;
		}
		//ef (InFolder(curr_dir, default_startup_directory) && strcmp(curr_dir, "/ProgramFiles") != 0) {
		ef (jpg_navigation) {
			saveNavHistoryOnExit();
			strcpy(curr_dir, discard_navigation_history ? "/ProgramFiles" : saved_pf_current_dir);
			rec_navigation = FALSE;
			mp3_navigation = FALSE;
			jpg_navigation = FALSE;
			pf_navigation = TRUE;
		}
		else {
			saveNavHistoryOnExit();
			strcpy(curr_dir, discard_navigation_history ? "/DataFiles" : saved_rec_current_dir);
			rec_navigation = TRUE;
			mp3_navigation = FALSE;
			jpg_navigation = FALSE;
			pf_navigation = FALSE;
		}

		restoreNavHistory();
		ChangeDirPath(curr_dir);
		populateFiles();
		if (IsDataFilesFolder(curr_dir))
			highlightRecording();
		drawFileList(FALSE, FALSE);

		copyMemoryToWindow();
		drawMp3InfoBox();
		drawDiskSpaceInfoBox();
	}
	else {
		handleChangeDirKey();
	}
}

void handleLeftArrowAction()
{
	if (enable_component_switching == 1) {
		
		//if (InMp3FilesFolder(curr_dir)) {
		if (mp3_navigation) {
			saveNavHistoryOnExit();
			strcpy(curr_dir, discard_navigation_history ? "/DataFiles" : saved_rec_current_dir);
			rec_navigation = TRUE;
			mp3_navigation = FALSE;
			jpg_navigation = FALSE;
			pf_navigation = FALSE;
		}
		//ef (!InFolder(curr_dir, default_startup_directory)) {
		ef (pf_navigation) {
			saveNavHistoryOnExit();
			strcpy(curr_dir, discard_navigation_history ? default_startup_directory : saved_jpg_current_dir);
			rec_navigation = FALSE;
			mp3_navigation = FALSE;
			jpg_navigation = TRUE;
			pf_navigation = FALSE;
		}
		else {
			saveNavHistoryOnExit();
			strcpy(curr_dir, discard_navigation_history ? "/MP3" : saved_mp3_current_dir);
			rec_navigation = FALSE;
			mp3_navigation = TRUE;
			jpg_navigation = FALSE;	
			pf_navigation = FALSE;
		}

		restoreNavHistory();
		ChangeDirPath(curr_dir);
		populateFiles();
		if (IsDataFilesFolder(curr_dir))
			highlightRecording();
		drawFileList(FALSE, FALSE);
		
		copyMemoryToWindow();
		drawMp3InfoBox();
		drawDiskSpaceInfoBox();
	}
	else {
		handleReturnToParentKey();
	}
}

void drawLetterBox(dword param1)
{
	word string_length, indent;

	switch (param1) {
		case RKEY_2: 
			letter_idx = (saved_letter == param1) ? (letter_idx + 1) % 3 : 0;
			strcpy(lookup_letter, letter_idx == 0 ? "A" : letter_idx == 1 ? "B" : "C"); 
			break;
		case RKEY_3: 
			letter_idx = (saved_letter == param1) ? (letter_idx + 1) % 3 : 0;
			strcpy(lookup_letter, letter_idx == 0 ? "D" : letter_idx == 1 ? "E" : "F"); 
			break;
		case RKEY_4: 
			letter_idx = (saved_letter == param1) ? (letter_idx + 1) % 3 : 0;
			strcpy(lookup_letter, letter_idx == 0 ? "G" : letter_idx == 1 ? "H" : "I"); 
			break;
		case RKEY_5: 
			letter_idx = (saved_letter == param1) ? (letter_idx + 1) % 3 : 0;
			strcpy(lookup_letter, letter_idx == 0 ? "J" : letter_idx == 1 ? "K" : "L"); 
			break;
		case RKEY_6: 
			letter_idx = (saved_letter == param1) ? (letter_idx + 1) % 3 : 0;
			strcpy(lookup_letter, letter_idx == 0 ? "M" : letter_idx == 1 ? "N" : "O"); 
			break;
		case RKEY_7: 
			letter_idx = (saved_letter == param1) ? (letter_idx + 1) % 4 : 0;
			strcpy(lookup_letter, letter_idx == 0 ? "P" : letter_idx == 1 ? "Q" : letter_idx == 2 ? "R" : "S"); 
			break;
		case RKEY_8: 
			letter_idx = (saved_letter == param1) ? (letter_idx + 1) % 3 : 0;
			strcpy(lookup_letter, letter_idx == 0 ? "T" : letter_idx == 1 ? "U" : "V");  
			break;
		case RKEY_9: 
			letter_idx = (saved_letter == param1) ? (letter_idx + 1) % 4 : 0;
			strcpy(lookup_letter, letter_idx == 0 ? "W" : letter_idx == 1 ? "X" : letter_idx == 2 ? "Y" : "Z"); 
			break;
	}
	saved_letter = param1;

	if (!processing_save)
		processing_save = TAP_Osd_SaveBox(region, offset_x+40-2, thumbnail_mode ? thumbnail_offset_y+1-2 : offset_y-10-2, 30+4, 30+4);
	TAP_Osd_DrawRectangle(region, offset_x+40+1, thumbnail_mode ? thumbnail_offset_y+2 : offset_y-8, 28, 26, 2, frame_colour);
	TAP_Osd_FillBox(region, offset_x+40+1+2, thumbnail_mode ? thumbnail_offset_y+2+2 : offset_y-8+2, 28-4, 26-4, COLOR_Red);
	string_length = getWidth(lookup_letter, FNT_Size_1926);
	indent = offset_x+40+1 + (((28) - string_length) / 2);
	drawText(region, indent, thumbnail_mode ? thumbnail_offset_y+2+1 : offset_y-8+1, -1, lookup_letter, COLOR_White, COLOR_None, FNT_Size_1926);
	letter_tick = TAP_GetTick();
	skip_to_letter = TRUE;
}

bool useNumbersToSearch()
{
	return use_numbers_to_search && InMp3FilesFolder(curr_dir);
}

dword handleFileListEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_Filelist:

			handleExitKey(TRUE, TRUE);
			return display_toppy_archive ? param1 : 0;

		case RKEY_Menu:

			handleMenuKey();
			//enable_recycle_bin = TRUE;
			//handleRecycleBinKey();
			//handleKeyboardKey();
			//drawSkinEditorHelpViewer();
			//handleAutoDeleteListKey();
			//handleSearchKey();
			//handleMoveKey();
			break;

		case RKEY_Options:

			sort_options = FALSE;
			handleOptionsListKey();
			break;

		case RKEY_Guide:

			handlePlaylistKey();
			break;

		case RKEY_Recall:

			handleToggleKey();
			break;

		case RKEY_TvSat:
			
			handleStartMP3ModeKey();
			break;

		case RKEY_Slow:
			
			handleSearchKey();
			break;

		case RKEY_Info:
			
			handleInfoKey();
			break;

		case RKEY_Text:

			handleHelpKey();
			break;

		case RKEY_Record :

			handleAppendToPlaylistKey();
			drawFile(curr_highlight, curr_idx);
			copyMemoryToWindow();
			break;

		case RKEY_Red:
		
			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:

			handleChangeTrack(TRUE);
			break;

		case RKEY_Green:

			handleNewFolderKey();
			break;

		case RKEY_Yellow:

			handleMoveKey();
			break;
		
		case RKEY_Pause:

			handleReorderKey();
			break;
		
		case RKEY_Ok :

			handleOkKey();
			break;

		case RKEY_Play :
			
			handlePlayKey();
			break;

		case RKEY_White:

			handleDeleteFileKey();
			break;

		case RKEY_Stop:

			handleStopKey(TRUE);
			break;
			
		case RKEY_Pip:
			if (show_all_files_activation_key == RKEY_Pip) {
				show_all_files = show_all_files ? FALSE : TRUE;
				saveNavHistory(0, 0, FALSE);
				populateFiles();
				drawFileList(FALSE, FALSE);
				copyMemoryToWindow();
			}
			break;

		case RKEY_PipSwap: 
			if (show_all_files_activation_key == RKEY_PipSwap) {
				show_all_files = show_all_files ? FALSE : TRUE;
				saveNavHistory(0, 0, FALSE);
				populateFiles();
				drawFileList(FALSE, FALSE);
				copyMemoryToWindow();
			}
			break;

		case RKEY_Exit :

			handleExitKey(TRUE, TRUE);
			break;

		case RKEY_1:

			if (InMp3FilesFolder(curr_dir))
				handleDeleteArtAssociation();
			else
				handleAssociateArt(TRUE);
			break;

		case RKEY_2:
			
			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleAssociateArt(FALSE);
			break;

		case RKEY_3:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleDeleteCachedPhoto();
			break;

		case RKEY_4:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleDeleteAllCachedPhotos();
			break;

		case RKEY_5:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			break;

		case RKEY_6:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleRecycleBinKey();
			break;

		case RKEY_7:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleRenameKey();
			break;

		case RKEY_8:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleNewFolderKey();
			break;

		case RKEY_9:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleMoveKey();
			break;

		case RKEY_0:

			handleReorderKey();
			break;

		case RKEY_VolUp :
			
			if (page_with_arrows)
				pageForwardFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			else
				handleRightArrowAction();
			break;

		case RKEY_VolDown :

			if (page_with_arrows)
				pageBackFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			else
				handleLeftArrowAction();
			break;

		case RKEY_ChUp :

			shuffleUpFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;
		
		case RKEY_Rewind :

			if (page_with_arrows)
				handleLeftArrowAction();
			else
				pageBackFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);

			break;

		case RKEY_Forward :
			
			if (page_with_arrows)
				handleRightArrowAction();
			else
				pageForwardFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, 10);
			break;
	}

	return 0;
}

void handleRightArrowRecAction()
{
	if (enable_component_switching) {
		saveNavHistoryOnExit();
		strcpy(curr_dir, discard_navigation_history ? "/MP3" : saved_mp3_current_dir);
		rec_navigation = FALSE;
		mp3_navigation = TRUE;
		jpg_navigation = FALSE;
		pf_navigation = FALSE;

		restoreNavHistory();
		ChangeDirPath(curr_dir);
		populateFiles();
		drawFileList(FALSE, FALSE);
		
		copyMemoryToWindow();
		drawMp3InfoBox();
		drawDiskSpaceInfoBox();
	}
	else {
		handleChangeDirKey();
	}
}

void handleLeftArrowRecAction()
{
	if (enable_component_switching == 1) {
		saveNavHistoryOnExit();
		strcpy(curr_dir, discard_navigation_history ? "/ProgramFiles" : saved_pf_current_dir);
		rec_navigation = FALSE;
		mp3_navigation = FALSE;
		jpg_navigation = FALSE;
		pf_navigation = TRUE;

		restoreNavHistory();
		ChangeDirPath(curr_dir);
		populateFiles();
		drawFileList(FALSE, FALSE);

		copyMemoryToWindow();
		drawMp3InfoBox();
		drawDiskSpaceInfoBox();
	}
	else {
		handleReturnToParentKey();
	}
}

dword handleRecFileListEventKey(dword param1)
{
	int found_idx = -1;

	switch (param1)
	{
		case RKEY_Filelist:

			handleExitKey(TRUE, TRUE);
			return display_toppy_archive ? param1 : 0;

		case RKEY_Menu:

			handleMenuKey();
			break;

		case RKEY_Options:

			sort_options = FALSE;
			handleOptionsListKey();
			break;

		case RKEY_Guide:

			handleBrowseScenesKey();
			break;

		case RKEY_Recall:

			handleToggleKey();
			break;

		case RKEY_Record:
			
			handleRecordKey();
			break;

		case RKEY_TvSat:
			
			handleAutoDeleteListKey();
			break;

		case RKEY_TvRadio:
			
			handleMarkFile(dir_info[curr_idx]->file_name, curr_dir, dir_info[curr_idx]->start_cluster, dir_info[curr_idx]->mjd, dir_info[curr_idx]->hour, dir_info[curr_idx]->min, dir_info[curr_idx]->size, dir_info[curr_idx]->locked);
			if (curr_idx < (no_of_files - 1))
				shuffleDownFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, line_count);
			break;

		case RKEY_Slow:
			
			if (no_of_files == 0)
				break;

			if (isRec(dir_info[curr_idx]->file_name)) {
				found_idx = existsInAutoDeleteList(dir_info[curr_idx]->sort_name);
				if (found_idx == -1) {
					appendToAutoDeleteList(dir_info[curr_idx]->sort_name);
					auto_delete_idx = no_of_auto_deletes - 1;
					new_auto_delete = TRUE;
				}
				else {
					auto_delete_idx = found_idx;
					copyAutoDeleteEntry(auto_delete_idx);
					new_auto_delete = FALSE;
				}
				
				handleAutoDeleteUpdateKey();
			}

			break;

		case RKEY_Info:

			handleRecInfoKey();
			break;

		case RKEY_Text:

			handleHelpKey();
			break;

		case RKEY_Red:

			handleRenameKey();
			break;

		case RKEY_Blue:

			sort_options = FALSE;
			handleOptionsListKey();
			break;

		case RKEY_Green:

			handleNewFolderKey();
			break;

		case RKEY_Yellow:

			handleMoveKey();
			break;

		case RKEY_1:

			handleCreateRecordingThumbnail(FALSE);
			break;

		case RKEY_2:

			handleCreateRecordingThumbnail(TRUE);
			break;

		case RKEY_3:

			handleDeleteRecordingThumbnail();
			break;

		case RKEY_4:

			handleDeleteAllRecordingThumbnails();
			break;

		case RKEY_5:

			//handleCreateAllRecordingThumbnails();
			break;

		case RKEY_6:

			handleRecycleBinKey();
			break;

		case RKEY_7:

			handleRenameKey();
			break;

		case RKEY_8:

			handleNewFolderKey();
			break;

		case RKEY_9:

			handleMoveKey();
			break;

		case RKEY_0:

			handleReorderKey();
			break;

		case RKEY_Ok :

			if (isRec(dir_info[curr_idx]->file_name)) {
				if (play_resumes_video)
					handlePlayKey();
				else
					handleOkKey();
			}
			else
				handleOkKey();
			break;

		case RKEY_Play :
			
			if (isRec(dir_info[curr_idx]->file_name)) {
				if (play_resumes_video == 1)
					handleOkKey();
				else
					handlePlayKey();
			}
			else
				handlePlayKey();
			break;

		case RKEY_Pause :
			
			handleReorderKey();
			break;

		case RKEY_White:

			handleDeleteFileKey();
			break;

		case RKEY_Stop:

			handleStopKey(FALSE);
			break;
		
		case RKEY_Pip: 
			if (show_all_files_activation_key == RKEY_Pip) {
				show_all_files = show_all_files ? FALSE : TRUE;
				saveNavHistory(0, 0, FALSE);
				populateFiles();
				drawFileList(FALSE, FALSE);
				copyMemoryToWindow();
			}
			break;

		case RKEY_PipSwap: 
			if (show_all_files_activation_key == RKEY_PipSwap) {
				show_all_files = show_all_files ? FALSE : TRUE;
				saveNavHistory(0, 0, FALSE);
				populateFiles();
				drawFileList(FALSE, FALSE);
				copyMemoryToWindow();
			}
			break;

		case RKEY_Exit :

			handleExitKey(TRUE, TRUE);
			break;

		case RKEY_VolUp :

			if (page_with_arrows)
				pageForwardFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, line_count);
			else
				handleRightArrowRecAction();
			break;

		case RKEY_VolDown :

			if (page_with_arrows)
				pageBackFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, line_count);
			else
				handleLeftArrowRecAction();
			break;

		case RKEY_ChUp :

			shuffleUpFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, line_count);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, line_count);
			break;
		
		case RKEY_Rewind :

			if (page_with_arrows)
				handleLeftArrowRecAction();
			else
				pageBackFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, line_count);
			break;

		case RKEY_Forward :

			if (page_with_arrows)
				handleRightArrowRecAction();
			else
				pageForwardFileList(FILE_LIST_NAVIGATION, &curr_idx, &curr_highlight, no_of_files, line_count);
			break;
	}

	return 0;
}

dword handleThumbnailEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_Filelist:

			handleExitKey(TRUE, TRUE);
			return display_toppy_archive ? param1 : 0;

		case RKEY_Menu:

			handleMenuKey();
			//handleDeleteFileKey();
			break;

		case RKEY_Guide:

			handlePlaylistKey();
			break;

		case RKEY_Options:

			sort_options = FALSE;
			handleOptionsListKey();
			break;

		case RKEY_Recall:

			handleToggleKey();
			break;

		case RKEY_TvSat:
			
			handleStartMP3ModeKey();
			break;

		case RKEY_Slow:
			
			handleSearchKey();
			break;

		case RKEY_Info:

			handleInfoKey();
			break;

		case RKEY_Text:

			handleHelpKey();
			break;

		case RKEY_Record :

			handleAppendToPlaylistKey();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_Red:
		
			handleChangeTrack(FALSE);
			break;

		case RKEY_Blue:

			handleChangeTrack(TRUE);
			break;

		case RKEY_Green:

			handleNewFolderKey();
			break;

		case RKEY_Yellow:

			handleMoveKey();
			break;
		
		case RKEY_Pause:

			handleReorderKey();
			break;
		
		case RKEY_1:

			if (InMp3FilesFolder(curr_dir))
				handleDeleteArtAssociation();
			else
				handleAssociateArt(TRUE);
			break;

		case RKEY_2:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleAssociateArt(FALSE);
			break;

		case RKEY_3:
			
			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleDeleteCachedPhoto();
			break;

		case RKEY_4:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleDeleteAllCachedPhotos();
			break;

		case RKEY_5:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			break;

		case RKEY_6:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleRecycleBinKey();
			break;

		case RKEY_7:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleRenameKey();
			break;

		case RKEY_8:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleNewFolderKey();
			break;

		case RKEY_9:

			if (useNumbersToSearch())
				drawLetterBox(param1);
			else
				handleMoveKey();
			break;

		case RKEY_0:

			handleReorderKey();
			break;

		case RKEY_ChUp :
			if (curr_idx - 3 < 0)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, no_of_files - 1, curr_idx, no_of_files - 1);
					curr_idx = no_of_files - 1;
					curr_highlight = no_of_files - 1;
				}
				else
				{
					curr_highlight = (no_of_files % 9 == 0) ? 8 : (no_of_files % 9) - 1;
					curr_idx = (no_of_files - 1);

					drawThumbnails(no_of_files - ((no_of_files % 9 == 0) ? 9 : (no_of_files % 9)));
				}
			}
			ef (curr_highlight < 3)
			{
				int start_point = curr_idx - curr_highlight - 3;
				curr_idx = curr_idx - 3;
				curr_highlight = curr_highlight;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight - 3, curr_idx, curr_idx - 3);
				curr_idx = curr_idx - 3;
				curr_highlight = curr_highlight - 3;
			}
			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_ChDown :
			if (curr_idx + 3 >= no_of_files)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, 0, curr_idx, 0);
					curr_idx = 0;
					curr_highlight = 0;
				}
				else
				{
					curr_highlight = curr_idx = 0;

					drawThumbnails(0);
				}
			}
			ef (curr_highlight >= 6)
			{
				int start_point = curr_idx - curr_highlight + 3;
				curr_idx = curr_idx + 3;
				curr_highlight = curr_highlight;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight + 3, curr_idx, curr_idx + 3);
				curr_idx = curr_idx + 3;
				curr_highlight = (curr_highlight + 3) % 9;
			}

			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_VolUp :
			if (curr_idx + 1 == no_of_files)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, 0, curr_idx, 0);
					curr_idx = 0;
					curr_highlight = 0;
				}
				else
				{
					curr_highlight = curr_idx = 0;
					drawThumbnails(0);
				}
			}
			ef (curr_highlight == 8)
			{
				int start_point = curr_idx - 5;
				curr_idx = curr_idx + 1;
				curr_highlight = 6;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight + 1, curr_idx, curr_idx + 1);
				curr_idx = curr_idx + 1;
				curr_highlight = curr_highlight + 1;
			}

			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_VolDown :
			if (curr_idx - 1 < 0)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, no_of_files - 1, curr_idx, no_of_files - 1);
					curr_idx = no_of_files - 1;
					curr_highlight = no_of_files - 1;
				}
				else
				{
					curr_highlight = (no_of_files % 9) == 0 ? 8 : (no_of_files % 9) - 1;
					curr_idx = (no_of_files - 1);
					drawThumbnails(no_of_files - ((no_of_files % 9) == 0 ? 9 : (no_of_files % 9)));
				}
			}
			ef (curr_highlight == 0)
			{
				int start_point = curr_idx - 3;
				curr_idx = curr_idx - 1;
				curr_highlight = 2;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight - 1, curr_idx, curr_idx - 1);
				curr_idx = curr_idx - 1;
				curr_highlight = curr_highlight - 1;
			}
			
			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_Rewind :
			if (curr_idx > 8)
			{
				if (curr_idx - curr_highlight < 8)
				{
					curr_idx = 0;
					curr_highlight = 0;
					drawThumbnails(0);
				}
				else
				{
					curr_idx = curr_idx - 9;
					drawThumbnails(curr_idx - curr_highlight);
				}
			}
			ef (no_of_files > 8)
			{
				curr_highlight = (no_of_files % 9 == 0) ? 8 : (no_of_files % 9) - 1;
				curr_idx = (no_of_files - 1);
				drawThumbnails(no_of_files - ((no_of_files % 9 == 0) ? 9 : (no_of_files % 9)));
			}

			// populate the footer box
			drawThumbnailGridFooter();
			copyMemoryToWindow();
			break;

		case RKEY_Forward :
			if (curr_idx < (no_of_files - 9))
			{
				curr_idx = curr_idx + 9;
				drawThumbnails(curr_idx - curr_highlight);
			}
			ef (no_of_files > 8)
			{
				curr_highlight = 0;
				curr_idx = 0;
				drawThumbnails(0);
			}

			// populate the footer box
			drawThumbnailGridFooter();
			copyMemoryToWindow();
			break;

		case RKEY_Ok :

			// if its a directory then delete window and start displaying piccies
			handleOkKey();
			break;

		case RKEY_Play :
			
			handlePlayKey();
			break;

		case RKEY_White:

			handleDeleteFileKey();
			break;

		case RKEY_Stop:

			handleStopKey(TRUE);
			break;

		case RKEY_Exit :
			
			// delete OSD and return Toppy to normal state
			handleExitKey(TRUE, TRUE);
			break;
	}

	return 0;
}

dword handleSceneEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_Menu:

			handleMenuKey();
			break;

		case RKEY_Ok :
		case RKEY_Play :

			handleOkKey();
			break;

		case RKEY_Exit :
		case RKEY_Guide :
			
			// return to file list
			if (write_log) if (verbose) logText("Exit scenes", FALSE);
			recreateWindow();
			scenes_displayed = FALSE;
			saved_scene_idx = 0;
			ChangeDirPath(curr_dir);
			populateFiles();

			if (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
			}
			else {
				drawFileList(TRUE, FALSE);
				drawMp3InfoBox();
			}
			copyMemoryToWindow();
			drawDiskSpaceInfoBox();
			window_displayed = TRUE;
			break;

		case RKEY_ChUp :
			if (curr_idx - 3 < 0)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, no_of_files - 1, curr_idx, no_of_files - 1);
					curr_idx = no_of_files - 1;
					curr_highlight = no_of_files - 1;
				}
				else
				{
					curr_highlight = (no_of_files % 9 == 0) ? 8 : (no_of_files % 9) - 1;
					curr_idx = (no_of_files - 1);

					drawThumbnails(no_of_files - ((no_of_files % 9 == 0) ? 9 : (no_of_files % 9)));
				}
			}
			ef (curr_highlight < 3)
			{
				int start_point = curr_idx - curr_highlight - 3;
				curr_idx = curr_idx - 3;
				curr_highlight = curr_highlight;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight - 3, curr_idx, curr_idx - 3);
				curr_idx = curr_idx - 3;
				curr_highlight = curr_highlight - 3;
			}
			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_ChDown :
			if (curr_idx + 3 >= no_of_files)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, 0, curr_idx, 0);
					curr_idx = 0;
					curr_highlight = 0;
				}
				else
				{
					curr_highlight = curr_idx = 0;

					drawThumbnails(0);
				}
			}
			ef (curr_highlight >= 6)
			{
				int start_point = curr_idx - curr_highlight + 3;
				curr_idx = curr_idx + 3;
				curr_highlight = curr_highlight;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight + 3, curr_idx, curr_idx + 3);
				curr_idx = curr_idx + 3;
				curr_highlight = (curr_highlight + 3) % 9;
			}

			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_VolUp :
			if (curr_idx + 1 == no_of_files)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, 0, curr_idx, 0);
					curr_idx = 0;
					curr_highlight = 0;
				}
				else
				{
					curr_highlight = curr_idx = 0;
					drawThumbnails(0);
				}
			}
			ef (curr_highlight == 8)
			{
				int start_point = curr_idx - 5;
				curr_idx = curr_idx + 1;
				curr_highlight = 6;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight + 1, curr_idx, curr_idx + 1);
				curr_idx = curr_idx + 1;
				curr_highlight = curr_highlight + 1;
			}

			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_VolDown :
			if (curr_idx - 1 < 0)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, no_of_files - 1, curr_idx, no_of_files - 1);
					curr_idx = no_of_files - 1;
					curr_highlight = no_of_files - 1;
				}
				else
				{
					curr_highlight = (no_of_files % 9) == 0 ? 8 : (no_of_files % 9) - 1;
					curr_idx = (no_of_files - 1);
					drawThumbnails(no_of_files - ((no_of_files % 9) == 0 ? 9 : (no_of_files % 9)));
				}
			}
			ef (curr_highlight == 0)
			{
				int start_point = curr_idx - 3;
				curr_idx = curr_idx - 1;
				curr_highlight = 2;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight - 1, curr_idx, curr_idx - 1);
				curr_idx = curr_idx - 1;
				curr_highlight = curr_highlight - 1;
			}
			
			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_Rewind :
			if (curr_idx > 8)
			{
				if (curr_idx - curr_highlight < 8)
				{
					curr_idx = 0;
					curr_highlight = 0;
					drawThumbnails(0);
				}
				else
				{
					curr_idx = curr_idx - 9;
					drawThumbnails(curr_idx - curr_highlight);
				}
			}
			ef (no_of_files > 8)
			{
				curr_highlight = (no_of_files % 9 == 0) ? 8 : (no_of_files % 9) - 1;
				curr_idx = (no_of_files - 1);
				drawThumbnails(no_of_files - ((no_of_files % 9 == 0) ? 9 : (no_of_files % 9)));
			}

			// populate the footer box
			drawThumbnailGridFooter();
			copyMemoryToWindow();
			break;

		case RKEY_Forward :
			if (curr_idx < (no_of_files - 9))
			{
				curr_idx = curr_idx + 9;
				drawThumbnails(curr_idx - curr_highlight);
			}
			ef (no_of_files > 8)
			{
				curr_highlight = 0;
				curr_idx = 0;
				drawThumbnails(0);
			}

			// populate the footer box
			drawThumbnailGridFooter();
			copyMemoryToWindow();
			break;
	}

	return 0;
}

void doRename(char *old_name, char *new_name, bool rename_new_folder, bool folder)
{
#ifndef	WIN32
	int i;

	if (rename_new_folder) {
		// first create the new folder, then highlight it
		TAP_Hdd_Create(new_name, ATTR_FOLDER);
		populateFiles();
	}
	else {
		char local_old_name[100];
		char local_new_name[100];

		// rename the file
		i = TAP_Hdd_Rename(old_name, new_name);

		// if successful, then also rename any thumbnail, scenes, cache, association
		if (i == 0) {
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename successful");
			if (write_log) if (verbose) logText(log_buffer, FALSE);

			// rename any progress data for this rec
			if (isRec(old_name) || isRec(new_name)) {
				TYPE_File *rec_file;
				rec_file = TAP_Hdd_Fopen(new_name);
				if (rec_file != NULL) {
					if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename progress data with new name %s", new_name);
					if (write_log) if (verbose) logText(log_buffer, FALSE);
					renameProgressData(rec_file, old_name, new_name);
					TAP_Hdd_Fclose(rec_file);
				}

				updateHeader(old_name, new_name, curr_dir, curr_dir);
			}
			ef (folder && InDataFilesFolder(curr_dir)) {
				strcpy(temp, curr_dir); strcpy(temp2, curr_dir);
				strcat(temp, "/"); strcat(temp2, "/");
				strcat(temp, old_name); strcat(temp2, new_name);
				updateHeaderForDir(temp, temp2);
			}

			// rename associated files
			if (isPhoto(old_name) || isMp3(old_name) || isRec(old_name)
					|| isPhoto(new_name) || isMp3(new_name) || isRec(new_name)) {
				if (TAP_Hdd_Exist("Cache")) {
					TYPE_File *first_scene = NULL;
					int no_of_scenes = 0;
					ChangeDir("Cache");

					// construct old and new name and rename thumnail
					strcpy(local_old_name, old_name); strcat(local_old_name, ".tn");
					strcpy(local_new_name, new_name); strcat(local_new_name, ".tn");
					if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename thumbnail %s to %s", local_old_name, local_new_name);
					if (write_log) if (verbose) logText(log_buffer, FALSE);
					if (TAP_Hdd_Exist(local_old_name)) TAP_Hdd_Rename(local_old_name, local_new_name);

					// construct old and new name and rename cache
					strcpy(local_old_name, old_name); strcat(local_old_name, ".cache");
					strcpy(local_new_name, new_name); strcat(local_new_name, ".cache");
					if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename cache %s to %s", local_old_name, local_new_name);
					if (write_log) if (verbose) logText(log_buffer, FALSE);
					if (TAP_Hdd_Exist(local_old_name)) TAP_Hdd_Rename(local_old_name, local_new_name);

					// construct old and new name and rename association
					strcpy(local_old_name, old_name); strcat(local_old_name, ".ass");
					strcpy(local_new_name, new_name); strcat(local_new_name, ".ass");
					if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename association %s to %s", local_old_name, local_new_name);
					if (write_log) if (verbose) logText(log_buffer, FALSE);
					if (TAP_Hdd_Exist(local_old_name)) TAP_Hdd_Rename(local_old_name, local_new_name);

					// scenes 
					TAP_SPrint(local_old_name, "%s.tn.1", old_name);
					first_scene = TAP_Hdd_Fopen(local_old_name);
					if (first_scene != NULL) {
						TAP_Hdd_Fread(&no_of_scenes, sizeof(int), 1, first_scene);
						TAP_Hdd_Fclose(first_scene);
					}

					for (i = 1; i <= no_of_scenes; i++) {
						TAP_SPrint(local_old_name, "%s.tn.%d", old_name, i);
						TAP_SPrint(local_new_name, "%s.tn.%d", new_name, i);
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Rename scene %s to %s", local_old_name, local_new_name);
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						TAP_Hdd_Rename(local_old_name, local_new_name);
					}

					ChangeDir("..");
				}
			}

			// rename any dimensions
			if (isPhoto(old_name) || isPhoto(new_name)) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Check %d dimensions", no_of_dimensions);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				for (i = 0; i < no_of_dimensions; i++) {
					if (strcmp(dimensions[i]->file_name, old_name) == 0) {
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Copy %s over %s", new_name, dimensions[i]->file_name);
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						strcpy(dimensions[i]->file_name, new_name);
						saveDimensions();
						break;
					}
				}
			}
		}
	}
#endif
}

void clearCharacter()
{
	cursor_pointer = 0;
	memset(keyboard_name, '\0', 100);
	TAP_Osd_FillBox(region_mem, X, Y+H-120-39, W, 39, keyboard_idx == 99 ? COLOR_Black : RGB8888(61,61,61));
	drawText(region_mem, X+5, Y+H-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);

	drawKeys();
	moveKeyboardHighlight(keyboard_idx, -1);
}

void deleteCharacter()
{
	word i;

	if (cursor_pointer > 0) {
		int finish_idx = strlen(keyboard_name)-1;
		if (cursor_pointer != strlen(keyboard_name)) {
			for (i = cursor_pointer-1; i < finish_idx; i++) {
				keyboard_name[i] = keyboard_name[i+1];
			}
		}
		cursor_pointer--;
		keyboard_name[finish_idx] = '\0';
		TAP_Osd_FillBox(region_mem, X, Y+H-120-39, W, 39, keyboard_idx == 99 ? COLOR_Black : RGB8888(61,61,61));
		if (cursor_pointer == strlen(keyboard_name))
			drawText(region_mem, X+5, Y+H-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);
		else {
			memset(buffer, '\0', 100);
			memset(buffer2, '\0', 100);
			strncat(buffer, keyboard_name, cursor_pointer);
			strncat(buffer2, keyboard_name+cursor_pointer, strlen(keyboard_name)-cursor_pointer);
			drawText(region_mem, X+5, Y+H-120-30, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1926);
			drawText(region_mem, X+5+getWidth(buffer, FNT_Size_1926)+5, Y+H-120-30, -1, buffer2, body_text_colour, COLOR_None, FNT_Size_1926);
		}
	}

	drawKeys();
	moveKeyboardHighlight(keyboard_idx, -1);
}

void spaceCharacter()
{
	word i;

	if (cursor_pointer != strlen(keyboard_name)) {
		for (i = strlen(keyboard_name); i > cursor_pointer; i--) {
			keyboard_name[i] = keyboard_name[i-1];
		}
	}
	keyboard_name[cursor_pointer] = ' ';
	cursor_pointer++;
	TAP_Osd_FillBox(region_mem, X, Y+H-120-39, W, 39, keyboard_idx == 99 ? COLOR_Black : RGB8888(61,61,61));
	if (cursor_pointer == strlen(keyboard_name))
		drawText(region_mem, X+5, Y+H-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);
	else {
		memset(buffer, '\0', 100);
		memset(buffer2, '\0', 100);
		strncat(buffer, keyboard_name, cursor_pointer);
		strncat(buffer2, keyboard_name+cursor_pointer, strlen(keyboard_name)-cursor_pointer);
		drawText(region_mem, X+5, Y+H-120-30, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1926);
		drawText(region_mem, X+5+getWidth(buffer, FNT_Size_1926)+5, Y+H-120-30, -1, buffer2, body_text_colour, COLOR_None, FNT_Size_1926);
	}

	drawKeys();
	moveKeyboardHighlight(keyboard_idx, -1);
}

void shiftCase()
{
	keyboard_case = (keyboard_case + 1) % 4;
	drawKeyboardHeader();	
	drawKeys();
	moveKeyboardHighlight(keyboard_idx, -1);
}

void saveKeyboard()
{
	word i;

	if (strlen(keyboard_name) > 0) {
		if (!new_folder && !auto_delete_update_displayed && !auto_deletes_displayed && !search_mp3s) {
			if (playlist_displayed) {
				if (photo_playlist_mode) {
					strcpy(photo_playlist_name, keyboard_name);
					strcat(keyboard_name, ".ppl");
				}
				else {
					strcpy(mp3_playlist_name, keyboard_name);
					strcat(keyboard_name, ".mpl");
				}
			}
			ef (isRec(dir_info[curr_idx]->file_name))
				strcat(keyboard_name, ".rec");
			ef (isMp3(dir_info[curr_idx]->file_name))
				strcat(keyboard_name, ".mp3");
			ef (isJpg(dir_info[curr_idx]->file_name))
				strcat(keyboard_name, ".jpg");
			ef (isBmp(dir_info[curr_idx]->file_name))
				strcat(keyboard_name, ".bmp");
			ef (isGif(dir_info[curr_idx]->file_name))
				strcat(keyboard_name, ".gif");
			ef (isSkin(dir_info[curr_idx]->file_name))
				strcat(keyboard_name, ".mcf");
		}

		if (skin_editor_displayed) {
			TAP_SPrint(buffer, "%s %s '%s'", saving_t, skin_t, keyboard_name);
			drawInfoBox(saving_t, buffer, NULL, FALSE, TRUE);

			loadSkinElementsFromMemory(no_of_skin_elements, W, 30);
			writeSkinFromMemory(keyboard_name, no_of_skin_elements);
			strcpy(skin_file_name, keyboard_name);

			TAP_Delay(50);
			TAP_Osd_RestoreBox(region_mem, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
			TAP_Osd_RestoreBox(region, X+60-10, Y+120-10, W-120+20, 150+20, info_save);
			TAP_MemFree(info_save);
			info_save = NULL;
		}
		ef (auto_delete_update_displayed || auto_deletes_displayed) {
			strcpy(auto_delete_list[auto_delete_idx]->file_name, keyboard_name);
		}
		ef (search_mp3s) {
			word i;
			processing_save = TAP_Osd_SaveBox(region, 0, 0, 720, 576);
						
			if (preload_mp3_headers) {
				if (!mp3s_loaded) {
					loadMp3Headers(TRUE, FALSE, TRUE);
					ChangeDirPath(curr_dir);
				}
				drawProcessingMessage(region, searching_for_mp3s_t, FALSE, FALSE, TRUE);
				for (i = 0; i < no_of_mp3_headers; i++)
					checkMp3Match(all_mp3_headers[i]);
			}
			else {
				drawProcessingMessage(region, searching_for_mp3s_t, FALSE, FALSE, TRUE);
				parseAllFiles(LOAD_SEARCH_MP3S, 0, TRUE);
			}

			saveNamedPlaylistFromKnown(FALSE, "mp3.pl", curr_dir);
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, processing_save);
			TAP_MemFree(processing_save);
			processing_save = NULL;
		}
		ef (playlist_displayed)
			saveNamedPlaylist(photo_playlist_mode, keyboard_name);
		else{
			doRename(dir_info[curr_idx]->file_name, keyboard_name, new_folder, dir_info[curr_idx]->folder);
			
			if (!new_folder) {
				// now safe to copy the new name over the old name
				dlfree(dir_info[curr_idx]->file_name); dir_info[curr_idx]->file_name = dlmalloc(strlen(keyboard_name)+1);
				dlfree(dir_info[curr_idx]->sort_name); dir_info[curr_idx]->sort_name = dlmalloc(strlen(keyboard_name)+2);

				strcpy(dir_info[curr_idx]->file_name, keyboard_name);
				FormatSortName(dir_info[curr_idx]->sort_name, dir_info[curr_idx]->file_name);
			}

			// reorder and reset current idx
			qsort(dir_info, no_of_files, sizeof(dir_info[0]), compareFiles);
			for (i = 0; i < no_of_files; i++) {
				if (strcmp(dir_info[i]->file_name, keyboard_name) == 0) {
					saveNavHistory(i, -1, TRUE);
					break;
				}
			}
		}

		if (skin_editor_displayed) {
			drawSkinEditor(TRUE);
			copyMemoryToWindow();
		}
		ef (auto_delete_update_displayed || auto_deletes_displayed) {
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, keyboard_save);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, keyboard_save);
			if (!auto_delete_update_displayed)
				handleAutoDeleteUpdateKey();
			else {
				drawAutoDeleteUpdateBoxLines();
				copyMemoryToRecInfoViewer();
			}
		}
		ef (search_mp3s) {
			if (playlist_displayed) {
				no_of_files = no_of_playlist_mp3s;
				saved_playlist_idx = 0;
				saved_playlist_highlight = 0;
				drawPlaylist(TRUE);
				copyMemoryToWindow();
			}
			else {
				handlePlaylistKey();
			}
		}
		ef (playlist_displayed) {
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, keyboard_save);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, keyboard_save);
		}
		ef (thumbnail_mode) {
			drawThumbnailGrid(FALSE);
			copyMemoryToWindow();
		}
		else {
			drawFileList(TRUE, FALSE);
			drawMp3InfoBox();
			copyMemoryToWindow();
		}
		drawDiskSpaceInfoBox();
		TAP_MemFree(keyboard_save);
		search_mp3s = FALSE;
		keyboard_save = NULL;
		keyboard_displayed = FALSE;
		window_displayed = TRUE;
	}
}

void handleLetterKey()
{
	word i;

	if (cursor_pointer != strlen(keyboard_name)) {
		for (i = strlen(keyboard_name); i > cursor_pointer; i--) {
			keyboard_name[i] = keyboard_name[i-1];
		}
	}
	//if (keyboard_case == KEYBOARD_AUTO && cursor_pointer > 0 && keyboard_name[cursor_pointer-1] != ' ')
	//	keyboard_name[cursor_pointer] = keyboard_data[keyboard_idx] + 32;
	//else
		keyboard_name[cursor_pointer] = keyboard_data[keyboard_idx];
	cursor_pointer++;

	drawKeys();
	moveKeyboardHighlight(keyboard_idx, -1);

	TAP_Osd_FillBox(region_mem, X, Y+H-120-39, W, 39, RGB8888(61,61,61));
	if (cursor_pointer == strlen(keyboard_name))
		drawText(region_mem, X+5, Y+H-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);
	else {
		memset(buffer, '\0', 100);
		memset(buffer2, '\0', 100);
		strncat(buffer, keyboard_name, cursor_pointer);
		strncat(buffer2, keyboard_name+cursor_pointer, strlen(keyboard_name)-cursor_pointer);
		drawText(region_mem, X+5, Y+H-120-30, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1926);
		drawText(region_mem, X+5+getWidth(buffer, FNT_Size_1926)+5, Y+H-120-30, -1, buffer2, body_text_colour, COLOR_None, FNT_Size_1926);
	}
}

void moveCursorBack()
{
	// cursor back
	if (cursor_pointer > 0) cursor_pointer--;
	TAP_Osd_FillBox(region_mem, X, Y+H-120-39, W, 39, keyboard_idx == 99 ? COLOR_Black : RGB8888(61,61,61));
	if (cursor_pointer == strlen(keyboard_name))
		drawText(region_mem, X+5, Y+H-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);
	else {
		memset(buffer, '\0', 100);
		memset(buffer2, '\0', 100);
		strncat(buffer, keyboard_name, cursor_pointer);
		strncat(buffer2, keyboard_name+cursor_pointer, strlen(keyboard_name)-cursor_pointer);
		drawText(region_mem, X+5, Y+H-120-30, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1926);
		drawText(region_mem, X+5+getWidth(buffer, FNT_Size_1926)+5, Y+H-120-30, -1, buffer2, body_text_colour, COLOR_None, FNT_Size_1926);
	}

	drawKeys();
	if (keyboard_idx != 99)
		moveKeyboardHighlight(keyboard_idx, -1);
	copyMemoryToKeyboard();
}

void moveCursorForward()
{
	// cursor forward
	if (cursor_pointer < strlen(keyboard_name)) cursor_pointer++;
	TAP_Osd_FillBox(region_mem, X, Y+H-120-39, W, 39, keyboard_idx == 99 ? COLOR_Black : RGB8888(61,61,61));
	if (cursor_pointer == strlen(keyboard_name))
		drawText(region_mem, X+5, Y+H-120-30, -1, keyboard_name, body_text_colour, COLOR_None, FNT_Size_1926);
	else {
		memset(buffer, '\0', 100);
		memset(buffer2, '\0', 100);
		strncat(buffer, keyboard_name, cursor_pointer);
		strncat(buffer2, keyboard_name+cursor_pointer, strlen(keyboard_name)-cursor_pointer);
		drawText(region_mem, X+5, Y+H-120-30, -1, buffer, body_text_colour, COLOR_None, FNT_Size_1926);
		drawText(region_mem, X+5+getWidth(buffer, FNT_Size_1926)+5, Y+H-120-30, -1, buffer2, body_text_colour, COLOR_None, FNT_Size_1926);
	}

	drawKeys();
	if (keyboard_idx != 99)
		moveKeyboardHighlight(keyboard_idx, -1);
	copyMemoryToKeyboard();
}

dword handleKeyboardEventKey(dword param1)
{
	int old_idx;

	switch (param1)
	{
		case RKEY_Ok :

			if (keyboard_idx < 26) {
				// handle a character being chosen
				handleLetterKey();
			}
			else {
				switch (keyboard_idx) {
					
					case 29:
						// CLEAR
						clearCharacter();
						break;
					
					case 30:
						// DEL
						deleteCharacter();
						break;
					
					case 31:
						// SPACE
						spaceCharacter();
						break;

					case 32:
						// SHIFT
						shiftCase();
						break;

					case 33:
						// SAVE
						saveKeyboard();
						return 0;
				}
			}
			copyMemoryToKeyboard();
			break;

		case RKEY_Record:

			// save shortcut
			saveKeyboard();
			break;

		case RKEY_Pause:

			// shift shortcut
			shiftCase();
			copyMemoryToKeyboard();
			break;

		case RKEY_Forward:

			// space shortcut
			spaceCharacter();
			copyMemoryToKeyboard();
			break;

		case RKEY_Rewind:

			// delete shortcut
			deleteCharacter();
			copyMemoryToKeyboard();
			break;

		case RKEY_White:

			// clear shortcut
			clearCharacter();
			copyMemoryToKeyboard();
			break;

#ifdef WIN32
		case RKEY_Menu:
#endif
		case RKEY_Red:

			moveCursorBack();
			break;

#ifdef WIN32
		case RKEY_Recall:
#endif
		case RKEY_Blue:

			moveCursorForward();
			break;

		case RKEY_Exit :
	
			// return to file list
			if (write_log) if (verbose) logText("Exit keyboard", FALSE);

			if (skin_editor_displayed || playlist_displayed || search_mp3s) {
				TAP_Osd_RestoreBox(region, 0, 0, 720, 576, keyboard_save);
				TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, keyboard_save);
			}
			ef (auto_delete_update_displayed || auto_deletes_displayed) {
				TAP_Osd_RestoreBox(region, 0, 0, 720, 576, keyboard_save);
				TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, keyboard_save);

				if (new_auto_delete && !auto_delete_update_displayed) {
					rollbackAutoDeleteList();
					auto_delete_idx = saved_auto_delete_idx; auto_delete_highlight = saved_auto_delete_highlight;
				}
			}
			ef (thumbnail_mode) {
				drawThumbnailGrid(FALSE);
				copyMemoryToWindow();
			}
			else {
				drawFileList(TRUE, TRUE);
				drawMp3InfoBox();
				copyMemoryToWindow();
			}
			drawDiskSpaceInfoBox();
			TAP_MemFree(keyboard_save);
			keyboard_save = NULL;
			search_mp3s = FALSE;
			keyboard_displayed = FALSE;
			window_displayed = TRUE;
			break;

		case RKEY_ChUp :
			
			old_idx = keyboard_idx;
			//keyboard_idx = (keyboard_idx - 9) < 0 ? (35 + (keyboard_idx-9+1)) : keyboard_idx - 9;
			if (keyboard_idx == 99)
				keyboard_idx = 36 - (9 - keyboard_offset);
			else
				keyboard_idx = (keyboard_idx - 9 < 0) ? 99 : keyboard_idx - 9;
			moveKeyboardHighlight(keyboard_idx, old_idx);
			copyMemoryToKeyboard();
			break;

		case RKEY_ChDown :
			
			old_idx = keyboard_idx;
			//keyboard_idx = (keyboard_idx + 9) % 36;
			if (keyboard_idx == 99)
				keyboard_idx = 0 + keyboard_offset;
			else
				keyboard_idx = (keyboard_idx + 9 > 35) ? 99 : (keyboard_idx + 9) % 36;
			moveKeyboardHighlight(keyboard_idx, old_idx);
			copyMemoryToKeyboard();
			break;
		
		case RKEY_VolUp :

			if (keyboard_idx == 99)
				moveCursorForward();
			else {
				old_idx = keyboard_idx;
				keyboard_idx = (keyboard_idx + 1) % 9 == 0 ? keyboard_idx - 8 : keyboard_idx + 1;
				moveKeyboardHighlight(keyboard_idx, old_idx);
				copyMemoryToKeyboard();
			}
			break;

		case RKEY_VolDown :

			if (keyboard_idx == 99)
				moveCursorBack();
			else {
				old_idx = keyboard_idx;
				keyboard_idx = keyboard_idx % 9 == 0 ? keyboard_idx + 8 : keyboard_idx - 1;
				moveKeyboardHighlight(keyboard_idx, old_idx);
				copyMemoryToKeyboard();
			}
			break;
	}

	return 0;
}

dword handleMoveEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_Ok :

			if (no_of_move_folders == 0)
				break;

			ChangeDirPath(move_folders[move_folder_idx]);
			freeMoveFolders();
			populateMoveFolders();
			drawMoveFolderList(FALSE);
			break;

		case RKEY_Yellow :

			if (no_of_move_folders == 0)
				break;

			handleMove();
			if (move_successful) {
				freeMoveFolders();
				TAP_MemFree(move_folder_save);
				move_folder_save = NULL;
			}
			break;

		case RKEY_Exit :
					
			// return to file list
			if (write_log) if (verbose) logText("Exit move", FALSE);
			ChangeDirPath(curr_dir);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, move_folder_save);
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, move_folder_save);
			TAP_MemFree(move_folder_save);
			move_folder_save = NULL;
			freeMoveFolders();
			move_folders_displayed = FALSE;
			window_displayed = TRUE;
			break;

		case RKEY_ChUp :

			shuffleUpFileList(MOVE_FOLDER_NAVIGATION, &move_folder_idx, &move_folder_highlight, no_of_move_folders, 8);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(MOVE_FOLDER_NAVIGATION, &move_folder_idx, &move_folder_highlight, no_of_move_folders, 8);
			break;
		
		case RKEY_VolDown :

			if (page_with_arrows)
				pageBackFileList(MOVE_FOLDER_NAVIGATION, &move_folder_idx, &move_folder_highlight, no_of_move_folders, 8);
			else {
				if (no_of_move_folders > 0) {
					ExtractLastField(move_folders[0], buffer);
					if (isParentDirectory(buffer+1)) {
						ChangeDir("..");
						freeMoveFolders();
						populateMoveFolders();
						drawMoveFolderList(FALSE);
					}
				}
			}
			break;
		
		case RKEY_VolUp :
			
			if (page_with_arrows)
				pageForwardFileList(MOVE_FOLDER_NAVIGATION, &move_folder_idx, &move_folder_highlight, no_of_move_folders, 8);
			else {
				if (no_of_move_folders > 0) {
					ChangeDirPath(move_folders[move_folder_idx]);
					freeMoveFolders();
					populateMoveFolders();
					drawMoveFolderList(FALSE);
				}
			}
			break;
		
		case RKEY_Rewind :

			if (!page_with_arrows)
				pageBackFileList(MOVE_FOLDER_NAVIGATION, &move_folder_idx, &move_folder_highlight, no_of_move_folders, 8);
			else {
				if (no_of_move_folders > 0) {
					ExtractLastField(move_folders[0], buffer);
					if (isParentDirectory(buffer+1)) {
						ChangeDir("..");
						freeMoveFolders();
						populateMoveFolders();
						drawMoveFolderList(FALSE);
					}
				}
			}
			break;

		case RKEY_Forward :

			if (!page_with_arrows)
				pageForwardFileList(MOVE_FOLDER_NAVIGATION, &move_folder_idx, &move_folder_highlight, no_of_move_folders, 8);
			else {
				if (no_of_move_folders > 0) {
					ChangeDirPath(move_folders[move_folder_idx]);
					freeMoveFolders();
					populateMoveFolders();
					drawMoveFolderList(FALSE);
				}
			}
			break;
	}

	return 0;
}

dword handleLoadPlaylistEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_Ok :

			if (no_of_playlists == 0)
				break;

			if (photo_playlist_mode) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Load playlist %s",  photo_playlists[load_playlist_idx]);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				loadNamedPlaylist(photo_playlist_mode, photo_playlists[load_playlist_idx]);
				memset(photo_playlist_name, '\0', 100);
				strncat(photo_playlist_name, photo_playlists[load_playlist_idx], strlen(photo_playlists[load_playlist_idx])-4);
			}
			else {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Load playlist %s",  mp3_playlists[load_playlist_idx]);
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				loadNamedPlaylist(photo_playlist_mode, mp3_playlists[load_playlist_idx]);
				memset(mp3_playlist_name, '\0', 100);
				strncat(mp3_playlist_name, mp3_playlists[load_playlist_idx], strlen(mp3_playlists[load_playlist_idx])-4);
				deletePlaylistHistory();
			}
			saved_playlist_idx = 0;
			saved_playlist_highlight = 0;
			no_of_files = photo_playlist_mode ? no_of_playlist_photos : no_of_playlist_mp3s;
			drawPlaylist(FALSE);
			drawMp3InfoBox();
			copyMemoryToWindow();
			load_playlist_displayed = FALSE;
			window_displayed = TRUE;
			break;

		case RKEY_White :

			// delete playlist file
			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Delete playlist %d", load_playlist_idx);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			if (no_of_playlists == 0)
				break;

			ChangeDirPlaylists();
			if (photo_playlist_mode) {
				TAP_Hdd_Delete(photo_playlists[load_playlist_idx]);
			}
			else {
				TAP_Hdd_Delete(mp3_playlists[load_playlist_idx]);
			}
			ChangeDirPath(curr_dir);
			
			// if at end of list, then move idx up
			if (no_of_playlists > 0) {
				adjustIndexForDelete(&load_playlist_idx, &load_playlist_highlight, no_of_playlists, 8);
			}

			drawBlankMoveFolderList();
			loadPlaylistFiles(photo_playlist_mode);
			no_of_playlists = photo_playlist_mode ? no_of_photo_playlists : no_of_mp3_playlists;

			drawLoadPlaylists(load_playlist_idx - load_playlist_highlight);
			copyMemoryToMoveFolders();
			break;

		case RKEY_Exit :
		case RKEY_TvRadio :
					
			// return to file list
			if (write_log) if (verbose) logText("Exit load playlist", FALSE);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, load_playlist_save);
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, load_playlist_save);
			TAP_MemFree(load_playlist_save);
			load_playlist_save = NULL;
			load_playlist_displayed = FALSE;
			window_displayed = TRUE;
			break;

		case RKEY_ChUp :

			shuffleUpFileList(PLAYLIST_LOAD_NAVIGATION, &load_playlist_idx, &load_playlist_highlight, no_of_playlists, 8);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(PLAYLIST_LOAD_NAVIGATION, &load_playlist_idx, &load_playlist_highlight, no_of_playlists, 8);
			break;

		case RKEY_Rewind :

			pageBackFileList(PLAYLIST_LOAD_NAVIGATION, &load_playlist_idx, &load_playlist_highlight, no_of_playlists, 8);
			break;

		case RKEY_Forward :

			pageForwardFileList(PLAYLIST_LOAD_NAVIGATION, &load_playlist_idx, &load_playlist_highlight, no_of_playlists, 8);
			break;
	}

	return 0;
}

dword handleLoadSkinEventKey(dword param1)
{
	switch (param1)
	{
		case RKEY_Ok :

			if (write_log) if (verbose) TAP_SPrint(log_buffer, "Load skin %s",  skins[load_skin_idx].skin_name);
			if (write_log) if (verbose) logText(log_buffer, FALSE);
			
			skin_editor_idx = 0;
			skin_editor_highlight = 0;
			skin_colour_idx = 0;

			// swap skins while we are editing
			strcpy(skin_file_name, skins[load_skin_idx].skin_name);
			if (skins[load_skin_idx].in_skins_folder)
				ChangeDirSkins();
			else
				ChangeDirProgramFiles();
			loadSkinElements(W, 30);

			// load skin elements into memory and then display editor
			populateSkinElements(skins[load_skin_idx].skin_name, &no_of_skin_elements);
			//TAP_Osd_Delete(region);
			//region = TAP_Osd_Create(0, 0, 720, 576, 0, FALSE);
			drawSkinEditor(TRUE);
			copyMemoryToWindow();
			load_skin_displayed = FALSE;
			window_displayed = TRUE;
			TAP_MemFree(load_skin_save);
			load_skin_save = NULL;
			break;
	
		case RKEY_Exit :
		case RKEY_TvRadio :
					
			// return to file list
			if (write_log) if (verbose) logText("Exit load skin", FALSE);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, load_skin_save);
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, load_skin_save);
			TAP_MemFree(load_skin_save);
			load_skin_save = NULL;
			load_skin_displayed = FALSE;
			window_displayed = TRUE;
			break;
		
		case RKEY_ChUp :

			shuffleUpFileList(SKIN_LOAD_NAVIGATION, &load_skin_idx, &load_skin_highlight, skin_count, 8);
			break;

		case RKEY_ChDown :

			shuffleDownFileList(SKIN_LOAD_NAVIGATION, &load_skin_idx, &load_skin_highlight, skin_count, 8);
			break;
		
		case RKEY_Rewind :

			pageBackFileList(SKIN_LOAD_NAVIGATION, &load_skin_idx, &load_skin_highlight, skin_count, 8);
			break;

		case RKEY_Forward :

			pageForwardFileList(SKIN_LOAD_NAVIGATION, &load_skin_idx, &load_skin_highlight, skin_count, 8);
			break;
	}

	return 0;
}

dword handleStopMenuEventKey(dword param1)
{
	TYPE_PlayInfo play_info;

	switch (param1)
	{
		case RKEY_Ok :

			switch (stop_menu_idx) {
				case 0:
					TAP_Hdd_GetPlayInfo(&play_info);
					if (play_info.playMode == PLAYMODE_Playing) {
						if (write_log) if (verbose) logText("Stop vid", TRUE);
						TAP_Hdd_StopTs();
						if (write_log) if (verbose) logText("Stopped vid", FALSE);
					}
					TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_None);
					handleDeleteFileKey();
					break;

				case 1:
					TAP_Hdd_GetPlayInfo(&play_info);
					if (play_info.playMode == PLAYMODE_Playing) {
						//TAP_Hdd_SetBookmark();
						if (write_log) if (verbose) logText("Stop vid", TRUE);
						TAP_Hdd_StopTs();
						if (write_log) if (verbose) logText("Stopped vid", FALSE);
					}
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					TAP_EnterNormal();
					stop_menu_displayed = FALSE;
					break;

				case 2:
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					TAP_EnterNormal();
					stop_menu_displayed = FALSE;
					TAP_GenerateEvent(EVT_KEY, RKEY_Pause, 0);
					break;

				case 3:
					TAP_Hdd_GetPlayInfo(&play_info);
					if (play_info.playMode == PLAYMODE_Playing) {
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Trim start of video");
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						trim_step = 0;
						trim_recording = TRUE;
					}
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					stop_menu_displayed = FALSE;
					trim_tick = TAP_GetTick();
					break;

				case 4:
					TAP_Hdd_GetPlayInfo(&play_info);
					if (play_info.playMode == PLAYMODE_Playing) {
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Trim end of video");
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						trim_step = 0;
						trim_recording = TRUE;
						deleteRecHeader(playing_file.name, playing_file.startCluster);
					}
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					stop_menu_displayed = FALSE;
					trim_tick = TAP_GetTick();
					break;

				case 5:
					TAP_Hdd_GetPlayInfo(&play_info);
					if (play_info.playMode == PLAYMODE_Playing) {
						if (write_log) if (verbose) TAP_SPrint(log_buffer, "Split video");
						if (write_log) if (verbose) logText(log_buffer, FALSE);
						trim_step = 0;
						trim_recording = TRUE;
					}
					TAP_Osd_Delete(region);
					TAP_Osd_Delete(region_mem);
					stop_menu_displayed = FALSE;
					trim_tick = TAP_GetTick();
					break;
			}

			break;
		
		case RKEY_White :

			// delete option shortcut
			TAP_Hdd_GetPlayInfo(&play_info);
			if (play_info.playMode == PLAYMODE_Playing) {
				if (write_log) if (verbose) logText("Stop vid", TRUE);
				TAP_Hdd_StopTs();
				if (write_log) if (verbose) logText("Stopped vid", FALSE);
			}
			TAP_Osd_FillBox(region, 0, 0, 720, 576, COLOR_None);
			handleDeleteFileKey();
			break;
		
		case RKEY_Stop :

			// stop option shortcut
			TAP_Hdd_GetPlayInfo(&play_info);
			if (play_info.playMode == PLAYMODE_Playing) {
				if (write_log) if (verbose) logText("Stop vid", TRUE);
				TAP_Hdd_StopTs();
				if (write_log) if (verbose) logText("Stopped vid", FALSE);
			}
			TAP_Osd_Delete(region);
			TAP_Osd_Delete(region_mem);
			TAP_EnterNormal();
			stop_menu_displayed = FALSE;
			break;
		
		case RKEY_Play :

			// resume option shortcut
			TAP_Osd_Delete(region);
			TAP_Osd_Delete(region_mem);
			TAP_EnterNormal();
			stop_menu_displayed = FALSE;
			TAP_GenerateEvent(EVT_KEY, RKEY_Pause, 0);
			break;

		case RKEY_Rewind :

			// trim start option shortcut
			TAP_Hdd_GetPlayInfo(&play_info);
			if (play_info.playMode == PLAYMODE_Playing) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Trim start of video");
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				trim_step = 0;
				trim_recording = TRUE;
				stop_menu_idx = 3;
			}
			TAP_Osd_Delete(region);
			TAP_Osd_Delete(region_mem);
			//TAP_EnterNormal();
			stop_menu_displayed = FALSE;
			trim_tick = TAP_GetTick();
			break;

		case RKEY_Forward :

			// trim end option shortcut
			TAP_Hdd_GetPlayInfo(&play_info);
			if (play_info.playMode == PLAYMODE_Playing) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Trim end of video");
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				trim_step = 0;
				trim_recording = TRUE;
				stop_menu_idx = 4;
			}
			TAP_Osd_Delete(region);
			TAP_Osd_Delete(region_mem);
			stop_menu_displayed = FALSE;
			trim_tick = TAP_GetTick();
			break;

		case RKEY_Pause :

			// split option shortcut
			TAP_Hdd_GetPlayInfo(&play_info);
			if (play_info.playMode == PLAYMODE_Playing) {
				if (write_log) if (verbose) TAP_SPrint(log_buffer, "Split video");
				if (write_log) if (verbose) logText(log_buffer, FALSE);
				trim_step = 0;
				trim_recording = TRUE;
				deleteRecHeader(playing_file.name, playing_file.startCluster);
				stop_menu_idx = 5;
			}
			TAP_Osd_Delete(region);
			TAP_Osd_Delete(region_mem);
			stop_menu_displayed = FALSE;
			trim_tick = TAP_GetTick();
			break;

		case RKEY_Exit :
			
			// return to normal
			if (write_log) if (verbose) logText("Exit stop menu", FALSE);
			TAP_Osd_Delete(region);
			TAP_Osd_Delete(region_mem);
			TAP_EnterNormal();
			stop_menu_displayed = FALSE;
			TAP_GenerateEvent(EVT_KEY, RKEY_Pause, 0);
			break;

		case RKEY_ChUp :

			// scroll up
			stop_menu_idx = stop_menu_idx == 0 ? (no_of_stop_options - 1) : stop_menu_idx - 1;
			stop_menu_highlight = stop_menu_idx;
			drawStopMenuLine(stop_menu_idx);
			drawStopMenuLine((stop_menu_idx == (no_of_stop_options - 1)) ? 0 : stop_menu_idx + 1);
			copyMemoryToStopMenu();
			break;

		case RKEY_ChDown :

			// scroll down
			stop_menu_idx = (stop_menu_idx + 1) % no_of_stop_options;
			stop_menu_highlight = stop_menu_idx;
			drawStopMenuLine(stop_menu_idx);
			drawStopMenuLine(stop_menu_idx == 0 ? no_of_stop_options - 1 : stop_menu_idx - 1);
			copyMemoryToStopMenu();
			break;
	}

	return 0;
}

dword handleOptionsListEventKey(dword param1)
{
	bool actioned;

	switch (param1)
	{
		case RKEY_Ok :

			if (sort_options) {
				handleReorder(options_idx);
				TAP_MemFree(options_save);
				options_save = NULL;
				options_displayed = FALSE;
			}
			ef (InDataFilesFolder(curr_dir)) {
				switch (options_idx) {
					case 0:
						actioned = handleCreateRecordingThumbnail(FALSE);
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 1:
						actioned = handleCreateRecordingThumbnail(TRUE);
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 2:
						actioned = handleDeleteRecordingThumbnail();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;

					case 3:
						actioned = handleDeleteAllRecordingThumbnails();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 4:
						actioned = handleRecycleBinKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
							window_displayed = TRUE;
						}
						break;
					case 5:
						actioned = handleRenameKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 6:
						actioned = handleNewFolderKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 7:
						actioned = handleMoveKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					/*case 8:
						handleReorderKey();
						TAP_MemFree(options_save);
						options_save = NULL;
						options_displayed = FALSE;
						window_displayed = TRUE;
						break;*/
				}
			}
			ef (InMp3FilesFolder(curr_dir)) {
				switch (options_idx) {
					case 0:
						actioned = handleDeleteArtAssociation();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 1:
						actioned = handleRecycleBinKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
							window_displayed = TRUE;
						}
						break;
					case 2:
						actioned = handleRenameKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 3:
						actioned = handleNewFolderKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 4:
						actioned = handleMoveKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					/*case 5:
						handleReorderKey();
						TAP_MemFree(options_save);
						options_save = NULL;
						options_displayed = FALSE;
						window_displayed = TRUE;
						break;*/
				}
			}
			else {
				switch (options_idx) {
					case 0:
						actioned = handleAssociateArt(TRUE);
						if (actioned) {
							//TAP_Osd_RestoreBox(region, X+150-1, Y+50-1, W-300+20, 350, options_save);
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;
					case 1:
						actioned = handleAssociateArt(FALSE);
						if (actioned) {
							//TAP_Osd_RestoreBox(region, X+150-1, Y+50-1, W-300+20, 350, options_save);
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;

					case 2:
						actioned = handleDeleteCachedPhoto();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;

					case 3:
						actioned = handleDeleteAllCachedPhotos();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;

					case 4:
						actioned = handleRecycleBinKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
							window_displayed = TRUE;
						}
						break;

					case 5:
						actioned = handleRenameKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;

					case 6:
						actioned = handleNewFolderKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;

					case 7:
						actioned = handleMoveKey();
						if (actioned) {
							TAP_MemFree(options_save);
							options_save = NULL;
							options_displayed = FALSE;
						}
						break;

					/*case 8:
						handleReorderKey();
						TAP_MemFree(options_save);
						options_save = NULL;
						options_displayed = FALSE;
						window_displayed = TRUE;
						break;*/
				}
			}

			break;

		case RKEY_Exit :
		case RKEY_Options :
		case RKEY_Blue :
			
			// return to file list
			if (write_log) if (verbose) logText("Exit options list", FALSE);
			TAP_Osd_RestoreBox(region, 0, 0, 720, 576, options_save);
			TAP_Osd_RestoreBox(region_mem, 0, 0, 720, 576, options_save);
			TAP_MemFree(options_save);
			options_save = NULL;
			options_displayed = FALSE;
			window_displayed = TRUE;
			break;

		case RKEY_ChUp :

			options_idx = options_idx == 0 ? (no_of_options - 1) : options_idx - 1;
			options_highlight = options_idx;
			drawOptionLine(options_idx);
			drawOptionLine((options_idx == (no_of_options - 1)) ? 0 : options_idx + 1);
			copyMemoryToOptions();
			break;

		case RKEY_ChDown :

			options_idx = (options_idx + 1) % no_of_options;
			options_highlight = options_idx;
			drawOptionLine(options_idx);
			drawOptionLine(options_idx == 0 ? no_of_options - 1 : options_idx - 1);
			copyMemoryToOptions();
			break;
	}

	return 0;
}

dword handleRecThumbnailEventKey(dword param1)
{
	int found_idx;

	switch (param1)
	{
		case RKEY_Filelist:

			handleExitKey(TRUE, TRUE);
			return display_toppy_archive ? param1 : 0;

		case RKEY_Menu:

			handleMenuKey();
			break;

		case RKEY_Options:

			sort_options = FALSE;
			handleOptionsListKey();
			break;

		case RKEY_Guide:

			handleBrowseScenesKey();
			break;

		case RKEY_Recall:

			handleToggleKey();
			break;

		case RKEY_Record:
			
			handleRecordKey();
			break;

		case RKEY_TvSat:
			
			handleAutoDeleteListKey();
			break;

		case RKEY_TvRadio:
			
			handleMarkFile(dir_info[curr_idx]->file_name, curr_dir, dir_info[curr_idx]->start_cluster, dir_info[curr_idx]->mjd, dir_info[curr_idx]->hour, dir_info[curr_idx]->min, dir_info[curr_idx]->size, dir_info[curr_idx]->locked);
			break;

		case RKEY_Slow:
			
			if (no_of_files == 0)
				return 0;

			if (isRec(dir_info[curr_idx]->file_name)) {
				found_idx = existsInAutoDeleteList(dir_info[curr_idx]->sort_name);
				if (found_idx == -1) {
					appendToAutoDeleteList(dir_info[curr_idx]->sort_name);
					auto_delete_idx = no_of_auto_deletes - 1;
					new_auto_delete = TRUE;
				}
				else {
					auto_delete_idx = found_idx;
					copyAutoDeleteEntry(auto_delete_idx);
					new_auto_delete = FALSE;
				}

				handleAutoDeleteUpdateKey();
			}
			break;

		case RKEY_Info:

			handleRecInfoKey();
			break;

		case RKEY_Text:

			handleHelpKey();
			break;

		case RKEY_Red:

			handleRenameKey();
			break;

		case RKEY_Blue:

			sort_options = FALSE;
			handleOptionsListKey();
			break;

		case RKEY_Green:

			handleNewFolderKey();
			break;

		case RKEY_Yellow:

			handleMoveKey();
			break;

		case RKEY_1:

			handleCreateRecordingThumbnail(FALSE);
			break;

		case RKEY_2:

			handleCreateRecordingThumbnail(TRUE);
			break;

		case RKEY_3:

			handleDeleteRecordingThumbnail();
			break;

		case RKEY_4:

			handleDeleteAllRecordingThumbnails();
			break;

		case RKEY_5:

			//handleCreateAllRecordingThumbnails();
			break;

		case RKEY_6:

			handleRecycleBinKey();
			break;

		case RKEY_7:

			handleRenameKey();
			break;

		case RKEY_8:

			handleNewFolderKey();
			break;

		case RKEY_9:

			handleMoveKey();
			break;

		case RKEY_0:

			handleReorderKey();
			break;

		case RKEY_Ok :

			if (isRec(dir_info[curr_idx]->file_name)) {
				if (play_resumes_video)
					handlePlayKey();
				else
					handleOkKey();
			}
			else
				handleOkKey();
			break;

		case RKEY_Play :
			
			if (isRec(dir_info[curr_idx]->file_name)) {
				if (play_resumes_video == 1)
					handleOkKey();
				else
					handlePlayKey();
			}
			else
				handlePlayKey();
			break;

		case RKEY_Pause :
			
			handleReorderKey();
			break;

		case RKEY_White:

			handleDeleteFileKey();
			break;

		case RKEY_Stop:

			handleStopKey(FALSE);
			break;

		case RKEY_Exit :

			handleExitKey(TRUE, TRUE);
			break;

		case RKEY_ChUp :

			if (no_of_files == 0)
				return 0;

			if (curr_idx - 3 < 0)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, no_of_files - 1, curr_idx, no_of_files - 1);
					curr_idx = no_of_files - 1;
					curr_highlight = no_of_files - 1;
				}
				else
				{
					curr_highlight = (no_of_files % 9 == 0) ? 8 : (no_of_files % 9) - 1;
					curr_idx = (no_of_files - 1);

					drawThumbnails(no_of_files - ((no_of_files % 9 == 0) ? 9 : (no_of_files % 9)));
				}
			}
			ef (curr_highlight < 3)
			{
				int start_point = curr_idx - curr_highlight - 3;
				curr_idx = curr_idx - 3;
				curr_highlight = curr_highlight;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight - 3, curr_idx, curr_idx - 3);
				curr_idx = curr_idx - 3;
				curr_highlight = curr_highlight - 3;
			}
			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_ChDown :

			if (no_of_files == 0)
				return 0;

			if (curr_idx + 3 >= no_of_files)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, 0, curr_idx, 0);
					curr_idx = 0;
					curr_highlight = 0;
				}
				else
				{
					curr_highlight = curr_idx = 0;

					drawThumbnails(0);
				}
			}
			ef (curr_highlight >= 6)
			{
				int start_point = curr_idx - curr_highlight + 3;
				curr_idx = curr_idx + 3;
				curr_highlight = curr_highlight;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight + 3, curr_idx, curr_idx + 3);
				curr_idx = curr_idx + 3;
				curr_highlight = (curr_highlight + 3) % 9;
			}

			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_VolUp :

			if (no_of_files == 0)
				return 0;

			if (curr_idx + 1 == no_of_files)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, 0, curr_idx, 0);
					curr_idx = 0;
					curr_highlight = 0;
				}
				else
				{
					curr_highlight = curr_idx = 0;
					drawThumbnails(0);
				}
			}
			ef (curr_highlight == 8)
			{
				int start_point = curr_idx - 5;
				curr_idx = curr_idx + 1;
				curr_highlight = 6;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight + 1, curr_idx, curr_idx + 1);
				curr_idx = curr_idx + 1;
				curr_highlight = curr_highlight + 1;
			}

			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_VolDown :

			if (no_of_files == 0)
				return 0;

			if (curr_idx - 1 < 0)
			{
				if (no_of_files < 9)
				{
					moveThumbnailHighLight(curr_highlight, no_of_files - 1, curr_idx, no_of_files - 1);
					curr_idx = no_of_files - 1;
					curr_highlight = no_of_files - 1;
				}
				else
				{
					curr_highlight = (no_of_files % 9) == 0 ? 8 : (no_of_files % 9) - 1;
					curr_idx = (no_of_files - 1);
					drawThumbnails(no_of_files - ((no_of_files % 9) == 0 ? 9 : (no_of_files % 9)));
				}
			}
			ef (curr_highlight == 0)
			{
				int start_point = curr_idx - 3;
				curr_idx = curr_idx - 1;
				curr_highlight = 2;
				drawThumbnails(start_point);
			}
			else
			{
				moveThumbnailHighLight(curr_highlight, curr_highlight - 1, curr_idx, curr_idx - 1);
				curr_idx = curr_idx - 1;
				curr_highlight = curr_highlight - 1;
			}
			
			// populate the footer box
			drawThumbnailGridFooter();
			updateThumbnailCount();
			copyMemoryToWindow();
			break;

		case RKEY_Rewind :

			if (no_of_files == 0)
				return 0;

			if (curr_idx > 8)
			{
				if (curr_idx - curr_highlight < 8)
				{
					curr_idx = 0;
					curr_highlight = 0;
					drawThumbnails(0);
				}
				else
				{
					curr_idx = curr_idx - 9;
					drawThumbnails(curr_idx - curr_highlight);
				}
			}
			ef (no_of_files > 8)
			{
				curr_highlight = (no_of_files % 9 == 0) ? 8 : (no_of_files % 9) - 1;
				curr_idx = (no_of_files - 1);
				drawThumbnails(no_of_files - ((no_of_files % 9 == 0) ? 9 : (no_of_files % 9)));
			}

			// populate the footer box
			drawThumbnailGridFooter();
			copyMemoryToWindow();
			break;

		case RKEY_Forward :

			if (no_of_files == 0)
				return 0;

			if (curr_idx < (no_of_files - 9))
			{
				curr_idx = curr_idx + 9;
				drawThumbnails(curr_idx - curr_highlight);
			}
			ef (no_of_files > 8)
			{
				curr_highlight = 0;
				curr_idx = 0;
				drawThumbnails(0);
			}

			// populate the footer box
			drawThumbnailGridFooter();
			copyMemoryToWindow();
			break;
	}

	return 0;
}

dword handleWindowEventKey(dword param1)
{
	if (recycle_bin_displayed) {
		// handle any recycle actions
		return handleRecycleBinEventKey(param1);
	}
	ef (auto_delete_update_displayed) {
		// handle any auto delete actions
		return handleAutoDeleteUpdateEventKey(param1);
	}
	ef (auto_deletes_displayed) {
		// handle any auto delete actions
		return handleAutoDeleteListEventKey(param1);
	}
	ef (playlist_displayed) {
		// handle any playlist actions
		return handlePlaylistEventKey(param1);
	}
	ef (skin_editor_displayed) {
		// handle any skin editor actions
		return handleSkinEditorEventKey(param1);
	}
	ef (scenes_displayed) {
		// handle any scene actions
		return handleSceneEventKey(param1);
	}
	ef (thumbnail_mode) {
		// handle any thumbnail actions
		if (InDataFilesFolder(curr_dir))
			return handleRecThumbnailEventKey(param1);
		else
			return handleThumbnailEventKey(param1);
	}
	else {
		// handle any file list actions
		if (InDataFilesFolder(curr_dir))
			return handleRecFileListEventKey(param1);
		else
			return handleFileListEventKey(param1);
	}

	return 0;
}

struct _event_queue {
	word event_type;
	dword param1;
	dword param2;
} event_queue[16];
static word no_of_events = 0;

// list holds most recent first, so add new event to end
void addEventToQueue(word event_type, dword param1, dword param2)
{
	event_queue[no_of_events].event_type = event_type;
	event_queue[no_of_events].param1 = param1;
	event_queue[no_of_events].param2 = param2;
	no_of_events++;
}

void removeEventFromQueue()
{
	word i;

	for (i = 0; i < no_of_events-1; i++) {
		event_queue[i].event_type = event_queue[i+1].event_type;
		event_queue[i].param1 = event_queue[i+1].param1;
		event_queue[i].param2 = event_queue[i+1].param2;
	}

	no_of_events--;
}

void handleEvent()
{
	word event_type; dword param1, param2;

	// if no events, then nothing to do
	if (no_of_events == 0)
		return;

	// get the first event (list holds most recent first)
	event_type	= event_queue[0].event_type;
	param1		= event_queue[0].param1;
	param2		= event_queue[0].param2;

	switch (event_type) { 
		case EVT_KEY: 
			break;
		case EVT_RBACK: 
			break;
		case EVT_INIT:
			handleInitialisation();
			break;
    }

	// event dealt with, so remove from queue
	removeEventFromQueue();
}

void handleServiceStatus(dword param1)
{
	if (copy_recording && copy_step == 0) { 
		if ((param1 & SVCSTATUS_MASK_Error) != 0) {
			if (write_log) TAP_SPrint(log_buffer, "Decode error at %d", TAP_GetTick());
			if (write_log) logText(log_buffer, FALSE);
			copy_delay = 2000;
			copy_error_tick = TAP_GetTick();
		}
	}
}

#define P2RKEY_TvRadio  0x1000e
#define P2RKEY_Left     0x1000f
#define P2RKEY_Up       0x10012
#define P2RKEY_Right    0x10015
#define P2RKEY_VolDown  0x10017
#define P2RKEY_List     0x10018
#define P2RKEY_Down     0x1001d
#define P2RKEY_VolUp    0x10020
#define P2RKEY_ChUp     0x10021
#define P2RKEY_ChDown   0x10037

dword TAP_EventHandler(word event_type, dword param1, dword param2)
{
	if (event_type == EVT_SVCSTATUS)
		handleServiceStatus(param1);

	if (event_type == EVT_KEY)
    {
		if (param1 == WSS_43 || param1 == WSS_Auto)
			return param1;

		// if copying or trimming a recording, then pass on key presses
		if (copy_recording || trim_recording)
			return param1;

		// while we are idling for the aspect ratio switch, then reject all keypresses
		if (idle_before_photo_display || idle_before_window_display)
			return 0;

		// kill off the photo batch job if exit pressed
		if (param1 == RKEY_Exit && batch_job_started) { 
			batch_job_started = FALSE;
			freeMediaFiles();
			freeAllFolders();
			TAP_GetTime(&mjd, &hour, &min, &sec);
			if (write_log) TAP_SPrint(log_buffer, "Batch cache process interrupted at %02d:%02d", hour, min);
			if (write_log) logText(log_buffer, FALSE);
			ChangeDirPath(curr_dir);
		}

		if (param2)
		{
			if ((slideshow_started && !full_size_display) 
					|| (external_slideshow && (compact_mode_started || blank_screen_started))) {

				// Channel up
				if (param2 == 0x107 || param2 == P2RKEY_ChUp) {
					TAP_Channel_Move(TRUE, 1);
					if (radio_slideshow) {
						exitRadioSlideshow();
					}
					ef (slideshow_started) {
						if (drawRadioChannelName()) {
							TAP_Osd_Delete(region_2);
							region_2 = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_Plane2);
						}
					}
					ef (compact_mode_started)
						refreshCompactMode(FALSE);

					return 0;
				}
				// Channel down
				ef (param2 == 0x147 || param2 == P2RKEY_ChDown) {
					TAP_Channel_Move(TRUE, -1);
					if (radio_slideshow) {
						exitRadioSlideshow();
					}
					ef (slideshow_started) {
						if (drawRadioChannelName()) {
							TAP_Osd_Delete(region_2);
							region_2 = TAP_Osd_Create(0, 0, 720, 576, 0, OSD_Flag_Plane2);
						}
					}
					ef (compact_mode_started)
						refreshCompactMode(FALSE);

					return 0;
				}
			}

			if (param2 == RAWKEY_List_TVRad || param2 == P2RKEY_List)
				param1 = RAWKEY_List_TVRad;

			if (active()) {
				if (param2 == RAWKEY_VolUp_Fav || param2 == P2RKEY_VolUp) {
					volUp();
					return 0;
				}

				if (param2 == RAWKEY_VolDown_Exit || param2 == P2RKEY_VolDown) {
					volDown();
					return 0;
				}
			}
		}

		if (param1 == RKEY_Mute && active()) {
			mute();
			return 0;
		}

		if (window_displayed)
		{
			return handleWindowEventKey(param1);
		}
		ef (menu_displayed)
		{
			return handleMenuEventKey(param1);
		}
		ef (options_displayed)
		{
			return handleOptionsListEventKey(param1);
		}
		ef (load_playlist_displayed)
		{
			return handleLoadPlaylistEventKey(param1);
		}
		ef (load_skin_displayed)
		{
			return handleLoadSkinEventKey(param1);
		}
		ef (skin_elements_displayed)
		{
			return handleSkinElementEventKey(param1);
		}
		ef (keyboard_displayed) 
		{
			return handleKeyboardEventKey(param1);
		}
		ef (confirmation_box_displayed) 
		{
			return handleConfirmationBoxEventKey(param1);
		}
		ef (info_box_displayed) 
		{
			return handleInfoBoxEventKey(param1);
		}
		ef (pin_box_displayed) 
		{
			return handlePinBoxEventKey(param1);
		}
		ef (stop_menu_displayed)
		{
			return handleStopMenuEventKey(param1);
		}
		ef (move_folders_displayed) 
		{
			return handleMoveEventKey(param1);
		}
		ef (log_displayed)
		{
			return handleLogEventKey(param1);
		}
		ef (info_displayed)
		{
			return handleInfoEventKey(param1);
		}
		ef (rec_info_displayed)
		{
			return handleRecInfoEventKey(param1);
		}
		ef (help_displayed)
		{
			return handleHelpEventKey(param1);
		}
		ef (slideshow_started)
		{
			return handleSlideshowEventKey(param1);
		}
		ef (screensaver_started)
		{
			return handleScreensaverEventKey(param1);
		}
		ef (album_art_started)
		{
			return handleAlbumArtEventKey(param1);
		}
		ef (compact_mode_started)
		{
			return handleCompactModeEventKey(param1);
		}
		ef (blank_screen_started)
		{
			return handleBlankScreenEventKey(param1);
		}
		else
		{
			return handleOtherEventKey(param1);
		}
    }
	ef (event_type == EVT_RBACK)	// Radio background change event.
    {
		return handleBackgroundEvent(param1);
    }
	ef (event_type == EVT_IDLE)
    {
		return handleIdleEvent(param1);
    }

    return param1;
}

int TAP_Main(void)
{
	// add the initialisation event to queue
	addEventToQueue(EVT_INIT, 0, 0);

	// TSR mode
#ifndef WIN32
	return 2;
#else
    return 1;
#endif	
}

void exitTap()
{
	word i;

	ChangeDirMediaManager();
	SaveConfigurationToFile();
	saveProgressData();

	// free all memory that may be still being used
	for (i = 0; i < 128; i++) {
		if (default_directories[i]) {
			dlfree(default_directories[i]);
			default_directories[i] = NULL;
		}
	}
	for (i = 0; i < skin_count; i++) {
		if (skins[i].skin_name) {
			dlfree(skins[i].skin_name);
			skins[i].skin_name = NULL;
		}
	}
	deleteFonts();
	if (background_gradient)			TAP_MemFree(background_gradient);
	if (highlight_gradient)				TAP_MemFree(highlight_gradient);
	if (folder_gradient)				TAP_MemFree(folder_gradient);
	if (playing_gradient)				TAP_MemFree(playing_gradient);
	if (recording_gradient)				TAP_MemFree(recording_gradient);
	if (chaseplay_gradient)				TAP_MemFree(chaseplay_gradient);
	if (skin_highlight_gradient)		TAP_MemFree(skin_highlight_gradient);
	if (options_background_gradient)	TAP_MemFree(options_background_gradient);
	if (stop_menu_background_gradient)	TAP_MemFree(stop_menu_background_gradient);
	if (options_highlight_gradient)		TAP_MemFree(options_highlight_gradient);
	if (stop_menu_highlight_gradient)	TAP_MemFree(stop_menu_highlight_gradient);
	if (auto_del_background_gradient)	TAP_MemFree(auto_del_background_gradient);
	if (auto_del_highlight_gradient)	TAP_MemFree(auto_del_highlight_gradient);
	if (keyboard_bg_gradient)			TAP_MemFree(keyboard_bg_gradient);
	if (keyboard_highlight_gradient)	TAP_MemFree(keyboard_highlight_gradient);
	if (keyboard_filler_gradient)		TAP_MemFree(keyboard_filler_gradient);

	ReleaseLogoMemory();
	deleteAllRecHeaders();
	deleteAllMp3Headers();
	freeChannels();

	dlmalloc_trim(0);
	dlmalloc_exit();

	logMemory("At exit", TRUE);
	if (write_log) logText("Exit TAP\n", FALSE);
	closeLogfile();

	//handleStopKey();

	TAP_Exit();
}

bool TSRCommanderExitTAP()
{
	exitTap();

	return TRUE;
}

void TSRCommanderConfigDialog()
{
	TAP_ExitNormal();
	recreateWindow();
	handleMenuKey();
}

#ifdef WIN32
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
// The following line sets some information in the SDK that will be available through the File->Info menuchoice
   setTAP_Information(__tap_program_name__, __tap_author_name__, __tap_description__, __tap_etc_str__, __tap_ud__);

   enableFramebufferUpdate(FALSE); // Set to TRUE to get all OSD output copied to framebuffer.
                                   // (available through GetBaseInfo). Setting this to TRUE will slow things down, so don't
                                   // use if you don't need it.

   enableFramebufferMonitor(FALSE); // Set to TRUE to get the SDK to copy any changed contents of the
                                    // framebuffer to the emulated screen. 

   return InitializeTAP_Environment(hInstance, nCmdShow, __tap_program_name__, TAP_Main, TAP_EventHandler);
} 
#endif













